/**
 * _______________________________________________________________________________
 *
 *  Copyright (c) 2012 TU Dresden, Chair for Embedded Systems
 *  Copyright (c) 2013-2016 TU Darmstadt, Computer Systems Group
 *  (http://www.rs.tu-darmstadt.de) All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions
 *  are met:
 *
 *  1. Redistributions of source code must retain the above copyright
 *     notice, this list of conditions and the following disclaimer.
 *
 *  2. Redistributions in binary form must reproduce the above copyright
 *     notice, this list of conditions and the following disclaimer in the
 *     documentation and/or other materials provided with the distribution.
 *
 *  3. All advertising materials mentioning features or use of this software
 *     must display the following acknowledgement: "This product includes
 *     software developed by the TU Dresden Chair for Embedded Systems, TU Darmstadt Computer Systems Group and
 *     its contributors."
 *
 *  4. Neither the name of the TU Dresden Chair for Embedded Systems, TU Darmstadt Computer Systems Group nor the
 *     names of its contributors may be used to endorse or promote products
 *     derived from this software without specific prior written permission.
 *
 *  THIS SOFTWARE IS PROVIDED BY TU DRESDEN CHAIR FOR EMBEDDED SYSTEMS, TU DARMSTADT COMPUTER SYSTEMS GROUP AND
 *  CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING,
 *  BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
 *  FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 *  REGENTS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 *  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
 *  TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 *  PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 *  LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 *  NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 *  SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * _______________________________________________________________________________
 */


function [31:0] Crc32;
  input [31:0] Crc_Sum_i;
  input [7:0]  Input_Byte_i;

  begin
    Crc32[0]  = Crc_Sum_i[24] ^ Crc_Sum_i[30] ^ Input_Byte_i[1] ^ Input_Byte_i[7];
    Crc32[1]  = Crc_Sum_i[25] ^ Crc_Sum_i[31] ^ Input_Byte_i[0] ^ Input_Byte_i[6] ^ Crc_Sum_i[24] ^ Crc_Sum_i[30] ^ Input_Byte_i[1] ^ Input_Byte_i[7];
    Crc32[2]  = Crc_Sum_i[26] ^ Input_Byte_i[5] ^ Crc_Sum_i[25] ^ Crc_Sum_i[31] ^ Input_Byte_i[0] ^ Input_Byte_i[6] ^ Crc_Sum_i[24] ^ Crc_Sum_i[30] ^ Input_Byte_i[1] ^ Input_Byte_i[7];
    Crc32[3]  = Crc_Sum_i[27] ^ Input_Byte_i[4] ^ Crc_Sum_i[26] ^ Input_Byte_i[5] ^ Crc_Sum_i[25] ^ Crc_Sum_i[31] ^ Input_Byte_i[0] ^ Input_Byte_i[6];
    Crc32[4]  = Crc_Sum_i[28] ^ Input_Byte_i[3] ^ Crc_Sum_i[27] ^ Input_Byte_i[4] ^ Crc_Sum_i[26] ^ Input_Byte_i[5] ^ Crc_Sum_i[24] ^ Crc_Sum_i[30] ^ Input_Byte_i[1] ^ Input_Byte_i[7];
    Crc32[5]  = Crc_Sum_i[29] ^ Input_Byte_i[2] ^ Crc_Sum_i[28] ^ Input_Byte_i[3] ^ Crc_Sum_i[27] ^ Input_Byte_i[4] ^ Crc_Sum_i[25] ^ Crc_Sum_i[31] ^ Input_Byte_i[0] ^ Input_Byte_i[6] ^ Crc_Sum_i[24] ^ Crc_Sum_i[30] ^ Input_Byte_i[1] ^ Input_Byte_i[7];
    Crc32[6]  = Crc_Sum_i[30] ^ Input_Byte_i[1] ^ Crc_Sum_i[29] ^ Input_Byte_i[2] ^ Crc_Sum_i[28] ^ Input_Byte_i[3] ^ Crc_Sum_i[26] ^ Input_Byte_i[5] ^ Crc_Sum_i[25] ^ Crc_Sum_i[31] ^ Input_Byte_i[0] ^ Input_Byte_i[6];
    Crc32[7]  = Crc_Sum_i[31] ^ Input_Byte_i[0] ^ Crc_Sum_i[30] ^ Input_Byte_i[1] ^ Crc_Sum_i[29] ^ Input_Byte_i[2] ^ Crc_Sum_i[27] ^ Input_Byte_i[4] ^ Crc_Sum_i[26] ^ Input_Byte_i[5] ^ Crc_Sum_i[24] ^ Crc_Sum_i[30] ^ Input_Byte_i[1] ^ Input_Byte_i[7];
    Crc32[8]  = Crc_Sum_i[0] ^ Crc_Sum_i[31] ^ Input_Byte_i[0] ^ Crc_Sum_i[30] ^ Input_Byte_i[1] ^ Crc_Sum_i[28] ^ Input_Byte_i[3] ^ Crc_Sum_i[27] ^ Input_Byte_i[4] ^ Crc_Sum_i[25] ^ Crc_Sum_i[31] ^ Input_Byte_i[0] ^ Input_Byte_i[6] ^ Crc_Sum_i[24] ^ Crc_Sum_i[30] ^ Input_Byte_i[1] ^ Input_Byte_i[7];
    Crc32[9]  = Crc_Sum_i[1] ^ Crc_Sum_i[31] ^ Input_Byte_i[0] ^ Crc_Sum_i[29] ^ Input_Byte_i[2] ^ Crc_Sum_i[28] ^ Input_Byte_i[3] ^ Crc_Sum_i[26] ^ Input_Byte_i[5] ^ Crc_Sum_i[25] ^ Crc_Sum_i[31] ^ Input_Byte_i[0] ^ Input_Byte_i[6];
    Crc32[10] = Crc_Sum_i[2] ^ Crc_Sum_i[30] ^ Input_Byte_i[1] ^ Crc_Sum_i[29] ^ Input_Byte_i[2] ^ Crc_Sum_i[27] ^ Input_Byte_i[4] ^ Crc_Sum_i[26] ^ Input_Byte_i[5] ^ Crc_Sum_i[24] ^ Crc_Sum_i[30] ^ Input_Byte_i[1] ^ Input_Byte_i[7];
    Crc32[11] = Crc_Sum_i[3] ^ Crc_Sum_i[31] ^ Input_Byte_i[0] ^ Crc_Sum_i[30] ^ Input_Byte_i[1] ^ Crc_Sum_i[28] ^ Input_Byte_i[3] ^ Crc_Sum_i[27] ^ Input_Byte_i[4] ^ Crc_Sum_i[25] ^ Crc_Sum_i[31] ^ Input_Byte_i[0] ^ Input_Byte_i[6] ^ Crc_Sum_i[24] ^ Crc_Sum_i[30] ^ Input_Byte_i[1] ^ Input_Byte_i[7];
    Crc32[12] = Crc_Sum_i[4] ^ Crc_Sum_i[31] ^ Input_Byte_i[0] ^ Crc_Sum_i[29] ^ Input_Byte_i[2] ^ Crc_Sum_i[28] ^ Input_Byte_i[3] ^ Crc_Sum_i[26] ^ Input_Byte_i[5] ^ Crc_Sum_i[25] ^ Crc_Sum_i[31] ^ Input_Byte_i[0] ^ Input_Byte_i[6] ^ Crc_Sum_i[24] ^ Crc_Sum_i[30] ^ Input_Byte_i[1] ^ Input_Byte_i[7];
    Crc32[13] = Crc_Sum_i[5] ^ Crc_Sum_i[30] ^ Input_Byte_i[1] ^ Crc_Sum_i[29] ^ Input_Byte_i[2] ^ Crc_Sum_i[27] ^ Input_Byte_i[4] ^ Crc_Sum_i[26] ^ Input_Byte_i[5] ^ Crc_Sum_i[25] ^ Crc_Sum_i[31] ^ Input_Byte_i[0] ^ Input_Byte_i[6];
    Crc32[14] = Crc_Sum_i[6] ^ Crc_Sum_i[31] ^ Input_Byte_i[0] ^ Crc_Sum_i[30] ^ Input_Byte_i[1] ^ Crc_Sum_i[28] ^ Input_Byte_i[3] ^ Crc_Sum_i[27] ^ Input_Byte_i[4] ^ Crc_Sum_i[26] ^ Input_Byte_i[5];
    Crc32[15] = Crc_Sum_i[7] ^ Crc_Sum_i[31] ^ Input_Byte_i[0] ^ Crc_Sum_i[29] ^ Input_Byte_i[2] ^ Crc_Sum_i[28] ^ Input_Byte_i[3] ^ Crc_Sum_i[27] ^ Input_Byte_i[4];
    Crc32[16] = Crc_Sum_i[8] ^ Crc_Sum_i[30] ^ Input_Byte_i[1] ^ Crc_Sum_i[29] ^ Input_Byte_i[2] ^ Crc_Sum_i[28] ^ Input_Byte_i[3] ^ Crc_Sum_i[24] ^ Crc_Sum_i[30] ^ Input_Byte_i[1] ^ Input_Byte_i[7];
    Crc32[17] = Crc_Sum_i[9] ^ Crc_Sum_i[31] ^ Input_Byte_i[0] ^ Crc_Sum_i[30] ^ Input_Byte_i[1] ^ Crc_Sum_i[29] ^ Input_Byte_i[2] ^ Crc_Sum_i[25] ^ Crc_Sum_i[31] ^ Input_Byte_i[0] ^ Input_Byte_i[6];
    Crc32[18] = Crc_Sum_i[10] ^ Crc_Sum_i[31] ^ Input_Byte_i[0] ^ Crc_Sum_i[30] ^ Input_Byte_i[1] ^ Crc_Sum_i[26] ^ Input_Byte_i[5];
    Crc32[19] = Crc_Sum_i[11] ^ Crc_Sum_i[31] ^ Input_Byte_i[0] ^ Crc_Sum_i[27] ^ Input_Byte_i[4];
    Crc32[20] = Crc_Sum_i[12] ^ Crc_Sum_i[28] ^ Input_Byte_i[3];
    Crc32[21] = Crc_Sum_i[13] ^ Crc_Sum_i[29] ^ Input_Byte_i[2];
    Crc32[22] = Crc_Sum_i[14] ^ Crc_Sum_i[30] ^ Input_Byte_i[1] ^ Crc_Sum_i[24] ^ Crc_Sum_i[30] ^ Input_Byte_i[1] ^ Input_Byte_i[7];
    Crc32[23] = Crc_Sum_i[15] ^ Crc_Sum_i[31] ^ Input_Byte_i[0] ^ Crc_Sum_i[25] ^ Crc_Sum_i[31] ^ Input_Byte_i[0] ^ Input_Byte_i[6] ^ Crc_Sum_i[24] ^ Crc_Sum_i[30] ^ Input_Byte_i[1] ^ Input_Byte_i[7];
    Crc32[24] = Crc_Sum_i[16] ^ Crc_Sum_i[26] ^ Input_Byte_i[5] ^ Crc_Sum_i[25] ^ Crc_Sum_i[31] ^ Input_Byte_i[0] ^ Input_Byte_i[6];
    Crc32[25] = Crc_Sum_i[17] ^ Crc_Sum_i[27] ^ Input_Byte_i[4] ^ Crc_Sum_i[26] ^ Input_Byte_i[5];
    Crc32[26] = Crc_Sum_i[18] ^ Crc_Sum_i[28] ^ Input_Byte_i[3] ^ Crc_Sum_i[27] ^ Input_Byte_i[4] ^ Crc_Sum_i[24] ^ Crc_Sum_i[30] ^ Input_Byte_i[1] ^ Input_Byte_i[7];
    Crc32[27] = Crc_Sum_i[19] ^ Crc_Sum_i[29] ^ Input_Byte_i[2] ^ Crc_Sum_i[28] ^ Input_Byte_i[3] ^ Crc_Sum_i[25] ^ Crc_Sum_i[31] ^ Input_Byte_i[0] ^ Input_Byte_i[6];
    Crc32[28] = Crc_Sum_i[20] ^ Crc_Sum_i[30] ^ Input_Byte_i[1] ^ Crc_Sum_i[29] ^ Input_Byte_i[2] ^ Crc_Sum_i[26] ^ Input_Byte_i[5];
    Crc32[29] = Crc_Sum_i[21] ^ Crc_Sum_i[31] ^ Input_Byte_i[0] ^ Crc_Sum_i[30] ^ Input_Byte_i[1] ^ Crc_Sum_i[27] ^ Input_Byte_i[4];
    Crc32[30] = Crc_Sum_i[22] ^ Crc_Sum_i[31] ^ Input_Byte_i[0] ^ Crc_Sum_i[28] ^ Input_Byte_i[3];
    Crc32[31] = Crc_Sum_i[23] ^ Crc_Sum_i[29] ^ Input_Byte_i[2];
  end
endfunction
