/*
 * _______________________________________________________________________________
 *
 *  Copyright (c) 2012 TU Dresden, Chair for Embedded Systems
 *  Copyright (c) 2013-2016 TU Darmstadt, Computer Systems Group
 *  (http://www.rs.tu-darmstadt.de) All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions
 *  are met:
 *
 *  1. Redistributions of source code must retain the above copyright
 *     notice, this list of conditions and the following disclaimer.
 *
 *  2. Redistributions in binary form must reproduce the above copyright
 *     notice, this list of conditions and the following disclaimer in the
 *     documentation and/or other materials provided with the distribution.
 *
 *  3. All advertising materials mentioning features or use of this software
 *     must display the following acknowledgement: "This product includes
 *     software developed by the TU Dresden Chair for Embedded Systems, TU Darmstadt Computer Systems Group and
 *     its contributors."
 *
 *  4. Neither the name of the TU Dresden Chair for Embedded Systems, TU Darmstadt Computer Systems Group nor the
 *     names of its contributors may be used to endorse or promote products
 *     derived from this software without specific prior written permission.
 *
 *  THIS SOFTWARE IS PROVIDED BY TU DRESDEN CHAIR FOR EMBEDDED SYSTEMS, TU DARMSTADT COMPUTER SYSTEMS GROUP AND
 *  CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING,
 *  BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
 *  FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 *  REGENTS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 *  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
 *  TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 *  PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 *  LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 *  NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 *  SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * _______________________________________________________________________________
 */

switch (document.target.targetName.toLowerCase()) {
	case "sp605":
		module.parameters["MEM_TYPE"] = "DDR3"
		pinFormats = [
				// controller
				clk_p: "CLOCK_SYSCLK_P",
				clk_n: "CLOCK_SYSCLK_N",
				mcb3_rzq: "FPGA_ONCHIP_TERM2_RZQ",
				mcb3_zio: "FPGA_ONCHIP_TERM1_ZIO",
				
				// ddr memory interface
				dram_dq: "MEM1_DQ%d",
				dram_udqs: "MEM1_UDQS_P",
				dram_udqs_n: "MEM1_UDQS_N",
				dram_dqs: "MEM1_LDQS_P",
				dram_dqs_n: "MEM1_LDQS_N",
				dram_a: "MEM1_A%d",
				dram_ba: "MEM1_BA%d",
				dram_ras_n: "MEM1_RAS_B",
				dram_cas_n: "MEM1_CAS_B",
				dram_we_n: "MEM1_WE_B",
				dram_odt: "MEM1_ODT",
				dram_reset_n: "MEM1_RESET_B",
				dram_cke: "MEM1_CKE",
				dram_dm: "MEM1_LDM",
				dram_udm: "MEM1_UDM",
				dram_ck: "MEM1_CLK_P",
				dram_ck_n: "MEM1_CLK_N",
		]
		break

	default:
		print "Target is not configured for the $module.moduleDescription.name module yet."
		return
}

// connect module ports with pins like described in pinFormats:
pinFormats.each {
	port = module.ports[it.key]
	pinFormat = it.value
	if (port.connectorWidth > 1)
		connectMultiple(port, 0, document, { String.format(pinFormat, it) })
	else
		connect(port, document.pins[String.format(pinFormat, 0)])
}

