/**
 * _______________________________________________________________________________
 *
 *  Copyright (c) 2012 TU Dresden, Chair for Embedded Systems
 *  Copyright (c) 2013-2016 TU Darmstadt, Computer Systems Group
 *  (http://www.rs.tu-darmstadt.de) All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions
 *  are met:
 *
 *  1. Redistributions of source code must retain the above copyright
 *     notice, this list of conditions and the following disclaimer.
 *
 *  2. Redistributions in binary form must reproduce the above copyright
 *     notice, this list of conditions and the following disclaimer in the
 *     documentation and/or other materials provided with the distribution.
 *
 *  3. All advertising materials mentioning features or use of this software
 *     must display the following acknowledgement: "This product includes
 *     software developed by the TU Dresden Chair for Embedded Systems, TU Darmstadt Computer Systems Group and
 *     its contributors."
 *
 *  4. Neither the name of the TU Dresden Chair for Embedded Systems, TU Darmstadt Computer Systems Group nor the
 *     names of its contributors may be used to endorse or promote products
 *     derived from this software without specific prior written permission.
 *
 *  THIS SOFTWARE IS PROVIDED BY TU DRESDEN CHAIR FOR EMBEDDED SYSTEMS, TU DARMSTADT COMPUTER SYSTEMS GROUP AND
 *  CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING,
 *  BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
 *  FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 *  REGENTS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 *  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
 *  TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 *  PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 *  LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 *  NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 *  SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * _______________________________________________________________________________
 */
assign ddr3_ila_basic[0] = init_calib_complete;
assign ddr3_ila_basic[1] = dbg_wrlvl_start;
assign ddr3_ila_basic[2] = dbg_wrlvl_done;
assign ddr3_ila_basic[3] = dbg_wrlvl_err;
assign ddr3_ila_basic[4] = dbg_pi_phaselock_start;
assign ddr3_ila_basic[5] = dbg_pi_phaselocked_done;
assign ddr3_ila_basic[6] = dbg_pi_phaselock_err;
assign ddr3_ila_basic[7] = dbg_pi_dqsfound_start;
assign ddr3_ila_basic[8] = dbg_pi_dqsfound_done;
assign ddr3_ila_basic[9] = dbg_pi_dqsfound_err;
assign ddr3_ila_basic[11:10] = dbg_rdlvl_start;
assign ddr3_ila_basic[13:12] = dbg_rdlvl_done;
assign ddr3_ila_basic[15:14] = dbg_rdlvl_err;
assign ddr3_ila_basic[16] = dbg_oclkdelay_calib_start;
assign ddr3_ila_basic[17] = dbg_oclkdelay_calib_done;
assign ddr3_ila_basic[18] = 1'b0;
assign ddr3_ila_basic[19] = dbg_wrcal_start;
assign ddr3_ila_basic[20] = dbg_wrcal_done;
assign ddr3_ila_basic[21] = dbg_wrcal_err;
assign ddr3_ila_basic[27:22] = dbg_phy_init[5:0];
assign ddr3_ila_basic[28]    = dbg_rddata_valid_r;
assign ddr3_ila_basic[92:29] = dbg_rddata_r;
// additional signals required for debug
assign ddr3_ila_basic[93]     = dbg_dqs_found_cal[14];
assign ddr3_ila_basic[119:94] = 26'b0;

assign ddr3_ila_wrpath[5:0]  = dbg_phy_wrlvl [31:27];
assign ddr3_ila_wrpath[9:6]  = dbg_phy_wrlvl [35:32];
assign ddr3_ila_wrpath[10]    = dbg_phy_wrlvl[60];
assign ddr3_ila_wrpath[11]    = rd_data_edge_detect_r[dbg_dqs];
assign ddr3_ila_wrpath[17:12] = wl_po_fine_cnt[(dbg_dqs*6)+5:(dbg_dqs*6)];
assign ddr3_ila_wrpath[20:18] = wl_po_coarse_cnt[(dbg_dqs*3)+2:(dbg_dqs*3)];
assign ddr3_ila_wrpath[26:21] = dbg_phy_wrlvl[66:61];
assign ddr3_ila_wrpath[31:27] = 5'b0;
assign ddr3_ila_wrpath[37:32] = ocal_tap_cnt[(dbg_dqs*6)+5:(dbg_dqs*6)];
assign ddr3_ila_wrpath[38]    = dbg_phy_oclkdelay_cal[58];
assign ddr3_ila_wrpath[39]    = dbg_phy_oclkdelay_cal[59];
assign ddr3_ila_wrpath[45:40] = dbg_phy_oclkdelay_cal[65:60];
assign ddr3_ila_wrpath[51:46] = dbg_phy_oclkdelay_cal[71:66];
assign ddr3_ila_wrpath[56:52] = dbg_phy_oclkdelay_cal[76:72];
assign ddr3_ila_wrpath[62:57] = dbg_phy_oclkdelay_cal[214:219];
assign ddr3_ila_wrpath[63]    = 1'b0;
// write calibration stage debug signals
assign ddr3_ila_wrpath[64]    = dbg_phy_wrcal[0];
assign ddr3_ila_wrpath[65]    = dbg_phy_wrcal[8];
assign ddr3_ila_wrpath[69:66] = dbg_phy_wrcal[12+DQS_CNT_WIDTH:13];
assign ddr3_ila_wrpath[74:70] = dbg_phy_wrcal[5:1];
assign ddr3_ila_wrpath[79:75] = dbg_phy_wrcal[70:66];
assign ddr3_ila_wrpath[80]    = dbg_phy_wrcal[71];
assign ddr3_ila_wrpath[81]    = dbg_phy_wrcal[72];
assign ddr3_ila_wrpath[87:82] = 6'b0;
assign ddr3_ila_wrpath[91:88]  = dbg_phy_oclkdelay_cal[57:54];
assign ddr3_ila_wrpath[95:92]  = 4'b0;
assign ddr3_ila_wrpath[149:96] = dbg_phy_wrlvl[129:76];
assign ddr3_ila_wrpath[176:150]= dbg_phy_wrlvl[156:130];
assign ddr3_ila_wrpath[184:177] = dbg_phy_rdlvl[177:170];
assign ddr3_ila_wrpath[192:185] = dbg_phy_rdlvl[185:178];
assign ddr3_ila_wrpath[200:193] = dbg_phy_rdlvl[193:186];
assign ddr3_ila_wrpath[208:201] = dbg_phy_rdlvl[201:194];
assign ddr3_ila_wrpath[216:209] = dbg_phy_rdlvl[209:202];
assign ddr3_ila_wrpath[224:217] = dbg_phy_rdlvl[217:210];
assign ddr3_ila_wrpath[232:225] = dbg_phy_rdlvl[225:218];
assign ddr3_ila_wrpath[240:233] = dbg_phy_rdlvl[233:226];
assign ddr3_ila_wrpath[255:241]= 15'b0;

// PHASER_IN debug signals
assign ddr3_ila_rdpath[11:0]  = dbg_pi_phase_locked_phy4lanes;
assign ddr3_ila_rdpath[23:12] = dbg_pi_dqs_found_lanes_phy4lanes;
assign ddr3_ila_rdpath[35:24] = dbg_rd_data_offset;
assign ddr3_ila_rdpath[39:36]  = 4'b0;
// read-leveling calibration debug data
assign ddr3_ila_rdpath[45:40] = dbg_phy_rdlvl[14:9];
assign ddr3_ila_rdpath[49:46] = dbg_phy_rdlvl[64:61];
assign ddr3_ila_rdpath[57:50] = dbg_phy_rdlvl[177:170];
assign ddr3_ila_rdpath[65:58] = dbg_phy_rdlvl[185:178];
assign ddr3_ila_rdpath[73:66] = dbg_phy_rdlvl[193:186];
assign ddr3_ila_rdpath[81:74] = dbg_phy_rdlvl[201:194];
assign ddr3_ila_rdpath[89:82] = dbg_phy_rdlvl[209:202];
assign ddr3_ila_rdpath[97:90] = dbg_phy_rdlvl[217:210];
assign ddr3_ila_rdpath[105:98] = dbg_phy_rdlvl[225:218];
assign ddr3_ila_rdpath[113:106] = dbg_phy_rdlvl[233:226];
assign ddr3_ila_rdpath[114]   = dbg_phy_rdlvl[1];
assign ddr3_ila_rdpath[115]   = dbg_phy_rdlvl[2];
assign ddr3_ila_rdpath[121:116] = dbg_cpt_first_edge_cnt[(dbg_dqs*6)+5:(dbg_dqs*6)];
assign ddr3_ila_rdpath[127:122] = dbg_cpt_second_edge_cnt[(dbg_dqs*6)+5:(dbg_dqs*6)];
assign ddr3_ila_rdpath[133:128] = dbg_cpt_tap_cnt[(dbg_dqs*6)+5:(dbg_dqs*6)];
assign ddr3_ila_rdpath[138:134] = dbg_dq_idelay_tap_cnt[(dbg_dqs*5)+4:(dbg_dqs*6)];
assign ddr3_ila_rdpath[163:139] = 25'b0;
// data offset values for PHASER_IN
assign ddr3_ila_rdpath[175:164] = dbg_calib_rd_data_offset_1;
assign ddr3_ila_rdpath[187:176] = dbg_calib_rd_data_offset_2;
assign ddr3_ila_rdpath[193:188]  = dbg_data_offset;
assign ddr3_ila_rdpath[199:194]  = dbg_data_offset_1;
assign ddr3_ila_rdpath[205:200]  = dbg_data_offset_2;
assign ddr3_ila_rdpath[313:206] = dbg_cpt_first_edge_cnt;
assign ddr3_ila_rdpath[421:314] = dbg_cpt_second_edge_cnt;
assign ddr3_ila_rdpath[529:422] = dbg_cpt_tap_cnt;
assign ddr3_ila_rdpath[619:530]  = dbg_dq_idelay_tap_cnt;
assign ddr3_ila_rdpath[874:620]  = dbg_prbs_rdlvl;
