

import java.awt.image.BufferedImage;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;

import javax.imageio.ImageIO;


public class img_gen {
	img_gen(String inputFile, String outputFile, int BPP, int wordWidth) {
		// Eingangsbild laden
		/*Image img = Toolkit.getDefaultToolkit().getImage(inputFile);
		int imgWidth = img.getWidth(null);
		int imgHeight = img.getHeight(null);
		int[] pixelArray = new int[imgWidth * imgHeight];
		new PixelGrabber(img, 0, 0, imgWidth, imgHeight, pixelArray, 0, imgWidth);
		*/
		try {
			BufferedImage img = ImageIO.read(new File(inputFile));
			int imgWidth = img.getWidth();
			int imgHeight = img.getHeight();
			// Ausagbedatei oeffnen
			File outFile;
			FileWriter o;
			
			outFile = new File(outputFile);
			o = new FileWriter(outFile);
			o.write("memory_initialization_radix=2;\n");
			o.write("memory_initialization_vector=\n");
			
			int x, y, i, color, outWordInt, arrIdx;
			char[] outWordArr = new char[wordWidth];
			arrIdx = wordWidth - BPP;
			
			for (y = 0; y < imgHeight; y++) {
				for (x = 0; x < imgWidth; x++) {
					//color = pixelArray[y*imgWidth + x];
					color = img.getRGB(x, y) & 0x00FFFFFF;
					
					// Farbwert auf 2^BPP Farben skalieren
					outWordInt = (color * (1 << BPP) / 0x1000000);
					
					// und diesen danach in seine einzelnen Bits zerlegen
					for (i = BPP-1; i >= 0; i--) {
						// lsb gesetzt? dann "1" ins array schreiben, sonst "0"
						outWordArr[arrIdx + i] = ((outWordInt & 1) == 1) ? '1' : '0';
						outWordInt >>>= 1;
					}
					
					if (0 == arrIdx) {
						o.write(outWordArr);
						o.write(",\n");
						arrIdx = wordWidth - BPP;
					}
					else {
						arrIdx = arrIdx - BPP;
					}
				}
			}
			
			o.close();
		}
		catch (IOException e) {
			e.printStackTrace();
			return;
		}
		
	}

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		if (args.length < 4) {
			System.out.println("Builds up a coefficient file for the initialization of memories in Xilinx ISE");
			System.out.println("Only GIF, JPG and PNG files are supported!");
			System.out.println("Usage: [inputFile] [outputFile] [bit per pixel] [word width]");
		}
		else {
			new img_gen(args[0], args[1], Integer.decode(args[2]).intValue(), Integer.decode(args[3]).intValue());
		}
	}

}
