

import java.io.File;
import java.io.BufferedReader;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.lang.Integer;

public class mif2sph {
	mif2sph(String inputFile, String outputFile, int numberOfDigits) {
		try {
			BufferedReader i = new BufferedReader(new FileReader(inputFile));
			FileWriter o = new FileWriter(outputFile);
			String s, sOut;
			int value;

			do {
				s = i.readLine();
				if (s != null) {
					value = 0;
					for (int idx = s.length()-1; idx >= 0; idx--) {
						if (s.charAt(idx) == '1')
							value += 1 << ((s.length()-1)-idx);
					}
					sOut = Integer.toHexString(value);
					while (sOut.length() < numberOfDigits)
						sOut = '0' + sOut;
					o.write(sOut + "\n");
				}
			} while ( s != null);
			i.close();
			o.close();
		}
		catch (IOException e) {
			e.printStackTrace();
		}
	}

	public static void main(String[] args) {
		if (args.length < 3) {
			System.out.println("Converts the \"ascii binary\" content ('0' and '1') of the input file to hex codes with the given minimum length");
			System.out.println("Example: Input \"10100100\" is written as \"00A4\" to the output file when \"hexLength\" is set to 4");
			System.out.println("Usage: mif2sph [inputFile] [outputFile] [hexLength]\n");
		}
		else
			new mif2sph(args[0], args[1], Integer.parseInt(args[2]));
	}
}
