

import java.io.File;
import java.io.BufferedReader;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.lang.Integer;

public class mifmerge {
	mifmerge(String inputFile, String outputFile, int linesToMerge) {
		try {
			BufferedReader i = new BufferedReader(new FileReader(inputFile));
			FileWriter o = new FileWriter(outputFile);
			String s = "";
			String sIn;
			int lineCount = 0;
			
			do {
				sIn = i.readLine();
				s = (lineCount % linesToMerge == 0) ? sIn : sIn + s;
				if (s != null) {
					if (lineCount % linesToMerge == linesToMerge-1) {
						o.write(s + "\n");
					}
				}
				lineCount++;
			} while (sIn != null);
			i.close();
			o.close();
		}
		catch (IOException e) {
			e.printStackTrace();
		}
	}
	
	public static void main(String[] args) {
		if (args.length < 3) {
			System.out.println("Merges a given number of lines to only one where the content of the first line is at the end of the merged line.");
			System.out.println("Example:");
			System.out.println("  Line1");
			System.out.println("  Line2");
			System.out.println("  Line3");
			System.out.println("  Line4\n");

			System.out.println("Merged: Line4Line3Line2Line1\n");

			System.out.println("Usage: mifmerge [inputFile] [outputFile] [numberOfLinesToMerge]\n");
		}
		else
			new mifmerge(args[0], args[1], Integer.parseInt(args[2]));
	}
}
