/**
 * _______________________________________________________________________________
 *
 *  Copyright (c) 2012 TU Dresden, Chair for Embedded Systems
 *  Copyright (c) 2013-2016 TU Darmstadt, Computer Systems Group
 *  (http://www.rs.tu-darmstadt.de) All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions
 *  are met:
 *
 *  1. Redistributions of source code must retain the above copyright
 *     notice, this list of conditions and the following disclaimer.
 *
 *  2. Redistributions in binary form must reproduce the above copyright
 *     notice, this list of conditions and the following disclaimer in the
 *     documentation and/or other materials provided with the distribution.
 *
 *  3. All advertising materials mentioning features or use of this software
 *     must display the following acknowledgement: "This product includes
 *     software developed by the TU Dresden Chair for Embedded Systems, TU Darmstadt Computer Systems Group and
 *     its contributors."
 *
 *  4. Neither the name of the TU Dresden Chair for Embedded Systems, TU Darmstadt Computer Systems Group nor the
 *     names of its contributors may be used to endorse or promote products
 *     derived from this software without specific prior written permission.
 *
 *  THIS SOFTWARE IS PROVIDED BY TU DRESDEN CHAIR FOR EMBEDDED SYSTEMS, TU DARMSTADT COMPUTER SYSTEMS GROUP AND
 *  CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING,
 *  BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
 *  FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 *  REGENTS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 *  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
 *  TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 *  PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 *  LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 *  NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 *  SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * _______________________________________________________________________________
 */
`timescale 1ns / 1ps
`default_nettype none

////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer:
//
// Create Date:   15:43:01 05/07/2015
// Design Name:   dvi
// Module Name:   test_dvi.v
// Project Name:  spmc-dvi
// Target Device:  
// Tool versions:  
// Description: 
//
// Verilog Test Fixture created by ISE for module: dvi
//
// Dependencies:
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
////////////////////////////////////////////////////////////////////////////////

module test_dvi;

	// Inputs
	reg clk_peri;
	reg [18:0] do_peri;
	reg [9:0] addr_peri;
	reg access_peri;
	reg wr_peri;
	reg reset;
	reg clk_pixel;

	// Outputs
	wire [17:0] di_peri;
	wire [11:0] dvi_data;
	wire xclk_n;
	wire xclk_p;
	wire data_en;
	wire h_sync;
	wire v_sync;

	// Instantiate the Unit Under Test (UUT)
	dvi uut (
		.clk_peri(clk_peri), 
		.do_peri(do_peri), 
		.di_peri(di_peri), 
		.addr_peri(addr_peri), 
		.access_peri(access_peri), 
		.wr_peri(wr_peri), 
		.reset(reset), 
		.dvi_data(dvi_data), 
		.xclk_n(xclk_n), 
		.xclk_p(xclk_p), 
		.data_en(data_en), 
		.h_sync(h_sync), 
		.v_sync(v_sync),
		.clk_pixel(clk_pixel)
	);

	initial begin
		// Initialize Inputs
		clk_peri = 0;
		do_peri = 1;
		addr_peri = 0;
		access_peri = 0;
		wr_peri = 1;
		reset = 1;
		clk_pixel = 0;

		// Wait 100 ns for global reset to finish
		#100;
		
		reset = 0;
		
		#100
		access_peri = 1;
		#20
		access_peri = 0;
        
		// Add stimulus here

	end
	
	//60MHz clock
	always begin
		#8.333
		clk_peri = ~clk_peri;
	end
	
	
	//108MHz clock
	always begin
		#4.63
		clk_pixel = ~clk_pixel;
	end
      
endmodule

