/**
 * _______________________________________________________________________________
 *
 *  Copyright (c) 2012 TU Dresden, Chair for Embedded Systems
 *  Copyright (c) 2013-2016 TU Darmstadt, Computer Systems Group
 *  (http://www.rs.tu-darmstadt.de) All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions
 *  are met:
 *
 *  1. Redistributions of source code must retain the above copyright
 *     notice, this list of conditions and the following disclaimer.
 *
 *  2. Redistributions in binary form must reproduce the above copyright
 *     notice, this list of conditions and the following disclaimer in the
 *     documentation and/or other materials provided with the distribution.
 *
 *  3. All advertising materials mentioning features or use of this software
 *     must display the following acknowledgement: "This product includes
 *     software developed by the TU Dresden Chair for Embedded Systems, TU Darmstadt Computer Systems Group and
 *     its contributors."
 *
 *  4. Neither the name of the TU Dresden Chair for Embedded Systems, TU Darmstadt Computer Systems Group nor the
 *     names of its contributors may be used to endorse or promote products
 *     derived from this software without specific prior written permission.
 *
 *  THIS SOFTWARE IS PROVIDED BY TU DRESDEN CHAIR FOR EMBEDDED SYSTEMS, TU DARMSTADT COMPUTER SYSTEMS GROUP AND
 *  CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING,
 *  BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
 *  FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 *  REGENTS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 *  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
 *  TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 *  PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 *  LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 *  NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 *  SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * _______________________________________________________________________________
 */
`timescale 1ns / 1ns
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date:    14:44:31 11/15/2010 
// Design Name: 
// Module Name:    DmaMemory 
// Project Name: 
// Target Devices: 
// Tool versions: 
// Description: 
//
// Dependencies: 
//
// Revision: 
// Revision 0.01 - File Created
// Additional Comments: 
//
//////////////////////////////////////////////////////////////////////////////////

//Port A/B are "memory ports"
//Port 0/1 are "ethernet ports"
`default_nettype none
module DmaMemory18to8(
	input wire Reset,
	//Port A - SpartanMC
	input wire A_Clk,
	input wire [11:0] A_Addr,
	input wire [17:0] A_DataIn,
	output wire [17:0] A_DataOut,
	input wire A_Enable,	//	0 disable the port
	input wire A_WriteEnable,	// 1 write operation, 0 read operation
	
	//Port B - Ethernet module
	input wire B_Clk,
	input wire B_Enable,	//	0 disable the port
	
	input wire [10:0] B_Addr,
	input wire [7:0] B_DataIn,
	output wire [7:0] B_DataOut,
	input wire B_WriteEnable	// 1 write operation, 0 read operation
	/*//tx
	input wire [10:0] B_Addrtx,
	input wire [7:0] B_DataIntx,
	output wire [7:0] B_DataOuttx,
	input wire B_WriteEnabletx	// 1 write operation, 0 read operation*/
);

assign A_DataOut[17:16] = 0;

//Port 0
//rx
BlockRam18to9 br_0(Reset,
//Port A
A_Clk,A_Addr[9:0],A_DataIn[15:0],A_DataIn[17:16],A_DataOut[15:0],,
A_Enable,A_WriteEnable,
//Port B
B_Clk,B_Addr,B_DataIn,1'b0,B_DataOut,,
B_Enable,B_WriteEnable
);
/*//tx
BlockRam18to9 br_1(Reset,
//Port A
A_Clk,A_Addr[9:0],A_DataIn[15:0],A_DataIn[17:16],dataAouttx[15:0],,
A_Enable,writeAtx,
//Port B
B_Clk,B_Addrtx,B_DataIntx,1'b0,B_DataOuttx,,
B_Enable,B_WriteEnabletx
);*/

endmodule
