/**
 * _______________________________________________________________________________
 *
 *  Copyright (c) 2012 TU Dresden, Chair for Embedded Systems
 *  Copyright (c) 2013-2016 TU Darmstadt, Computer Systems Group
 *  (http://www.rs.tu-darmstadt.de) All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions
 *  are met:
 *
 *  1. Redistributions of source code must retain the above copyright
 *     notice, this list of conditions and the following disclaimer.
 *
 *  2. Redistributions in binary form must reproduce the above copyright
 *     notice, this list of conditions and the following disclaimer in the
 *     documentation and/or other materials provided with the distribution.
 *
 *  3. All advertising materials mentioning features or use of this software
 *     must display the following acknowledgement: "This product includes
 *     software developed by the TU Dresden Chair for Embedded Systems, TU Darmstadt Computer Systems Group and
 *     its contributors."
 *
 *  4. Neither the name of the TU Dresden Chair for Embedded Systems, TU Darmstadt Computer Systems Group nor the
 *     names of its contributors may be used to endorse or promote products
 *     derived from this software without specific prior written permission.
 *
 *  THIS SOFTWARE IS PROVIDED BY TU DRESDEN CHAIR FOR EMBEDDED SYSTEMS, TU DARMSTADT COMPUTER SYSTEMS GROUP AND
 *  CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING,
 *  BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
 *  FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 *  REGENTS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 *  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
 *  TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 *  PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 *  LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 *  NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 *  SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * _______________________________________________________________________________
 */
`timescale 1ns / 1ps
`default_nettype none

////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer:
//
// Create Date:   14:53:10 12/13/2013
// Design Name:   port_out_expander
// Module Name:   poe_test.v
// Project Name:  ise_miner
// Target Device:  
// Tool versions:  
// Description: 
//
// Verilog Test Fixture created by ISE for module: port_out_expander
//
// Dependencies:
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
////////////////////////////////////////////////////////////////////////////////

module poe_test;

	// Inputs
	reg clk_peri;
	reg [17:0] do_peri;
	reg [9:0] addr_peri;
	reg access_peri;
	reg wr_peri;
	reg reset;

	// Outputs
	wire [17:0] di_peri;
	wire [511:0] pin;
	wire strobe;

	// Instantiate the Unit Under Test (UUT)
	port_out_expander uut (
		.clk_peri(clk_peri), 
		.do_peri(do_peri), 
		.di_peri(di_peri), 
		.addr_peri(addr_peri), 
		.access_peri(access_peri), 
		.wr_peri(wr_peri), 
		.reset(reset), 
		.pin(pin), 
		.strobe(strobe)
	);

parameter PERIOD2 = 20;

   initial begin
      clk_peri = 1'b0;
      #(PERIOD2/2);
      forever
         #(PERIOD2/2) clk_peri = ~clk_peri;
   end

integer i;
	initial begin
		// Initialize Inputs
		clk_peri = 0;
		do_peri = 0;
		addr_peri = 0;
		access_peri = 0;
		wr_peri = 0;
		reset = 1;
		i = 0;
		// Wait 100 ns for global reset to finish
		#100;
      reset = 0;
		#100;
		// Add stimulus here
		
		
		@(posedge clk_peri);
		addr_peri <= 1;
		do_peri <= 64;
		access_peri = 1;
		wr_peri = 1;
		@(posedge clk_peri);
		addr_peri <= 0;
		do_peri <= 0;
		access_peri = 0;
		wr_peri = 0;		
		#100
		for(i=1;i<129;i=i+1) begin
		@(posedge clk_peri);
		addr_peri <= 0;
		do_peri <= i;
		access_peri = 1;
		wr_peri = 1;
		@(posedge clk_peri);
		addr_peri <= 0;
		do_peri <= 0;
		access_peri = 0;
		wr_peri = 0;	
		end
	end
      
endmodule

