/**
 * _______________________________________________________________________________
 *
 *  Copyright (c) 2012 TU Dresden, Chair for Embedded Systems
 *  Copyright (c) 2013-2016 TU Darmstadt, Computer Systems Group
 *  (http://www.rs.tu-darmstadt.de) All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions
 *  are met:
 *
 *  1. Redistributions of source code must retain the above copyright
 *     notice, this list of conditions and the following disclaimer.
 *
 *  2. Redistributions in binary form must reproduce the above copyright
 *     notice, this list of conditions and the following disclaimer in the
 *     documentation and/or other materials provided with the distribution.
 *
 *  3. All advertising materials mentioning features or use of this software
 *     must display the following acknowledgement: "This product includes
 *     software developed by the TU Dresden Chair for Embedded Systems, TU Darmstadt Computer Systems Group and
 *     its contributors."
 *
 *  4. Neither the name of the TU Dresden Chair for Embedded Systems, TU Darmstadt Computer Systems Group nor the
 *     names of its contributors may be used to endorse or promote products
 *     derived from this software without specific prior written permission.
 *
 *  THIS SOFTWARE IS PROVIDED BY TU DRESDEN CHAIR FOR EMBEDDED SYSTEMS, TU DARMSTADT COMPUTER SYSTEMS GROUP AND
 *  CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING,
 *  BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
 *  FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 *  REGENTS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 *  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
 *  TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 *  PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 *  LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 *  NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 *  SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * _______________________________________________________________________________
 */

//`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date:    09:07:39 07/16/2010 
// Design Name: 
// Module Name:    jtag_parameter 
// Project Name: 
// Target Devices: 
// Tool versions: 
// Description: 
//
// Dependencies: 
//
// Revision: 
// Revision 0.01 - File Created
// Additional Comments: 
//
//////////////////////////////////////////////////////////////////////////////////

	
	// parameter TAP-Master-State
	parameter State_Reset			= 4'h0;
	parameter State_Idle				= 4'h1;
	parameter State_Waiting			= 4'h2;
	parameter State_TapToStart		= 4'h3;
	parameter State_Shift			= 4'h4;
	parameter State_TapToEnd		= 4'h5;
	parameter State_Correct_1		= 4'h6;
	parameter State_Correct_2		= 4'h7;
	parameter State_setTclk			= 4'h8;
	parameter State_setTMS			= 4'h9;
	parameter State_setTDI			= 4'hA;
	
	// parameter Shift State
	parameter idle						= 3'h0;
	parameter prepare_for_working	= 3'h1;
	parameter shifting1				= 3'h2;
	parameter shifting2				= 3'h3;
	parameter shifting3				= 3'h4;
	parameter shifting4				= 3'h5;
	parameter shift_unused1			= 3'h6;
	parameter shift_unused2			= 3'h7;
	
	// parameter TMS State
	//parameter idle						= 3'h0; 
	//parameter prepare_for_working	= 3'h1;
	parameter working_normal1		= 3'h2;
	parameter working_normal2		= 3'h3;
	parameter working_normal3 		= 3'h4;
	parameter working_softreset1	= 3'h5;
	parameter working_softreset2	= 3'h6;
	parameter working_softreset3	= 3'h7;
	
	
	// parameter für TAP-STATE
	parameter TEST_LOGIC_RESET  	= 4'h0;
	parameter RUN_TEST_IDLE			= 4'h1;
	parameter SELECT_DR				= 4'h2;
	parameter CAPTURE_DR				= 4'h3;
	parameter SHIFT_DR			 	= 4'h4;
	parameter EXIT1_DR			 	= 4'h5;
	parameter PAUSE_DR			 	= 4'h6;
	parameter EXIT2_DR			 	= 4'h7;
	parameter UPDATE_DR			 	= 4'h8;
	parameter SELECT_IR			 	= 4'h9;
	parameter CAPTURE_IR			 	= 4'hA;
	parameter SHIFT_IR			 	= 4'hB;
	parameter EXIT1_IR			 	= 4'hC;
	parameter PAUSE_IR			 	= 4'hD;
	parameter EXIT2_IR			 	= 4'hE;
	parameter UPDATE_IR			 	= 4'hF;
