/**
 * _______________________________________________________________________________
 *
 *  Copyright (c) 2012 TU Dresden, Chair for Embedded Systems
 *  Copyright (c) 2013-2016 TU Darmstadt, Computer Systems Group
 *  (http://www.rs.tu-darmstadt.de) All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions
 *  are met:
 *
 *  1. Redistributions of source code must retain the above copyright
 *     notice, this list of conditions and the following disclaimer.
 *
 *  2. Redistributions in binary form must reproduce the above copyright
 *     notice, this list of conditions and the following disclaimer in the
 *     documentation and/or other materials provided with the distribution.
 *
 *  3. All advertising materials mentioning features or use of this software
 *     must display the following acknowledgement: "This product includes
 *     software developed by the TU Dresden Chair for Embedded Systems, TU Darmstadt Computer Systems Group and
 *     its contributors."
 *
 *  4. Neither the name of the TU Dresden Chair for Embedded Systems, TU Darmstadt Computer Systems Group nor the
 *     names of its contributors may be used to endorse or promote products
 *     derived from this software without specific prior written permission.
 *
 *  THIS SOFTWARE IS PROVIDED BY TU DRESDEN CHAIR FOR EMBEDDED SYSTEMS, TU DARMSTADT COMPUTER SYSTEMS GROUP AND
 *  CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING,
 *  BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
 *  FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 *  REGENTS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 *  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
 *  TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 *  PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 *  LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 *  NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 *  SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * _______________________________________________________________________________
 */

`default_nettype none

//*** Operationscodes fuer Speicher ***

//Signale 				{  RAS,CAS,WE } 
`define OP_NOP			3'b1___1___1			//HEX 7
`define OP_ACTIVE		3'b0___1___1			//HEX 3
`define OP_READ		3'b1___0___1			//HEX 5
`define OP_WRITE		3'b1___0___0			//HEX 4
`define OP_TERM		3'b1___1___0			//HEX 6
`define OP_PRECH		3'b0___1___0			//HEX	2
`define OP_AUREFR		3'b0___0___1			//HEX 1
`define OP_MREGSET	3'b0___0___0			//HEX 0

//*** Adressauswahl ***
`define ADDR_INIT		3'bx00					//InitRAM (Daten fuer Mode Register)
`define ADDR_WRROW	3'b001					//Schreibadresse (Zeile)
`define ADDR_WRCOL	3'b101					//Schreibadresse (Spalte)
`define ADDR_RDROW	3'b010					//Leseadresse (Zeile)
`define ADDR_RDCOL	3'b110					//Leseadresse (Spalte)
`define ADDR_REFR		3'bx11					//Refreshadresse (Zeile)

//*** Zugriffsmodi ***
`define M_REFR			2'b00
`define M_WRITE		2'b01
`define M_READ			2'b10
`define M_DUAL			2'b11
