proc build_uart_light_microblaze { design_name params } {

	#set default paramater values
	array set optional [list \
-UART_BAUDRATE "9600" \
{*}$params]
	
	set UART_BAUDRATE $optional(-UART_BAUDRATE)

	# Create instance: axi_uartlite_0, and set properties
	set axi_uartlite_0 [ create_bd_cell -type ip -vlnv xilinx.com:ip:axi_uartlite:2.0 $design_name ]
set_property -dict [ list \
CONFIG.C_BAUDRATE $UART_BAUDRATE \
] $axi_uartlite_0

}

proc automate_uart_light_microblaze { design_name parent_module} {

	#delete dummy ports
	delete_bd_objs [get_bd_ports uart_rtl_txd]
	delete_bd_objs [get_bd_ports uart_rtl_rxd]
	
	#connect peripheral to core via AXI interconnect
	apply_bd_automation -rule xilinx.com:bd_rule:axi4 -config [list Master "/$parent_module (Periph)" Clk "Auto"] [get_bd_intf_pins $design_name/S_AXI]
	#connect to UART pins
	apply_bd_automation -rule xilinx.com:bd_rule:board  [get_bd_intf_pins $design_name/UART]
}
