/**
 * _______________________________________________________________________________
 *
 *  Copyright (c) 2012 TU Dresden, Chair for Embedded Systems
 *  Copyright (c) 2013-2016 TU Darmstadt, Computer Systems Group
 *  (http://www.rs.tu-darmstadt.de) All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions
 *  are met:
 *
 *  1. Redistributions of source code must retain the above copyright
 *     notice, this list of conditions and the following disclaimer.
 *
 *  2. Redistributions in binary form must reproduce the above copyright
 *     notice, this list of conditions and the following disclaimer in the
 *     documentation and/or other materials provided with the distribution.
 *
 *  3. All advertising materials mentioning features or use of this software
 *     must display the following acknowledgement: "This product includes
 *     software developed by the TU Dresden Chair for Embedded Systems, TU Darmstadt Computer Systems Group and
 *     its contributors."
 *
 *  4. Neither the name of the TU Dresden Chair for Embedded Systems, TU Darmstadt Computer Systems Group nor the
 *     names of its contributors may be used to endorse or promote products
 *     derived from this software without specific prior written permission.
 *
 *  THIS SOFTWARE IS PROVIDED BY TU DRESDEN CHAIR FOR EMBEDDED SYSTEMS, TU DARMSTADT COMPUTER SYSTEMS GROUP AND
 *  CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING,
 *  BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
 *  FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 *  REGENTS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 *  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
 *  TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 *  PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 *  LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 *  NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 *  SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * _______________________________________________________________________________
 */

 `default_nettype none

module mult18_prim
(
	A,
	B,
	P
);


input wire	[17:0]	A;
input wire 	[17:0]	B;

output wire	[35:0]	P;


    defparam dsp_0.GSR = "ENABLED" ;
    defparam dsp_0.REG_SIGNEDB_RST = "RST0" ;
    defparam dsp_0.REG_SIGNEDB_CE = "CE0" ;
    defparam dsp_0.REG_SIGNEDB_CLK = "NONE" ;
    defparam dsp_0.REG_SIGNEDA_RST = "RST0" ;
    defparam dsp_0.REG_SIGNEDA_CE = "CE0" ;
    defparam dsp_0.REG_SIGNEDA_CLK = "NONE" ;
    defparam dsp_0.REG_OUTPUT_RST = "RST0" ;
    defparam dsp_0.REG_OUTPUT_CE = "CE0" ;
    defparam dsp_0.REG_OUTPUT_CLK = "NONE" ;
    defparam dsp_0.REG_PIPELINE_RST = "RST0" ;
    defparam dsp_0.REG_PIPELINE_CE = "CE0" ;
    defparam dsp_0.REG_PIPELINE_CLK = "NONE" ;
    defparam dsp_0.REG_INPUTB_RST = "RST0" ;
    defparam dsp_0.REG_INPUTB_CE = "CE0" ;
    defparam dsp_0.REG_INPUTB_CLK = "NONE" ;
    defparam dsp_0.REG_INPUTA_RST = "RST0" ;
    defparam dsp_0.REG_INPUTA_CE = "CE0" ;
    defparam dsp_0.REG_INPUTA_CLK = "NONE" ;

    MULT18X18B dsp_0 (.A17(A[17]), .A16(A[16]), .A15(A[15]), .A14(A[14]), 
        .A13(A[13]), .A12(A[12]), .A11(A[11]), .A10(A[10]), .A9(A[9]), .A8(A[8]), 
        .A7(A[7]), .A6(A[6]), .A5(A[5]), .A4(A[4]), .A3(A[3]), .A2(A[2]), 
        .A1(A[1]), .A0(A[0]), .B17(B[17]), .B16(B[16]), .B15(B[15]), .B14(B[14]), 
        .B13(B[13]), .B12(B[12]), .B11(B[11]), .B10(B[10]), .B9(B[9]), .B8(B[8]), 
        .B7(B[7]), .B6(B[6]), .B5(B[5]), .B4(B[4]), .B3(B[3]), .B2(B[2]), 
        .B1(B[1]), .B0(B[0]), .SIGNEDA(1'b1), .SIGNEDB(1'b1), 
        .SOURCEA(1'b0), .SOURCEB(1'b0), .CE0(1'b1), .CE1(1'b1), 
        .CE2(1'b1), .CE3(1'b1), .CLK0(1'b0), .CLK1(1'b0), 
        .CLK2(1'b0), .CLK3(1'b0), .RST0(1'b0), .RST1(1'b0), 
        .RST2(1'b0), .RST3(1'b0), .SRIA17(1'b0), .SRIA16(1'b0), 
        .SRIA15(1'b0), .SRIA14(1'b0), .SRIA13(1'b0), .SRIA12(1'b0), 
        .SRIA11(1'b0), .SRIA10(1'b0), .SRIA9(1'b0), .SRIA8(1'b0), 
        .SRIA7(1'b0), .SRIA6(1'b0), .SRIA5(1'b0), .SRIA4(1'b0), 
        .SRIA3(1'b0), .SRIA2(1'b0), .SRIA1(1'b0), .SRIA0(1'b0), 
        .SRIB17(1'b0), .SRIB16(1'b0), .SRIB15(1'b0), .SRIB14(1'b0), 
        .SRIB13(1'b0), .SRIB12(1'b0), .SRIB11(1'b0), .SRIB10(1'b0), 
        .SRIB9(1'b0), .SRIB8(1'b0), .SRIB7(1'b0), .SRIB6(1'b0), 
        .SRIB5(1'b0), .SRIB4(1'b0), .SRIB3(1'b0), .SRIB2(1'b0), 
        .SRIB1(1'b0), .SRIB0(1'b0), .SROA17(), .SROA16(), .SROA15(), 
        .SROA14(), .SROA13(), .SROA12(), .SROA11(), .SROA10(), .SROA9(), 
        .SROA8(), .SROA7(), .SROA6(), .SROA5(), .SROA4(), .SROA3(), .SROA2(), 
        .SROA1(), .SROA0(), .SROB17(), .SROB16(), .SROB15(), .SROB14(), 
        .SROB13(), .SROB12(), .SROB11(), .SROB10(), .SROB9(), .SROB8(), 
        .SROB7(), .SROB6(), .SROB5(), .SROB4(), .SROB3(), .SROB2(), .SROB1(), 
        .SROB0(), .P35(P[35]), .P34(P[34]), .P33(P[33]), .P32(P[32]), .P31(P[31]), 
        .P30(P[30]), .P29(P[29]), .P28(P[28]), .P27(P[27]), .P26(P[26]), 
        .P25(P[25]), .P24(P[24]), .P23(P[23]), .P22(P[22]), .P21(P[21]), 
        .P20(P[20]), .P19(P[19]), .P18(P[18]), .P17(P[17]), .P16(P[16]), 
        .P15(P[15]), .P14(P[14]), .P13(P[13]), .P12(P[12]), .P11(P[11]), 
        .P10(P[10]), .P9(P[9]), .P8(P[8]), .P7(P[7]), .P6(P[6]), .P5(P[5]), 
        .P4(P[4]), .P3(P[3]), .P2(P[2]), .P1(P[1]), .P0(P[0]));


endmodule
