/**
 * _______________________________________________________________________________
 *
 *  Copyright (c) 2012 TU Dresden, Chair for Embedded Systems
 *  Copyright (c) 2013-2016 TU Darmstadt, Computer Systems Group
 *  (http://www.rs.tu-darmstadt.de) All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions
 *  are met:
 *
 *  1. Redistributions of source code must retain the above copyright
 *     notice, this list of conditions and the following disclaimer.
 *
 *  2. Redistributions in binary form must reproduce the above copyright
 *     notice, this list of conditions and the following disclaimer in the
 *     documentation and/or other materials provided with the distribution.
 *
 *  3. All advertising materials mentioning features or use of this software
 *     must display the following acknowledgement: "This product includes
 *     software developed by the TU Dresden Chair for Embedded Systems, TU Darmstadt Computer Systems Group and
 *     its contributors."
 *
 *  4. Neither the name of the TU Dresden Chair for Embedded Systems, TU Darmstadt Computer Systems Group nor the
 *     names of its contributors may be used to endorse or promote products
 *     derived from this software without specific prior written permission.
 *
 *  THIS SOFTWARE IS PROVIDED BY TU DRESDEN CHAIR FOR EMBEDDED SYSTEMS, TU DARMSTADT COMPUTER SYSTEMS GROUP AND
 *  CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING,
 *  BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
 *  FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 *  REGENTS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 *  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
 *  TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 *  PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 *  LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 *  NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 *  SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * _______________________________________________________________________________
 */

 `default_nettype none

module mult18_prim
(
	A,
	B,
	P
);


input wire	[17:0]	A;
input wire 	[17:0]	B;

output wire	[35:0]	P;


    wire mult18_prim_mult_direct_out_1_35;
    wire mult18_prim_mult_direct_out_1_34;
    wire mult18_prim_mult_direct_out_1_33;
    wire mult18_prim_mult_direct_out_1_32;
    wire mult18_prim_mult_direct_out_1_31;
    wire mult18_prim_mult_direct_out_1_30;
    wire mult18_prim_mult_direct_out_1_29;
    wire mult18_prim_mult_direct_out_1_28;
    wire mult18_prim_mult_direct_out_1_27;
    wire mult18_prim_mult_direct_out_1_26;
    wire mult18_prim_mult_direct_out_1_25;
    wire mult18_prim_mult_direct_out_1_24;
    wire mult18_prim_mult_direct_out_1_23;
    wire mult18_prim_mult_direct_out_1_22;
    wire mult18_prim_mult_direct_out_1_21;
    wire mult18_prim_mult_direct_out_1_20;
    wire mult18_prim_mult_direct_out_1_19;
    wire mult18_prim_mult_direct_out_1_18;
    wire mult18_prim_mult_direct_out_1_17;
    wire mult18_prim_mult_direct_out_1_16;
    wire mult18_prim_mult_direct_out_1_15;
    wire mult18_prim_mult_direct_out_1_14;
    wire mult18_prim_mult_direct_out_1_13;
    wire mult18_prim_mult_direct_out_1_12;
    wire mult18_prim_mult_direct_out_1_11;
    wire mult18_prim_mult_direct_out_1_10;
    wire mult18_prim_mult_direct_out_1_9;
    wire mult18_prim_mult_direct_out_1_8;
    wire mult18_prim_mult_direct_out_1_7;
    wire mult18_prim_mult_direct_out_1_6;
    wire mult18_prim_mult_direct_out_1_5;
    wire mult18_prim_mult_direct_out_1_4;
    wire mult18_prim_mult_direct_out_1_3;
    wire mult18_prim_mult_direct_out_1_2;
    wire mult18_prim_mult_direct_out_1_1;
    wire mult18_prim_mult_direct_out_1_0;
    wire scuba_vhi;
    wire scuba_vlo;

    VHI scuba_vhi_inst (.Z(scuba_vhi));

    VLO scuba_vlo_inst (.Z(scuba_vlo));

    defparam dsp_mult_0.CLK3_DIV = "ENABLED" ;
    defparam dsp_mult_0.CLK2_DIV = "ENABLED" ;
    defparam dsp_mult_0.CLK1_DIV = "ENABLED" ;
    defparam dsp_mult_0.CLK0_DIV = "ENABLED" ;
    defparam dsp_mult_0.HIGHSPEED_CLK = "NONE" ;
    defparam dsp_mult_0.REG_INPUTC_RST = "RST0" ;
    defparam dsp_mult_0.REG_INPUTC_CE = "CE0" ;
    defparam dsp_mult_0.REG_INPUTC_CLK = "NONE" ;
    defparam dsp_mult_0.SOURCEB_MODE = "B_SHIFT" ;
    defparam dsp_mult_0.MULT_BYPASS = "DISABLED" ;
    defparam dsp_mult_0.CAS_MATCH_REG = "FALSE" ;
    defparam dsp_mult_0.RESETMODE = "SYNC" ;
    defparam dsp_mult_0.GSR = "ENABLED" ;
    defparam dsp_mult_0.REG_OUTPUT_RST = "RST0" ;
    defparam dsp_mult_0.REG_OUTPUT_CE = "CE0" ;
    defparam dsp_mult_0.REG_OUTPUT_CLK = "NONE" ;
    defparam dsp_mult_0.REG_PIPELINE_RST = "RST0" ;
    defparam dsp_mult_0.REG_PIPELINE_CE = "CE0" ;
    defparam dsp_mult_0.REG_PIPELINE_CLK = "NONE" ;
    defparam dsp_mult_0.REG_INPUTB_RST = "RST0" ;
    defparam dsp_mult_0.REG_INPUTB_CE = "CE0" ;
    defparam dsp_mult_0.REG_INPUTB_CLK = "NONE" ;
    defparam dsp_mult_0.REG_INPUTA_RST = "RST0" ;
    defparam dsp_mult_0.REG_INPUTA_CE = "CE0" ;
    defparam dsp_mult_0.REG_INPUTA_CLK = "NONE" ;
    MULT18X18D dsp_mult_0 (.A17(A[17]), .A16(A[16]), .A15(A[15]), .A14(A[14]), 
        .A13(A[13]), .A12(A[12]), .A11(A[11]), .A10(A[10]), .A9(A[9]), .A8(A[8]), 
        .A7(A[7]), .A6(A[6]), .A5(A[5]), .A4(A[4]), .A3(A[3]), .A2(A[2]), 
        .A1(A[1]), .A0(A[0]), .B17(B[17]), .B16(B[16]), .B15(B[15]), .B14(B[14]), 
        .B13(B[13]), .B12(B[12]), .B11(B[11]), .B10(B[10]), .B9(B[9]), .B8(B[8]), 
        .B7(B[7]), .B6(B[6]), .B5(B[5]), .B4(B[4]), .B3(B[3]), .B2(B[2]), 
        .B1(B[1]), .B0(B[0]), .C17(scuba_vlo), .C16(scuba_vlo), .C15(scuba_vlo), 
        .C14(scuba_vlo), .C13(scuba_vlo), .C12(scuba_vlo), .C11(scuba_vlo), 
        .C10(scuba_vlo), .C9(scuba_vlo), .C8(scuba_vlo), .C7(scuba_vlo), 
        .C6(scuba_vlo), .C5(scuba_vlo), .C4(scuba_vlo), .C3(scuba_vlo), 
        .C2(scuba_vlo), .C1(scuba_vlo), .C0(scuba_vlo), .SIGNEDA(scuba_vhi), 
        .SIGNEDB(scuba_vhi), .SOURCEA(scuba_vlo), .SOURCEB(scuba_vlo), .CE0(scuba_vhi), 
        .CE1(scuba_vhi), .CE2(scuba_vhi), .CE3(scuba_vhi), .CLK0(scuba_vlo), 
        .CLK1(scuba_vlo), .CLK2(scuba_vlo), .CLK3(scuba_vlo), .RST0(scuba_vlo), 
        .RST1(scuba_vlo), .RST2(scuba_vlo), .RST3(scuba_vlo), .SRIA17(scuba_vlo), 
        .SRIA16(scuba_vlo), .SRIA15(scuba_vlo), .SRIA14(scuba_vlo), .SRIA13(scuba_vlo), 
        .SRIA12(scuba_vlo), .SRIA11(scuba_vlo), .SRIA10(scuba_vlo), .SRIA9(scuba_vlo), 
        .SRIA8(scuba_vlo), .SRIA7(scuba_vlo), .SRIA6(scuba_vlo), .SRIA5(scuba_vlo), 
        .SRIA4(scuba_vlo), .SRIA3(scuba_vlo), .SRIA2(scuba_vlo), .SRIA1(scuba_vlo), 
        .SRIA0(scuba_vlo), .SRIB17(scuba_vlo), .SRIB16(scuba_vlo), .SRIB15(scuba_vlo), 
        .SRIB14(scuba_vlo), .SRIB13(scuba_vlo), .SRIB12(scuba_vlo), .SRIB11(scuba_vlo), 
        .SRIB10(scuba_vlo), .SRIB9(scuba_vlo), .SRIB8(scuba_vlo), .SRIB7(scuba_vlo), 
        .SRIB6(scuba_vlo), .SRIB5(scuba_vlo), .SRIB4(scuba_vlo), .SRIB3(scuba_vlo), 
        .SRIB2(scuba_vlo), .SRIB1(scuba_vlo), .SRIB0(scuba_vlo), .SROA17(), 
        .SROA16(), .SROA15(), .SROA14(), .SROA13(), .SROA12(), .SROA11(), 
        .SROA10(), .SROA9(), .SROA8(), .SROA7(), .SROA6(), .SROA5(), .SROA4(), 
        .SROA3(), .SROA2(), .SROA1(), .SROA0(), .SROB17(), .SROB16(), .SROB15(), 
        .SROB14(), .SROB13(), .SROB12(), .SROB11(), .SROB10(), .SROB9(), 
        .SROB8(), .SROB7(), .SROB6(), .SROB5(), .SROB4(), .SROB3(), .SROB2(), 
        .SROB1(), .SROB0(), .ROA17(), .ROA16(), .ROA15(), .ROA14(), .ROA13(), 
        .ROA12(), .ROA11(), .ROA10(), .ROA9(), .ROA8(), .ROA7(), .ROA6(), 
        .ROA5(), .ROA4(), .ROA3(), .ROA2(), .ROA1(), .ROA0(), .ROB17(), 
        .ROB16(), .ROB15(), .ROB14(), .ROB13(), .ROB12(), .ROB11(), .ROB10(), 
        .ROB9(), .ROB8(), .ROB7(), .ROB6(), .ROB5(), .ROB4(), .ROB3(), .ROB2(), 
        .ROB1(), .ROB0(), .ROC17(), .ROC16(), .ROC15(), .ROC14(), .ROC13(), 
        .ROC12(), .ROC11(), .ROC10(), .ROC9(), .ROC8(), .ROC7(), .ROC6(), 
        .ROC5(), .ROC4(), .ROC3(), .ROC2(), .ROC1(), .ROC0(), .P35(mult18_prim_mult_direct_out_1_35), 
        .P34(mult18_prim_mult_direct_out_1_34), .P33(mult18_prim_mult_direct_out_1_33), 
        .P32(mult18_prim_mult_direct_out_1_32), .P31(mult18_prim_mult_direct_out_1_31), 
        .P30(mult18_prim_mult_direct_out_1_30), .P29(mult18_prim_mult_direct_out_1_29), 
        .P28(mult18_prim_mult_direct_out_1_28), .P27(mult18_prim_mult_direct_out_1_27), 
        .P26(mult18_prim_mult_direct_out_1_26), .P25(mult18_prim_mult_direct_out_1_25), 
        .P24(mult18_prim_mult_direct_out_1_24), .P23(mult18_prim_mult_direct_out_1_23), 
        .P22(mult18_prim_mult_direct_out_1_22), .P21(mult18_prim_mult_direct_out_1_21), 
        .P20(mult18_prim_mult_direct_out_1_20), .P19(mult18_prim_mult_direct_out_1_19), 
        .P18(mult18_prim_mult_direct_out_1_18), .P17(mult18_prim_mult_direct_out_1_17), 
        .P16(mult18_prim_mult_direct_out_1_16), .P15(mult18_prim_mult_direct_out_1_15), 
        .P14(mult18_prim_mult_direct_out_1_14), .P13(mult18_prim_mult_direct_out_1_13), 
        .P12(mult18_prim_mult_direct_out_1_12), .P11(mult18_prim_mult_direct_out_1_11), 
        .P10(mult18_prim_mult_direct_out_1_10), .P9(mult18_prim_mult_direct_out_1_9), 
        .P8(mult18_prim_mult_direct_out_1_8), .P7(mult18_prim_mult_direct_out_1_7), 
        .P6(mult18_prim_mult_direct_out_1_6), .P5(mult18_prim_mult_direct_out_1_5), 
        .P4(mult18_prim_mult_direct_out_1_4), .P3(mult18_prim_mult_direct_out_1_3), 
        .P2(mult18_prim_mult_direct_out_1_2), .P1(mult18_prim_mult_direct_out_1_1), 
        .P0(mult18_prim_mult_direct_out_1_0), .SIGNEDP());

    assign P[35] = mult18_prim_mult_direct_out_1_35;
    assign P[34] = mult18_prim_mult_direct_out_1_34;
    assign P[33] = mult18_prim_mult_direct_out_1_33;
    assign P[32] = mult18_prim_mult_direct_out_1_32;
    assign P[31] = mult18_prim_mult_direct_out_1_31;
    assign P[30] = mult18_prim_mult_direct_out_1_30;
    assign P[29] = mult18_prim_mult_direct_out_1_29;
    assign P[28] = mult18_prim_mult_direct_out_1_28;
    assign P[27] = mult18_prim_mult_direct_out_1_27;
    assign P[26] = mult18_prim_mult_direct_out_1_26;
    assign P[25] = mult18_prim_mult_direct_out_1_25;
    assign P[24] = mult18_prim_mult_direct_out_1_24;
    assign P[23] = mult18_prim_mult_direct_out_1_23;
    assign P[22] = mult18_prim_mult_direct_out_1_22;
    assign P[21] = mult18_prim_mult_direct_out_1_21;
    assign P[20] = mult18_prim_mult_direct_out_1_20;
    assign P[19] = mult18_prim_mult_direct_out_1_19;
    assign P[18] = mult18_prim_mult_direct_out_1_18;
    assign P[17] = mult18_prim_mult_direct_out_1_17;
    assign P[16] = mult18_prim_mult_direct_out_1_16;
    assign P[15] = mult18_prim_mult_direct_out_1_15;
    assign P[14] = mult18_prim_mult_direct_out_1_14;
    assign P[13] = mult18_prim_mult_direct_out_1_13;
    assign P[12] = mult18_prim_mult_direct_out_1_12;
    assign P[11] = mult18_prim_mult_direct_out_1_11;
    assign P[10] = mult18_prim_mult_direct_out_1_10;
    assign P[9] = mult18_prim_mult_direct_out_1_9;
    assign P[8] = mult18_prim_mult_direct_out_1_8;
    assign P[7] = mult18_prim_mult_direct_out_1_7;
    assign P[6] = mult18_prim_mult_direct_out_1_6;
    assign P[5] = mult18_prim_mult_direct_out_1_5;
    assign P[4] = mult18_prim_mult_direct_out_1_4;
    assign P[3] = mult18_prim_mult_direct_out_1_3;
    assign P[2] = mult18_prim_mult_direct_out_1_2;
    assign P[1] = mult18_prim_mult_direct_out_1_1;
    assign P[0] = mult18_prim_mult_direct_out_1_0;


endmodule
