#ifndef DEBUGGER_H_
#define DEBUGGER_H_

#ifdef __cplusplus
extern "C" {
#endif

#define BREAKPOINT __asm__("trap tsr_breakpoint_idx")

#include <stdint.h>
#include <stdio.h>

/**
* enable hardware and sync up with debugger
* set debug interface to compiler set variable DEBUGGER_UART_BASE or stdio_descr->base_addr_in
**/
void debugging_initialize();
//__attribute__((constructor (1000)))

/**
* after init, get the actual count of hardware breakpoints
**/
uint9_t get_brk_count();

/**
* after init, get the actual count of hardware watchpoints
**/
uint9_t get_wtch_count();

/**
* single step support in hardware
**/
uint9_t get_single_step_support();

/**
 * FILE to use for debugger IO
 */
extern FILE * debugIO;

#ifdef __cplusplus
}
#endif

#endif /* DEBUGGER_H_ */
