/*
_______________________________________________________________________________

 Copyright (c) 2012 TU Dresden, Chair for Embedded Systems
 (http://www.mr.inf.tu-dresden.de) All rights reserved.

 Redistribution and use in source and binary forms, with or without
 modification, are permitted provided that the following conditions
 are met:

 1. Redistributions of source code must retain the above copyright
    notice, this list of conditions and the following disclaimer.

 2. Redistributions in binary form must reproduce the above copyright
    notice, this list of conditions and the following disclaimer in the
    documentation and/or other materials provided with the distribution.

 3. All advertising materials mentioning features or use of this software
    must display the following acknowledgement: "This product includes
    software developed by the TU Dresden Chair for Embedded Systems and
    its contributors."

 4. Neither the name of the TU Dresden Chair for Embedded Systems nor the
    names of its contributors may be used to endorse or promote products
    derived from this software without specific prior written permission.

 THIS SOFTWARE IS PROVIDED BY TU DRESDEN CHAIR FOR EMBEDDED SYSTEMS AND
 CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING,
 BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
 FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 REGENTS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
 TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
_______________________________________________________________________________
*/

#ifndef __FIFO_H
#define __FIFO_H

#ifdef __cplusplus
extern "C" {
#endif

#include <peripherals/fifo_in.h>
#include <peripherals/fifo_out.h>


#define declare_FIFO_IN_FILE(fifo_in) { \
	.base_addr = (void*) fifo_in, \
	.send_byte = (fun_stdio_send_byte) 0, \
	.receive_byte = (fun_stdio_receive_byte) fifo_in_read, \
	.receive_byte_nb = (fun_stdio_receive_byte_nb) fifo_in_read_nb \
}

#define declare_FIFO_OUT_FILE(fifo_out) { \
	.base_addr = (void*) fifo_out, \
	.send_byte = (fun_stdio_send_byte) fifo_out_write, \
	.receive_byte = (fun_stdio_receive_byte) 0, \
	.receive_byte_nb = (fun_stdio_receive_byte_nb) 0 \
}



void __attribute__((error("stdio_fifo_open is no longer supported. Declare a global variable FILE * stdout = &FIFO_*_FILE instead"))) stdio_fifo_open(fifo_out_regs_t *fifo_out, fifo_in_regs_t *fifo_in);

unsigned int fifo_in_read(fifo_in_regs_t *fifo);
int fifo_in_read_nb(fifo_in_regs_t *fifo, uint18_t *value);
void fifo_out_write(fifo_out_regs_t *fifo, const unsigned int value);

#ifdef __cplusplus
}
#endif

#endif
