#ifndef _GLOBAL_VARIABLES_
#define _GLOBAL_VARIABLES_

#ifdef __cplusplus
extern "C" {
#endif

#define SECTIONNAME ".globaldata"

#define DEFINE_GLOBAL(type, name, value) type name __attribute__((section ( SECTIONNAME ))) = value;
#define DECLARE_GLOBAL(type, name) type name __attribute__((section ( SECTIONNAME ))) = { 0 };

#define WRAP_INIT_VALUES(...) {__VA_ARGS__}

#define BEGIN_INITIALISATION(hardware_barrier) __attribute__((constructor (300))) void _initialise_global_variables() { hardware_barrier_t* bar = &hardware_barrier;

#define INIT_MUTEX(name)			initialise_mutex_open(&name);
#define INIT_MUTEX_LOCKED(name)		initialise_mutex_locked(&name);
#define INIT_MUTEX_OPEN(name)  		initialise_mutex_open(&name);
#define INIT_SEMAPHORE(name, value) initialise_semaphore(&name, value);
#define INIT_SIMPLE(name, value) name = value;

#define END_INITIALISATION signalForAll(bar); }


#ifdef __cplusplus
}
#endif

#endif
