/*
_______________________________________________________________________________

 Copyright (c) 2012 TU Dresden, Chair for Embedded Systems
 (http://www.mr.inf.tu-dresden.de) All rights reserved.

 Redistribution and use in source and binary forms, with or without
 modification, are permitted provided that the following conditions
 are met:

 1. Redistributions of source code must retain the above copyright
    notice, this list of conditions and the following disclaimer.

 2. Redistributions in binary form must reproduce the above copyright
    notice, this list of conditions and the following disclaimer in the
    documentation and/or other materials provided with the distribution.

 3. All advertising materials mentioning features or use of this software
    must display the following acknowledgement: "This product includes
    software developed by the TU Dresden Chair for Embedded Systems and
    its contributors."

 4. Neither the name of the TU Dresden Chair for Embedded Systems nor the
    names of its contributors may be used to endorse or promote products
    derived from this software without specific prior written permission.

 THIS SOFTWARE IS PROVIDED BY TU DRESDEN CHAIR FOR EMBEDDED SYSTEMS AND
 CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING,
 BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
 FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 REGENTS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
 TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
_______________________________________________________________________________
*/
#ifndef I2C_MASTER___
#define I2C_MASTER___

#ifdef __cplusplus
extern "C" {
#endif

#include <peripherals/i2c_master.h>
// user funktion
int i2c_master_write(i2c_master_regs_t *i2c_m, unsigned int slave_addr, unsigned int anz, unsigned int * dataw);

int i2c_master_reada(i2c_master_regs_t *i2c_m, unsigned int slave_addr, unsigned int anz, unsigned int * datar);
int i2c_master_readn(i2c_master_regs_t *i2c_m, unsigned int slave_addr, unsigned int anz, unsigned int * datar);

int i2c_master_wr_rda(i2c_master_regs_t *i2c_m, unsigned int slave_addr, unsigned int anzw, unsigned int * dataw, unsigned int anzr, unsigned int * datar);
int i2c_master_wr_rdn(i2c_master_regs_t *i2c_m, unsigned int slave_addr, unsigned int anzw, unsigned int * dataw, unsigned int anzr, unsigned int * datar);
// intern only
int i2c_master_wr_st(i2c_master_regs_t *i2c_m, unsigned int slave_addr, unsigned int anz, unsigned int * dataw, unsigned int stop);

#ifdef __cplusplus
}
#endif

#endif  //define __I2C_MASTER
