/*
_______________________________________________________________________________

 Copyright (c) 2012 TU Dresden, Chair for Embedded Systems
 (http://www.mr.inf.tu-dresden.de) All rights reserved.

 Redistribution and use in source and binary forms, with or without
 modification, are permitted provided that the following conditions
 are met:

 1. Redistributions of source code must retain the above copyright
    notice, this list of conditions and the following disclaimer.

 2. Redistributions in binary form must reproduce the above copyright
    notice, this list of conditions and the following disclaimer in the
    documentation and/or other materials provided with the distribution.

 3. All advertising materials mentioning features or use of this software
    must display the following acknowledgement: "This product includes
    software developed by the TU Dresden Chair for Embedded Systems and
    its contributors."

 4. Neither the name of the TU Dresden Chair for Embedded Systems nor the
    names of its contributors may be used to endorse or promote products
    derived from this software without specific prior written permission.

 THIS SOFTWARE IS PROVIDED BY TU DRESDEN CHAIR FOR EMBEDDED SYSTEMS AND
 CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING,
 BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
 FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 REGENTS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
 TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
_______________________________________________________________________________
*/

#ifndef __MONITOR_H
#define __MONITOR_H

#ifdef __cplusplus
extern "C" {
#endif
/*****************************************************************************
  Function    : monitor_print
  Description : prints a string to the monitor shell
  Parameter   : char *string: string to print
  Return      : void
  Misc        : Trap 1
 *****************************************************************************/
void monitor_print(char *string);

/*****************************************************************************
  Function    : monitor_putchar
  Description : 
  Parameter   : 
  Return      : void
  Misc        : Trap 2
 *****************************************************************************/
void monitor_putchar(unsigned char c);

/*****************************************************************************
  Function    :  
  Description : 
  Parameter   : 
  Return      : char
  Misc        : Trap 3
 *****************************************************************************/
unsigned char monitor_getchar(void);

/*****************************************************************************
  Function    : 
  Description : 
  Parameter   : 
  Return      : char
  Misc        : Trap 17
 *****************************************************************************/
unsigned char monitor_getstat(void);

/*****************************************************************************
  Function    : monitor_putbyte
  Description : prints 8 Bit signed hex
  Parameter   : 
  Return      : void
  Misc        : Trap 5
 *****************************************************************************/
void monitor_putbyte(unsigned char b);

/*****************************************************************************
  Function    :  
  Description : 
  Parameter   : 
  Return      : 
  Misc        : Trap 7
 *****************************************************************************/
unsigned char monitor_getbyte(void);

/*****************************************************************************
  Function    :  
  Description : 
  Parameter   : 
  Return      : 
  Misc        : Trap 4
 *****************************************************************************/
void monitor_putint(int i);

/*****************************************************************************
  Function    :  
  Description : 
  Parameter   : 
  Return      : 
  Misc        : Trap 6
 *****************************************************************************/
int monitor_getint(void);

/*****************************************************************************
  Function    :  
  Description : 
  Parameter   : 
  Return      : 
  Misc        : Trap 12
 *****************************************************************************/
void monitor_newline(void);

/*****************************************************************************
  Function    :  
  Description : 
  Parameter   : 
  Return      : 
  Misc        : Trap 13
 *****************************************************************************/
void monitor_space(void);

/*****************************************************************************
  Function    :  
  Description : 
  Parameter   : 
  Return      : 
  Misc        : Trap 16 + 12
 *****************************************************************************/
void monitor_putregs(void);

/*****************************************************************************
  Function    :  
  Description : 
  Parameter   : int a1 = Next PC int a2 = CC-Bit
  Return      : 
  Misc        : Trap 16 + 12
 *****************************************************************************/
void monitor_intregs(int a1, int a2);

/*****************************************************************************
  Function    :  
  Description : 
  Parameter   : 
  Return      : 
  Misc        : R1 Bit 1 = 1
 *****************************************************************************/
void monitor_echoon(void);

/*****************************************************************************
  Function    :  
  Description : 
  Parameter   : 
  Return      : 
  Misc        : R1 Bit 1 = 0
 *****************************************************************************/
void monitor_echooff(void);

extern	void	monitor_print(char *s);
extern	void	monitor_putint(int i);
extern	void	monitor_putbyte(unsigned char c);
extern	void	monitor_putchar(unsigned char c);
/*
void	(*myprint) (char *)		= &monitor_print;
void	(*myputint) (int)		= &monitor_putint;
void	(*myputbyte) (unsigned char)	= &monitor_putbyte;
void	(*myputchar) (unsigned char)	= &monitor_putchar;
*/
#ifdef __cplusplus
}
#endif

#endif
