#ifndef __AXI_HW_H
#define __AXI_HW_H

#ifdef __cplusplus
extern "C" {
#endif

//Control-register masks
#define AXI_CTRL_BLEN		0x00FF
#define AXI_CTRL_TYPE		0x0300
#define AXI_CTRL_VALID		0x0400
#define AXI_CTRL_RESP		0x1800
#define AXI_CTRL_DONE		0x2000

//Burst-types
#define AXI_CTRL_TYPE_FIXED	0x0000
#define AXI_CTRL_TYPE_INCR	0x0100
#define AXI_CTRL_TYPE_WRAP	0x0200

typedef struct axi {
	//0x00
	volatile unsigned int	w_ctrl_0;
	//0x01
	volatile unsigned int	w_ctrl_1;
	//0x02
	volatile unsigned int r_ctrl_0;
	//0x03
	volatile unsigned int	r_ctrl_1;

	//0x04
	volatile unsigned int		w_addr_0_0;
	//0x05
	volatile unsigned int		w_addr_0_1;
	//0x06
	volatile unsigned int 		r_addr_0_0;
	//0x07
	volatile unsigned int 		r_addr_0_1;

	//0x08
	volatile unsigned int		w_addr_1_0;
	//0x09
	volatile unsigned int		w_addr_1_1;
	//0x0A
	volatile unsigned int 		r_addr_1_0;
	//0x0B
	volatile unsigned int 		r_addr_1_1;

	//0x0C
	volatile unsigned int					w_buffer_0[254];
	//0x10a
	volatile unsigned int					w_buffer_1[252];
	//0x206
	volatile unsigned int	r_buffer_0[254];
	//0x304
	volatile unsigned int	r_buffer_1[252];
} axi_dma_t;

#ifdef __cplusplus
}
#endif

#endif
