/*
_______________________________________________________________________________

 Copyright (c) 2012 TU Dresden, Chair for Embedded Systems
 (http://www.mr.inf.tu-dresden.de) All rights reserved.

 Redistribution and use in source and binary forms, with or without
 modification, are permitted provided that the following conditions
 are met:

 1. Redistributions of source code must retain the above copyright
    notice, this list of conditions and the following disclaimer.

 2. Redistributions in binary form must reproduce the above copyright
    notice, this list of conditions and the following disclaimer in the
    documentation and/or other materials provided with the distribution.

 3. All advertising materials mentioning features or use of this software
    must display the following acknowledgement: "This product includes
    software developed by the TU Dresden Chair for Embedded Systems and
    its contributors."

 4. Neither the name of the TU Dresden Chair for Embedded Systems nor the
    names of its contributors may be used to endorse or promote products
    derived from this software without specific prior written permission.

 THIS SOFTWARE IS PROVIDED BY TU DRESDEN CHAIR FOR EMBEDDED SYSTEMS AND
 CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING,
 BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
 FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 REGENTS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
 TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
_______________________________________________________________________________
*/
#ifndef __CAN_HW_H
#define __CAN_HW_H

#ifdef __cplusplus
extern "C" {
#endif

// Konstanten und Masken fuer:
//  1. work Register
#define	CAN_MODE_NORMAL		0x00000
#define	CAN_MODE_CONFIG		0x00300
#define	CAN_MODE_LISTEN_ONLY	0x00200
#define	CAN_MODE_SELF_TEST	0x00100
#define	CAN_ABORT_TX		0x00080
#define	CAN_EN_EXCEPTION_IR	0x00040
#define	CAN_TX_SUCCESSFUL_IR	0x00020
#define	CAN_RX_SUCCESSFUL_IR	0x00010
#define	CAN_OVERLOAD_REQUEST	0x00008
#define	CAB_TRANSMITTING	0x00004
#define	CAN_RECEIVING		0x00002
#define	CAN_BUS_FREE		0x00001
//  2. choose_config Register
#define	CAN_EXTENDED_MODE	0x00001
//  3. bustiming Register
#define	CAN_BAUDRATE_PRESC_000	0x00000
#define	CAN_BAUDRATE_PRESC_001	0x00800
#define	CAN_BAUDRATE_PRESC_002	0x01000
#define	CAN_BAUDRATE_PRESC_003	0x01800
#define	CAN_BAUDRATE_PRESC_004	0x02000
#define	CAN_BAUDRATE_PRESC_005	0x02800
#define	CAN_BAUDRATE_PRESC_006	0x03000
#define	CAN_BAUDRATE_PRESC_007	0x03800
#define	CAN_BAUDRATE_PRESC_008	0x04000
#define	CAN_BAUDRATE_PRESC_009	0x04800
#define	CAN_BAUDRATE_PRESC_010	0x05000
#define	CAN_BAUDRATE_PRESC_011	0x05800
#define	CAN_BAUDRATE_PRESC_012	0x06000
#define	CAN_BAUDRATE_PRESC_013	0x06800
#define	CAN_BAUDRATE_PRESC_014	0x07000
#define	CAN_BAUDRATE_PRESC_015	0x07800
#define	CAN_BAUDRATE_PRESC_016	0x08000
#define	CAN_BAUDRATE_PRESC_017	0x08800
#define	CAN_BAUDRATE_PRESC_018	0x09000
#define	CAN_BAUDRATE_PRESC_019	0x09100
#define	CAN_BAUDRATE_PRESC_020	0x0A000
#define	CAN_BAUDRATE_PRESC_021	0x0A800
#define	CAN_BAUDRATE_PRESC_022	0x0B000
#define	CAN_BAUDRATE_PRESC_023	0x0B800
#define	CAN_BAUDRATE_PRESC_024	0x0C000
#define	CAN_BAUDRATE_PRESC_025	0x0C800
#define	CAN_BAUDRATE_PRESC_026	0x0D000
#define	CAN_BAUDRATE_PRESC_027	0x0D800
#define	CAN_BAUDRATE_PRESC_028	0x0E000
#define	CAN_BAUDRATE_PRESC_029	0x0E800
#define	CAN_BAUDRATE_PRESC_030	0x0F000
#define	CAN_BAUDRATE_PRESC_031	0x0F800
#define	CAN_BAUDRATE_PRESC_032	0x10000
#define	CAN_BAUDRATE_PRESC_033	0x10800
#define	CAN_BAUDRATE_PRESC_034	0x11000
#define	CAN_BAUDRATE_PRESC_035	0x11800
#define	CAN_BAUDRATE_PRESC_036	0x12000
#define	CAN_BAUDRATE_PRESC_037	0x12800
#define	CAN_BAUDRATE_PRESC_038	0x13000
#define	CAN_BAUDRATE_PRESC_039	0x13800
#define	CAN_BAUDRATE_PRESC_040	0x14000
#define	CAN_BAUDRATE_PRESC_041	0x14800
#define	CAN_BAUDRATE_PRESC_042	0x15000
#define	CAN_BAUDRATE_PRESC_043	0x15800
#define	CAN_BAUDRATE_PRESC_044	0x16000
#define	CAN_BAUDRATE_PRESC_045	0x16800
#define	CAN_BAUDRATE_PRESC_046	0x17000
#define	CAN_BAUDRATE_PRESC_047	0x17800
#define	CAN_BAUDRATE_PRESC_048	0x18000
#define	CAN_BAUDRATE_PRESC_049	0x18800
#define	CAN_BAUDRATE_PRESC_050	0x19000
#define	CAN_BAUDRATE_PRESC_051	0x19800
#define	CAN_BAUDRATE_PRESC_052	0x1A000
#define	CAN_BAUDRATE_PRESC_053	0x1A800
#define	CAN_BAUDRATE_PRESC_054	0x1B000
#define	CAN_BAUDRATE_PRESC_055	0x1B800
#define	CAN_BAUDRATE_PRESC_056	0x1C000
#define	CAN_BAUDRATE_PRESC_057	0x1C800
#define	CAN_BAUDRATE_PRESC_058	0x1D000
#define	CAN_BAUDRATE_PRESC_059	0x1D800
#define	CAN_BAUDRATE_PRESC_060	0x1E000
#define	CAN_BAUDRATE_PRESC_061	0x1E800
#define	CAN_BAUDRATE_PRESC_062	0x1F000
#define	CAN_BAUDRATE_PRESC_063	0x1F800
#define	CAN_BAUDRATE_PRESC_064	0x20000
#define	CAN_BAUDRATE_PRESC_065	0x20800
#define	CAN_BAUDRATE_PRESC_066	0x21000
#define	CAN_BAUDRATE_PRESC_067	0x21800
#define	CAN_BAUDRATE_PRESC_068	0x22000
#define	CAN_BAUDRATE_PRESC_069	0x22800
#define	CAN_BAUDRATE_PRESC_070	0x23000
#define	CAN_BAUDRATE_PRESC_071	0x23800
#define	CAN_BAUDRATE_PRESC_072	0x24000
#define	CAN_BAUDRATE_PRESC_073	0x24800
#define	CAN_BAUDRATE_PRESC_074	0x25000
#define	CAN_BAUDRATE_PRESC_075	0x25800
#define	CAN_BAUDRATE_PRESC_076	0x26000
#define	CAN_BAUDRATE_PRESC_077	0x26800
#define	CAN_BAUDRATE_PRESC_078	0x27000
#define	CAN_BAUDRATE_PRESC_079	0x27800
#define	CAN_BAUDRATE_PRESC_080	0x28000
#define	CAN_BAUDRATE_PRESC_081	0x28800
#define	CAN_BAUDRATE_PRESC_082	0x29000
#define	CAN_BAUDRATE_PRESC_083	0x29100
#define	CAN_BAUDRATE_PRESC_084	0x2A000
#define	CAN_BAUDRATE_PRESC_085	0x2A800
#define	CAN_BAUDRATE_PRESC_086	0x2B000
#define	CAN_BAUDRATE_PRESC_087	0x2B800
#define	CAN_BAUDRATE_PRESC_088	0x2C000
#define	CAN_BAUDRATE_PRESC_089	0x2C800
#define	CAN_BAUDRATE_PRESC_090	0x2D000
#define	CAN_BAUDRATE_PRESC_091	0x2D800
#define	CAN_BAUDRATE_PRESC_092	0x2E000
#define	CAN_BAUDRATE_PRESC_093	0x2E800
#define	CAN_BAUDRATE_PRESC_094	0x2F000
#define	CAN_BAUDRATE_PRESC_095	0x2F800
#define	CAN_BAUDRATE_PRESC_096	0x30000
#define	CAN_BAUDRATE_PRESC_097	0x30800
#define	CAN_BAUDRATE_PRESC_098	0x31000
#define	CAN_BAUDRATE_PRESC_099	0x31800
#define	CAN_BAUDRATE_PRESC_100	0x32000
#define	CAN_BAUDRATE_PRESC_101	0x32800
#define	CAN_BAUDRATE_PRESC_102	0x33000
#define	CAN_BAUDRATE_PRESC_103	0x33800
#define	CAN_BAUDRATE_PRESC_104	0x34000
#define	CAN_BAUDRATE_PRESC_105	0x34800
#define	CAN_BAUDRATE_PRESC_106	0x35000
#define	CAN_BAUDRATE_PRESC_107	0x35800
#define	CAN_BAUDRATE_PRESC_108	0x36000
#define	CAN_BAUDRATE_PRESC_109	0x36800
#define	CAN_BAUDRATE_PRESC_110	0x37000
#define	CAN_BAUDRATE_PRESC_111	0x37800
#define	CAN_BAUDRATE_PRESC_112	0x38000
#define	CAN_BAUDRATE_PRESC_113	0x38800
#define	CAN_BAUDRATE_PRESC_114	0x39000
#define	CAN_BAUDRATE_PRESC_115	0x39800
#define	CAN_BAUDRATE_PRESC_116	0x3A000
#define	CAN_BAUDRATE_PRESC_117	0x3A800
#define	CAN_BAUDRATE_PRESC_118	0x3B000
#define	CAN_BAUDRATE_PRESC_119	0x3B800
#define	CAN_BAUDRATE_PRESC_120	0x3C000
#define	CAN_BAUDRATE_PRESC_121	0x3C800
#define	CAN_BAUDRATE_PRESC_122	0x3D000
#define	CAN_BAUDRATE_PRESC_123	0x3D800
#define	CAN_BAUDRATE_PRESC_124	0x3E000
#define	CAN_BAUDRATE_PRESC_125	0x3E800
//#define	CAN_BAUDRATE_PRESC_126	0x3F000	// nicht zulaessig, da noch 2 addiert wird
//#define	CAN_BAUDRATE_PRESC_127	0x3F800	// nicht zulaessig, da noch 2 addiert wird
#define	CAN_SYNC_JUMP_WIDTH_0	0x00000
#define	CAN_SYNC_JUMP_WIDTH_1	0x00200
#define	CAN_SYNC_JUMP_WIDTH_2	0x00400
#define	CAN_SYNC_JUMP_WIDTH_3	0x00600
#define	CAN_TIME_SEGMENT1_00	0x00000
#define	CAN_TIME_SEGMENT1_01	0x00010
#define	CAN_TIME_SEGMENT1_02	0x00020
#define	CAN_TIME_SEGMENT1_03	0x00030
#define	CAN_TIME_SEGMENT1_04	0x00040
#define	CAN_TIME_SEGMENT1_05	0x00050
#define	CAN_TIME_SEGMENT1_06	0x00060
#define	CAN_TIME_SEGMENT1_07	0x00070
#define	CAN_TIME_SEGMENT1_08	0x00080
#define	CAN_TIME_SEGMENT1_09	0x00090
#define	CAN_TIME_SEGMENT1_10	0x000A0
#define	CAN_TIME_SEGMENT1_11	0x000B0
#define	CAN_TIME_SEGMENT1_12	0x000C0
#define	CAN_TIME_SEGMENT1_13	0x000D0
#define	CAN_TIME_SEGMENT1_14	0x000E0
#define	CAN_TIME_SEGMENT1_15	0x000F0
#define	CAN_TIME_SEGMENT1_16	0x00100
#define	CAN_TIME_SEGMENT1_17	0x00110
#define	CAN_TIME_SEGMENT1_18	0x00120
#define	CAN_TIME_SEGMENT1_19	0x00130
#define	CAN_TIME_SEGMENT1_20	0x00140
#define	CAN_TIME_SEGMENT1_21	0x00150
#define	CAN_TIME_SEGMENT1_22	0x00160
#define	CAN_TIME_SEGMENT1_23	0x00170
#define	CAN_TIME_SEGMENT1_24	0x00180
#define	CAN_TIME_SEGMENT1_25	0x00190
#define	CAN_TIME_SEGMENT1_26	0x001A0
#define	CAN_TIME_SEGMENT1_27	0x001B0
#define	CAN_TIME_SEGMENT1_28	0x001C0
#define	CAN_TIME_SEGMENT1_29	0x001D0
#define	CAN_TIME_SEGMENT1_30	0x001E0
#define	CAN_TIME_SEGMENT1_31	0x001F0
#define	CAN_TIME_SEGMENT2_0	0x00000
#define	CAN_TIME_SEGMENT2_1	0x00002
#define	CAN_TIME_SEGMENT2_2	0x00004
#define	CAN_TIME_SEGMENT2_3	0x00006
#define	CAN_TIME_SEGMENT2_4	0x00008
#define	CAN_TIME_SEGMENT2_5	0x0000A
#define	CAN_TIME_SEGMENT2_6	0x0000C
#define	CAN_TIME_SEGMENT2_7	0x0000E
#define	CAN_SAMPLE_MODE		0X00001
//  4. error_cnt Register
#define	CAN_RX_ERROR_MASK	0x3fe00
#define	CAN_TX_ERROR_MASK	0x001FF
// 10. error_code Register
#define	CAN_ERROR_WARNING	0x20000
#define	CAN_ERROR_DIRECTION	0x10000
#define	CAN_ERROR_CAPTURE_MASK	0x07000
#define	CAN_ERROR_FSM_MASK	0x001F0
#define	CAN_NODE_ERROR_PASSIVE	0x00008
#define	CAN_NODE_BUS_OFF	0x00004
#define	CAN_RX_BUFFER_FULL_Q	0x00002
#define	CAN_SEND_FAILED_Q	0x00001

// 11. BAUDRATE

// f = can_clk / (BRP+2)*(1+tseg1+tseg2) = 14000 kHz / (0+2)*(1+5+1) = 14000 kHz / 2*7 = 1000 kHz
// tseg2 > (100 - 87,5)*(1+tseg1+tseg2)/100
// tseg2 < (100 - 75,0)*(1+tseg1+tseg2)/100

#define	CAN_BAUDRATE_1000k	CAN_BAUDRATE_PRESC_000|CAN_SYNC_JUMP_WIDTH_1|CAN_TIME_SEGMENT1_05|CAN_TIME_SEGMENT2_1
#define	CAN_BAUDRATE_500k	CAN_BAUDRATE_PRESC_000|CAN_SYNC_JUMP_WIDTH_1|CAN_TIME_SEGMENT1_11|CAN_TIME_SEGMENT2_2
#define	CAN_BAUDRATE_250k	CAN_BAUDRATE_PRESC_002|CAN_SYNC_JUMP_WIDTH_1|CAN_TIME_SEGMENT1_11|CAN_TIME_SEGMENT2_2
#define	CAN_BAUDRATE_125k	CAN_BAUDRATE_PRESC_006|CAN_SYNC_JUMP_WIDTH_1|CAN_TIME_SEGMENT1_11|CAN_TIME_SEGMENT2_2
#define	CAN_BAUDRATE_100k	CAN_BAUDRATE_PRESC_005|CAN_SYNC_JUMP_WIDTH_2|CAN_TIME_SEGMENT1_15|CAN_TIME_SEGMENT2_4
#define	CAN_BAUDRATE_50k	CAN_BAUDRATE_PRESC_012|CAN_SYNC_JUMP_WIDTH_2|CAN_TIME_SEGMENT1_15|CAN_TIME_SEGMENT2_4
#define	CAN_BAUDRATE_20k	CAN_BAUDRATE_PRESC_018|CAN_SYNC_JUMP_WIDTH_3|CAN_TIME_SEGMENT1_29|CAN_TIME_SEGMENT2_5
#define	CAN_BAUDRATE_10k	CAN_BAUDRATE_PRESC_038|CAN_SYNC_JUMP_WIDTH_3|CAN_TIME_SEGMENT1_29|CAN_TIME_SEGMENT2_5
#define	CAN_BAUDRATE_5k		CAN_BAUDRATE_PRESC_078|CAN_SYNC_JUMP_WIDTH_3|CAN_TIME_SEGMENT1_29|CAN_TIME_SEGMENT2_5


// I/O-Register Strucktur des CAN-Interface
typedef struct can {
	volatile unsigned int	work;
	volatile unsigned int	choose_config;
	volatile unsigned int	bustiming;
	volatile unsigned int	error_cnt;
	volatile unsigned int	warn_state;
	volatile unsigned int	acf_select;
	volatile unsigned int	acf_ac1;
	volatile unsigned int	acf_am1;
	volatile unsigned int	acf_ac2;
	volatile unsigned int	acf_am2;
	volatile unsigned int	error_code;
	volatile unsigned int	tx_succ;
	volatile unsigned int	rx_succ;
	volatile unsigned int	tx_buffer;
	volatile unsigned int	rx_buffer;
} can_regs_t;

// Datenpuffer Strucktur des CAN-Interface im DMA Puffer
typedef struct can_dma {
	volatile unsigned int	data_tx00[8];
	volatile unsigned int	data_tx01[8];
	volatile unsigned int	data_tx02[8];
	volatile unsigned int	data_tx03[8];
	volatile unsigned int	data_tx04[8];
	volatile unsigned int	data_tx05[8];
	volatile unsigned int	data_tx06[8];
	volatile unsigned int	data_tx07[8];
	volatile unsigned int	data_tx08[8];
	volatile unsigned int	data_tx09[8];
	volatile unsigned int	data_tx10[8];
	volatile unsigned int	data_tx11[8];
	volatile unsigned int	data_tx12[8];
	volatile unsigned int	data_tx13[8];
	volatile unsigned int	data_tx14[8];
	volatile unsigned int	data_tx15[8];
	volatile unsigned int	data_tx16[8];
	volatile unsigned int	data_tx17[8];

	volatile unsigned int	data_rx00[8];
	volatile unsigned int	data_rx01[8];
	volatile unsigned int	data_rx02[8];
	volatile unsigned int	data_rx03[8];
	volatile unsigned int	data_rx04[8];
	volatile unsigned int	data_rx05[8];
	volatile unsigned int	data_rx06[8];
	volatile unsigned int	data_rx07[8];
	volatile unsigned int	data_rx08[8];
	volatile unsigned int	data_rx09[8];
	volatile unsigned int	data_rx10[8];
	volatile unsigned int	data_rx11[8];
	volatile unsigned int	data_rx12[8];
	volatile unsigned int	data_rx13[8];
	volatile unsigned int	data_rx14[8];
	volatile unsigned int	data_rx15[8];
	volatile unsigned int	data_rx16[8];
	volatile unsigned int	data_rx17[8];
} can_dma_t;
#ifdef __cplusplus
}
#endif

#endif
