/*
_______________________________________________________________________________

 Copyright (c) 2012 TU Dresden, Chair for Embedded Systems
 (http://www.mr.inf.tu-dresden.de) All rights reserved.

 Redistribution and use in source and binary forms, with or without
 modification, are permitted provided that the following conditions
 are met:

 1. Redistributions of source code must retain the above copyright
    notice, this list of conditions and the following disclaimer.

 2. Redistributions in binary form must reproduce the above copyright
    notice, this list of conditions and the following disclaimer in the
    documentation and/or other materials provided with the distribution.

 3. All advertising materials mentioning features or use of this software
    must display the following acknowledgement: "This product includes
    software developed by the TU Dresden Chair for Embedded Systems and
    its contributors."

 4. Neither the name of the TU Dresden Chair for Embedded Systems nor the
    names of its contributors may be used to endorse or promote products
    derived from this software without specific prior written permission.

 THIS SOFTWARE IS PROVIDED BY TU DRESDEN CHAIR FOR EMBEDDED SYSTEMS AND
 CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING,
 BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
 FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 REGENTS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
 TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
_______________________________________________________________________________
*/

#ifndef __COMPARE_H
#define __COMPARE_H

#ifdef __cplusplus
extern "C" {
#endif

#define COMPARE_EN          (1 << 0)     // Compare Enable
#define COMPARE_EN_INT      (1 << 1)     // Compare Interrupt Enable
#define COMPARE_MODE        (1 << 2)     // Mode Bit 0

#define COMPARE_NON_FRQ     (COMPARE_MODE * 0)  // Ausgang bleibt gleich
#define COMPARE_SET_OUT     (COMPARE_MODE * 1)  // Ausgang setzen(=1)
#define COMPARE_CLEAR_OUT   (COMPARE_MODE * 2)  // Ausgang zurücksetzen(=0)
#define COMPARE_TOGGLE_OUT  (COMPARE_MODE * 3)  // Ausgang negieren
#define COMPARE_NON_IMP     (COMPARE_MODE * 4)  // Ausgang bleibt gleich
#define COMPARE_C0_N1       (COMPARE_MODE * 6)  // Ausgang auf 0 wenn Timer = CMP_DAT ist -- Ausgang auf 1 wenn Timer = 0 ist.
#define COMPARE_C1_N0       (COMPARE_MODE * 7)  // Ausgang auf 1 wenn Timer = CMP_DAT ist -- Ausgang auf 0 wenn Timer = 0 ist.

#define COMPARE_EN_OUT      (1 << 5)     // Compare Output Enable
#define COMPARE_VAL_OUT     (1 << 6)     // Compare Output Value

typedef struct cmp {
    volatile unsigned int CMP_CTRL; // (r/w)
    volatile unsigned int CMP_DAT;  // (r/w)
} compare_regs_t;

#ifdef __cplusplus
}
#endif

#endif
