#ifndef ETHERNET_RX_H_
#define ETHERNET_RX_H_

#ifdef __cplusplus
extern "C" {
#endif


typedef struct ethernet_rx_mem{
	volatile unsigned int x[1024];
} ethernet_rx_dma_t;

typedef struct ethernet_rx_regs{
	volatile unsigned int control;
	volatile unsigned int offset;
	volatile unsigned int interrupt;
	volatile unsigned int rxCount;
	volatile unsigned int wrongCrcCount;
	volatile unsigned int mac1;
	volatile unsigned int mac2;
	volatile unsigned int mac3;
} ethernet_rx_regs_t;

#define ETHERNET_RX_CONTROL_PROMISCUOUS 1
#define ETHERNET_RX_CONTROL_IRQEN 2
#define ETHERNET_RX_CONTROL_IGNORE_BROADCAST 4
#define ETHERNET_RX_CONTROL_IGNORE_CRCERROR 8
#define ETHERNET_RX_CONTROL_OVERFLOW 16

#ifdef __cplusplus
}
#endif

#endif
