/*
_______________________________________________________________________________

 Copyright (c) 2012 TU Dresden, Chair for Embedded Systems
 (http://www.mr.inf.tu-dresden.de) All rights reserved.

 Redistribution and use in source and binary forms, with or without
 modification, are permitted provided that the following conditions
 are met:

 1. Redistributions of source code must retain the above copyright
    notice, this list of conditions and the following disclaimer.

 2. Redistributions in binary form must reproduce the above copyright
    notice, this list of conditions and the following disclaimer in the
    documentation and/or other materials provided with the distribution.

 3. All advertising materials mentioning features or use of this software
    must display the following acknowledgement: "This product includes
    software developed by the TU Dresden Chair for Embedded Systems and
    its contributors."

 4. Neither the name of the TU Dresden Chair for Embedded Systems nor the
    names of its contributors may be used to endorse or promote products
    derived from this software without specific prior written permission.

 THIS SOFTWARE IS PROVIDED BY TU DRESDEN CHAIR FOR EMBEDDED SYSTEMS AND
 CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING,
 BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
 FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 REGENTS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
 TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
_______________________________________________________________________________
*/

#ifndef __PORT_BI_H
#define __PORT_BI_H

#ifdef __cplusplus
extern "C" {
#endif

#define PORT_IOBIT_0    (1<<0)
#define PORT_IOBIT_1    (1<<1)
#define PORT_IOBIT_2    (1<<2)
#define PORT_IOBIT_3    (1<<3)
#define PORT_IOBIT_4    (1<<4)
#define PORT_IOBIT_5    (1<<5)
#define PORT_IOBIT_6    (1<<6)
#define PORT_IOBIT_7    (1<<7)
#define PORT_IOBIT_8    (1<<8)
#define PORT_IOBIT_9    (1<<9)
#define PORT_IOBIT_10   (1<<10)
#define PORT_IOBIT_11   (1<<11)
#define PORT_IOBIT_12   (1<<12)
#define PORT_IOBIT_13   (1<<13)
#define PORT_IOBIT_14   (1<<14)
#define PORT_IOBIT_15   (1<<15)
#define PORT_IOBIT_16   (1<<16)
#define PORT_IOBIT_17   (1<<17)

typedef struct port_bi {
    volatile unsigned int data; // (r/w) (reset-interrupt)
    volatile unsigned int ie;   // (r/w) (reset-interrupt)
    volatile unsigned int oe;   // (r/w)
    volatile unsigned int dir;  // (r/w) (reset-interrupt) 1 = Input
    volatile unsigned int edgsel;   // (r/w) (reset-interrupt) 1 = positiv
    volatile unsigned int ir_stat;  // (r)
} port_bi_regs_t;

#ifdef __cplusplus
}
#endif

#endif
