/*
_______________________________________________________________________________

 Copyright (c) 2012 TU Dresden, Chair for Embedded Systems
 (http://www.mr.inf.tu-dresden.de) All rights reserved.

 Redistribution and use in source and binary forms, with or without
 modification, are permitted provided that the following conditions
 are met:

 1. Redistributions of source code must retain the above copyright
    notice, this list of conditions and the following disclaimer.

 2. Redistributions in binary form must reproduce the above copyright
    notice, this list of conditions and the following disclaimer in the
    documentation and/or other materials provided with the distribution.

 3. All advertising materials mentioning features or use of this software
    must display the following acknowledgement: "This product includes
    software developed by the TU Dresden Chair for Embedded Systems and
    its contributors."

 4. Neither the name of the TU Dresden Chair for Embedded Systems nor the
    names of its contributors may be used to endorse or promote products
    derived from this software without specific prior written permission.

 THIS SOFTWARE IS PROVIDED BY TU DRESDEN CHAIR FOR EMBEDDED SYSTEMS AND
 CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING,
 BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
 FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 REGENTS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
 TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
_______________________________________________________________________________
*/

#ifndef __RTI_H
#define __RTI_H

#ifdef __cplusplus
extern "C" {
#endif

#define RTI_EN		    (1 << 0)
#define RTI_EN_INT	    (1 << 1)
#define RTI_PRE_VAL	    (1 << 2) // *0 fuer 2^0 bis *15 fuer 2^15

#define RTI_PRE_1	    (RTI_PRE_VAL * 0)
#define RTI_PRE_2	    (RTI_PRE_VAL * 1)
#define RTI_PRE_4	    (RTI_PRE_VAL * 2)
#define RTI_PRE_8	    (RTI_PRE_VAL * 3)
#define RTI_PRE_16	    (RTI_PRE_VAL * 4)
#define RTI_PRE_32	    (RTI_PRE_VAL * 5)
#define RTI_PRE_64	    (RTI_PRE_VAL * 6)
#define RTI_PRE_128	    (RTI_PRE_VAL * 7)
#define RTI_PRE_256	    (RTI_PRE_VAL * 8)
#define RTI_PRE_512	    (RTI_PRE_VAL * 9)
#define RTI_PRE_1024	(RTI_PRE_VAL * 10)
#define RTI_PRE_2048	(RTI_PRE_VAL * 11)
#define RTI_PRE_4096	(RTI_PRE_VAL * 12)
#define RTI_PRE_8192	(RTI_PRE_VAL * 13)
#define RTI_PRE_16384	(RTI_PRE_VAL * 14)
#define RTI_PRE_32765	(RTI_PRE_VAL * 15)

typedef struct rti {
    volatile unsigned int ctrl;
} rti_regs_t;

#ifdef __cplusplus
}
#endif

#endif
