//
// Created by wenzel on 05.08.16.
//

#pragma once

#ifdef __cplusplus
extern "C" {
#endif

typedef struct {
    volatile unsigned int data;
    volatile unsigned int rxAvail;
} sim_print_regs_t;

//We use int but fun_stdio_send_byte uses bytes so it's undefined behaviour but we don't care and save a sign extend :)
void sim_print_send(sim_print_regs_t *sp, const unsigned int value);
unsigned char sim_print_receive(sim_print_regs_t *sp);
int sim_print_receive_nb(sim_print_regs_t *sp, unsigned char *value);

#define declare_SIM_PRINT_FILE(sim_print) { \
	.base_addr = (void*) sim_print, \
	.send_byte = (fun_stdio_send_byte) sim_print_send, \
	.receive_byte = (fun_stdio_receive_byte) sim_print_receive, \
	.receive_byte_nb = (fun_stdio_receive_byte_nb) sim_print_receive_nb \
}

void __attribute__((error("stdio_sim_print_open is no longer supported. Declare a global variable FILE * stdout = &SIM_PRINT_*_FILE instead"))) stdio_sim_print_open(sim_print_regs_t * uart);


#ifdef __cplusplus
}
#endif
