/*
_______________________________________________________________________________

 Copyright (c) 2012 TU Dresden, Chair for Embedded Systems
 (http://www.mr.inf.tu-dresden.de) All rights reserved.

 Redistribution and use in source and binary forms, with or without
 modification, are permitted provided that the following conditions
 are met:

 1. Redistributions of source code must retain the above copyright
    notice, this list of conditions and the following disclaimer.

 2. Redistributions in binary form must reproduce the above copyright
    notice, this list of conditions and the following disclaimer in the
    documentation and/or other materials provided with the distribution.

 3. All advertising materials mentioning features or use of this software
    must display the following acknowledgement: "This product includes
    software developed by the TU Dresden Chair for Embedded Systems and
    its contributors."

 4. Neither the name of the TU Dresden Chair for Embedded Systems nor the
    names of its contributors may be used to endorse or promote products
    derived from this software without specific prior written permission.

 THIS SOFTWARE IS PROVIDED BY TU DRESDEN CHAIR FOR EMBEDDED SYSTEMS AND
 CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING,
 BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
 FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 REGENTS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
 TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
_______________________________________________________________________________
*/
#ifndef __SPI_MASTER_H
#define __SPI_MASTER_H

#ifdef __cplusplus
extern "C" {
#endif

#include <peripherals/spi_common.h>

// CONTROL
#define SPI_MASTER_CTRL_EN          SPI_CTRL_EN
#define SPI_MASTER_CTRL_INT_EN      SPI_CTRL_INT_EN
#define SPI_MASTER_CTRL_CPOL        SPI_CTRL_CPOL
#define SPI_MASTER_CTRL_CPHA        SPI_CTRL_CPHA
#define SPI_MASTER_CTRL_SLAVE       0x000F0  // 00 0000 0000 1111 0000
#define SPI_MASTER_CTRL_BITCNT      0x01F00  // 00 0001 1111 0000 0000
#define SPI_MASTER_CTRL_DIV         0x0E000  // 00 1110 0000 0000 0000

//STATUS COMPATIBILITY SECTION FOR OLD PROJECTS
#define SPI_MASTER_STAT_TRANS_EMPTY SPI_STAT_TRANS_EMPTY
#define SPI_MASTER_STAT_INT         SPI_STAT_INT
#define SPI_MASTER_STAT_SS_ON       SPI_STAT_SS_ON
#define SPI_MASTER_STAT_SS_SET      SPI_STAT_SS_SET

typedef struct {
   	spi_t spi;
} spi_master_regs_t;

#ifdef __cplusplus
}
#endif

#endif
