#ifndef __USB11_FIFO_H
#define __USB11_FIFO_H

#ifdef __cplusplus
extern "C" {
#endif

#define USB11_FIFO_EP1_TX_READY         (1<<0)
#define USB11_FIFO_EP2_TX_READY         (1<<1)
#define USB11_FIFO_EP3_TX_READY         (1<<2)
#define USB11_FIFO_EP4_TX_READY         (1<<3)
#define USB11_FIFO_EP5_TX_READY         (1<<4)
#define USB11_FIFO_EP6_TX_READY         (1<<5)
#define USB11_FIFO_EP1_RX_VALID         (1<<6)
#define USB11_FIFO_EP2_RX_VALID         (1<<7)
#define USB11_FIFO_EP3_RX_VALID         (1<<8)
#define USB11_FIFO_EP4_RX_VALID         (1<<9)
#define USB11_FIFO_EP5_RX_VALID         (1<<10)
#define USB11_FIFO_EP6_RX_VALID         (1<<11)
#define USB11_FIFO_CONFIGURED           (1<<12)
#define USB11_FIFO_ADDRESSED            (1<<13)

typedef struct {
    volatile unsigned int status;
    volatile unsigned int ep_tx_data[6];
    volatile unsigned int ep_rx_data[6];
} usb11_fifo_regs_t;
#ifdef __cplusplus
}
#endif

#endif
