/*
_______________________________________________________________________________

 Copyright (c) 2012 TU Dresden, Chair for Embedded Systems
 (http://www.mr.inf.tu-dresden.de) All rights reserved.

 Redistribution and use in source and binary forms, with or without
 modification, are permitted provided that the following conditions
 are met:

 1. Redistributions of source code must retain the above copyright
    notice, this list of conditions and the following disclaimer.

 2. Redistributions in binary form must reproduce the above copyright
    notice, this list of conditions and the following disclaimer in the
    documentation and/or other materials provided with the distribution.

 3. All advertising materials mentioning features or use of this software
    must display the following acknowledgement: "This product includes
    software developed by the TU Dresden Chair for Embedded Systems and
    its contributors."

 4. Neither the name of the TU Dresden Chair for Embedded Systems nor the
    names of its contributors may be used to endorse or promote products
    derived from this software without specific prior written permission.

 THIS SOFTWARE IS PROVIDED BY TU DRESDEN CHAIR FOR EMBEDDED SYSTEMS AND
 CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING,
 BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
 FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 REGENTS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
 TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
_______________________________________________________________________________
*/

#ifndef __WATCHDOG_H
#define __WATCHDOG_H

#ifdef __cplusplus
extern "C" {
#endif

#define WATCHDOG_EN		    (1<<0)
#define WATCHDOG_PRE_EN	    (1<<1)
#define WATCHDOG_PRE_VAL	(1<<2)		// *0 fuer 2^1  bis *7 fuer 2^8

#define WATCHDOG_PRE_2	    (WATCHDOG_PRE_VAL * 0)
#define WATCHDOG_PRE_4	    (WATCHDOG_PRE_VAL * 1)
#define WATCHDOG_PRE_8	    (WATCHDOG_PRE_VAL * 2)
#define WATCHDOG_PRE_16	    (WATCHDOG_PRE_VAL * 3)
#define WATCHDOG_PRE_32	    (WATCHDOG_PRE_VAL * 4)
#define WATCHDOG_PRE_64	    (WATCHDOG_PRE_VAL * 5)
#define WATCHDOG_PRE_128	(WATCHDOG_PRE_VAL * 6)
#define WATCHDOG_PRE_256	(WATCHDOG_PRE_VAL * 7)

#define	WATCHDOG_ALARM	    (1<<5)

typedef struct wdt {
	volatile unsigned int control;	// (r/w)
	volatile unsigned int limit;	// (r/w)
	volatile unsigned int val_rst;	// (r = val / w PIN = rst)
} watchdog_regs_t;
#ifdef __cplusplus
}
#endif

#endif
