/*
_______________________________________________________________________________

 Copyright (c) 2012 TU Dresden, Chair for Embedded Systems
 (http://www.mr.inf.tu-dresden.de) All rights reserved.

 Redistribution and use in source and binary forms, with or without
 modification, are permitted provided that the following conditions
 are met:

 1. Redistributions of source code must retain the above copyright
    notice, this list of conditions and the following disclaimer.

 2. Redistributions in binary form must reproduce the above copyright
    notice, this list of conditions and the following disclaimer in the
    documentation and/or other materials provided with the distribution.

 3. All advertising materials mentioning features or use of this software
    must display the following acknowledgement: "This product includes
    software developed by the TU Dresden Chair for Embedded Systems and
    its contributors."

 4. Neither the name of the TU Dresden Chair for Embedded Systems nor the
    names of its contributors may be used to endorse or promote products
    derived from this software without specific prior written permission.

 THIS SOFTWARE IS PROVIDED BY TU DRESDEN CHAIR FOR EMBEDDED SYSTEMS AND
 CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING,
 BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
 FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 REGENTS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
 TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
_______________________________________________________________________________
*/

#ifndef __SPI_H
#define __SPI_H

#ifdef __cplusplus
extern "C" {
#endif

#include <peripherals/spi_master.h>
#include <peripherals/spi_slave.h>
#include <bitmagic.h>

//master only functions
void spi_master_activate(spi_master_regs_t *spi,unsigned int device);
void spi_master_deactivate(spi_master_regs_t *spi);
void spi_master_set_div(spi_master_regs_t *spi, unsigned int div);

//master duplicate functions
unsigned int spi_master_readwrite(spi_master_regs_t *spi, unsigned int data);
void spi_master_write(spi_master_regs_t *spi, unsigned int data);
void spi_master_enable(spi_master_regs_t *spi);     
void spi_master_disable(spi_master_regs_t *spi);     
void spi_master_enable_irq(spi_master_regs_t *spi);     
void spi_master_disable_irq(spi_master_regs_t *spi);     
void spi_master_set_cpol(spi_master_regs_t *spi, unsigned int cpol);     
void spi_master_set_cpah(spi_master_regs_t *spi, unsigned int cpah);     
void spi_master_set_bitcnt(spi_master_regs_t *spi, unsigned int bitcnt);

//slave duplicate functions
unsigned int spi_slave_readwrite(spi_slave_regs_t *spi, unsigned int data);
void spi_slave_write(spi_slave_regs_t *spi, unsigned int data);
void spi_slave_enable(spi_slave_regs_t *spi);     
void spi_slave_disable(spi_slave_regs_t *spi);     
void spi_slave_enable_irq(spi_slave_regs_t *spi);     
void spi_slave_disable_irq(spi_slave_regs_t *spi);     
void spi_slave_set_cpol(spi_slave_regs_t *spi, unsigned int cpol);     
void spi_slave_set_cpah(spi_slave_regs_t *spi, unsigned int cpah);     
void spi_slave_set_bitcnt(spi_slave_regs_t *spi, unsigned int bitcnt);

#ifdef __cplusplus
}
#endif

#endif
