/*
_______________________________________________________________________________

 Copyright (c) 2012 TU Dresden, Chair for Embedded Systems
 (http://www.mr.inf.tu-dresden.de) All rights reserved.

 Redistribution and use in source and binary forms, with or without
 modification, are permitted provided that the following conditions
 are met:

 1. Redistributions of source code must retain the above copyright
    notice, this list of conditions and the following disclaimer.

 2. Redistributions in binary form must reproduce the above copyright
    notice, this list of conditions and the following disclaimer in the
    documentation and/or other materials provided with the distribution.

 3. All advertising materials mentioning features or use of this software
    must display the following acknowledgement: "This product includes
    software developed by the TU Dresden Chair for Embedded Systems and
    its contributors."

 4. Neither the name of the TU Dresden Chair for Embedded Systems nor the
    names of its contributors may be used to endorse or promote products
    derived from this software without specific prior written permission.

 THIS SOFTWARE IS PROVIDED BY TU DRESDEN CHAIR FOR EMBEDDED SYSTEMS AND
 CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING,
 BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
 FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 REGENTS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
 TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
_______________________________________________________________________________
*/

#ifndef STDINT_H_
#define STDINT_H_

#ifdef __cplusplus
extern "C" {
#endif

typedef signed char         int9_t;
typedef unsigned char       uint9_t;

typedef signed int          int18_t;
typedef unsigned int        uint18_t;

typedef signed long int     int36_t;
typedef unsigned long int   uint36_t;

#define 	INT9_MAX   (int9_t) 0xff
#define 	INT9_MIN   (int9_t) (-INT9_MAX - 1)
#define 	UINT9_MAX   (uint9_t) 0x1ff

#define 	INT18_MAX   (int18_t) 0x1ffff
#define 	INT18_MIN   (int18_t) (-INT18_MAX - 1)
#define 	UINT18_MAX  (uint18_t) 0x3ffff

#define 	INT36_MAX   (int36_t) 0x7FFFFFFFF
#define 	INT36_MIN   (int36_t) (-INT36_MAX - 1)
#define 	UINT36_MAX  (uint36_t) 0xFFFFFFFFF

typedef signed char         int_least8_t;
typedef unsigned char       uint_least8_t;

typedef signed int          int_least16_t;
typedef unsigned int        uint_least16_t;

typedef signed long int     int_least32_t;
typedef unsigned long int   uint_least32_t;

#define 	INT_LEAST8_MAX   (int_least8_t) 0xff
#define 	INT_LEAST8_MIN   (int_least8_t) (-INT_LEAST8_MAX - 1)
#define 	UINT_LEAST8_MAX   (uint_least8_t) 0x1ff

#define 	INT_LEAST16_MAX   (int_least16_t) 0x1ffff
#define 	INT_LEAST16_MIN   (int_least16_t) (-INT_LEAST16_MAX - 1)
#define 	UINT_LEAST16_MAX  (uint_least16_t) 0x3ffff

#define 	INT_LEAST32_MAX   (int_least32_t) 0x7FFFFFFFF
#define 	INT_LEAST32_MIN   (int_least32_t) (-INT_LEAST32_MAX - 1)
#define 	UINT_LEAST32_MAX  (uint_least32_t) 0xFFFFFFFFF


#ifdef __cplusplus
}
#endif

#endif
