/*
_______________________________________________________________________________

 Copyright (c) 2012 TU Dresden, Chair for Embedded Systems
 (http://www.mr.inf.tu-dresden.de) All rights reserved.

 Redistribution and use in source and binary forms, with or without
 modification, are permitted provided that the following conditions
 are met:

 1. Redistributions of source code must retain the above copyright
    notice, this list of conditions and the following disclaimer.

 2. Redistributions in binary form must reproduce the above copyright
    notice, this list of conditions and the following disclaimer in the
    documentation and/or other materials provided with the distribution.

 3. All advertising materials mentioning features or use of this software
    must display the following acknowledgement: "This product includes
    software developed by the TU Dresden Chair for Embedded Systems and
    its contributors."

 4. Neither the name of the TU Dresden Chair for Embedded Systems nor the
    names of its contributors may be used to endorse or promote products
    derived from this software without specific prior written permission.

 THIS SOFTWARE IS PROVIDED BY TU DRESDEN CHAIR FOR EMBEDDED SYSTEMS AND
 CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING,
 BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
 FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 REGENTS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
 TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
_______________________________________________________________________________
*/


#ifndef TIMER_CAP_H_
#define TIMER_CAP_H_

#ifdef __cplusplus
extern "C" {
#endif

// file kept for compatibility with older projects, may be removed in the
// future

#include <peripherals/capture.h>

#define CAP_EN              CAPTURE_EN			 
#define CAP_EN_INT          CAPTURE_EN_INT		 
#define CAP_EDGE            CAPTURE_EDGE		 
                                                 
#define CAP_NON             CAPTURE_NON			 
#define CAP_FALLING_EDGE    CAPTURE_FALLING_EDGE 
#define CAP_RISING_EDGE     CAPTURE_RISING_EDGE	 
#define CAP_LOW_LEVEL       CAPTURE_LOW_LEVEL	 
#define CAP_HIGH_LEVEL      CAPTURE_HIGH_LEVEL	 
#define CAP_ANYTHING_EDGE   CAPTURE_ANYTHING_EDGE

typedef capture_regs_t cap_t;

#ifdef __cplusplus
}
#endif

#endif /* TIMER_CAP_H_ */
