/*
_______________________________________________________________________________

 Copyright (c) 2012 TU Dresden, Chair for Embedded Systems
 (http://www.mr.inf.tu-dresden.de) All rights reserved.

 Redistribution and use in source and binary forms, with or without
 modification, are permitted provided that the following conditions
 are met:

 1. Redistributions of source code must retain the above copyright
    notice, this list of conditions and the following disclaimer.

 2. Redistributions in binary form must reproduce the above copyright
    notice, this list of conditions and the following disclaimer in the
    documentation and/or other materials provided with the distribution.

 3. All advertising materials mentioning features or use of this software
    must display the following acknowledgement: "This product includes
    software developed by the TU Dresden Chair for Embedded Systems and
    its contributors."

 4. Neither the name of the TU Dresden Chair for Embedded Systems nor the
    names of its contributors may be used to endorse or promote products
    derived from this software without specific prior written permission.

 THIS SOFTWARE IS PROVIDED BY TU DRESDEN CHAIR FOR EMBEDDED SYSTEMS AND
 CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING,
 BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
 FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 REGENTS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
 TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
_______________________________________________________________________________
*/

#ifndef TIMER_CMP_H_
#define TIMER_CMP_H_

#ifdef __cplusplus
extern "C" {
#endif

// file kept for compatibility with older projects, may be removed in the
// future

#include <peripherals/compare.h>

#define CMP_EN          COMPARE_EN        
#define CMP_EN_INT      COMPARE_EN_INT    
#define CMP_MODE        COMPARE_MODE      
                                          
#define CMP_NON_FRQ     COMPARE_NON_FRQ   
#define CMP_SET_OUT     COMPARE_SET_OUT   
#define CMP_CLEAR_OUT   COMPARE_CLEAR_OUT 
#define CMP_TOGGLE_OUT  COMPARE_TOGGLE_OUT
#define CMP_NON_IMP     COMPARE_NON_IMP   
#define CMP_C0_N1       COMPARE_C0_N1     
#define CMP_C1_N0       COMPARE_C1_N0     
                                          
#define CMP_EN_OUT      COMPARE_EN_OUT    
#define CMP_VAL_OUT     COMPARE_VAL_OUT   

typedef compare_regs_t cmp_t;

#ifdef __cplusplus
}
#endif

#endif /* TIMER_CMP_H_ */
