; macro to format entries in the trap table
; call using "trap_entry <name>"
; will generate a global label "tsr_<name>_idx" with the idx in the final table
; will add an entry to the trap table, jumping to "tsr_<name>"

.macro	trap_entry	function
	.global tsr_\function\()_idx
	tsr_\function\()_idx = (. - _trap_table) >> 2
	j	tsr_\function
.endm

.section .traps, "ax", @progbits

.global _trap_table
_trap_table:

trap_entry breakpoint
trap_entry breakpoint_hdw
trap_entry watchpoint
trap_entry single_step

or	r0,	r0	; delay slot of the jump of the last entry
