
; native sleep functions so that their runtime, given a specific clock rate, is constant and foreseeable
; sleep: 6 static + 3 cycles per iteration

.text
.align9

; void sleep(int inner);
.global sleep
sleep:
	BEQZ	r4,end
	MOVI	r5,1
	J		loop
	NOP; empty-delay-slot

; sleep_sleep: 4 static + ((3 * inner) + 3) * outer


; void sleep(int inner, int outer);
.global sleep_sleep
sleep_sleep:
	BEQZ	r5,end
	MOV		r6,r4
loop:
	ADDI	r4,-1
	BNEZ	r4,loop
	NOP; empty-delay-slot
	ADDI	r5,-1
	BNEZ	r5,loop
	MOV		r4,r6
end:
	JRS		r11
	NOP; empty-delay-slot
