	.text
;*****************************************************************************
; The function copies the string s2 (R5), including its terminating null     *
; character, to successive elements of the array of char whose first element *
; has the address s1 (R4). It returns s1.                                    *
;*****************************************************************************
.global strcpy 
strcpy:
		MOV	R8,	R4
_strcpy_loop:
		L9	R9,	0(R5)
		S9	0(R8),	R9
		ADDI	R5,	1
		BNEZ	R9,	_strcpy_loop 
		ADDI	R8,	1	;wird im Delay Slot ausgefuehrt
		JRS	R11
		or	r0,	r0
;
;
;*****************************************************************************
; The function copies the string s2 (R5), including its terminating null     *
; character, to successive elements of the array of char whose first element *
; has the address s1 (R4). It returns s1.                                    *
;*****************************************************************************
.global strncpy 
strncpy:
		MOV	R8,	R4
_strncpy_loop:
		L9	R9,	0(R5)
		S9	0(R8),	R9
		ADDI	R5,	1
		ADDI	R8,	1
		BEQZ	R9,	_strncpy_end
		ADDI	R6,	-1	;countdown element
;		wird im Delay Slot ausgefuehrt
		BNEZ	R6,	_strncpy_loop
		or	r0,	r0
_strncpy_stop:	JRS	R11
		or	r0,	r0
_strncpy_end:	BEQZ	r6,	_strncpy_stop
		or	r0,	r0
		S9	0(R8),	R9
		ADDI	R8,	1
		ADDI	R6,	-1	;countdown element
		J	_strncpy_end
		OR r0,r0
;
;
;*****************************************************************************
; The function compares successive elements from two strings, s1 and s2,     *
; until it finds elements that are not equal.                                *
;  * If all elements are equal, the function returns zero.                   *
;  * If the differing element from s1 is greater than the element from s2    *
;    (both taken as unsigned char), the function returns a positive number.  *
;  * Otherwise, the function returns a negative number.                      *
;*****************************************************************************
.global strcmp 
strcmp:
		L9	R9,	0(R4)	;load characters
		L9	R10,	0(R5)
		ADDI	R4,	1	;next element
		SEQ	R9,	R10
		mov	r8,	r10
		or	r8,	r9	;sind beide 0?
		beqz	r8,	allequ
		ADDI	R5,	1	;next element
;		wird im Delay Slot ausgefuehrt
		BNEZC	strcmp		;if equal - next	
		or	r0,	r0
allequ:		MOV	R4,	R9
		SUB	R4,	R10
		JRS	R11
		or	r0,	r0
;
;
;*****************************************************************************
; The function compares successive elements from two strings, s1 and s2,     *
; until it finds elements that are not equal.                                *
;  * If all elements are equal, the function returns zero.                   *
;  * If the differing element from s1 is greater than the element from s2    *
;    (both taken as unsigned char), the function returns a positive number.  *
;  * Otherwise, the function returns a negative number.                      *
;*****************************************************************************
.global strncmp 
strncmp:
		L9	R9,	0(R4)	;load characters
		L9	R10,	0(R5)
		ADDI	R4,	1	;next element
		SEQ	R9,	R10
		ADDI	R6,	-1	;countdown element
		mov	r8,	r10
		or	r8,	r9	;sind beide 0?
		beqz	r8,	allequn
		ADDI	R5,	1	;next element
;		wird im Delay Slot ausgefuehrt
		BEQZ	r6,	allequn
		or	r0,	r0
		BNEZC	strncmp		;if equal - next	
allequn:	MOV	R4,	R9
		SUB	R4,	R10
		JRS	R11
		or	r0,	r0
;
;

