.text
.align9

; Setzen des Interruptvektors
; r4: Adresse der Interrupttabelle
.global set_iv
set_iv:		
		jrs	r11
		movi2s	SFR_IV,	r4
;		wird im Delay Slot ausgefuehrt

; Interrupts freigeben
.global interrupt_enable
interrupt_enable:
		jrs	r11
		sbits	INT
;		wird im Delay Slot ausgefuehrt
; Interrupts sperren
.global interrupt_disable
interrupt_disable:
		jrs	r11
		cbits	INT
;		wird im Delay Slot ausgefuehrt

.section .interrupt, "ax", @progbits
.align9

; Interrupt-Handler
.global _intr_handle
_intr_handle:

		lhi	r8,	%dhi(INT_BASE)
		ori r8, %dlo(INT_BASE)
		movs2i	r10,	SFR_CC	; CC in lokalem Register retten,
								; ermöglicht Taskwechsel des RTOS aus einer ISR
		l18	r9,	0(r8)			; Inhalt int_pri Register
		andi	r9,	0x01f			; Interruptquelle groesser 31 und 0?
		lhi	r8, %dhi(__INTR_TAB__)
		ori	r8, %dlo(__INTR_TAB__)
		beqz	r9,	_intr_exit		; Interrupt nicht unterstuetzt
		slli	r9,	1			; Offset verdoppeln
		addu	r9,	r8			; Adresse in der Tabelle fuer Behandlung
		l18	r9,	0(r9)			; Sprungziel laden
		jalrs	r9				; Sprung zu den ISRxx Funktionen.
		mov	r12,	r11			; Uebergabe von Next PC an die ISRxx Funktionen.
;
; Ruecksprung aus den _ISRxx Funktionen -- Interruptbehandlung beenden
;
_intr_exit:
		movi2s	SFR_CC, r10			; CC zurueckladen
		rfe	r11
		sbits	INT				; Interrupts freigeben
;		wird im Delay Slot ausgefuehrt

