.text
.align9

; Setzen des Interruptvektors
; r4: Adresse der Interrupttabelle
.global set_iv
set_iv:		
		movi2s	SFR_IV,	r4
		movi	r9,	0
		lhi	r10, %dhi(_intr_tab)
		ori	r10, %dlo(_intr_tab)
		jrs	r11
		s18	0(r10),	r9		; Zellen fuer CC-Bits und Protokoll Counter loeschen
;		wird im Delay Slot ausgefuehrt

; Interrupts freigeben
.global interrupt_enable
interrupt_enable:
		jrs	r11
		sbits	INT
;		wird im Delay Slot ausgefuehrt

; Interrupts sperren
.global interrupt_disable
interrupt_disable:
		jrs	r11
		cbits	INT
;		wird im Delay Slot ausgefuehrt

.section interrupt, "x", @progbits
.align9

; Interrupt-Handler
.global _intr_handle
_intr_handle:

		lhi	r8, %dhi(INT_BASE)
		lhi	r8, %dlo(INT_BASE)
		movs2i	r14,	SFR_CC			; CC Retten
		l18	r9,	0(r8)			; Inhalt int_pri Register
		andi	r9,	0x01f			; Interruptquelle groesser 31 und 0?
		lhi	r10, %dhi(_intr_tab)
		ori	r10, %dlo(_intr_tab)
;
; 8 CC- Bits auf _intr_tab retten
;
		l9	r15,	0(r10)
		slli	r15,	1
		or	r15,	r14
		s9	0(r10),	r15
;
; Protokoll Counter + 1 fuer Tests
;
		l9	r13,	1(r10)
		addi	r13,	1
		s9	1(r10),	r13
;
		beqz	r9,	_intr_exit		; Interrupt nicht unterstuetzt
		slli	r9,	1			; Offset verdoppeln
		addu	r9,	r10			; Adresse in der Tabelle fuer Behandlung
		l18	r9,	0(r9)			; Sprungziel laden
		jalrs	r9				; Sprung zu den ISRxx Funktionen.
		mov	r12,	r11			; Uebergabe von Next PC an die ISRxx Funktionen.
;		wird im Delay Slot ausgefuehrt
;
; Ruecksprung aus den _ISRxx Funktionen -- Interruptbehandlung beenden
;
_intr_exit:
;		cbits	INT
		lhi	r10, %dhi(_intr_tab) 		; Adresse Interrupttabelle *2 fuer Daten
		ori	r10, %dlo(_intr_tab)
;
; CC- Bit auf _intr_tab zurueckladen in SFR_CC
;
		l9	r15,	0(r10)			; CC Bit vom Puffer laden.
		movi2s	SFR_CC, r15			; CC zurueckladen
		srli	r15,	1
		s9	0(r10),	r15
;
; Protokoll Counter -1 fuer Tests
;
		l9	r13,	1(r10)
		addi	r13,	-1
		s9	1(r10),	r13
;
		rfe	r11				; wird noch im DI abgearbeitet und
							; gibt Interrupts frei
		or	r0,	r0
;		wird im Delay Slot ausgefuehrt

