/**
 * _______________________________________________________________________________
 *
 *  Copyright (c) 2012 TU Dresden, Chair for Embedded Systems
 *  Copyright (c) 2013-2016 TU Darmstadt, Computer Systems Group
 *  (http://www.rs.tu-darmstadt.de) All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions
 *  are met:
 *
 *  1. Redistributions of source code must retain the above copyright
 *     notice, this list of conditions and the following disclaimer.
 *
 *  2. Redistributions in binary form must reproduce the above copyright
 *     notice, this list of conditions and the following disclaimer in the
 *     documentation and/or other materials provided with the distribution.
 *
 *  3. All advertising materials mentioning features or use of this software
 *     must display the following acknowledgement: "This product includes
 *     software developed by the TU Dresden Chair for Embedded Systems, TU Darmstadt Computer Systems Group and
 *     its contributors."
 *
 *  4. Neither the name of the TU Dresden Chair for Embedded Systems, TU Darmstadt Computer Systems Group nor the
 *     names of its contributors may be used to endorse or promote products
 *     derived from this software without specific prior written permission.
 *
 *  THIS SOFTWARE IS PROVIDED BY TU DRESDEN CHAIR FOR EMBEDDED SYSTEMS, TU DARMSTADT COMPUTER SYSTEMS GROUP AND
 *  CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING,
 *  BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
 *  FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 *  REGENTS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 *  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
 *  TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 *  PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 *  LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 *  NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 *  SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * _______________________________________________________________________________
 */


#include <mpsoc.h>

int core_connector_slave_dma_receive_value_nb(core_connector_dma_t *conn, volatile unsigned int * value) {
	
	conn->msg_size = 1;
    conn->data_addr = value;
	if (!dma_transfer_finished(&conn->status)) {
		return MODULE_BUSY;
	}
    conn->status = MODULE_BUSY;//<-los geht's
	return CORE_CONN_OK;

}

void core_connector_slave_dma_receive_value(core_connector_dma_t *conn, volatile unsigned int * value) {

	conn->msg_size = 1;
	conn->data_addr = value;
	wait_dma_transfer_finished(&conn->status);
    conn->status = MODULE_BUSY;//<-los geht's
	wait_dma_transfer_finished(&conn->status);

}

int core_connector_slave_dma_receive_data_nb(core_connector_dma_t *conn, volatile unsigned int * data, unsigned int count) {
	
   	conn->msg_size = count;
	conn->data_addr = data;
    if (!dma_transfer_finished(&conn->status)) {
       	return MODULE_BUSY;
    }
	conn->status = MODULE_BUSY;//<-los geht's
    return CORE_CONN_OK;
}

void core_connector_slave_dma_receive_data(core_connector_dma_t *conn, volatile unsigned int * data, unsigned int count) {
	
	conn->msg_size=count;
	conn->data_addr = data;
	wait_dma_transfer_finished(&conn->status);//wait till further transmission is finished
	conn->status = MODULE_BUSY;//<-los geht's
	wait_dma_transfer_finished(&conn->status);
}
