/**
 * _______________________________________________________________________________
 *
 *  Copyright (c) 2012 TU Dresden, Chair for Embedded Systems
 *  Copyright (c) 2013-2016 TU Darmstadt, Computer Systems Group
 *  (http://www.rs.tu-darmstadt.de) All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions
 *  are met:
 *
 *  1. Redistributions of source code must retain the above copyright
 *     notice, this list of conditions and the following disclaimer.
 *
 *  2. Redistributions in binary form must reproduce the above copyright
 *     notice, this list of conditions and the following disclaimer in the
 *     documentation and/or other materials provided with the distribution.
 *
 *  3. All advertising materials mentioning features or use of this software
 *     must display the following acknowledgement: "This product includes
 *     software developed by the TU Dresden Chair for Embedded Systems, TU Darmstadt Computer Systems Group and
 *     its contributors."
 *
 *  4. Neither the name of the TU Dresden Chair for Embedded Systems, TU Darmstadt Computer Systems Group nor the
 *     names of its contributors may be used to endorse or promote products
 *     derived from this software without specific prior written permission.
 *
 *  THIS SOFTWARE IS PROVIDED BY TU DRESDEN CHAIR FOR EMBEDDED SYSTEMS, TU DARMSTADT COMPUTER SYSTEMS GROUP AND
 *  CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING,
 *  BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
 *  FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 *  REGENTS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 *  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
 *  TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 *  PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 *  LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 *  NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 *  SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * _______________________________________________________________________________
 */
#include <perf.h>
#include <stdio.h>


/*static void print_dec36(uint36_t n)
{
	char s[16];
	int i;

	s[15] = '\0';
	for(i = 14; i >= 0; i--) {
		s[i] = (n % 10) + '0';
		n = n / 10;
		if(n == 0)
			break;
	}

	printf("%s", &s[i]);

	return;
}*/

void perf_results_printf(struct perf_result *res)
{
	uint18_t reg_dat;
	int num_cyclecnt, num_eventcnt, i;

	PCNT_IDX_WRITE(0);
	PCNT_DAT_READ(reg_dat);
	num_cyclecnt = (reg_dat >> 9) & 0x07;
	num_eventcnt = (reg_dat >> 12) & 0x1f;

	printf("========== Performance counter results ==========\r\n");
	for(i = 0; i < num_cyclecnt; i++) {
		printf("Cycle%d: ", i); printf("%ld",res->cycles[i].counter); printf("\r\n");
	}
	for(i = 0; i < num_eventcnt; i++) {
		printf("Event%d: ", i); printf("%ld",res->events[i].counter); printf("\r\n");
	}
	for(i = 0; i < num_cyclecnt; i++) {
		if(res->cycles[i].overflow) {
			printf("Warning: Cycle counter %d overflow!\n\r", i);
		}
	}
	for(i = 0; i < num_eventcnt; i++) {
		if(res->events[i].overflow) {
			printf("Warning: Event counter %d overflow!\n\r", i);
		}
	}

	printf("\r\n");

	return;
}


void perf_auto_print(int size, struct perf_auto_result *r)
{
	int i;

	// Print a bunch of newlines to prevent gibberish after reset.
	printf("\r\n\r\n\r\n\r\n\r\n\r\n\r\n\r\n\r\n\r\n");
	printf("PERF_AUTO_START\r\n");
	for(i = 0; i < size; i++) {
		printf("%s;", r[i].name);
		printf("%ld",r[i].result.cycles[0].counter);
		printf("\r\n");
	}
	printf("PERF_AUTO_STOP\r\n");
}

void perf_auto_print_iter(int size, struct perf_auto_result *r)
{
	int i;

	// Print a bunch of newlines to prevent gibberish after reset.
	printf("\r\n\r\n\r\n\r\n\r\n\r\n\r\n\r\n\r\n\r\n");
	printf("PERF_AUTO_START_PRINT_ITER\r\n");
	for(i = 0; i < size; i++) {
		printf("%s;", r[i].name);
		printf("%ld",r[i].result.cycles[0].counter);
		printf("\r\n");
	}
	printf("PERF_AUTO_STOP_PRINT_ITER\r\n");
}

void perf_auto_end_loop()
{
	printf("PERF_AUTO_END_LOOP\r\n");
}

void perf_auto_stop_loopOpt()
{
	printf("PERF_AUTO_STOP\r\n");
}
