package de.tu_darmstadt.rs;

import org.w3c.dom.Node;
import org.w3c.dom.NodeList;

import java.util.Collections;
import java.util.List;
import java.util.stream.Collector;
import java.util.stream.Collectors;

public class MyNodeList implements NodeList {
    private final List<? extends Node> items;

    public MyNodeList(List<? extends Node> items) {

        this.items = items;
    }
    @Override
    public Node item(int index) {
        return items.get(index);
    }

    @Override
    public int getLength() {
        return items.size();
    }

    public static Collector<Node, ?, MyNodeList> toList() {
        return Collectors.collectingAndThen(Collectors.toList(),MyNodeList::new);
    }

    public static NodeList singletonList(Node node) {
        return new MyNodeList(Collections.singletonList(node));
    }
}
