<?xml version="1.0" encoding="ISO-8859-1"?>
<!--

    _______________________________________________________________________________

     Copyright (c) 2012 TU Dresden, Chair for Embedded Systems
     Copyright (c) 2013-2016 TU Darmstadt, Computer Systems Group
     (http://www.rs.tu-darmstadt.de) All rights reserved.

     Redistribution and use in source and binary forms, with or without
     modification, are permitted provided that the following conditions
     are met:

     1. Redistributions of source code must retain the above copyright
        notice, this list of conditions and the following disclaimer.

     2. Redistributions in binary form must reproduce the above copyright
        notice, this list of conditions and the following disclaimer in the
        documentation and/or other materials provided with the distribution.

     3. All advertising materials mentioning features or use of this software
        must display the following acknowledgement: "This product includes
        software developed by the TU Dresden Chair for Embedded Systems, TU Darmstadt Computer Systems Group and
        its contributors."

     4. Neither the name of the TU Dresden Chair for Embedded Systems, TU Darmstadt Computer Systems Group nor the
        names of its contributors may be used to endorse or promote products
        derived from this software without specific prior written permission.

     THIS SOFTWARE IS PROVIDED BY TU DRESDEN CHAIR FOR EMBEDDED SYSTEMS, TU DARMSTADT COMPUTER SYSTEMS GROUP AND
     CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING,
     BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
     FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
     REGENTS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
     SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
     TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
     PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
     LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
     NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
     SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
    _______________________________________________________________________________

-->
<xsl:stylesheet version="1.0"
				xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
				xmlns:fo="http://www.w3.org/1999/XSL/Format"
				xmlns:svg="http://www.w3.org/2000/svg"
				xmlns:man="http://www.rs.tu-darmstadt.de/ns/spartanmc/manual/"
				xmlns:java="http://xml.apache.org/xalan/java"
			>


	<xsl:preserve-space elements="stri emi"/>

	<xsl:template name="printTitlePage">

		<fo:page-sequence master-reference="a4">

			<fo:static-content flow-name="xsl-region-before">
				<fo:block font-family="Helvetica" font-weight="bold" font-size="14pt" width="100%"
						  border-bottom-style="solid" border-bottom-width="2pt" border-bottom-color="black"
						  text-align="center" color="white">
					<xsl:text>SpartanMC</xsl:text>
				</fo:block>
			</fo:static-content>

			<fo:static-content flow-name="xsl-region-after">
				<fo:block width="100%" border-bottom-style="solid" border-bottom-width="2pt"
						  border-bottom-color="black"/>
			</fo:static-content>

			<fo:flow flow-name="xsl-region-body">
				<fo:block id="{generate-id(.)}">
					<fo:table table-layout="fixed" width="100%" font-family="Helvetica" font-weight="bold"
							  margin-top="6cm">
						<fo:table-body>
							<fo:table-row>
								<fo:table-cell>
									<fo:block text-align="right" font-size="40pt">
										SpartanMC
									</fo:block>
									<fo:block text-align="right" font-size="28pt" font-style="italic">
										<xsl:value-of select="normalize-space(man:title)"/>
									</fo:block>
								</fo:table-cell>
							</fo:table-row>
						</fo:table-body>
					</fo:table>
				</fo:block>
			</fo:flow>

		</fo:page-sequence>

	</xsl:template>

	<xsl:template match="man:section">
		<xsl:choose>
			<xsl:when test="@newpage = 'true'">
				<fo:block font-family="Helvetica" font-size="18pt" font-weight="bold" space-after="0.5cm"
						  space-before="1cm" id="{generate-id(.)}" keep-with-next="always" break-before="page">
					<fo:marker marker-class-name="title">
						<xsl:value-of select="normalize-space(man:title)"/>
					</fo:marker>
					<xsl:call-template name="printSectionHeader"/>
				</fo:block>
			</xsl:when>
			<xsl:otherwise>
				<fo:block font-family="Helvetica" font-size="18pt" font-weight="bold" space-after="0.5cm"
						  space-before="1cm" id="{generate-id(.)}" keep-with-next="always">
					<fo:marker marker-class-name="title">
						<xsl:value-of select="normalize-space(man:title)"/>
					</fo:marker>
					<xsl:call-template name="printSectionHeader"/>
				</fo:block>
			</xsl:otherwise>
		</xsl:choose>
		<xsl:apply-templates/>
	</xsl:template>

	<xsl:template match="man:subsection">
		<xsl:choose>
			<xsl:when test="@newpage = 'true'">
				<fo:block font-family="Helvetica" font-size="14pt" font-weight="bold" space-after="0.5cm"
						  space-before="1cm" id="{generate-id(.)}" keep-with-next="always" break-before="page">
					<fo:marker marker-class-name="title">
						<xsl:value-of select="normalize-space(man:title)"/>
					</fo:marker>
					<xsl:call-template name="printSubsectionHeader"/>
				</fo:block>
			</xsl:when>
			<xsl:otherwise>
				<fo:block font-family="Helvetica" font-size="14pt" font-weight="bold" space-after="0.5cm"
						  space-before="1cm" id="{generate-id(.)}" keep-with-next="always">
					<fo:marker marker-class-name="title">
						<xsl:value-of select="normalize-space(man:title)"/>
					</fo:marker>
					<xsl:call-template name="printSubsectionHeader"/>
				</fo:block>
			</xsl:otherwise>
		</xsl:choose>
		<xsl:apply-templates select="man:*"/>
	</xsl:template>

	<xsl:template name="page_header">
		<fo:block font-family="Helvetica" font-weight="bold" font-size="14pt" width="100%" border-bottom-style="solid"
				  border-bottom-width="2pt" border-bottom-color="black" text-align="center">
			SpartanMC
		</fo:block>
	</xsl:template>

	<xsl:template name="page_footer">
		<xsl:param name="prefix"/>
		<fo:block font-family="Helvetica" font-size="10pt">
			<fo:table table-layout="fixed" width="100%" border-top-style="solid" border-top-width="2pt"
					  border-top-color="black">
				<fo:table-body>
					<fo:table-row>
						<fo:table-cell width="1.5cm">
							<fo:block></fo:block>
						</fo:table-cell>
						<fo:table-cell padding-top="3mm" text-align="center">
							<fo:block>
								<fo:inline font-weight="bold">
									<xsl:value-of select="normalize-space(man:title)"/>
								</fo:inline>
							</fo:block>
						</fo:table-cell>
						<fo:table-cell padding-top="3mm" width="1.5cm" text-align="right">
							<fo:block>
								<xsl:value-of select="$prefix"/>
								<fo:page-number/>
							</fo:block>
						</fo:table-cell>
					</fo:table-row>
				</fo:table-body>
			</fo:table>
		</fo:block>
	</xsl:template>

	<xsl:template match="man:paragraph">
		<fo:block font-family="Helvetica" font-style="normal" font-weight="normal" line-height="14pt" space-after="6pt"
				  text-align="justify" widows="3" orphans="3" language="en" hyphenate="true"
				  hyphenation-push-character-count="2" hyphenation-remain-character-count="2">
			<xsl:apply-templates/>
		</fo:block>
	</xsl:template>

	<xsl:template match="man:note">
		<fo:block space-after="0.5cm" space-before="0.5cm">
			<fo:table table-layout="fixed" width="100%">
				<fo:table-column column-width="10%"/>
				<fo:table-column column-width="90%"/>
				<fo:table-body>
					<fo:table-row>
						<fo:table-cell>
							<fo:block font-family="Helvetica" font-style="normal" font-weight="bold" line-height="14pt">
								Note:
							</fo:block>
						</fo:table-cell>
						<fo:table-cell>
							<fo:block font-family="Helvetica" font-style="normal" font-weight="normal"
									  line-height="14pt" text-align="justify" widows="3" orphans="3" language="en"
									  hyphenate="true" hyphenation-push-character-count="2"
									  hyphenation-remain-character-count="2">
								<xsl:apply-templates/>
							</fo:block>
						</fo:table-cell>
					</fo:table-row>
				</fo:table-body>
			</fo:table>
		</fo:block>
	</xsl:template>

	<xsl:template match="man:image">
	</xsl:template>

	<xsl:template match="man:figure">

		<fo:block space-before="1cm" space-after="1cm" id="{generate-id(.)}">

			<fo:marker marker-class-name="figure">
				<xsl:value-of select="normalize-space(@caption-text)"/>
			</fo:marker>

			<xsl:if test="(@caption-position = 'both') or (@caption-position = 'top')">
				<fo:block text-align="center" font-weight="bold" font-size="10pt" keep-with-next="always">
					<xsl:call-template name="printFigureNumber"/>
				</fo:block>
			</xsl:if>

			<fo:block text-align="center" space-before.optimum="8pt" space-after.optimum="8pt">
				<xsl:element name="fo:external-graphic">
					<xsl:attribute name="src">
						<xsl:value-of select="@src"/>
					</xsl:attribute>
					<xsl:if test="@width">
						<xsl:attribute name="content-width">
							<xsl:value-of select="@width"/>
						</xsl:attribute>
					</xsl:if>
					<xsl:if test="@height">
						<xsl:attribute name="content-height">
							<xsl:value-of select="@height"/>
						</xsl:attribute>
					</xsl:if>
				</xsl:element>
			</fo:block>

			<xsl:if test="(@caption-position = 'both') or (@caption-position = 'bottom') or not(@caption-position)">
				<fo:block text-align="center" font-weight="bold" font-size="10pt" space-before="0.5cm"
						  keep-with-previous="always">
					<xsl:call-template name="printFigureNumber"/>
				</fo:block>
			</xsl:if>

		</fo:block>

	</xsl:template>

	<xsl:template match="man:table">

		<fo:block space-before="1cm" space-after="1cm" id="{generate-id(.)}">

			<fo:marker marker-class-name="table">
				<xsl:value-of select="normalize-space(@caption-text)"/>
			</fo:marker>

			<xsl:if test="(@caption-position = 'both') or (@caption-position = 'top') or not(@caption-position)">
				<fo:block text-align="center" font-weight="bold" font-size="10pt" keep-with-next="always">
					<xsl:call-template name="printTableNumber"/>
				</fo:block>
			</xsl:if>

			<fo:table table-layout="fixed" width="100%" border-top="1pt solid black" border-left="1pt solid black"
					  space-before="0.5cm">
				<xsl:apply-templates/>
			</fo:table>

			<xsl:if test="@caption-position = 'both' or @caption-position = 'bottom'">
				<fo:block text-align="center" font-weight="bold" font-size="10pt" space-before="0.5cm"
						  keep-with-previous="always">
					<xsl:call-template name="printTableNumber"/>
				</fo:block>
			</xsl:if>

		</fo:block>

	</xsl:template>

	<xsl:template match="man:coldef">
		<xsl:element name="fo:table-column">
			<xsl:attribute name="column-width">
				<xsl:value-of select="."/>
			</xsl:attribute>
		</xsl:element>
	</xsl:template>

	<xsl:template name="table-content">
		<xsl:choose>
			<xsl:when test="./*">
				<xsl:apply-templates/>
			</xsl:when>
			<xsl:otherwise>
				<fo:table-row>
					<fo:table-cell>
						<fo:block/>
					</fo:table-cell>
				</fo:table-row>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>

	<xsl:template match="man:thead">
		<fo:table-header>
			<xsl:call-template name="table-content"/>
		</fo:table-header>
	</xsl:template>

	<xsl:template match="man:tbody">
		<fo:table-body>
			<xsl:call-template name="table-content"/>
		</fo:table-body>
	</xsl:template>

	<xsl:template match="man:tr">
		<fo:table-row>
			<xsl:apply-templates/>
		</fo:table-row>
	</xsl:template>

	<xsl:template match="man:th">
		<fo:table-cell border-right="1pt solid black" border-bottom="1pt solid black" padding="2pt"
					   background-color="lightgrey">
			<xsl:choose>
				<xsl:when test="@align">
					<xsl:element name="fo:block">
						<xsl:attribute name="font-size">10pt</xsl:attribute>
						<xsl:attribute name="text-align">
							<xsl:value-of select="@align"/>
						</xsl:attribute>
						<xsl:apply-templates/>
					</xsl:element>
				</xsl:when>
				<xsl:otherwise>
					<fo:block font-size="10pt">
						<xsl:apply-templates/>
					</fo:block>
				</xsl:otherwise>
			</xsl:choose>
		</fo:table-cell>
	</xsl:template>

	<xsl:template match="man:td">
		<fo:table-cell border-right="1pt solid black" border-bottom="1pt solid black" padding="2pt">
			<xsl:choose>
				<xsl:when test="@align">
					<xsl:element name="fo:block">
						<xsl:attribute name="font-size">10pt</xsl:attribute>
						<xsl:attribute name="text-align">
							<xsl:value-of select="@align"/>
						</xsl:attribute>
						<xsl:apply-templates/>
					</xsl:element>
				</xsl:when>
				<xsl:otherwise>
					<fo:block font-size="10pt">
						<xsl:apply-templates/>
					</fo:block>
				</xsl:otherwise>
			</xsl:choose>
		</fo:table-cell>
	</xsl:template>

	<xsl:template match="man:listing">
		<xsl:apply-templates select="java:de.tu_darmstadt.rs.IncludeCode.highlight(current(), string(@language))"/>
	</xsl:template>

	<xsl:template match="man:listingHighlighted">
		<xsl:for-each select="child::node()">
			<fo:block font-family="Courier">
				<xsl:if test="(parent::node()/@numbered = 'true')">
					<fo:inline font-size="8pt" font-family="Courier">
						<xsl:number/>
					</fo:inline>
					<fo:leader leader-pattern="space" leader-length="0.5cm"/>
				</xsl:if>
				<xsl:if test=".=''">
					<fo:leader/>
				</xsl:if>
				<xsl:apply-templates/>
			</fo:block>
		</xsl:for-each>
	</xsl:template>

	<xsl:template match="man:tab">
		<fo:leader leader-pattern="space" leader-length="0.75cm"/>
	</xsl:template>

	<xsl:template match="man:regular">
			<xsl:value-of select="text()" />
	</xsl:template>
	<xsl:template match="man:comment">
		<fo:inline color="gray" font-style="italic">
			<xsl:apply-templates/>
		</fo:inline>
	</xsl:template>
	<xsl:template match="man:directive">
		<fo:inline color="maroon">
			<xsl:apply-templates/>
		</fo:inline>
	</xsl:template>
	<xsl:template match="man:string">
		<fo:inline color="blue">
			<xsl:apply-templates/>
		</fo:inline>
	</xsl:template>
	<xsl:template match="man:keyword">
		<fo:inline font-weight="bold" color="#000090">
			<xsl:apply-templates/>
		</fo:inline>
	</xsl:template>
	<xsl:template match="man:includeCode">
		<xsl:apply-templates select="java:de.tu_darmstadt.rs.IncludeCode.includeCode(string(@src), string(@language), string(@removeCommentCount))"/>
	</xsl:template>

	<xsl:template match="man:code">
		<fo:inline font-family="Courier">
			<xsl:text> </xsl:text>
			<xsl:apply-templates/>
			<xsl:text> </xsl:text>
		</fo:inline>
	</xsl:template>

	<xsl:template match="man:strong">
		<fo:inline font-weight="bold">
			<xsl:text> </xsl:text>
			<xsl:apply-templates/>
			<xsl:text> </xsl:text>
		</fo:inline>
	</xsl:template>

	<xsl:template match="man:strong" mode="non-normalized">
		<fo:inline font-weight="bold">
			<xsl:text> </xsl:text>
			<xsl:apply-templates/>
			<xsl:text> </xsl:text>
		</fo:inline>
	</xsl:template>

	<xsl:template match="man:emph">
		<fo:inline font-style="italic">
			<xsl:text> </xsl:text>
			<xsl:apply-templates/>
			<xsl:text> </xsl:text>
		</fo:inline>
	</xsl:template>

	<xsl:template match="man:stri">
		<fo:inline font-weight="bold">
			<xsl:apply-templates mode="non-normalized"/>
		</fo:inline>
	</xsl:template>

	<xsl:template match="man:emi">
		<fo:inline font-style="italic">
			<xsl:apply-templates mode="non-normalized"/>
		</fo:inline>
	</xsl:template>

	<xsl:template match="man:sci">
		<fo:inline font-variant="small-caps">
			<xsl:apply-templates mode="non-normalized"/>
		</fo:inline>
	</xsl:template>

	<xsl:template match="man:sc">
		<fo:inline font-variant="small-caps">
			<xsl:text> </xsl:text>
			<xsl:apply-templates/>
			<xsl:text> </xsl:text>
		</fo:inline>
	</xsl:template>

	<xsl:template match="man:list">
		<fo:list-block space-before="6pt" space-after="12pt">
			<xsl:apply-templates/>
		</fo:list-block>
	</xsl:template>

	<xsl:template match="man:item">
		<xsl:choose>
			<xsl:when test="name(..) = 'descr'">
				<fo:block text-align="justify">
					<xsl:apply-templates/>
				</fo:block>
			</xsl:when>
			<xsl:otherwise>
				<fo:list-item space-before="6pt">
					<fo:list-item-label end-indent="label-end()">
						<xsl:choose>
							<xsl:when test="parent::node()/@type = 'bullet'">
								<fo:block>
									<fo:inline>&#x2022;</fo:inline>
								</fo:block>
							</xsl:when>
							<xsl:when test="parent::node()/@type = 'numbered'">
								<fo:block>
									<xsl:number count="man:item" format="1."/>
								</fo:block>
							</xsl:when>
							<xsl:when test="parent::node()/@type = 'none'">
								<fo:block/>
							</xsl:when>
						</xsl:choose>
					</fo:list-item-label>
					<fo:list-item-body start-indent="body-start()">
						<fo:block text-align="justify">
							<xsl:apply-templates/>
						</fo:block>
					</fo:list-item-body>
				</fo:list-item>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>

	<xsl:template match="man:longitem">
		<xsl:choose>
			<xsl:when test="name(..) = 'descr'">
				<xsl:apply-templates/>
			</xsl:when>
			<xsl:otherwise>
				<fo:list-item space-before="6pt">
					<fo:list-item-label end-indent="label-end()">
						<xsl:choose>
							<xsl:when test="parent::node()/@type = 'bullet'">
								<fo:block>
									<fo:inline>&#x2022;</fo:inline>
								</fo:block>
							</xsl:when>
							<xsl:when test="parent::node()/@type = 'numbered'">
								<fo:block>
									<xsl:number count="man:item" format="1."/>
								</fo:block>
							</xsl:when>
							<xsl:when test="parent::node()/@type = 'none'">
								<fo:block/>
							</xsl:when>
						</xsl:choose>
					</fo:list-item-label>
					<fo:list-item-body start-indent="body-start()">
						<xsl:apply-templates/>
					</fo:list-item-body>
				</fo:list-item>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>

	<xsl:template match="man:descr">
		<fo:list-block provisional-distance-between-starts="35mm" provisional-label-separation="5mm">
			<xsl:call-template name="process.description.content"/>
		</fo:list-block>
	</xsl:template>

	<xsl:template match="man:label">
		<fo:block>
			<xsl:choose>
				<xsl:when test="parent::node()/@type = 'bare'">
					<xsl:apply-templates/>
				</xsl:when>
				<xsl:otherwise>
					<fo:inline font-weight="bold">
						<xsl:apply-templates/>
					</fo:inline>
				</xsl:otherwise>
			</xsl:choose>
		</fo:block>
	</xsl:template>

	<xsl:template name="process.description.content">
		<xsl:param name="labels" select="./empty-list"/>
		<xsl:param name="items" select="./empty-list"/>
		<xsl:param name="do-output"/>
		<xsl:param name="nodes" select="*"/>

		<xsl:choose>
			<xsl:when test="count($nodes) = 0">
				<xsl:if test="count($labels) > 0 or count($items) > 0">
					<fo:list-item>
						<fo:list-item-label end-indent="label-end()">
							<xsl:apply-templates select="$labels"/>
						</fo:list-item-label>
						<fo:list-item-body start-indent="body-start()">
							<xsl:if test="$labels[1]/@long = 'true'">
								<fo:block>
									&#xA0;
								</fo:block>
							</xsl:if>
							<xsl:apply-templates select="$items"/>
						</fo:list-item-body>
					</fo:list-item>
				</xsl:if>
			</xsl:when>

			<xsl:when test="name($nodes[1])=$do-output">
				<fo:list-item space-after="5pt">
					<fo:list-item-label end-indent="label-end()">
						<xsl:apply-templates select="$labels"/>
					</fo:list-item-label>
					<fo:list-item-body start-indent="body-start()">
						<xsl:if test="$labels[1]/@long = 'true'">
							<fo:block>
								&#xA0;
							</fo:block>
						</xsl:if>
						<xsl:apply-templates select="$items"/>
					</fo:list-item-body>
				</fo:list-item>
				<!-- process next node -->
				<xsl:call-template name="process.description.content">
					<xsl:with-param name="nodes" select="$nodes"/>
				</xsl:call-template>
			</xsl:when>

			<xsl:when test="name($nodes[1])='label'">
				<xsl:call-template name="process.description.content">
					<xsl:with-param name="labels" select="$labels|$nodes[1]"/>
					<xsl:with-param name="items" select="$items"/>
					<xsl:with-param name="nodes" select="$nodes[position()>1]"/>
				</xsl:call-template>
			</xsl:when>

			<xsl:when test="name($nodes[1])='item' or name($nodes[1])='longitem'">
				<xsl:call-template name="process.description.content">
					<xsl:with-param name="labels" select="$labels"/>
					<xsl:with-param name="items" select="$items|$nodes[1]"/>
					<xsl:with-param name="do-output">label</xsl:with-param>
					<xsl:with-param name="nodes" select="$nodes[position()>1]"/>
				</xsl:call-template>
			</xsl:when>

			<xsl:otherwise>
				<xsl:message>
					<xsl:text>Bogus description list content: </xsl:text>
					<xsl:value-of select="name($nodes[1])"/>
				</xsl:message>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>

	<xsl:template match="child::text()">
		<xsl:value-of select="normalize-space(.)"/>
	</xsl:template>

	<xsl:template match="child::text()" mode="non-normalized">
		<xsl:value-of select="."/>
	</xsl:template>

</xsl:stylesheet>
