<?xml version="1.0" encoding="ISO-8859-1"?>
<!--

    _______________________________________________________________________________

     Copyright (c) 2012 TU Dresden, Chair for Embedded Systems
     Copyright (c) 2013-2016 TU Darmstadt, Computer Systems Group
     (http://www.rs.tu-darmstadt.de) All rights reserved.

     Redistribution and use in source and binary forms, with or without
     modification, are permitted provided that the following conditions
     are met:

     1. Redistributions of source code must retain the above copyright
        notice, this list of conditions and the following disclaimer.

     2. Redistributions in binary form must reproduce the above copyright
        notice, this list of conditions and the following disclaimer in the
        documentation and/or other materials provided with the distribution.

     3. All advertising materials mentioning features or use of this software
        must display the following acknowledgement: "This product includes
        software developed by the TU Dresden Chair for Embedded Systems, TU Darmstadt Computer Systems Group and
        its contributors."

     4. Neither the name of the TU Dresden Chair for Embedded Systems, TU Darmstadt Computer Systems Group nor the
        names of its contributors may be used to endorse or promote products
        derived from this software without specific prior written permission.

     THIS SOFTWARE IS PROVIDED BY TU DRESDEN CHAIR FOR EMBEDDED SYSTEMS, TU DARMSTADT COMPUTER SYSTEMS GROUP AND
     CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING,
     BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
     FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
     REGENTS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
     SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
     TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
     PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
     LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
     NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
     SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
    _______________________________________________________________________________

-->
<!DOCTYPE stylesheet [
<!ENTITY sp "<xsl:text> </xsl:text>">
<!ENTITY cr "<xsl:text>
</xsl:text>">
]>
<xsl:stylesheet version="1.0"
            xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
            xmlns:fo="http://www.w3.org/1999/XSL/Format"
            xmlns:svg="http://www.w3.org/2000/svg"
            xmlns:man="http://www.rs.tu-darmstadt.de/ns/spartanmc/manual/">

    <xsl:output omit-xml-declaration="yes" method="text" indent="no" />
    <xsl:template match="/">
      <xsl:text>.\"_______________________________________________________________________________
.\"
.\" Copyright (c) 2012 TU Dresden, Chair for Embedded Systems
.\" (http://www.mr.inf.tu-dresden.de) All rights reserved.
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\"
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\"
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.
.\"
.\" 3. All advertising materials mentioning features or use of this software
.\"    must display the following acknowledgement: "This product includes
.\"    software developed by the TU Dresden Chair for Embedded Systems and
.\"    its contributors."
.\"
.\" 4. Neither the name of the TU Dresden Chair for Embedded Systems nor the
.\"    names of its contributors may be used to endorse or promote products
.\"    derived from this software without specific prior written permission.
.\"
.\" THIS SOFTWARE IS PROVIDED BY TU DRESDEN CHAIR FOR EMBEDDED SYSTEMS AND
.\" CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING,
.\" BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
.\" FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
.\" REGENTS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
.\" SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
.\" TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
.\" PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
.\" LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
.\" NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
.\" SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
.\"_______________________________________________________________________________
</xsl:text>
<xsl:apply-templates select="man:manpage" />
    </xsl:template>

    <xsl:template match="man:manpage">
      <xsl:text>.TH </xsl:text><xsl:value-of select="normalize-space(man:name)"/>&sp;<xsl:value-of select="normalize-space(man:man-section)" />&sp;<xsl:value-of select="normalize-space(man:date)" /><xsl:text> "</xsl:text><xsl:value-of select="normalize-space(man:shorttitle)" /><xsl:text>" "</xsl:text><xsl:value-of select="normalize-space(man:title)" /><xsl:text>"</xsl:text>&cr;
      <xsl:apply-templates select="man:*" />
    </xsl:template>

    <xsl:template match="man:section">
      <xsl:text>.SH </xsl:text><xsl:value-of select="normalize-space(child::man:title)" />&cr;
      <xsl:apply-templates select="man:*" />
    </xsl:template>

    <xsl:template match="man:subsection">
      <xsl:text>.SS </xsl:text><xsl:value-of select="normalize-space(child::man:title)" />&cr;
      <xsl:apply-templates select="man:*" />
    </xsl:template>

    <xsl:template match="man:paragraph">
      <xsl:apply-templates />&cr;
      <xsl:text>.sp</xsl:text>&cr;
    </xsl:template>

    <xsl:template match="man:paragraph/text()">
      <xsl:value-of select="normalize-space(.)" />
    </xsl:template>

    <xsl:template match="man:strong">
      <xsl:text> \fB</xsl:text><xsl:apply-templates /><xsl:text>\fP </xsl:text>
    </xsl:template>

    <xsl:template match="man:strong" mode="non-normalized">
      <xsl:text> \fB</xsl:text><xsl:apply-templates /><xsl:text>\fP </xsl:text>
    </xsl:template>

    <xsl:template match="man:emph">
      <xsl:text> \fI</xsl:text><xsl:apply-templates /><xsl:text>\fP </xsl:text>
    </xsl:template>

    <xsl:template match="man:stri">
      <xsl:text>\fB</xsl:text><xsl:apply-templates /><xsl:text>\fP</xsl:text>
    </xsl:template>

    <xsl:template match="man:emi">
      <xsl:text>\fI</xsl:text><xsl:apply-templates /><xsl:text>\fP</xsl:text>
    </xsl:template>

    <xsl:template match="man:listing">
      <xsl:text>.EX</xsl:text>&cr;
      <xsl:for-each select="child::node()">
        <xsl:apply-templates />
      </xsl:for-each>
      <xsl:text>.EE</xsl:text>&cr;
    </xsl:template>

    <xsl:template match="man:codeline" />
    <xsl:template match="man:codeline/text()" >
      <xsl:value-of select="normalize-space(.)" />&cr;
    </xsl:template>

    <xsl:template match="man:descr">
      <xsl:call-template name="process.description.content" />
      <xsl:text>.PP</xsl:text>&cr;
    </xsl:template>

    <xsl:template match="man:label">
      <xsl:apply-templates />&cr;
    </xsl:template>
    <xsl:template match="man:label/text()" >
      <xsl:value-of select="normalize-space(.)" />
    </xsl:template>

    <xsl:template match="man:item">
      <xsl:apply-templates />&cr;
    </xsl:template>
    <xsl:template match="man:item/text()" >
      <xsl:value-of select="normalize-space(.)" />
    </xsl:template>

    <xsl:template match="man:longitem">
      <xsl:apply-templates />
    </xsl:template>
    <xsl:template match="man:longitem/text()" />

    <xsl:template name="process.description.content">
      <xsl:param name="labels" select="./empty-list" />
      <xsl:param name="items" select="./empty-list" />
      <xsl:param name="do-output" />
      <xsl:param name="nodes" select="*" />

      <xsl:choose>
        <xsl:when test="count($nodes) = 0">
          <xsl:if test="count($labels) > 0 or count($items) > 0">
            <xsl:text>.TP</xsl:text>&cr;
            <xsl:apply-templates select="$labels" />
            <xsl:apply-templates select="$items" />
          </xsl:if>
        </xsl:when>

        <xsl:when test="name($nodes[1])=$do-output">
          <xsl:text>.TP</xsl:text>&cr;
          <xsl:apply-templates select="$labels" />
          <xsl:apply-templates select="$items" />
          <!-- process next node -->
          <xsl:call-template name="process.description.content">
            <xsl:with-param name="nodes" select="$nodes" />
          </xsl:call-template>
        </xsl:when>

        <xsl:when test="name($nodes[1])='label'">
          <xsl:call-template name="process.description.content">
            <xsl:with-param name="labels" select="$labels|$nodes[1]" />
            <xsl:with-param name="items" select="$items" />
            <xsl:with-param name="nodes" select="$nodes[position()>1]" />
          </xsl:call-template>
        </xsl:when>

        <xsl:when test="name($nodes[1])='item' or name($nodes[1])='longitem'">
          <xsl:call-template name="process.description.content">
            <xsl:with-param name="labels" select="$labels" />
            <xsl:with-param name="items" select="$items|$nodes[1]" />
            <xsl:with-param name="do-output">label</xsl:with-param>
            <xsl:with-param name="nodes" select="$nodes[position()>1]" />
          </xsl:call-template>
        </xsl:when>

        <xsl:otherwise>
          <xsl:message>
            <xsl:text>Bogus description list content: </xsl:text>
            <xsl:value-of select="name($nodes[1])" />
          </xsl:message>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:template>

    <xsl:template match="man:section/text()" />
    <xsl:template match="man:man-section/text()" />
    <xsl:template match="man:name/text()" />
    <xsl:template match="man:title/text()" />
    <xsl:template match="man:shorttitle/text()" />
    <xsl:template match="man:date/text()" />
</xsl:stylesheet>
