<?xml version="1.0" encoding="ISO-8859-1"?>
<!--

    _______________________________________________________________________________

     Copyright (c) 2012 TU Dresden, Chair for Embedded Systems
     Copyright (c) 2013-2016 TU Darmstadt, Computer Systems Group
     (http://www.rs.tu-darmstadt.de) All rights reserved.

     Redistribution and use in source and binary forms, with or without
     modification, are permitted provided that the following conditions
     are met:

     1. Redistributions of source code must retain the above copyright
        notice, this list of conditions and the following disclaimer.

     2. Redistributions in binary form must reproduce the above copyright
        notice, this list of conditions and the following disclaimer in the
        documentation and/or other materials provided with the distribution.

     3. All advertising materials mentioning features or use of this software
        must display the following acknowledgement: "This product includes
        software developed by the TU Dresden Chair for Embedded Systems, TU Darmstadt Computer Systems Group and
        its contributors."

     4. Neither the name of the TU Dresden Chair for Embedded Systems, TU Darmstadt Computer Systems Group nor the
        names of its contributors may be used to endorse or promote products
        derived from this software without specific prior written permission.

     THIS SOFTWARE IS PROVIDED BY TU DRESDEN CHAIR FOR EMBEDDED SYSTEMS, TU DARMSTADT COMPUTER SYSTEMS GROUP AND
     CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING,
     BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
     FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
     REGENTS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
     SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
     TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
     PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
     LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
     NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
     SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
    _______________________________________________________________________________

-->
<xsl:stylesheet version="1.0" xmlns:man="http://www.rs.tu-darmstadt.de/ns/spartanmc/manual/" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:module="soc-library">
	<xsl:template match="module:module | module:peripheral | module:processor">
		<man:chapter> 
		<man:title><xsl:value-of select="module:header/@label"/><xsl:text> [</xsl:text><xsl:value-of select="module:header/@name"/><xsl:text>]</xsl:text></man:title>
		<man:paragraph>
			<xsl:value-of select="module:header/module:description"/>
		</man:paragraph>
<!--
		<man:section>
			<man:title>Hardware description language information</man:title>
			<xsl:if test="module:hdl">
				<xsl:if test="module:hdl/@lang!=''">
					<man:paragraph>Language used: <xsl:value-of select="module:hdl/@lang"/></man:paragraph>
				</xsl:if>
				<man:paragraph>Hardware name of component: <xsl:value-of select="module:hdl/@toplevel"/></man:paragraph>
				<xsl:if test="module:hdl/module:sources">
					<xsl:if test="module:hdl/module:sources/module:modules!=''">
						<man:paragraph>Hardware description depends on:
						<man:list>
							<man:item><xsl:value-of select="module:hdl/module:sources/module:modules"/></man:item>
						</man:list>
						</man:paragraph>
					</xsl:if>
					<xsl:if test="module:hdl/module:sources/module:files!=''">
						<man:paragraph>Hardware description files:
						<man:list>
							<man:item><xsl:value-of select="module:hdl/module:sources/module:files"/></man:item>
						</man:list>
						</man:paragraph>
					</xsl:if>
					<xsl:if test="module:hdl/module:sources/module:includes!=''">
						<man:paragraph>Included hardware files:
						<man:list>
							<man:item><xsl:value-of select="module:hdl/module:sources/module:includes"/></man:item>
						</man:list>
						</man:paragraph>
					</xsl:if>
				</xsl:if>
			</xsl:if>
		</man:section>
-->
			<xsl:if test="module:parameters/module:parameter">
				<man:section>
					<man:title>Module Parameters</man:title>
					<man:table caption-text="module parameters" caption-position="top">
						<man:coldef>20%</man:coldef>
						<man:coldef>20%</man:coldef>
						<man:coldef>40%</man:coldef>
						<man:coldef>20%</man:coldef>
						<man:thead>
							<man:tr>
								<man:th>Parameter</man:th>
								<man:th>Default value</man:th>
								<man:th>Description</man:th>
								<man:th>Group</man:th>
							</man:tr>
						</man:thead>
						<man:tbody>
							<xsl:for-each select="module:parameters/module:parameter">
								<xsl:call-template name="parameter"/>
							</xsl:for-each>
						</man:tbody>
					</man:table>
				</man:section>
			</xsl:if>
			<xsl:if test="module:ports">
				<man:section>
					<man:title>Module ports</man:title>
					<man:table caption-text="module ports" caption-position="top">
						<man:coldef>20%</man:coldef>
						<man:coldef>20%</man:coldef>
						<man:coldef>10%</man:coldef>
						<man:coldef>40%</man:coldef>
						<man:coldef>10%</man:coldef>
						<man:thead>
							<man:tr>
								<man:th>Name</man:th>
								<man:th>Direction</man:th>
								<man:th>Width</man:th>
								<man:th>Description</man:th>
								<man:th>Group</man:th>
							</man:tr>
						</man:thead>
						<man:tbody>
							<xsl:for-each select="module:ports">
								<xsl:for-each select="module:port">
									<xsl:call-template name="port"/>
								</xsl:for-each>
							</xsl:for-each>
						</man:tbody>
					</man:table>
				</man:section>
			</xsl:if>
<!--
			<man:section>
				<man:title>Interrupts</man:title>
				<man:paragraph>
					
				</man:paragraph>
			</man:section>
-->
			<xsl:if test="module:registers">
				<man:section>
					<man:title>Peripheral registers</man:title>
					<man:subsection>
						<man:title>Register Description</man:title>
						<man:paragraph>The peripheral provides the following 18 bit registers which are mapped to the SpartanMC address space e.g. 0x1A000 + BASE_ADR + Offset.</man:paragraph>
						<xsl:element name="man:table">
							<xsl:attribute name="caption-text"><xsl:value-of select="//module:header/@label"/> registers</xsl:attribute>
							<xsl:attribute name="caption-position">top</xsl:attribute>
							<man:coldef>10%</man:coldef>
							<man:coldef>30%</man:coldef>
							<man:coldef>10%</man:coldef>
							<man:coldef>50%</man:coldef>
							<man:thead>
								<man:tr>
									<man:th>Offset</man:th>
									<man:th>Name</man:th>
									<man:th>Access</man:th>
									<man:th>Description</man:th>
								</man:tr>
							</man:thead>
							<xsl:apply-templates select="module:registers"/>
						</xsl:element>
					</man:subsection>
					<xsl:for-each select="module:registers/module:register">
						<xsl:call-template name="registerLayout"/>
					</xsl:for-each>
				</man:section>
			</xsl:if>
		</man:chapter>
	</xsl:template>
	<xsl:template name="parameter">
		<man:tr>
			<man:td><xsl:value-of select="@name"/></man:td>
			<man:td><xsl:value-of select="@value"/></man:td>
			<man:td>
				<xsl:choose>
					<xsl:when test="@descr">
						<xsl:value-of select="@descr"/>
					</xsl:when>
					<xsl:otherwise>
						<xsl:text>%Insert description here%</xsl:text>
					</xsl:otherwise>
				</xsl:choose>
				<xsl:choose>
					<xsl:when test="module:choice">
						<xsl:text> (the value is one of </xsl:text>
							<man:list type="none">
								<xsl:for-each select="module:choice">
									<man:item><xsl:value-of select="@name"/><xsl:text> for </xsl:text><xsl:value-of select="@descr"/></man:item>
								</xsl:for-each>
							</man:list>
							<xsl:text>)</xsl:text>
					</xsl:when>
					<xsl:when test="module:range">
							<xsl:text> (the value is in the range from </xsl:text><xsl:value-of select="module:range/@min"/><xsl:text> to </xsl:text><xsl:value-of select="module:range/@max"/><xsl:text>)</xsl:text>
					</xsl:when>
					<xsl:otherwise>
						<xsl:text></xsl:text>
					</xsl:otherwise>
				</xsl:choose>
			</man:td>
			<man:td>
				<xsl:if test="../@group">
					<xsl:value-of select="../@group"/>
				</xsl:if>
			</man:td>
		</man:tr>
	</xsl:template>
	<xsl:template name="port">
		<man:tr>
			<man:td><xsl:value-of select="@name"/></man:td>
			<man:td>
				<xsl:choose>
					<xsl:when test="@direction">
						<xsl:value-of select="@direction"/>
					</xsl:when>
					<xsl:when test="../@direction">
						<xsl:value-of select="../@direction"/>
					</xsl:when>
				</xsl:choose>
			</man:td>
			<man:td>
				<xsl:choose>
					<xsl:when test="@width">
						<xsl:value-of select="@width"/>
					</xsl:when>
					<xsl:otherwise>
						<xsl:text>1</xsl:text>
					</xsl:otherwise>
				</xsl:choose>
			</man:td>
			<man:td>
				<xsl:choose>
					<xsl:when test="@descr">
						<xsl:value-of select="@descr"/>
					</xsl:when>
					<xsl:otherwise>
						<xsl:text>%Insert description here%</xsl:text>
					</xsl:otherwise>
				</xsl:choose>
			</man:td>
			<man:td>
				<xsl:if test="../@group">
					<xsl:value-of select="../@group"/>
				</xsl:if>
			</man:td>
		</man:tr>
	</xsl:template>
	<xsl:template match="module:registers">
		<man:tbody>
			<xsl:apply-templates select="module:register"/>
		</man:tbody>
	</xsl:template>
	<xsl:template match="module:register">
		<man:tr>
			<man:td><xsl:value-of select="@offset"/></man:td>
			<man:td><xsl:value-of select="@name"/></man:td>
			<man:td><xsl:value-of select="@access"/></man:td>
			<man:td><xsl:value-of select="module:description"/></man:td>
		</man:tr>
	</xsl:template>
	<xsl:template name="registerLayout">
		<xsl:if test="module:bitgroup">
			<man:subsection>
				<man:title><xsl:value-of select="@name"/> Register</man:title>
				<xsl:element name="man:table">
					<xsl:attribute name="caption-text"><xsl:value-of select="@name"/> register layout</xsl:attribute>
					<xsl:attribute name="caption-position">both</xsl:attribute>
					<man:coldef>6%</man:coldef>
					<man:coldef>20%</man:coldef>
					<man:coldef>10%</man:coldef>
					<man:coldef>9%</man:coldef>
					<man:coldef>55%</man:coldef>
					<man:thead>
						<man:tr>
							<man:th>Bit</man:th>
							<man:th>Name</man:th>
							<man:th>Access</man:th>
							<man:th>Default</man:th>
							<man:th>Description</man:th>
						</man:tr>
					</man:thead>
					<man:tbody>
						<xsl:for-each select="module:bitgroup">
							<xsl:call-template name="bitgroupTable"/>
						</xsl:for-each>
					</man:tbody>
				</xsl:element>
			</man:subsection>
		</xsl:if>
	</xsl:template>
	<xsl:template name="bitgroupTable">
		<man:tr>
			<xsl:choose>
				<xsl:when test="@width&gt;1">
					<man:td><xsl:value-of select="@lsb"/>..<xsl:value-of select="@lsb+@width -1"/></man:td>
				</xsl:when>
				<xsl:otherwise>
					<man:td><xsl:value-of select="@lsb"/></man:td>
				</xsl:otherwise>
			</xsl:choose>
			<man:td><xsl:value-of select="@name"/></man:td>
			<man:td> </man:td>
			<xsl:choose>
				<xsl:when test="@default">
					<man:td><xsl:value-of select="@default"/></man:td>
				</xsl:when>
				<xsl:otherwise>
					<man:td>0</man:td>
				</xsl:otherwise>
			</xsl:choose>
			<xsl:choose>
				<xsl:when test="./module:bitval">
					<man:td><xsl:value-of select="module:description"/> <xsl:text>(the value is one of</xsl:text>
						<man:list type="none">
							<xsl:for-each select="module:bitval">
								<man:item><xsl:value-of select="@value"/><xsl:text> for </xsl:text><xsl:value-of select="@name"/></man:item>
							</xsl:for-each>
						</man:list>
						<xsl:text>)</xsl:text>
					</man:td>
				</xsl:when>
				<xsl:otherwise>
					<man:td><xsl:value-of select="module:description"/></man:td>
				</xsl:otherwise>
			</xsl:choose>
		</man:tr>
	</xsl:template>
</xsl:stylesheet>
