<?xml version="1.0" encoding="ISO-8859-1"?>
<!--

    _______________________________________________________________________________

     Copyright (c) 2012 TU Dresden, Chair for Embedded Systems
     Copyright (c) 2013-2016 TU Darmstadt, Computer Systems Group
     (http://www.rs.tu-darmstadt.de) All rights reserved.

     Redistribution and use in source and binary forms, with or without
     modification, are permitted provided that the following conditions
     are met:

     1. Redistributions of source code must retain the above copyright
        notice, this list of conditions and the following disclaimer.

     2. Redistributions in binary form must reproduce the above copyright
        notice, this list of conditions and the following disclaimer in the
        documentation and/or other materials provided with the distribution.

     3. All advertising materials mentioning features or use of this software
        must display the following acknowledgement: "This product includes
        software developed by the TU Dresden Chair for Embedded Systems, TU Darmstadt Computer Systems Group and
        its contributors."

     4. Neither the name of the TU Dresden Chair for Embedded Systems, TU Darmstadt Computer Systems Group nor the
        names of its contributors may be used to endorse or promote products
        derived from this software without specific prior written permission.

     THIS SOFTWARE IS PROVIDED BY TU DRESDEN CHAIR FOR EMBEDDED SYSTEMS, TU DARMSTADT COMPUTER SYSTEMS GROUP AND
     CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING,
     BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
     FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
     REGENTS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
     SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
     TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
     PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
     LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
     NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
     SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
    _______________________________________________________________________________

-->
<xsl:stylesheet version="1.0" 
            xmlns:xsl="http://www.w3.org/1999/XSL/Transform" 
            xmlns:fo="http://www.w3.org/1999/XSL/Format" 
            xmlns:svg="http://www.w3.org/2000/svg"
            xmlns:man="http://www.rs.tu-darmstadt.de/ns/spartanmc/manual/">

  <xsl:template name="toc">
 
    <fo:page-sequence master-reference="a4" format="i" initial-page-number="1">
   
      <fo:static-content flow-name="xsl-region-before">
	<xsl:call-template name="page_header" />
      </fo:static-content>
    
      <fo:static-content flow-name="xsl-region-after">
	<xsl:call-template name="page_footer" />
      </fo:static-content>
    
      <fo:flow flow-name="xsl-region-body">

	<fo:block font-family="Helvetica" text-align="center" font-weight="bold" font-size="22pt" space-after="2cm">
	  <xsl:text>Table of Contents</xsl:text>
	</fo:block>

	<xsl:apply-templates mode="toc" />

      </fo:flow>
    
    </fo:page-sequence>

  </xsl:template>
  
  <xsl:template match="man:manpage" mode="toc">
    <fo:block font-size="12pt" font-weight="bold" space-before="1.2cm" text-align-last="justify">
      <fo:basic-link internal-destination="{generate-id(.)}" >
        <xsl:call-template name="printManpageTOCEntry" />
        <fo:leader leader-pattern="dots" />
        <xsl:call-template name="printPageNumberCitation" />
      </fo:basic-link>
    </fo:block>
  </xsl:template>

  <xsl:template match="man:chapter" mode="toc">
      <fo:block font-size="12pt" font-weight="bold" space-before="1cm" text-align-last="justify">
        <fo:basic-link internal-destination="{generate-id(.)}">
          <xsl:call-template name="printChapterTOCEntry" />
          <fo:leader leader-pattern="dots" />
          <xsl:call-template name="printPageNumberCitation" />
        </fo:basic-link>
      </fo:block>
      <xsl:apply-templates mode="toc" />
    </xsl:template>

  <xsl:template match="man:section" mode="toc">
    <xsl:if test="parent::man:chapter">
      <fo:block font-size="12pt" font-weight="bold" space-before="12pt" text-align-last="justify">
        <fo:basic-link internal-destination="{generate-id(.)}">
          <xsl:call-template name="printSectionTOCEntry" />
          <fo:leader leader-pattern="dots" />
          <xsl:call-template name="printPageNumberCitation" />
        </fo:basic-link>
      </fo:block>
    </xsl:if>
    <xsl:apply-templates mode="toc" />
  </xsl:template>

  <xsl:template match="man:subsection" mode="toc">
    <xsl:if test="ancestor::man:chapter">
      <fo:block font-size="12pt" space-before="6pt" text-align-last="justify">
        <fo:basic-link internal-destination="{generate-id(.)}">
          <xsl:call-template name="printSubsectionTOCEntry" />
          <fo:leader leader-pattern="dots" />
          <xsl:call-template name="printPageNumberCitation" />
        </fo:basic-link>
      </fo:block>
    </xsl:if>
  </xsl:template>

  <xsl:template match="child::text()" mode="toc" />

</xsl:stylesheet>
