<?xml version="1.0" encoding="ISO-8859-1"?>
<!--

    _______________________________________________________________________________

     Copyright (c) 2012 TU Dresden, Chair for Embedded Systems
     Copyright (c) 2013-2016 TU Darmstadt, Computer Systems Group
     (http://www.rs.tu-darmstadt.de) All rights reserved.

     Redistribution and use in source and binary forms, with or without
     modification, are permitted provided that the following conditions
     are met:

     1. Redistributions of source code must retain the above copyright
        notice, this list of conditions and the following disclaimer.

     2. Redistributions in binary form must reproduce the above copyright
        notice, this list of conditions and the following disclaimer in the
        documentation and/or other materials provided with the distribution.

     3. All advertising materials mentioning features or use of this software
        must display the following acknowledgement: "This product includes
        software developed by the TU Dresden Chair for Embedded Systems, TU Darmstadt Computer Systems Group and
        its contributors."

     4. Neither the name of the TU Dresden Chair for Embedded Systems, TU Darmstadt Computer Systems Group nor the
        names of its contributors may be used to endorse or promote products
        derived from this software without specific prior written permission.

     THIS SOFTWARE IS PROVIDED BY TU DRESDEN CHAIR FOR EMBEDDED SYSTEMS, TU DARMSTADT COMPUTER SYSTEMS GROUP AND
     CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING,
     BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
     FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
     REGENTS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
     SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
     TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
     PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
     LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
     NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
     SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
    _______________________________________________________________________________

-->
<xsl:stylesheet version="2.0" xmlns="soc-library" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:xi="http://www.w3.org/2001/XInclude" exclude-result-prefixes="#all">
	<xsl:namespace-alias result-prefix="soc" stylesheet-prefix="#default" />
	<xsl:variable name="ns-uri" select="string(@targetNamespace)"/>
	<xsl:param name="modules"/>
	<xsl:param name="files"/>
	<xsl:param name="includes"/>
	<xsl:template match="/">
		<xsl:apply-templates select="/*[local-name()='module' and (namespace-uri()='soc-library' or namespace-uri()='http://www.rs.tu-darmstadt.de/spartanmc/module')]"/>
	</xsl:template>
	<xsl:template match="/*[local-name()='module' and (namespace-uri()='soc-library' or namespace-uri()='http://www.rs.tu-darmstadt.de/spartanmc/module')]">
		<xsl:call-template name="writeTypedModule"/>
	</xsl:template>
	<xsl:template name="writeTypedModule">
		<xsl:choose>
			<xsl:when test="@type='peripheral'">
				<xsl:call-template name="writePeripheral"/>
			</xsl:when>
			<xsl:when test="@type='gluelogic'">
				<xsl:call-template name="writeGlueLogic"/>
			</xsl:when>
			<xsl:when test="@type='processor'">
				<xsl:call-template name="writeProcessor"/>
			</xsl:when>
			<xsl:otherwise>
				<xsl:message>Cannot determine the type represented by this file!</xsl:message>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
	<xsl:template name="writePeripheral">
		<xsl:element name="peripheral">
			<xsl:attribute name="document-type">
				<xsl:choose>
					<xsl:when test="/*[local-name()='module' and (namespace-uri()='soc-library' or namespace-uri()='http://www.rs.tu-darmstadt.de/spartanmc/module')]/*[local-name()='interface' and (namespace-uri()='soc-library' or namespace-uri()='http://www.rs.tu-darmstadt.de/spartanmc/module')]/*[local-name()='memory' and (namespace-uri()='soc-library' or namespace-uri()='http://www.rs.tu-darmstadt.de/spartanmc/module')]">soc-dmadevice-1.0</xsl:when>
					<xsl:otherwise>soc-peripheral-1.0</xsl:otherwise>
				</xsl:choose>
			</xsl:attribute>
			<xsl:call-template name="writeHeader"/>
			<xsl:call-template name="writeHDL"/>
			<xsl:call-template name="writeParameters"/>
			<xsl:call-template name="writePorts"/>
			<xsl:choose>
				<xsl:when test="/*[local-name()='module' and (namespace-uri()='soc-library' or namespace-uri()='http://www.rs.tu-darmstadt.de/spartanmc/module')]/*[local-name()='interface' and (namespace-uri()='soc-library' or namespace-uri()='http://www.rs.tu-darmstadt.de/spartanmc/module')]/*[local-name()='memory' and (namespace-uri()='soc-library' or namespace-uri()='http://www.rs.tu-darmstadt.de/spartanmc/module')]"><xi:include href="../defaults/dma.xml"/><xi:include href="../defaults/peripheral.xml"/></xsl:when>
				<xsl:otherwise><xi:include href="../defaults/peripheral.xml"/></xsl:otherwise>
			</xsl:choose>
			<xsl:call-template name="writeRegisters"/>
			<xsl:if test="/*[local-name()='module' and (namespace-uri()='soc-library' or namespace-uri()='http://www.rs.tu-darmstadt.de/spartanmc/module')]/*[local-name()='interface' and (namespace-uri()='soc-library' or namespace-uri()='http://www.rs.tu-darmstadt.de/spartanmc/module')]/*[local-name()='memory' and (namespace-uri()='soc-library' or namespace-uri()='http://www.rs.tu-darmstadt.de/spartanmc/module')]">
				<xsl:call-template name="writeMemory"/>
			</xsl:if>
		</xsl:element>
	</xsl:template>
	<xsl:template name="writeGlueLogic">
		<xsl:element name="module">
			<xsl:attribute name="document-type">soc-module-1.0</xsl:attribute>
			<xsl:call-template name="writeHeader"/>
			<xsl:call-template name="writeHDL"/>
			<xsl:call-template name="writeParameters"/>
			<xsl:call-template name="writePorts"/>
		</xsl:element>
	</xsl:template>
	<xsl:template name="writeProcessor">
		<xsl:element name="processor">
			<xsl:attribute name="document-type">soc-processor-1.0</xsl:attribute>
			<xsl:call-template name="writeHeader"/>
			<xsl:call-template name="writeHDL"/>
			<xsl:call-template name="writeParameters"/>
			<xsl:call-template name="writePorts"/>
			<xsl:if test="/*[local-name()='module' and (namespace-uri()='soc-library' or namespace-uri()='http://www.rs.tu-darmstadt.de/spartanmc/module')]/*[local-name()='interface' and (namespace-uri()='soc-library' or namespace-uri()='http://www.rs.tu-darmstadt.de/spartanmc/module')]/*[local-name()='memory' and (namespace-uri()='soc-library' or namespace-uri()='http://www.rs.tu-darmstadt.de/spartanmc/module')]">
				<xsl:call-template name="writeMemory"/>
			</xsl:if>
		</xsl:element>
	</xsl:template>
	<xsl:template name="writeHeader">
		<xsl:element name="header">
			<xsl:attribute name="name"><xsl:value-of select="@name"/></xsl:attribute>
			<xsl:attribute name="label"><xsl:value-of select="@text"/></xsl:attribute>
			<xsl:attribute name="category"><xsl:value-of select="@category"/></xsl:attribute>
			<xsl:element name="description"><xsl:value-of select="normalize-space(*[local-name()='description' and (namespace-uri()='soc-library' or namespace-uri()='http://www.rs.tu-darmstadt.de/spartanmc/module')]/text())"/></xsl:element>
		</xsl:element>
	</xsl:template>
	<xsl:template name="writeHDL">
		<xsl:element name="hdl">
			<xsl:attribute name="lang">verilog</xsl:attribute>
			<xsl:attribute name="toplevel"><xsl:value-of select="*[local-name()='interface' and (namespace-uri()='soc-library' or namespace-uri()='http://www.rs.tu-darmstadt.de/spartanmc/module')]/@toplevel"/></xsl:attribute>
			<xsl:element name="sources">
				<xsl:attribute name="toolchain">xilinx</xsl:attribute>
					<xsl:element name="modules">
						<xsl:call-template name="split">
							<xsl:with-param name="text" select="$modules"/>
						</xsl:call-template>
					</xsl:element>
					<xsl:element name="files">
						<xsl:call-template name="split">
							<xsl:with-param name="text" select="$files"/>
						</xsl:call-template>
					</xsl:element>
					<xsl:element name="includes">
						<xsl:call-template name="split">
							<xsl:with-param name="text" select="$includes"/>
						</xsl:call-template>
					</xsl:element>
			</xsl:element>
		</xsl:element>
	</xsl:template>
	<xsl:template name="writeRegisters">
		<xsl:if test="count(*[local-name()='registers' and (namespace-uri()='soc-library' or namespace-uri()='http://www.rs.tu-darmstadt.de/spartanmc/module')]/*[local-name()='register' and (namespace-uri()='soc-library' or namespace-uri()='http://www.rs.tu-darmstadt.de/spartanmc/module')])>0 or *[local-name()='interface' and (namespace-uri()='soc-library' or namespace-uri()='http://www.rs.tu-darmstadt.de/spartanmc/module')]/@registers>0">
			<xsl:element name="registers">
				<xsl:for-each select="*[local-name()='registers' and (namespace-uri()='soc-library' or namespace-uri()='http://www.rs.tu-darmstadt.de/spartanmc/module')]/*[local-name()='register' and (namespace-uri()='soc-library' or namespace-uri()='http://www.rs.tu-darmstadt.de/spartanmc/module')]">
					<xsl:element name="register">
						<xsl:attribute name="name"><xsl:value-of select="@name"/></xsl:attribute>
						<xsl:attribute name="offset"><xsl:value-of select="@offset"/></xsl:attribute>
						<xsl:attribute name="access"><xsl:value-of select="@access"/></xsl:attribute>
						<xsl:choose>
							<xsl:when test="*[local-name()='description' and (namespace-uri()='soc-library' or namespace-uri()='http://www.rs.tu-darmstadt.de/spartanmc/module')]">
								<xsl:element name="description"><xsl:copy-of select="normalize-space(*[local-name()='description' and (namespace-uri()='soc-library' or namespace-uri()='http://www.rs.tu-darmstadt.de/spartanmc/module')]/text())"/></xsl:element>
							</xsl:when>
							<xsl:otherwise>
								<xsl:element name="description">%Insert a register description here%</xsl:element>
							</xsl:otherwise>
						</xsl:choose>
						<xsl:for-each select="*[local-name()='bitgroup' and (namespace-uri()='soc-library' or namespace-uri()='http://www.rs.tu-darmstadt.de/spartanmc/module')]">
							<xsl:element name="bitgroup">
								<xsl:attribute name="name"><xsl:value-of select="./@name"/></xsl:attribute>
								<xsl:attribute name="lsb"><xsl:value-of select="@lsb"/></xsl:attribute>
								<xsl:attribute name="width"><xsl:value-of select="@width"/></xsl:attribute>
								<xsl:choose>
									<xsl:when test="*[local-name()='description' and (namespace-uri()='soc-library' or namespace-uri()='http://www.rs.tu-darmstadt.de/spartanmc/module')]">
										<xsl:element name="description"><xsl:copy-of select="normalize-space(*[local-name()='description' and (namespace-uri()='soc-library' or namespace-uri()='http://www.rs.tu-darmstadt.de/spartanmc/module')]/text())"/></xsl:element>
									</xsl:when>
									<xsl:otherwise>
										<xsl:element name="description">%Insert a description for the bit group here%</xsl:element>
									</xsl:otherwise>
								</xsl:choose>
								<xsl:for-each select="*[local-name()='bitvalue' and (namespace-uri()='soc-library' or namespace-uri()='http://www.rs.tu-darmstadt.de/spartanmc/module')]">
									<xsl:element name="bitval">
										<xsl:attribute name="name"><xsl:value-of select="@name"/></xsl:attribute>
										<xsl:attribute name="value">
											<xsl:text>0x</xsl:text>
											<xsl:call-template name="convertDecimalToHex">
												<xsl:with-param name="decimalValue" select="@value"/>
											</xsl:call-template>
										</xsl:attribute>
										<xsl:attribute name="descr">%Insert a description for the bit group value here%</xsl:attribute>
									</xsl:element>
								</xsl:for-each>
							</xsl:element>
						</xsl:for-each>
					</xsl:element>
				</xsl:for-each>
				<xsl:call-template name="createRegisters">
					<xsl:with-param name="counter" select="count(*[local-name()='registers' and (namespace-uri()='soc-library' or namespace-uri()='http://www.rs.tu-darmstadt.de/spartanmc/module')]/*[local-name()='register' and (namespace-uri()='soc-library' or namespace-uri()='http://www.rs.tu-darmstadt.de/spartanmc/module')])"/>
					<xsl:with-param name="maxCounter" select="/*[local-name()='module' and (namespace-uri()='soc-library' or namespace-uri()='http://www.rs.tu-darmstadt.de/spartanmc/module')]/*[local-name()='interface' and (namespace-uri()='soc-library' or namespace-uri()='http://www.rs.tu-darmstadt.de/spartanmc/module')]/@registers"/>
				</xsl:call-template>
			</xsl:element>
		</xsl:if>
	</xsl:template>
	<xsl:template name="writePorts">
		<xsl:for-each select="*[local-name()='ports' and (namespace-uri()='soc-library' or namespace-uri()='http://www.rs.tu-darmstadt.de/spartanmc/module')]">
			<xsl:element name="ports">
				<xsl:if test="@direction">
					<xsl:attribute name="direction"><xsl:value-of select="@direction"/></xsl:attribute>
				</xsl:if>
				<xsl:if test="@group">
					<xsl:attribute name="group"><xsl:value-of select="@group"/></xsl:attribute>
				</xsl:if>
				<xsl:for-each select="*[local-name()='port' and (namespace-uri()='soc-library' or namespace-uri()='http://www.rs.tu-darmstadt.de/spartanmc/module')]">
					<xsl:element name="port">
						<xsl:attribute name="name"><xsl:value-of select="@name"/></xsl:attribute>
						<xsl:if test="@width">
							<xsl:attribute name="width"><xsl:value-of select="@width"/></xsl:attribute>
						</xsl:if>
						<xsl:attribute name="descr">%Insert port description here%</xsl:attribute>
						<xsl:if test="@direction">
							<xsl:attribute name="direction"><xsl:value-of select="@direction"/></xsl:attribute>
						</xsl:if>
					</xsl:element>
				</xsl:for-each>
			</xsl:element>
		</xsl:for-each>
	</xsl:template>
	<xsl:template name="writeParameters">
		<xsl:for-each select="*[local-name()='parameters' and (namespace-uri()='soc-library' or namespace-uri()='http://www.rs.tu-darmstadt.de/spartanmc/module')]">
			<xsl:if test="count(./*[local-name()='parameter' and (namespace-uri()='soc-library' or namespace-uri()='http://www.rs.tu-darmstadt.de/spartanmc/module')])!=0">
			<xsl:element name="parameters">
				<xsl:if test="@group">
					<xsl:attribute name="group"><xsl:value-of select="@group"/></xsl:attribute>
				</xsl:if>
				<xsl:for-each select="*[local-name()='parameter' and (namespace-uri()='soc-library' or namespace-uri()='http://www.rs.tu-darmstadt.de/spartanmc/module')]">
					<xsl:element name="parameter">
						<xsl:attribute name="name"><xsl:value-of select="@name"/></xsl:attribute>
						<xsl:attribute name="type"><xsl:value-of select="@type"/></xsl:attribute>
						<xsl:attribute name="value"><xsl:value-of select="@value"/></xsl:attribute>
						<xsl:element name="description">%Insert a parameter description here%</xsl:element>
						<xsl:if test="*[local-name()='range' and (namespace-uri()='soc-library' or namespace-uri()='http://www.rs.tu-darmstadt.de/spartanmc/module')]">
							<xsl:element name="range">
								<xsl:attribute name="min"><xsl:value-of select="*[local-name()='range' and (namespace-uri()='soc-library' or namespace-uri()='http://www.rs.tu-darmstadt.de/spartanmc/module')]/@min"/></xsl:attribute>
								<xsl:attribute name="max"><xsl:value-of select="*[local-name()='range' and (namespace-uri()='soc-library' or namespace-uri()='http://www.rs.tu-darmstadt.de/spartanmc/module')]/@max"/></xsl:attribute>
							</xsl:element>
						</xsl:if>
						<xsl:for-each select="*[local-name()='choice' and (namespace-uri()='soc-library' or namespace-uri()='http://www.rs.tu-darmstadt.de/spartanmc/module')]">
							<xsl:element name="choice">
								<xsl:attribute name="value"><xsl:value-of select="@value"/></xsl:attribute>
								<xsl:attribute name="descr">%Insert a description for the choices here%</xsl:attribute>
								<xsl:for-each select="*[local-name()='preset' and (namespace-uri()='soc-library' or namespace-uri()='http://www.rs.tu-darmstadt.de/spartanmc/module')]">
									<xsl:element name="preset">
										<xsl:attribute name="param"><xsl:value-of select="@param"/></xsl:attribute>
										<xsl:attribute name="value"><xsl:value-of select="@value"/></xsl:attribute>
									</xsl:element>
								</xsl:for-each>
							</xsl:element>
						</xsl:for-each>
					</xsl:element>
				</xsl:for-each>
			</xsl:element>
			</xsl:if>
		</xsl:for-each>
	</xsl:template>
	<xsl:template name="writeMemory">
		<xsl:element name="memory">
			<xsl:attribute name="size"><xsl:value-of select="/*[local-name()='module' and (namespace-uri()='soc-library' or namespace-uri()='http://www.rs.tu-darmstadt.de/spartanmc/module')]/*[local-name()='interface' and (namespace-uri()='soc-library' or namespace-uri()='http://www.rs.tu-darmstadt.de/spartanmc/module')]/*[local-name()='memory' and (namespace-uri()='soc-library' or namespace-uri()='http://www.rs.tu-darmstadt.de/spartanmc/module')]/@size"/></xsl:attribute>
			<xsl:attribute name="instance"><xsl:value-of select="/*[local-name()='module' and (namespace-uri()='soc-library' or namespace-uri()='http://www.rs.tu-darmstadt.de/spartanmc/module')]/*[local-name()='interface' and (namespace-uri()='soc-library' or namespace-uri()='http://www.rs.tu-darmstadt.de/spartanmc/module')]/*[local-name()='memory' and (namespace-uri()='soc-library' or namespace-uri()='http://www.rs.tu-darmstadt.de/spartanmc/module')]/@instance"/></xsl:attribute>
			<xsl:if test="/*[local-name()='module' and (namespace-uri()='soc-library' or namespace-uri()='http://www.rs.tu-darmstadt.de/spartanmc/module')]/*[local-name()='interface' and (namespace-uri()='soc-library' or namespace-uri()='http://www.rs.tu-darmstadt.de/spartanmc/module')]/*[local-name()='memory' and (namespace-uri()='soc-library' or namespace-uri()='http://www.rs.tu-darmstadt.de/spartanmc/module')]/@bitlanes">
				<xsl:attribute name="bitlanes"><xsl:value-of select="/*[local-name()='module' and (namespace-uri()='soc-library' or namespace-uri()='http://www.rs.tu-darmstadt.de/spartanmc/module')]/*[local-name()='interface' and (namespace-uri()='soc-library' or namespace-uri()='http://www.rs.tu-darmstadt.de/spartanmc/module')]/*[local-name()='memory' and (namespace-uri()='soc-library' or namespace-uri()='http://www.rs.tu-darmstadt.de/spartanmc/module')]/@bitlanes"/></xsl:attribute>
			</xsl:if>
		</xsl:element>
	</xsl:template>
	<xsl:template name="split">
		<xsl:param name="text" select="."/>
		<xsl:param name="separator" select="','"/>
		<xsl:choose>
			<xsl:when test="contains($text, $separator)">
				<xsl:value-of select="substring-before($text, $separator)"/><xsl:text>
</xsl:text>
				<xsl:call-template name="split">
					<xsl:with-param name="text" select="substring-after($text, $separator)"/>
				</xsl:call-template>
			</xsl:when>
			<xsl:otherwise>
				<xsl:value-of select="$text"/>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
	<xsl:template name="convertDecimalToHex">
		<xsl:param name="decimalValue"/>
		<xsl:if test="$decimalValue &gt;= 16">
			<xsl:call-template name="convertDecimalToHex">
				<xsl:with-param name="decimalValue" select="floor($decimalValue div 16)"/>
			</xsl:call-template>
		</xsl:if>
		<xsl:value-of select="substring('0123456789ABCDEF', ($decimalValue mod 16)+1, 1)"/>
	</xsl:template>
	<xsl:template name="createRegisters">
		<xsl:param name="counter"/>
		<xsl:param name="maxCounter"/>
		<xsl:if test="$counter &lt; $maxCounter">
			<xsl:element name="register">
				<xsl:attribute name="name"><xsl:value-of select="concat('reg', $counter)"/></xsl:attribute>
				<xsl:attribute name="offset"><xsl:value-of select="$counter"/></xsl:attribute>
				<xsl:element name="description">%Insert a register description here%</xsl:element>
				<xsl:call-template name="createBitgroupWithBitValues"/>
			</xsl:element>
			<xsl:call-template name="createRegisters">
				<xsl:with-param name="counter" select="$counter+1"/>
				<xsl:with-param name="maxCounter" select="$maxCounter"/>
			</xsl:call-template>
		</xsl:if>
	</xsl:template>
	<xsl:template name="createBitgroupWithBitValues">
		<xsl:element name="bitgroup">
			<xsl:attribute name="name">REG_VALUE</xsl:attribute>
			<xsl:attribute name="lsb">0</xsl:attribute>
			<xsl:attribute name="width">18</xsl:attribute>
			<xsl:element name="description">%Insert a description for the bit group here%</xsl:element>
			<xsl:element name="bitval">
				<xsl:attribute name="name">VALUE_NAME</xsl:attribute>
				<xsl:attribute name="value">0x0</xsl:attribute>
				<xsl:attribute name="descr">%Insert a description for the bit group value here%</xsl:attribute>
			</xsl:element>
		</xsl:element>
	</xsl:template>
</xsl:stylesheet>
