/**
 * _______________________________________________________________________________
 *
 *  Copyright (c) 2012 TU Dresden, Chair for Embedded Systems
 *  Copyright (c) 2013-2016 TU Darmstadt, Computer Systems Group
 *  (http://www.rs.tu-darmstadt.de) All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions
 *  are met:
 *
 *  1. Redistributions of source code must retain the above copyright
 *     notice, this list of conditions and the following disclaimer.
 *
 *  2. Redistributions in binary form must reproduce the above copyright
 *     notice, this list of conditions and the following disclaimer in the
 *     documentation and/or other materials provided with the distribution.
 *
 *  3. All advertising materials mentioning features or use of this software
 *     must display the following acknowledgement: "This product includes
 *     software developed by the TU Dresden Chair for Embedded Systems, TU Darmstadt Computer Systems Group and
 *     its contributors."
 *
 *  4. Neither the name of the TU Dresden Chair for Embedded Systems, TU Darmstadt Computer Systems Group nor the
 *     names of its contributors may be used to endorse or promote products
 *     derived from this software without specific prior written permission.
 *
 *  THIS SOFTWARE IS PROVIDED BY TU DRESDEN CHAIR FOR EMBEDDED SYSTEMS, TU DARMSTADT COMPUTER SYSTEMS GROUP AND
 *  CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING,
 *  BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
 *  FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 *  REGENTS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 *  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
 *  TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 *  PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 *  LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 *  NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 *  SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * _______________________________________________________________________________
 */


package de.tu_darmstadt.rs.spartanmc.jconfig.ui.components.chrome;

import java.awt.Component;
import java.awt.Graphics;
import java.awt.Image;
import java.net.URL;
import javax.swing.Icon;
import javax.swing.ImageIcon;

/**
 *
 */
@Deprecated
public class OverlayIcon extends ImageIcon {

	public static final int BOTTOM_RIGHT = 0;
	public static final int BOTTOM_LEFT = 1;

	private Icon[] fOverlayIcon = new Icon[2];
	private int[] fOffsetX = new int[2];
	private int[] fOffsetY = new int[2];

	/**
	 *
	 */
	public OverlayIcon(URL location) {
		super(location);
	}

	/**
	 *
	 */
	public OverlayIcon(Image image) {
		super(image);
	}

	/**
	 *
	 */
	public OverlayIcon(ImageIcon icon) {
		super(icon.getImage());
	}

	/**
	 *
	 */
	public void setOverlayImage(Icon icon, int position) {
		fOverlayIcon[position] = icon;
		if (icon != null) {
			if (position == BOTTOM_RIGHT) {
				fOffsetX[position] = getIconWidth() - icon.getIconWidth();
			} else {
				fOffsetX[position] = 0;
			}
			fOffsetY[position] = getIconHeight() - icon.getIconHeight();
		}
	}

	/**
	 *
	 */
	@Override
	public void paintIcon(final Component c, final Graphics g, final int x, final int y) {
		super.paintIcon(c, g, x, y);
		for (int i = 0; i < 2; i++) {
			if (fOverlayIcon[i] != null) {
				fOverlayIcon[i].paintIcon(c, g, x + fOffsetX[i], y + fOffsetY[i]);
			}
		}
	}

}
