/*
 * _______________________________________________________________________________
 *
 *  Copyright (c) 2012 TU Dresden, Chair for Embedded Systems
 *  Copyright (c) 2013-2016 TU Darmstadt, Computer Systems Group
 *  (http://www.rs.tu-darmstadt.de) All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions
 *  are met:
 *
 *  1. Redistributions of source code must retain the above copyright
 *     notice, this list of conditions and the following disclaimer.
 *
 *  2. Redistributions in binary form must reproduce the above copyright
 *     notice, this list of conditions and the following disclaimer in the
 *     documentation and/or other materials provided with the distribution.
 *
 *  3. All advertising materials mentioning features or use of this software
 *     must display the following acknowledgement: "This product includes
 *     software developed by the TU Dresden Chair for Embedded Systems, TU Darmstadt Computer Systems Group and
 *     its contributors."
 *
 *  4. Neither the name of the TU Dresden Chair for Embedded Systems, TU Darmstadt Computer Systems Group nor the
 *     names of its contributors may be used to endorse or promote products
 *     derived from this software without specific prior written permission.
 *
 *  THIS SOFTWARE IS PROVIDED BY TU DRESDEN CHAIR FOR EMBEDDED SYSTEMS, TU DARMSTADT COMPUTER SYSTEMS GROUP AND
 *  CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING,
 *  BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
 *  FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 *  REGENTS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 *  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
 *  TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 *  PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 *  LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 *  NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 *  SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * _______________________________________________________________________________
 */

package de.tu_darmstadt.rs.spartanmc.jconfig.testing

import de.tu_darmstadt.rs.spartanmc.devxml.Library
import de.tu_darmstadt.rs.spartanmc.jconfig.ILibJConfigProject
import de.tu_darmstadt.rs.spartanmc.jconfig.TestingProjectProvider
import de.tu_darmstadt.rs.spartanmc.jconfig.api.IConfigurationDocument
import org.junit.Rule
import org.junit.rules.TemporaryFolder
import spock.lang.Ignore
import spock.lang.Specification
/**
 * Created by Ramon on 31.05.2016.
 */
@Ignore
class BaseLibJConfigSpec extends Specification {

	static {
		System.setProperty("org.slf4j.simpleLogger.logFile", "System.out")
		System.setProperty("org.slf4j.simpleLogger.defaultLogLevel", "info")
	}

	public static String CORE = "spartanmc"
	public static String PORT_IN = "port_in"
	public static String PORT_OUT = "port_out"
	public static String TEST_MOD = "test_mod"
	public static String SYSCLK = "clk_xilinx"
	public static String TEST_MEM = "test_mem"
	public static String TEST_DYN = "test_dyn"
	public static String UART = "uart_light"
	public static String SPI = "spi_master"
	public static String USB = "usb11"
	public static String CAN = "can"
	public static String LOCAL_MEM = "spartanmc_mem_local"
	public static String GLOBAL_MEM = "spartanmc_mem_data_global"
	public static String TARGET_CONF = "SP601"

	ILibJConfigProject project

	Library lib;

	@Rule
	TemporaryFolder temporaryFolder = new TemporaryFolder();

	IConfigurationDocument document;

	def setup() {
		project = TestingProjectProvider.getInstance().newProject(temporaryFolder.newFolder().toPath())

		lib = project.application.library
		document = project.documentHandler.newDocument(TARGET_CONF)
	}
}
