/*
 * _______________________________________________________________________________
 *
 *  Copyright (c) 2012 TU Dresden, Chair for Embedded Systems
 *  Copyright (c) 2013-2016 TU Darmstadt, Computer Systems Group
 *  (http://www.rs.tu-darmstadt.de) All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions
 *  are met:
 *
 *  1. Redistributions of source code must retain the above copyright
 *     notice, this list of conditions and the following disclaimer.
 *
 *  2. Redistributions in binary form must reproduce the above copyright
 *     notice, this list of conditions and the following disclaimer in the
 *     documentation and/or other materials provided with the distribution.
 *
 *  3. All advertising materials mentioning features or use of this software
 *     must display the following acknowledgement: "This product includes
 *     software developed by the TU Dresden Chair for Embedded Systems, TU Darmstadt Computer Systems Group and
 *     its contributors."
 *
 *  4. Neither the name of the TU Dresden Chair for Embedded Systems, TU Darmstadt Computer Systems Group nor the
 *     names of its contributors may be used to endorse or promote products
 *     derived from this software without specific prior written permission.
 *
 *  THIS SOFTWARE IS PROVIDED BY TU DRESDEN CHAIR FOR EMBEDDED SYSTEMS, TU DARMSTADT COMPUTER SYSTEMS GROUP AND
 *  CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING,
 *  BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
 *  FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 *  REGENTS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 *  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
 *  TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 *  PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 *  LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 *  NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 *  SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * _______________________________________________________________________________
 */

import edu.byu.ece.rapidSmith.design.Design;

import java.io.IOException;
import java.nio.file.Paths;

/**
 * Testing: Modify partitions
 * Created by jakobw on 26.10.15.
 */
public class ModifyPartition {

	public ModifyPartition() {

	}

	public static void main(String[] args) throws IOException {
		changeLut("test_map_prev_mapped");
		changeLut("test_prev_routed");
	}

	private static void changeLut(String filename) throws IOException {
		String fnIn = "test/test1/import/orig/" + filename + ".xdl";
		String fnOut = "test/test1/import/" + filename + ".xdl";

		Design design = new Design();
		design.loadXDLFile(Paths.get(fnIn));


		/* design.getInstances().stream()
				.filter(i -> i.getName().startsWith("a_inst"))
                .forEach(i -> {
                    System.out.println(i.getName());
                    i.getAttributes().stream()
                            //LUTs that are not off
                            .filter(a -> a.getPhysicalName().contains("LUT") && !a.getValue().equals("#OFF"))
                            .forEach(a -> {
                                System.out.print(a + " -> ");
                                a.setValue(a.getValue().replace('+', '*'));
                                System.out.println(a);
                            });
                });*/

		design.fixSp6IOBs();
		design.saveXDLFile(Paths.get(fnOut));
	}
}
