/*
 * _______________________________________________________________________________
 *
 *  Copyright (c) 2012 TU Dresden, Chair for Embedded Systems
 *  Copyright (c) 2013-2016 TU Darmstadt, Computer Systems Group
 *  (http://www.rs.tu-darmstadt.de) All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions
 *  are met:
 *
 *  1. Redistributions of source code must retain the above copyright
 *     notice, this list of conditions and the following disclaimer.
 *
 *  2. Redistributions in binary form must reproduce the above copyright
 *     notice, this list of conditions and the following disclaimer in the
 *     documentation and/or other materials provided with the distribution.
 *
 *  3. All advertising materials mentioning features or use of this software
 *     must display the following acknowledgement: "This product includes
 *     software developed by the TU Dresden Chair for Embedded Systems, TU Darmstadt Computer Systems Group and
 *     its contributors."
 *
 *  4. Neither the name of the TU Dresden Chair for Embedded Systems, TU Darmstadt Computer Systems Group nor the
 *     names of its contributors may be used to endorse or promote products
 *     derived from this software without specific prior written permission.
 *
 *  THIS SOFTWARE IS PROVIDED BY TU DRESDEN CHAIR FOR EMBEDDED SYSTEMS, TU DARMSTADT COMPUTER SYSTEMS GROUP AND
 *  CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING,
 *  BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
 *  FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 *  REGENTS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 *  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
 *  TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 *  PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 *  LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 *  NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 *  SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * _______________________________________________________________________________
 */

import edu.byu.ece.rapidSmith.design.Design;
import edu.byu.ece.rapidSmith.design.Pin;
import edu.byu.ece.rapidSmith.device.PrimitiveType;
import edu.byu.ece.rapidSmith.primitiveDefs.PrimitiveDefList;
import edu.byu.ece.rapidSmith.timing.DotDumper;
import edu.byu.ece.rapidSmith.util.DeviceDatabaseProvider;

import java.io.FileNotFoundException;
import java.nio.file.Paths;

/**
 * Testing...
 *
 * Created by wenzel on 13.10.16.
 */
@SuppressWarnings("checkstyle:SystemOut")
public class TempTestClockFromData {

	public TempTestClockFromData() {
	}

	/**
	 * Main
	 * @param args Arguments
	 */
	public static void main(String[] args) {
		//		Design design = new Design("dresden/spmc-prj-ss17/hw-tests/test1/sp601/build/spartanmc_par.xdl");
		Design design = new Design(Paths.get("temp/test/top.xdl"));

		PrimitiveDefList primitiveDefs = DeviceDatabaseProvider.getDeviceDatabase().loadPrimitiveDefs(design.getFamilyType());
		design.getInstances().stream()
				.filter(i -> i.getType() == PrimitiveType.BUFG)
				.flatMap(i -> i.getPins().stream()).map(Pin::getNet)
				.forEach(net -> {
					System.out.println();
					System.out.println(net.getName());
					System.out.println("source: " + net.getSource());
					net.getPins().forEach(pin -> {
						if (pin != net.getSource()) {
							System.out.println(pin);
						}
					});
				});
		//.filter(i -> i.getName().contains("rti_0"))
		/*.flatMap(i -> {
			Pin clk = i.getPin("CLK");
			if (clk==null)
				return Stream.empty();
			return Stream.of(clk);
		})
		.map(p->p.getNet())
		.distinct()
		.forEach(clkNet -> {
			System.out.println();
			System.out.println(clkNet.getName());
			System.out.println(clkNet.getSource());
			Instance src = clkNet.getSource().getInstance();
			System.out.println(src);
			try {
				DotDumper.dumpInstance(src,primitiveDefs);
			} catch (FileNotFoundException e) {
				e.printStackTrace();
			}
		});*/
		design.getInstances()
				.forEach(i -> {
					try {
						DotDumper.dumpInstance(i, primitiveDefs);
					} catch (FileNotFoundException e) {
						e.printStackTrace();
					}
				});
	}

}
