package client;

import java.net.*;
import java.io.*;
import java.nio.*;
import java.nio.channels.*;

import libsim.*;

public class Client implements Runnable {

    private SocketChannel sock;
    public int id;
    private void connect() {
        while (true) {
            try {
                sock = SocketChannel.open(new InetSocketAddress("localhost", 8886));
                sock.configureBlocking(true);
                return;
            } catch (IOException e) {
            }
            System.err.printf("Connection refused%n");
            try {
                Thread.sleep(1000);
            } catch (InterruptedException e) {
            }
        }
    }

    private void disconnect() {
        try {
            sock.close();
            if (!sock.isOpen())
                System.out.printf("Socket closed%n");
        } catch (IOException e) {
        }
    }

    public void run() {
        connect();
        Payload pp = new Payload(0, -1, id);
        Message m;
        ByteBuffer buf;
        ByteBuffer[] bufs = MessageType.allocate_msg_buf();
        try {
            sock.write(MessageType.R_CFG.construct(pp).serialize());
            pp.add(Condition.INIT);
            sock.write(MessageType.COND.construct(pp).serialize());
            for (int i = 0; i < 100000; i++) {
                m = MessageType.deserialize(sock, bufs);
                bufs = new ByteBuffer[3];
                System.out.printf("%s%n", m.format_msg());
                if (m.type().equals(MessageType.STEP)) {
                    System.out.printf("Sending NUPD%n");
                    pp.reset();
                    pp.seq(m.seq());
                    pp.add(Condition.NUPD);
                    m = MessageType.COND.construct(pp);
                    buf = m.serialize();
                    sock.write(buf);
                }
                if (i == 10) {
                    pp.reset();
                    pp.dst(0x1a000);
                    m = MessageType.R_FIFO.construct(pp);
                    sock.write(m.serialize());
                }
                if (i == 20) {
                    pp.reset();
                    pp.add(Condition.RESET);
                    m = MessageType.COND.construct(pp);
                    sock.write(m.serialize());
                }
            }
            pp.reset();
            pp.add(Condition.STOP);
            m = MessageType.COND.construct(pp);
            buf = m.serialize();
            sock.write(buf);
            System.in.read();
            Thread.sleep(1000);
        } catch (InterruptedException e) {
        } catch (IOException e) {
        } catch (UnknownMessage e) {
        }

        disconnect();
    }

    public static void main(String... args) {
        Client c = new Client();
        Thread t = new Thread(c);
        c.id = Integer.decode(args[0]);
        t.start();
    }
}
