package dispatcher.gui;

import java.util.*;
import com.trolltech.qt.*;
import com.trolltech.qt.gui.*;
import com.trolltech.qt.core.*;

import dispatcher.model.*;

public class GuiShmModel extends QAbstractTableModel {

    private List<SharedMemoryModel> shms;
    private ClientModel c;
    private static final String[] col_names = new String[]{ "Base", "Memory"};

    public GuiShmModel(List<SharedMemoryModel> shms, ClientModel c) {
        this.shms = shms;
        this.c = c;
    }

    public int rowCount(QModelIndex parent) {
        return shms.size();
    }

    public int columnCount(QModelIndex parent) {
        return col_names.length;
    }

    public Object headerData(int section, Qt.Orientation orientation, int role) {
        if (role != Qt.ItemDataRole.DisplayRole)
            return null;

        if (orientation == Qt.Orientation.Horizontal)
            return col_names[section];
        else
            return section;
    }

    public Object data(QModelIndex index, int role) {
        if (role != Qt.ItemDataRole.DisplayRole)
            return null;
            SharedMemoryModel shm = shms.get(index.row());
        switch(index.column()) {
        case 0:
            return String.format("0x%x", shm.base(c));
        case 3:
            return "";
        default:
            return null;
        }
    }
}
