package dispatcher.gui;

import com.trolltech.qt.*;
import com.trolltech.qt.core.*;
import com.trolltech.qt.gui.*;
import java.util.List;

/**
 * Implements the project open dialog.
 * It emits the signal FILE_OPENED when a project file was selected to be opened.
 *
 * @author Michael Raitza
 */
public class PrjOpen extends QSignalEmitter {
    private String filter = "JConfig projects (*.xml)";
    private String directory = System.getenv().get("HOME");
    private QFileDialog f;
    private boolean terminate = false;

    /* SIGNALS */
    public Signal1<String> file_opened = new Signal1<String>();

    public PrjOpen() {
    }

    public PrjOpen(String filter, String directory) {
        this.filter = filter;
        this.directory = directory;
    }

    public void show_dialog(boolean s) {
        f = new QFileDialog();
        f.setFileMode(QFileDialog.FileMode.ExistingFiles);
        List<String> files;

        f.setDirectory(directory);
        f.setFilter(filter);
        f.show();
        if (f.exec() == 0)
            return;

        files = f.selectedFiles();
        file_opened.emit(files.iterator().next());
    }
}
