package dispatcher.log;

import com.trolltech.qt.*;
import org.apache.log4j.*;
import org.apache.log4j.spi.*;
import libjconfig.common.Log;
import java.io.StringWriter;
import java.util.*;

/**
 * Appends log events to a QTextDocument.
 *
 * @author Michael Raitza
 */
public class QtLogAppender extends QSignalEmitter {

    public Signal1<String>log_entry = new Signal1<String>();
    public final apr appender = new apr();
    private Timer timer = new Timer("GuiLogTimer");

    private class TT extends TimerTask {
        public void run() {
            appender.update();
        }
    }

    public QtLogAppender() {
    }

    public class apr extends AppenderSkeleton {
        public StringBuffer m = new StringBuffer();
        public TT tt = null;
        private boolean start = false;

        public apr() {
            super();
            layout = Log.CONSOLE_LAYOUT;
        }

	@Override
	public void close() {
	}

	@Override
	public boolean requiresLayout() {
		return true;
	}

        public void append(LoggingEvent event) {
            m.append(layout.format(event));
            if (tt == null && start)
                timer.schedule(new TT(), 100);
        }

        public void update() {
            if (m.length() != 0) {
                log_entry.emit(m.toString());
                m = new StringBuffer();
                tt = null;
            }
        }

        public void setup() {
            start = true;
        }

        public void dissemble() {
            timer.cancel();
            timer = null;
        }
    }
}
