package dispatcher.model;

import java.nio.channels.SelectionKey;

/**
 * A communication channel, a mapping between a ClientModel, a communication thread
 * and its connection.
 *
 * @author Michael Raitza
 */
public class Channel {
    public final ClientModel c;
    public final SelectionKey k;
    public Channel(ClientModel client, SelectionKey key) {
        c = client;
        k = key;
    }

    public int hashCode() {
        return k.hashCode();
    }

    public boolean equals(Object o) {
        return ((Channel)o).k.equals(k);
    }
}
