package dispatcher.model;

public class ClientBaseKey {
    public final ClientModel client;
    public final int base;
    private final int h;

    public ClientBaseKey(final ClientModel client, final int base_address) {
        this.client = client;
        this.base = base_address;
        h = hash(client.id(), base_address);
    }

    public int hashCode() {
        return h;
    }

    public boolean equals(Object o) {
        return h == o.hashCode();
    }

    public static int hash(final int client, final int base_address) {
        return ((client << 18) | (client >> 16)) ^ base_address;
    }
    public String toString() {
        return "" + client.toString() + " : " + base;
    }
}
