package dispatcher.model;

import com.trolltech.qt.*;

import java.util.Collection;

import dispatcher.exception.ApplicationError;

/**
 * Qt wrapper class that implements signalling methods for the JConfigReader
 *
 * @author Michael Raitza
 */
public class QtJConfigReader extends QSignalEmitter {

    private JConfigReader r;

    public Signal3<Collection<ClientModel>,
        Collection<InterconnectModel>,
        Collection<SharedMemoryModel>> configuration_parsed = new Signal3<Collection<ClientModel>,
        Collection<InterconnectModel>,
        Collection<SharedMemoryModel>>();

    public QtJConfigReader() {
        r = new JConfigReader();
    }

    public void parseConfiguration(String file) throws ApplicationError {
        r.parseConfiguration(file);
        configuration_parsed.emit(r.getClients(), r.getInterconnects(), r.getSharedMemory());
    }
}
