package dispatcher.model;

/**
 * The simulation state.
 *
 * @author Michael Raitza
 */
public enum SimState {
    /**
     * The simulation is running.
     */
    RUNNING,
    /**
     * The simulation is stopped.
     */
    STOPPED,
    /**
     * The simulation is initialized and at a state prior to any instruction execution in the clients.
     */
    RESET,
    /**
     * The simulation is initialized but at least one client is not connected.
     */
    UNCONNECTED,
    /**
     * The simulation is not initialized. No project is loaded.
     */
    UNINITIALIZED;
}
