package dispatcher.model;

import java.nio.ByteBuffer;

import libsim.Message;
/**
 * Represents a (maybe unfinished) transaction.
 *
 * @author Michael Raitza
 */
public class Transaction {

    public ByteBuffer[] msg_buf;
    public Message msg;
    public boolean send;
    public boolean finished = false;

    private Transaction(Message msg) {
        this.msg = msg;
        send = true;
        msg_buf = new ByteBuffer[]{ msg.serialize() };
    }

    private Transaction(ByteBuffer[] buf) {
        msg_buf = buf;
        send = false;
        msg = null;
    }

    public static Transaction send(Message msg) {
        return new Transaction(msg);
    }

    public static Transaction recv() {
        return new Transaction(new ByteBuffer[3]);
    }

    public String toString() {
        return msg != null? msg.format_msg(): "No msg";
    }
}
