package dispatcher.test;

import org.junit.*;

import dispatcher.SpinLock;

public class LockTest {
    @Test(timeout=1000) public void multilock() {
        SpinLock l = new SpinLock();

        try {
            for (int i = 1; i < 10; i++) {
                l.lock();
            }
        } catch (InterruptedException e) {
        }

        for (int i = 1; i < 10; i++) {
            l.unlock();
        }
    }

    @Test(expected=IllegalMonitorStateException.class)
    public void multilock_fail() throws InterruptedException {
        SpinLock l = new SpinLock();

        l.lock();
        l.unlock();
        l.unlock();
    }

    private SpinLock l = new SpinLock();
    private class Runner extends Thread {
        public boolean terminate = false;
        private int cnt = 0;
        public void run() {
            try {
                while (!terminate && cnt < 100) {
                    cnt++;
                    l.lock();
                    Thread.sleep(10);
                    l.unlock();
                }
            } catch (InterruptedException e) {
            }
        }
    }
    @Test(timeout=3000)
    public void concurrent_lock() throws InterruptedException {
        Runner q = new Runner();
        Runner p = new Runner();
        q.start();
        p.start();
        while(q.isAlive() || p.isAlive())
            Thread.sleep(10);
    }
}
