/**
 * _______________________________________________________________________________
 *
 * Copyright (c) 2012 TU Dresden, Chair for Embedded Systems
 * Copyright (c) 2013-2016 TU Darmstadt, Computer Systems Group
 * (http://www.rs.tu-darmstadt.de) All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 * notice, this list of conditions and the following disclaimer.
 *
 * 2. Redistributions in binary form must reproduce the above copyright
 * notice, this list of conditions and the following disclaimer in the
 * documentation and/or other materials provided with the distribution.
 *
 * 3. All advertising materials mentioning features or use of this software
 * must display the following acknowledgement: "This product includes
 * software developed by the TU Dresden Chair for Embedded Systems, TU Darmstadt Computer Systems Group and
 * its contributors."
 *
 * 4. Neither the name of the TU Dresden Chair for Embedded Systems, TU Darmstadt Computer Systems Group nor the
 * names of its contributors may be used to endorse or promote products
 * derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY TU DRESDEN CHAIR FOR EMBEDDED SYSTEMS, TU DARMSTADT COMPUTER SYSTEMS GROUP AND
 * CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING,
 * BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
 * FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * REGENTS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
 * TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 * NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * _______________________________________________________________________________
 */
/*
_______________________________________________________________________________

 Copyright (c) 2012 TU Dresden, Chair for Embedded Systems
 (http://www.mr.inf.tu-dresden.de) All rights reserved.

 Redistribution and use in source and binary forms, with or without
 modification, are permitted provided that the following conditions
 are met:

 1. Redistributions of source code must retain the above copyright
    notice, this list of conditions and the following disclaimer.

 2. Redistributions in binary form must reproduce the above copyright
    notice, this list of conditions and the following disclaimer in the
    documentation and/or other materials provided with the distribution.

 3. All advertising materials mentioning features or use of this software
    must display the following acknowledgement: "This product includes
    software developed by the TU Dresden Chair for Embedded Systems and
    its contributors."

 4. Neither the name of the TU Dresden Chair for Embedded Systems nor the
    names of its contributors may be used to endorse or promote products
    derived from this software without specific prior written permission.

 THIS SOFTWARE IS PROVIDED BY TU DRESDEN CHAIR FOR EMBEDDED SYSTEMS AND
 CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING,
 BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
 FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 REGENTS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
 TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
_______________________________________________________________________________
*/

package de.tu_darmstadt.rs.sim.console;

/**
 * The CommandHandler is responsible for reading the commands
 * from the de.tu_darmstadt.rs.sim.console and execute it.
 */
public class CommandHandler {
	//	private final static String CMD_EXIT = "exit";
	//
	//	private SimulationManager simulationMgr = null;
	//
	//	/**
	//	 * list of commands sorted by name
	//	 */
	//	private final List<Command> commandList;
	//
	//	/**
	//	 * manage own breakpoint list, as engine does not provide a stable overview
	//	 * on existing breakpoints.
	//	 * Backend can only check if address have a breakpoint. Also internal a
	//	 * HashSet is used, so the order of the breakpoints can change.
	//	 */
	//	private final List<Integer> breakpointList;
	//
	//	/**
	//	 * Constructor
	//	 * @param mgr The SimulationManager controlled with this instance of the CommandHandler
	//	 */
	//	public CommandHandler(SimulationManager mgr){
	//		simulationMgr = mgr;
	//
	//		breakpointList = new LinkedList<Integer>();
	//		commandList = new LinkedList<Command>();
	//
	//		commandList.add(new StepCommand());
	//		commandList.add(new ContinueCommand());
	//		commandList.add(new HelpCommand());
	//		commandList.add(new ListCommand());
	//		commandList.add(new ParameterCommand());
	//		commandList.add(new SetCommand());
	//		commandList.add(new BreakCommand());
	//		commandList.add(new InfoCommand());
	//		commandList.add(new DeleteCommand());
	//
	//		Collections.sort(commandList);
	//	}
	//
	//
	//	/**
	//	 * search in the commandList after a matching command. Abbreviations are allowed if
	//	 * unambiguous.
	//	 * @param cmdString the command string
	//	 * @return null if no command was found, else the matching command
	//	 */
	//	private Command searchCommand(String cmdString){
	//		Command execCommand = null;
	//		List<Command> candidateList = new LinkedList<Command>();
	//
	//		for(Command cmd : commandList){
	//			final String cmdName = cmd.getName();
	//			final int diff = cmdName.compareTo(cmdString);
	//
	//			if(diff == 0){
	//				//command matches exact
	//				execCommand = cmd;
	//				break;
	//
	//			}else if(diff > 0){
	//				//lexicographic higher, abbreviations still possible
	//				if(cmdName.startsWith(cmdString)){
	//					//remember possible candidate
	//					candidateList.add(cmd);
	//				}else{
	//					//command can never found later
	//					break;
	//				}
	//			}
	//		}
	//
	//		//check candidates
	//		final int candidateCount = candidateList.size();
	//		switch(candidateCount){
	//		case 0:
	//			//no abbreviations candidates
	//			break;
	//		case 1:
	//			//exactly one candidate
	//			execCommand = candidateList.get(0);
	//			break;
	//		default:
	//			//multiple candidates
	//			System.out.println("ambigious abbreviation, possible candidates:");
	//			for(Command cmd : candidateList){
	//				System.out.println("* " + cmd.getName());
	//			}
	//		}
	//
	//		return execCommand;
	//	}
	//
	//
	//	/**
	//	 * Read one command from the de.tu_darmstadt.rs.sim.console and execute it.
	//	 * @return If the program execution should continue
	//	 * @throws SimulationBreakException
	//	 * @throws SpartanException
	//	 */
	//	public boolean handleCommand() throws SpartanException, SimulationBreakException{
	//		String cmdLine = null;
	//
	//		//indicate that the user can enter a new command
	//		System.out.print("sdb> ");
	//
	//		BufferedReader reader = new BufferedReader(new InputStreamReader(System.in));
	//
	//		try{
	//			cmdLine = reader.readLine();
	//		}catch(IOException e){
	//			System.out.println("IOException during command handling");
	//			e.printStackTrace();
	//			System.exit(-1);
	//		}
	//
	//		if(cmdLine == null){
	//			//input stream was closed
	//			return false;
	//		}
	//
	//		//special treatment for exit command
	//		if(cmdLine.startsWith(CMD_EXIT)){
	//			return false;
	//		}
	//
	//		String[] tokens = cmdLine.split(" ");
	//
	//		if((tokens.length == 0) || (tokens[0].length() == 0)){
	//			//empty line
	//			return true;
	//		}
	//
	//		//general command handling
	//		Command execCommand = searchCommand(tokens[0]);
	//
	//
	//		//execute general command
	//		if(execCommand != null){
	//			return execCommand.execute(tokens);
	//		}
	//
	//		//command is not known
	//		System.out.println("Unknown command, type 'help' for a list of available commands");
	//
	//		return true;
	//	}
	//
	//	/**
	//	 * print list of available commands
	//	 */
	//	public void printHelp(){
	//		System.out.println("command list:\n" +
	//				"most commands can be shortend if unambiguous (exception: exit)");
	//
	//		for(Command cmd : commandList){
	//			System.out.println(cmd.getName() + "\t" + cmd.getShortHelp());
	//		}
	//
	//		System.out.println("exit \tclose the program");
	//	}
	//
	//
	//
	//	//****************
	//	// Command classes
	//	//*********************
	//	private abstract class Command implements Comparable<Command>{
	//		@Override
	//		public int compareTo(Command cmd){
	//			return getName().compareTo(cmd.getToolchainName());
	//		}
	//
	//
	//		/**
	//		 * @return the name of the command
	//		 */
	//		public abstract String getName();
	//
	//		/**
	//		 *
	//		 * @return a short description for the command
	//		 */
	//		public abstract String getShortHelp();
	//
	//		/**
	//		 *
	//		 * @return the complete help for the command
	//		 */
	//		public abstract String getLongHelp();
	//
	//		/**
	//		 * Execute the command represented by this Command class.
	//		 * @param tokens the tokens from the command line.
	//		 * @return true, if command was executed successfully and program should
	//		 * continue. Flase if the program should be exited.
	//		 */
	//		public abstract boolean execute(String[] tokens) throws SpartanException, SimulationBreakException;
	//	}
	//
	//
	//	private class StepCommand extends Command{
	//
	//		public String getName(){
	//			return "step";
	//		}
	//
	//		public String getShortHelp(){
	//			return "Execute a single clock cycle";
	//		}
	//
	//		public String getLongHelp(){
	//			return "step <n>\t executes n steps";
	//		}
	//
	//		public boolean execute(String[] tokens) throws SpartanException, SimulationBreakException{
	//			simulationMgr.issueSimulationCommand(SimulationController_I.Command.STEP);
	//			return true;
	//		}
	//	}
	//
	//
	//	private class ContinueCommand extends Command{
	//		public String getName(){
	//			return "continue";
	//		}
	//
	//		public String getShortHelp(){
	//			return "Start continous simulation";
	//		}
	//
	//		public String getLongHelp(){
	//			return "continue\t" + getShortHelp();
	//		}
	//
	//		public boolean execute(String[] tokens) throws SpartanException, SimulationBreakException{
	//			while(true){
	//				//TODO allow breaks by user input
	//			    simulationMgr.issueSimulationCommand(SimulationController_I.Command.STEP);
	//			}
	//		}
	//	}
	//
	//	private class HelpCommand extends Command{
	//
	//		@Override
	//		public String getName() {
	//			return "help";
	//		}
	//
	//		@Override
	//		public String getShortHelp() {
	//			return "print help information";
	//		}
	//
	//		@Override
	//		public String getLongHelp() {
	//			return "help <cmd> print help informations about the command";
	//		}
	//
	//		@Override
	//		public boolean execute(String[] tokens) throws SpartanException,
	//				SimulationBreakException {
	//
	//			if(tokens.length == 1){
	//				printHelp();
	//
	//			}else if(tokens.length > 1){
	//				Command cmd = searchCommand(tokens[1]);
	//
	//				if(cmd != null){
	//					System.out.println(cmd.getLongHelp());
	//				}else{
	//					//unknown command
	//					System.out.println("unknown command: " + tokens[1]);
	//				}
	//			}
	//
	//			return true;
	//		}
	//	}
	//
	//	private class ListCommand extends Command{
	//
	//		@Override
	//		public String getName() {
	//			return "list";
	//		}
	//
	//		@Override
	//		public String getShortHelp() {
	//			return "print existing periphery";
	//		}
	//
	//		@Override
	//		public String getLongHelp() {
	//			return "list\t print existing periphery.\n" +
	//					"The id in front of each periphery can be used for other commands.";
	//		}
	//
	//		@Override
	//		public boolean execute(String[] tokens) throws SpartanException,
	//				SimulationBreakException {
	//
	//			int id = 0;
	//
	//			for(AbstractPeripheral peri : simulationMgr.getPeripheralManager().getAllPeripheral()){
	//				System.out.println(id + ") " + peri);
	//				id++;
	//			}
	//
	//			return true;
	//		}
	//	}
	//
	//	private class ParameterCommand extends Command{
	//
	//		@Override
	//		public String getName() {
	//			return "parameter";
	//		}
	//
	//		@Override
	//		public String getShortHelp() {
	//			return "lists all parameters of a periphery";
	//		}
	//
	//		@Override
	//		public String getLongHelp() {
	//			return "parameter <periphery id>\t lists all parameters of the periphery\n" +
	//					"with matching peripher id. The id can be determined with the list command.";
	//		}
	//
	//		@Override
	//		public boolean execute(String[] tokens) throws SpartanException,
	//				SimulationBreakException {
	//
	//			if(tokens.length < 2){
	//				System.out.println("periphery id missing");
	//				System.out.println(getLongHelp());
	//				return true;
	//			}
	//
	//			try{
	//				final int id = Integer.parseInt(tokens[1]);
	//
	//				final PeripheralManager peripheryMgr = simulationMgr.getPeripheralManager();
	//				final AbstractPeripheral peri = peripheryMgr.getAllPeripheral().get(id);
	//				if(peri == null){
	//					System.out.println("no periphery exist with id: " + id);
	//				}else{
	//					String[] parameters = peri.getParameters();
	//
	//					int paramId = 0;
	//					for(String p : parameters){
	//						System.out.println(paramId +") " +p);
	//						paramId++;
	//					}
	//				}
	//			}catch (NumberFormatException e){
	//				System.out.println("the entered id is not a number");
	//			}
	//
	//			return true;
	//		}
	//	}
	//
	//	private class SetCommand extends Command{
	//
	//		@Override
	//		public String getName() {
	//			return "set";
	//		}
	//
	//		@Override
	//		public String getShortHelp() {
	//			return "set a periphery parameter";
	//		}
	//
	//		@Override
	//		public String getLongHelp() {
	//			return "set <periphery id> <parameter id> <value>\tset a periphery parameter.\n" +
	//					"The periphery id can be determined with 'list' and the parameter id with\n" +
	//					"'parameter <periphery id>'.";
	//		}
	//
	//		@Override
	//		public boolean execute(String[] tokens) throws SpartanException,
	//				SimulationBreakException {
	//
	//			if(tokens.length < 4){
	//				System.out.println("peripheral, parameter id and value are required");
	//				System.out.println(getLongHelp());
	//				return true;
	//			}
	//
	//			try{
	//				final int peripheryId = Integer.parseInt(tokens[1]);
	//				final int parameterId = Integer.parseInt(tokens[2]);
	//				final int value = Integer.parseInt(tokens[3]);
	//
	//				final PeripheralManager peripheryMgr = simulationMgr.getPeripheralManager();
	//				final AbstractPeripheral peri = peripheryMgr.getAllPeripheral().get(peripheryId);
	//
	//				if(peri == null){
	//					System.out.println("no peripheral exist with id: " + peripheryId);
	//					return true;
	//				}
	//
	//				boolean success = peri.setParameter(parameterId, value);
	//				if(!success){
	//					System.out.println("no parameter with id: " + parameterId + "exists");
	//				}
	//			}catch (NumberFormatException e){
	//				System.out.println("peripheral id and/or parameter id is not a number");
	//			}
	//
	//			return true;
	//		}
	//
	//	}
	//
	//	private class BreakCommand extends Command implements SpartanDefinitions_I{
	//
	//		@Override
	//		public String getName() {
	//			return "break";
	//		}
	//
	//		@Override
	//		public String getShortHelp() {
	//			return "set a breakpoint";
	//		}
	//
	//		@Override
	//		public String getLongHelp() {
	//			return "break <hex_address>\tset a break point at the given address(hexadecimal).";
	//		}
	//
	//		@Override
	//		public boolean execute(String[] tokens) throws SpartanException,
	//				SimulationBreakException {
	//
	//			if(tokens.length < 2){
	//				System.out.println("breakpoint address required");
	//				return true;
	//			}
	//
	//			final int address = Formatter.parseHexString(tokens[1], BITMASK_18);
	//			if(address == INVALID){
	//				System.out.println("the entered value is not a 18 bit hex address");
	//				return true;
	//			}
	//
	//			final MainMemory memory = simulationMgr.getMemory();
	//
	//			if(memory.hasBreakpoint(address)){
	//				System.out.println(String.format("0x%x already have a breakpoint", address));
	//			}else{
	//				memory.toggleBreakpoint(address);
	//				breakpointList.add(address);
	//				System.out.println(String.format("set breakpoint at 0x%x", address));
	//			}
	//
	//			return true;
	//		}
	//
	//	}
	//
	//
	//	private class InfoCommand extends Command{
	//
	//		@Override
	//		public String getName() {
	//			return "info";
	//		}
	//
	//		@Override
	//		public String getShortHelp() {
	//			return "print all existing breakpoints";
	//		}
	//
	//		@Override
	//		public String getLongHelp() {
	//			return "info\t" + getShortHelp();
	//		}
	//
	//		@Override
	//		public boolean execute(String[] tokens) throws SpartanException,
	//				SimulationBreakException {
	//
	//			if(breakpointList.size() == 0){
	//				System.out.println("no breakpoints");
	//				return true;
	//			}
	//
	//			for(int id = 0; id < breakpointList.size(); id++){
	//				String msgEnd = String.format(") breakpoint at 0x%x", breakpointList.get(id));
	//				System.out.println(id + msgEnd);
	//			}
	//
	//			return true;
	//		}
	//
	//	}
	//
	//
	//	class DeleteCommand extends Command{
	//
	//		@Override
	//		public String getName() {
	//			return "delete";
	//		}
	//
	//		@Override
	//		public String getShortHelp() {
	//			return "delete a breakpoint";
	//		}
	//
	//		@Override
	//		public String getLongHelp() {
	//			return "delete <breakpoint id | all>\t delete the specified breakpoint, or all";
	//		}
	//
	//		@Override
	//		public boolean execute(String[] tokens) throws SpartanException,
	//				SimulationBreakException {
	//
	//			if(tokens.length < 2){
	//				System.out.println("breakpoint id required");
	//			}
	//
	//			final MainMemory memory = simulationMgr.getMemory();
	//
	//			//clear all breakpoints if requested
	//			if("all".startsWith(tokens[1])){
	//				for(Integer bp : breakpointList){
	//					assert(memory.hasBreakpoint(bp));
	//
	//					memory.toggleBreakpoint(bp);
	//				}
	//
	//				System.out.println("all breakpoints cleared");
	//				return true;
	//			}
	//
	//			try{
	//				final int id = Integer.parseInt(tokens[1]);
	//
	//				if(breakpointList.size() <= id){
	//					System.out.println("breakpoint " + id + " does not exist");
	//					return true;
	//				}
	//
	//				final Integer breakpointAddress = breakpointList.get(id);
	//
	//				assert(memory.hasBreakpoint(breakpointAddress));
	//
	//				memory.toggleBreakpoint(breakpointAddress);
	//				breakpointList.remove(breakpointAddress);
	//				String msgEnd = String.format(" at 0x%x cleared", breakpointAddress);
	//				System.out.println("breakpoint " + id + msgEnd);
	//
	//			}catch (NumberFormatException e){
	//				System.out.println("the entered value is not a breakpoint id");
	//			}
	//
	//			return true;
	//		}
	//
	//	}

}
