/**
 * _______________________________________________________________________________
 *
 * Copyright (c) 2012 TU Dresden, Chair for Embedded Systems
 * Copyright (c) 2013-2016 TU Darmstadt, Computer Systems Group
 * (http://www.rs.tu-darmstadt.de) All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 * notice, this list of conditions and the following disclaimer.
 *
 * 2. Redistributions in binary form must reproduce the above copyright
 * notice, this list of conditions and the following disclaimer in the
 * documentation and/or other materials provided with the distribution.
 *
 * 3. All advertising materials mentioning features or use of this software
 * must display the following acknowledgement: "This product includes
 * software developed by the TU Dresden Chair for Embedded Systems, TU Darmstadt Computer Systems Group and
 * its contributors."
 *
 * 4. Neither the name of the TU Dresden Chair for Embedded Systems, TU Darmstadt Computer Systems Group nor the
 * names of its contributors may be used to endorse or promote products
 * derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY TU DRESDEN CHAIR FOR EMBEDDED SYSTEMS, TU DARMSTADT COMPUTER SYSTEMS GROUP AND
 * CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING,
 * BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
 * FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * REGENTS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
 * TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 * NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * _______________________________________________________________________________
 *
 * Spartan MC Simulator
 * Matthias Hofmann
 * Department for Computer Science, Chair for Embedded Systems
 * TU Dresden, 2011
 *
 * Spartan MC Simulator
 * Matthias Hofmann
 * Department for Computer Science, Chair for Embedded Systems
 * TU Dresden, 2011
 */
/*
_______________________________________________________________________________

 Copyright (c) 2012 TU Dresden, Chair for Embedded Systems
 (http://www.mr.inf.tu-dresden.de) All rights reserved.

 Redistribution and use in source and binary forms, with or without
 modification, are permitted provided that the following conditions
 are met:

 1. Redistributions of source code must retain the above copyright
    notice, this list of conditions and the following disclaimer.

 2. Redistributions in binary form must reproduce the above copyright
    notice, this list of conditions and the following disclaimer in the
    documentation and/or other materials provided with the distribution.

 3. All advertising materials mentioning features or use of this software
    must display the following acknowledgement: "This product includes
    software developed by the TU Dresden Chair for Embedded Systems and
    its contributors."

 4. Neither the name of the TU Dresden Chair for Embedded Systems nor the
    names of its contributors may be used to endorse or promote products
    derived from this software without specific prior written permission.

 THIS SOFTWARE IS PROVIDED BY TU DRESDEN CHAIR FOR EMBEDDED SYSTEMS AND
 CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING,
 BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
 FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 REGENTS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
 TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
_______________________________________________________________________________
*/

/**
 * Spartan MC Simulator
 * Matthias Hofmann
 * Department for Computer Science, Chair for Embedded Systems
 * TU Dresden, 2011
 */
package de.tu_darmstadt.rs.sim.console;

/**
 * The de.tu_darmstadt.rs.sim.main class for the de.tu_darmstadt.rs.sim.console program for the SpartanMc Simulator.
 */
public class Console {

	//	/**
	//	 * @param args command line arguments:
	//	 */
	//	public static void de.tu_darmstadt.rs.sim.main(String[] args){
	//		SimulationManager simulationMgr = new SimulationManager(null);
	//        simulationMgr.setMessageHandler(
	//            new MessageHandler_I() {
	//                @Override
	//                public void postMessage(String msg, MsgType type) {
	//                    System.out.printf("%s\n", msg);
	//                }
	//                public MsgResult confirmMessage(String msg, MsgType type, MsgOpt opt) {
	//                    System.out.printf("%s\n", msg);
	//                    if (opt == MsgOpt.YES_NO) {
	//                        return MsgResult.NO;
	//                    } else {
	//                        return MsgResult.CANCEL;
	//                    }
	//
	//                }
	//            }
	//        );
	//		CommandHandler cmdHandler = new CommandHandler(simulationMgr);
	//		AssemblyParser parser = null;
	//		MainMemory memory = null;
	//
	//		OptionParser options = new OptionParser();
	//		options.parseCmdLine(args);
	//
	//		if(!options.requiredOptionsSet()){
	//			System.out.println("command options missing. Type -h for help.");
	//			System.exit(-1);
	//		}
	//
	//		assert(options.getMemoryFile() != null);
	//
	//		//setup SimulationManager to initialize all fields
	//		simulationMgr.setupSimulation();
	//
	//		//load program into memory
	//		memory = simulationMgr.getMemory();
	//		parser = new AssemblyParser(memory);
	//		memory.delete();
	//		memory.restart();
	//
	//		try{
	//			parser.loadAssemblyCode(options.getMemoryFile());
	//		}catch (ParsingException e) {
	//			System.out.println("error: malformed de.tu_darmstadt.rs.sim.main memory file");
	//			System.out.println(e.toString());
	//			System.exit(-1);
	//		}
	//
	//		//import jconfig, if available
	//		final File jconfigFile = options.getJConfigFile();
	//
	//		if(jconfigFile != null){
	//			final JConfigDocumentManager jConfigDocumentManager=simulationMgr.getJConfigDocumentManager();
	//			final PeripheralManager peripheryMgr = simulationMgr.getPeripheralManager();
	//
	//			try {
	//				jConfigDocumentManager.setJConfigFile(jconfigFile.getAbsolutePath());
	//			} catch (SpartanException e1) {
	//				System.err.println(e1.getMessage());
	//				System.exit(-1);
	//			}
	//
	//			final int subsystemNumber = options.getSubsystemNumber();
	//			int subsystemCount = 0;
	//
	//			try{
	//				subsystemCount = jConfigDocumentManager.getNumberOfSubsystems();
	//			}catch (SpartanException e){
	//				System.err.println("The number of subsystems could not be determined: " + e.getMessage());
	//				System.exit(-1);
	//			}
	//
	//			if(subsystemNumber >= subsystemCount){
	//				System.err.println("The chosen subsystem number is too high, only " + subsystemCount +
	//						"subsystems exists");
	//				System.exit(-1);
	//			}
	//
	//			try {
	//				jConfigDocumentManager.loadSubsystem(subsystemNumber);
	//
	//				//print information
	//				System.out.println("Subsystem " + subsystemNumber + " loaded, imported periphery:");
	//				List<AbstractPeripheral> peripheries = peripheryMgr.getAllPeripheral();
	//				for(AbstractPeripheral peri : peripheries){
	//					System.out.println("* " + peri);
	//				}
	//
	//			} catch (SpartanException e) {
	//				System.err.println("Import subsystem " + subsystemNumber + " failed: " + e.getMessage());
	//				System.exit(-1);
	//			}
	//		}
	//
	//		//setup the simulation
	//		simulationMgr.setupSimulation();
	//
	//		//run simulation without user interaction
	//		if(options.runInstant()){
	////                        ClientCommunicator com = ClientCommunicator.getCommunicator(simulationMgr);
	////                        com.startWorker();
	//			while(true){
	//        		simulationMgr.issueSimulationCommand(SimulationController_I.Command.STEP);
	//			}
	//		}
	//
	//		//execute user commands until exit received
	//		boolean shouldContinue = true;
	//		while(shouldContinue){
	//			try{
	//				shouldContinue = cmdHandler.handleCommand();
	//			}catch(SpartanException e){
	//				System.out.println("Simulation Exception: " + e.getMessage());
	//				//e.printStackTrace();
	//				System.exit(-1);
	//			}catch (SimulationBreakException e) {
	//				//inform user about breakpoint
	//				System.out.println(e.getMessage());
	//			}
	//		}
	//
	//		System.exit(0);
	//	}

}
