/**
 * _______________________________________________________________________________
 *
 * Copyright (c) 2012 TU Dresden, Chair for Embedded Systems
 * Copyright (c) 2013-2016 TU Darmstadt, Computer Systems Group
 * (http://www.rs.tu-darmstadt.de) All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 * notice, this list of conditions and the following disclaimer.
 *
 * 2. Redistributions in binary form must reproduce the above copyright
 * notice, this list of conditions and the following disclaimer in the
 * documentation and/or other materials provided with the distribution.
 *
 * 3. All advertising materials mentioning features or use of this software
 * must display the following acknowledgement: "This product includes
 * software developed by the TU Dresden Chair for Embedded Systems, TU Darmstadt Computer Systems Group and
 * its contributors."
 *
 * 4. Neither the name of the TU Dresden Chair for Embedded Systems, TU Darmstadt Computer Systems Group nor the
 * names of its contributors may be used to endorse or promote products
 * derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY TU DRESDEN CHAIR FOR EMBEDDED SYSTEMS, TU DARMSTADT COMPUTER SYSTEMS GROUP AND
 * CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING,
 * BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
 * FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * REGENTS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
 * TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 * NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * _______________________________________________________________________________
 */
package de.tu_darmstadt.rs.sim.gdb;

/*import sun.misc.Regexp;

import java.util.Collections;
import java.util.HashMap;
import java.util.Map;
import java.util.regex.Pattern;

/**
 * Created by heid on 09.12.15.
 */
public final class Symbols {

	public static final char startSequence = '$';
	public static final char stopSequence = '#';
	public static final char splitFields = ';';
	public static final char splitCMD = ':';

	private Symbols(){}

	public enum GDBSignal {
		GDB_SIGNAL_0(0, "0"),          // "Signal 0"
		GDB_SIGNAL_HUP(1, "SIGHUP"),     //, "Hangup")
		GDB_SIGNAL_INT(2, "SIGINT"),     // "Interrupt")
		GDB_SIGNAL_QUIT(3, "SIGQUIT"),    // "Quit")
		GDB_SIGNAL_ILL(4, "SIGILL"),     // "Illegal instruction")
		GDB_SIGNAL_TRAP(5, "SIGTRAP"),    // "Trace/breakpoint trap")
		GDB_SIGNAL_ABRT(6, "SIGABRT"),    // "Aborted")
		GDB_SIGNAL_EMT(7, "SIGEMT"),     // "Emulation trap")
		GDB_SIGNAL_FPE(8, "SIGFPE"),     // "Arithmetic exception")
		GDB_SIGNAL_KILL(9, "SIGKILL"),    // "Killed")
		GDB_SIGNAL_BUS(10, "SIGBUS"),    // "Bus error")
		GDB_SIGNAL_SEGV(11, "SIGSEGV"),   // "Segmentation fault")
		GDB_SIGNAL_SYS(12, "SIGSYS"),    // "Bad system call")
		GDB_SIGNAL_PIPE(13, "SIGPIPE"),   // "Broken pipe")
		GDB_SIGNAL_ALRM(14, "SIGALRM"),   // "Alarm clock")
		GDB_SIGNAL_TERM(15, "SIGTERM"),   // "Terminated")
		GDB_SIGNAL_URG(16, "SIGURG"),    // "Urgent I/O condition")
		GDB_SIGNAL_STOP(17, "SIGSTOP"),   // "Stopped (de.tu_darmstadt.rs.sim.signal)")
		GDB_SIGNAL_TSTP(18, "SIGTSTP"),   // "Stopped (user)")
		GDB_SIGNAL_CONT(19, "SIGCONT");   // "Continued")

		private final int nr;
		private final String label;
		private final int maxSingalNr = 256;

		GDBSignal(final int nr, final String label) {
			this.nr = nr % maxSingalNr;
			this.label = label;
		}

		public int getNr() {
			return this.nr;
		}

		/**
		 * @param nr the nr to convert
		 * @return the hexadecimal number of the de.tu_darmstadt.rs.sim.signal
		 */
		public static String get2DigitHEXNr(int nr) {
			String s = Integer.toHexString(nr);
			if (s.length() == 1) {
				s = "0" + s;
			}
			return s;
		}

		/**
		 * @return the hexadecimal number of the de.tu_darmstadt.rs.sim.signal
		 */
		public String get2DigitHEXNr() {
			String s = Integer.toHexString(nr);
			if (s.length() == 1) {
				s = "0" + s;
			}
			return s;
		}

		public String getLabel() {
			return this.label;
		}


	}

}
