#_______________________________________________________________________________
#
# Copyright (c) 2012 TU Dresden, Chair for Embedded Systems
# (http://www.mr.inf.tu-dresden.de) All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
#
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
#
# 3. All advertising materials mentioning features or use of this software
#    must display the following acknowledgement: "This product includes
#    software developed by the TU Dresden Chair for Embedded Systems and
#    its contributors."
#
# 4. Neither the name of the TU Dresden Chair for Embedded Systems nor the
#    names of its contributors may be used to endorse or promote products
#    derived from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY TU DRESDEN CHAIR FOR EMBEDDED SYSTEMS AND
# CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING,
# BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
# FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
# REGENTS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
# TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
# PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
# LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
# NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
# SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#_______________________________________________________________________________
#

### Include makefile for SpartanMC build process ###
#
# Provides clean and clobber target
#
# BUILD_DIR (in): Root for all files created during build
#
# CLEAN_LIST (in): List of files and directories to remove
#     when calling 'clean'
#
# CLOBBER_LIST (in): List of files and directories to remove
#     when calling 'clobber'
#
# AVAILABLE_TARGETS (in/out): List of all explicit targets
#    (used in target what)
#

AVAILABLE_TARGETS+=clean clobber
HELP_clean:=Remove intermediate build files
HELP_clobber:=Remove all generated files

CLEAN_PROCESS:=Removing intermediate build files
CLOBBER_PROCESS:=Removing all generated files

CLEAN_CMD = $(call REMOVE,$(call MAKE_RELATIVE,$(sort $(wildcard $(CLEAN_LIST)))))
CLOBBER_CMD = $(call REMOVE,$(call MAKE_RELATIVE,$(sort $(wildcard $(CLOBBER_LIST)))))

.PHONY: clean,clobber

clean:
ifneq ($(CLEAN_LIST),)
	@$(call BUILD_NOCD,CLEAN,--noecho)
endif

clobber: clean
ifneq ($(CLOBBER_LIST),)
	@$(call BUILD_NOCD,CLOBBER,--noecho)
endif
