ifndef __LOCALVARS_MK
define __LOCALVARS_MK
endef

# save current values of a set of variables by extending the original
# variable name by an unique ID (generates make code)
define local_export
	$(foreach NAME,$(2),\
		$(eval $(NAME)_$(1):=$($(NAME)))\
	)
endef

# import saved values from a set of variables into shell call of a receipe
# (generates shell code)
define local_import
	$(foreach NAME,$(2),$(NAME)='$($(NAME)_$(1))')
endef

endif
