#_______________________________________________________________________________
#
# Copyright (c) 2012 TU Dresden, Chair for Embedded Systems
# (http://www.mr.inf.tu-dresden.de) All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
#
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
#
# 3. All advertising materials mentioning features or use of this software
#    must display the following acknowledgement: "This product includes
#    software developed by the TU Dresden Chair for Embedded Systems and
#    its contributors."
#
# 4. Neither the name of the TU Dresden Chair for Embedded Systems nor the
#    names of its contributors may be used to endorse or promote products
#    derived from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY TU DRESDEN CHAIR FOR EMBEDDED SYSTEMS AND
# CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING,
# BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
# FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
# REGENTS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
# TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
# PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
# LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
# NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
# SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#_______________________________________________________________________________
#

### Include makefile for SpartanMC build process ###
#
# Provides all targets to build firmware from
# a set of source files. Supports .c and
# .a18 projects
#

$(eval $(MAKEFILE_PROLOG))

.PHONY: sph

AVAILABLE_TARGETS+=sph
HELP_sph:=Build SpartanMC hex files $(OBRACE)*.sph$(CBRACE)


ifneq ($(MAKECMDGOALS),newfirmware)
ifneq ($(MAKECMDGOALS),jconfig)
FW_BUILD_MK:=fwbuild-2.1.mk
$(foreach FW_ID,$(JCONFIG_FIRMWARE_IDS), \
  $(eval include $(SPARTANMC_ROOT)/src/scripts/make/firmware/$(FW_BUILD_MK)) \
)
endif
endif

$(LF_A): $(SPARTANMC_LIBS_CHK)

FW_SOURCE_FILES:=$(sort $(FW_SOURCE_FILES))

# Error handling
#%config-build.mk:
#	@test -r $@ || $(call TARGET_ERROR,Include makefile '$@' is missing)

$(SYSTEM_INC) $(SYSTEM_H):
	@test -r $@ || $(call TARGET_ERROR,$(SYSTEM_INCLUDE_ERROR))

$(FW_SOURCE_FILES):
	@test -r $@ || $(call TARGET_MESSAGE,Required firmware file '$@' not found) && \
		$(call TARGET_MESSAGE,Search path is $(VPATH)) && \
		false

sph: $(SPH_FILES)
