#_______________________________________________________________________________
#
# Copyright (c) 2012 TU Dresden, Chair for Embedded Systems
# (http://www.mr.inf.tu-dresden.de) All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
#
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
#
# 3. All advertising materials mentioning features or use of this software
#    must display the following acknowledgement: "This product includes
#    software developed by the TU Dresden Chair for Embedded Systems and
#    its contributors."
#
# 4. Neither the name of the TU Dresden Chair for Embedded Systems nor the
#    names of its contributors may be used to endorse or promote products
#    derived from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY TU DRESDEN CHAIR FOR EMBEDDED SYSTEMS AND
# CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING,
# BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
# FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
# REGENTS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
# TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
# PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
# LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
# NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
# SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#_______________________________________________________________________________
#

### Include makefile for SpartanMC build process ###
#
# Provides target to upload firmware image to implemented system
#

#$(eval $(call MAKEFILE_PROLOG,$(JCONFIG_FW_$(FW_ID)_SUBSYSTEM): ))

AVAILABLE_TARGETS+=upload verify
HELP_upload:=Update firmware image on target via UART connected to given PORT $(OBRACE)requires boot loader$(CBRACE)
ARGS_upload:=+port=PORT +args=OPTIONS

UPLOAD_CMD=$(SPARTANMC_LOADER) -d $(+port) -e -s .loader.text,.loader.data,.startup,.init,.fini,.text,.ctors,.dtors,.intr_tab $(+args)
UPLOAD_PROCESS:=Uploading firmware image to target

HELP_verify:=Verify firmware image on target against current firmware file $(OBRACE)requires boot loader$(CBRACE)
ARGS_verify:=+port=PORT +args=OPTIONS

VERIFY_CMD=$(SPARTANMC_LOADER) -d $(+port) -v -e -s .loader.data $(+args)
VERIFY_PROCESS:=Verifying firmware image on target

ifndef __TARGET_UPLOAD_CHECKS_DEFINED
    __TARGET_UPLOAD_CHECKS_DEFINED:=1 
upload_checks:
ifneq ($(origin +port),command line)
    ifeq ($(DEFAULT_UPLOAD_PORT),)
		@$(call TARGET_ERROR,no port given\n\n    usage: $(MAKE) upload $(ARGS_upload))
    else

+port=$(DEFAULT_UPLOAD_PORT)
    endif
endif

endif # __TARGET_UPLOAD_CHECKS_DEFINED

upload: upload_$(JCONFIG_FW_$(FW_ID)_SUBSYSTEM)

verify: verify_$(JCONFIG_FW_$(FW_ID)_SUBSYSTEM)

upload_$(JCONFIG_FW_$(FW_ID)_SUBSYSTEM): upload_checks $(SPARTANMC_UPLOAD) $(F_ELF)
	@$(call BUILD,UPLOAD,,$(lastword $^))

verify_$(JCONFIG_FW_$(FW_ID)_SUBSYSTEM): upload_checks $(SPARTANMC_UPLOAD) $(F_ELF)
	@$(call BUILD,VERIFY,,$(lastword $^))
