#_______________________________________________________________________________
#
# Copyright (c) 2012 TU Dresden, Chair for Embedded Systems
# (http://www.mr.inf.tu-dresden.de) All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
#
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
#
# 3. All advertising materials mentioning features or use of this software
#    must display the following acknowledgement: "This product includes
#    software developed by the TU Dresden Chair for Embedded Systems and
#    its contributors."
#
# 4. Neither the name of the TU Dresden Chair for Embedded Systems nor the
#    names of its contributors may be used to endorse or promote products
#    derived from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY TU DRESDEN CHAIR FOR EMBEDDED SYSTEMS AND
# CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING,
# BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
# FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
# REGENTS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
# TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
# PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
# LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
# NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
# SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#_______________________________________________________________________________
#

$(eval $(MAKEFILE_PROLOG))

AVAILABLE_TARGETS+=report_hw maxFreq timingViolation

HELP_report_hw := Show a nicely formatted hardware report, parsed from synthesis reports
ARGS_report_hw :=[+args="<reportHardware args>"]

HELP_maxFreq:=Start Evaluation of maximum frequency
ARGS_maxFreq:=[+args="<maxFreq args>"]

HELP_timingViolation:=Tells if the current hardware design holds timing violations
ARGS_timingViolation:=[+args="<timingViolation args>"]



ifeq ($(origin +args),command line)
  CMDLINE_ARGS:=$(+args)
else
  CMDLINE_ARGS:=
endif

REPORT_HW_PROCESS:=Starting hardware report parser
REPORT_HW_CMD:= cd $(CURDIR) && $(SPARTANMC_EVALUATION) hardwareReport $(CMDLINE_ARGS)


MAX_FREQ_PROCESS:=Start finding maximum Frequency
MAX_FREQ_CMD:= cd $(CURDIR) && $(SPARTANMC_EVALUATION) maxFreq $(CMDLINE_ARGS)


TIMING_VIOLATION_CALL:= cd $(CURDIR) && $(SPARTANMC_EVALUATION) timingViolation $(CMDLINE_ARGS)


.PHONY: report_hw maxFreq timingViolation

report_hw: $(SPARTANMC_EVALUATION)
	@$(call BUILD_NOCD,REPORT_HW)

maxFreq: $(SPARTANMC_EVALUATION)
	@$(call BUILD_NOCD,MAX_FREQ)

timingViolation: $(SPARTANMC_EVALUATION)
	$(TIMING_VIOLATION_CALL)

