#_______________________________________________________________________________
#
# Copyright (c) 2012 TU Dresden, Chair for Embedded Systems
# (http://www.mr.inf.tu-dresden.de) All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
#
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
#
# 3. All advertising materials mentioning features or use of this software
#    must display the following acknowledgement: "This product includes
#    software developed by the TU Dresden Chair for Embedded Systems and
#    its contributors."
#
# 4. Neither the name of the TU Dresden Chair for Embedded Systems nor the
#    names of its contributors may be used to endorse or promote products
#    derived from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY TU DRESDEN CHAIR FOR EMBEDDED SYSTEMS AND
# CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING,
# BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
# FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
# REGENTS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
# TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
# PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
# LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
# NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
# SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#_______________________________________________________________________________
#

### Include makefile for SpartanMC build process ###
#
# Definition of all build files
#

$(eval $(MAKEFILE_PROLOG))

ifeq ($(JCONFIG_VERSION),1)
    FW_FILE:=$(JCONFIG_FIRMWARE_SOURCE)
endif
UCF_PROGRAMRAM:=$(BUILD_ROOT)_programram.ucf
TCL_PROGRAMRAM:=$(BUILD_ROOT)_programram.tcl
V_PROG_SIM:=$(BUILD_ROOT)_programram.v
H_PROG_SIM:=$(BUILD_ROOT)_programram.txt
MEM:=$(BUILD_ROOT).mem

BMM:=$(GENERATED_FILES_DIR)/system.bmm
CGP:=$(BUILD_DIR)/ipcore/spartanmc.cgp
XCO:=$(BUILD_ROOT).ipcore
NGC:=$(BUILD_ROOT).ngc
UCF:=$(BUILD_ROOT).ucf
NGD:=$(BUILD_ROOT).ngd
PCF:=$(BUILD_ROOT).pcf
NCD_MAP:=$(BUILD_ROOT)_map.ncd
NCD_PAR:=$(BUILD_ROOT)_par.ncd
ORG_DIR:=$(BUILD_DIR)/org
NCD_PAR_ORG:=$(ORG_DIR)/$(JCONFIG_PRJNAME)_par.ncd
XDL_PAR:=$(BUILD_ROOT)_par.xdl

PLANAHEAD_SCRIPT:=$(BUILD_ROOT)_planahead.tcl

RAPID_MOD:=$(BUILD_DIR)/module/module.smile
RAPID_XDL:=$(BUILD_DIR)/rapidSoc.xdl
RAPID_XDL_OWNROUTER:=$(BUILD_DIR)/rapidSoc_ownrouter.xdl
RAPID_NCD:=$(BUILD_DIR)/rapidSoc.ncd
RAPID_NCD_OWNROUTER:=$(BUILD_DIR)/rapidSoc_ownrouter.ncd
RAPID_NCD_ROUTED:=$(BUILD_DIR)/rapidSoc_routed.ncd
RAPID_BIT_OWNROUTER:=$(BUILD_DIR)/rapidSoc_ownrouter.bit
RAPID_BIT_ROUTED:=$(BUILD_DIR)/rapidSoc_routed.bit
MEM_MAP:=$(GENERATED_FILES_DIR)/memory.xml
ifndef BITFILE
  BIT:=$(BUILD_ROOT).bit
else
  BITFILE_BASE:=$(abspath $(basename $(BITFILE)))
  BIT:=$(BITFILE_BASE).bit
endif
BIT_REG:=$(BUILD_ROOT)_reg.bit
MSK_REG:=$(BUILD_ROOT)_reg.msk
MSK:=$(BUILD_ROOT).msk
BGN:=$(BUILD_ROOT)_reg.bgn
DRC:=$(BUILD_ROOT)_reg.drc
LOCATION:=$(BUILD_ROOT)_reg.ll


BIT_UT:=$(BUILD_ROOT).ut
LSO:=$(BUILD_ROOT).lso
IMPACT_CMD:=$(BUILD_DIR)/impact.cmd

TIMESIM:=$(BUILD_ROOT)_timesim.v
TIMESIM_REGULAR:=$(BUILD_ROOT)_timesim_regular.v
TIMESIM_RAPIDSOC:=$(BUILD_ROOT)_timesim_rapidsoc.v


TIMESIM_SDF:=$(BUILD_ROOT)_timesim.sdf
TIMESIM_SDF_REGULAR:=$(BUILD_ROOT)_timesim_regular.sdf
TIMESIM_SDF_RAPIDSOC:=$(BUILD_ROOT)_timesim_rapidsoc.sdf
FDO_WORKLIB:=$(GENERATED_FILES_DIR)/spartanmc_worklib.fdo
CONFIG_TCL:=$(BUILD_DIR)/configure.tcl

CPJ:=$(GENERATED_FILES_DIR)/chipscope.cpj
