#_______________________________________________________________________________
#
# Copyright (c) 2012 TU Dresden, Chair for Embedded Systems
# (http://www.mr.inf.tu-dresden.de) All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
#
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
#
# 3. All advertising materials mentioning features or use of this software
#    must display the following acknowledgement: "This product includes
#    software developed by the TU Dresden Chair for Embedded Systems and
#    its contributors."
#
# 4. Neither the name of the TU Dresden Chair for Embedded Systems nor the
#    names of its contributors may be used to endorse or promote products
#    derived from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY TU DRESDEN CHAIR FOR EMBEDDED SYSTEMS AND
# CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING,
# BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
# FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
# REGENTS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
# TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
# PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
# LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
# NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
# SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#_______________________________________________________________________________
#

### Include makefile for SpartanMC build process ###
#
# Run system builder
#

$(eval $(MAKEFILE_PROLOG))

AVAILABLE_TARGETS+=jconfig jconfig_update
HELP_jconfig:=Start JConfig
ARGS_jconfig:=[+args="<jconfig args>"]
HELP_jconfig_update:=Update current configuration with JConfig
ARGS_jconfig_update:=[+args="<jconfig args>"]


JCONFIG_PROCESS:=Starting JConfig
JCONFIG_CMD=cd $(CURDIR) && $(SPARTANMC_JCONFIG) $(JCONFIG_CMDLINE_ARGS)

JCONFIG_UPDATE_PROCESS:=Updating Project with last used JConfig Configuration
JCONFIG_UPDATE_CMD=cd $(CURDIR) && $(SPARTANMC_JCONFIG) -q -u  $(JCONFIG_CMDLINE_ARGS)


ifeq ($(origin +args),command line)
  JCONFIG_CMDLINE_ARGS:=$(+args)
else
  JCONFIG_CMDLINE_ARGS:=
endif

PROJECT_HARDWARE:=hardware

JCONFIG_CMDLINE_ARGS+=$(JCFLAGS)

ifneq ("$(wildcard $(PROJECT_HARDWARE))","")
	JCONFIG_CMDLINE_ARGS+=-I hardware
endif

.PHONY: jconfig

jconfig: $(SPARTANMC_JCONFIG)
	@$(call BUILD_NOCD,JCONFIG)
	
jconfig_update: $(SPARTANMC_JCONFIG)
	@$(call BUILD_NOCD,JCONFIG_UPDATE)
