#\\$(eval \\$(call MAKEFILE_PROLOG, (\\$(FW_ID))))

${D_BUILD}/%.o: ${D_SRC}/%.c ${LF_INC} \\$(MAKEFILE_LIST) ${CONFIG_BUILD_MK} | ${D_BUILD}

ifneq (\\$(ENABLE_GCC),yes)
	@\\$(call TARGET_ERROR,'Unable to proceed. Your project requires GCC but integration with SpartanMC-GCC was disabled by configure option '\''--disable-gcc'\''. Provide required programs and rerun configure without '\''--disable-gcc'\''.')
endif

ifeq (\\$(SB_SPARTANMC_0_RAMBLOCKS),)
	@\\$(call TARGET_ERROR,'Parameter values SB_SPARTANMC_0_* not set! Make sure your processor instance is named '\''spartanmc_0'\''.')
endif

ifeq (\\$(SB_SPARTANMC_0_SINGLE_SHIFT),1)
	@\\$(call TARGET_ERROR,'Processor parameter SINGLE_SHIFT=1 is currently not supported by GCC. You need to configure your processor to support multi-shift in hardware (set SINGLE_SHIFT=0).')
endif

	gcc -o \\$@ -c ${_CFLAGS} \\$<
	@\\$(call ECHO_TARGET_DONE)

${F_BIN}: ${LF_OBJ} ${P_MAIN}.o
	objcopy --redefine-sym main=simMain ${P_MAIN}.o
	gcc -o \\$@ \\$(sort ${LF_OBJ} ${P_MAIN}.o) ${_LDFLAGS} ${LIBS}
	@\\$(call ECHO_TARGET_DONE)

