#!/bin/sh

# First argument into the script is the manifest file to generate
# Two environment variables are evaluated:
# CLASSPATH : the class path to write into the manifest
# ENTRY_CLASS : the entry class if the manifest is generated for a stand-alone application
[ $# -eq 1 ] || exit 1

MANIFEST=$1

exec 1>"${MANIFEST}"

printf "Manifest-Version: 1.0\nBuilt-By: ${USER}\n"

[ -n "${JTOOL_MANIFEST_CP}" ] && printf "Class-Path: ${JTOOL_MANIFEST_CP}\n"
[ -n "${JTOOL_ENTRY_CLASS}" ] && printf "Main-Class: ${JTOOL_ENTRY_CLASS}\n"

exit 0
