#include <stdio.h>
#include <peripherals.h>


extern int arr[4] ;
extern int LD_SYMBOL_1;

int * g0 = &arr[0];
int * g1 = &arr[1];
int * g2 = &arr[2];
int * g3 = &arr[3];


void __attribute__((noinline,noclone)) checkeq(int * x, int * y) {
	if (x!=y) {
		printf("FAIL!\n");
	} else {
		printf("ok\n");
	}

}

#define useVar(x) asm volatile ("nop" : : "r"(x));

FILE * stdout = &SIM_PRINT_0_FILE;

int main() {

	//================
	// DATA addresses 
	//================

	int * l0 = &arr[0];
	int * l1 = &arr[1];
	int * l2 = &arr[2];
	int * l3 = &arr[3];

	checkeq(g0,l0);
	checkeq(g1,l1);
	checkeq(g2,l2);
	checkeq(g3,l3);

	//================
	// CODE addresses
	//================

	//We can't  have this array be global, because the labels are only visible from inside the function.
	//So instead it's static
	const static void * codeArr[] = {(&&code1)+8};
	//And we use it, so that gcc does not optimize it away
	useVar(codeArr);

	void * codePointer1 = (&&code1) + 8;
	void * codePointer2 = &&code2;

	checkeq((int*)codePointer1, (int*)codePointer2);
	checkeq((int*)codePointer1, (int*)codeArr[0]);



	//Code labels that get referenced above
	code1:
	asm ("nop\nnop\nnop\nnop");
	code2:
	asm ("nop\n");
	return 0;
	
}
