#!/bin/bash
#exit on all errors
set -e

#create temp dir, remove on exit
WORKDIR=`mktemp --directory --tmpdir spmc-scripts.XXXXXX`
trap "rm -rf $WORKDIR" EXIT

SAVEFILE_GROOVY=`readlink -f ../saveFile.groovy`


make -C $SPARTANMC_ROOT newproject +path=$WORKDIR
cp config.jc3 $WORKDIR/config.jc3

cd $WORKDIR

make jconfig +args="-f config.jc3 -q"</dev/null || (echo "Error: Regular jconfig call should not throw exceptions"; exit 1)

(! make jconfig +args="-f config.jc3 -q --script $SAVEFILE_GROOVY" </dev/null) || (echo "Error: jConfig call with saveFile.groovy should throw exception"; exit 1)
