//concentrator - master
#include <peripherals.h>
#include <moduleParameters.h>
#include <stdio.h>
#include <mpsoc.h>
#include <interrupt.h>

#include "../../core0/include/global_vars.h"

unsigned int rec[GLOBAL_AMOUNT_RECEIVES][TOTAL_MESSAGES];	
unsigned int count[GLOBAL_AMOUNT_RECEIVES];
unsigned int id[GLOBAL_AMOUNT_RECEIVES];

void null(){
	
	for(int x=0;x<GLOBAL_AMOUNT_RECEIVES;x++){
		count[x]=0;
		id[x]=0;
		for(int y=0;y<TOTAL_MESSAGES;y++){
			rec[x][y]=0;
		}
	}
}

FILE * stdout = &SIM_PRINT_0_FILE;

int main(){
	//enable all output pins to forward signal to input ports

	for(int k=0; k<=TOTAL_MESSAGES; k=k+GLOBAL_AMOUNT_RECEIVES){
		null();
		for(int i=0; i<GLOBAL_AMOUNT_RECEIVES && (i+k)<TOTAL_MESSAGES; i++){
			concentrator_master_read_data(&CONCENTRATOR_MASTER_0, &rec[i], &count[i], &id[i]);
		}
		
		//check receipt for correctness
		
		for(int i=0; i<GLOBAL_AMOUNT_RECEIVES && (i+k)<TOTAL_MESSAGES; i++){
			unsigned int expectedMsgSize = id[i]+k+1;
			int error = 0;
			if(count[i]!=expectedMsgSize){
					printf("expected msgSize was %d but got %d from slave %d\n", expectedMsgSize, count[i], id[i]);
					error=1;
				}
			for(unsigned int j=0; j<expectedMsgSize; j++){
				if(rec[i][j]!=j){	//wrong entry found
					printf("received %d but expected %d from slave %d with msg_size %d\n", rec[i][j], j, id[i], count[i]);
					error=1;
				}
			}
			if(error != 0) {
				printf("Msg %d from slave %d NOT OK\n",k+i, i);
			}
		}	
	}
	printf("DONE\n");
	while(1);
}
