//concentrator - master
#include <peripherals.h>
#include <moduleParameters.h>
#include <stdio.h>
#include <mpsoc.h>
#include <interrupt.h>

#include "../../core0/include/global_vars.h"

FILE * stdout = &SIM_PRINT_0_FILE;


int main(){
	//enable all output pins to forward signal to input ports
    volatile unsigned int * id=&CONCENTRATOR_MASTER_DMA_0_DMA.data[0];
    volatile unsigned int * count=&CONCENTRATOR_MASTER_DMA_0_DMA.data[1];
    volatile unsigned int * rec=&CONCENTRATOR_MASTER_DMA_0_DMA.data[2];

	for(int k=0; k<=TOTAL_MESSAGES; k=k+GLOBAL_AMOUNT_RECEIVES){

		for(int i=0; i<GLOBAL_AMOUNT_RECEIVES && (i+k)<TOTAL_MESSAGES; i++){
			concentrator_master_dma_read_data(&CONCENTRATOR_MASTER_DMA_0_DMA, rec, count, id);

            unsigned int expectedMsgSize = *id+k+1;
            int error = 0;

            if(*count!=expectedMsgSize){
                printf("expected msgSize was %d but got %d from slave %d\n", expectedMsgSize, *count, *id);
                error=1;
            }
            for(unsigned int j=0; j<expectedMsgSize; j++){
                if(*(rec+j)!=j){	//wrong entry found
                    printf("received %d but expected %d from slave %d with msg_size %d\n", *(rec+j), j, *id, *count);
                    error=1;
                }
            }
            if(error != 0) {
                printf("Msg %d from slave %d NOT OK\n",k+i, i);
            }

            //reset data
            //for(int j=0; j<expectedMsgSize+2; j++){
             //   CONCENTRATOR_MASTER_DMA_0_DMA.data[j] = 0;
            //}
		}

    }

	printf("DONE\n");
	while(1);
}
