//dispatcher - global vars
#define SHOW_WAITS 0
#define DISTRIBUTION_MODE 1	//1: individual receivers, 2: round-robin, 3: load-balancing

#if DISTRIBUTION_MODE == 1
#define DEST (i-1)%ACTIVE_SLAVES_COUNT
#elif DISTRIBUTION_MODE == 2
#define DEST DISPATCH_ROUND_ROBIN
#elif DISTRIBUTION_MODE == 3
#define DEST DISPATCH_LOAD_BALANCING
#endif

#define SCALE_FACTOR 1
#define TOTAL_MESSAGES 128
#define ACTIVE_SLAVES_COUNT 8

#define WAIT_FREE_COUNT 10
#define WAIT_DATA_COUNT 1

//set active cores
#define CORE_1_ACTIVE 1
#if ACTIVE_SLAVES_COUNT > 1
#define CORE_2_ACTIVE 1
#else
#define CORE_2_ACTIVE 0
#endif
#if ACTIVE_SLAVES_COUNT > 2
#define CORE_3_ACTIVE 1
#else
#define CORE_3_ACTIVE 0
#endif
#if ACTIVE_SLAVES_COUNT > 3
#define CORE_4_ACTIVE 1
#else
#define CORE_4_ACTIVE 0
#endif
#if ACTIVE_SLAVES_COUNT > 4
#define CORE_5_ACTIVE 1
#else
#define CORE_5_ACTIVE 0
#endif
#if ACTIVE_SLAVES_COUNT > 5
#define CORE_6_ACTIVE 1
#else
#define CORE_6_ACTIVE 0
#endif
#if ACTIVE_SLAVES_COUNT > 6
#define CORE_7_ACTIVE 1
#else
#define CORE_7_ACTIVE 0
#endif
#if ACTIVE_SLAVES_COUNT > 7
#define CORE_8_ACTIVE 1
#else
#define CORE_8_ACTIVE 0
#endif

#define RECEIVE(id) {\
    int errorGlobal = 0;\
    for (unsigned int i = id-1; i < TOTAL_MESSAGES; i = i + ACTIVE_SLAVES_COUNT) {\
        volatile unsigned int * arr0 = &DISPATCHER_SLAVE_DMA_0_DMA.data[1];\
        volatile unsigned int * count = &DISPATCHER_SLAVE_DMA_0_DMA.data[0];\
        dispatcher_slave_dma_read_data(&DISPATCHER_SLAVE_DMA_0_DMA, arr0, count);\
\
        unsigned int expectedMsgSize = i + 1;\
        unsigned int error = 0;\
        if (*count != expectedMsgSize) {\
            printf("expected msgSize was %d but got %d from master\n", expectedMsgSize, *count);\
            error = 1;\
        }\
        for (unsigned int j = 0; j < expectedMsgSize; j++) {\
            if (arr0[j] != j) { \
                printf("received %d but expected %d \n", arr0[j], j);\
                error = 1;\
            }\
        }\
        if (error != 0) {\
            printf("Msg %d NOT OK\n", i);\
            errorGlobal=1;\
        } \
    }\
    if (errorGlobal == 0) {\
            printf("DONE\n");\
    }\
\
}

