#ifndef _BUFFER_H
#define _BUFFER_H

#include <semaphore.h>

struct netdev;

struct buffer_entry {
	unsigned int state;
	unsigned int size;
	semaphore sem;
	unsigned int data[1020];
};

enum buffer_entry_state {
	BUF_UNUSED = 0,
	BUF_FILTERQUEUE,
	BUF_ALLOWED,
};

extern int globaldata_start;
extern int __GLOBAL_MEM_HEAP_END;
#define NUM_BUFFER_ENTRIES ((&__GLOBAL_MEM_HEAP_END - &globaldata_start) / sizeof(struct buffer_entry))


void buffer_init(void);
int buffer_receive(const struct netdev *dev);
unsigned int *buffer_getdata(int index);
void buffer_setstate(int index, unsigned int state);
void buffer_sendallowed(const struct netdev *dev);

#endif
