#ifndef _FILTER_H
#define _FILTER_H

struct firewall_conf {
	int type;
	int num_rules;
	unsigned int rules[];
};

enum firewall_type {
	ALLOW_ALL,
	DENY_ALL
};

enum rule_type {
	PROTOCOL,
	PORT_TCP,
	PORT_UDP,
	PORT_IP_TCP,
	PORT_IP_UDP,
	PORT_IP6_TCP,
	PORT_IP6_UDP,
	IP_DEST,
	IP_SRC,
	IP6_DEST,
	IP6_SRC,
	IPRANGE_DEST,
	IPRANGE_SRC,
};

enum protocol {
	IPV4,
	IPV6,
	ARP,
	ICMP
};

#define RULE_PROTOCOL(a) PROTOCOL, (a)
#define RULE_PORT_TCP(a) PORT_TCP, (a)
#define RULE_PORT_UDP(a) PORT_UDP, (a)
#define RULE_IP_DEST(a, b, c, d) IP_DEST, ((a) << 8) | (b), ((c) << 8) | (d)
#define RULE_IP_SRC(a, b, c, d) IP_SRC, ((a) << 8) | (b), ((c) << 8) | (d)
#define RULE_IP6_DEST(a, b, c, d, e, f, g, h, i, j, k, l, m, n, o, p) IP6_DEST, ((a) << 8) | (b), ((c) << 8) | (d), ((e) << 8) | (f), ((g) << 8) | (h), ((i) << 8) | (j), ((k) << 8) | (l), ((m) << 8) | (n), ((o) << 8) | (p)
#define RULE_IP6_SRC(a, b, c, d, e, f, g, h, i, j, k, l, m, n, o, p) IP6_SRC, ((a) << 8) | (b), ((c) << 8) | (d), ((e) << 8) | (f), ((g) << 8) | (h), ((i) << 8) | (j), ((k) << 8) | (l), ((m) << 8) | (n), ((o) << 8) | (p)
#define RULE_IPRANGE_DEST(a, b, c, d, e, f, g, h) IPRANGE_DEST, ((a) << 8) | (b), ((c) << 8) | (d), ((e) << 8) | (f), ((g) << 8) | (h)
#define RULE_IPRANGE_SRC(a, b, c, d, e, f, g, h) IPRANGE_SRC, ((a) << 8) | (b), ((c) << 8) | (d), ((e) << 8) | (f), ((g) << 8) | (h)
#define RULE_PORT_IP_TCP(a, b, c, d, e) PORT_IP_TCP, ((a) << 8) | (b), ((c) << 8) | (d), (e)
#define RULE_PORT_IP_UDP(a, b, c, d, e) PORT_IP_UDP, ((a) << 8) | (b), ((c) << 8) | (d), (e)
#define RULE_PORT_IP6_TCP(a, b, c, d, e, f, g, h, i, j, k, l, m, n, o, p, q) PORT_IP6_TCP, ((a) << 8) | (b), ((c) << 8) | (d), ((e) << 8) | (f), ((g) << 8) | (h), ((i) << 8) | (j), ((k) << 8) | (l), ((m) << 8) | (n), ((o) << 8) | (p), (q)
#define RULE_PORT_IP6_UDP(a, b, c, d, e, f, g, h, i, j, k, l, m, n, o, p, q) PORT_IP6_UDP, ((a) << 8) | (b), ((c) << 8) | (d), ((e) << 8) | (f), ((g) << 8) | (h), ((i) << 8) | (j), ((k) << 8) | (l), ((m) << 8) | (n), ((o) << 8) | (p), (q)

void filter(int buf_index);

#endif
