#ifndef _NETWORK_H
#define _NETWORK_H

#include <peripherals/ethernet_rx.h>
#include <peripherals/ethernet_tx.h>
#include <peripherals/mdio.h>

struct netdev {
	int id;
	unsigned int phy_addr;
	
	mdio_regs_t *mdio;
	ethernet_rx_regs_t *rx;
	ethernet_tx_regs_t *tx;
	ethernet_rx_dma_t  *rx_dma;
	ethernet_tx_dma_t  *tx_dma;
};

void network_init(const struct netdev *dev);
void network_wait_ready(const struct netdev *dev);
int network_receive(const struct netdev *dev, unsigned int *buf);
void network_send(const struct netdev *dev, unsigned int *data, unsigned int size);

#endif
