#include <stddef.h>

#include "buffer.h"

int globaldata_start __attribute__((section(".globaldata")));
static struct buffer_entry *buffer = (void*)&globaldata_start;


void buffer_init(void)
{
	int idx;

	for(idx = 0; idx < NUM_BUFFER_ENTRIES; idx++) {
		buffer[idx].state = BUF_UNUSED;
		buffer[idx].size = 0;
		buffer[idx].sem.m = OPEN;
		buffer[idx].sem.counter = 1;
	}

	return;
}

unsigned int *buffer_getdata(int index)
{
	return buffer[index].data;
}

void buffer_setstate(int index, unsigned int state)
{
	down(&buffer[index].sem);
	buffer[index].state = state;
	up(&buffer[index].sem);
}
