/*
 * buffer_sendallowed.c
 *
 *  Created on: 06.07.2017
 *      Author: laurenzk
 */

#include <stddef.h>

#include "buffer.h"
#include "network.h"

static struct buffer_entry *buffer = (void*)&globaldata_start;

void buffer_sendallowed(const struct netdev *dev)
{
	int i;

	for(i = 0; i < NUM_BUFFER_ENTRIES; i++) {
		if(buffer[i].state == BUF_ALLOWED) {
			network_send(dev, buffer[i].data, buffer[i].size);
			buffer[i].state = BUF_UNUSED;
		}
	}
}

int buffer_receive(const struct netdev *dev)
{
	int idx, framesize;
	struct buffer_entry *b = NULL;

	// Find free entry in the buffer.
	for(idx = 0; idx < NUM_BUFFER_ENTRIES; idx++) {
		if(buffer[idx].state == BUF_UNUSED) {
			b = &buffer[idx];
			break;
		}
	}

	if(b == NULL) {
		// No free buffer entry found.
		return -2;
	}

	// Receive frame from network.
	framesize = network_receive(dev, b->data);

	if(framesize == 0) {
		return -1;
	}

	b->state = BUF_FILTERQUEUE;
	b->size = framesize;

	return idx;
}
