

#include <stddef.h>
#include <string.h>
#include <stdio.h>
#include <perf.h>
#include <peripherals.h>

#include "eval.h"
#include "buffer.h"

#include "eval_data.h"

static struct buffer_entry *buffer = (void*)&globaldata_start;
static char recvbuf[1500];

#define EVAL_ROUNDS 2

int eval_buffer_receive(int i)
{
	int idx, framesize;
	struct buffer_entry *b = NULL;

	if(i > (num_packets * EVAL_ROUNDS)) {
		return -1; // No more packets.
	}

	// Find free entry in the buffer.
	for(idx = 0; idx < NUM_BUFFER_ENTRIES; idx++) {
		down(&buffer[idx].sem);
		if(buffer[idx].state == BUF_UNUSED) {
			b = &buffer[idx];
			break;
		}
		up(&buffer[idx].sem);
	}

	if(b == NULL) {
		// No free buffer entry found.
		return -2;
	}

	int pi = i % num_packets;

	// Receive frame from eval data.
	framesize = packets[pi].headerlen + packets[pi].payloadlen;
	memcpy(b->data, packets[pi].data, packets[pi].headerlen);
	memcpy(((char*)b->data) + packets[pi].headerlen, recvbuf, packets[pi].payloadlen);

	if(i >= (num_packets * EVAL_ROUNDS)) {
		b->size = -1; // Mark last packet.
		b->state = BUF_UNUSED;
	} else {
		b->size = framesize;
		b->state = BUF_FILTERQUEUE;
	}

	up(&buffer[idx].sem);

	return idx;
}
