

#include <stddef.h>
#include <string.h>
#include <stdio.h>
#include <perf.h>
#include <peripherals.h>

#include "eval.h"
#include "buffer.h"

static struct buffer_entry *buffer = (void*)&globaldata_start;
static int sendcounter, invcounter;

#define EVAL_ROUNDS 10

static void eval_start(void)
{
	//stdio_uart_light_open(&UART_LIGHT_0);
	printf("Evaluation started.\n");

	struct ccnt_conf c;
	c.intr_filter = 0;
	c.prescaler = 0;

	perf_init_ccnt(0, &c);

	perf_start(0);
}

static void eval_stop(void)
{
	perf_stop(0);
	printf("Evaluation stopped.\n");
	printf("    %lu cycles.\n", perf_read_ccnt(0, NULL));
	printf("    %u packets sent.\n", sendcounter);
	printf("    %u invalid packets.\n", invcounter);

	while(1);
}

void eval_buffer_sendallowed(void)
{
	int i;
	int hasqueued = 0;
	int haslastpacket = 0;
	static int started = 0;

	if(started == 0) {
		eval_start();
		started = 1;
		sendcounter = 0;
		invcounter = 0;
	}

	for(i = 0; i < NUM_BUFFER_ENTRIES; i++) {
		down(&buffer[i].sem);

		if(buffer[i].state == BUF_ALLOWED) {
			buffer[i].state = BUF_UNUSED;
			sendcounter++;
		} else if(buffer[i].state == BUF_FILTERQUEUE) {
			hasqueued++;
		} else if(buffer[i].state == BUF_UNUSED) {
			if(buffer[i].size == -1) {
				haslastpacket = 1;
			}
		} else {
			invcounter++;
		}

		up(&buffer[i].sem);
	}

	//printf("%d %d %d\n", haslastpacket, hasqueued, invalid);

	if(haslastpacket && !hasqueued) {
		eval_stop();
	}
}
