/*
 * platform_mdio_init.c
 *
 *  Created on: 06.07.2017
 *      Author: laurenzk
 */


#include <peripherals.h>
#include <ethlib.h>

#include "platform.h"

extern struct netdev eth0;
extern struct netdev eth1;

void platform_mdio_init(void)
{
	unsigned int regval;

	/* Configure PHY0. */
	// Wait for PHY to finish reset.
	do {
		mdio_read(eth0.mdio, eth0.phy_addr, 0, &regval);
	} while(regval & 0x8000);

	mdio_write(eth0.mdio, eth0.phy_addr, 0x09, 0x00); // Disable gigabit
	regval = (0 << 6) | (1 << 13) | // 100 Mbit speed
	         (1 << 12) | // auto-negotiation.
	         (1 << 9) | // Trigger autoneg
	         (1 << 8); // Full duplex mode.
	mdio_write(eth0.mdio, eth0.phy_addr, 0, regval);
	mdio_write(eth0.mdio, eth0.phy_addr, 0x1F, 1 << 14); // Restart software

	/* Configure PHY1. */
	// Wait for PHY to finish reset.
	do {
		mdio_read(eth1.mdio, eth1.phy_addr, 0, &regval);
	} while(regval & 0x8000);

	mdio_write(eth1.mdio, eth1.phy_addr, 0x09, 0x00); // Disable gigabit
	regval = (0 << 6) | (1 << 13) | // 100 Mbit speed
	         (1 << 12) | // auto-negotiation.
	         (1 << 9) | // Trigger autoneg
	         (1 << 8); // Full duplex mode.
	mdio_write(eth1.mdio, eth1.phy_addr, 0, regval);
	mdio_write(eth1.mdio, eth1.phy_addr, 0x1F, 1 << 14); // Restart software

	return;
}
