#include <subsystems/spartanmc_0/peripherals.h>
#include <stdio.h>
#include <interrupt.h>

//PORT_OUT_0 needs to be one bit wide and be directly connected to the interrupt controller

//Expected output:
//  1
//  2
//  3

//Actual output:
//  1
//  2
//  1
//  2
//  1
//  2
// (and so on)

FILE * stdout = &UART_LIGHT_0_FILE;

void main() {

	PORT_OUT_0.oe=1;
	interrupt_enable();
	printf("1\n");
	
	//Interrupt
	PORT_OUT_0.data=1;

	//Force forwarding of reg A
	asm volatile (
		"nop\n\t"
		"XOR r4, r4\n\t"
		//Interrupt here. Return address is wrong!
		"NOT r4, r4\n\t"
		:/* no output registers */
		: /* no input registers */
		:"r4");

	printf("3\n");
}


ISR(0)() {
	printf("2\n");
	//Reset interrupt
	PORT_OUT_0.data=0;
}
