#include <stdio.h>
#include <peripherals.h>
#include <interrupt.h>
#include "moduleParameters.h"

//Forbid inlining, otherwise the function is forbidden, but the inlined version is not
void __attribute__((noinline)) forbiddenFunction() {

    printf("this should not get printed.\n");
}

volatile int notWritable[3] = {5,6,7};
volatile int notReadable = 5;


ISR(0)() {
    memguard_print(&MEMGUARD_0);
}

//A function with a read in its first instruction
int externalRead(int * addr) ;

FILE * stdout = &SIM_PRINT_0_FILE;

void main() {
    memguard_configure_watcher(&MEMGUARD_0, 0, (void*)&notReadable, 1, MEMGUARD_ALLOW_WR | MEMGUARD_ALLOW_CODE);
    memguard_configure_watcher(&MEMGUARD_0, 1, (void*)&notWritable, 2, MEMGUARD_ALLOW_RD | MEMGUARD_ALLOW_CODE);
    //Double ptr to change from code addr to data addr
    memguard_configure_watcher(&MEMGUARD_0, 2, CODE_TO_DATA(forbiddenFunction), 1, MEMGUARD_ALLOW_RD | MEMGUARD_ALLOW_WR);
    memguard_info(&MEMGUARD_0,SB_MEMGUARD_0_NUM_WATCHERS);
    interrupt_enable();

    printf("not readable = %d\n",notReadable);
    memguard_enable(&MEMGUARD_0, 1);
    printf("not readable = %d\n",notReadable);

    //Check that the address in the error message has the right pc
    printf("%X ",(unsigned int)externalRead);
    externalRead((int * )&notReadable);


    printf("not writable[0] = %d\n",notWritable[0]);
    printf("not writable[1] = %d\n",notWritable[1]);
    printf("not writable[2] = %d\n",notWritable[2]);
    notWritable[0] = 10;
    notWritable[1] = 10;
    notWritable[2] = 10;
    printf("not writable[0] = %d\n",notWritable[0]);
    printf("not writable[1] = %d\n",notWritable[1]);
    printf("not writable[2] = %d\n",notWritable[2]);

    forbiddenFunction();
}


