#ifndef __GLOBALS_H__
#define __GLOBALS_H__

#ifdef spartanmc
typedef int imgtype;
#else
typedef short int imgtype;
#endif

#ifndef WIDTH
#define WIDTH 128
#endif

#if WIDTH==64
#define IMG_SIZE 4096  /* 262144, 65536 16384 4096*/
#elif WIDTH==128
#define IMG_SIZE 16384  /* 262144, 65536 16384 4096*/
#elif WIDTH==256
#define IMG_SIZE 65536  /* 262144, 65536 16384 4096*/
#elif WIDTH==512
#define IMG_SIZE 262144  /* 262144, 65536 16384 4096*/
#endif

#define COL WIDTH

#define BLOCK_SIZE COL/4 /*used 3 times, no need to initialize*/

#define NBLKS 10
#define BLKS_SAVED 7
#define ZERO_MARK 16

#define min(a,b) ((a<b)?(a):(b))
#define max(a,b) ((a>b)?(a):(b))
#define my_abs(x) ((x>0)? (x):(0-x))

/* I/O Variables */
#define DEFAULT_CRATIO 128         /* Default Compression Level */

/* Wavelet variables */
#define ROW 1

#define MEMDUMP_BM_INT_AS_SHORT 8
#define MEMDUMP_BM_SWAP 16

#endif