#!/bin/bash

#exit on all errors
set -e

#create temp dir, remove on exit
WORKDIR=`mktemp --directory --tmpdir spmc-modifyModule.XXXXXX`
trap "rm -rf $WORKDIR" EXIT

#generate project
make -C $SPARTANMC_ROOT newproject +path=$WORKDIR
mkdir $WORKDIR/hardware
cp template.jc3 $WORKDIR/config.jc3
cp test_dyn.module.xml $WORKDIR/hardware/

cd $WORKDIR
make newfirmware +path=firmware
make jconfig +args="-f config.jc3 -q -u"

echo "<!-- asdf --> " >> hardware/test_dyn.module.xml

mkdir -p build
make jconfig_update +args="-a" 2>&1 | tee build/jcOutput1.txt
(! grep -q "Written: 0 groups" build/jcOutput1.txt) || (echo "Error: JConfig should update when module is changed."; exit 1)

make jconfig_update 2>&1 | tee build/jcOutput2.txt
grep -q "Written: 0 groups" build/jcOutput2.txt || (echo "Error: JConfig should not update anything when called again with the same input."; exit 1)
