#!/bin/bash

#exit on all errors
set -e

#create temp dir, remove on exit
WORKDIR=`mktemp --directory --tmpdir spmc-moveproject.XXXXXX`
trap "rm -rf $WORKDIR" EXIT

LOC1=$WORKDIR/loc1
LOC2=$WORKDIR/loc2


#generate project
make -C $SPARTANMC_ROOT newproject +path=$LOC1
cp template.jc3 $LOC1/config.jc3
pushd $LOC1
make newfirmware +path=firmware
make jconfig +args="-f config.jc3 -q -u"
popd

#move project
mv $LOC1 $LOC2


#generate jConfig files again
pushd $LOC2
make jconfig +args="-q -u"
popd
