import difflib.DiffUtils;
import difflib.Patch;
import java.util.stream.Collectors;
import java.nio.file.Files;
import java.nio.file.StandardCopyOption;


h = project.documentHandler
origLocation = h.saveLocation

//If you just updated jConfig to save something differently, all tests will fail
//Set this to true to replace all saved files with the updated version
expectDiff = false

buildDir = h.saveLocation.resolveSibling("build")
Files.createDirectories(buildDir)
tempLocation = buildDir.resolve("configTemp.jc3"); 

h.saveLocation = tempLocation
h.save()
h.saveLocation = origLocation


expectedLines = origLocation.readLines()
Patch<String> patch = DiffUtils.diff(expectedLines, tempLocation.readLines());

if (!patch.getDeltas().isEmpty()) {
	if (expectDiff) {
		println("Config file has changed, updating original")
		Files.copy(tempLocation, origLocation, StandardCopyOption.REPLACE_EXISTING)
	} else {
		diff = DiffUtils.generateUnifiedDiff(origLocation.toString(), tempLocation.toString(), expectedLines, patch, 3)
		final String diffStr = diff.stream().collect(Collectors.joining("\n"));
		throw new RuntimeException("File should be identical when saved again, but has differences:\n"+diffStr);
	}
}
