#!/bin/bash

#exit on all errors
set -e

#create temp dir, remove on exit
WORKDIR=`mktemp --directory --tmpdir spmc-scripts.XXXXXX`
trap "rm -rf $WORKDIR" EXIT

TESTCASE_MK=`readlink -f ../testcase.mk`

#generate project
make -C $SPARTANMC_ROOT newproject +path=$WORKDIR
cp test.groovy $WORKDIR/test.groovy
cp main.c $WORKDIR/main.c
cd $WORKDIR
make newfirmware +path=firmware
mv main.c firmware/src/main.c

#Run JConfig
make jconfig +args="--script test.groovy -q -t SP601" </dev/null

make newsim +path=sim

#remove endmodule
sed -i '/endmodule/d' sim/testbench.v
#append reset generation
echo "initial begin
clk_xilinx_0_reset = 1;
#100 clk_xilinx_0_reset = 0;
end
endmodule" >> sim/testbench.v

touch sim/wave.do

sed -i "s/include/SIM_HOME:=\$(abspath sim)\ninclude/" Makefile
echo "include $TESTCASE_MK" >> Makefile

mkdir -p expected/sim
echo "hello world">expected/sim/spartanmc_0.txt

make testSim
