#include <stdio.h>
#include <peripherals.h>
#include <perf.h>
#include <sleep.h>
#include <moduleParameters.h>

DEFINE_SLEEP_MS(sleep_ms,SB_SPARTANMC_0_FREQUENCY)
DEFINE_SLEEP_US(sleep_us,SB_SPARTANMC_0_FREQUENCY)


void measureSleep(int len) {
	perf_reset();
	perf_start(0);
	sleep_us(len);
	perf_stop(0);

	struct perf_result x;
	perf_read(&x);
	int expected = CYCLES_PER_US(SB_SPARTANMC_0_FREQUENCY*len);
	long diff = x.cycles[0].counter - expected;
	if (diff<0)
		diff = -diff;

	if (diff>10)
		printf("big diff at %d: %d\n",len,(int)diff);
	else
		printf("%d ok\n",len);
}

FILE * stdout = &SIM_PRINT_0_FILE;

void main() {
	struct perf_conf c ;
	c.cycle[0].prescaler = 0;
	perf_init(&c);

	for (int i=0;i<=100;i+=5) {
		measureSleep(i);
	}

}
