#include <stdio.h>
#include <peripherals.h>

FILE * stdout = &SIM_PRINT_0_FILE;


//Verify that two DMA memories are correctly initialized

testdma_dma_t TESTDMA_0_DMA __attribute__((section(".dma.testdma_0"))) = {
	.data                 = {0x31234, 0x15678}
};

testdma_dma_t TESTDMA_1_DMA __attribute__((section(".dma.testdma_1"))) = {
	.data                 = {0x29abc, 0xdef0}
};

#include "usb_init.h"

int read(testdma_regs_t * t, int addr) {
	t->addr = addr;
	return t->data;
}


void write(testdma_regs_t * t, int addr, int data) {
	t->addr = addr;
	t->data = data;
}


void __attribute__((noinline, noclone)) use(int data) {
	data;
}

void main() {
    printf("dma 0: %x %x\n",TESTDMA_0_DMA.data[0],TESTDMA_0_DMA.data[1]);
    printf("dma 1: %x %x\n",TESTDMA_1_DMA.data[0],TESTDMA_1_DMA.data[1]);
    printf("peri0: %x %x\n",read(&TESTDMA_0,0),read(&TESTDMA_0,1));
    printf("peri1: %x %x\n",read(&TESTDMA_1,0),read(&TESTDMA_1,1));

    use(USB11_0_DMA.data01[1]);
}
