#!/bin/bash

MEMSIZE=4
TARGET="nexys"
SCRIPT_FILE="setmem.groovy"
ADDITIONAL_SCRIPT=""
BUILD=""

while [[ $# -gt 0 ]]
do
key="$1"

case $key in
    -m|--memsize)
    MEMSIZE="$2"
    shift # past argument
    shift # past value
    ;;
    -t|--target)
    TARGET="$2"
    shift # past argument
    shift # past value
    ;;
	-s|--script)
    ADDITIONAL_SCRIPT="$2"
    shift # past argument
    shift # past value
    ;;
	-b|--buildsilent)
    BUILD="-u -a -q --config-file import.jc3"
    shift # past argument
    ;;
    *)    # unknown option
    POSITIONAL+=("$1") # save it in an array for later
    shift # past argument
    ;;
esac
done

echo "MemUtils.setAllMemorySize(document, $MEMSIZE)" > $SCRIPT_FILE

make jconfig +args="-i hardware.xml -t $TARGET --script $SCRIPT_FILE,$ADDITIONAL_SCRIPT $BUILD"