module rapidsocTestTristate(
input wire clk,
input wire tristateData,
input wire tristateDataDirect,
input wire tristateSelect,
input wire tristateSelectDirect,

output wire tristateRead,
output wire tristateReadDirect,

inout wire tristate,
inout wire tristateDirect
);

wire tristateReadInt;
wire tristateSelectReg;
wire tristateDataReg;

(* KEEP_HIERARCHY = "yes" *)
FDRE test_fdre_inst1(.C(clk), .D(tristateSelect), .Q(tristateSelectReg), .R(), .CE());
(* KEEP_HIERARCHY = "yes" *)
FDRE test_fdre_inst2(.C(clk), .D(tristateData), .Q(tristateDataReg), .R(), .CE());
(* KEEP_HIERARCHY = "yes" *)
FDRE test_fdre_inst3(.C(clk), .D(tristateReadInt), .Q(tristateRead), .R(), .CE());

assign tristate = tristateSelectReg ? 1'bz : tristateDataReg;
assign tristateDirect = tristateSelectDirect ? 1'bz : tristateDataDirect;


assign tristateReadInt = tristate;
assign tristateReadDirect = tristateDirect;

endmodule
