#!/bin/sh

INSTALL_DIR="$SPARTANMC_TOOLS"
ECHO="echo"

if [ ! -f $SPARTANMC_BINUTILS_SRC/opcodes/spmc-dis.c ]; then
	$ECHO "\033[1m\033[31mSPARTANMC_BINUTILS_SRC\033[0m is set to an invalid directory!"
	exit 1;
else
	cd $SPARTANMC_BINUTILS_SRC
	if test -d $INSTALL_DIR; then
		if [ -f $INSTALL_DIR/bin/spartanmc-objdump ]; then
			$ECHO "Binutils are already installed at $INSTALL_DIR \n Press what shall be done? \n (o)verwrite installation \n (c)lean directory and install \n (a)bort installation"
                	read action
                	case "$action" in
				o) 	$ECHO "Overwriting installation"
				;;
				c) 	$ECHO "Remove install directory"
				   	rm -rf $INSTALL_DIR/*
					make clean
					make distclean
					mkdir -p $INSTALL_DIR
				;;
				*) 	$ECHO "Aborting installation"
					exit 0
				;;
			esac
		fi	
	else
		mkdir -p $INSTALL_DIR
	fi
	$ECHO "Starting installation"	
	./configure  --target=spartanmc --prefix=$INSTALL_DIR --disable-werror
	make
	make install 
	exit 0
fi
