#!/bin/sh

INSTALL_DIR="$SPARTANMC_TOOLS"
ECHO="echo"

if [ ! -f $SPARTANMC_GCC_SRC/build-spmc-gcc.sh ]; then
	echo "\033[1m\033[31mSPARTANMC_GCC_SRC\033[0m is set to an invalid directory!"
	exit 0
elif [ ! -f $INSTALL_DIR/bin/spartanmc-as ]; then
	echo "No installation of Binutils found at: $INSTALL_DIR \nPlease install Binutils first to this location."
	exit 0
else
        cd $SPARTANMC_GCC_SRC
        if test -d $INSTALL_DIR; then
                if [ -f $INSTALL_DIR/bin/spartanmc-gcc ]; then
                        $ECHO "GCC is already installed at $INSTALL_DIR \n Choose what shall be done? \n (o)verwrite installation \n (a)bort installation"
                        read action
                        case "$action" in
                                o)      $ECHO "Overwriting installation"
                                ;;
                                *)      $ECHO "Aborting installation"
                                        exit 0
                                ;;
                        esac
                fi      
        else
                mkdir -p $INSTALL_DIR
        fi
        $ECHO "Starting installation"
        ./build-spmc-gcc.sh "-i $INSTALL_DIR"
        exit 0
fi

