/**
 * _______________________________________________________________________________
 *
 *  Copyright (c) 2012 TU Dresden, Chair for Embedded Systems
 *  Copyright (c) 2013-2016 TU Darmstadt, Computer Systems Group
 *  (http://www.rs.tu-darmstadt.de) All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions
 *  are met:
 *
 *  1. Redistributions of source code must retain the above copyright
 *     notice, this list of conditions and the following disclaimer.
 *
 *  2. Redistributions in binary form must reproduce the above copyright
 *     notice, this list of conditions and the following disclaimer in the
 *     documentation and/or other materials provided with the distribution.
 *
 *  3. All advertising materials mentioning features or use of this software
 *     must display the following acknowledgement: "This product includes
 *     software developed by the TU Dresden Chair for Embedded Systems, TU Darmstadt Computer Systems Group and
 *     its contributors."
 *
 *  4. Neither the name of the TU Dresden Chair for Embedded Systems, TU Darmstadt Computer Systems Group nor the
 *     names of its contributors may be used to endorse or promote products
 *     derived from this software without specific prior written permission.
 *
 *  THIS SOFTWARE IS PROVIDED BY TU DRESDEN CHAIR FOR EMBEDDED SYSTEMS, TU DARMSTADT COMPUTER SYSTEMS GROUP AND
 *  CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING,
 *  BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
 *  FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 *  REGENTS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 *  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
 *  TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 *  PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 *  LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 *  NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 *  SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * _______________________________________________________________________________
 */
`default_nettype none

// TU-Logo in weiss auf schwarzem Hintergrund
`ifdef toolchain_ise

defparam    MEMORIES.GRAPH.BRAM_ARRAY[8].BRAM.ram_9_inst.INIT_3F = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[8].BRAM.ram_9_inst.INIT_3E = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[8].BRAM.ram_9_inst.INIT_3D = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[8].BRAM.ram_9_inst.INIT_3C = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[8].BRAM.ram_9_inst.INIT_3B = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[8].BRAM.ram_9_inst.INIT_3A = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[8].BRAM.ram_9_inst.INIT_39 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[8].BRAM.ram_9_inst.INIT_38 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[8].BRAM.ram_9_inst.INIT_37 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[8].BRAM.ram_9_inst.INIT_36 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[8].BRAM.ram_9_inst.INIT_35 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[8].BRAM.ram_9_inst.INIT_34 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[8].BRAM.ram_9_inst.INIT_33 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[8].BRAM.ram_9_inst.INIT_32 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[8].BRAM.ram_9_inst.INIT_31 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[8].BRAM.ram_9_inst.INIT_30 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[8].BRAM.ram_9_inst.INIT_2F = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[8].BRAM.ram_9_inst.INIT_2E = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[8].BRAM.ram_9_inst.INIT_2D = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[8].BRAM.ram_9_inst.INIT_2C = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[8].BRAM.ram_9_inst.INIT_2B = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[8].BRAM.ram_9_inst.INIT_2A = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[8].BRAM.ram_9_inst.INIT_29 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[8].BRAM.ram_9_inst.INIT_28 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[8].BRAM.ram_9_inst.INIT_27 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[8].BRAM.ram_9_inst.INIT_26 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[8].BRAM.ram_9_inst.INIT_25 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[8].BRAM.ram_9_inst.INIT_24 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[8].BRAM.ram_9_inst.INIT_23 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[8].BRAM.ram_9_inst.INIT_22 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[8].BRAM.ram_9_inst.INIT_21 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[8].BRAM.ram_9_inst.INIT_20 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[8].BRAM.ram_9_inst.INIT_1F = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[8].BRAM.ram_9_inst.INIT_1E = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[8].BRAM.ram_9_inst.INIT_1D = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[8].BRAM.ram_9_inst.INIT_1C = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[8].BRAM.ram_9_inst.INIT_1B = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[8].BRAM.ram_9_inst.INIT_1A = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[8].BRAM.ram_9_inst.INIT_19 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[8].BRAM.ram_9_inst.INIT_18 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[8].BRAM.ram_9_inst.INIT_17 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[8].BRAM.ram_9_inst.INIT_16 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[8].BRAM.ram_9_inst.INIT_15 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[8].BRAM.ram_9_inst.INIT_14 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[8].BRAM.ram_9_inst.INIT_13 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[8].BRAM.ram_9_inst.INIT_12 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[8].BRAM.ram_9_inst.INIT_11 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[8].BRAM.ram_9_inst.INIT_10 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[8].BRAM.ram_9_inst.INIT_0F = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[8].BRAM.ram_9_inst.INIT_0E = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[8].BRAM.ram_9_inst.INIT_0D = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[8].BRAM.ram_9_inst.INIT_0C = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[8].BRAM.ram_9_inst.INIT_0B = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[8].BRAM.ram_9_inst.INIT_0A = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[8].BRAM.ram_9_inst.INIT_09 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[8].BRAM.ram_9_inst.INIT_08 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[8].BRAM.ram_9_inst.INIT_07 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[8].BRAM.ram_9_inst.INIT_06 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[8].BRAM.ram_9_inst.INIT_05 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[8].BRAM.ram_9_inst.INIT_04 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[8].BRAM.ram_9_inst.INIT_03 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[8].BRAM.ram_9_inst.INIT_02 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[8].BRAM.ram_9_inst.INIT_01 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[8].BRAM.ram_9_inst.INIT_00 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[8].BRAM.ram_9_inst.INITP_07 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[8].BRAM.ram_9_inst.INITP_06 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[8].BRAM.ram_9_inst.INITP_05 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[8].BRAM.ram_9_inst.INITP_04 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[8].BRAM.ram_9_inst.INITP_03 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[8].BRAM.ram_9_inst.INITP_02 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[8].BRAM.ram_9_inst.INITP_01 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[8].BRAM.ram_9_inst.INITP_00 = 256'h0000000000000000000000000000000000000000000000000000000000000000;

defparam    MEMORIES.GRAPH.BRAM_ARRAY[2].BRAM.ram_9_inst.INIT_3F = 256'hc00000003ff003ffc003ff00fffff000ffc0000ff000000000fff00000003ff0;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[2].BRAM.ram_9_inst.INIT_3E = 256'h00003ff00000000000000000000ff00ff0000000000000003fc03fc000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[2].BRAM.ram_9_inst.INIT_3D = 256'h000000ffc003ff00003ff000000000ffc00000000ffc03ffc003ff00fffff000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[2].BRAM.ram_9_inst.INIT_3C = 256'hffc0000ff000000000ffc00000003ff000003ff000000000000000000003fc03;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[2].BRAM.ram_9_inst.INIT_3B = 256'hffffffffffffffffff00ff0000000000000000ffc003ff00003ff00fff0003ff;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[2].BRAM.ram_9_inst.INIT_3A = 256'hc00000000ffc03ffc003ff003ffff000ffc0000ff003ff0000ffc00000003ff0;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[2].BRAM.ram_9_inst.INIT_39 = 256'h00003ff000000000000000000000ff00fffffffffffffffffc03fc0000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[2].BRAM.ram_9_inst.INIT_38 = 256'h000000ffc003ff00003ff003ff0003ff000000000ff003ffc003ff003ffff000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[2].BRAM.ram_9_inst.INIT_37 = 256'hffc0000ff003ffc000ffc00000003ff000003ff0000000000000000000003fc0;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[2].BRAM.ram_9_inst.INIT_36 = 256'h3ffffffffffffffff00ff00000000000000000ffc003ff00003ff003ffc00fff;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[2].BRAM.ram_9_inst.INIT_35 = 256'h0000f0003ff003ffc003ff000ffff000ffc0000ff000ffc003ffc00000003ff0;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[2].BRAM.ram_9_inst.INIT_34 = 256'h00003ff0000000000000000000000ff00000000000000000003fc00000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[2].BRAM.ram_9_inst.INIT_33 = 256'hffffffffc003ff00003ff003ffffffff0003ffc3fff003ffc003ff0003fff000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[2].BRAM.ram_9_inst.INIT_32 = 256'hffc0000ff000ffffffff000ffffffff003ffffffffc0000000000000000003fc;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[2].BRAM.ram_9_inst.INIT_31 = 256'h000000000000000000ff000000000000ffffffffc003ff00003ff000fffffffc;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[2].BRAM.ram_9_inst.INIT_30 = 256'h000fffffffc003ffc003ff0003fff000ffc0000ff0003fffffff000ffffffff0;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[2].BRAM.ram_9_inst.INIT_2F = 256'h03ffffffffc0000000000000000000ff000000000000000003fc000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[2].BRAM.ram_9_inst.INIT_2E = 256'hffffffffc003ff00003ff0003ffffff0000fffffffc003ffc003ff0000fff000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[2].BRAM.ram_9_inst.INIT_2D = 256'hffc0000ff0000ffffffc000ffffffff003ffffffffc00000000000000000003f;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[2].BRAM.ram_9_inst.INIT_2C = 256'hfffffffffffffffffff0000000000000ffffffffc003ff00003ff0000fffffc0;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[2].BRAM.ram_9_inst.INIT_2B = 256'h0000fffffc0003ffc003ff00003ff000ffc0000ff00003fffff0000ffffffff0;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[2].BRAM.ram_9_inst.INIT_2A = 256'h03ffffffffc00000000000000000000fffffffffffffffffffc0000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[2].BRAM.ram_9_inst.INIT_29 = 256'hffffffffc003ff00003ff000003ff00000000fffc00003ffc003ff00003ff000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[2].BRAM.ram_9_inst.INIT_28 = 256'hffc0000ff000003ffc00000ffffffff003ffffffffc000000000000000000003;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[2].BRAM.ram_9_inst.INIT_27 = 256'hffffffffffffffffff0000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[2].BRAM.ram_9_inst.INIT_26 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[2].BRAM.ram_9_inst.INIT_25 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[2].BRAM.ram_9_inst.INIT_24 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[2].BRAM.ram_9_inst.INIT_23 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[2].BRAM.ram_9_inst.INIT_22 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[2].BRAM.ram_9_inst.INIT_21 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[2].BRAM.ram_9_inst.INIT_20 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[2].BRAM.ram_9_inst.INIT_1F = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[2].BRAM.ram_9_inst.INIT_1E = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[2].BRAM.ram_9_inst.INIT_1D = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[2].BRAM.ram_9_inst.INIT_1C = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[2].BRAM.ram_9_inst.INIT_1B = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[2].BRAM.ram_9_inst.INIT_1A = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[2].BRAM.ram_9_inst.INIT_19 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[2].BRAM.ram_9_inst.INIT_18 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[2].BRAM.ram_9_inst.INIT_17 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[2].BRAM.ram_9_inst.INIT_16 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[2].BRAM.ram_9_inst.INIT_15 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[2].BRAM.ram_9_inst.INIT_14 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[2].BRAM.ram_9_inst.INIT_13 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[2].BRAM.ram_9_inst.INIT_12 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[2].BRAM.ram_9_inst.INIT_11 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[2].BRAM.ram_9_inst.INIT_10 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[2].BRAM.ram_9_inst.INIT_0F = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[2].BRAM.ram_9_inst.INIT_0E = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[2].BRAM.ram_9_inst.INIT_0D = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[2].BRAM.ram_9_inst.INIT_0C = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[2].BRAM.ram_9_inst.INIT_0B = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[2].BRAM.ram_9_inst.INIT_0A = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[2].BRAM.ram_9_inst.INIT_09 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[2].BRAM.ram_9_inst.INIT_08 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[2].BRAM.ram_9_inst.INIT_07 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[2].BRAM.ram_9_inst.INIT_06 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[2].BRAM.ram_9_inst.INIT_05 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[2].BRAM.ram_9_inst.INIT_04 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[2].BRAM.ram_9_inst.INIT_03 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[2].BRAM.ram_9_inst.INIT_02 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[2].BRAM.ram_9_inst.INIT_01 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[2].BRAM.ram_9_inst.INIT_00 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[2].BRAM.ram_9_inst.INITP_07 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[2].BRAM.ram_9_inst.INITP_06 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[2].BRAM.ram_9_inst.INITP_05 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[2].BRAM.ram_9_inst.INITP_04 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[2].BRAM.ram_9_inst.INITP_03 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[2].BRAM.ram_9_inst.INITP_02 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[2].BRAM.ram_9_inst.INITP_01 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[2].BRAM.ram_9_inst.INITP_00 = 256'h0000000000000000000000000000000000000000000000000000000000000000;

defparam    MEMORIES.GRAPH.BRAM_ARRAY[3].BRAM.ram_9_inst.INIT_3F = 256'h0ffc0000ffc0000003f0000000000000003f0000000003f0000000000000003f;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[3].BRAM.ram_9_inst.INIT_3E = 256'h3ffffffffc0003fc0003ffffffffc03ff0000fffffc00000fffffffc03ffffff;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[3].BRAM.ram_9_inst.INIT_3D = 256'hff00ffc0000ffc03ff003ffc0000ffc00ffc0000ffc0000003f0000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[3].BRAM.ram_9_inst.INIT_3C = 256'h003f0000000003f0000000000000003f00000000003fc0003fc0000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[3].BRAM.ram_9_inst.INIT_3B = 256'h0000003ff0000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[3].BRAM.ram_9_inst.INIT_3A = 256'h000000000000000003f03fffffffffffffff0000000003fffffffffffffff03f;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[3].BRAM.ram_9_inst.INIT_39 = 256'h00000000003fc0003fc000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[3].BRAM.ram_9_inst.INIT_38 = 256'h00000000000000000000000000000000000000000000000003f03fffffffffff;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[3].BRAM.ram_9_inst.INIT_37 = 256'hffff0000000003fffffffffffffff03f00000000003fc0003fc0000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[3].BRAM.ram_9_inst.INIT_36 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[3].BRAM.ram_9_inst.INIT_35 = 256'h000000000000000003f03fffffffffffffff0000000003fffffffffffffff03f;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[3].BRAM.ram_9_inst.INIT_34 = 256'h00000000003fc0003fc000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[3].BRAM.ram_9_inst.INIT_33 = 256'h00000000000000000000000000000000000000000000000003f03fc000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[3].BRAM.ram_9_inst.INIT_32 = 256'h000000000000000000000000000ff03f00000000003fc0003fc0000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[3].BRAM.ram_9_inst.INIT_31 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[3].BRAM.ram_9_inst.INIT_30 = 256'h000000000000000003f00ff000000000000000000000000000000000003fc03f;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[3].BRAM.ram_9_inst.INIT_2F = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[3].BRAM.ram_9_inst.INIT_2E = 256'h00000000000000000000000000000000000000000000000003fc03fc00000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[3].BRAM.ram_9_inst.INIT_2D = 256'h00000000000000000000000000ff00ff00000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[3].BRAM.ram_9_inst.INIT_2C = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[3].BRAM.ram_9_inst.INIT_2B = 256'h000000000000000000ff00ff0000000000000000000000000000000003fc03fc;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[3].BRAM.ram_9_inst.INIT_2A = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[3].BRAM.ram_9_inst.INIT_29 = 256'h000000000000000000000000000000000000000000000000003fc03fc0000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[3].BRAM.ram_9_inst.INIT_28 = 256'h0000000000000000000000000ff00ff000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[3].BRAM.ram_9_inst.INIT_27 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[3].BRAM.ram_9_inst.INIT_26 = 256'h0000000000000000000ff00ff00000000000000000000000000000003fc03fc0;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[3].BRAM.ram_9_inst.INIT_25 = 256'hffffffffc003ff00003ff00003ffff0000003fffff0003ffc003ff00003ff000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[3].BRAM.ram_9_inst.INIT_24 = 256'hffc0000ff00000ffffc0000ffffffff000003ff0000000000003fc03fc000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[3].BRAM.ram_9_inst.INIT_23 = 256'h000000000000000000000000ff00ff00ffffffffc003ff00003ff0000ffffff0;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[3].BRAM.ram_9_inst.INIT_22 = 256'h0000fffffff003ffc003ff00003ff000ffc0000ff0000ffffff0000ffffffff0;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[3].BRAM.ram_9_inst.INIT_21 = 256'h00003ff0000000000000ff00ff000000000000000000000000000003fc03fc00;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[3].BRAM.ram_9_inst.INIT_20 = 256'hffffffffc003ff00003ff000fffffffc0003fffffffc03ffc003ffc0003ff000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[3].BRAM.ram_9_inst.INIT_1F = 256'hffc0000ff0003ffffffc000ffffffff000003ff00000000000003fc03fc00000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[3].BRAM.ram_9_inst.INIT_1E = 256'h00000000000000000000000ff00ff000ffffffffc003ff00003ff000fffffffc;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[3].BRAM.ram_9_inst.INIT_1D = 256'h000ffffffffc03ffc003fff0003ff000ffc0000ff000ffffffff000ffffffff0;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[3].BRAM.ram_9_inst.INIT_1C = 256'h00003ff00000000000000ff00ff0000000000000000000000000003fc03fc000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[3].BRAM.ram_9_inst.INIT_1B = 256'h000000ffc003ff00003ff003ffc00fff000fff000ff003ffc003fff0003ff000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[3].BRAM.ram_9_inst.INIT_1A = 256'hffc0000ff000fff00fffc00000003ff000003ff000000000000003fc03fc0000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[3].BRAM.ram_9_inst.INIT_19 = 256'h0000000000000000000000ff00ff0000000000ffc003ff00003ff003ff0003ff;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[3].BRAM.ram_9_inst.INIT_18 = 256'h003ff00000c003ffc003fffc003ff000ffc0000ff003ffc000ffc00000003ff0;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[3].BRAM.ram_9_inst.INIT_17 = 256'h00003ff000000000000000ff00ff00000000000000000000000003fc03fc0000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[3].BRAM.ram_9_inst.INIT_16 = 256'h000000ffc003ff00003ff00fff0003ffc03ff000000003ffc003ffff003ff000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[3].BRAM.ram_9_inst.INIT_15 = 256'hffc0000ff003ff0000ffc00000003ff000003ff0000000000000003fc03fc000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[3].BRAM.ram_9_inst.INIT_14 = 256'h000000000000000000000ff00ff00000000000ffc003ff00003ff00ffc0000ff;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[3].BRAM.ram_9_inst.INIT_13 = 256'hc03ff000000003ffc003ffff003ff000ffc0000ff003ff0000ffc00000003ff0;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[3].BRAM.ram_9_inst.INIT_12 = 256'h00003ff0000000000000000ff00ff000000000000000000000003fc03fc00000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[3].BRAM.ram_9_inst.INIT_11 = 256'h000000ffc003ff00003ff000000000ffc03ff000000003ffc003ffffc03ff000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[3].BRAM.ram_9_inst.INIT_10 = 256'hffc0000ff000000000fff00000003ff000003ff00000000000000003fc03fc00;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[3].BRAM.ram_9_inst.INIT_0F = 256'h00000000000000000000ff00ff000000000000ffc003ff00003ff000000000ff;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[3].BRAM.ram_9_inst.INIT_0E = 256'hc03fff00000003ffc003ffffc03ff000ffc0000ff000000000fff00000003ff0;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[3].BRAM.ram_9_inst.INIT_0D = 256'h00003ff00000000000000000ff00ff0000000000000000000003fc03fc000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[3].BRAM.ram_9_inst.INIT_0C = 256'h0fffffffc003fffffffff000000000ffc00fffffc00003ffc003fffff03ff000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[3].BRAM.ram_9_inst.INIT_0B = 256'hfffffffff000000000fff003fffffff000003ff000000000000000003fc03fc0;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[3].BRAM.ram_9_inst.INIT_0A = 256'h0000000000000000000ff00ff00000000fffffffc003fffffffff000000000ff;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[3].BRAM.ram_9_inst.INIT_09 = 256'hc00fffffff0003ffc003ff3ffc3ff000fffffffff000000000fff003fffffff0;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[3].BRAM.ram_9_inst.INIT_08 = 256'h00003ff000000000000000000ff00ff00000000000000000003fc03fc0000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[3].BRAM.ram_9_inst.INIT_07 = 256'h0fffffffc003fffffffff000000000ffc003ffffffc003ffc003ff0ffc3ff000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[3].BRAM.ram_9_inst.INIT_06 = 256'hfffffffff000000000fff003fffffff000003ff0000000000000000003fc03fc;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[3].BRAM.ram_9_inst.INIT_05 = 256'h000000000000000000ff00ff000000000fffffffc003fffffffff000000000ff;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[3].BRAM.ram_9_inst.INIT_04 = 256'hc0003ffffff003ffc003ff0fff3ff000fffffffff000000000fff003fffffff0;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[3].BRAM.ram_9_inst.INIT_03 = 256'h00003ff0000000000000000000ff00ff000000000000000003fc03fc00000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[3].BRAM.ram_9_inst.INIT_02 = 256'h0fffffffc003fffffffff000000000ffc00000fffff003ffc003ff03fffff000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[3].BRAM.ram_9_inst.INIT_01 = 256'hfffffffff000000000fff003fffffff000003ff00000000000000000003fc03f;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[3].BRAM.ram_9_inst.INIT_00 = 256'hc0000000000000000ff00ff000000000000000ffc003ff00003ff000000000ff;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[3].BRAM.ram_9_inst.INITP_07 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[3].BRAM.ram_9_inst.INITP_06 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[3].BRAM.ram_9_inst.INITP_05 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[3].BRAM.ram_9_inst.INITP_04 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[3].BRAM.ram_9_inst.INITP_03 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[3].BRAM.ram_9_inst.INITP_02 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[3].BRAM.ram_9_inst.INITP_01 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[3].BRAM.ram_9_inst.INITP_00 = 256'h0000000000000000000000000000000000000000000000000000000000000000;

defparam    MEMORIES.GRAPH.BRAM_ARRAY[4].BRAM.ram_9_inst.INIT_3F = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[4].BRAM.ram_9_inst.INIT_3E = 256'h00000000000000000000000000000000000000000000000003f03f0000000003;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[4].BRAM.ram_9_inst.INIT_3D = 256'hf03ffffffffffff03f0000000003f03f00000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[4].BRAM.ram_9_inst.INIT_3C = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[4].BRAM.ram_9_inst.INIT_3B = 256'h000000000000000003f03f0000000003f03f0000000003f03f0000000003f03f;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[4].BRAM.ram_9_inst.INIT_3A = 256'h000000000000000000000000000000000000000ffc0000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[4].BRAM.ram_9_inst.INIT_39 = 256'h0000000000000000000000000000000000000ff00000000003f03f0000000003;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[4].BRAM.ram_9_inst.INIT_38 = 256'hf03f0000000003f03f0000000003f03f0003ff000ffc000003ff000ffc00003f;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[4].BRAM.ram_9_inst.INIT_37 = 256'hf00003fffffc00fff0000ffc03ffffffff000003ff000003ff003ffc0000ffc0;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[4].BRAM.ram_9_inst.INIT_36 = 256'h0003ffffc000000003f03f0000000003f03f0000000003f03f0000000003f03f;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[4].BRAM.ram_9_inst.INIT_35 = 256'h0003ff0003ff00000ffc000ffc00003ff0003fffffff00fff0000ffc03ffffff;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[4].BRAM.ram_9_inst.INIT_34 = 256'hff000003ff000003ff003ffc0000ffc0003ffffff000000003f03f0000000003;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[4].BRAM.ram_9_inst.INIT_33 = 256'hf03f0000000003f03f0000000003f03f0003ff0003ff00000ffc000ffc00003f;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[4].BRAM.ram_9_inst.INIT_32 = 256'hf0003ffffffff03ffc000ffc03ffffffff00000fff000003ff003fff0000ffc0;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[4].BRAM.ram_9_inst.INIT_31 = 256'h00fffffffc00000003f03f0000000003f03f0000000003f03f0000000003f03f;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[4].BRAM.ram_9_inst.INIT_30 = 256'h0003ff0003ff00000ffc000ffc00003ff000ffffffffc00ffc000ffc03ffffff;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[4].BRAM.ram_9_inst.INIT_2F = 256'hff00000fffc00003ff003fff0000ffc000ffffffff00000003f03f0000000003;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[4].BRAM.ram_9_inst.INIT_2E = 256'hf03f0000000003f03f0000000003f03f0003ff0000fffffffff0000ffc00003f;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[4].BRAM.ram_9_inst.INIT_2D = 256'hf003ffc000ff000fff000ffc00000003ff00000fffc00003ff003fffc000ffc0;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[4].BRAM.ram_9_inst.INIT_2C = 256'h03ffc00fff00000003f03f0000000003f03f0000000003f03f0000000003f03f;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[4].BRAM.ram_9_inst.INIT_2B = 256'h0003ff0000fffffffff0000ffc00003ff003ff00000c0003ff000ffc00000003;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[4].BRAM.ram_9_inst.INIT_2A = 256'hff00000fffc00003ff003ffff000ffc003ff0003ffc0000003f03f0000000003;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[4].BRAM.ram_9_inst.INIT_29 = 256'hf03f0000000003f03f0000000003f03f0003ff0000fffffffff0000ffc00003f;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[4].BRAM.ram_9_inst.INIT_28 = 256'hf003ff0000000003ffc00ffc00000003ff00003fffc00003ff003ffff000ffc0;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[4].BRAM.ram_9_inst.INIT_27 = 256'h0fff0000ffc0000003f03f0000000003f03f0000000003f03f0000000003f03f;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[4].BRAM.ram_9_inst.INIT_26 = 256'h0003ff00003fffffffc0000ffc00003ff003ff0000000000ffc00ffc00000003;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[4].BRAM.ram_9_inst.INIT_25 = 256'hff00003ffff00003ff003ffffc00ffc00ffc0000ffc0000003f03f0000000003;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[4].BRAM.ram_9_inst.INIT_24 = 256'hf03f0000000003f03f0000000003f03f0003ff00003ff000ffc0000ffc00003f;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[4].BRAM.ram_9_inst.INIT_23 = 256'hf003ff0000000000fff00ffc00000003ff0000fffff00003ff003fffff00ffc0;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[4].BRAM.ram_9_inst.INIT_22 = 256'h0ffc0000ffc0000003f03f0000000003f03f0000000003f03f0000000003f03f;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[4].BRAM.ram_9_inst.INIT_21 = 256'h0003ff00000ff003ffc0000ffc00003ff003fff0000000003ffffffc00000003;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[4].BRAM.ram_9_inst.INIT_20 = 256'hff0000ffcffc0003ff003fffffc0ffc00ffc0000ffc0000003f03f0000000003;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[4].BRAM.ram_9_inst.INIT_1F = 256'hf03f0000000003f03f0000000003f03f0003ff00000ffc03ff00000ffc00003f;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[4].BRAM.ram_9_inst.INIT_1E = 256'hf000ffffff0000003ffffffc003fffffff0000ffcffc0003ff003fffffc0ffc0;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[4].BRAM.ram_9_inst.INIT_1D = 256'h0ffc0000ffc0000003f03f0000000003f03f0000000003f03f0000000003f03f;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[4].BRAM.ram_9_inst.INIT_1C = 256'h0003ff00000ffc03ff00000ffc00003ff000fffffff00003fffffffc003fffff;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[4].BRAM.ram_9_inst.INIT_1B = 256'hff0003ff0ffc0003ff003ffcfff0ffc00ffc0000ffc0000003f03f0000000003;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[4].BRAM.ram_9_inst.INIT_1A = 256'hf03f0000000003f03f0000000003f03f0003ff000003fc0ffc00000ffc00003f;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[4].BRAM.ram_9_inst.INIT_19 = 256'hf0003ffffffc000ffffffffc003fffffff0003ff03ff0003ff003ffcfff0ffc0;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[4].BRAM.ram_9_inst.INIT_18 = 256'h0ffc0000ffc0000003f03f0000000003f03f0000000003f03f0000000003f03f;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[4].BRAM.ram_9_inst.INIT_17 = 256'h0003ff000003ff0ffc00000ffc00003ff00003ffffff003ffffffffc003fffff;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[4].BRAM.ram_9_inst.INIT_16 = 256'hff0003ff03ff0003ff003ffc3ffcffc00ffc0000ffc0000003f03f0000000003;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[4].BRAM.ram_9_inst.INIT_15 = 256'hf03f0000000003f03f0000000003f03f0003ff000003ff0ffc00000ffc00003f;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[4].BRAM.ram_9_inst.INIT_14 = 256'hf0000000ffff003ffc000ffc00000003ff0003fc03ff0003ff003ffc0fffffc0;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[4].BRAM.ram_9_inst.INIT_13 = 256'h0ffc0000ffc0000003f03f0000000003f03f0000000003f03f0000000003f03f;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[4].BRAM.ram_9_inst.INIT_12 = 256'h0003ff000000ff3ff000000ffc00003ff000000003ffc0fff0000ffc00000003;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[4].BRAM.ram_9_inst.INIT_11 = 256'hff000ffc00ffc003ff003ffc0fffffc00ffc0000ffc0000003f03f0000000003;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[4].BRAM.ram_9_inst.INIT_10 = 256'hf03f0000000003f03f0000000003f03f0003ff000000fffff000000ffc00003f;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[4].BRAM.ram_9_inst.INIT_0F = 256'hf000000000ffc0fff0000ffc00000003ff000ffc00ffc003ff003ffc03ffffc0;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[4].BRAM.ram_9_inst.INIT_0E = 256'h0ffc0000ffc0000003f03f0000000003f03f0000000003f03f0000000003f03f;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[4].BRAM.ram_9_inst.INIT_0D = 256'h0003ff0000003ffff000000ffc00003ff000000000ffc0fff0000ffc00000003;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[4].BRAM.ram_9_inst.INIT_0C = 256'hff003ffc00ffc003ff003ffc00ffffc00ffc0000ffc0000003f03f0000000003;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[4].BRAM.ram_9_inst.INIT_0B = 256'hf03f0000000003f03f0000000003f03f0003ff0000003fffc000000ffc00003f;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[4].BRAM.ram_9_inst.INIT_0A = 256'hf000000000ffc0fff0000ffc00000003ff003ff000fff003ff003ffc00ffffc0;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[4].BRAM.ram_9_inst.INIT_09 = 256'h0ffc0000ffc0000003f03f0000000003f03f0000000003f03f0000000003f03f;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[4].BRAM.ram_9_inst.INIT_08 = 256'h0003ff0000003fffc000000ffc00003ff0000f0003ff003ffc000ffc00000003;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[4].BRAM.ram_9_inst.INIT_07 = 256'hff003ff0003ff003ff003ffc003fffc00ffc0000ffc0000003f03fffffffffff;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[4].BRAM.ram_9_inst.INIT_06 = 256'hf03f0000000003f03ffffffffffff03f3ffffffffc000fff0003ffffffffc03f;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[4].BRAM.ram_9_inst.INIT_05 = 256'hf0003fffffff003ffffffffc03ffffffff00fff0003ff003ff003ffc000fffc0;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[4].BRAM.ram_9_inst.INIT_04 = 256'h0ffc0000ffc0000003f03ffffffffffff03f0000000003f03ffffffffffff03f;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[4].BRAM.ram_9_inst.INIT_03 = 256'h3ffffffffc000fff0003ffffffffc03ff000fffffffc000ffffffffc03ffffff;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[4].BRAM.ram_9_inst.INIT_02 = 256'hff00ffc0003ffc03ff003ffc000fffc00ffc0000ffc0000003f03fffffffffff;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[4].BRAM.ram_9_inst.INIT_01 = 256'hf03f0000000003f03ffffffffffff03f3ffffffffc000fff0003ffffffffc03f;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[4].BRAM.ram_9_inst.INIT_00 = 256'hf0003ffffff00003fffffffc03ffffffff00ffc0000ffc03ff003ffc0003ffc0;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[4].BRAM.ram_9_inst.INITP_07 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[4].BRAM.ram_9_inst.INITP_06 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[4].BRAM.ram_9_inst.INITP_05 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[4].BRAM.ram_9_inst.INITP_04 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[4].BRAM.ram_9_inst.INITP_03 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[4].BRAM.ram_9_inst.INITP_02 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[4].BRAM.ram_9_inst.INITP_01 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[4].BRAM.ram_9_inst.INITP_00 = 256'h0000000000000000000000000000000000000000000000000000000000000000;

defparam    MEMORIES.GRAPH.BRAM_ARRAY[9].BRAM.ram_9_inst.INIT_3F = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[9].BRAM.ram_9_inst.INIT_3E = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[9].BRAM.ram_9_inst.INIT_3D = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[9].BRAM.ram_9_inst.INIT_3C = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[9].BRAM.ram_9_inst.INIT_3B = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[9].BRAM.ram_9_inst.INIT_3A = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[9].BRAM.ram_9_inst.INIT_39 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[9].BRAM.ram_9_inst.INIT_38 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[9].BRAM.ram_9_inst.INIT_37 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[9].BRAM.ram_9_inst.INIT_36 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[9].BRAM.ram_9_inst.INIT_35 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[9].BRAM.ram_9_inst.INIT_34 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[9].BRAM.ram_9_inst.INIT_33 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[9].BRAM.ram_9_inst.INIT_32 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[9].BRAM.ram_9_inst.INIT_31 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[9].BRAM.ram_9_inst.INIT_30 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[9].BRAM.ram_9_inst.INIT_2F = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[9].BRAM.ram_9_inst.INIT_2E = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[9].BRAM.ram_9_inst.INIT_2D = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[9].BRAM.ram_9_inst.INIT_2C = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[9].BRAM.ram_9_inst.INIT_2B = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[9].BRAM.ram_9_inst.INIT_2A = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[9].BRAM.ram_9_inst.INIT_29 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[9].BRAM.ram_9_inst.INIT_28 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[9].BRAM.ram_9_inst.INIT_27 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[9].BRAM.ram_9_inst.INIT_26 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[9].BRAM.ram_9_inst.INIT_25 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[9].BRAM.ram_9_inst.INIT_24 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[9].BRAM.ram_9_inst.INIT_23 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[9].BRAM.ram_9_inst.INIT_22 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[9].BRAM.ram_9_inst.INIT_21 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[9].BRAM.ram_9_inst.INIT_20 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[9].BRAM.ram_9_inst.INIT_1F = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[9].BRAM.ram_9_inst.INIT_1E = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[9].BRAM.ram_9_inst.INIT_1D = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[9].BRAM.ram_9_inst.INIT_1C = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[9].BRAM.ram_9_inst.INIT_1B = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[9].BRAM.ram_9_inst.INIT_1A = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[9].BRAM.ram_9_inst.INIT_19 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[9].BRAM.ram_9_inst.INIT_18 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[9].BRAM.ram_9_inst.INIT_17 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[9].BRAM.ram_9_inst.INIT_16 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[9].BRAM.ram_9_inst.INIT_15 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[9].BRAM.ram_9_inst.INIT_14 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[9].BRAM.ram_9_inst.INIT_13 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[9].BRAM.ram_9_inst.INIT_12 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[9].BRAM.ram_9_inst.INIT_11 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[9].BRAM.ram_9_inst.INIT_10 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[9].BRAM.ram_9_inst.INIT_0F = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[9].BRAM.ram_9_inst.INIT_0E = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[9].BRAM.ram_9_inst.INIT_0D = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[9].BRAM.ram_9_inst.INIT_0C = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[9].BRAM.ram_9_inst.INIT_0B = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[9].BRAM.ram_9_inst.INIT_0A = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[9].BRAM.ram_9_inst.INIT_09 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[9].BRAM.ram_9_inst.INIT_08 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[9].BRAM.ram_9_inst.INIT_07 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[9].BRAM.ram_9_inst.INIT_06 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[9].BRAM.ram_9_inst.INIT_05 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[9].BRAM.ram_9_inst.INIT_04 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[9].BRAM.ram_9_inst.INIT_03 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[9].BRAM.ram_9_inst.INIT_02 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[9].BRAM.ram_9_inst.INIT_01 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[9].BRAM.ram_9_inst.INIT_00 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[9].BRAM.ram_9_inst.INITP_07 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[9].BRAM.ram_9_inst.INITP_06 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[9].BRAM.ram_9_inst.INITP_05 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[9].BRAM.ram_9_inst.INITP_04 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[9].BRAM.ram_9_inst.INITP_03 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[9].BRAM.ram_9_inst.INITP_02 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[9].BRAM.ram_9_inst.INITP_01 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[9].BRAM.ram_9_inst.INITP_00 = 256'h0000000000000000000000000000000000000000000000000000000000000000;

defparam    MEMORIES.GRAPH.BRAM_ARRAY[6].BRAM.ram_9_inst.INIT_3F = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[6].BRAM.ram_9_inst.INIT_3E = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[6].BRAM.ram_9_inst.INIT_3D = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[6].BRAM.ram_9_inst.INIT_3C = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[6].BRAM.ram_9_inst.INIT_3B = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[6].BRAM.ram_9_inst.INIT_3A = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[6].BRAM.ram_9_inst.INIT_39 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[6].BRAM.ram_9_inst.INIT_38 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[6].BRAM.ram_9_inst.INIT_37 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[6].BRAM.ram_9_inst.INIT_36 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[6].BRAM.ram_9_inst.INIT_35 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[6].BRAM.ram_9_inst.INIT_34 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[6].BRAM.ram_9_inst.INIT_33 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[6].BRAM.ram_9_inst.INIT_32 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[6].BRAM.ram_9_inst.INIT_31 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[6].BRAM.ram_9_inst.INIT_30 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[6].BRAM.ram_9_inst.INIT_2F = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[6].BRAM.ram_9_inst.INIT_2E = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[6].BRAM.ram_9_inst.INIT_2D = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[6].BRAM.ram_9_inst.INIT_2C = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[6].BRAM.ram_9_inst.INIT_2B = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[6].BRAM.ram_9_inst.INIT_2A = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[6].BRAM.ram_9_inst.INIT_29 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[6].BRAM.ram_9_inst.INIT_28 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[6].BRAM.ram_9_inst.INIT_27 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[6].BRAM.ram_9_inst.INIT_26 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[6].BRAM.ram_9_inst.INIT_25 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[6].BRAM.ram_9_inst.INIT_24 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[6].BRAM.ram_9_inst.INIT_23 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[6].BRAM.ram_9_inst.INIT_22 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[6].BRAM.ram_9_inst.INIT_21 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[6].BRAM.ram_9_inst.INIT_20 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[6].BRAM.ram_9_inst.INIT_1F = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[6].BRAM.ram_9_inst.INIT_1E = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[6].BRAM.ram_9_inst.INIT_1D = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[6].BRAM.ram_9_inst.INIT_1C = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[6].BRAM.ram_9_inst.INIT_1B = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[6].BRAM.ram_9_inst.INIT_1A = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[6].BRAM.ram_9_inst.INIT_19 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[6].BRAM.ram_9_inst.INIT_18 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[6].BRAM.ram_9_inst.INIT_17 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[6].BRAM.ram_9_inst.INIT_16 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[6].BRAM.ram_9_inst.INIT_15 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[6].BRAM.ram_9_inst.INIT_14 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[6].BRAM.ram_9_inst.INIT_13 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[6].BRAM.ram_9_inst.INIT_12 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[6].BRAM.ram_9_inst.INIT_11 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[6].BRAM.ram_9_inst.INIT_10 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[6].BRAM.ram_9_inst.INIT_0F = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[6].BRAM.ram_9_inst.INIT_0E = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[6].BRAM.ram_9_inst.INIT_0D = 256'h00000000000000000000000000000000000000000000000000000000000000ff;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[6].BRAM.ram_9_inst.INIT_0C = 256'h00000ffc00ffffffff0000003fffff000003fff0000ffffffff00fff0000fff0;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[6].BRAM.ram_9_inst.INIT_0B = 256'h00000fffffc000000000000000000003ffffffffffffffffff00000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[6].BRAM.ram_9_inst.INIT_0A = 256'h000000000000000000000000000000ffc0000ffc00ffffffff00000fffffff00;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[6].BRAM.ram_9_inst.INIT_09 = 256'h00ffffffc00ffffffff003ffc000fff00003ffffffc00000000000000000000f;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[6].BRAM.ram_9_inst.INIT_08 = 256'hffffffffffffffffffc0000000000000000000000000000000000000000000ff;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[6].BRAM.ram_9_inst.INIT_07 = 256'hf0000ffc00ffffffff0000ffffffff0003fffffff00ffffffff000ffc000fff0;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[6].BRAM.ram_9_inst.INIT_06 = 256'h003fffffffc00000000000000000003ffffffffffffffffffff0000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[6].BRAM.ram_9_inst.INIT_05 = 256'h000000000000000000000000000000fff0000ffc00ffffffff0003ffffffff00;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[6].BRAM.ram_9_inst.INIT_04 = 256'h0ffffffffc0ffffffff000fff000fff000ffffffffc0000000000000000000ff;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[6].BRAM.ram_9_inst.INIT_03 = 256'h000000000000000003fc000000000000000000000000000000000000000000ff;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[6].BRAM.ram_9_inst.INIT_02 = 256'hfc000ffc00ffffffff0003ffffffff003ffffffff00ffffffff0003ff000fff0;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[6].BRAM.ram_9_inst.INIT_01 = 256'h00ffffffffc0000000000000000003fc000000000000000000ff000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[6].BRAM.ram_9_inst.INIT_00 = 256'h000000000000000000000000000000ffff000ffc00000003ff000fff0003ff00;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[6].BRAM.ram_9_inst.INITP_07 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[6].BRAM.ram_9_inst.INITP_06 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[6].BRAM.ram_9_inst.INITP_05 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[6].BRAM.ram_9_inst.INITP_04 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[6].BRAM.ram_9_inst.INITP_03 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[6].BRAM.ram_9_inst.INITP_02 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[6].BRAM.ram_9_inst.INITP_01 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[6].BRAM.ram_9_inst.INITP_00 = 256'h0000000000000000000000000000000000000000000000000000000000000000;

defparam    MEMORIES.GRAPH.BRAM_ARRAY[7].BRAM.ram_9_inst.INIT_3F = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[7].BRAM.ram_9_inst.INIT_3E = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[7].BRAM.ram_9_inst.INIT_3D = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[7].BRAM.ram_9_inst.INIT_3C = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[7].BRAM.ram_9_inst.INIT_3B = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[7].BRAM.ram_9_inst.INIT_3A = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[7].BRAM.ram_9_inst.INIT_39 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[7].BRAM.ram_9_inst.INIT_38 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[7].BRAM.ram_9_inst.INIT_37 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[7].BRAM.ram_9_inst.INIT_36 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[7].BRAM.ram_9_inst.INIT_35 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[7].BRAM.ram_9_inst.INIT_34 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[7].BRAM.ram_9_inst.INIT_33 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[7].BRAM.ram_9_inst.INIT_32 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[7].BRAM.ram_9_inst.INIT_31 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[7].BRAM.ram_9_inst.INIT_30 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[7].BRAM.ram_9_inst.INIT_2F = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[7].BRAM.ram_9_inst.INIT_2E = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[7].BRAM.ram_9_inst.INIT_2D = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[7].BRAM.ram_9_inst.INIT_2C = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[7].BRAM.ram_9_inst.INIT_2B = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[7].BRAM.ram_9_inst.INIT_2A = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[7].BRAM.ram_9_inst.INIT_29 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[7].BRAM.ram_9_inst.INIT_28 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[7].BRAM.ram_9_inst.INIT_27 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[7].BRAM.ram_9_inst.INIT_26 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[7].BRAM.ram_9_inst.INIT_25 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[7].BRAM.ram_9_inst.INIT_24 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[7].BRAM.ram_9_inst.INIT_23 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[7].BRAM.ram_9_inst.INIT_22 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[7].BRAM.ram_9_inst.INIT_21 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[7].BRAM.ram_9_inst.INIT_20 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[7].BRAM.ram_9_inst.INIT_1F = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[7].BRAM.ram_9_inst.INIT_1E = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[7].BRAM.ram_9_inst.INIT_1D = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[7].BRAM.ram_9_inst.INIT_1C = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[7].BRAM.ram_9_inst.INIT_1B = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[7].BRAM.ram_9_inst.INIT_1A = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[7].BRAM.ram_9_inst.INIT_19 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[7].BRAM.ram_9_inst.INIT_18 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[7].BRAM.ram_9_inst.INIT_17 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[7].BRAM.ram_9_inst.INIT_16 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[7].BRAM.ram_9_inst.INIT_15 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[7].BRAM.ram_9_inst.INIT_14 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[7].BRAM.ram_9_inst.INIT_13 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[7].BRAM.ram_9_inst.INIT_12 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[7].BRAM.ram_9_inst.INIT_11 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[7].BRAM.ram_9_inst.INIT_10 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[7].BRAM.ram_9_inst.INIT_0F = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[7].BRAM.ram_9_inst.INIT_0E = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[7].BRAM.ram_9_inst.INIT_0D = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[7].BRAM.ram_9_inst.INIT_0C = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[7].BRAM.ram_9_inst.INIT_0B = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[7].BRAM.ram_9_inst.INIT_0A = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[7].BRAM.ram_9_inst.INIT_09 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[7].BRAM.ram_9_inst.INIT_08 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[7].BRAM.ram_9_inst.INIT_07 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[7].BRAM.ram_9_inst.INIT_06 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[7].BRAM.ram_9_inst.INIT_05 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[7].BRAM.ram_9_inst.INIT_04 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[7].BRAM.ram_9_inst.INIT_03 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[7].BRAM.ram_9_inst.INIT_02 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[7].BRAM.ram_9_inst.INIT_01 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[7].BRAM.ram_9_inst.INIT_00 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[7].BRAM.ram_9_inst.INITP_07 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[7].BRAM.ram_9_inst.INITP_06 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[7].BRAM.ram_9_inst.INITP_05 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[7].BRAM.ram_9_inst.INITP_04 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[7].BRAM.ram_9_inst.INITP_03 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[7].BRAM.ram_9_inst.INITP_02 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[7].BRAM.ram_9_inst.INITP_01 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[7].BRAM.ram_9_inst.INITP_00 = 256'h0000000000000000000000000000000000000000000000000000000000000000;

defparam    MEMORIES.GRAPH.BRAM_ARRAY[0].BRAM.ram_9_inst.INIT_3F = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[0].BRAM.ram_9_inst.INIT_3E = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[0].BRAM.ram_9_inst.INIT_3D = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[0].BRAM.ram_9_inst.INIT_3C = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[0].BRAM.ram_9_inst.INIT_3B = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[0].BRAM.ram_9_inst.INIT_3A = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[0].BRAM.ram_9_inst.INIT_39 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[0].BRAM.ram_9_inst.INIT_38 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[0].BRAM.ram_9_inst.INIT_37 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[0].BRAM.ram_9_inst.INIT_36 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[0].BRAM.ram_9_inst.INIT_35 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[0].BRAM.ram_9_inst.INIT_34 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[0].BRAM.ram_9_inst.INIT_33 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[0].BRAM.ram_9_inst.INIT_32 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[0].BRAM.ram_9_inst.INIT_31 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[0].BRAM.ram_9_inst.INIT_30 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[0].BRAM.ram_9_inst.INIT_2F = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[0].BRAM.ram_9_inst.INIT_2E = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[0].BRAM.ram_9_inst.INIT_2D = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[0].BRAM.ram_9_inst.INIT_2C = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[0].BRAM.ram_9_inst.INIT_2B = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[0].BRAM.ram_9_inst.INIT_2A = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[0].BRAM.ram_9_inst.INIT_29 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[0].BRAM.ram_9_inst.INIT_28 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[0].BRAM.ram_9_inst.INIT_27 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[0].BRAM.ram_9_inst.INIT_26 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[0].BRAM.ram_9_inst.INIT_25 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[0].BRAM.ram_9_inst.INIT_24 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[0].BRAM.ram_9_inst.INIT_23 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[0].BRAM.ram_9_inst.INIT_22 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[0].BRAM.ram_9_inst.INIT_21 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[0].BRAM.ram_9_inst.INIT_20 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[0].BRAM.ram_9_inst.INIT_1F = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[0].BRAM.ram_9_inst.INIT_1E = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[0].BRAM.ram_9_inst.INIT_1D = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[0].BRAM.ram_9_inst.INIT_1C = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[0].BRAM.ram_9_inst.INIT_1B = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[0].BRAM.ram_9_inst.INIT_1A = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[0].BRAM.ram_9_inst.INIT_19 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[0].BRAM.ram_9_inst.INIT_18 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[0].BRAM.ram_9_inst.INIT_17 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[0].BRAM.ram_9_inst.INIT_16 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[0].BRAM.ram_9_inst.INIT_15 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[0].BRAM.ram_9_inst.INIT_14 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[0].BRAM.ram_9_inst.INIT_13 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[0].BRAM.ram_9_inst.INIT_12 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[0].BRAM.ram_9_inst.INIT_11 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[0].BRAM.ram_9_inst.INIT_10 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[0].BRAM.ram_9_inst.INIT_0F = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[0].BRAM.ram_9_inst.INIT_0E = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[0].BRAM.ram_9_inst.INIT_0D = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[0].BRAM.ram_9_inst.INIT_0C = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[0].BRAM.ram_9_inst.INIT_0B = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[0].BRAM.ram_9_inst.INIT_0A = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[0].BRAM.ram_9_inst.INIT_09 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[0].BRAM.ram_9_inst.INIT_08 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[0].BRAM.ram_9_inst.INIT_07 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[0].BRAM.ram_9_inst.INIT_06 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[0].BRAM.ram_9_inst.INIT_05 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[0].BRAM.ram_9_inst.INIT_04 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[0].BRAM.ram_9_inst.INIT_03 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[0].BRAM.ram_9_inst.INIT_02 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[0].BRAM.ram_9_inst.INIT_01 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[0].BRAM.ram_9_inst.INIT_00 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[0].BRAM.ram_9_inst.INITP_07 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[0].BRAM.ram_9_inst.INITP_06 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[0].BRAM.ram_9_inst.INITP_05 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[0].BRAM.ram_9_inst.INITP_04 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[0].BRAM.ram_9_inst.INITP_03 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[0].BRAM.ram_9_inst.INITP_02 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[0].BRAM.ram_9_inst.INITP_01 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[0].BRAM.ram_9_inst.INITP_00 = 256'h0000000000000000000000000000000000000000000000000000000000000000;

defparam    MEMORIES.GRAPH.BRAM_ARRAY[5].BRAM.ram_9_inst.INIT_3F = 256'h3ff0000fc00000003ff0003ffc00fff003fff000ffc000000000000000000ff0;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[5].BRAM.ram_9_inst.INIT_3E = 256'h0000000000000000003fc00000000000000000000000000000000000000000ff;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[5].BRAM.ram_9_inst.INIT_3D = 256'hff000ffc00000003ff000ffc0003ff003ff00000000000003ff0000ffc00fff0;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[5].BRAM.ram_9_inst.INIT_3C = 256'h03ff0000ffc000000000000000003fc03ffffffffffffffff00ff00000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[5].BRAM.ram_9_inst.INIT_3B = 256'h000000000000000000000000000000ffffc00ffc00000003ff000ffc0003ff00;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[5].BRAM.ram_9_inst.INIT_3A = 256'hffc00000000000003ff0000fff00fff003ff0000ffc00000000000000000ff00;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[5].BRAM.ram_9_inst.INIT_39 = 256'hfffffffffffffffffc03fc0000000000000000000000000000000000000000ff;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[5].BRAM.ram_9_inst.INIT_38 = 256'hffc00ffc00000003ff000ffc0003ff00fff00000000000003ff00003ff00fff0;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[5].BRAM.ram_9_inst.INIT_37 = 256'h03ff0000ffc00000000000000003fc03ffffffffffffffffff00ff0000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[5].BRAM.ram_9_inst.INIT_36 = 256'h000000000000000000000000000000fffff00ffc00000003ff000ffc0003ff00;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[5].BRAM.ram_9_inst.INIT_35 = 256'h3ff00000000000003ff00003ffc0fff003ff0000ffc0000000000000000ff00f;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[5].BRAM.ram_9_inst.INIT_34 = 256'hf0000000000000003fc03fc000000000000000000000000000000000000000ff;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[5].BRAM.ram_9_inst.INIT_33 = 256'hfffc0ffc00000003ff000ffc0003ff003fffc000000000003ff00000fffffff0;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[5].BRAM.ram_9_inst.INIT_32 = 256'h03ff0000ffc0000000000000003fc03fc0000000000000000ff00ff000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[5].BRAM.ram_9_inst.INIT_31 = 256'h000000000000000000000000000000fffffc0ffc000fffffff000ffc0003ff00;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[5].BRAM.ram_9_inst.INIT_30 = 256'h3ffffff00003fffffff00003fffffff003ff0000ffc000000000000000ff00ff;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[5].BRAM.ram_9_inst.INIT_2F = 256'h000000000000000003fc03fc00000000000000000000000000000000000000ff;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[5].BRAM.ram_9_inst.INIT_2E = 256'hcfff0ffc000fffffff000ffc0003ff000fffffff0003fffffff0000ffffffff0;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[5].BRAM.ram_9_inst.INIT_2D = 256'h03ff0000ffc000000000000003fc03fc000000000000000000ff00ff00000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[5].BRAM.ram_9_inst.INIT_2C = 256'h000000000000000000000000000000ffc3ffcffc000fffffff000ffc0003ff00;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[5].BRAM.ram_9_inst.INIT_2B = 256'h03ffffffc003fffffff0003ffffffff003ff0000ffc00000000000000ff00ff0;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[5].BRAM.ram_9_inst.INIT_2A = 256'h0000000000000000003fc03fc0000000000000000000000000000000000000ff;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[5].BRAM.ram_9_inst.INIT_29 = 256'hc3ffcffc000fffffff000ffc0003ff00003fffffc003fffffff000fffffffff0;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[5].BRAM.ram_9_inst.INIT_28 = 256'h03ff0000ffc00000000000003fc03fc00000000000000000000ff00ff0000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[5].BRAM.ram_9_inst.INIT_27 = 256'h000000000000000000000000000000ffc0fffffc00000003ff000ffc0003ff00;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[5].BRAM.ram_9_inst.INIT_26 = 256'h000003fff00000003ff000ffc000fff003ff0000ffc0000000000000ff00ff00;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[5].BRAM.ram_9_inst.INIT_25 = 256'h00000000000000000003fc03fc000000000000000000000000000000000000ff;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[5].BRAM.ram_9_inst.INIT_24 = 256'hc03ffffc00000003ff000ffc0003ff000000003ff00000003ff003ffc000fff0;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[5].BRAM.ram_9_inst.INIT_23 = 256'h03ff0000ffc0000000000003fc03fc0000000000000000000000ff00ff000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[5].BRAM.ram_9_inst.INIT_22 = 256'h000000000000000000000000000000ffc03ffffc00000003ff000ffc0003ff00;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[5].BRAM.ram_9_inst.INIT_21 = 256'h0000003ff00000003ff003ff0000fff003ff0000ffc000000000000ff00ff000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[5].BRAM.ram_9_inst.INIT_20 = 256'h000000000000000000003fc03fc00000000000000000000000000000000000ff;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[5].BRAM.ram_9_inst.INIT_1F = 256'hc00ffffc00000003ff000ffc0003ff000000003ff00000003ff003ff0000fff0;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[5].BRAM.ram_9_inst.INIT_1E = 256'h03ff0000ffc000000000003fc03fc000000000000000000000000ff00ff00000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[5].BRAM.ram_9_inst.INIT_1D = 256'h000000000000000000000000000000ffc003fffc00000003ff000fff0003ff00;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[5].BRAM.ram_9_inst.INIT_1C = 256'h0000003ff00000003ff003ffc000fff003ffc000ffc00000000000ff00ff0000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[5].BRAM.ram_9_inst.INIT_1B = 256'h0000000000000000000003fc03fc0000000000000000000000000000000000ff;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[5].BRAM.ram_9_inst.INIT_1A = 256'hc003fffc00000003ff000fffc003ff0003f000fff00000003ff000fff000fff0;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[5].BRAM.ram_9_inst.INIT_19 = 256'h03fff000ffc00000000003fc03fc00000000000000000000000000ff00ff0000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[5].BRAM.ram_9_inst.INIT_18 = 256'h000000000000000000000000000000ffc000fffc00ffffffff0003ffffffff00;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[5].BRAM.ram_9_inst.INIT_17 = 256'h0fffffffc00ffffffff000fffffffff000ffffffffc0000000000ff00ff00000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[5].BRAM.ram_9_inst.INIT_16 = 256'h00000000000000000000003fc03fc000000000000000000000000000000000ff;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[5].BRAM.ram_9_inst.INIT_15 = 256'hc0003ffc00ffffffff0000ffffffff003fffffffc00ffffffff0003ffffffff0;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[5].BRAM.ram_9_inst.INIT_14 = 256'h003fffffffc0000000003fc03fc0000000000000000000000000000ff00ff000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[5].BRAM.ram_9_inst.INIT_13 = 256'h000000000000000000000000000000ffc0003ffc00ffffffff00003fffffff00;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[5].BRAM.ram_9_inst.INIT_12 = 256'h0fffffff000ffffffff0000ffffffff0000fffffffc000000000ff00ff000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[5].BRAM.ram_9_inst.INIT_11 = 256'h000000000000000000000003fc03fc00000000000000000000000000000000ff;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[5].BRAM.ram_9_inst.INIT_10 = 256'hc0000ffc00ffffffff00000fffffff0000fffff0000ffffffff00000fffffff0;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[5].BRAM.ram_9_inst.INIT_0F = 256'h0003ffffffc000000003fc03fc000003ffffffffffffffffff000000ff00ff00;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[5].BRAM.ram_9_inst.INIT_0E = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[5].BRAM.ram_9_inst.INIT_0D = 256'h000000000000000000000000000000000000000000000000000ff00ff0000003;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[5].BRAM.ram_9_inst.INIT_0C = 256'hffffffffffffffffff0000003fc03fc000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[5].BRAM.ram_9_inst.INIT_0B = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[5].BRAM.ram_9_inst.INIT_0A = 256'h0000000000000000003fc03fc0000003ffffffffffffffffff0000000ff00ff0;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[5].BRAM.ram_9_inst.INIT_09 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[5].BRAM.ram_9_inst.INIT_08 = 256'h00000000000000000000000000000000000000000000000000ff00ff00000003;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[5].BRAM.ram_9_inst.INIT_07 = 256'hf0000000000000003f00000003fc03fc00000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[5].BRAM.ram_9_inst.INIT_06 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[5].BRAM.ram_9_inst.INIT_05 = 256'h000000000000000003fc03fc00000003f0000000000000003f00000000ff00ff;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[5].BRAM.ram_9_inst.INIT_04 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[5].BRAM.ram_9_inst.INIT_03 = 256'h00000000000000000000000000000000000000000000000003f00ff000000003;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[5].BRAM.ram_9_inst.INIT_02 = 256'hf03ffffffffffff03f000000003fc03f00000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[5].BRAM.ram_9_inst.INIT_01 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[5].BRAM.ram_9_inst.INIT_00 = 256'h000000000000000003f03fc000000003f03ffffffffffff03f000000000ff03f;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[5].BRAM.ram_9_inst.INITP_07 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[5].BRAM.ram_9_inst.INITP_06 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[5].BRAM.ram_9_inst.INITP_05 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[5].BRAM.ram_9_inst.INITP_04 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[5].BRAM.ram_9_inst.INITP_03 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[5].BRAM.ram_9_inst.INITP_02 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[5].BRAM.ram_9_inst.INITP_01 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[5].BRAM.ram_9_inst.INITP_00 = 256'h0000000000000000000000000000000000000000000000000000000000000000;

defparam    MEMORIES.GRAPH.BRAM_ARRAY[1].BRAM.ram_9_inst.INIT_3F = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[1].BRAM.ram_9_inst.INIT_3E = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[1].BRAM.ram_9_inst.INIT_3D = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[1].BRAM.ram_9_inst.INIT_3C = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[1].BRAM.ram_9_inst.INIT_3B = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[1].BRAM.ram_9_inst.INIT_3A = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[1].BRAM.ram_9_inst.INIT_39 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[1].BRAM.ram_9_inst.INIT_38 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[1].BRAM.ram_9_inst.INIT_37 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[1].BRAM.ram_9_inst.INIT_36 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[1].BRAM.ram_9_inst.INIT_35 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[1].BRAM.ram_9_inst.INIT_34 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[1].BRAM.ram_9_inst.INIT_33 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[1].BRAM.ram_9_inst.INIT_32 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[1].BRAM.ram_9_inst.INIT_31 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[1].BRAM.ram_9_inst.INIT_30 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[1].BRAM.ram_9_inst.INIT_2F = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[1].BRAM.ram_9_inst.INIT_2E = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[1].BRAM.ram_9_inst.INIT_2D = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[1].BRAM.ram_9_inst.INIT_2C = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[1].BRAM.ram_9_inst.INIT_2B = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[1].BRAM.ram_9_inst.INIT_2A = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[1].BRAM.ram_9_inst.INIT_29 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[1].BRAM.ram_9_inst.INIT_28 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[1].BRAM.ram_9_inst.INIT_27 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[1].BRAM.ram_9_inst.INIT_26 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[1].BRAM.ram_9_inst.INIT_25 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[1].BRAM.ram_9_inst.INIT_24 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[1].BRAM.ram_9_inst.INIT_23 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[1].BRAM.ram_9_inst.INIT_22 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[1].BRAM.ram_9_inst.INIT_21 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[1].BRAM.ram_9_inst.INIT_20 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[1].BRAM.ram_9_inst.INIT_1F = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[1].BRAM.ram_9_inst.INIT_1E = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[1].BRAM.ram_9_inst.INIT_1D = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[1].BRAM.ram_9_inst.INIT_1C = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[1].BRAM.ram_9_inst.INIT_1B = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[1].BRAM.ram_9_inst.INIT_1A = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[1].BRAM.ram_9_inst.INIT_19 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[1].BRAM.ram_9_inst.INIT_18 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[1].BRAM.ram_9_inst.INIT_17 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[1].BRAM.ram_9_inst.INIT_16 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[1].BRAM.ram_9_inst.INIT_15 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[1].BRAM.ram_9_inst.INIT_14 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[1].BRAM.ram_9_inst.INIT_13 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[1].BRAM.ram_9_inst.INIT_12 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[1].BRAM.ram_9_inst.INIT_11 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[1].BRAM.ram_9_inst.INIT_10 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[1].BRAM.ram_9_inst.INIT_0F = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[1].BRAM.ram_9_inst.INIT_0E = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[1].BRAM.ram_9_inst.INIT_0D = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[1].BRAM.ram_9_inst.INIT_0C = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[1].BRAM.ram_9_inst.INIT_0B = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[1].BRAM.ram_9_inst.INIT_0A = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[1].BRAM.ram_9_inst.INIT_09 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[1].BRAM.ram_9_inst.INIT_08 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[1].BRAM.ram_9_inst.INIT_07 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[1].BRAM.ram_9_inst.INIT_06 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[1].BRAM.ram_9_inst.INIT_05 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[1].BRAM.ram_9_inst.INIT_04 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[1].BRAM.ram_9_inst.INIT_03 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[1].BRAM.ram_9_inst.INIT_02 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[1].BRAM.ram_9_inst.INIT_01 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[1].BRAM.ram_9_inst.INIT_00 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[1].BRAM.ram_9_inst.INITP_07 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[1].BRAM.ram_9_inst.INITP_06 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[1].BRAM.ram_9_inst.INITP_05 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[1].BRAM.ram_9_inst.INITP_04 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[1].BRAM.ram_9_inst.INITP_03 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[1].BRAM.ram_9_inst.INITP_02 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[1].BRAM.ram_9_inst.INITP_01 = 256'h0000000000000000000000000000000000000000000000000000000000000000;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[1].BRAM.ram_9_inst.INITP_00 = 256'h0000000000000000000000000000000000000000000000000000000000000000;

`endif

`ifdef toolchain_quartus

defparam    MEMORIES.GRAPH.BRAM_ARRAY[8].BRAM.init_file = "MEMORIES.GRAPH.BRAM_ARRAY[8].BRAM.ram_9_inst.mif";
defparam    MEMORIES.GRAPH.BRAM_ARRAY[2].BRAM.init_file = "MEMORIES.GRAPH.BRAM_ARRAY[2].BRAM.ram_9_inst.mif";
defparam    MEMORIES.GRAPH.BRAM_ARRAY[3].BRAM.init_file = "MEMORIES.GRAPH.BRAM_ARRAY[3].BRAM.ram_9_inst.mif";
defparam    MEMORIES.GRAPH.BRAM_ARRAY[4].BRAM.init_file = "MEMORIES.GRAPH.BRAM_ARRAY[4].BRAM.ram_9_inst.mif";
defparam    MEMORIES.GRAPH.BRAM_ARRAY[9].BRAM.init_file = "MEMORIES.GRAPH.BRAM_ARRAY[9].BRAM.ram_9_inst.mif";
defparam    MEMORIES.GRAPH.BRAM_ARRAY[6].BRAM.init_file = "MEMORIES.GRAPH.BRAM_ARRAY[6].BRAM.ram_9_inst.mif";
defparam    MEMORIES.GRAPH.BRAM_ARRAY[7].BRAM.init_file = "MEMORIES.GRAPH.BRAM_ARRAY[7].BRAM.ram_9_inst.mif";
defparam    MEMORIES.GRAPH.BRAM_ARRAY[0].BRAM.init_file = "MEMORIES.GRAPH.BRAM_ARRAY[0].BRAM.ram_9_inst.mif";
defparam    MEMORIES.GRAPH.BRAM_ARRAY[5].BRAM.init_file = "MEMORIES.GRAPH.BRAM_ARRAY[5].BRAM.ram_9_inst.mif";
defparam    MEMORIES.GRAPH.BRAM_ARRAY[1].BRAM.init_file = "MEMORIES.GRAPH.BRAM_ARRAY[1].BRAM.ram_9_inst.mif";

`endif

`ifdef toolchain_lattice

defparam    MEMORIES.GRAPH.BRAM_ARRAY[8].BRAM.INITVAL_3F = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[8].BRAM.INITVAL_3E = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[8].BRAM.INITVAL_3D = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[8].BRAM.INITVAL_3C = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[8].BRAM.INITVAL_3B = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[8].BRAM.INITVAL_3A = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[8].BRAM.INITVAL_39 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[8].BRAM.INITVAL_38 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[8].BRAM.INITVAL_37 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[8].BRAM.INITVAL_36 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[8].BRAM.INITVAL_35 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[8].BRAM.INITVAL_34 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[8].BRAM.INITVAL_33 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[8].BRAM.INITVAL_32 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[8].BRAM.INITVAL_31 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[8].BRAM.INITVAL_30 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[8].BRAM.INITVAL_2F = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[8].BRAM.INITVAL_2E = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[8].BRAM.INITVAL_2D = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[8].BRAM.INITVAL_2C = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[8].BRAM.INITVAL_2B = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[8].BRAM.INITVAL_2A = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[8].BRAM.INITVAL_29 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[8].BRAM.INITVAL_28 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[8].BRAM.INITVAL_27 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[8].BRAM.INITVAL_26 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[8].BRAM.INITVAL_25 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[8].BRAM.INITVAL_24 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[8].BRAM.INITVAL_23 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[8].BRAM.INITVAL_22 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[8].BRAM.INITVAL_21 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[8].BRAM.INITVAL_20 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[8].BRAM.INITVAL_1F = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[8].BRAM.INITVAL_1E = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[8].BRAM.INITVAL_1D = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[8].BRAM.INITVAL_1C = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[8].BRAM.INITVAL_1B = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[8].BRAM.INITVAL_1A = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[8].BRAM.INITVAL_19 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[8].BRAM.INITVAL_18 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[8].BRAM.INITVAL_17 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[8].BRAM.INITVAL_16 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[8].BRAM.INITVAL_15 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[8].BRAM.INITVAL_14 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[8].BRAM.INITVAL_13 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[8].BRAM.INITVAL_12 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[8].BRAM.INITVAL_11 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[8].BRAM.INITVAL_10 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[8].BRAM.INITVAL_0F = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[8].BRAM.INITVAL_0E = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[8].BRAM.INITVAL_0D = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[8].BRAM.INITVAL_0C = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[8].BRAM.INITVAL_0B = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[8].BRAM.INITVAL_0A = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[8].BRAM.INITVAL_09 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[8].BRAM.INITVAL_08 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[8].BRAM.INITVAL_07 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[8].BRAM.INITVAL_06 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[8].BRAM.INITVAL_05 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[8].BRAM.INITVAL_04 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[8].BRAM.INITVAL_03 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[8].BRAM.INITVAL_02 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[8].BRAM.INITVAL_01 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[8].BRAM.INITVAL_00 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;

defparam    MEMORIES.GRAPH.BRAM_ARRAY[2].BRAM.INITVAL_3F = "0x180000000007EF0006FF180031FE001FEFF1E0001FEC00000F1E00000000000FF1E0000000007EF0" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[2].BRAM.INITVAL_3E = "0x0000007EF0000000000000000000000000F1E00F1E00000000000000000007EC007EC00000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[2].BRAM.INITVAL_3D = "0x00000000FF180031FE000003F1E00000000000FF180000000001EFC006FF180031FE001FEFF1E000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[2].BRAM.INITVAL_3C = "0x1FEC00000F1E00000000000FF180000000007EF00000007EF000000000000000000000000031F803" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[2].BRAM.INITVAL_3B = "0x1FEFF1FEFF1FEFF1FEFF1FE001FE00000000000000000000FF180031FE000003F1E00F1FE00006FF" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[2].BRAM.INITVAL_3A = "0x180000000001EFC006FF180031FE0007EFF1E0001FEC00000F1E0031FE00000FF180000000007EF0" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[2].BRAM.INITVAL_39 = "0x0000007EF000000000000000000000000001FE001FEFF1FEFF1FEFF1FEFF1F8031F8000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[2].BRAM.INITVAL_38 = "0x00000000FF180031FE000003F1E0031FE00006FF000000000001EF0006FF180031FE0007EFF1E000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[2].BRAM.INITVAL_37 = "0x1FEC00000F1E0031FEC0000FF180000000007EF00000007EF0000000000000000000000000007EC0" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[2].BRAM.INITVAL_36 = "0x07EFF1FEFF1FEFF1FEFF1E00F1E000000000000000000000FF180031FE000003F1E0031FEC001EFF" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[2].BRAM.INITVAL_35 = "0x000001E00007EF0006FF180031FE0001EFF1E0001FEC00000F1E0001FEC0006FF180000000007EF0" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[2].BRAM.INITVAL_34 = "0x0000007EF0000000000000000000000000001EF0000000000000000000000003F180000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[2].BRAM.INITVAL_33 = "0x1FEFF1FEFF180031FE000003F1E0031FEFF1FEFF000031FEC31FEF0006FF180031FE00006FF1E000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[2].BRAM.INITVAL_32 = "0x1FEC00000F1E0001FEFF1FEFF0000F1FEFF1FEF0006FF1FEFF1FEC000000000000000000000006FC" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[2].BRAM.INITVAL_31 = "0x00000000000000000000000FF0000000000000001FEFF1FEFF180031FE000003F1E0001FEFF1FEFC" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[2].BRAM.INITVAL_30 = "0x0000F1FEFF1FEC0006FF180031FE00006FF1E0001FEC00000F1E00007EFF1FEFF0000F1FEFF1FEF0" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[2].BRAM.INITVAL_2F = "0x006FF1FEFF1FEC000000000000000000000000FF00000000000000000000006FC000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[2].BRAM.INITVAL_2E = "0x1FEFF1FEFF180031FE000003F1E00007EFF1FEF00000F1FEFF1FEC0006FF180031FE00000FF1E000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[2].BRAM.INITVAL_2D = "0x1FEC00000F1E00001EFF1FEFC0000F1FEFF1FEF0006FF1FEFF1FEC0000000000000000000000003F" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[2].BRAM.INITVAL_2C = "0x1FEFF1FEFF1FEFF1FEFF1FEF00000000000000001FEFF1FEFF180031FE000003F1E00001EFF1FEC0" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[2].BRAM.INITVAL_2B = "0x000001FEFF1F800006FF180031FE000003F1E0001FEC00000F1E000006FF1FEF00000F1FEFF1FEF0" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[2].BRAM.INITVAL_2A = "0x006FF1FEFF1FEC0000000000000000000000000F1FEFF1FEFF1FEFF1FEFF1FEC0000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[2].BRAM.INITVAL_29 = "0x1FEFF1FEFF180031FE000003F1E0000003F1E0000000001EFF18000006FF180031FE000003F1E000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[2].BRAM.INITVAL_28 = "0x1FEC00000F1E0000003F1F8000000F1FEFF1FEF0006FF1FEFF1FEC00000000000000000000000003" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[2].BRAM.INITVAL_27 = "0x1FEFF1FEFF1FEFF1FEFF1FE000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[2].BRAM.INITVAL_26 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[2].BRAM.INITVAL_25 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[2].BRAM.INITVAL_24 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[2].BRAM.INITVAL_23 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[2].BRAM.INITVAL_22 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[2].BRAM.INITVAL_21 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[2].BRAM.INITVAL_20 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[2].BRAM.INITVAL_1F = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[2].BRAM.INITVAL_1E = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[2].BRAM.INITVAL_1D = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[2].BRAM.INITVAL_1C = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[2].BRAM.INITVAL_1B = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[2].BRAM.INITVAL_1A = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[2].BRAM.INITVAL_19 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[2].BRAM.INITVAL_18 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[2].BRAM.INITVAL_17 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[2].BRAM.INITVAL_16 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[2].BRAM.INITVAL_15 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[2].BRAM.INITVAL_14 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[2].BRAM.INITVAL_13 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[2].BRAM.INITVAL_12 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[2].BRAM.INITVAL_11 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[2].BRAM.INITVAL_10 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[2].BRAM.INITVAL_0F = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[2].BRAM.INITVAL_0E = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[2].BRAM.INITVAL_0D = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[2].BRAM.INITVAL_0C = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[2].BRAM.INITVAL_0B = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[2].BRAM.INITVAL_0A = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[2].BRAM.INITVAL_09 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[2].BRAM.INITVAL_08 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[2].BRAM.INITVAL_07 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[2].BRAM.INITVAL_06 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[2].BRAM.INITVAL_05 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[2].BRAM.INITVAL_04 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[2].BRAM.INITVAL_03 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[2].BRAM.INITVAL_02 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[2].BRAM.INITVAL_01 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[2].BRAM.INITVAL_00 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;

defparam    MEMORIES.GRAPH.BRAM_ARRAY[3].BRAM.INITVAL_3F = "0x01EFC000001FEC000000006F00000000000000000003F0000000000006F00000000000000000003F" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[3].BRAM.INITVAL_3E = "0x07EFF1FEFF1F800006FC000031FEFF1FEFF1803F1E00001EFF1FEC0000001FEFF1FEFC006FF1FEFF" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[3].BRAM.INITVAL_3D = "0x1FE001FEC00000F1F8031FE0007EFC000001FEC001EFC000001FEC000000006F0000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[3].BRAM.INITVAL_3C = "0x0003F0000000000006F00000000000000000003F00000000000003F1800007EC0000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[3].BRAM.INITVAL_3B = "0x000000003F1E00000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[3].BRAM.INITVAL_3A = "0x00000000000000000000006F007EFF1FEFF1FEFF1FEFF0000000000006FF1FEFF1FEFF1FEFF1E03F" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[3].BRAM.INITVAL_39 = "0x00000000000003F1800007EC00000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[3].BRAM.INITVAL_38 = "0x000000000000000000000000000000000000000000000000000000000000006F007EFF1FEFF1FEFF" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[3].BRAM.INITVAL_37 = "0x1FEFF0000000000006FF1FEFF1FEFF1FEFF1E03F00000000000003F1800007EC0000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[3].BRAM.INITVAL_36 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[3].BRAM.INITVAL_35 = "0x00000000000000000000006F007EFF1FEFF1FEFF1FEFF0000000000006FF1FEFF1FEFF1FEFF1E03F" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[3].BRAM.INITVAL_34 = "0x00000000000003F1800007EC00000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[3].BRAM.INITVAL_33 = "0x000000000000000000000000000000000000000000000000000000000000006F007EC00000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[3].BRAM.INITVAL_32 = "0x0000000000000000000000000000000000F1E03F00000000000003F1800007EC0000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[3].BRAM.INITVAL_31 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[3].BRAM.INITVAL_30 = "0x00000000000000000000006F001EF000000000000000000000000000000000000000000003F1803F" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[3].BRAM.INITVAL_2F = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[3].BRAM.INITVAL_2E = "0x000000000000000000000000000000000000000000000000000000000000006FC006FC0000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[3].BRAM.INITVAL_2D = "0x000000000000000000000000000000000FF000FF0000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[3].BRAM.INITVAL_2C = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[3].BRAM.INITVAL_2B = "0x00000000000000000000000FF000FF0000000000000000000000000000000000000000006FC006FC" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[3].BRAM.INITVAL_2A = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[3].BRAM.INITVAL_29 = "0x0000000000000000000000000000000000000000000000000000000000000003F1803F1800000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[3].BRAM.INITVAL_28 = "0x00000000000000000000000000000001EF001EF00000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[3].BRAM.INITVAL_27 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[3].BRAM.INITVAL_26 = "0x000000000000000000000000F1E00F1E0000000000000000000000000000000000000007EC007EC0" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[3].BRAM.INITVAL_25 = "0x1FEFF1FEFF180031FE000003F1E000006FF1FE000000007EFF1FE00006FF180031FE000003F1E000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[3].BRAM.INITVAL_24 = "0x1FEC00000F1E000000FF1FEC00000F1FEFF1FEF00000007EF00000000000000031F8031F80000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[3].BRAM.INITVAL_23 = "0x0000000000000000000000000000001FE001FE001FEFF1FEFF180031FE000003F1E00001EFF1FEF0" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[3].BRAM.INITVAL_22 = "0x000001FEFF1FEF0006FF180031FE000003F1E0001FEC00000F1E00001EFF1FEF00000F1FEFF1FEF0" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[3].BRAM.INITVAL_21 = "0x0000007EF00000000000000001FE001FE00000000000000000000000000000000000031F8031F800" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[3].BRAM.INITVAL_20 = "0x1FEFF1FEFF180031FE000003F1E0001FEFF1FEFC000031FEFF1FEFC006FF180031FEC00003F1E000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[3].BRAM.INITVAL_1F = "0x1FEC00000F1E00007EFF1FEFC0000F1FEFF1FEF00000007EF000000000000000007EC007EC000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[3].BRAM.INITVAL_1E = "0x00000000000000000000000000000F1E00F1E0001FEFF1FEFF180031FE000003F1E0001FEFF1FEFC" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[3].BRAM.INITVAL_1D = "0x0000F1FEFF1FEFC006FF180031FEF00003F1E0001FEC00000F1E0001FEFF1FEFF0000F1FEFF1FEF0" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[3].BRAM.INITVAL_1C = "0x0000007EF000000000000000001EF001EF00000000000000000000000000000000003F1803F18000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[3].BRAM.INITVAL_1B = "0x00000000FF180031FE000003F1E0031FEC001EFF0000F1FE0001EF0006FF180031FEF00003F1E000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[3].BRAM.INITVAL_1A = "0x1FEC00000F1E0001FEF001EFF180000000007EF00000007EF0000000000000000006FC006FC00000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[3].BRAM.INITVAL_19 = "0x0000000000000000000000000000FF000FF0000000000000FF180031FE000003F1E0031FE00006FF" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[3].BRAM.INITVAL_18 = "0x0003F1E000000C0006FF180031FEFC0003F1E0001FEC00000F1E0031FEC0000FF180000000007EF0" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[3].BRAM.INITVAL_17 = "0x0000007EF0000000000000000000FF000FF000000000000000000000000000000006FC006FC00000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[3].BRAM.INITVAL_16 = "0x00000000FF180031FE000003F1E00F1FE00006FF1803F1E00000000006FF180031FEFF0003F1E000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[3].BRAM.INITVAL_15 = "0x1FEC00000F1E0031FE00000FF180000000007EF00000007EF00000000000000000003F1803F18000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[3].BRAM.INITVAL_14 = "0x000000000000000000000000001EF001EF00000000000000FF180031FE000003F1E00F1F800000FF" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[3].BRAM.INITVAL_13 = "0x1803F1E00000000006FF180031FEFF0003F1E0001FEC00000F1E0031FE00000FF180000000007EF0" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[3].BRAM.INITVAL_12 = "0x0000007EF00000000000000000000F1E00F1E000000000000000000000000000007EC007EC000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[3].BRAM.INITVAL_11 = "0x00000000FF180031FE000003F1E00000000000FF1803F1E00000000006FF180031FEFF1803F1E000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[3].BRAM.INITVAL_10 = "0x1FEC00000F1E00000000000FF1E0000000007EF00000007EF0000000000000000000031F8031F800" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[3].BRAM.INITVAL_0F = "0x00000000000000000000000001FE001FE000000000000000FF180031FE000003F1E00000000000FF" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[3].BRAM.INITVAL_0E = "0x1803F1FE0000000006FF180031FEFF1803F1E0001FEC00000F1E00000000000FF1E0000000007EF0" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[3].BRAM.INITVAL_0D = "0x0000007EF0000000000000000000001FE001FE0000000000000000000000000031F8031F80000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[3].BRAM.INITVAL_0C = "0x01EFF1FEFF180031FEFF1FEFF1E00000000000FF1800F1FEFF18000006FF180031FEFF1E03F1E000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[3].BRAM.INITVAL_0B = "0x1FEFF1FEFF1E00000000000FF1E0031FEFF1FEF00000007EF00000000000000000000007EC007EC0" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[3].BRAM.INITVAL_0A = "0x000000000000000000000000F1E00F1E0000000001EFF1FEFF180031FEFF1FEFF1E00000000000FF" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[3].BRAM.INITVAL_09 = "0x1800F1FEFF1FE00006FF180031FE3F1F83F1E0001FEFF1FEFF1E00000000000FF1E0031FEFF1FEF0" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[3].BRAM.INITVAL_08 = "0x0000007EF00000000000000000000001EF001EF0000000000000000000000003F1803F1800000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[3].BRAM.INITVAL_07 = "0x01EFF1FEFF180031FEFF1FEFF1E00000000000FF180031FEFF1FEC0006FF180031FE0F1F83F1E000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[3].BRAM.INITVAL_06 = "0x1FEFF1FEFF1E00000000000FF1E0031FEFF1FEF00000007EF000000000000000000000006FC006FC" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[3].BRAM.INITVAL_05 = "0x00000000000000000000000FF000FF000000000001EFF1FEFF180031FEFF1FEFF1E00000000000FF" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[3].BRAM.INITVAL_04 = "0x1800007EFF1FEF0006FF180031FE0F1FE3F1E0001FEFF1FEFF1E00000000000FF1E0031FEFF1FEF0" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[3].BRAM.INITVAL_03 = "0x0000007EF000000000000000000000000FF000FF00000000000000000000006FC006FC0000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[3].BRAM.INITVAL_02 = "0x01EFF1FEFF180031FEFF1FEFF1E00000000000FF18000000FF1FEF0006FF180031FE031FEFF1E000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[3].BRAM.INITVAL_01 = "0x1FEFF1FEFF1E00000000000FF1E0031FEFF1FEF00000007EF0000000000000000000000003F1803F" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[3].BRAM.INITVAL_00 = "0x1800000000000000000001EF001EF0000000000000000000FF180031FE000003F1E00000000000FF" ;

defparam    MEMORIES.GRAPH.BRAM_ARRAY[4].BRAM.INITVAL_3F = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[4].BRAM.INITVAL_3E = "0x000000000000000000000000000000000000000000000000000000000000006F007E000000000003" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[4].BRAM.INITVAL_3D = "0x1E03F1FEFF1FEFF1FEF007E0000000000031E03F0000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[4].BRAM.INITVAL_3C = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[4].BRAM.INITVAL_3B = "0x00000000000000000000006F007E0000000000031E03F0000000000006F007E0000000000031E03F" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[4].BRAM.INITVAL_3A = "0x0000000000000000000000000000000000000000000000000F1F8000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[4].BRAM.INITVAL_39 = "0x00000000000000000000000000000000000000000000001EF00000000000006F007E000000000003" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[4].BRAM.INITVAL_38 = "0x1E03F0000000000006F007E0000000000031E03F000031FE0001EFC00000006FF0000F1F8000003F" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[4].BRAM.INITVAL_37 = "0x1E000006FF1FEFC000FF1E00001EFC006FF1FEFF1FE00000031FE00000031FE0007EFC000001FEC0" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[4].BRAM.INITVAL_36 = "0x000031FEFF1800000000006F007E0000000000031E03F0000000000006F007E0000000000031E03F" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[4].BRAM.INITVAL_35 = "0x000031FE00006FF0000001EFC0000F1F8000003F1E00007EFF1FEFF000FF1E00001EFC006FF1FEFF" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[4].BRAM.INITVAL_34 = "0x1FE00000031FE00000031FE0007EFC000001FEC00003F1FEFF1E00000000006F007E000000000003" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[4].BRAM.INITVAL_33 = "0x1E03F0000000000006F007E0000000000031E03F000031FE00006FF0000001EFC0000F1F8000003F" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[4].BRAM.INITVAL_32 = "0x1E00007EFF1FEFF1E03F1F80001EFC006FF1FEFF1FE000000F1FE00000031FE0007EFF000001FEC0" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[4].BRAM.INITVAL_31 = "0x000FF1FEFF1F80000000006F007E0000000000031E03F0000000000006F007E0000000000031E03F" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[4].BRAM.INITVAL_30 = "0x000031FE00006FF0000001EFC0000F1F8000003F1E0001FEFF1FEFF1800F1F80001EFC006FF1FEFF" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[4].BRAM.INITVAL_2F = "0x1FE000000F1FEC0000031FE0007EFF000001FEC0000FF1FEFF1FE0000000006F007E000000000003" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[4].BRAM.INITVAL_2E = "0x1E03F0000000000006F007E0000000000031E03F000031FE00000FF1FEFF1FEF00000F1F8000003F" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[4].BRAM.INITVAL_2D = "0x1E0031FEC0000FF0000F1FE0001EFC00000000031FE000000F1FEC0000031FE0007EFF180001FEC0" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[4].BRAM.INITVAL_2C = "0x006FF1800F1FE0000000006F007E0000000000031E03F0000000000006F007E0000000000031E03F" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[4].BRAM.INITVAL_2B = "0x000031FE00000FF1FEFF1FEF00000F1F8000003F1E0031FE000000C000031FE0001EFC0000000003" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[4].BRAM.INITVAL_2A = "0x1FE000000F1FEC0000031FE0007EFF1E0001FEC0006FF000031FEC000000006F007E000000000003" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[4].BRAM.INITVAL_29 = "0x1E03F0000000000006F007E0000000000031E03F000031FE00000FF1FEFF1FEF00000F1F8000003F" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[4].BRAM.INITVAL_28 = "0x1E0031FE0000000000031FEC001EFC00000000031FE000003F1FEC0000031FE0007EFF1E0001FEC0" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[4].BRAM.INITVAL_27 = "0x01EFF000001FEC000000006F007E0000000000031E03F0000000000006F007E0000000000031E03F" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[4].BRAM.INITVAL_26 = "0x000031FE000003F1FEFF1FEC00000F1F8000003F1E0031FE0000000000001FEC001EFC0000000003" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[4].BRAM.INITVAL_25 = "0x1FE000003F1FEF0000031FE0007EFF1F8001FEC001EFC000001FEC000000006F007E000000000003" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[4].BRAM.INITVAL_24 = "0x1E03F0000000000006F007E0000000000031E03F000031FE000003F1E0001FEC00000F1F8000003F" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[4].BRAM.INITVAL_23 = "0x1E0031FE0000000000001FEF001EFC00000000031FE00000FF1FEF0000031FE0007EFF1FE001FEC0" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[4].BRAM.INITVAL_22 = "0x01EFC000001FEC000000006F007E0000000000031E03F0000000000006F007E0000000000031E03F" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[4].BRAM.INITVAL_21 = "0x000031FE000000F1E0031FEC00000F1F8000003F1E0031FEF0000000000007EFF1FEFC0000000003" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[4].BRAM.INITVAL_20 = "0x1FE00000FF19EFC000031FE0007EFF1FEC01FEC001EFC000001FEC000000006F007E000000000003" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[4].BRAM.INITVAL_1F = "0x1E03F0000000000006F007E0000000000031E03F000031FE000000F1F8031FE000000F1F8000003F" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[4].BRAM.INITVAL_1E = "0x1E0001FEFF1FE000000007EFF1FEFC0003F1FEFF1FE00000FF19EFC000031FE0007EFF1FEC01FEC0" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[4].BRAM.INITVAL_1D = "0x01EFC000001FEC000000006F007E0000000000031E03F0000000000006F007E0000000000031E03F" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[4].BRAM.INITVAL_1C = "0x000031FE000000F1F8031FE000000F1F8000003F1E0001FEFF1FEF0000031FEFF1FEFC0003F1FEFF" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[4].BRAM.INITVAL_1B = "0x1FE00006FF01EFC000031FE0007EFC1FEF01FEC001EFC000001FEC000000006F007E000000000003" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[4].BRAM.INITVAL_1A = "0x1E03F0000000000006F007E0000000000031E03F000031FE00000031F80F1F8000000F1F8000003F" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[4].BRAM.INITVAL_19 = "0x1E00007EFF1FEFC0000F1FEFF1FEFC0003F1FEFF1FE00006FF006FF000031FE0007EFC1FEF01FEC0" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[4].BRAM.INITVAL_18 = "0x01EFC000001FEC000000006F007E0000000000031E03F0000000000006F007E0000000000031E03F" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[4].BRAM.INITVAL_17 = "0x000031FE00000031FE0F1F8000000F1F8000003F1E000006FF1FEFF0003F1FEFF1FEFC0003F1FEFF" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[4].BRAM.INITVAL_16 = "0x1FE00006FF006FF000031FE0007EFC07EFC1FEC001EFC000001FEC000000006F007E000000000003" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[4].BRAM.INITVAL_15 = "0x1E03F0000000000006F007E0000000000031E03F000031FE00000031FE0F1F8000000F1F8000003F" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[4].BRAM.INITVAL_14 = "0x1E000000001FEFF0003F1F80001EFC00000000031FE00006FC006FF000031FE0007EFC01EFF1FEC0" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[4].BRAM.INITVAL_13 = "0x01EFC000001FEC000000006F007E0000000000031E03F0000000000006F007E0000000000031E03F" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[4].BRAM.INITVAL_12 = "0x000031FE00000001FE3F1E0000000F1F8000003F1E00000000006FF180FF1E00001EFC0000000003" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[4].BRAM.INITVAL_11 = "0x1FE0001EFC000FF180031FE0007EFC01EFF1FEC001EFC000001FEC000000006F007E000000000003" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[4].BRAM.INITVAL_10 = "0x1E03F0000000000006F007E0000000000031E03F000031FE00000001FEFF1E0000000F1F8000003F" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[4].BRAM.INITVAL_0F = "0x1E00000000000FF180FF1E00001EFC00000000031FE0001EFC000FF180031FE0007EFC006FF1FEC0" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[4].BRAM.INITVAL_0E = "0x01EFC000001FEC000000006F007E0000000000031E03F0000000000006F007E0000000000031E03F" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[4].BRAM.INITVAL_0D = "0x000031FE000000007EFF1E0000000F1F8000003F1E00000000000FF180FF1E00001EFC0000000003" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[4].BRAM.INITVAL_0C = "0x1FE0007EFC000FF180031FE0007EFC000FF1FEC001EFC000001FEC000000006F007E000000000003" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[4].BRAM.INITVAL_0B = "0x1E03F0000000000006F007E0000000000031E03F000031FE000000007EFF180000000F1F8000003F" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[4].BRAM.INITVAL_0A = "0x1E00000000000FF180FF1E00001EFC00000000031FE0007EF0000FF1E0031FE0007EFC000FF1FEC0" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[4].BRAM.INITVAL_09 = "0x01EFC000001FEC000000006F007E0000000000031E03F0000000000006F007E0000000000031E03F" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[4].BRAM.INITVAL_08 = "0x000031FE000000007EFF180000000F1F8000003F1E00001E00006FF0003F1F80001EFC0000000003" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[4].BRAM.INITVAL_07 = "0x1FE0007EF00003F1E0031FE0007EFC0003F1FEC001EFC000001FEC000000006F007EFF1FEFF1FEFF" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[4].BRAM.INITVAL_06 = "0x1E03F0000000000006F007EFF1FEFF1FEFF1E03F07EFF1FEFF1F80001EFF000031FEFF1FEFF1803F" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[4].BRAM.INITVAL_05 = "0x1E00007EFF1FEFF0003F1FEFF1FEFC006FF1FEFF1FE001FEF00003F1E0031FE0007EFC0000F1FEC0" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[4].BRAM.INITVAL_04 = "0x01EFC000001FEC000000006F007EFF1FEFF1FEFF1E03F0000000000006F007EFF1FEFF1FEFF1E03F" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[4].BRAM.INITVAL_03 = "0x07EFF1FEFF1F80001EFF000031FEFF1FEFF1803F1E0001FEFF1FEFC0000F1FEFF1FEFC006FF1FEFF" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[4].BRAM.INITVAL_02 = "0x1FE001FEC00003F1F8031FE0007EFC0000F1FEC001EFC000001FEC000000006F007EFF1FEFF1FEFF" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[4].BRAM.INITVAL_01 = "0x1E03F0000000000006F007EFF1FEFF1FEFF1E03F07EFF1FEFF1F80001EFF000031FEFF1FEFF1803F" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[4].BRAM.INITVAL_00 = "0x1E00007EFF1FEF0000031FEFF1FEFC006FF1FEFF1FE001FEC00000F1F8031FE0007EFC000031FEC0" ;

defparam    MEMORIES.GRAPH.BRAM_ARRAY[9].BRAM.INITVAL_3F = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[9].BRAM.INITVAL_3E = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[9].BRAM.INITVAL_3D = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[9].BRAM.INITVAL_3C = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[9].BRAM.INITVAL_3B = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[9].BRAM.INITVAL_3A = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[9].BRAM.INITVAL_39 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[9].BRAM.INITVAL_38 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[9].BRAM.INITVAL_37 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[9].BRAM.INITVAL_36 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[9].BRAM.INITVAL_35 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[9].BRAM.INITVAL_34 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[9].BRAM.INITVAL_33 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[9].BRAM.INITVAL_32 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[9].BRAM.INITVAL_31 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[9].BRAM.INITVAL_30 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[9].BRAM.INITVAL_2F = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[9].BRAM.INITVAL_2E = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[9].BRAM.INITVAL_2D = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[9].BRAM.INITVAL_2C = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[9].BRAM.INITVAL_2B = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[9].BRAM.INITVAL_2A = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[9].BRAM.INITVAL_29 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[9].BRAM.INITVAL_28 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[9].BRAM.INITVAL_27 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[9].BRAM.INITVAL_26 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[9].BRAM.INITVAL_25 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[9].BRAM.INITVAL_24 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[9].BRAM.INITVAL_23 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[9].BRAM.INITVAL_22 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[9].BRAM.INITVAL_21 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[9].BRAM.INITVAL_20 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[9].BRAM.INITVAL_1F = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[9].BRAM.INITVAL_1E = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[9].BRAM.INITVAL_1D = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[9].BRAM.INITVAL_1C = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[9].BRAM.INITVAL_1B = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[9].BRAM.INITVAL_1A = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[9].BRAM.INITVAL_19 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[9].BRAM.INITVAL_18 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[9].BRAM.INITVAL_17 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[9].BRAM.INITVAL_16 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[9].BRAM.INITVAL_15 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[9].BRAM.INITVAL_14 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[9].BRAM.INITVAL_13 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[9].BRAM.INITVAL_12 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[9].BRAM.INITVAL_11 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[9].BRAM.INITVAL_10 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[9].BRAM.INITVAL_0F = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[9].BRAM.INITVAL_0E = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[9].BRAM.INITVAL_0D = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[9].BRAM.INITVAL_0C = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[9].BRAM.INITVAL_0B = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[9].BRAM.INITVAL_0A = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[9].BRAM.INITVAL_09 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[9].BRAM.INITVAL_08 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[9].BRAM.INITVAL_07 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[9].BRAM.INITVAL_06 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[9].BRAM.INITVAL_05 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[9].BRAM.INITVAL_04 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[9].BRAM.INITVAL_03 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[9].BRAM.INITVAL_02 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[9].BRAM.INITVAL_01 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[9].BRAM.INITVAL_00 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;

defparam    MEMORIES.GRAPH.BRAM_ARRAY[6].BRAM.INITVAL_3F = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[6].BRAM.INITVAL_3E = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[6].BRAM.INITVAL_3D = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[6].BRAM.INITVAL_3C = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[6].BRAM.INITVAL_3B = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[6].BRAM.INITVAL_3A = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[6].BRAM.INITVAL_39 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[6].BRAM.INITVAL_38 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[6].BRAM.INITVAL_37 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[6].BRAM.INITVAL_36 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[6].BRAM.INITVAL_35 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[6].BRAM.INITVAL_34 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[6].BRAM.INITVAL_33 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[6].BRAM.INITVAL_32 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[6].BRAM.INITVAL_31 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[6].BRAM.INITVAL_30 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[6].BRAM.INITVAL_2F = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[6].BRAM.INITVAL_2E = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[6].BRAM.INITVAL_2D = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[6].BRAM.INITVAL_2C = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[6].BRAM.INITVAL_2B = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[6].BRAM.INITVAL_2A = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[6].BRAM.INITVAL_29 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[6].BRAM.INITVAL_28 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[6].BRAM.INITVAL_27 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[6].BRAM.INITVAL_26 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[6].BRAM.INITVAL_25 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[6].BRAM.INITVAL_24 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[6].BRAM.INITVAL_23 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[6].BRAM.INITVAL_22 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[6].BRAM.INITVAL_21 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[6].BRAM.INITVAL_20 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[6].BRAM.INITVAL_1F = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[6].BRAM.INITVAL_1E = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[6].BRAM.INITVAL_1D = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[6].BRAM.INITVAL_1C = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[6].BRAM.INITVAL_1B = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[6].BRAM.INITVAL_1A = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[6].BRAM.INITVAL_19 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[6].BRAM.INITVAL_18 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[6].BRAM.INITVAL_17 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[6].BRAM.INITVAL_16 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[6].BRAM.INITVAL_15 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[6].BRAM.INITVAL_14 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[6].BRAM.INITVAL_13 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[6].BRAM.INITVAL_12 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[6].BRAM.INITVAL_11 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[6].BRAM.INITVAL_10 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[6].BRAM.INITVAL_0F = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[6].BRAM.INITVAL_0E = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[6].BRAM.INITVAL_0D = "0x000000000000000000000000000000000000000000000000000000000000000000000000000000FF" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[6].BRAM.INITVAL_0C = "0x0000001EFC000FF1FEFF1FE000000007EFF1FE00000031FEF00000F1FEFF1FEF001EFF000001FEF0" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[6].BRAM.INITVAL_0B = "0x0000001EFF1FEC000000000000000000000000031FEFF1FEFF1FEFF1FEFF1FE00000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[6].BRAM.INITVAL_0A = "0x00000000000000000000000000000000000000FF1800001EFC000FF1FEFF1FE000000F1FEFF1FE00" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[6].BRAM.INITVAL_09 = "0x000FF1FEFF1800F1FEFF1FEF0006FF180001FEF0000031FEFF1FEC0000000000000000000000000F" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[6].BRAM.INITVAL_08 = "0x1FEFF1FEFF1FEFF1FEFF1FEC000000000000000000000000000000000000000000000000000000FF" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[6].BRAM.INITVAL_07 = "0x1E00001EFC000FF1FEFF1FE00000FF1FEFF1FE00006FF1FEFF1E00F1FEFF1FEF0000FF180001FEF0" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[6].BRAM.INITVAL_06 = "0x0003F1FEFF1FEC0000000000000000000000003F1FEFF1FEFF1FEFF1FEFF1FEF0000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[6].BRAM.INITVAL_05 = "0x00000000000000000000000000000000000000FF1E00001EFC000FF1FEFF1FE00006FF1FEFF1FE00" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[6].BRAM.INITVAL_04 = "0x01EFF1FEFF1F80F1FEFF1FEF0000FF1E0001FEF0000FF1FEFF1FEC000000000000000000000000FF" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[6].BRAM.INITVAL_03 = "0x00000000000000000000006FC00000000000000000000000000000000000000000000000000000FF" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[6].BRAM.INITVAL_02 = "0x1F80001EFC000FF1FEFF1FE00006FF1FEFF1FE0007EFF1FEFF1E00F1FEFF1FEF00003F1E0001FEF0" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[6].BRAM.INITVAL_01 = "0x000FF1FEFF1FEC000000000000000000000006FC00000000000000000000000FF000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[6].BRAM.INITVAL_00 = "0x00000000000000000000000000000000000000FF1FE0001EFC00000000031FE0001EFF000031FE00" ;

defparam    MEMORIES.GRAPH.BRAM_ARRAY[7].BRAM.INITVAL_3F = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[7].BRAM.INITVAL_3E = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[7].BRAM.INITVAL_3D = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[7].BRAM.INITVAL_3C = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[7].BRAM.INITVAL_3B = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[7].BRAM.INITVAL_3A = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[7].BRAM.INITVAL_39 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[7].BRAM.INITVAL_38 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[7].BRAM.INITVAL_37 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[7].BRAM.INITVAL_36 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[7].BRAM.INITVAL_35 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[7].BRAM.INITVAL_34 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[7].BRAM.INITVAL_33 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[7].BRAM.INITVAL_32 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[7].BRAM.INITVAL_31 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[7].BRAM.INITVAL_30 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[7].BRAM.INITVAL_2F = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[7].BRAM.INITVAL_2E = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[7].BRAM.INITVAL_2D = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[7].BRAM.INITVAL_2C = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[7].BRAM.INITVAL_2B = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[7].BRAM.INITVAL_2A = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[7].BRAM.INITVAL_29 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[7].BRAM.INITVAL_28 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[7].BRAM.INITVAL_27 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[7].BRAM.INITVAL_26 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[7].BRAM.INITVAL_25 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[7].BRAM.INITVAL_24 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[7].BRAM.INITVAL_23 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[7].BRAM.INITVAL_22 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[7].BRAM.INITVAL_21 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[7].BRAM.INITVAL_20 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[7].BRAM.INITVAL_1F = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[7].BRAM.INITVAL_1E = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[7].BRAM.INITVAL_1D = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[7].BRAM.INITVAL_1C = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[7].BRAM.INITVAL_1B = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[7].BRAM.INITVAL_1A = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[7].BRAM.INITVAL_19 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[7].BRAM.INITVAL_18 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[7].BRAM.INITVAL_17 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[7].BRAM.INITVAL_16 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[7].BRAM.INITVAL_15 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[7].BRAM.INITVAL_14 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[7].BRAM.INITVAL_13 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[7].BRAM.INITVAL_12 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[7].BRAM.INITVAL_11 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[7].BRAM.INITVAL_10 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[7].BRAM.INITVAL_0F = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[7].BRAM.INITVAL_0E = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[7].BRAM.INITVAL_0D = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[7].BRAM.INITVAL_0C = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[7].BRAM.INITVAL_0B = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[7].BRAM.INITVAL_0A = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[7].BRAM.INITVAL_09 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[7].BRAM.INITVAL_08 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[7].BRAM.INITVAL_07 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[7].BRAM.INITVAL_06 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[7].BRAM.INITVAL_05 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[7].BRAM.INITVAL_04 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[7].BRAM.INITVAL_03 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[7].BRAM.INITVAL_02 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[7].BRAM.INITVAL_01 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[7].BRAM.INITVAL_00 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;

defparam    MEMORIES.GRAPH.BRAM_ARRAY[0].BRAM.INITVAL_3F = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[0].BRAM.INITVAL_3E = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[0].BRAM.INITVAL_3D = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[0].BRAM.INITVAL_3C = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[0].BRAM.INITVAL_3B = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[0].BRAM.INITVAL_3A = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[0].BRAM.INITVAL_39 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[0].BRAM.INITVAL_38 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[0].BRAM.INITVAL_37 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[0].BRAM.INITVAL_36 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[0].BRAM.INITVAL_35 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[0].BRAM.INITVAL_34 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[0].BRAM.INITVAL_33 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[0].BRAM.INITVAL_32 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[0].BRAM.INITVAL_31 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[0].BRAM.INITVAL_30 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[0].BRAM.INITVAL_2F = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[0].BRAM.INITVAL_2E = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[0].BRAM.INITVAL_2D = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[0].BRAM.INITVAL_2C = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[0].BRAM.INITVAL_2B = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[0].BRAM.INITVAL_2A = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[0].BRAM.INITVAL_29 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[0].BRAM.INITVAL_28 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[0].BRAM.INITVAL_27 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[0].BRAM.INITVAL_26 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[0].BRAM.INITVAL_25 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[0].BRAM.INITVAL_24 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[0].BRAM.INITVAL_23 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[0].BRAM.INITVAL_22 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[0].BRAM.INITVAL_21 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[0].BRAM.INITVAL_20 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[0].BRAM.INITVAL_1F = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[0].BRAM.INITVAL_1E = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[0].BRAM.INITVAL_1D = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[0].BRAM.INITVAL_1C = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[0].BRAM.INITVAL_1B = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[0].BRAM.INITVAL_1A = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[0].BRAM.INITVAL_19 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[0].BRAM.INITVAL_18 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[0].BRAM.INITVAL_17 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[0].BRAM.INITVAL_16 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[0].BRAM.INITVAL_15 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[0].BRAM.INITVAL_14 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[0].BRAM.INITVAL_13 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[0].BRAM.INITVAL_12 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[0].BRAM.INITVAL_11 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[0].BRAM.INITVAL_10 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[0].BRAM.INITVAL_0F = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[0].BRAM.INITVAL_0E = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[0].BRAM.INITVAL_0D = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[0].BRAM.INITVAL_0C = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[0].BRAM.INITVAL_0B = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[0].BRAM.INITVAL_0A = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[0].BRAM.INITVAL_09 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[0].BRAM.INITVAL_08 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[0].BRAM.INITVAL_07 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[0].BRAM.INITVAL_06 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[0].BRAM.INITVAL_05 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[0].BRAM.INITVAL_04 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[0].BRAM.INITVAL_03 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[0].BRAM.INITVAL_02 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[0].BRAM.INITVAL_01 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[0].BRAM.INITVAL_00 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;

defparam    MEMORIES.GRAPH.BRAM_ARRAY[5].BRAM.INITVAL_3F = "0x07EF00000F180000000007EF00003F1F8001FEF0006FF1E0001FEC00000000000000000000001EF0" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[5].BRAM.INITVAL_3E = "0x000000000000000000000003F18000000000000000000000000000000000000000000000000000FF" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[5].BRAM.INITVAL_3D = "0x1FE0001EFC00000000031FE0001EFC000031FE0007EF000000000000000007EF00000F1F8001FEF0" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[5].BRAM.INITVAL_3C = "0x006FF000001FEC00000000000000000000007EC007EFF1FEFF1FEFF1FEFF1E00F1E0000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[5].BRAM.INITVAL_3B = "0x00000000000000000000000000000000000000FF1FEC001EFC00000000031FE0001EFC000031FE00" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[5].BRAM.INITVAL_3A = "0x1FEC000000000000000007EF00000F1FE001FEF0006FF000001FEC0000000000000000000001FE00" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[5].BRAM.INITVAL_39 = "0x1FEFF1FEFF1FEFF1FEFF1F8031F800000000000000000000000000000000000000000000000000FF" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[5].BRAM.INITVAL_38 = "0x1FEC001EFC00000000031FE0001EFC000031FE001FEF000000000000000007EF0000031FE001FEF0" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[5].BRAM.INITVAL_37 = "0x006FF000001FEC0000000000000000000031F8031FEFF1FEFF1FEFF1FEFF1FE001FE000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[5].BRAM.INITVAL_36 = "0x00000000000000000000000000000000000000FF1FEF001EFC00000000031FE0001EFC000031FE00" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[5].BRAM.INITVAL_35 = "0x07EF000000000000000007EF0000031FEC01FEF0006FF000001FEC00000000000000000000F1E00F" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[5].BRAM.INITVAL_34 = "0x1E00000000000000000007EC007EC0000000000000000000000000000000000000000000000000FF" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[5].BRAM.INITVAL_33 = "0x1FEFC01EFC00000000031FE0001EFC000031FE0007EFF18000000000000007EF0000001FEFF1FEF0" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[5].BRAM.INITVAL_32 = "0x006FF000001FEC00000000000000000003F1803F1800000000000000000001EF001EF00000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[5].BRAM.INITVAL_31 = "0x00000000000000000000000000000000000000FF1FEFC01EFC0000F1FEFF1FE0001EFC000031FE00" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[5].BRAM.INITVAL_30 = "0x07EFF1FEF0000031FEFF1FEF0000031FEFF1FEF0006FF000001FEC0000000000000000000FF000FF" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[5].BRAM.INITVAL_2F = "0x00000000000000000000006FC006FC000000000000000000000000000000000000000000000000FF" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[5].BRAM.INITVAL_2E = "0x19EFF01EFC0000F1FEFF1FE0001EFC000031FE0001EFF1FEFF000031FEFF1FEF00000F1FEFF1FEF0" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[5].BRAM.INITVAL_2D = "0x006FF000001FEC0000000000000000006FC006FC00000000000000000000000FF000FF0000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[5].BRAM.INITVAL_2C = "0x00000000000000000000000000000000000000FF186FF19EFC0000F1FEFF1FE0001EFC000031FE00" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[5].BRAM.INITVAL_2B = "0x006FF1FEFF180031FEFF1FEF00003F1FEFF1FEF0006FF000001FEC000000000000000001EF001EF0" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[5].BRAM.INITVAL_2A = "0x000000000000000000000003F1803F180000000000000000000000000000000000000000000000FF" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[5].BRAM.INITVAL_29 = "0x186FF19EFC0000F1FEFF1FE0001EFC000031FE000003F1FEFF180031FEFF1FEF0000FF1FEFF1FEF0" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[5].BRAM.INITVAL_28 = "0x006FF000001FEC000000000000000007EC007EC0000000000000000000000000F1E00F1E00000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[5].BRAM.INITVAL_27 = "0x00000000000000000000000000000000000000FF180FF1FEFC00000000031FE0001EFC000031FE00" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[5].BRAM.INITVAL_26 = "0x00000006FF1E0000000007EF0000FF180001FEF0006FF000001FEC00000000000000001FE001FE00" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[5].BRAM.INITVAL_25 = "0x00000000000000000000000031F8031F8000000000000000000000000000000000000000000000FF" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[5].BRAM.INITVAL_24 = "0x1803F1FEFC00000000031FE0001EFC000031FE00000000003F1E0000000007EF0006FF180001FEF0" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[5].BRAM.INITVAL_23 = "0x006FF000001FEC00000000000000031F8031F80000000000000000000000000001FE001FE0000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[5].BRAM.INITVAL_22 = "0x00000000000000000000000000000000000000FF1803F1FEFC00000000031FE0001EFC000031FE00" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[5].BRAM.INITVAL_21 = "0x000000003F1E0000000007EF0006FF000001FEF0006FF000001FEC000000000000000F1E00F1E000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[5].BRAM.INITVAL_20 = "0x000000000000000000000000007EC007EC00000000000000000000000000000000000000000000FF" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[5].BRAM.INITVAL_1F = "0x1800F1FEFC00000000031FE0001EFC000031FE00000000003F1E0000000007EF0006FF000001FEF0" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[5].BRAM.INITVAL_1E = "0x006FF000001FEC000000000000003F1803F18000000000000000000000000000001EF001EF000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[5].BRAM.INITVAL_1D = "0x00000000000000000000000000000000000000FF180031FEFC00000000031FE0001EFF000031FE00" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[5].BRAM.INITVAL_1C = "0x000000003F1E0000000007EF0006FF180001FEF0006FF180001FEC00000000000000FF000FF00000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[5].BRAM.INITVAL_1B = "0x0000000000000000000000000006FC006FC0000000000000000000000000000000000000000000FF" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[5].BRAM.INITVAL_1A = "0x180031FEFC00000000031FE0001EFF180031FE00006F0000FF1E0000000007EF0000FF1E0001FEF0" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[5].BRAM.INITVAL_19 = "0x006FF1E0001FEC00000000000006FC006FC000000000000000000000000000000000FF000FF00000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[5].BRAM.INITVAL_18 = "0x00000000000000000000000000000000000000FF180001FEFC000FF1FEFF1FE00006FF1FEFF1FE00" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[5].BRAM.INITVAL_17 = "0x01EFF1FEFF1800F1FEFF1FEF0000FF1FEFF1FEF0000FF1FEFF1FEC0000000000001EF001EF000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[5].BRAM.INITVAL_16 = "0x00000000000000000000000000003F1803F1800000000000000000000000000000000000000000FF" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[5].BRAM.INITVAL_15 = "0x1800007EFC000FF1FEFF1FE00000FF1FEFF1FE0007EFF1FEFF1800F1FEFF1FEF00003F1FEFF1FEF0" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[5].BRAM.INITVAL_14 = "0x0003F1FEFF1FEC0000000000007EC007EC00000000000000000000000000000000000F1E00F1E000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[5].BRAM.INITVAL_13 = "0x00000000000000000000000000000000000000FF1800007EFC000FF1FEFF1FE000003F1FEFF1FE00" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[5].BRAM.INITVAL_12 = "0x01EFF1FEFF0000F1FEFF1FEF00000F1FEFF1FEF00000F1FEFF1FEC000000000001FE001FE0000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[5].BRAM.INITVAL_11 = "0x0000000000000000000000000000031F8031F80000000000000000000000000000000000000000FF" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[5].BRAM.INITVAL_10 = "0x1800001EFC000FF1FEFF1FE000000F1FEFF1FE00000FF1FEF00000F1FEFF1FEF0000001FEFF1FEF0" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[5].BRAM.INITVAL_0F = "0x000031FEFF1FEC000000000031F8031F800000031FEFF1FEFF1FEFF1FEFF1FE00000001FE001FE00" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[5].BRAM.INITVAL_0E = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[5].BRAM.INITVAL_0D = "0x0000000000000000000000000000000000000000000000000000000000000000F1E00F1E00000003" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[5].BRAM.INITVAL_0C = "0x1FEFF1FEFF1FEFF1FEFF1FE000000007EC007EC00000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[5].BRAM.INITVAL_0B = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[5].BRAM.INITVAL_0A = "0x000000000000000000000003F1803F18000000031FEFF1FEFF1FEFF1FEFF1FE000000001EF001EF0" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[5].BRAM.INITVAL_09 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[5].BRAM.INITVAL_08 = "0x000000000000000000000000000000000000000000000000000000000000000FF000FF0000000003" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[5].BRAM.INITVAL_07 = "0x1E00000000000000000007E0000000006FC006FC0000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[5].BRAM.INITVAL_06 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[5].BRAM.INITVAL_05 = "0x00000000000000000000006FC006FC00000000031E00000000000000000007E0000000000FF000FF" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[5].BRAM.INITVAL_04 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[5].BRAM.INITVAL_03 = "0x000000000000000000000000000000000000000000000000000000000000006F001EF00000000003" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[5].BRAM.INITVAL_02 = "0x1E03F1FEFF1FEFF1FEF007E00000000003F1803F0000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[5].BRAM.INITVAL_01 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[5].BRAM.INITVAL_00 = "0x00000000000000000000006F007EC000000000031E03F1FEFF1FEFF1FEF007E00000000000F1E03F" ;

defparam    MEMORIES.GRAPH.BRAM_ARRAY[1].BRAM.INITVAL_3F = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[1].BRAM.INITVAL_3E = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[1].BRAM.INITVAL_3D = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[1].BRAM.INITVAL_3C = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[1].BRAM.INITVAL_3B = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[1].BRAM.INITVAL_3A = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[1].BRAM.INITVAL_39 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[1].BRAM.INITVAL_38 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[1].BRAM.INITVAL_37 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[1].BRAM.INITVAL_36 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[1].BRAM.INITVAL_35 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[1].BRAM.INITVAL_34 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[1].BRAM.INITVAL_33 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[1].BRAM.INITVAL_32 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[1].BRAM.INITVAL_31 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[1].BRAM.INITVAL_30 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[1].BRAM.INITVAL_2F = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[1].BRAM.INITVAL_2E = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[1].BRAM.INITVAL_2D = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[1].BRAM.INITVAL_2C = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[1].BRAM.INITVAL_2B = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[1].BRAM.INITVAL_2A = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[1].BRAM.INITVAL_29 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[1].BRAM.INITVAL_28 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[1].BRAM.INITVAL_27 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[1].BRAM.INITVAL_26 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[1].BRAM.INITVAL_25 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[1].BRAM.INITVAL_24 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[1].BRAM.INITVAL_23 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[1].BRAM.INITVAL_22 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[1].BRAM.INITVAL_21 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[1].BRAM.INITVAL_20 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[1].BRAM.INITVAL_1F = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[1].BRAM.INITVAL_1E = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[1].BRAM.INITVAL_1D = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[1].BRAM.INITVAL_1C = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[1].BRAM.INITVAL_1B = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[1].BRAM.INITVAL_1A = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[1].BRAM.INITVAL_19 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[1].BRAM.INITVAL_18 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[1].BRAM.INITVAL_17 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[1].BRAM.INITVAL_16 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[1].BRAM.INITVAL_15 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[1].BRAM.INITVAL_14 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[1].BRAM.INITVAL_13 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[1].BRAM.INITVAL_12 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[1].BRAM.INITVAL_11 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[1].BRAM.INITVAL_10 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[1].BRAM.INITVAL_0F = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[1].BRAM.INITVAL_0E = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[1].BRAM.INITVAL_0D = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[1].BRAM.INITVAL_0C = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[1].BRAM.INITVAL_0B = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[1].BRAM.INITVAL_0A = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[1].BRAM.INITVAL_09 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[1].BRAM.INITVAL_08 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[1].BRAM.INITVAL_07 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[1].BRAM.INITVAL_06 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[1].BRAM.INITVAL_05 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[1].BRAM.INITVAL_04 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[1].BRAM.INITVAL_03 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[1].BRAM.INITVAL_02 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[1].BRAM.INITVAL_01 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;
defparam    MEMORIES.GRAPH.BRAM_ARRAY[1].BRAM.INITVAL_00 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ;

`endif

