/**
 * _______________________________________________________________________________
 *
 *  Copyright (c) 2012 TU Dresden, Chair for Embedded Systems
 *  Copyright (c) 2013-2016 TU Darmstadt, Computer Systems Group
 *  (http://www.rs.tu-darmstadt.de) All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions
 *  are met:
 *
 *  1. Redistributions of source code must retain the above copyright
 *     notice, this list of conditions and the following disclaimer.
 *
 *  2. Redistributions in binary form must reproduce the above copyright
 *     notice, this list of conditions and the following disclaimer in the
 *     documentation and/or other materials provided with the distribution.
 *
 *  3. All advertising materials mentioning features or use of this software
 *     must display the following acknowledgement: "This product includes
 *     software developed by the TU Dresden Chair for Embedded Systems, TU Darmstadt Computer Systems Group and
 *     its contributors."
 *
 *  4. Neither the name of the TU Dresden Chair for Embedded Systems, TU Darmstadt Computer Systems Group nor the
 *     names of its contributors may be used to endorse or promote products
 *     derived from this software without specific prior written permission.
 *
 *  THIS SOFTWARE IS PROVIDED BY TU DRESDEN CHAIR FOR EMBEDDED SYSTEMS, TU DARMSTADT COMPUTER SYSTEMS GROUP AND
 *  CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING,
 *  BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
 *  FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 *  REGENTS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 *  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
 *  TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 *  PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 *  LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 *  NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 *  SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * _______________________________________________________________________________
 */

 `default_nettype none

module ram_36_prim
#(
	parameter WRITE_MODE_A = "WRITE_FIRST",
	parameter INIT_A = 36'h000000000, // only for  xilinx (no function on lattice)
	parameter SRVAL_A = 36'h000000000,
	parameter WRITE_MODE_B = "WRITE_FIRST",
	parameter INIT_B = 36'h000000000, // only for  xilinx (no function on lattice)
	parameter SRVAL_B = 36'h000000000,
	parameter SIM_COLLISION_CHECK = "ALL",	// for testing on xilinx (no function on lattice)
        parameter INITVAL_1F_lowbits = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ,
        parameter INITVAL_1E_lowbits = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ,
        parameter INITVAL_1D_lowbits = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ,
        parameter INITVAL_1C_lowbits = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ,
        parameter INITVAL_1B_lowbits = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ,
        parameter INITVAL_1A_lowbits = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ,
        parameter INITVAL_19_lowbits = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ,
        parameter INITVAL_18_lowbits = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ,
        parameter INITVAL_17_lowbits = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ,
        parameter INITVAL_16_lowbits = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ,
        parameter INITVAL_15_lowbits = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ,
        parameter INITVAL_14_lowbits = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ,
        parameter INITVAL_13_lowbits = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ,
        parameter INITVAL_12_lowbits = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ,
        parameter INITVAL_11_lowbits = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ,
        parameter INITVAL_10_lowbits = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ,
        parameter INITVAL_0F_lowbits = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ,
        parameter INITVAL_0E_lowbits = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ,
        parameter INITVAL_0D_lowbits = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ,
        parameter INITVAL_0C_lowbits = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ,
        parameter INITVAL_0B_lowbits = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ,
        parameter INITVAL_0A_lowbits = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ,
        parameter INITVAL_09_lowbits = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ,
        parameter INITVAL_08_lowbits = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ,
        parameter INITVAL_07_lowbits = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ,
        parameter INITVAL_06_lowbits = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ,
        parameter INITVAL_05_lowbits = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ,
        parameter INITVAL_04_lowbits = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ,
        parameter INITVAL_03_lowbits = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ,
        parameter INITVAL_02_lowbits = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ,
        parameter INITVAL_01_lowbits = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ,
        parameter INITVAL_00_lowbits = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ,
	parameter INITVAL_1F_highbits = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ,
	parameter INITVAL_1E_highbits = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ,
	parameter INITVAL_1D_highbits = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ,
	parameter INITVAL_1C_highbits = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ,
	parameter INITVAL_1B_highbits = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ,
	parameter INITVAL_1A_highbits = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ,
	parameter INITVAL_19_highbits = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ,
	parameter INITVAL_18_highbits = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ,
	parameter INITVAL_17_highbits = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ,
	parameter INITVAL_16_highbits = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ,
	parameter INITVAL_15_highbits = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ,
	parameter INITVAL_14_highbits = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ,
	parameter INITVAL_13_highbits = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ,
	parameter INITVAL_12_highbits = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ,
	parameter INITVAL_11_highbits = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ,
	parameter INITVAL_10_highbits = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ,
	parameter INITVAL_0F_highbits = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ,
	parameter INITVAL_0E_highbits = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ,
	parameter INITVAL_0D_highbits = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ,
	parameter INITVAL_0C_highbits = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ,
	parameter INITVAL_0B_highbits = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ,
	parameter INITVAL_0A_highbits = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ,
	parameter INITVAL_09_highbits = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ,
	parameter INITVAL_08_highbits = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ,
	parameter INITVAL_07_highbits = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ,
	parameter INITVAL_06_highbits = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ,
	parameter INITVAL_05_highbits = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ,
	parameter INITVAL_04_highbits = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ,
	parameter INITVAL_03_highbits = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ,
	parameter INITVAL_02_highbits = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ,
	parameter INITVAL_01_highbits = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ,
	parameter INITVAL_00_highbits = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" 
)
(
	CLKA,
	CLKB,
	DOA,
	DOB,
	DIA,
	DIB,
	ADDRA,
	ADDRB,
	ENA,
	ENB,
	WEA,
	WEB,
	SSRA,
	SSRB
);


input wire		CLKA;
input wire		CLKB;
input wire	[35:0]	DIA;
input wire	[35:0]	DIB;
input wire	[8:0]	ADDRA;
input wire	[8:0]	ADDRB;
input wire		ENA;
input wire		ENB;
input wire		WEA;
input wire		WEB;
input wire		SSRA;
input wire		SSRB;

output wire	[35:0]	DOA;
output wire	[35:0]	DOB;

wire scuba_vhi;
wire scuba_vlo;

VHI scuba_vhi_inst (.Z(scuba_vhi));
VLO scuba_vlo_inst (.Z(scuba_vlo));

wire [35:0] DOA_internal;
wire [35:0] DOB_internal;

// instantiation according to WRITE_MODE_A and WRITE_MODE_B

generate

	// begin port a = WRITE_FIRST

	if (WRITE_MODE_A == "WRITE_FIRST")
	begin

		if (WRITE_MODE_B == "WRITE_FIRST")
		begin
		
            ssr_logic #(
            .WIDTH  (      36      ),
            .SRVAL  ( SRVAL_A      )
            ) ssr_logic_inst_a (
            .CLK    ( CLKA         ),
            .DO_in  ( DOA_internal ),
            .DO_out ( DOA          ),
            .EN     ( ENA          ),
            .SSR    ( SSRA         )
            );   
            
            ssr_logic #(
            .WIDTH  (      36      ),
            .SRVAL  ( SRVAL_B      )
            ) ssr_logic_inst_b (
            .CLK    ( CLKB         ),
            .DO_in  ( DOB_internal ),
            .DO_out ( DOB          ),
            .EN     ( ENB          ),
            .SSR    ( SSRB         )
            );



			defparam ram_36_inst_lowbits.INITVAL_1F = INITVAL_1F_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_1E = INITVAL_1E_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_1D = INITVAL_1D_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_1C = INITVAL_1C_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_1B = INITVAL_1B_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_1A = INITVAL_1A_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_19 = INITVAL_19_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_18 = INITVAL_18_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_17 = INITVAL_17_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_16 = INITVAL_16_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_15 = INITVAL_15_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_14 = INITVAL_14_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_13 = INITVAL_13_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_12 = INITVAL_12_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_11 = INITVAL_11_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_10 = INITVAL_10_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_0F = INITVAL_0F_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_0E = INITVAL_0E_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_0D = INITVAL_0D_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_0C = INITVAL_0C_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_0B = INITVAL_0B_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_0A = INITVAL_0A_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_09 = INITVAL_09_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_08 = INITVAL_08_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_07 = INITVAL_07_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_06 = INITVAL_06_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_05 = INITVAL_05_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_04 = INITVAL_04_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_03 = INITVAL_03_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_02 = INITVAL_02_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_01 = INITVAL_01_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_00 = INITVAL_00_lowbits ;
			defparam ram_36_inst_lowbits.CSDECODE_A = "0b000" ;
			defparam ram_36_inst_lowbits.CSDECODE_B = "0b000" ;
			defparam ram_36_inst_lowbits.WRITEMODE_A = "WRITETHROUGH" ;
			defparam ram_36_inst_lowbits.WRITEMODE_B = "WRITETHROUGH" ;
			defparam ram_36_inst_lowbits.GSR = "DISABLED" ;
 			defparam ram_36_inst_lowbits.REGMODE_A = "NOREG" ;
			defparam ram_36_inst_lowbits.REGMODE_B = "NOREG" ;
			defparam ram_36_inst_lowbits.DATA_WIDTH_A = 18 ;
			defparam ram_36_inst_lowbits.DATA_WIDTH_B = 18 ;
			DP16KC ram_36_inst_lowbits (
						    .DIA0(DIA[0]), 
						    .DIA1(DIA[1]), 
						    .DIA2(DIA[2]), 
						    .DIA3(DIA[3]), 
						    .DIA4(DIA[4]), 
						    .DIA5(DIA[5]), 
						    .DIA6(DIA[6]), 
						    .DIA7(DIA[7]), 
						    .DIA8(DIA[8]), 
						    .DIA9(DIA[9]), 
						    .DIA10(DIA[10]), 
						    .DIA11(DIA[11]), 
						    .DIA12(DIA[12]), 
						    .DIA13(DIA[13]), 
						    .DIA14(DIA[14]), 
						    .DIA15(DIA[15]), 
						    .DIA16(DIA[16]), 
						    .DIA17(DIA[17]), 
						    .ADA0(scuba_vhi), 
						    .ADA1(scuba_vhi), 
						    .ADA2(scuba_vlo), 
						    .ADA3(scuba_vlo), 
						    .ADA4(ADDRA[0]), 
						    .ADA5(ADDRA[1]), 
						    .ADA6(ADDRA[2]), 
						    .ADA7(ADDRA[3]), 
						    .ADA8(ADDRA[4]), 
						    .ADA9(ADDRA[5]), 
						    .ADA10(ADDRA[6]), 
						    .ADA11(ADDRA[7]), 
						    .ADA12(ADDRA[8]), 
						    .ADA13(scuba_vlo), 
						    .CEA(ENA), 
						    .CLKA(CLKA), 
						    .OCEA(ENA), 
						    .WEA(WEA), 
						    .CSA0(scuba_vlo), 
						    .CSA1(scuba_vlo), 
						    .CSA2(scuba_vlo), 
						    .RSTA(scuba_vlo), 
						    .DIB0(DIB[0]), 
						    .DIB1(DIB[1]), 
						    .DIB2(DIB[2]), 
						    .DIB3(DIB[3]), 
						    .DIB4(DIB[4]), 
						    .DIB5(DIB[5]), 
						    .DIB6(DIB[6]), 
						    .DIB7(DIB[7]), 
						    .DIB8(DIB[8]), 
						    .DIB9(DIB[9]), 
						    .DIB10(DIB[10]), 
						    .DIB11(DIB[11]), 
						    .DIB12(DIB[12]), 
						    .DIB13(DIB[13]), 
						    .DIB14(DIB[14]), 
						    .DIB15(DIB[15]), 
						    .DIB16(DIB[16]), 
						    .DIB17(DIB[17]), 
						    .ADB0(scuba_vhi), 
						    .ADB1(scuba_vhi), 
						    .ADB2(scuba_vlo), 
						    .ADB3(scuba_vlo), 
						    .ADB4(ADDRB[0]), 
						    .ADB5(ADDRB[1]), 
						    .ADB6(ADDRB[2]), 
						    .ADB7(ADDRB[3]), 
						    .ADB8(ADDRB[4]), 
						    .ADB9(ADDRB[5]), 
						    .ADB10(ADDRB[6]), 
						    .ADB11(ADDRB[7]), 
						    .ADB12(ADDRB[8]), 
						    .ADB13(scuba_vlo), 
						    .CEB(ENB), 
						    .CLKB(CLKB), 
						    .OCEB(ENB), 
						    .WEB(WEB), 
						    .CSB0(scuba_vlo), 
						    .CSB1(scuba_vlo), 
						    .CSB2(scuba_vlo), 
						    .RSTB(scuba_vlo), 
						    .DOA0(DOA_internal[0]), 
						    .DOA1(DOA_internal[1]), 
						    .DOA2(DOA_internal[2]), 
						    .DOA3(DOA_internal[3]), 
						    .DOA4(DOA_internal[4]), 
						    .DOA5(DOA_internal[5]), 
						    .DOA6(DOA_internal[6]), 
						    .DOA7(DOA_internal[7]), 
						    .DOA8(DOA_internal[8]), 
						    .DOA9(DOA_internal[9]), 
						    .DOA10(DOA_internal[10]), 
						    .DOA11(DOA_internal[11]), 
						    .DOA12(DOA_internal[12]), 
						    .DOA13(DOA_internal[13]), 
						    .DOA14(DOA_internal[14]), 
						    .DOA15(DOA_internal[15]), 
						    .DOA16(DOA_internal[16]), 
						    .DOA17(DOA_internal[17]), 
						    .DOB0(DOB_internal[0]), 
						    .DOB1(DOB_internal[1]), 
						    .DOB2(DOB_internal[2]), 
						    .DOB3(DOB_internal[3]), 
						    .DOB4(DOB_internal[4]), 
						    .DOB5(DOB_internal[5]), 
						    .DOB6(DOB_internal[6]), 
						    .DOB7(DOB_internal[7]),
						    .DOB8(DOB_internal[8]), 
						    .DOB9(DOB_internal[9]), 
						    .DOB10(DOB_internal[10]), 
						    .DOB11(DOB_internal[11]), 
						    .DOB12(DOB_internal[12]), 
						    .DOB13(DOB_internal[13]), 
						    .DOB14(DOB_internal[14]), 
						    .DOB15(DOB_internal[15]), 
						    .DOB16(DOB_internal[16]), 
						    .DOB17(DOB_internal[17]));



			defparam ram_36_inst_highbits.INITVAL_1F = INITVAL_1F_highbits ;
			defparam ram_36_inst_highbits.INITVAL_1E = INITVAL_1E_highbits ;
			defparam ram_36_inst_highbits.INITVAL_1D = INITVAL_1D_highbits ;
			defparam ram_36_inst_highbits.INITVAL_1C = INITVAL_1C_highbits ;
			defparam ram_36_inst_highbits.INITVAL_1B = INITVAL_1B_highbits ;
			defparam ram_36_inst_highbits.INITVAL_1A = INITVAL_1A_highbits ;
			defparam ram_36_inst_highbits.INITVAL_19 = INITVAL_19_highbits ;
			defparam ram_36_inst_highbits.INITVAL_18 = INITVAL_18_highbits ;
			defparam ram_36_inst_highbits.INITVAL_17 = INITVAL_17_highbits ;
			defparam ram_36_inst_highbits.INITVAL_16 = INITVAL_16_highbits ;
			defparam ram_36_inst_highbits.INITVAL_15 = INITVAL_15_highbits ;
			defparam ram_36_inst_highbits.INITVAL_14 = INITVAL_14_highbits ;
			defparam ram_36_inst_highbits.INITVAL_13 = INITVAL_13_highbits ;
			defparam ram_36_inst_highbits.INITVAL_12 = INITVAL_12_highbits ;
			defparam ram_36_inst_highbits.INITVAL_11 = INITVAL_11_highbits ;
			defparam ram_36_inst_highbits.INITVAL_10 = INITVAL_10_highbits ;
			defparam ram_36_inst_highbits.INITVAL_0F = INITVAL_0F_highbits ;
			defparam ram_36_inst_highbits.INITVAL_0E = INITVAL_0E_highbits ;
			defparam ram_36_inst_highbits.INITVAL_0D = INITVAL_0D_highbits ;
			defparam ram_36_inst_highbits.INITVAL_0C = INITVAL_0C_highbits ;
			defparam ram_36_inst_highbits.INITVAL_0B = INITVAL_0B_highbits ;
			defparam ram_36_inst_highbits.INITVAL_0A = INITVAL_0A_highbits ;
			defparam ram_36_inst_highbits.INITVAL_09 = INITVAL_09_highbits ;
			defparam ram_36_inst_highbits.INITVAL_08 = INITVAL_08_highbits ;
			defparam ram_36_inst_highbits.INITVAL_07 = INITVAL_07_highbits ;
			defparam ram_36_inst_highbits.INITVAL_06 = INITVAL_06_highbits ;
			defparam ram_36_inst_highbits.INITVAL_05 = INITVAL_05_highbits ;
			defparam ram_36_inst_highbits.INITVAL_04 = INITVAL_04_highbits ;
			defparam ram_36_inst_highbits.INITVAL_03 = INITVAL_03_highbits ;
			defparam ram_36_inst_highbits.INITVAL_02 = INITVAL_02_highbits ;
			defparam ram_36_inst_highbits.INITVAL_01 = INITVAL_01_highbits ;
			defparam ram_36_inst_highbits.INITVAL_00 = INITVAL_00_highbits ;
			defparam ram_36_inst_highbits.CSDECODE_A = "0b000" ;
			defparam ram_36_inst_highbits.CSDECODE_B = "0b000" ;
			defparam ram_36_inst_highbits.WRITEMODE_A = "WRITETHROUGH" ;
			defparam ram_36_inst_highbits.WRITEMODE_B = "WRITETHROUGH" ;
			defparam ram_36_inst_highbits.GSR = "DISABLED" ;
 			defparam ram_36_inst_highbits.REGMODE_A = "NOREG" ;
			defparam ram_36_inst_highbits.REGMODE_B = "NOREG" ;
			defparam ram_36_inst_highbits.DATA_WIDTH_A = 18 ;
			defparam ram_36_inst_highbits.DATA_WIDTH_B = 18 ;
			DP16KC ram_36_inst_highbits (
						    .DIA0(DIA[18]), 
						    .DIA1(DIA[19]), 
						    .DIA2(DIA[20]), 
						    .DIA3(DIA[21]), 
						    .DIA4(DIA[22]), 
						    .DIA5(DIA[23]), 
						    .DIA6(DIA[24]), 
						    .DIA7(DIA[25]), 
						    .DIA8(DIA[26]), 
						    .DIA9(DIA[27]), 
						    .DIA10(DIA[28]), 
						    .DIA11(DIA[29]), 
						    .DIA12(DIA[30]), 
						    .DIA13(DIA[31]), 
						    .DIA14(DIA[32]), 
						    .DIA15(DIA[33]), 
						    .DIA16(DIA[34]), 
						    .DIA17(DIA[35]), 
						    .ADA0(scuba_vhi), 
						    .ADA1(scuba_vhi), 
						    .ADA2(scuba_vlo), 
						    .ADA3(scuba_vlo), 
						    .ADA4(ADDRA[0]), 
						    .ADA5(ADDRA[1]), 
						    .ADA6(ADDRA[2]), 
						    .ADA7(ADDRA[3]), 
						    .ADA8(ADDRA[4]), 
						    .ADA9(ADDRA[5]), 
						    .ADA10(ADDRA[6]), 
						    .ADA11(ADDRA[7]), 
						    .ADA12(ADDRA[8]), 
						    .ADA13(scuba_vlo), 
						    .CEA(ENA), 
						    .CLKA(CLKA), 
						    .OCEA(ENA), 
						    .WEA(WEA), 
						    .CSA0(scuba_vlo), 
						    .CSA1(scuba_vlo), 
						    .CSA2(scuba_vlo), 
						    .RSTA(scuba_vlo), 
						    .DIB0(DIB[18]), 
						    .DIB1(DIB[19]), 
						    .DIB2(DIB[20]), 
						    .DIB3(DIB[21]), 
						    .DIB4(DIB[22]), 
						    .DIB5(DIB[23]), 
						    .DIB6(DIB[24]), 
						    .DIB7(DIB[25]), 
						    .DIB8(DIB[26]), 
						    .DIB9(DIB[27]), 
						    .DIB10(DIB[28]), 
						    .DIB11(DIB[29]), 
						    .DIB12(DIB[30]), 
						    .DIB13(DIB[31]), 
						    .DIB14(DIB[32]), 
						    .DIB15(DIB[33]), 
						    .DIB16(DIB[34]), 
						    .DIB17(DIB[35]), 
						    .ADB0(scuba_vhi), 
						    .ADB1(scuba_vhi), 
						    .ADB2(scuba_vlo), 
						    .ADB3(scuba_vlo), 
						    .ADB4(ADDRB[0]), 
						    .ADB5(ADDRB[1]), 
						    .ADB6(ADDRB[2]), 
						    .ADB7(ADDRB[3]), 
						    .ADB8(ADDRB[4]), 
						    .ADB9(ADDRB[5]), 
						    .ADB10(ADDRB[6]), 
						    .ADB11(ADDRB[7]), 
						    .ADB12(ADDRB[8]), 
						    .ADB13(scuba_vlo), 
						    .CEB(ENB), 
						    .CLKB(CLKB), 
						    .OCEB(ENB), 
						    .WEB(WEB), 
						    .CSB0(scuba_vlo), 
						    .CSB1(scuba_vlo), 
						    .CSB2(scuba_vlo), 
						    .RSTB(scuba_vlo), 
						    .DOA0(DOA_internal[18]), 
						    .DOA1(DOA_internal[19]), 
						    .DOA2(DOA_internal[20]), 
						    .DOA3(DOA_internal[21]), 
						    .DOA4(DOA_internal[22]), 
						    .DOA5(DOA_internal[23]), 
						    .DOA6(DOA_internal[24]), 
						    .DOA7(DOA_internal[25]), 
						    .DOA8(DOA_internal[26]), 
						    .DOA9(DOA_internal[27]), 
						    .DOA10(DOA_internal[28]), 
						    .DOA11(DOA_internal[29]), 
						    .DOA12(DOA_internal[30]), 
						    .DOA13(DOA_internal[31]), 
						    .DOA14(DOA_internal[32]), 
						    .DOA15(DOA_internal[33]), 
						    .DOA16(DOA_internal[34]), 
						    .DOA17(DOA_internal[35]), 
						    .DOB0(DOB_internal[18]), 
						    .DOB1(DOB_internal[19]), 
						    .DOB2(DOB_internal[20]), 
						    .DOB3(DOB_internal[21]), 
						    .DOB4(DOB_internal[22]), 
						    .DOB5(DOB_internal[23]), 
						    .DOB6(DOB_internal[24]), 
						    .DOB7(DOB_internal[25]), 
						    .DOB8(DOB_internal[26]), 
						    .DOB9(DOB_internal[27]), 
						    .DOB10(DOB_internal[28]), 
						    .DOB11(DOB_internal[29]), 
						    .DOB12(DOB_internal[30]), 
						    .DOB13(DOB_internal[31]), 
						    .DOB14(DOB_internal[32]), 
						    .DOB15(DOB_internal[33]), 
						    .DOB16(DOB_internal[34]), 
						    .DOB17(DOB_internal[35]));

		end
		else if (WRITE_MODE_B == "READ_FIRST")
		begin
		
            ssr_logic #(
            .WIDTH  (      36      ),
            .SRVAL  ( SRVAL_A      )
            ) ssr_logic_inst_a (
            .CLK    ( CLKA         ),
            .DO_in  ( DOA_internal ),
            .DO_out ( DOA          ),
            .EN     ( ENA          ),
            .SSR    ( SSRA         )
            );   
            
            ssr_logic #(
            .WIDTH  (      36      ),
            .SRVAL  ( SRVAL_B      )
            ) ssr_logic_inst_b (
            .CLK    ( CLKB         ),
            .DO_in  ( DOB_internal ),
            .DO_out ( DOB          ),
            .EN     ( ENB          ),
            .SSR    ( SSRB         )
            ); 
		


			defparam ram_36_inst_lowbits.INITVAL_1F = INITVAL_1F_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_1E = INITVAL_1E_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_1D = INITVAL_1D_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_1C = INITVAL_1C_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_1B = INITVAL_1B_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_1A = INITVAL_1A_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_19 = INITVAL_19_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_18 = INITVAL_18_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_17 = INITVAL_17_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_16 = INITVAL_16_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_15 = INITVAL_15_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_14 = INITVAL_14_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_13 = INITVAL_13_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_12 = INITVAL_12_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_11 = INITVAL_11_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_10 = INITVAL_10_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_0F = INITVAL_0F_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_0E = INITVAL_0E_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_0D = INITVAL_0D_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_0C = INITVAL_0C_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_0B = INITVAL_0B_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_0A = INITVAL_0A_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_09 = INITVAL_09_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_08 = INITVAL_08_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_07 = INITVAL_07_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_06 = INITVAL_06_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_05 = INITVAL_05_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_04 = INITVAL_04_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_03 = INITVAL_03_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_02 = INITVAL_02_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_01 = INITVAL_01_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_00 = INITVAL_00_lowbits ;
			defparam ram_36_inst_lowbits.CSDECODE_A = "0b000" ;
			defparam ram_36_inst_lowbits.CSDECODE_B = "0b000" ;
			defparam ram_36_inst_lowbits.WRITEMODE_A = "WRITETHROUGH" ;
			defparam ram_36_inst_lowbits.WRITEMODE_B = "READBEFOREWRITE" ;
			defparam ram_36_inst_lowbits.GSR = "DISABLED" ;
 			defparam ram_36_inst_lowbits.REGMODE_A = "NOREG" ;
			defparam ram_36_inst_lowbits.REGMODE_B = "NOREG" ;
			defparam ram_36_inst_lowbits.DATA_WIDTH_A = 18 ;
			defparam ram_36_inst_lowbits.DATA_WIDTH_B = 18 ;
			DP16KC ram_36_inst_lowbits (
						    .DIA0(DIA[0]), 
						    .DIA1(DIA[1]), 
						    .DIA2(DIA[2]), 
						    .DIA3(DIA[3]), 
						    .DIA4(DIA[4]), 
						    .DIA5(DIA[5]), 
						    .DIA6(DIA[6]), 
						    .DIA7(DIA[7]), 
						    .DIA8(DIA[8]), 
						    .DIA9(DIA[9]), 
						    .DIA10(DIA[10]), 
						    .DIA11(DIA[11]), 
						    .DIA12(DIA[12]), 
						    .DIA13(DIA[13]), 
						    .DIA14(DIA[14]), 
						    .DIA15(DIA[15]), 
						    .DIA16(DIA[16]), 
						    .DIA17(DIA[17]), 
						    .ADA0(scuba_vhi), 
						    .ADA1(scuba_vhi), 
						    .ADA2(scuba_vlo), 
						    .ADA3(scuba_vlo), 
						    .ADA4(ADDRA[0]), 
						    .ADA5(ADDRA[1]), 
						    .ADA6(ADDRA[2]), 
						    .ADA7(ADDRA[3]), 
						    .ADA8(ADDRA[4]), 
						    .ADA9(ADDRA[5]), 
						    .ADA10(ADDRA[6]), 
						    .ADA11(ADDRA[7]), 
						    .ADA12(ADDRA[8]), 
						    .ADA13(scuba_vlo), 
						    .CEA(ENA), 
						    .CLKA(CLKA), 
						    .OCEA(ENA), 
						    .WEA(WEA), 
						    .CSA0(scuba_vlo), 
						    .CSA1(scuba_vlo), 
						    .CSA2(scuba_vlo), 
						    .RSTA(scuba_vlo), 
						    .DIB0(DIB[0]), 
						    .DIB1(DIB[1]), 
						    .DIB2(DIB[2]), 
						    .DIB3(DIB[3]), 
						    .DIB4(DIB[4]), 
						    .DIB5(DIB[5]), 
						    .DIB6(DIB[6]), 
						    .DIB7(DIB[7]), 
						    .DIB8(DIB[8]), 
						    .DIB9(DIB[9]), 
						    .DIB10(DIB[10]), 
						    .DIB11(DIB[11]), 
						    .DIB12(DIB[12]), 
						    .DIB13(DIB[13]), 
						    .DIB14(DIB[14]), 
						    .DIB15(DIB[15]), 
						    .DIB16(DIB[16]), 
						    .DIB17(DIB[17]), 
						    .ADB0(scuba_vhi), 
						    .ADB1(scuba_vhi), 
						    .ADB2(scuba_vlo), 
						    .ADB3(scuba_vlo), 
						    .ADB4(ADDRB[0]), 
						    .ADB5(ADDRB[1]), 
						    .ADB6(ADDRB[2]), 
						    .ADB7(ADDRB[3]), 
						    .ADB8(ADDRB[4]), 
						    .ADB9(ADDRB[5]), 
						    .ADB10(ADDRB[6]), 
						    .ADB11(ADDRB[7]), 
						    .ADB12(ADDRB[8]), 
						    .ADB13(scuba_vlo), 
						    .CEB(ENB), 
						    .CLKB(CLKB), 
						    .OCEB(ENB), 
						    .WEB(WEB), 
						    .CSB0(scuba_vlo), 
						    .CSB1(scuba_vlo), 
						    .CSB2(scuba_vlo), 
						    .RSTB(scuba_vlo), 
						    .DOA0(DOA_internal[0]), 
						    .DOA1(DOA_internal[1]), 
						    .DOA2(DOA_internal[2]), 
						    .DOA3(DOA_internal[3]), 
						    .DOA4(DOA_internal[4]), 
						    .DOA5(DOA_internal[5]), 
						    .DOA6(DOA_internal[6]), 
						    .DOA7(DOA_internal[7]), 
						    .DOA8(DOA_internal[8]), 
						    .DOA9(DOA_internal[9]), 
						    .DOA10(DOA_internal[10]), 
						    .DOA11(DOA_internal[11]), 
						    .DOA12(DOA_internal[12]), 
						    .DOA13(DOA_internal[13]), 
						    .DOA14(DOA_internal[14]), 
						    .DOA15(DOA_internal[15]), 
						    .DOA16(DOA_internal[16]), 
						    .DOA17(DOA_internal[17]), 
						    .DOB0(DOB_internal[0]), 
						    .DOB1(DOB_internal[1]), 
						    .DOB2(DOB_internal[2]), 
						    .DOB3(DOB_internal[3]), 
						    .DOB4(DOB_internal[4]), 
						    .DOB5(DOB_internal[5]), 
						    .DOB6(DOB_internal[6]), 
						    .DOB7(DOB_internal[7]),
						    .DOB8(DOB_internal[8]), 
						    .DOB9(DOB_internal[9]), 
						    .DOB10(DOB_internal[10]), 
						    .DOB11(DOB_internal[11]), 
						    .DOB12(DOB_internal[12]), 
						    .DOB13(DOB_internal[13]), 
						    .DOB14(DOB_internal[14]), 
						    .DOB15(DOB_internal[15]), 
						    .DOB16(DOB_internal[16]), 
						    .DOB17(DOB_internal[17]));



			defparam ram_36_inst_highbits.INITVAL_1F = INITVAL_1F_highbits ;
			defparam ram_36_inst_highbits.INITVAL_1E = INITVAL_1E_highbits ;
			defparam ram_36_inst_highbits.INITVAL_1D = INITVAL_1D_highbits ;
			defparam ram_36_inst_highbits.INITVAL_1C = INITVAL_1C_highbits ;
			defparam ram_36_inst_highbits.INITVAL_1B = INITVAL_1B_highbits ;
			defparam ram_36_inst_highbits.INITVAL_1A = INITVAL_1A_highbits ;
			defparam ram_36_inst_highbits.INITVAL_19 = INITVAL_19_highbits ;
			defparam ram_36_inst_highbits.INITVAL_18 = INITVAL_18_highbits ;
			defparam ram_36_inst_highbits.INITVAL_17 = INITVAL_17_highbits ;
			defparam ram_36_inst_highbits.INITVAL_16 = INITVAL_16_highbits ;
			defparam ram_36_inst_highbits.INITVAL_15 = INITVAL_15_highbits ;
			defparam ram_36_inst_highbits.INITVAL_14 = INITVAL_14_highbits ;
			defparam ram_36_inst_highbits.INITVAL_13 = INITVAL_13_highbits ;
			defparam ram_36_inst_highbits.INITVAL_12 = INITVAL_12_highbits ;
			defparam ram_36_inst_highbits.INITVAL_11 = INITVAL_11_highbits ;
			defparam ram_36_inst_highbits.INITVAL_10 = INITVAL_10_highbits ;
			defparam ram_36_inst_highbits.INITVAL_0F = INITVAL_0F_highbits ;
			defparam ram_36_inst_highbits.INITVAL_0E = INITVAL_0E_highbits ;
			defparam ram_36_inst_highbits.INITVAL_0D = INITVAL_0D_highbits ;
			defparam ram_36_inst_highbits.INITVAL_0C = INITVAL_0C_highbits ;
			defparam ram_36_inst_highbits.INITVAL_0B = INITVAL_0B_highbits ;
			defparam ram_36_inst_highbits.INITVAL_0A = INITVAL_0A_highbits ;
			defparam ram_36_inst_highbits.INITVAL_09 = INITVAL_09_highbits ;
			defparam ram_36_inst_highbits.INITVAL_08 = INITVAL_08_highbits ;
			defparam ram_36_inst_highbits.INITVAL_07 = INITVAL_07_highbits ;
			defparam ram_36_inst_highbits.INITVAL_06 = INITVAL_06_highbits ;
			defparam ram_36_inst_highbits.INITVAL_05 = INITVAL_05_highbits ;
			defparam ram_36_inst_highbits.INITVAL_04 = INITVAL_04_highbits ;
			defparam ram_36_inst_highbits.INITVAL_03 = INITVAL_03_highbits ;
			defparam ram_36_inst_highbits.INITVAL_02 = INITVAL_02_highbits ;
			defparam ram_36_inst_highbits.INITVAL_01 = INITVAL_01_highbits ;
			defparam ram_36_inst_highbits.INITVAL_00 = INITVAL_00_highbits ;
			defparam ram_36_inst_highbits.CSDECODE_A = "0b000" ;
			defparam ram_36_inst_highbits.CSDECODE_B = "0b000" ;
			defparam ram_36_inst_highbits.WRITEMODE_A = "WRITETHROUGH" ;
			defparam ram_36_inst_highbits.WRITEMODE_B = "READBEFOREWRITE" ;
			defparam ram_36_inst_highbits.GSR = "DISABLED" ;
 			defparam ram_36_inst_highbits.REGMODE_A = "NOREG" ;
			defparam ram_36_inst_highbits.REGMODE_B = "NOREG" ;
			defparam ram_36_inst_highbits.DATA_WIDTH_A = 18 ;
			defparam ram_36_inst_highbits.DATA_WIDTH_B = 18 ;
			DP16KC ram_36_inst_highbits (
						    .DIA0(DIA[18]), 
						    .DIA1(DIA[19]), 
						    .DIA2(DIA[20]), 
						    .DIA3(DIA[21]), 
						    .DIA4(DIA[22]), 
						    .DIA5(DIA[23]), 
						    .DIA6(DIA[24]), 
						    .DIA7(DIA[25]), 
						    .DIA8(DIA[26]), 
						    .DIA9(DIA[27]), 
						    .DIA10(DIA[28]), 
						    .DIA11(DIA[29]), 
						    .DIA12(DIA[30]), 
						    .DIA13(DIA[31]), 
						    .DIA14(DIA[32]), 
						    .DIA15(DIA[33]), 
						    .DIA16(DIA[34]), 
						    .DIA17(DIA[35]), 
						    .ADA0(scuba_vhi), 
						    .ADA1(scuba_vhi), 
						    .ADA2(scuba_vlo), 
						    .ADA3(scuba_vlo), 
						    .ADA4(ADDRA[0]), 
						    .ADA5(ADDRA[1]), 
						    .ADA6(ADDRA[2]), 
						    .ADA7(ADDRA[3]), 
						    .ADA8(ADDRA[4]), 
						    .ADA9(ADDRA[5]), 
						    .ADA10(ADDRA[6]), 
						    .ADA11(ADDRA[7]), 
						    .ADA12(ADDRA[8]), 
						    .ADA13(scuba_vlo), 
						    .CEA(ENA), 
						    .CLKA(CLKA), 
						    .OCEA(ENA), 
						    .WEA(WEA), 
						    .CSA0(scuba_vlo), 
						    .CSA1(scuba_vlo), 
						    .CSA2(scuba_vlo), 
						    .RSTA(scuba_vlo), 
						    .DIB0(DIB[18]), 
						    .DIB1(DIB[19]), 
						    .DIB2(DIB[20]), 
						    .DIB3(DIB[21]), 
						    .DIB4(DIB[22]), 
						    .DIB5(DIB[23]), 
						    .DIB6(DIB[24]), 
						    .DIB7(DIB[25]), 
						    .DIB8(DIB[26]), 
						    .DIB9(DIB[27]), 
						    .DIB10(DIB[28]), 
						    .DIB11(DIB[29]), 
						    .DIB12(DIB[30]), 
						    .DIB13(DIB[31]), 
						    .DIB14(DIB[32]), 
						    .DIB15(DIB[33]), 
						    .DIB16(DIB[34]), 
						    .DIB17(DIB[35]), 
						    .ADB0(scuba_vhi), 
						    .ADB1(scuba_vhi), 
						    .ADB2(scuba_vlo), 
						    .ADB3(scuba_vlo), 
						    .ADB4(ADDRB[0]), 
						    .ADB5(ADDRB[1]), 
						    .ADB6(ADDRB[2]), 
						    .ADB7(ADDRB[3]), 
						    .ADB8(ADDRB[4]), 
						    .ADB9(ADDRB[5]), 
						    .ADB10(ADDRB[6]), 
						    .ADB11(ADDRB[7]), 
						    .ADB12(ADDRB[8]), 
						    .ADB13(scuba_vlo), 
						    .CEB(ENB), 
						    .CLKB(CLKB), 
						    .OCEB(ENB), 
						    .WEB(WEB), 
						    .CSB0(scuba_vlo), 
						    .CSB1(scuba_vlo), 
						    .CSB2(scuba_vlo), 
						    .RSTB(scuba_vlo), 
						    .DOA0(DOA_internal[18]), 
						    .DOA1(DOA_internal[19]), 
						    .DOA2(DOA_internal[20]), 
						    .DOA3(DOA_internal[21]), 
						    .DOA4(DOA_internal[22]), 
						    .DOA5(DOA_internal[23]), 
						    .DOA6(DOA_internal[24]), 
						    .DOA7(DOA_internal[25]), 
						    .DOA8(DOA_internal[26]), 
						    .DOA9(DOA_internal[27]), 
						    .DOA10(DOA_internal[28]), 
						    .DOA11(DOA_internal[29]), 
						    .DOA12(DOA_internal[30]), 
						    .DOA13(DOA_internal[31]), 
						    .DOA14(DOA_internal[32]), 
						    .DOA15(DOA_internal[33]), 
						    .DOA16(DOA_internal[34]), 
						    .DOA17(DOA_internal[35]), 
						    .DOB0(DOB_internal[18]), 
						    .DOB1(DOB_internal[19]), 
						    .DOB2(DOB_internal[20]), 
						    .DOB3(DOB_internal[21]), 
						    .DOB4(DOB_internal[22]), 
						    .DOB5(DOB_internal[23]), 
						    .DOB6(DOB_internal[24]), 
						    .DOB7(DOB_internal[25]), 
						    .DOB8(DOB_internal[26]), 
						    .DOB9(DOB_internal[27]), 
						    .DOB10(DOB_internal[28]), 
						    .DOB11(DOB_internal[29]), 
						    .DOB12(DOB_internal[30]), 
						    .DOB13(DOB_internal[31]), 
						    .DOB14(DOB_internal[32]), 
						    .DOB15(DOB_internal[33]), 
						    .DOB16(DOB_internal[34]), 
						    .DOB17(DOB_internal[35]));

		end
		else if (WRITE_MODE_B == "NO_CHANGE")
		begin
		
			ssr_logic #(
            .WIDTH  (      36      ),
            .SRVAL  ( SRVAL_A      )
            ) ssr_logic_inst_a (
            .CLK    ( CLKA         ),
            .DO_in  ( DOA_internal ),
            .DO_out ( DOA          ),
            .EN     ( ENA          ),
            .SSR    ( SSRA         )
            );   
            
            nochange_ssr_logic #(
            .WIDTH  (      36      ),
            .SRVAL  ( SRVAL_B      )
            ) nochange_ssr_logic_inst_b (
            .CLK    ( CLKB         ),
            .DO_in  ( DOB_internal ),
            .DO_out ( DOB          ),
            .EN     ( ENB          ),
            .WE     ( WEB          ),
            .SSR    ( SSRB         )
            );    
			


			defparam ram_36_inst_lowbits.INITVAL_1F = INITVAL_1F_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_1E = INITVAL_1E_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_1D = INITVAL_1D_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_1C = INITVAL_1C_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_1B = INITVAL_1B_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_1A = INITVAL_1A_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_19 = INITVAL_19_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_18 = INITVAL_18_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_17 = INITVAL_17_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_16 = INITVAL_16_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_15 = INITVAL_15_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_14 = INITVAL_14_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_13 = INITVAL_13_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_12 = INITVAL_12_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_11 = INITVAL_11_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_10 = INITVAL_10_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_0F = INITVAL_0F_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_0E = INITVAL_0E_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_0D = INITVAL_0D_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_0C = INITVAL_0C_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_0B = INITVAL_0B_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_0A = INITVAL_0A_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_09 = INITVAL_09_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_08 = INITVAL_08_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_07 = INITVAL_07_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_06 = INITVAL_06_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_05 = INITVAL_05_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_04 = INITVAL_04_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_03 = INITVAL_03_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_02 = INITVAL_02_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_01 = INITVAL_01_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_00 = INITVAL_00_lowbits ;
			defparam ram_36_inst_lowbits.CSDECODE_A = "0b000" ;
			defparam ram_36_inst_lowbits.CSDECODE_B = "0b000" ;
			defparam ram_36_inst_lowbits.WRITEMODE_A = "WRITETHROUGH" ;
			defparam ram_36_inst_lowbits.WRITEMODE_B = "WRITETHROUGH" ;
			defparam ram_36_inst_lowbits.GSR = "DISABLED" ;
 			defparam ram_36_inst_lowbits.REGMODE_A = "NOREG" ;
			defparam ram_36_inst_lowbits.REGMODE_B = "NOREG" ;
			defparam ram_36_inst_lowbits.DATA_WIDTH_A = 18 ;
			defparam ram_36_inst_lowbits.DATA_WIDTH_B = 18 ;
			DP16KC ram_36_inst_lowbits (
						    .DIA0(DIA[0]), 
						    .DIA1(DIA[1]), 
						    .DIA2(DIA[2]), 
						    .DIA3(DIA[3]), 
						    .DIA4(DIA[4]), 
						    .DIA5(DIA[5]), 
						    .DIA6(DIA[6]), 
						    .DIA7(DIA[7]), 
						    .DIA8(DIA[8]), 
						    .DIA9(DIA[9]), 
						    .DIA10(DIA[10]), 
						    .DIA11(DIA[11]), 
						    .DIA12(DIA[12]), 
						    .DIA13(DIA[13]), 
						    .DIA14(DIA[14]), 
						    .DIA15(DIA[15]), 
						    .DIA16(DIA[16]), 
						    .DIA17(DIA[17]), 
						    .ADA0(scuba_vhi), 
						    .ADA1(scuba_vhi), 
						    .ADA2(scuba_vlo), 
						    .ADA3(scuba_vlo), 
						    .ADA4(ADDRA[0]), 
						    .ADA5(ADDRA[1]), 
						    .ADA6(ADDRA[2]), 
						    .ADA7(ADDRA[3]), 
						    .ADA8(ADDRA[4]), 
						    .ADA9(ADDRA[5]), 
						    .ADA10(ADDRA[6]), 
						    .ADA11(ADDRA[7]), 
						    .ADA12(ADDRA[8]), 
						    .ADA13(scuba_vlo), 
						    .CEA(ENA), 
						    .CLKA(CLKA), 
						    .OCEA(ENA), 
						    .WEA(WEA), 
						    .CSA0(scuba_vlo), 
						    .CSA1(scuba_vlo), 
						    .CSA2(scuba_vlo), 
						    .RSTA(scuba_vlo), 
						    .DIB0(DIB[0]), 
						    .DIB1(DIB[1]), 
						    .DIB2(DIB[2]), 
						    .DIB3(DIB[3]), 
						    .DIB4(DIB[4]), 
						    .DIB5(DIB[5]), 
						    .DIB6(DIB[6]), 
						    .DIB7(DIB[7]), 
						    .DIB8(DIB[8]), 
						    .DIB9(DIB[9]), 
						    .DIB10(DIB[10]), 
						    .DIB11(DIB[11]), 
						    .DIB12(DIB[12]), 
						    .DIB13(DIB[13]), 
						    .DIB14(DIB[14]), 
						    .DIB15(DIB[15]), 
						    .DIB16(DIB[16]), 
						    .DIB17(DIB[17]), 
						    .ADB0(scuba_vhi), 
						    .ADB1(scuba_vhi), 
						    .ADB2(scuba_vlo), 
						    .ADB3(scuba_vlo), 
						    .ADB4(ADDRB[0]), 
						    .ADB5(ADDRB[1]), 
						    .ADB6(ADDRB[2]), 
						    .ADB7(ADDRB[3]), 
						    .ADB8(ADDRB[4]), 
						    .ADB9(ADDRB[5]), 
						    .ADB10(ADDRB[6]), 
						    .ADB11(ADDRB[7]), 
						    .ADB12(ADDRB[8]), 
						    .ADB13(scuba_vlo), 
						    .CEB(ENB), 
						    .CLKB(CLKB), 
						    .OCEB(ENB), 
						    .WEB(WEB), 
						    .CSB0(scuba_vlo), 
						    .CSB1(scuba_vlo), 
						    .CSB2(scuba_vlo), 
						    .RSTB(scuba_vlo), 
						    .DOA0(DOA_internal[0]), 
						    .DOA1(DOA_internal[1]), 
						    .DOA2(DOA_internal[2]), 
						    .DOA3(DOA_internal[3]), 
						    .DOA4(DOA_internal[4]), 
						    .DOA5(DOA_internal[5]), 
						    .DOA6(DOA_internal[6]), 
						    .DOA7(DOA_internal[7]), 
						    .DOA8(DOA_internal[8]), 
						    .DOA9(DOA_internal[9]), 
						    .DOA10(DOA_internal[10]), 
						    .DOA11(DOA_internal[11]), 
						    .DOA12(DOA_internal[12]), 
						    .DOA13(DOA_internal[13]), 
						    .DOA14(DOA_internal[14]), 
						    .DOA15(DOA_internal[15]), 
						    .DOA16(DOA_internal[16]), 
						    .DOA17(DOA_internal[17]), 
						    .DOB0(DOB_internal[0]), 
						    .DOB1(DOB_internal[1]), 
						    .DOB2(DOB_internal[2]), 
						    .DOB3(DOB_internal[3]), 
						    .DOB4(DOB_internal[4]), 
						    .DOB5(DOB_internal[5]), 
						    .DOB6(DOB_internal[6]), 
						    .DOB7(DOB_internal[7]),
						    .DOB8(DOB_internal[8]), 
						    .DOB9(DOB_internal[9]), 
						    .DOB10(DOB_internal[10]), 
						    .DOB11(DOB_internal[11]), 
						    .DOB12(DOB_internal[12]), 
						    .DOB13(DOB_internal[13]), 
						    .DOB14(DOB_internal[14]), 
						    .DOB15(DOB_internal[15]), 
						    .DOB16(DOB_internal[16]), 
						    .DOB17(DOB_internal[17]));



			defparam ram_36_inst_highbits.INITVAL_1F = INITVAL_1F_highbits ;
			defparam ram_36_inst_highbits.INITVAL_1E = INITVAL_1E_highbits ;
			defparam ram_36_inst_highbits.INITVAL_1D = INITVAL_1D_highbits ;
			defparam ram_36_inst_highbits.INITVAL_1C = INITVAL_1C_highbits ;
			defparam ram_36_inst_highbits.INITVAL_1B = INITVAL_1B_highbits ;
			defparam ram_36_inst_highbits.INITVAL_1A = INITVAL_1A_highbits ;
			defparam ram_36_inst_highbits.INITVAL_19 = INITVAL_19_highbits ;
			defparam ram_36_inst_highbits.INITVAL_18 = INITVAL_18_highbits ;
			defparam ram_36_inst_highbits.INITVAL_17 = INITVAL_17_highbits ;
			defparam ram_36_inst_highbits.INITVAL_16 = INITVAL_16_highbits ;
			defparam ram_36_inst_highbits.INITVAL_15 = INITVAL_15_highbits ;
			defparam ram_36_inst_highbits.INITVAL_14 = INITVAL_14_highbits ;
			defparam ram_36_inst_highbits.INITVAL_13 = INITVAL_13_highbits ;
			defparam ram_36_inst_highbits.INITVAL_12 = INITVAL_12_highbits ;
			defparam ram_36_inst_highbits.INITVAL_11 = INITVAL_11_highbits ;
			defparam ram_36_inst_highbits.INITVAL_10 = INITVAL_10_highbits ;
			defparam ram_36_inst_highbits.INITVAL_0F = INITVAL_0F_highbits ;
			defparam ram_36_inst_highbits.INITVAL_0E = INITVAL_0E_highbits ;
			defparam ram_36_inst_highbits.INITVAL_0D = INITVAL_0D_highbits ;
			defparam ram_36_inst_highbits.INITVAL_0C = INITVAL_0C_highbits ;
			defparam ram_36_inst_highbits.INITVAL_0B = INITVAL_0B_highbits ;
			defparam ram_36_inst_highbits.INITVAL_0A = INITVAL_0A_highbits ;
			defparam ram_36_inst_highbits.INITVAL_09 = INITVAL_09_highbits ;
			defparam ram_36_inst_highbits.INITVAL_08 = INITVAL_08_highbits ;
			defparam ram_36_inst_highbits.INITVAL_07 = INITVAL_07_highbits ;
			defparam ram_36_inst_highbits.INITVAL_06 = INITVAL_06_highbits ;
			defparam ram_36_inst_highbits.INITVAL_05 = INITVAL_05_highbits ;
			defparam ram_36_inst_highbits.INITVAL_04 = INITVAL_04_highbits ;
			defparam ram_36_inst_highbits.INITVAL_03 = INITVAL_03_highbits ;
			defparam ram_36_inst_highbits.INITVAL_02 = INITVAL_02_highbits ;
			defparam ram_36_inst_highbits.INITVAL_01 = INITVAL_01_highbits ;
			defparam ram_36_inst_highbits.INITVAL_00 = INITVAL_00_highbits ;
			defparam ram_36_inst_highbits.CSDECODE_A = "0b000" ;
			defparam ram_36_inst_highbits.CSDECODE_B = "0b000" ;
			defparam ram_36_inst_highbits.WRITEMODE_A = "WRITETHROUGH" ;
			defparam ram_36_inst_highbits.WRITEMODE_B = "WRITETHROUGH" ;
			defparam ram_36_inst_highbits.GSR = "DISABLED" ;
 			defparam ram_36_inst_highbits.REGMODE_A = "NOREG" ;
			defparam ram_36_inst_highbits.REGMODE_B = "NOREG" ;
			defparam ram_36_inst_highbits.DATA_WIDTH_A = 18 ;
			defparam ram_36_inst_highbits.DATA_WIDTH_B = 18 ;
			DP16KC ram_36_inst_highbits (
						    .DIA0(DIA[18]), 
						    .DIA1(DIA[19]), 
						    .DIA2(DIA[20]), 
						    .DIA3(DIA[21]), 
						    .DIA4(DIA[22]), 
						    .DIA5(DIA[23]), 
						    .DIA6(DIA[24]), 
						    .DIA7(DIA[25]), 
						    .DIA8(DIA[26]), 
						    .DIA9(DIA[27]), 
						    .DIA10(DIA[28]), 
						    .DIA11(DIA[29]), 
						    .DIA12(DIA[30]), 
						    .DIA13(DIA[31]), 
						    .DIA14(DIA[32]), 
						    .DIA15(DIA[33]), 
						    .DIA16(DIA[34]), 
						    .DIA17(DIA[35]), 
						    .ADA0(scuba_vhi), 
						    .ADA1(scuba_vhi), 
						    .ADA2(scuba_vlo), 
						    .ADA3(scuba_vlo), 
						    .ADA4(ADDRA[0]), 
						    .ADA5(ADDRA[1]), 
						    .ADA6(ADDRA[2]), 
						    .ADA7(ADDRA[3]), 
						    .ADA8(ADDRA[4]), 
						    .ADA9(ADDRA[5]), 
						    .ADA10(ADDRA[6]), 
						    .ADA11(ADDRA[7]), 
						    .ADA12(ADDRA[8]), 
						    .ADA13(scuba_vlo), 
						    .CEA(ENA), 
						    .CLKA(CLKA), 
						    .OCEA(ENA), 
						    .WEA(WEA), 
						    .CSA0(scuba_vlo), 
						    .CSA1(scuba_vlo), 
						    .CSA2(scuba_vlo), 
						    .RSTA(scuba_vlo), 
						    .DIB0(DIB[18]), 
						    .DIB1(DIB[19]), 
						    .DIB2(DIB[20]), 
						    .DIB3(DIB[21]), 
						    .DIB4(DIB[22]), 
						    .DIB5(DIB[23]), 
						    .DIB6(DIB[24]), 
						    .DIB7(DIB[25]), 
						    .DIB8(DIB[26]), 
						    .DIB9(DIB[27]), 
						    .DIB10(DIB[28]), 
						    .DIB11(DIB[29]), 
						    .DIB12(DIB[30]), 
						    .DIB13(DIB[31]), 
						    .DIB14(DIB[32]), 
						    .DIB15(DIB[33]), 
						    .DIB16(DIB[34]), 
						    .DIB17(DIB[35]), 
						    .ADB0(scuba_vhi), 
						    .ADB1(scuba_vhi), 
						    .ADB2(scuba_vlo), 
						    .ADB3(scuba_vlo), 
						    .ADB4(ADDRB[0]), 
						    .ADB5(ADDRB[1]), 
						    .ADB6(ADDRB[2]), 
						    .ADB7(ADDRB[3]), 
						    .ADB8(ADDRB[4]), 
						    .ADB9(ADDRB[5]), 
						    .ADB10(ADDRB[6]), 
						    .ADB11(ADDRB[7]), 
						    .ADB12(ADDRB[8]), 
						    .ADB13(scuba_vlo), 
						    .CEB(ENB), 
						    .CLKB(CLKB), 
						    .OCEB(ENB), 
						    .WEB(WEB), 
						    .CSB0(scuba_vlo), 
						    .CSB1(scuba_vlo), 
						    .CSB2(scuba_vlo), 
						    .RSTB(scuba_vlo), 
						    .DOA0(DOA_internal[18]), 
						    .DOA1(DOA_internal[19]), 
						    .DOA2(DOA_internal[20]), 
						    .DOA3(DOA_internal[21]), 
						    .DOA4(DOA_internal[22]), 
						    .DOA5(DOA_internal[23]), 
						    .DOA6(DOA_internal[24]), 
						    .DOA7(DOA_internal[25]), 
						    .DOA8(DOA_internal[26]), 
						    .DOA9(DOA_internal[27]), 
						    .DOA10(DOA_internal[28]), 
						    .DOA11(DOA_internal[29]), 
						    .DOA12(DOA_internal[30]), 
						    .DOA13(DOA_internal[31]), 
						    .DOA14(DOA_internal[32]), 
						    .DOA15(DOA_internal[33]), 
						    .DOA16(DOA_internal[34]), 
						    .DOA17(DOA_internal[35]), 
						    .DOB0(DOB_internal[18]), 
						    .DOB1(DOB_internal[19]), 
						    .DOB2(DOB_internal[20]), 
						    .DOB3(DOB_internal[21]), 
						    .DOB4(DOB_internal[22]), 
						    .DOB5(DOB_internal[23]), 
						    .DOB6(DOB_internal[24]), 
						    .DOB7(DOB_internal[25]), 
						    .DOB8(DOB_internal[26]), 
						    .DOB9(DOB_internal[27]), 
						    .DOB10(DOB_internal[28]), 
						    .DOB11(DOB_internal[29]), 
						    .DOB12(DOB_internal[30]), 
						    .DOB13(DOB_internal[31]), 
						    .DOB14(DOB_internal[32]), 
						    .DOB15(DOB_internal[33]), 
						    .DOB16(DOB_internal[34]), 
						    .DOB17(DOB_internal[35]));

		end
		else
		begin
		
            ssr_logic #(
            .WIDTH  (      36      ),
            .SRVAL  ( SRVAL_A      )
            ) ssr_logic_inst_a (
            .CLK    ( CLKA         ),
            .DO_in  ( DOA_internal ),
            .DO_out ( DOA          ),
            .EN     ( ENA          ),
            .SSR    ( SSRA         )
            );   
            
            ssr_logic #(
            .WIDTH  (      36      ),
            .SRVAL  ( SRVAL_B      )
            ) ssr_logic_inst_b (
            .CLK    ( CLKB         ),
            .DO_in  ( DOB_internal ),
            .DO_out ( DOB          ),
            .EN     ( ENB          ),
            .SSR    ( SSRB         )
            );   
		


			defparam ram_36_inst_lowbits.INITVAL_1F = INITVAL_1F_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_1E = INITVAL_1E_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_1D = INITVAL_1D_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_1C = INITVAL_1C_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_1B = INITVAL_1B_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_1A = INITVAL_1A_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_19 = INITVAL_19_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_18 = INITVAL_18_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_17 = INITVAL_17_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_16 = INITVAL_16_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_15 = INITVAL_15_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_14 = INITVAL_14_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_13 = INITVAL_13_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_12 = INITVAL_12_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_11 = INITVAL_11_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_10 = INITVAL_10_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_0F = INITVAL_0F_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_0E = INITVAL_0E_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_0D = INITVAL_0D_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_0C = INITVAL_0C_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_0B = INITVAL_0B_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_0A = INITVAL_0A_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_09 = INITVAL_09_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_08 = INITVAL_08_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_07 = INITVAL_07_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_06 = INITVAL_06_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_05 = INITVAL_05_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_04 = INITVAL_04_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_03 = INITVAL_03_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_02 = INITVAL_02_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_01 = INITVAL_01_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_00 = INITVAL_00_lowbits ;
			defparam ram_36_inst_lowbits.CSDECODE_A = "0b000" ;
			defparam ram_36_inst_lowbits.CSDECODE_B = "0b000" ;
			defparam ram_36_inst_lowbits.WRITEMODE_A = "WRITETHROUGH" ;
			defparam ram_36_inst_lowbits.WRITEMODE_B = "WRITETHROUGH" ;
			defparam ram_36_inst_lowbits.GSR = "DISABLED" ;
 			defparam ram_36_inst_lowbits.REGMODE_A = "NOREG" ;
			defparam ram_36_inst_lowbits.REGMODE_B = "NOREG" ;
			defparam ram_36_inst_lowbits.DATA_WIDTH_A = 18 ;
			defparam ram_36_inst_lowbits.DATA_WIDTH_B = 18 ;
			DP16KC ram_36_inst_lowbits (
						    .DIA0(DIA[0]), 
						    .DIA1(DIA[1]), 
						    .DIA2(DIA[2]), 
						    .DIA3(DIA[3]), 
						    .DIA4(DIA[4]), 
						    .DIA5(DIA[5]), 
						    .DIA6(DIA[6]), 
						    .DIA7(DIA[7]), 
						    .DIA8(DIA[8]), 
						    .DIA9(DIA[9]), 
						    .DIA10(DIA[10]), 
						    .DIA11(DIA[11]), 
						    .DIA12(DIA[12]), 
						    .DIA13(DIA[13]), 
						    .DIA14(DIA[14]), 
						    .DIA15(DIA[15]), 
						    .DIA16(DIA[16]), 
						    .DIA17(DIA[17]), 
						    .ADA0(scuba_vhi), 
						    .ADA1(scuba_vhi), 
						    .ADA2(scuba_vlo), 
						    .ADA3(scuba_vlo), 
						    .ADA4(ADDRA[0]), 
						    .ADA5(ADDRA[1]), 
						    .ADA6(ADDRA[2]), 
						    .ADA7(ADDRA[3]), 
						    .ADA8(ADDRA[4]), 
						    .ADA9(ADDRA[5]), 
						    .ADA10(ADDRA[6]), 
						    .ADA11(ADDRA[7]), 
						    .ADA12(ADDRA[8]), 
						    .ADA13(scuba_vlo), 
						    .CEA(ENA), 
						    .CLKA(CLKA), 
						    .OCEA(ENA), 
						    .WEA(WEA), 
						    .CSA0(scuba_vlo), 
						    .CSA1(scuba_vlo), 
						    .CSA2(scuba_vlo), 
						    .RSTA(scuba_vlo), 
						    .DIB0(DIB[0]), 
						    .DIB1(DIB[1]), 
						    .DIB2(DIB[2]), 
						    .DIB3(DIB[3]), 
						    .DIB4(DIB[4]), 
						    .DIB5(DIB[5]), 
						    .DIB6(DIB[6]), 
						    .DIB7(DIB[7]), 
						    .DIB8(DIB[8]), 
						    .DIB9(DIB[9]), 
						    .DIB10(DIB[10]), 
						    .DIB11(DIB[11]), 
						    .DIB12(DIB[12]), 
						    .DIB13(DIB[13]), 
						    .DIB14(DIB[14]), 
						    .DIB15(DIB[15]), 
						    .DIB16(DIB[16]), 
						    .DIB17(DIB[17]), 
						    .ADB0(scuba_vhi), 
						    .ADB1(scuba_vhi), 
						    .ADB2(scuba_vlo), 
						    .ADB3(scuba_vlo), 
						    .ADB4(ADDRB[0]), 
						    .ADB5(ADDRB[1]), 
						    .ADB6(ADDRB[2]), 
						    .ADB7(ADDRB[3]), 
						    .ADB8(ADDRB[4]), 
						    .ADB9(ADDRB[5]), 
						    .ADB10(ADDRB[6]), 
						    .ADB11(ADDRB[7]), 
						    .ADB12(ADDRB[8]), 
						    .ADB13(scuba_vlo), 
						    .CEB(ENB), 
						    .CLKB(CLKB), 
						    .OCEB(ENB), 
						    .WEB(WEB), 
						    .CSB0(scuba_vlo), 
						    .CSB1(scuba_vlo), 
						    .CSB2(scuba_vlo), 
						    .RSTB(scuba_vlo), 
						    .DOA0(DOA_internal[0]), 
						    .DOA1(DOA_internal[1]), 
						    .DOA2(DOA_internal[2]), 
						    .DOA3(DOA_internal[3]), 
						    .DOA4(DOA_internal[4]), 
						    .DOA5(DOA_internal[5]), 
						    .DOA6(DOA_internal[6]), 
						    .DOA7(DOA_internal[7]), 
						    .DOA8(DOA_internal[8]), 
						    .DOA9(DOA_internal[9]), 
						    .DOA10(DOA_internal[10]), 
						    .DOA11(DOA_internal[11]), 
						    .DOA12(DOA_internal[12]), 
						    .DOA13(DOA_internal[13]), 
						    .DOA14(DOA_internal[14]), 
						    .DOA15(DOA_internal[15]), 
						    .DOA16(DOA_internal[16]), 
						    .DOA17(DOA_internal[17]), 
						    .DOB0(DOB_internal[0]), 
						    .DOB1(DOB_internal[1]), 
						    .DOB2(DOB_internal[2]), 
						    .DOB3(DOB_internal[3]), 
						    .DOB4(DOB_internal[4]), 
						    .DOB5(DOB_internal[5]), 
						    .DOB6(DOB_internal[6]), 
						    .DOB7(DOB_internal[7]),
						    .DOB8(DOB_internal[8]), 
						    .DOB9(DOB_internal[9]), 
						    .DOB10(DOB_internal[10]), 
						    .DOB11(DOB_internal[11]), 
						    .DOB12(DOB_internal[12]), 
						    .DOB13(DOB_internal[13]), 
						    .DOB14(DOB_internal[14]), 
						    .DOB15(DOB_internal[15]), 
						    .DOB16(DOB_internal[16]), 
						    .DOB17(DOB_internal[17]));



			defparam ram_36_inst_highbits.INITVAL_1F = INITVAL_1F_highbits ;
			defparam ram_36_inst_highbits.INITVAL_1E = INITVAL_1E_highbits ;
			defparam ram_36_inst_highbits.INITVAL_1D = INITVAL_1D_highbits ;
			defparam ram_36_inst_highbits.INITVAL_1C = INITVAL_1C_highbits ;
			defparam ram_36_inst_highbits.INITVAL_1B = INITVAL_1B_highbits ;
			defparam ram_36_inst_highbits.INITVAL_1A = INITVAL_1A_highbits ;
			defparam ram_36_inst_highbits.INITVAL_19 = INITVAL_19_highbits ;
			defparam ram_36_inst_highbits.INITVAL_18 = INITVAL_18_highbits ;
			defparam ram_36_inst_highbits.INITVAL_17 = INITVAL_17_highbits ;
			defparam ram_36_inst_highbits.INITVAL_16 = INITVAL_16_highbits ;
			defparam ram_36_inst_highbits.INITVAL_15 = INITVAL_15_highbits ;
			defparam ram_36_inst_highbits.INITVAL_14 = INITVAL_14_highbits ;
			defparam ram_36_inst_highbits.INITVAL_13 = INITVAL_13_highbits ;
			defparam ram_36_inst_highbits.INITVAL_12 = INITVAL_12_highbits ;
			defparam ram_36_inst_highbits.INITVAL_11 = INITVAL_11_highbits ;
			defparam ram_36_inst_highbits.INITVAL_10 = INITVAL_10_highbits ;
			defparam ram_36_inst_highbits.INITVAL_0F = INITVAL_0F_highbits ;
			defparam ram_36_inst_highbits.INITVAL_0E = INITVAL_0E_highbits ;
			defparam ram_36_inst_highbits.INITVAL_0D = INITVAL_0D_highbits ;
			defparam ram_36_inst_highbits.INITVAL_0C = INITVAL_0C_highbits ;
			defparam ram_36_inst_highbits.INITVAL_0B = INITVAL_0B_highbits ;
			defparam ram_36_inst_highbits.INITVAL_0A = INITVAL_0A_highbits ;
			defparam ram_36_inst_highbits.INITVAL_09 = INITVAL_09_highbits ;
			defparam ram_36_inst_highbits.INITVAL_08 = INITVAL_08_highbits ;
			defparam ram_36_inst_highbits.INITVAL_07 = INITVAL_07_highbits ;
			defparam ram_36_inst_highbits.INITVAL_06 = INITVAL_06_highbits ;
			defparam ram_36_inst_highbits.INITVAL_05 = INITVAL_05_highbits ;
			defparam ram_36_inst_highbits.INITVAL_04 = INITVAL_04_highbits ;
			defparam ram_36_inst_highbits.INITVAL_03 = INITVAL_03_highbits ;
			defparam ram_36_inst_highbits.INITVAL_02 = INITVAL_02_highbits ;
			defparam ram_36_inst_highbits.INITVAL_01 = INITVAL_01_highbits ;
			defparam ram_36_inst_highbits.INITVAL_00 = INITVAL_00_highbits ;
			defparam ram_36_inst_highbits.CSDECODE_A = "0b000" ;
			defparam ram_36_inst_highbits.CSDECODE_B = "0b000" ;
			defparam ram_36_inst_highbits.WRITEMODE_A = "WRITETHROUGH" ;
			defparam ram_36_inst_highbits.WRITEMODE_B = "WRITETHROUGH" ;
			defparam ram_36_inst_highbits.GSR = "DISABLED" ;
 			defparam ram_36_inst_highbits.REGMODE_A = "NOREG" ;
			defparam ram_36_inst_highbits.REGMODE_B = "NOREG" ;
			defparam ram_36_inst_highbits.DATA_WIDTH_A = 18 ;
			defparam ram_36_inst_highbits.DATA_WIDTH_B = 18 ;
			DP16KC ram_36_inst_highbits (
						    .DIA0(DIA[18]), 
						    .DIA1(DIA[19]), 
						    .DIA2(DIA[20]), 
						    .DIA3(DIA[21]), 
						    .DIA4(DIA[22]), 
						    .DIA5(DIA[23]), 
						    .DIA6(DIA[24]), 
						    .DIA7(DIA[25]), 
						    .DIA8(DIA[26]), 
						    .DIA9(DIA[27]), 
						    .DIA10(DIA[28]), 
						    .DIA11(DIA[29]), 
						    .DIA12(DIA[30]), 
						    .DIA13(DIA[31]), 
						    .DIA14(DIA[32]), 
						    .DIA15(DIA[33]), 
						    .DIA16(DIA[34]), 
						    .DIA17(DIA[35]), 
						    .ADA0(scuba_vhi), 
						    .ADA1(scuba_vhi), 
						    .ADA2(scuba_vlo), 
						    .ADA3(scuba_vlo), 
						    .ADA4(ADDRA[0]), 
						    .ADA5(ADDRA[1]), 
						    .ADA6(ADDRA[2]), 
						    .ADA7(ADDRA[3]), 
						    .ADA8(ADDRA[4]), 
						    .ADA9(ADDRA[5]), 
						    .ADA10(ADDRA[6]), 
						    .ADA11(ADDRA[7]), 
						    .ADA12(ADDRA[8]), 
						    .ADA13(scuba_vlo), 
						    .CEA(ENA), 
						    .CLKA(CLKA), 
						    .OCEA(ENA), 
						    .WEA(WEA), 
						    .CSA0(scuba_vlo), 
						    .CSA1(scuba_vlo), 
						    .CSA2(scuba_vlo), 
						    .RSTA(scuba_vlo), 
						    .DIB0(DIB[18]), 
						    .DIB1(DIB[19]), 
						    .DIB2(DIB[20]), 
						    .DIB3(DIB[21]), 
						    .DIB4(DIB[22]), 
						    .DIB5(DIB[23]), 
						    .DIB6(DIB[24]), 
						    .DIB7(DIB[25]), 
						    .DIB8(DIB[26]), 
						    .DIB9(DIB[27]), 
						    .DIB10(DIB[28]), 
						    .DIB11(DIB[29]), 
						    .DIB12(DIB[30]), 
						    .DIB13(DIB[31]), 
						    .DIB14(DIB[32]), 
						    .DIB15(DIB[33]), 
						    .DIB16(DIB[34]), 
						    .DIB17(DIB[35]), 
						    .ADB0(scuba_vhi), 
						    .ADB1(scuba_vhi), 
						    .ADB2(scuba_vlo), 
						    .ADB3(scuba_vlo), 
						    .ADB4(ADDRB[0]), 
						    .ADB5(ADDRB[1]), 
						    .ADB6(ADDRB[2]), 
						    .ADB7(ADDRB[3]), 
						    .ADB8(ADDRB[4]), 
						    .ADB9(ADDRB[5]), 
						    .ADB10(ADDRB[6]), 
						    .ADB11(ADDRB[7]), 
						    .ADB12(ADDRB[8]), 
						    .ADB13(scuba_vlo), 
						    .CEB(ENB), 
						    .CLKB(CLKB), 
						    .OCEB(ENB), 
						    .WEB(WEB), 
						    .CSB0(scuba_vlo), 
						    .CSB1(scuba_vlo), 
						    .CSB2(scuba_vlo), 
						    .RSTB(scuba_vlo), 
						    .DOA0(DOA_internal[18]), 
						    .DOA1(DOA_internal[19]), 
						    .DOA2(DOA_internal[20]), 
						    .DOA3(DOA_internal[21]), 
						    .DOA4(DOA_internal[22]), 
						    .DOA5(DOA_internal[23]), 
						    .DOA6(DOA_internal[24]), 
						    .DOA7(DOA_internal[25]), 
						    .DOA8(DOA_internal[26]), 
						    .DOA9(DOA_internal[27]), 
						    .DOA10(DOA_internal[28]), 
						    .DOA11(DOA_internal[29]), 
						    .DOA12(DOA_internal[30]), 
						    .DOA13(DOA_internal[31]), 
						    .DOA14(DOA_internal[32]), 
						    .DOA15(DOA_internal[33]), 
						    .DOA16(DOA_internal[34]), 
						    .DOA17(DOA_internal[35]), 
						    .DOB0(DOB_internal[18]), 
						    .DOB1(DOB_internal[19]), 
						    .DOB2(DOB_internal[20]), 
						    .DOB3(DOB_internal[21]), 
						    .DOB4(DOB_internal[22]), 
						    .DOB5(DOB_internal[23]), 
						    .DOB6(DOB_internal[24]), 
						    .DOB7(DOB_internal[25]), 
						    .DOB8(DOB_internal[26]), 
						    .DOB9(DOB_internal[27]), 
						    .DOB10(DOB_internal[28]), 
						    .DOB11(DOB_internal[29]), 
						    .DOB12(DOB_internal[30]), 
						    .DOB13(DOB_internal[31]), 
						    .DOB14(DOB_internal[32]), 
						    .DOB15(DOB_internal[33]), 
						    .DOB16(DOB_internal[34]), 
						    .DOB17(DOB_internal[35]));

		end

	end
	
	// end port a = WRITE_FIRST

	// begin port a = READ_FIRST

	else if (WRITE_MODE_A == "READ_FIRST")
	begin
	
		if (WRITE_MODE_B == "WRITE_FIRST")
		begin
		
            ssr_logic #(
            .WIDTH  (      36      ),
            .SRVAL  ( SRVAL_A      )
            ) ssr_logic_inst_a (
            .CLK    ( CLKA         ),
            .DO_in  ( DOA_internal ),
            .DO_out ( DOA          ),
            .EN     ( ENA          ),
            .SSR    ( SSRA         )
            );   
            
            ssr_logic #(
            .WIDTH  (      36      ),
            .SRVAL  ( SRVAL_B      )
            ) ssr_logic_inst_b (
            .CLK    ( CLKB         ),
            .DO_in  ( DOB_internal ),
            .DO_out ( DOB          ),
            .EN     ( ENB          ),
            .SSR    ( SSRB         )
            );  
		


			defparam ram_36_inst_lowbits.INITVAL_1F = INITVAL_1F_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_1E = INITVAL_1E_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_1D = INITVAL_1D_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_1C = INITVAL_1C_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_1B = INITVAL_1B_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_1A = INITVAL_1A_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_19 = INITVAL_19_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_18 = INITVAL_18_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_17 = INITVAL_17_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_16 = INITVAL_16_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_15 = INITVAL_15_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_14 = INITVAL_14_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_13 = INITVAL_13_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_12 = INITVAL_12_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_11 = INITVAL_11_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_10 = INITVAL_10_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_0F = INITVAL_0F_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_0E = INITVAL_0E_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_0D = INITVAL_0D_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_0C = INITVAL_0C_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_0B = INITVAL_0B_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_0A = INITVAL_0A_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_09 = INITVAL_09_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_08 = INITVAL_08_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_07 = INITVAL_07_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_06 = INITVAL_06_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_05 = INITVAL_05_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_04 = INITVAL_04_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_03 = INITVAL_03_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_02 = INITVAL_02_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_01 = INITVAL_01_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_00 = INITVAL_00_lowbits ;
			defparam ram_36_inst_lowbits.CSDECODE_A = "0b000" ;
			defparam ram_36_inst_lowbits.CSDECODE_B = "0b000" ;
			defparam ram_36_inst_lowbits.WRITEMODE_A = "READBEFOREWRITE" ;
			defparam ram_36_inst_lowbits.WRITEMODE_B = "WRITETHROUGH" ;
			defparam ram_36_inst_lowbits.GSR = "DISABLED" ;
 			defparam ram_36_inst_lowbits.REGMODE_A = "NOREG" ;
			defparam ram_36_inst_lowbits.REGMODE_B = "NOREG" ;
			defparam ram_36_inst_lowbits.DATA_WIDTH_A = 18 ;
			defparam ram_36_inst_lowbits.DATA_WIDTH_B = 18 ;
			DP16KC ram_36_inst_lowbits (
						    .DIA0(DIA[0]), 
						    .DIA1(DIA[1]), 
						    .DIA2(DIA[2]), 
						    .DIA3(DIA[3]), 
						    .DIA4(DIA[4]), 
						    .DIA5(DIA[5]), 
						    .DIA6(DIA[6]), 
						    .DIA7(DIA[7]), 
						    .DIA8(DIA[8]), 
						    .DIA9(DIA[9]), 
						    .DIA10(DIA[10]), 
						    .DIA11(DIA[11]), 
						    .DIA12(DIA[12]), 
						    .DIA13(DIA[13]), 
						    .DIA14(DIA[14]), 
						    .DIA15(DIA[15]), 
						    .DIA16(DIA[16]), 
						    .DIA17(DIA[17]), 
						    .ADA0(scuba_vhi), 
						    .ADA1(scuba_vhi), 
						    .ADA2(scuba_vlo), 
						    .ADA3(scuba_vlo), 
						    .ADA4(ADDRA[0]), 
						    .ADA5(ADDRA[1]), 
						    .ADA6(ADDRA[2]), 
						    .ADA7(ADDRA[3]), 
						    .ADA8(ADDRA[4]), 
						    .ADA9(ADDRA[5]), 
						    .ADA10(ADDRA[6]), 
						    .ADA11(ADDRA[7]), 
						    .ADA12(ADDRA[8]), 
						    .ADA13(scuba_vlo), 
						    .CEA(ENA), 
						    .CLKA(CLKA), 
						    .OCEA(ENA), 
						    .WEA(WEA), 
						    .CSA0(scuba_vlo), 
						    .CSA1(scuba_vlo), 
						    .CSA2(scuba_vlo), 
						    .RSTA(scuba_vlo), 
						    .DIB0(DIB[0]), 
						    .DIB1(DIB[1]), 
						    .DIB2(DIB[2]), 
						    .DIB3(DIB[3]), 
						    .DIB4(DIB[4]), 
						    .DIB5(DIB[5]), 
						    .DIB6(DIB[6]), 
						    .DIB7(DIB[7]), 
						    .DIB8(DIB[8]), 
						    .DIB9(DIB[9]), 
						    .DIB10(DIB[10]), 
						    .DIB11(DIB[11]), 
						    .DIB12(DIB[12]), 
						    .DIB13(DIB[13]), 
						    .DIB14(DIB[14]), 
						    .DIB15(DIB[15]), 
						    .DIB16(DIB[16]), 
						    .DIB17(DIB[17]), 
						    .ADB0(scuba_vhi), 
						    .ADB1(scuba_vhi), 
						    .ADB2(scuba_vlo), 
						    .ADB3(scuba_vlo), 
						    .ADB4(ADDRB[0]), 
						    .ADB5(ADDRB[1]), 
						    .ADB6(ADDRB[2]), 
						    .ADB7(ADDRB[3]), 
						    .ADB8(ADDRB[4]), 
						    .ADB9(ADDRB[5]), 
						    .ADB10(ADDRB[6]), 
						    .ADB11(ADDRB[7]), 
						    .ADB12(ADDRB[8]), 
						    .ADB13(scuba_vlo), 
						    .CEB(ENB), 
						    .CLKB(CLKB), 
						    .OCEB(ENB), 
						    .WEB(WEB), 
						    .CSB0(scuba_vlo), 
						    .CSB1(scuba_vlo), 
						    .CSB2(scuba_vlo), 
						    .RSTB(scuba_vlo), 
						    .DOA0(DOA_internal[0]), 
						    .DOA1(DOA_internal[1]), 
						    .DOA2(DOA_internal[2]), 
						    .DOA3(DOA_internal[3]), 
						    .DOA4(DOA_internal[4]), 
						    .DOA5(DOA_internal[5]), 
						    .DOA6(DOA_internal[6]), 
						    .DOA7(DOA_internal[7]), 
						    .DOA8(DOA_internal[8]), 
						    .DOA9(DOA_internal[9]), 
						    .DOA10(DOA_internal[10]), 
						    .DOA11(DOA_internal[11]), 
						    .DOA12(DOA_internal[12]), 
						    .DOA13(DOA_internal[13]), 
						    .DOA14(DOA_internal[14]), 
						    .DOA15(DOA_internal[15]), 
						    .DOA16(DOA_internal[16]), 
						    .DOA17(DOA_internal[17]), 
						    .DOB0(DOB_internal[0]), 
						    .DOB1(DOB_internal[1]), 
						    .DOB2(DOB_internal[2]), 
						    .DOB3(DOB_internal[3]), 
						    .DOB4(DOB_internal[4]), 
						    .DOB5(DOB_internal[5]), 
						    .DOB6(DOB_internal[6]), 
						    .DOB7(DOB_internal[7]),
						    .DOB8(DOB_internal[8]), 
						    .DOB9(DOB_internal[9]), 
						    .DOB10(DOB_internal[10]), 
						    .DOB11(DOB_internal[11]), 
						    .DOB12(DOB_internal[12]), 
						    .DOB13(DOB_internal[13]), 
						    .DOB14(DOB_internal[14]), 
						    .DOB15(DOB_internal[15]), 
						    .DOB16(DOB_internal[16]), 
						    .DOB17(DOB_internal[17]));



			defparam ram_36_inst_highbits.INITVAL_1F = INITVAL_1F_highbits ;
			defparam ram_36_inst_highbits.INITVAL_1E = INITVAL_1E_highbits ;
			defparam ram_36_inst_highbits.INITVAL_1D = INITVAL_1D_highbits ;
			defparam ram_36_inst_highbits.INITVAL_1C = INITVAL_1C_highbits ;
			defparam ram_36_inst_highbits.INITVAL_1B = INITVAL_1B_highbits ;
			defparam ram_36_inst_highbits.INITVAL_1A = INITVAL_1A_highbits ;
			defparam ram_36_inst_highbits.INITVAL_19 = INITVAL_19_highbits ;
			defparam ram_36_inst_highbits.INITVAL_18 = INITVAL_18_highbits ;
			defparam ram_36_inst_highbits.INITVAL_17 = INITVAL_17_highbits ;
			defparam ram_36_inst_highbits.INITVAL_16 = INITVAL_16_highbits ;
			defparam ram_36_inst_highbits.INITVAL_15 = INITVAL_15_highbits ;
			defparam ram_36_inst_highbits.INITVAL_14 = INITVAL_14_highbits ;
			defparam ram_36_inst_highbits.INITVAL_13 = INITVAL_13_highbits ;
			defparam ram_36_inst_highbits.INITVAL_12 = INITVAL_12_highbits ;
			defparam ram_36_inst_highbits.INITVAL_11 = INITVAL_11_highbits ;
			defparam ram_36_inst_highbits.INITVAL_10 = INITVAL_10_highbits ;
			defparam ram_36_inst_highbits.INITVAL_0F = INITVAL_0F_highbits ;
			defparam ram_36_inst_highbits.INITVAL_0E = INITVAL_0E_highbits ;
			defparam ram_36_inst_highbits.INITVAL_0D = INITVAL_0D_highbits ;
			defparam ram_36_inst_highbits.INITVAL_0C = INITVAL_0C_highbits ;
			defparam ram_36_inst_highbits.INITVAL_0B = INITVAL_0B_highbits ;
			defparam ram_36_inst_highbits.INITVAL_0A = INITVAL_0A_highbits ;
			defparam ram_36_inst_highbits.INITVAL_09 = INITVAL_09_highbits ;
			defparam ram_36_inst_highbits.INITVAL_08 = INITVAL_08_highbits ;
			defparam ram_36_inst_highbits.INITVAL_07 = INITVAL_07_highbits ;
			defparam ram_36_inst_highbits.INITVAL_06 = INITVAL_06_highbits ;
			defparam ram_36_inst_highbits.INITVAL_05 = INITVAL_05_highbits ;
			defparam ram_36_inst_highbits.INITVAL_04 = INITVAL_04_highbits ;
			defparam ram_36_inst_highbits.INITVAL_03 = INITVAL_03_highbits ;
			defparam ram_36_inst_highbits.INITVAL_02 = INITVAL_02_highbits ;
			defparam ram_36_inst_highbits.INITVAL_01 = INITVAL_01_highbits ;
			defparam ram_36_inst_highbits.INITVAL_00 = INITVAL_00_highbits ;
			defparam ram_36_inst_highbits.CSDECODE_A = "0b000" ;
			defparam ram_36_inst_highbits.CSDECODE_B = "0b000" ;
			defparam ram_36_inst_highbits.WRITEMODE_A = "READBEFOREWRITE" ;
			defparam ram_36_inst_highbits.WRITEMODE_B = "WRITETHROUGH" ;
			defparam ram_36_inst_highbits.GSR = "DISABLED" ;
 			defparam ram_36_inst_highbits.REGMODE_A = "NOREG" ;
			defparam ram_36_inst_highbits.REGMODE_B = "NOREG" ;
			defparam ram_36_inst_highbits.DATA_WIDTH_A = 18 ;
			defparam ram_36_inst_highbits.DATA_WIDTH_B = 18 ;
			DP16KC ram_36_inst_highbits (
						    .DIA0(DIA[18]), 
						    .DIA1(DIA[19]), 
						    .DIA2(DIA[20]), 
						    .DIA3(DIA[21]), 
						    .DIA4(DIA[22]), 
						    .DIA5(DIA[23]), 
						    .DIA6(DIA[24]), 
						    .DIA7(DIA[25]), 
						    .DIA8(DIA[26]), 
						    .DIA9(DIA[27]), 
						    .DIA10(DIA[28]), 
						    .DIA11(DIA[29]), 
						    .DIA12(DIA[30]), 
						    .DIA13(DIA[31]), 
						    .DIA14(DIA[32]), 
						    .DIA15(DIA[33]), 
						    .DIA16(DIA[34]), 
						    .DIA17(DIA[35]), 
						    .ADA0(scuba_vhi), 
						    .ADA1(scuba_vhi), 
						    .ADA2(scuba_vlo), 
						    .ADA3(scuba_vlo), 
						    .ADA4(ADDRA[0]), 
						    .ADA5(ADDRA[1]), 
						    .ADA6(ADDRA[2]), 
						    .ADA7(ADDRA[3]), 
						    .ADA8(ADDRA[4]), 
						    .ADA9(ADDRA[5]), 
						    .ADA10(ADDRA[6]), 
						    .ADA11(ADDRA[7]), 
						    .ADA12(ADDRA[8]), 
						    .ADA13(scuba_vlo), 
						    .CEA(ENA), 
						    .CLKA(CLKA), 
						    .OCEA(ENA), 
						    .WEA(WEA), 
						    .CSA0(scuba_vlo), 
						    .CSA1(scuba_vlo), 
						    .CSA2(scuba_vlo), 
						    .RSTA(scuba_vlo), 
						    .DIB0(DIB[18]), 
						    .DIB1(DIB[19]), 
						    .DIB2(DIB[20]), 
						    .DIB3(DIB[21]), 
						    .DIB4(DIB[22]), 
						    .DIB5(DIB[23]), 
						    .DIB6(DIB[24]), 
						    .DIB7(DIB[25]), 
						    .DIB8(DIB[26]), 
						    .DIB9(DIB[27]), 
						    .DIB10(DIB[28]), 
						    .DIB11(DIB[29]), 
						    .DIB12(DIB[30]), 
						    .DIB13(DIB[31]), 
						    .DIB14(DIB[32]), 
						    .DIB15(DIB[33]), 
						    .DIB16(DIB[34]), 
						    .DIB17(DIB[35]), 
						    .ADB0(scuba_vhi), 
						    .ADB1(scuba_vhi), 
						    .ADB2(scuba_vlo), 
						    .ADB3(scuba_vlo), 
						    .ADB4(ADDRB[0]), 
						    .ADB5(ADDRB[1]), 
						    .ADB6(ADDRB[2]), 
						    .ADB7(ADDRB[3]), 
						    .ADB8(ADDRB[4]), 
						    .ADB9(ADDRB[5]), 
						    .ADB10(ADDRB[6]), 
						    .ADB11(ADDRB[7]), 
						    .ADB12(ADDRB[8]), 
						    .ADB13(scuba_vlo), 
						    .CEB(ENB), 
						    .CLKB(CLKB), 
						    .OCEB(ENB), 
						    .WEB(WEB), 
						    .CSB0(scuba_vlo), 
						    .CSB1(scuba_vlo), 
						    .CSB2(scuba_vlo), 
						    .RSTB(scuba_vlo), 
						    .DOA0(DOA_internal[18]), 
						    .DOA1(DOA_internal[19]), 
						    .DOA2(DOA_internal[20]), 
						    .DOA3(DOA_internal[21]), 
						    .DOA4(DOA_internal[22]), 
						    .DOA5(DOA_internal[23]), 
						    .DOA6(DOA_internal[24]), 
						    .DOA7(DOA_internal[25]), 
						    .DOA8(DOA_internal[26]), 
						    .DOA9(DOA_internal[27]), 
						    .DOA10(DOA_internal[28]), 
						    .DOA11(DOA_internal[29]), 
						    .DOA12(DOA_internal[30]), 
						    .DOA13(DOA_internal[31]), 
						    .DOA14(DOA_internal[32]), 
						    .DOA15(DOA_internal[33]), 
						    .DOA16(DOA_internal[34]), 
						    .DOA17(DOA_internal[35]), 
						    .DOB0(DOB_internal[18]), 
						    .DOB1(DOB_internal[19]), 
						    .DOB2(DOB_internal[20]), 
						    .DOB3(DOB_internal[21]), 
						    .DOB4(DOB_internal[22]), 
						    .DOB5(DOB_internal[23]), 
						    .DOB6(DOB_internal[24]), 
						    .DOB7(DOB_internal[25]), 
						    .DOB8(DOB_internal[26]), 
						    .DOB9(DOB_internal[27]), 
						    .DOB10(DOB_internal[28]), 
						    .DOB11(DOB_internal[29]), 
						    .DOB12(DOB_internal[30]), 
						    .DOB13(DOB_internal[31]), 
						    .DOB14(DOB_internal[32]), 
						    .DOB15(DOB_internal[33]), 
						    .DOB16(DOB_internal[34]), 
						    .DOB17(DOB_internal[35]));

		end
		else if (WRITE_MODE_B == "READ_FIRST")
		begin
		
            ssr_logic #(
            .WIDTH  (      36      ),
            .SRVAL  ( SRVAL_A      )
            ) ssr_logic_inst_a (
            .CLK    ( CLKA         ),
            .DO_in  ( DOA_internal ),
            .DO_out ( DOA          ),
            .EN     ( ENA          ),
            .SSR    ( SSRA         )
            );   
            
            ssr_logic #(
            .WIDTH  (      36      ),
            .SRVAL  ( SRVAL_B      )
            ) ssr_logic_inst_b (
            .CLK    ( CLKB         ),
            .DO_in  ( DOB_internal ),
            .DO_out ( DOB          ),
            .EN     ( ENB          ),
            .SSR    ( SSRB         )
            ); 
		


			defparam ram_36_inst_lowbits.INITVAL_1F = INITVAL_1F_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_1E = INITVAL_1E_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_1D = INITVAL_1D_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_1C = INITVAL_1C_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_1B = INITVAL_1B_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_1A = INITVAL_1A_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_19 = INITVAL_19_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_18 = INITVAL_18_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_17 = INITVAL_17_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_16 = INITVAL_16_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_15 = INITVAL_15_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_14 = INITVAL_14_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_13 = INITVAL_13_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_12 = INITVAL_12_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_11 = INITVAL_11_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_10 = INITVAL_10_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_0F = INITVAL_0F_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_0E = INITVAL_0E_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_0D = INITVAL_0D_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_0C = INITVAL_0C_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_0B = INITVAL_0B_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_0A = INITVAL_0A_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_09 = INITVAL_09_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_08 = INITVAL_08_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_07 = INITVAL_07_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_06 = INITVAL_06_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_05 = INITVAL_05_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_04 = INITVAL_04_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_03 = INITVAL_03_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_02 = INITVAL_02_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_01 = INITVAL_01_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_00 = INITVAL_00_lowbits ;
			defparam ram_36_inst_lowbits.CSDECODE_A = "0b000" ;
			defparam ram_36_inst_lowbits.CSDECODE_B = "0b000" ;
			defparam ram_36_inst_lowbits.WRITEMODE_A = "READBEFOREWRITE" ;
			defparam ram_36_inst_lowbits.WRITEMODE_B = "READBEFOREWRITE" ;
			defparam ram_36_inst_lowbits.GSR = "DISABLED" ;
 			defparam ram_36_inst_lowbits.REGMODE_A = "NOREG" ;
			defparam ram_36_inst_lowbits.REGMODE_B = "NOREG" ;
			defparam ram_36_inst_lowbits.DATA_WIDTH_A = 18 ;
			defparam ram_36_inst_lowbits.DATA_WIDTH_B = 18 ;
			DP16KC ram_36_inst_lowbits (
						    .DIA0(DIA[0]), 
						    .DIA1(DIA[1]), 
						    .DIA2(DIA[2]), 
						    .DIA3(DIA[3]), 
						    .DIA4(DIA[4]), 
						    .DIA5(DIA[5]), 
						    .DIA6(DIA[6]), 
						    .DIA7(DIA[7]), 
						    .DIA8(DIA[8]), 
						    .DIA9(DIA[9]), 
						    .DIA10(DIA[10]), 
						    .DIA11(DIA[11]), 
						    .DIA12(DIA[12]), 
						    .DIA13(DIA[13]), 
						    .DIA14(DIA[14]), 
						    .DIA15(DIA[15]), 
						    .DIA16(DIA[16]), 
						    .DIA17(DIA[17]), 
						    .ADA0(scuba_vhi), 
						    .ADA1(scuba_vhi), 
						    .ADA2(scuba_vlo), 
						    .ADA3(scuba_vlo), 
						    .ADA4(ADDRA[0]), 
						    .ADA5(ADDRA[1]), 
						    .ADA6(ADDRA[2]), 
						    .ADA7(ADDRA[3]), 
						    .ADA8(ADDRA[4]), 
						    .ADA9(ADDRA[5]), 
						    .ADA10(ADDRA[6]), 
						    .ADA11(ADDRA[7]), 
						    .ADA12(ADDRA[8]), 
						    .ADA13(scuba_vlo), 
						    .CEA(ENA), 
						    .CLKA(CLKA), 
						    .OCEA(ENA), 
						    .WEA(WEA), 
						    .CSA0(scuba_vlo), 
						    .CSA1(scuba_vlo), 
						    .CSA2(scuba_vlo), 
						    .RSTA(scuba_vlo), 
						    .DIB0(DIB[0]), 
						    .DIB1(DIB[1]), 
						    .DIB2(DIB[2]), 
						    .DIB3(DIB[3]), 
						    .DIB4(DIB[4]), 
						    .DIB5(DIB[5]), 
						    .DIB6(DIB[6]), 
						    .DIB7(DIB[7]), 
						    .DIB8(DIB[8]), 
						    .DIB9(DIB[9]), 
						    .DIB10(DIB[10]), 
						    .DIB11(DIB[11]), 
						    .DIB12(DIB[12]), 
						    .DIB13(DIB[13]), 
						    .DIB14(DIB[14]), 
						    .DIB15(DIB[15]), 
						    .DIB16(DIB[16]), 
						    .DIB17(DIB[17]), 
						    .ADB0(scuba_vhi), 
						    .ADB1(scuba_vhi), 
						    .ADB2(scuba_vlo), 
						    .ADB3(scuba_vlo), 
						    .ADB4(ADDRB[0]), 
						    .ADB5(ADDRB[1]), 
						    .ADB6(ADDRB[2]), 
						    .ADB7(ADDRB[3]), 
						    .ADB8(ADDRB[4]), 
						    .ADB9(ADDRB[5]), 
						    .ADB10(ADDRB[6]), 
						    .ADB11(ADDRB[7]), 
						    .ADB12(ADDRB[8]), 
						    .ADB13(scuba_vlo), 
						    .CEB(ENB), 
						    .CLKB(CLKB), 
						    .OCEB(ENB), 
						    .WEB(WEB), 
						    .CSB0(scuba_vlo), 
						    .CSB1(scuba_vlo), 
						    .CSB2(scuba_vlo), 
						    .RSTB(scuba_vlo), 
						    .DOA0(DOA_internal[0]), 
						    .DOA1(DOA_internal[1]), 
						    .DOA2(DOA_internal[2]), 
						    .DOA3(DOA_internal[3]), 
						    .DOA4(DOA_internal[4]), 
						    .DOA5(DOA_internal[5]), 
						    .DOA6(DOA_internal[6]), 
						    .DOA7(DOA_internal[7]), 
						    .DOA8(DOA_internal[8]), 
						    .DOA9(DOA_internal[9]), 
						    .DOA10(DOA_internal[10]), 
						    .DOA11(DOA_internal[11]), 
						    .DOA12(DOA_internal[12]), 
						    .DOA13(DOA_internal[13]), 
						    .DOA14(DOA_internal[14]), 
						    .DOA15(DOA_internal[15]), 
						    .DOA16(DOA_internal[16]), 
						    .DOA17(DOA_internal[17]), 
						    .DOB0(DOB_internal[0]), 
						    .DOB1(DOB_internal[1]), 
						    .DOB2(DOB_internal[2]), 
						    .DOB3(DOB_internal[3]), 
						    .DOB4(DOB_internal[4]), 
						    .DOB5(DOB_internal[5]), 
						    .DOB6(DOB_internal[6]), 
						    .DOB7(DOB_internal[7]),
						    .DOB8(DOB_internal[8]), 
						    .DOB9(DOB_internal[9]), 
						    .DOB10(DOB_internal[10]), 
						    .DOB11(DOB_internal[11]), 
						    .DOB12(DOB_internal[12]), 
						    .DOB13(DOB_internal[13]), 
						    .DOB14(DOB_internal[14]), 
						    .DOB15(DOB_internal[15]), 
						    .DOB16(DOB_internal[16]), 
						    .DOB17(DOB_internal[17]));



			defparam ram_36_inst_highbits.INITVAL_1F = INITVAL_1F_highbits ;
			defparam ram_36_inst_highbits.INITVAL_1E = INITVAL_1E_highbits ;
			defparam ram_36_inst_highbits.INITVAL_1D = INITVAL_1D_highbits ;
			defparam ram_36_inst_highbits.INITVAL_1C = INITVAL_1C_highbits ;
			defparam ram_36_inst_highbits.INITVAL_1B = INITVAL_1B_highbits ;
			defparam ram_36_inst_highbits.INITVAL_1A = INITVAL_1A_highbits ;
			defparam ram_36_inst_highbits.INITVAL_19 = INITVAL_19_highbits ;
			defparam ram_36_inst_highbits.INITVAL_18 = INITVAL_18_highbits ;
			defparam ram_36_inst_highbits.INITVAL_17 = INITVAL_17_highbits ;
			defparam ram_36_inst_highbits.INITVAL_16 = INITVAL_16_highbits ;
			defparam ram_36_inst_highbits.INITVAL_15 = INITVAL_15_highbits ;
			defparam ram_36_inst_highbits.INITVAL_14 = INITVAL_14_highbits ;
			defparam ram_36_inst_highbits.INITVAL_13 = INITVAL_13_highbits ;
			defparam ram_36_inst_highbits.INITVAL_12 = INITVAL_12_highbits ;
			defparam ram_36_inst_highbits.INITVAL_11 = INITVAL_11_highbits ;
			defparam ram_36_inst_highbits.INITVAL_10 = INITVAL_10_highbits ;
			defparam ram_36_inst_highbits.INITVAL_0F = INITVAL_0F_highbits ;
			defparam ram_36_inst_highbits.INITVAL_0E = INITVAL_0E_highbits ;
			defparam ram_36_inst_highbits.INITVAL_0D = INITVAL_0D_highbits ;
			defparam ram_36_inst_highbits.INITVAL_0C = INITVAL_0C_highbits ;
			defparam ram_36_inst_highbits.INITVAL_0B = INITVAL_0B_highbits ;
			defparam ram_36_inst_highbits.INITVAL_0A = INITVAL_0A_highbits ;
			defparam ram_36_inst_highbits.INITVAL_09 = INITVAL_09_highbits ;
			defparam ram_36_inst_highbits.INITVAL_08 = INITVAL_08_highbits ;
			defparam ram_36_inst_highbits.INITVAL_07 = INITVAL_07_highbits ;
			defparam ram_36_inst_highbits.INITVAL_06 = INITVAL_06_highbits ;
			defparam ram_36_inst_highbits.INITVAL_05 = INITVAL_05_highbits ;
			defparam ram_36_inst_highbits.INITVAL_04 = INITVAL_04_highbits ;
			defparam ram_36_inst_highbits.INITVAL_03 = INITVAL_03_highbits ;
			defparam ram_36_inst_highbits.INITVAL_02 = INITVAL_02_highbits ;
			defparam ram_36_inst_highbits.INITVAL_01 = INITVAL_01_highbits ;
			defparam ram_36_inst_highbits.INITVAL_00 = INITVAL_00_highbits ;
			defparam ram_36_inst_highbits.CSDECODE_A = "0b000" ;
			defparam ram_36_inst_highbits.CSDECODE_B = "0b000" ;
			defparam ram_36_inst_highbits.WRITEMODE_A = "READBEFOREWRITE" ;
			defparam ram_36_inst_highbits.WRITEMODE_B = "READBEFOREWRITE" ;
			defparam ram_36_inst_highbits.GSR = "DISABLED" ;
 			defparam ram_36_inst_highbits.REGMODE_A = "NOREG" ;
			defparam ram_36_inst_highbits.REGMODE_B = "NOREG" ;
			defparam ram_36_inst_highbits.DATA_WIDTH_A = 18 ;
			defparam ram_36_inst_highbits.DATA_WIDTH_B = 18 ;
			DP16KC ram_36_inst_highbits (
						    .DIA0(DIA[18]), 
						    .DIA1(DIA[19]), 
						    .DIA2(DIA[20]), 
						    .DIA3(DIA[21]), 
						    .DIA4(DIA[22]), 
						    .DIA5(DIA[23]), 
						    .DIA6(DIA[24]), 
						    .DIA7(DIA[25]), 
						    .DIA8(DIA[26]), 
						    .DIA9(DIA[27]), 
						    .DIA10(DIA[28]), 
						    .DIA11(DIA[29]), 
						    .DIA12(DIA[30]), 
						    .DIA13(DIA[31]), 
						    .DIA14(DIA[32]), 
						    .DIA15(DIA[33]), 
						    .DIA16(DIA[34]), 
						    .DIA17(DIA[35]), 
						    .ADA0(scuba_vhi), 
						    .ADA1(scuba_vhi), 
						    .ADA2(scuba_vlo), 
						    .ADA3(scuba_vlo), 
						    .ADA4(ADDRA[0]), 
						    .ADA5(ADDRA[1]), 
						    .ADA6(ADDRA[2]), 
						    .ADA7(ADDRA[3]), 
						    .ADA8(ADDRA[4]), 
						    .ADA9(ADDRA[5]), 
						    .ADA10(ADDRA[6]), 
						    .ADA11(ADDRA[7]), 
						    .ADA12(ADDRA[8]), 
						    .ADA13(scuba_vlo), 
						    .CEA(ENA), 
						    .CLKA(CLKA), 
						    .OCEA(ENA), 
						    .WEA(WEA), 
						    .CSA0(scuba_vlo), 
						    .CSA1(scuba_vlo), 
						    .CSA2(scuba_vlo), 
						    .RSTA(scuba_vlo), 
						    .DIB0(DIB[18]), 
						    .DIB1(DIB[19]), 
						    .DIB2(DIB[20]), 
						    .DIB3(DIB[21]), 
						    .DIB4(DIB[22]), 
						    .DIB5(DIB[23]), 
						    .DIB6(DIB[24]), 
						    .DIB7(DIB[25]), 
						    .DIB8(DIB[26]), 
						    .DIB9(DIB[27]), 
						    .DIB10(DIB[28]), 
						    .DIB11(DIB[29]), 
						    .DIB12(DIB[30]), 
						    .DIB13(DIB[31]), 
						    .DIB14(DIB[32]), 
						    .DIB15(DIB[33]), 
						    .DIB16(DIB[34]), 
						    .DIB17(DIB[35]), 
						    .ADB0(scuba_vhi), 
						    .ADB1(scuba_vhi), 
						    .ADB2(scuba_vlo), 
						    .ADB3(scuba_vlo), 
						    .ADB4(ADDRB[0]), 
						    .ADB5(ADDRB[1]), 
						    .ADB6(ADDRB[2]), 
						    .ADB7(ADDRB[3]), 
						    .ADB8(ADDRB[4]), 
						    .ADB9(ADDRB[5]), 
						    .ADB10(ADDRB[6]), 
						    .ADB11(ADDRB[7]), 
						    .ADB12(ADDRB[8]), 
						    .ADB13(scuba_vlo), 
						    .CEB(ENB), 
						    .CLKB(CLKB), 
						    .OCEB(ENB), 
						    .WEB(WEB), 
						    .CSB0(scuba_vlo), 
						    .CSB1(scuba_vlo), 
						    .CSB2(scuba_vlo), 
						    .RSTB(scuba_vlo), 
						    .DOA0(DOA_internal[18]), 
						    .DOA1(DOA_internal[19]), 
						    .DOA2(DOA_internal[20]), 
						    .DOA3(DOA_internal[21]), 
						    .DOA4(DOA_internal[22]), 
						    .DOA5(DOA_internal[23]), 
						    .DOA6(DOA_internal[24]), 
						    .DOA7(DOA_internal[25]), 
						    .DOA8(DOA_internal[26]), 
						    .DOA9(DOA_internal[27]), 
						    .DOA10(DOA_internal[28]), 
						    .DOA11(DOA_internal[29]), 
						    .DOA12(DOA_internal[30]), 
						    .DOA13(DOA_internal[31]), 
						    .DOA14(DOA_internal[32]), 
						    .DOA15(DOA_internal[33]), 
						    .DOA16(DOA_internal[34]), 
						    .DOA17(DOA_internal[35]), 
						    .DOB0(DOB_internal[18]), 
						    .DOB1(DOB_internal[19]), 
						    .DOB2(DOB_internal[20]), 
						    .DOB3(DOB_internal[21]), 
						    .DOB4(DOB_internal[22]), 
						    .DOB5(DOB_internal[23]), 
						    .DOB6(DOB_internal[24]), 
						    .DOB7(DOB_internal[25]), 
						    .DOB8(DOB_internal[26]), 
						    .DOB9(DOB_internal[27]), 
						    .DOB10(DOB_internal[28]), 
						    .DOB11(DOB_internal[29]), 
						    .DOB12(DOB_internal[30]), 
						    .DOB13(DOB_internal[31]), 
						    .DOB14(DOB_internal[32]), 
						    .DOB15(DOB_internal[33]), 
						    .DOB16(DOB_internal[34]), 
						    .DOB17(DOB_internal[35]));

		end
		else if (WRITE_MODE_B == "NO_CHANGE")
		begin
		
			ssr_logic #(
            .WIDTH  (      36      ),
            .SRVAL  ( SRVAL_A      )
            ) ssr_logic_inst_a (
            .CLK    ( CLKA         ),
            .DO_in  ( DOA_internal ),
            .DO_out ( DOA          ),
            .EN     ( ENA          ),
            .SSR    ( SSRA         )
            );   
            
            nochange_ssr_logic #(
            .WIDTH  (      36      ),
            .SRVAL  ( SRVAL_B      )
            ) nochange_ssr_logic_inst_b (
            .CLK    ( CLKB         ),
            .DO_in  ( DOB_internal ),
            .DO_out ( DOB          ),
            .EN     ( ENB          ),
            .WE     ( WEB          ),
            .SSR    ( SSRB         )
            ); 
			


			defparam ram_36_inst_lowbits.INITVAL_1F = INITVAL_1F_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_1E = INITVAL_1E_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_1D = INITVAL_1D_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_1C = INITVAL_1C_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_1B = INITVAL_1B_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_1A = INITVAL_1A_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_19 = INITVAL_19_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_18 = INITVAL_18_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_17 = INITVAL_17_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_16 = INITVAL_16_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_15 = INITVAL_15_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_14 = INITVAL_14_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_13 = INITVAL_13_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_12 = INITVAL_12_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_11 = INITVAL_11_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_10 = INITVAL_10_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_0F = INITVAL_0F_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_0E = INITVAL_0E_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_0D = INITVAL_0D_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_0C = INITVAL_0C_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_0B = INITVAL_0B_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_0A = INITVAL_0A_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_09 = INITVAL_09_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_08 = INITVAL_08_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_07 = INITVAL_07_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_06 = INITVAL_06_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_05 = INITVAL_05_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_04 = INITVAL_04_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_03 = INITVAL_03_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_02 = INITVAL_02_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_01 = INITVAL_01_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_00 = INITVAL_00_lowbits ;
			defparam ram_36_inst_lowbits.CSDECODE_A = "0b000" ;
			defparam ram_36_inst_lowbits.CSDECODE_B = "0b000" ;
			defparam ram_36_inst_lowbits.WRITEMODE_A = "READBEFOREWRITE" ;
			defparam ram_36_inst_lowbits.WRITEMODE_B = "WRITETHROUGH" ;
			defparam ram_36_inst_lowbits.GSR = "DISABLED" ;
 			defparam ram_36_inst_lowbits.REGMODE_A = "NOREG" ;
			defparam ram_36_inst_lowbits.REGMODE_B = "NOREG" ;
			defparam ram_36_inst_lowbits.DATA_WIDTH_A = 18 ;
			defparam ram_36_inst_lowbits.DATA_WIDTH_B = 18 ;
			DP16KC ram_36_inst_lowbits (
						    .DIA0(DIA[0]), 
						    .DIA1(DIA[1]), 
						    .DIA2(DIA[2]), 
						    .DIA3(DIA[3]), 
						    .DIA4(DIA[4]), 
						    .DIA5(DIA[5]), 
						    .DIA6(DIA[6]), 
						    .DIA7(DIA[7]), 
						    .DIA8(DIA[8]), 
						    .DIA9(DIA[9]), 
						    .DIA10(DIA[10]), 
						    .DIA11(DIA[11]), 
						    .DIA12(DIA[12]), 
						    .DIA13(DIA[13]), 
						    .DIA14(DIA[14]), 
						    .DIA15(DIA[15]), 
						    .DIA16(DIA[16]), 
						    .DIA17(DIA[17]), 
						    .ADA0(scuba_vhi), 
						    .ADA1(scuba_vhi), 
						    .ADA2(scuba_vlo), 
						    .ADA3(scuba_vlo), 
						    .ADA4(ADDRA[0]), 
						    .ADA5(ADDRA[1]), 
						    .ADA6(ADDRA[2]), 
						    .ADA7(ADDRA[3]), 
						    .ADA8(ADDRA[4]), 
						    .ADA9(ADDRA[5]), 
						    .ADA10(ADDRA[6]), 
						    .ADA11(ADDRA[7]), 
						    .ADA12(ADDRA[8]), 
						    .ADA13(scuba_vlo), 
						    .CEA(ENA), 
						    .CLKA(CLKA), 
						    .OCEA(ENA), 
						    .WEA(WEA), 
						    .CSA0(scuba_vlo), 
						    .CSA1(scuba_vlo), 
						    .CSA2(scuba_vlo), 
						    .RSTA(scuba_vlo), 
						    .DIB0(DIB[0]), 
						    .DIB1(DIB[1]), 
						    .DIB2(DIB[2]), 
						    .DIB3(DIB[3]), 
						    .DIB4(DIB[4]), 
						    .DIB5(DIB[5]), 
						    .DIB6(DIB[6]), 
						    .DIB7(DIB[7]), 
						    .DIB8(DIB[8]), 
						    .DIB9(DIB[9]), 
						    .DIB10(DIB[10]), 
						    .DIB11(DIB[11]), 
						    .DIB12(DIB[12]), 
						    .DIB13(DIB[13]), 
						    .DIB14(DIB[14]), 
						    .DIB15(DIB[15]), 
						    .DIB16(DIB[16]), 
						    .DIB17(DIB[17]), 
						    .ADB0(scuba_vhi), 
						    .ADB1(scuba_vhi), 
						    .ADB2(scuba_vlo), 
						    .ADB3(scuba_vlo), 
						    .ADB4(ADDRB[0]), 
						    .ADB5(ADDRB[1]), 
						    .ADB6(ADDRB[2]), 
						    .ADB7(ADDRB[3]), 
						    .ADB8(ADDRB[4]), 
						    .ADB9(ADDRB[5]), 
						    .ADB10(ADDRB[6]), 
						    .ADB11(ADDRB[7]), 
						    .ADB12(ADDRB[8]), 
						    .ADB13(scuba_vlo), 
						    .CEB(ENB), 
						    .CLKB(CLKB), 
						    .OCEB(ENB), 
						    .WEB(WEB), 
						    .CSB0(scuba_vlo), 
						    .CSB1(scuba_vlo), 
						    .CSB2(scuba_vlo), 
						    .RSTB(scuba_vlo), 
						    .DOA0(DOA_internal[0]), 
						    .DOA1(DOA_internal[1]), 
						    .DOA2(DOA_internal[2]), 
						    .DOA3(DOA_internal[3]), 
						    .DOA4(DOA_internal[4]), 
						    .DOA5(DOA_internal[5]), 
						    .DOA6(DOA_internal[6]), 
						    .DOA7(DOA_internal[7]), 
						    .DOA8(DOA_internal[8]), 
						    .DOA9(DOA_internal[9]), 
						    .DOA10(DOA_internal[10]), 
						    .DOA11(DOA_internal[11]), 
						    .DOA12(DOA_internal[12]), 
						    .DOA13(DOA_internal[13]), 
						    .DOA14(DOA_internal[14]), 
						    .DOA15(DOA_internal[15]), 
						    .DOA16(DOA_internal[16]), 
						    .DOA17(DOA_internal[17]), 
						    .DOB0(DOB_internal[0]), 
						    .DOB1(DOB_internal[1]), 
						    .DOB2(DOB_internal[2]), 
						    .DOB3(DOB_internal[3]), 
						    .DOB4(DOB_internal[4]), 
						    .DOB5(DOB_internal[5]), 
						    .DOB6(DOB_internal[6]), 
						    .DOB7(DOB_internal[7]),
						    .DOB8(DOB_internal[8]), 
						    .DOB9(DOB_internal[9]), 
						    .DOB10(DOB_internal[10]), 
						    .DOB11(DOB_internal[11]), 
						    .DOB12(DOB_internal[12]), 
						    .DOB13(DOB_internal[13]), 
						    .DOB14(DOB_internal[14]), 
						    .DOB15(DOB_internal[15]), 
						    .DOB16(DOB_internal[16]), 
						    .DOB17(DOB_internal[17]));



			defparam ram_36_inst_highbits.INITVAL_1F = INITVAL_1F_highbits ;
			defparam ram_36_inst_highbits.INITVAL_1E = INITVAL_1E_highbits ;
			defparam ram_36_inst_highbits.INITVAL_1D = INITVAL_1D_highbits ;
			defparam ram_36_inst_highbits.INITVAL_1C = INITVAL_1C_highbits ;
			defparam ram_36_inst_highbits.INITVAL_1B = INITVAL_1B_highbits ;
			defparam ram_36_inst_highbits.INITVAL_1A = INITVAL_1A_highbits ;
			defparam ram_36_inst_highbits.INITVAL_19 = INITVAL_19_highbits ;
			defparam ram_36_inst_highbits.INITVAL_18 = INITVAL_18_highbits ;
			defparam ram_36_inst_highbits.INITVAL_17 = INITVAL_17_highbits ;
			defparam ram_36_inst_highbits.INITVAL_16 = INITVAL_16_highbits ;
			defparam ram_36_inst_highbits.INITVAL_15 = INITVAL_15_highbits ;
			defparam ram_36_inst_highbits.INITVAL_14 = INITVAL_14_highbits ;
			defparam ram_36_inst_highbits.INITVAL_13 = INITVAL_13_highbits ;
			defparam ram_36_inst_highbits.INITVAL_12 = INITVAL_12_highbits ;
			defparam ram_36_inst_highbits.INITVAL_11 = INITVAL_11_highbits ;
			defparam ram_36_inst_highbits.INITVAL_10 = INITVAL_10_highbits ;
			defparam ram_36_inst_highbits.INITVAL_0F = INITVAL_0F_highbits ;
			defparam ram_36_inst_highbits.INITVAL_0E = INITVAL_0E_highbits ;
			defparam ram_36_inst_highbits.INITVAL_0D = INITVAL_0D_highbits ;
			defparam ram_36_inst_highbits.INITVAL_0C = INITVAL_0C_highbits ;
			defparam ram_36_inst_highbits.INITVAL_0B = INITVAL_0B_highbits ;
			defparam ram_36_inst_highbits.INITVAL_0A = INITVAL_0A_highbits ;
			defparam ram_36_inst_highbits.INITVAL_09 = INITVAL_09_highbits ;
			defparam ram_36_inst_highbits.INITVAL_08 = INITVAL_08_highbits ;
			defparam ram_36_inst_highbits.INITVAL_07 = INITVAL_07_highbits ;
			defparam ram_36_inst_highbits.INITVAL_06 = INITVAL_06_highbits ;
			defparam ram_36_inst_highbits.INITVAL_05 = INITVAL_05_highbits ;
			defparam ram_36_inst_highbits.INITVAL_04 = INITVAL_04_highbits ;
			defparam ram_36_inst_highbits.INITVAL_03 = INITVAL_03_highbits ;
			defparam ram_36_inst_highbits.INITVAL_02 = INITVAL_02_highbits ;
			defparam ram_36_inst_highbits.INITVAL_01 = INITVAL_01_highbits ;
			defparam ram_36_inst_highbits.INITVAL_00 = INITVAL_00_highbits ;
			defparam ram_36_inst_highbits.CSDECODE_A = "0b000" ;
			defparam ram_36_inst_highbits.CSDECODE_B = "0b000" ;
			defparam ram_36_inst_highbits.WRITEMODE_A = "READBEFOREWRITE" ;
			defparam ram_36_inst_highbits.WRITEMODE_B = "WRITETHROUGH" ;
			defparam ram_36_inst_highbits.GSR = "DISABLED" ;
 			defparam ram_36_inst_highbits.REGMODE_A = "NOREG" ;
			defparam ram_36_inst_highbits.REGMODE_B = "NOREG" ;
			defparam ram_36_inst_highbits.DATA_WIDTH_A = 18 ;
			defparam ram_36_inst_highbits.DATA_WIDTH_B = 18 ;
			DP16KC ram_36_inst_highbits (
						    .DIA0(DIA[18]), 
						    .DIA1(DIA[19]), 
						    .DIA2(DIA[20]), 
						    .DIA3(DIA[21]), 
						    .DIA4(DIA[22]), 
						    .DIA5(DIA[23]), 
						    .DIA6(DIA[24]), 
						    .DIA7(DIA[25]), 
						    .DIA8(DIA[26]), 
						    .DIA9(DIA[27]), 
						    .DIA10(DIA[28]), 
						    .DIA11(DIA[29]), 
						    .DIA12(DIA[30]), 
						    .DIA13(DIA[31]), 
						    .DIA14(DIA[32]), 
						    .DIA15(DIA[33]), 
						    .DIA16(DIA[34]), 
						    .DIA17(DIA[35]), 
						    .ADA0(scuba_vhi), 
						    .ADA1(scuba_vhi), 
						    .ADA2(scuba_vlo), 
						    .ADA3(scuba_vlo), 
						    .ADA4(ADDRA[0]), 
						    .ADA5(ADDRA[1]), 
						    .ADA6(ADDRA[2]), 
						    .ADA7(ADDRA[3]), 
						    .ADA8(ADDRA[4]), 
						    .ADA9(ADDRA[5]), 
						    .ADA10(ADDRA[6]), 
						    .ADA11(ADDRA[7]), 
						    .ADA12(ADDRA[8]), 
						    .ADA13(scuba_vlo), 
						    .CEA(ENA), 
						    .CLKA(CLKA), 
						    .OCEA(ENA), 
						    .WEA(WEA), 
						    .CSA0(scuba_vlo), 
						    .CSA1(scuba_vlo), 
						    .CSA2(scuba_vlo), 
						    .RSTA(scuba_vlo), 
						    .DIB0(DIB[18]), 
						    .DIB1(DIB[19]), 
						    .DIB2(DIB[20]), 
						    .DIB3(DIB[21]), 
						    .DIB4(DIB[22]), 
						    .DIB5(DIB[23]), 
						    .DIB6(DIB[24]), 
						    .DIB7(DIB[25]), 
						    .DIB8(DIB[26]), 
						    .DIB9(DIB[27]), 
						    .DIB10(DIB[28]), 
						    .DIB11(DIB[29]), 
						    .DIB12(DIB[30]), 
						    .DIB13(DIB[31]), 
						    .DIB14(DIB[32]), 
						    .DIB15(DIB[33]), 
						    .DIB16(DIB[34]), 
						    .DIB17(DIB[35]), 
						    .ADB0(scuba_vhi), 
						    .ADB1(scuba_vhi), 
						    .ADB2(scuba_vlo), 
						    .ADB3(scuba_vlo), 
						    .ADB4(ADDRB[0]), 
						    .ADB5(ADDRB[1]), 
						    .ADB6(ADDRB[2]), 
						    .ADB7(ADDRB[3]), 
						    .ADB8(ADDRB[4]), 
						    .ADB9(ADDRB[5]), 
						    .ADB10(ADDRB[6]), 
						    .ADB11(ADDRB[7]), 
						    .ADB12(ADDRB[8]), 
						    .ADB13(scuba_vlo), 
						    .CEB(ENB), 
						    .CLKB(CLKB), 
						    .OCEB(ENB), 
						    .WEB(WEB), 
						    .CSB0(scuba_vlo), 
						    .CSB1(scuba_vlo), 
						    .CSB2(scuba_vlo), 
						    .RSTB(scuba_vlo), 
						    .DOA0(DOA_internal[18]), 
						    .DOA1(DOA_internal[19]), 
						    .DOA2(DOA_internal[20]), 
						    .DOA3(DOA_internal[21]), 
						    .DOA4(DOA_internal[22]), 
						    .DOA5(DOA_internal[23]), 
						    .DOA6(DOA_internal[24]), 
						    .DOA7(DOA_internal[25]), 
						    .DOA8(DOA_internal[26]), 
						    .DOA9(DOA_internal[27]), 
						    .DOA10(DOA_internal[28]), 
						    .DOA11(DOA_internal[29]), 
						    .DOA12(DOA_internal[30]), 
						    .DOA13(DOA_internal[31]), 
						    .DOA14(DOA_internal[32]), 
						    .DOA15(DOA_internal[33]), 
						    .DOA16(DOA_internal[34]), 
						    .DOA17(DOA_internal[35]), 
						    .DOB0(DOB_internal[18]), 
						    .DOB1(DOB_internal[19]), 
						    .DOB2(DOB_internal[20]), 
						    .DOB3(DOB_internal[21]), 
						    .DOB4(DOB_internal[22]), 
						    .DOB5(DOB_internal[23]), 
						    .DOB6(DOB_internal[24]), 
						    .DOB7(DOB_internal[25]), 
						    .DOB8(DOB_internal[26]), 
						    .DOB9(DOB_internal[27]), 
						    .DOB10(DOB_internal[28]), 
						    .DOB11(DOB_internal[29]), 
						    .DOB12(DOB_internal[30]), 
						    .DOB13(DOB_internal[31]), 
						    .DOB14(DOB_internal[32]), 
						    .DOB15(DOB_internal[33]), 
						    .DOB16(DOB_internal[34]), 
						    .DOB17(DOB_internal[35]));

		end
		else
		begin
		
            ssr_logic #(
            .WIDTH  (      36      ),
            .SRVAL  ( SRVAL_A      )
            ) ssr_logic_inst_a (
            .CLK    ( CLKA         ),
            .DO_in  ( DOA_internal ),
            .DO_out ( DOA          ),
            .EN     ( ENA          ),
            .SSR    ( SSRA         )
            );   
            
            ssr_logic #(
            .WIDTH  (      36      ),
            .SRVAL  ( SRVAL_B      )
            ) ssr_logic_inst_b (
            .CLK    ( CLKB         ),
            .DO_in  ( DOB_internal ),
            .DO_out ( DOB          ),
            .EN     ( ENB          ),
            .SSR    ( SSRB         )
            ); 
		


			defparam ram_36_inst_lowbits.INITVAL_1F = INITVAL_1F_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_1E = INITVAL_1E_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_1D = INITVAL_1D_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_1C = INITVAL_1C_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_1B = INITVAL_1B_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_1A = INITVAL_1A_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_19 = INITVAL_19_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_18 = INITVAL_18_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_17 = INITVAL_17_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_16 = INITVAL_16_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_15 = INITVAL_15_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_14 = INITVAL_14_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_13 = INITVAL_13_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_12 = INITVAL_12_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_11 = INITVAL_11_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_10 = INITVAL_10_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_0F = INITVAL_0F_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_0E = INITVAL_0E_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_0D = INITVAL_0D_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_0C = INITVAL_0C_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_0B = INITVAL_0B_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_0A = INITVAL_0A_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_09 = INITVAL_09_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_08 = INITVAL_08_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_07 = INITVAL_07_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_06 = INITVAL_06_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_05 = INITVAL_05_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_04 = INITVAL_04_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_03 = INITVAL_03_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_02 = INITVAL_02_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_01 = INITVAL_01_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_00 = INITVAL_00_lowbits ;
			defparam ram_36_inst_lowbits.CSDECODE_A = "0b000" ;
			defparam ram_36_inst_lowbits.CSDECODE_B = "0b000" ;
			defparam ram_36_inst_lowbits.WRITEMODE_A = "READBEFOREWRITE" ;
			defparam ram_36_inst_lowbits.WRITEMODE_B = "WRITETHROUGH" ;
			defparam ram_36_inst_lowbits.GSR = "DISABLED" ;
 			defparam ram_36_inst_lowbits.REGMODE_A = "NOREG" ;
			defparam ram_36_inst_lowbits.REGMODE_B = "NOREG" ;
			defparam ram_36_inst_lowbits.DATA_WIDTH_A = 18 ;
			defparam ram_36_inst_lowbits.DATA_WIDTH_B = 18 ;
			DP16KC ram_36_inst_lowbits (
						    .DIA0(DIA[0]), 
						    .DIA1(DIA[1]), 
						    .DIA2(DIA[2]), 
						    .DIA3(DIA[3]), 
						    .DIA4(DIA[4]), 
						    .DIA5(DIA[5]), 
						    .DIA6(DIA[6]), 
						    .DIA7(DIA[7]), 
						    .DIA8(DIA[8]), 
						    .DIA9(DIA[9]), 
						    .DIA10(DIA[10]), 
						    .DIA11(DIA[11]), 
						    .DIA12(DIA[12]), 
						    .DIA13(DIA[13]), 
						    .DIA14(DIA[14]), 
						    .DIA15(DIA[15]), 
						    .DIA16(DIA[16]), 
						    .DIA17(DIA[17]), 
						    .ADA0(scuba_vhi), 
						    .ADA1(scuba_vhi), 
						    .ADA2(scuba_vlo), 
						    .ADA3(scuba_vlo), 
						    .ADA4(ADDRA[0]), 
						    .ADA5(ADDRA[1]), 
						    .ADA6(ADDRA[2]), 
						    .ADA7(ADDRA[3]), 
						    .ADA8(ADDRA[4]), 
						    .ADA9(ADDRA[5]), 
						    .ADA10(ADDRA[6]), 
						    .ADA11(ADDRA[7]), 
						    .ADA12(ADDRA[8]), 
						    .ADA13(scuba_vlo), 
						    .CEA(ENA), 
						    .CLKA(CLKA), 
						    .OCEA(ENA), 
						    .WEA(WEA), 
						    .CSA0(scuba_vlo), 
						    .CSA1(scuba_vlo), 
						    .CSA2(scuba_vlo), 
						    .RSTA(scuba_vlo), 
						    .DIB0(DIB[0]), 
						    .DIB1(DIB[1]), 
						    .DIB2(DIB[2]), 
						    .DIB3(DIB[3]), 
						    .DIB4(DIB[4]), 
						    .DIB5(DIB[5]), 
						    .DIB6(DIB[6]), 
						    .DIB7(DIB[7]), 
						    .DIB8(DIB[8]), 
						    .DIB9(DIB[9]), 
						    .DIB10(DIB[10]), 
						    .DIB11(DIB[11]), 
						    .DIB12(DIB[12]), 
						    .DIB13(DIB[13]), 
						    .DIB14(DIB[14]), 
						    .DIB15(DIB[15]), 
						    .DIB16(DIB[16]), 
						    .DIB17(DIB[17]), 
						    .ADB0(scuba_vhi), 
						    .ADB1(scuba_vhi), 
						    .ADB2(scuba_vlo), 
						    .ADB3(scuba_vlo), 
						    .ADB4(ADDRB[0]), 
						    .ADB5(ADDRB[1]), 
						    .ADB6(ADDRB[2]), 
						    .ADB7(ADDRB[3]), 
						    .ADB8(ADDRB[4]), 
						    .ADB9(ADDRB[5]), 
						    .ADB10(ADDRB[6]), 
						    .ADB11(ADDRB[7]), 
						    .ADB12(ADDRB[8]), 
						    .ADB13(scuba_vlo), 
						    .CEB(ENB), 
						    .CLKB(CLKB), 
						    .OCEB(ENB), 
						    .WEB(WEB), 
						    .CSB0(scuba_vlo), 
						    .CSB1(scuba_vlo), 
						    .CSB2(scuba_vlo), 
						    .RSTB(scuba_vlo), 
						    .DOA0(DOA_internal[0]), 
						    .DOA1(DOA_internal[1]), 
						    .DOA2(DOA_internal[2]), 
						    .DOA3(DOA_internal[3]), 
						    .DOA4(DOA_internal[4]), 
						    .DOA5(DOA_internal[5]), 
						    .DOA6(DOA_internal[6]), 
						    .DOA7(DOA_internal[7]), 
						    .DOA8(DOA_internal[8]), 
						    .DOA9(DOA_internal[9]), 
						    .DOA10(DOA_internal[10]), 
						    .DOA11(DOA_internal[11]), 
						    .DOA12(DOA_internal[12]), 
						    .DOA13(DOA_internal[13]), 
						    .DOA14(DOA_internal[14]), 
						    .DOA15(DOA_internal[15]), 
						    .DOA16(DOA_internal[16]), 
						    .DOA17(DOA_internal[17]), 
						    .DOB0(DOB_internal[0]), 
						    .DOB1(DOB_internal[1]), 
						    .DOB2(DOB_internal[2]), 
						    .DOB3(DOB_internal[3]), 
						    .DOB4(DOB_internal[4]), 
						    .DOB5(DOB_internal[5]), 
						    .DOB6(DOB_internal[6]), 
						    .DOB7(DOB_internal[7]),
						    .DOB8(DOB_internal[8]), 
						    .DOB9(DOB_internal[9]), 
						    .DOB10(DOB_internal[10]), 
						    .DOB11(DOB_internal[11]), 
						    .DOB12(DOB_internal[12]), 
						    .DOB13(DOB_internal[13]), 
						    .DOB14(DOB_internal[14]), 
						    .DOB15(DOB_internal[15]), 
						    .DOB16(DOB_internal[16]), 
						    .DOB17(DOB_internal[17]));



			defparam ram_36_inst_highbits.INITVAL_1F = INITVAL_1F_highbits ;
			defparam ram_36_inst_highbits.INITVAL_1E = INITVAL_1E_highbits ;
			defparam ram_36_inst_highbits.INITVAL_1D = INITVAL_1D_highbits ;
			defparam ram_36_inst_highbits.INITVAL_1C = INITVAL_1C_highbits ;
			defparam ram_36_inst_highbits.INITVAL_1B = INITVAL_1B_highbits ;
			defparam ram_36_inst_highbits.INITVAL_1A = INITVAL_1A_highbits ;
			defparam ram_36_inst_highbits.INITVAL_19 = INITVAL_19_highbits ;
			defparam ram_36_inst_highbits.INITVAL_18 = INITVAL_18_highbits ;
			defparam ram_36_inst_highbits.INITVAL_17 = INITVAL_17_highbits ;
			defparam ram_36_inst_highbits.INITVAL_16 = INITVAL_16_highbits ;
			defparam ram_36_inst_highbits.INITVAL_15 = INITVAL_15_highbits ;
			defparam ram_36_inst_highbits.INITVAL_14 = INITVAL_14_highbits ;
			defparam ram_36_inst_highbits.INITVAL_13 = INITVAL_13_highbits ;
			defparam ram_36_inst_highbits.INITVAL_12 = INITVAL_12_highbits ;
			defparam ram_36_inst_highbits.INITVAL_11 = INITVAL_11_highbits ;
			defparam ram_36_inst_highbits.INITVAL_10 = INITVAL_10_highbits ;
			defparam ram_36_inst_highbits.INITVAL_0F = INITVAL_0F_highbits ;
			defparam ram_36_inst_highbits.INITVAL_0E = INITVAL_0E_highbits ;
			defparam ram_36_inst_highbits.INITVAL_0D = INITVAL_0D_highbits ;
			defparam ram_36_inst_highbits.INITVAL_0C = INITVAL_0C_highbits ;
			defparam ram_36_inst_highbits.INITVAL_0B = INITVAL_0B_highbits ;
			defparam ram_36_inst_highbits.INITVAL_0A = INITVAL_0A_highbits ;
			defparam ram_36_inst_highbits.INITVAL_09 = INITVAL_09_highbits ;
			defparam ram_36_inst_highbits.INITVAL_08 = INITVAL_08_highbits ;
			defparam ram_36_inst_highbits.INITVAL_07 = INITVAL_07_highbits ;
			defparam ram_36_inst_highbits.INITVAL_06 = INITVAL_06_highbits ;
			defparam ram_36_inst_highbits.INITVAL_05 = INITVAL_05_highbits ;
			defparam ram_36_inst_highbits.INITVAL_04 = INITVAL_04_highbits ;
			defparam ram_36_inst_highbits.INITVAL_03 = INITVAL_03_highbits ;
			defparam ram_36_inst_highbits.INITVAL_02 = INITVAL_02_highbits ;
			defparam ram_36_inst_highbits.INITVAL_01 = INITVAL_01_highbits ;
			defparam ram_36_inst_highbits.INITVAL_00 = INITVAL_00_highbits ;
			defparam ram_36_inst_highbits.CSDECODE_A = "0b000" ;
			defparam ram_36_inst_highbits.CSDECODE_B = "0b000" ;
			defparam ram_36_inst_highbits.WRITEMODE_A = "READBEFOREWRITE" ;
			defparam ram_36_inst_highbits.WRITEMODE_B = "WRITETHROUGH" ;
			defparam ram_36_inst_highbits.GSR = "DISABLED" ;
 			defparam ram_36_inst_highbits.REGMODE_A = "NOREG" ;
			defparam ram_36_inst_highbits.REGMODE_B = "NOREG" ;
			defparam ram_36_inst_highbits.DATA_WIDTH_A = 18 ;
			defparam ram_36_inst_highbits.DATA_WIDTH_B = 18 ;
			DP16KC ram_36_inst_highbits (
						    .DIA0(DIA[18]), 
						    .DIA1(DIA[19]), 
						    .DIA2(DIA[20]), 
						    .DIA3(DIA[21]), 
						    .DIA4(DIA[22]), 
						    .DIA5(DIA[23]), 
						    .DIA6(DIA[24]), 
						    .DIA7(DIA[25]), 
						    .DIA8(DIA[26]), 
						    .DIA9(DIA[27]), 
						    .DIA10(DIA[28]), 
						    .DIA11(DIA[29]), 
						    .DIA12(DIA[30]), 
						    .DIA13(DIA[31]), 
						    .DIA14(DIA[32]), 
						    .DIA15(DIA[33]), 
						    .DIA16(DIA[34]), 
						    .DIA17(DIA[35]), 
						    .ADA0(scuba_vhi), 
						    .ADA1(scuba_vhi), 
						    .ADA2(scuba_vlo), 
						    .ADA3(scuba_vlo), 
						    .ADA4(ADDRA[0]), 
						    .ADA5(ADDRA[1]), 
						    .ADA6(ADDRA[2]), 
						    .ADA7(ADDRA[3]), 
						    .ADA8(ADDRA[4]), 
						    .ADA9(ADDRA[5]), 
						    .ADA10(ADDRA[6]), 
						    .ADA11(ADDRA[7]), 
						    .ADA12(ADDRA[8]), 
						    .ADA13(scuba_vlo), 
						    .CEA(ENA), 
						    .CLKA(CLKA), 
						    .OCEA(ENA), 
						    .WEA(WEA), 
						    .CSA0(scuba_vlo), 
						    .CSA1(scuba_vlo), 
						    .CSA2(scuba_vlo), 
						    .RSTA(scuba_vlo), 
						    .DIB0(DIB[18]), 
						    .DIB1(DIB[19]), 
						    .DIB2(DIB[20]), 
						    .DIB3(DIB[21]), 
						    .DIB4(DIB[22]), 
						    .DIB5(DIB[23]), 
						    .DIB6(DIB[24]), 
						    .DIB7(DIB[25]), 
						    .DIB8(DIB[26]), 
						    .DIB9(DIB[27]), 
						    .DIB10(DIB[28]), 
						    .DIB11(DIB[29]), 
						    .DIB12(DIB[30]), 
						    .DIB13(DIB[31]), 
						    .DIB14(DIB[32]), 
						    .DIB15(DIB[33]), 
						    .DIB16(DIB[34]), 
						    .DIB17(DIB[35]), 
						    .ADB0(scuba_vhi), 
						    .ADB1(scuba_vhi), 
						    .ADB2(scuba_vlo), 
						    .ADB3(scuba_vlo), 
						    .ADB4(ADDRB[0]), 
						    .ADB5(ADDRB[1]), 
						    .ADB6(ADDRB[2]), 
						    .ADB7(ADDRB[3]), 
						    .ADB8(ADDRB[4]), 
						    .ADB9(ADDRB[5]), 
						    .ADB10(ADDRB[6]), 
						    .ADB11(ADDRB[7]), 
						    .ADB12(ADDRB[8]), 
						    .ADB13(scuba_vlo), 
						    .CEB(ENB), 
						    .CLKB(CLKB), 
						    .OCEB(ENB), 
						    .WEB(WEB), 
						    .CSB0(scuba_vlo), 
						    .CSB1(scuba_vlo), 
						    .CSB2(scuba_vlo), 
						    .RSTB(scuba_vlo), 
						    .DOA0(DOA_internal[18]), 
						    .DOA1(DOA_internal[19]), 
						    .DOA2(DOA_internal[20]), 
						    .DOA3(DOA_internal[21]), 
						    .DOA4(DOA_internal[22]), 
						    .DOA5(DOA_internal[23]), 
						    .DOA6(DOA_internal[24]), 
						    .DOA7(DOA_internal[25]), 
						    .DOA8(DOA_internal[26]), 
						    .DOA9(DOA_internal[27]), 
						    .DOA10(DOA_internal[28]), 
						    .DOA11(DOA_internal[29]), 
						    .DOA12(DOA_internal[30]), 
						    .DOA13(DOA_internal[31]), 
						    .DOA14(DOA_internal[32]), 
						    .DOA15(DOA_internal[33]), 
						    .DOA16(DOA_internal[34]), 
						    .DOA17(DOA_internal[35]), 
						    .DOB0(DOB_internal[18]), 
						    .DOB1(DOB_internal[19]), 
						    .DOB2(DOB_internal[20]), 
						    .DOB3(DOB_internal[21]), 
						    .DOB4(DOB_internal[22]), 
						    .DOB5(DOB_internal[23]), 
						    .DOB6(DOB_internal[24]), 
						    .DOB7(DOB_internal[25]), 
						    .DOB8(DOB_internal[26]), 
						    .DOB9(DOB_internal[27]), 
						    .DOB10(DOB_internal[28]), 
						    .DOB11(DOB_internal[29]), 
						    .DOB12(DOB_internal[30]), 
						    .DOB13(DOB_internal[31]), 
						    .DOB14(DOB_internal[32]), 
						    .DOB15(DOB_internal[33]), 
						    .DOB16(DOB_internal[34]), 
						    .DOB17(DOB_internal[35]));

		end
		
	end
	
	// end port a = READ_FIRST

	// begin port a = NO_CHANGE

	else if (WRITE_MODE_A == "NO_CHANGE")
	begin
	
		if (WRITE_MODE_B == "WRITE_FIRST")
		begin
		
			nochange_ssr_logic #(
            .WIDTH  (      36      ),
            .SRVAL  ( SRVAL_A      )
            ) nochange_ssr_logic_inst_a (
            .CLK    ( CLKA         ),
            .DO_in  ( DOA_internal ),
            .DO_out ( DOA          ),
            .EN     ( ENA          ),
            .WE     ( WEA          ),
            .SSR    ( SSRA         )
            );     
            
            ssr_logic #(
            .WIDTH  (      36      ),
            .SRVAL  ( SRVAL_B      )
            ) ssr_logic_inst_b (
            .CLK    ( CLKB         ),
            .DO_in  ( DOB_internal ),
            .DO_out ( DOB          ),
            .EN     ( ENB          ),
            .SSR    ( SSRB         )
            ); 




			defparam ram_36_inst_lowbits.INITVAL_1F = INITVAL_1F_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_1E = INITVAL_1E_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_1D = INITVAL_1D_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_1C = INITVAL_1C_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_1B = INITVAL_1B_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_1A = INITVAL_1A_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_19 = INITVAL_19_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_18 = INITVAL_18_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_17 = INITVAL_17_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_16 = INITVAL_16_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_15 = INITVAL_15_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_14 = INITVAL_14_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_13 = INITVAL_13_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_12 = INITVAL_12_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_11 = INITVAL_11_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_10 = INITVAL_10_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_0F = INITVAL_0F_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_0E = INITVAL_0E_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_0D = INITVAL_0D_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_0C = INITVAL_0C_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_0B = INITVAL_0B_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_0A = INITVAL_0A_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_09 = INITVAL_09_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_08 = INITVAL_08_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_07 = INITVAL_07_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_06 = INITVAL_06_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_05 = INITVAL_05_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_04 = INITVAL_04_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_03 = INITVAL_03_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_02 = INITVAL_02_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_01 = INITVAL_01_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_00 = INITVAL_00_lowbits ;
			defparam ram_36_inst_lowbits.CSDECODE_A = "0b000" ;
			defparam ram_36_inst_lowbits.CSDECODE_B = "0b000" ;
			defparam ram_36_inst_lowbits.WRITEMODE_A = "WRITETHROUGH" ;
			defparam ram_36_inst_lowbits.WRITEMODE_B = "WRITETHROUGH" ;
			defparam ram_36_inst_lowbits.GSR = "DISABLED" ;
 			defparam ram_36_inst_lowbits.REGMODE_A = "NOREG" ;
			defparam ram_36_inst_lowbits.REGMODE_B = "NOREG" ;
			defparam ram_36_inst_lowbits.DATA_WIDTH_A = 18 ;
			defparam ram_36_inst_lowbits.DATA_WIDTH_B = 18 ;
			DP16KC ram_36_inst_lowbits (
						    .DIA0(DIA[0]), 
						    .DIA1(DIA[1]), 
						    .DIA2(DIA[2]), 
						    .DIA3(DIA[3]), 
						    .DIA4(DIA[4]), 
						    .DIA5(DIA[5]), 
						    .DIA6(DIA[6]), 
						    .DIA7(DIA[7]), 
						    .DIA8(DIA[8]), 
						    .DIA9(DIA[9]), 
						    .DIA10(DIA[10]), 
						    .DIA11(DIA[11]), 
						    .DIA12(DIA[12]), 
						    .DIA13(DIA[13]), 
						    .DIA14(DIA[14]), 
						    .DIA15(DIA[15]), 
						    .DIA16(DIA[16]), 
						    .DIA17(DIA[17]), 
						    .ADA0(scuba_vhi), 
						    .ADA1(scuba_vhi), 
						    .ADA2(scuba_vlo), 
						    .ADA3(scuba_vlo), 
						    .ADA4(ADDRA[0]), 
						    .ADA5(ADDRA[1]), 
						    .ADA6(ADDRA[2]), 
						    .ADA7(ADDRA[3]), 
						    .ADA8(ADDRA[4]), 
						    .ADA9(ADDRA[5]), 
						    .ADA10(ADDRA[6]), 
						    .ADA11(ADDRA[7]), 
						    .ADA12(ADDRA[8]), 
						    .ADA13(scuba_vlo), 
						    .CEA(ENA), 
						    .CLKA(CLKA), 
						    .OCEA(ENA), 
						    .WEA(WEA), 
						    .CSA0(scuba_vlo), 
						    .CSA1(scuba_vlo), 
						    .CSA2(scuba_vlo), 
						    .RSTA(scuba_vlo), 
						    .DIB0(DIB[0]), 
						    .DIB1(DIB[1]), 
						    .DIB2(DIB[2]), 
						    .DIB3(DIB[3]), 
						    .DIB4(DIB[4]), 
						    .DIB5(DIB[5]), 
						    .DIB6(DIB[6]), 
						    .DIB7(DIB[7]), 
						    .DIB8(DIB[8]), 
						    .DIB9(DIB[9]), 
						    .DIB10(DIB[10]), 
						    .DIB11(DIB[11]), 
						    .DIB12(DIB[12]), 
						    .DIB13(DIB[13]), 
						    .DIB14(DIB[14]), 
						    .DIB15(DIB[15]), 
						    .DIB16(DIB[16]), 
						    .DIB17(DIB[17]), 
						    .ADB0(scuba_vhi), 
						    .ADB1(scuba_vhi), 
						    .ADB2(scuba_vlo), 
						    .ADB3(scuba_vlo), 
						    .ADB4(ADDRB[0]), 
						    .ADB5(ADDRB[1]), 
						    .ADB6(ADDRB[2]), 
						    .ADB7(ADDRB[3]), 
						    .ADB8(ADDRB[4]), 
						    .ADB9(ADDRB[5]), 
						    .ADB10(ADDRB[6]), 
						    .ADB11(ADDRB[7]), 
						    .ADB12(ADDRB[8]), 
						    .ADB13(scuba_vlo), 
						    .CEB(ENB), 
						    .CLKB(CLKB), 
						    .OCEB(ENB), 
						    .WEB(WEB), 
						    .CSB0(scuba_vlo), 
						    .CSB1(scuba_vlo), 
						    .CSB2(scuba_vlo), 
						    .RSTB(scuba_vlo), 
						    .DOA0(DOA_internal[0]), 
						    .DOA1(DOA_internal[1]), 
						    .DOA2(DOA_internal[2]), 
						    .DOA3(DOA_internal[3]), 
						    .DOA4(DOA_internal[4]), 
						    .DOA5(DOA_internal[5]), 
						    .DOA6(DOA_internal[6]), 
						    .DOA7(DOA_internal[7]), 
						    .DOA8(DOA_internal[8]), 
						    .DOA9(DOA_internal[9]), 
						    .DOA10(DOA_internal[10]), 
						    .DOA11(DOA_internal[11]), 
						    .DOA12(DOA_internal[12]), 
						    .DOA13(DOA_internal[13]), 
						    .DOA14(DOA_internal[14]), 
						    .DOA15(DOA_internal[15]), 
						    .DOA16(DOA_internal[16]), 
						    .DOA17(DOA_internal[17]), 
						    .DOB0(DOB_internal[0]), 
						    .DOB1(DOB_internal[1]), 
						    .DOB2(DOB_internal[2]), 
						    .DOB3(DOB_internal[3]), 
						    .DOB4(DOB_internal[4]), 
						    .DOB5(DOB_internal[5]), 
						    .DOB6(DOB_internal[6]), 
						    .DOB7(DOB_internal[7]),
						    .DOB8(DOB_internal[8]), 
						    .DOB9(DOB_internal[9]), 
						    .DOB10(DOB_internal[10]), 
						    .DOB11(DOB_internal[11]), 
						    .DOB12(DOB_internal[12]), 
						    .DOB13(DOB_internal[13]), 
						    .DOB14(DOB_internal[14]), 
						    .DOB15(DOB_internal[15]), 
						    .DOB16(DOB_internal[16]), 
						    .DOB17(DOB_internal[17]));



			defparam ram_36_inst_highbits.INITVAL_1F = INITVAL_1F_highbits ;
			defparam ram_36_inst_highbits.INITVAL_1E = INITVAL_1E_highbits ;
			defparam ram_36_inst_highbits.INITVAL_1D = INITVAL_1D_highbits ;
			defparam ram_36_inst_highbits.INITVAL_1C = INITVAL_1C_highbits ;
			defparam ram_36_inst_highbits.INITVAL_1B = INITVAL_1B_highbits ;
			defparam ram_36_inst_highbits.INITVAL_1A = INITVAL_1A_highbits ;
			defparam ram_36_inst_highbits.INITVAL_19 = INITVAL_19_highbits ;
			defparam ram_36_inst_highbits.INITVAL_18 = INITVAL_18_highbits ;
			defparam ram_36_inst_highbits.INITVAL_17 = INITVAL_17_highbits ;
			defparam ram_36_inst_highbits.INITVAL_16 = INITVAL_16_highbits ;
			defparam ram_36_inst_highbits.INITVAL_15 = INITVAL_15_highbits ;
			defparam ram_36_inst_highbits.INITVAL_14 = INITVAL_14_highbits ;
			defparam ram_36_inst_highbits.INITVAL_13 = INITVAL_13_highbits ;
			defparam ram_36_inst_highbits.INITVAL_12 = INITVAL_12_highbits ;
			defparam ram_36_inst_highbits.INITVAL_11 = INITVAL_11_highbits ;
			defparam ram_36_inst_highbits.INITVAL_10 = INITVAL_10_highbits ;
			defparam ram_36_inst_highbits.INITVAL_0F = INITVAL_0F_highbits ;
			defparam ram_36_inst_highbits.INITVAL_0E = INITVAL_0E_highbits ;
			defparam ram_36_inst_highbits.INITVAL_0D = INITVAL_0D_highbits ;
			defparam ram_36_inst_highbits.INITVAL_0C = INITVAL_0C_highbits ;
			defparam ram_36_inst_highbits.INITVAL_0B = INITVAL_0B_highbits ;
			defparam ram_36_inst_highbits.INITVAL_0A = INITVAL_0A_highbits ;
			defparam ram_36_inst_highbits.INITVAL_09 = INITVAL_09_highbits ;
			defparam ram_36_inst_highbits.INITVAL_08 = INITVAL_08_highbits ;
			defparam ram_36_inst_highbits.INITVAL_07 = INITVAL_07_highbits ;
			defparam ram_36_inst_highbits.INITVAL_06 = INITVAL_06_highbits ;
			defparam ram_36_inst_highbits.INITVAL_05 = INITVAL_05_highbits ;
			defparam ram_36_inst_highbits.INITVAL_04 = INITVAL_04_highbits ;
			defparam ram_36_inst_highbits.INITVAL_03 = INITVAL_03_highbits ;
			defparam ram_36_inst_highbits.INITVAL_02 = INITVAL_02_highbits ;
			defparam ram_36_inst_highbits.INITVAL_01 = INITVAL_01_highbits ;
			defparam ram_36_inst_highbits.INITVAL_00 = INITVAL_00_highbits ;
			defparam ram_36_inst_highbits.CSDECODE_A = "0b000" ;
			defparam ram_36_inst_highbits.CSDECODE_B = "0b000" ;
			defparam ram_36_inst_highbits.WRITEMODE_A = "WRITETHROUGH" ;
			defparam ram_36_inst_highbits.WRITEMODE_B = "WRITETHROUGH" ;
			defparam ram_36_inst_highbits.GSR = "DISABLED" ;
 			defparam ram_36_inst_highbits.REGMODE_A = "NOREG" ;
			defparam ram_36_inst_highbits.REGMODE_B = "NOREG" ;
			defparam ram_36_inst_highbits.DATA_WIDTH_A = 18 ;
			defparam ram_36_inst_highbits.DATA_WIDTH_B = 18 ;
			DP16KC ram_36_inst_highbits (
						    .DIA0(DIA[18]), 
						    .DIA1(DIA[19]), 
						    .DIA2(DIA[20]), 
						    .DIA3(DIA[21]), 
						    .DIA4(DIA[22]), 
						    .DIA5(DIA[23]), 
						    .DIA6(DIA[24]), 
						    .DIA7(DIA[25]), 
						    .DIA8(DIA[26]), 
						    .DIA9(DIA[27]), 
						    .DIA10(DIA[28]), 
						    .DIA11(DIA[29]), 
						    .DIA12(DIA[30]), 
						    .DIA13(DIA[31]), 
						    .DIA14(DIA[32]), 
						    .DIA15(DIA[33]), 
						    .DIA16(DIA[34]), 
						    .DIA17(DIA[35]), 
						    .ADA0(scuba_vhi), 
						    .ADA1(scuba_vhi), 
						    .ADA2(scuba_vlo), 
						    .ADA3(scuba_vlo), 
						    .ADA4(ADDRA[0]), 
						    .ADA5(ADDRA[1]), 
						    .ADA6(ADDRA[2]), 
						    .ADA7(ADDRA[3]), 
						    .ADA8(ADDRA[4]), 
						    .ADA9(ADDRA[5]), 
						    .ADA10(ADDRA[6]), 
						    .ADA11(ADDRA[7]), 
						    .ADA12(ADDRA[8]), 
						    .ADA13(scuba_vlo), 
						    .CEA(ENA), 
						    .CLKA(CLKA), 
						    .OCEA(ENA), 
						    .WEA(WEA), 
						    .CSA0(scuba_vlo), 
						    .CSA1(scuba_vlo), 
						    .CSA2(scuba_vlo), 
						    .RSTA(scuba_vlo), 
						    .DIB0(DIB[18]), 
						    .DIB1(DIB[19]), 
						    .DIB2(DIB[20]), 
						    .DIB3(DIB[21]), 
						    .DIB4(DIB[22]), 
						    .DIB5(DIB[23]), 
						    .DIB6(DIB[24]), 
						    .DIB7(DIB[25]), 
						    .DIB8(DIB[26]), 
						    .DIB9(DIB[27]), 
						    .DIB10(DIB[28]), 
						    .DIB11(DIB[29]), 
						    .DIB12(DIB[30]), 
						    .DIB13(DIB[31]), 
						    .DIB14(DIB[32]), 
						    .DIB15(DIB[33]), 
						    .DIB16(DIB[34]), 
						    .DIB17(DIB[35]), 
						    .ADB0(scuba_vhi), 
						    .ADB1(scuba_vhi), 
						    .ADB2(scuba_vlo), 
						    .ADB3(scuba_vlo), 
						    .ADB4(ADDRB[0]), 
						    .ADB5(ADDRB[1]), 
						    .ADB6(ADDRB[2]), 
						    .ADB7(ADDRB[3]), 
						    .ADB8(ADDRB[4]), 
						    .ADB9(ADDRB[5]), 
						    .ADB10(ADDRB[6]), 
						    .ADB11(ADDRB[7]), 
						    .ADB12(ADDRB[8]), 
						    .ADB13(scuba_vlo), 
						    .CEB(ENB), 
						    .CLKB(CLKB), 
						    .OCEB(ENB), 
						    .WEB(WEB), 
						    .CSB0(scuba_vlo), 
						    .CSB1(scuba_vlo), 
						    .CSB2(scuba_vlo), 
						    .RSTB(scuba_vlo), 
						    .DOA0(DOA_internal[18]), 
						    .DOA1(DOA_internal[19]), 
						    .DOA2(DOA_internal[20]), 
						    .DOA3(DOA_internal[21]), 
						    .DOA4(DOA_internal[22]), 
						    .DOA5(DOA_internal[23]), 
						    .DOA6(DOA_internal[24]), 
						    .DOA7(DOA_internal[25]), 
						    .DOA8(DOA_internal[26]), 
						    .DOA9(DOA_internal[27]), 
						    .DOA10(DOA_internal[28]), 
						    .DOA11(DOA_internal[29]), 
						    .DOA12(DOA_internal[30]), 
						    .DOA13(DOA_internal[31]), 
						    .DOA14(DOA_internal[32]), 
						    .DOA15(DOA_internal[33]), 
						    .DOA16(DOA_internal[34]), 
						    .DOA17(DOA_internal[35]), 
						    .DOB0(DOB_internal[18]), 
						    .DOB1(DOB_internal[19]), 
						    .DOB2(DOB_internal[20]), 
						    .DOB3(DOB_internal[21]), 
						    .DOB4(DOB_internal[22]), 
						    .DOB5(DOB_internal[23]), 
						    .DOB6(DOB_internal[24]), 
						    .DOB7(DOB_internal[25]), 
						    .DOB8(DOB_internal[26]), 
						    .DOB9(DOB_internal[27]), 
						    .DOB10(DOB_internal[28]), 
						    .DOB11(DOB_internal[29]), 
						    .DOB12(DOB_internal[30]), 
						    .DOB13(DOB_internal[31]), 
						    .DOB14(DOB_internal[32]), 
						    .DOB15(DOB_internal[33]), 
						    .DOB16(DOB_internal[34]), 
						    .DOB17(DOB_internal[35]));

		end
		else if (WRITE_MODE_B == "READ_FIRST")
		begin
		
			nochange_ssr_logic #(
            .WIDTH  (      36      ),
            .SRVAL  ( SRVAL_A      )
            ) nochange_ssr_logic_inst_a (
            .CLK    ( CLKA         ),
            .DO_in  ( DOA_internal ),
            .DO_out ( DOA          ),
            .EN     ( ENA          ),
            .WE     ( WEA          ),
            .SSR    ( SSRA         )
            );     
            
            ssr_logic #(
            .WIDTH  (      36      ),
            .SRVAL  ( SRVAL_B      )
            ) ssr_logic_inst_b (
            .CLK    ( CLKB         ),
            .DO_in  ( DOB_internal ),
            .DO_out ( DOB          ),
            .EN     ( ENB          ),
            .SSR    ( SSRB         )
            );



			defparam ram_36_inst_lowbits.INITVAL_1F = INITVAL_1F_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_1E = INITVAL_1E_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_1D = INITVAL_1D_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_1C = INITVAL_1C_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_1B = INITVAL_1B_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_1A = INITVAL_1A_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_19 = INITVAL_19_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_18 = INITVAL_18_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_17 = INITVAL_17_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_16 = INITVAL_16_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_15 = INITVAL_15_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_14 = INITVAL_14_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_13 = INITVAL_13_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_12 = INITVAL_12_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_11 = INITVAL_11_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_10 = INITVAL_10_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_0F = INITVAL_0F_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_0E = INITVAL_0E_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_0D = INITVAL_0D_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_0C = INITVAL_0C_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_0B = INITVAL_0B_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_0A = INITVAL_0A_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_09 = INITVAL_09_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_08 = INITVAL_08_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_07 = INITVAL_07_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_06 = INITVAL_06_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_05 = INITVAL_05_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_04 = INITVAL_04_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_03 = INITVAL_03_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_02 = INITVAL_02_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_01 = INITVAL_01_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_00 = INITVAL_00_lowbits ;
			defparam ram_36_inst_lowbits.CSDECODE_A = "0b000" ;
			defparam ram_36_inst_lowbits.CSDECODE_B = "0b000" ;
			defparam ram_36_inst_lowbits.WRITEMODE_A = "WRITETHROUGH" ;
			defparam ram_36_inst_lowbits.WRITEMODE_B = "READBEFOREWRITE" ;
			defparam ram_36_inst_lowbits.GSR = "DISABLED" ;
 			defparam ram_36_inst_lowbits.REGMODE_A = "NOREG" ;
			defparam ram_36_inst_lowbits.REGMODE_B = "NOREG" ;
			defparam ram_36_inst_lowbits.DATA_WIDTH_A = 18 ;
			defparam ram_36_inst_lowbits.DATA_WIDTH_B = 18 ;
			DP16KC ram_36_inst_lowbits (
						    .DIA0(DIA[0]), 
						    .DIA1(DIA[1]), 
						    .DIA2(DIA[2]), 
						    .DIA3(DIA[3]), 
						    .DIA4(DIA[4]), 
						    .DIA5(DIA[5]), 
						    .DIA6(DIA[6]), 
						    .DIA7(DIA[7]), 
						    .DIA8(DIA[8]), 
						    .DIA9(DIA[9]), 
						    .DIA10(DIA[10]), 
						    .DIA11(DIA[11]), 
						    .DIA12(DIA[12]), 
						    .DIA13(DIA[13]), 
						    .DIA14(DIA[14]), 
						    .DIA15(DIA[15]), 
						    .DIA16(DIA[16]), 
						    .DIA17(DIA[17]), 
						    .ADA0(scuba_vhi), 
						    .ADA1(scuba_vhi), 
						    .ADA2(scuba_vlo), 
						    .ADA3(scuba_vlo), 
						    .ADA4(ADDRA[0]), 
						    .ADA5(ADDRA[1]), 
						    .ADA6(ADDRA[2]), 
						    .ADA7(ADDRA[3]), 
						    .ADA8(ADDRA[4]), 
						    .ADA9(ADDRA[5]), 
						    .ADA10(ADDRA[6]), 
						    .ADA11(ADDRA[7]), 
						    .ADA12(ADDRA[8]), 
						    .ADA13(scuba_vlo), 
						    .CEA(ENA), 
						    .CLKA(CLKA), 
						    .OCEA(ENA), 
						    .WEA(WEA), 
						    .CSA0(scuba_vlo), 
						    .CSA1(scuba_vlo), 
						    .CSA2(scuba_vlo), 
						    .RSTA(scuba_vlo), 
						    .DIB0(DIB[0]), 
						    .DIB1(DIB[1]), 
						    .DIB2(DIB[2]), 
						    .DIB3(DIB[3]), 
						    .DIB4(DIB[4]), 
						    .DIB5(DIB[5]), 
						    .DIB6(DIB[6]), 
						    .DIB7(DIB[7]), 
						    .DIB8(DIB[8]), 
						    .DIB9(DIB[9]), 
						    .DIB10(DIB[10]), 
						    .DIB11(DIB[11]), 
						    .DIB12(DIB[12]), 
						    .DIB13(DIB[13]), 
						    .DIB14(DIB[14]), 
						    .DIB15(DIB[15]), 
						    .DIB16(DIB[16]), 
						    .DIB17(DIB[17]), 
						    .ADB0(scuba_vhi), 
						    .ADB1(scuba_vhi), 
						    .ADB2(scuba_vlo), 
						    .ADB3(scuba_vlo), 
						    .ADB4(ADDRB[0]), 
						    .ADB5(ADDRB[1]), 
						    .ADB6(ADDRB[2]), 
						    .ADB7(ADDRB[3]), 
						    .ADB8(ADDRB[4]), 
						    .ADB9(ADDRB[5]), 
						    .ADB10(ADDRB[6]), 
						    .ADB11(ADDRB[7]), 
						    .ADB12(ADDRB[8]), 
						    .ADB13(scuba_vlo), 
						    .CEB(ENB), 
						    .CLKB(CLKB), 
						    .OCEB(ENB), 
						    .WEB(WEB), 
						    .CSB0(scuba_vlo), 
						    .CSB1(scuba_vlo), 
						    .CSB2(scuba_vlo), 
						    .RSTB(scuba_vlo), 
						    .DOA0(DOA_internal[0]), 
						    .DOA1(DOA_internal[1]), 
						    .DOA2(DOA_internal[2]), 
						    .DOA3(DOA_internal[3]), 
						    .DOA4(DOA_internal[4]), 
						    .DOA5(DOA_internal[5]), 
						    .DOA6(DOA_internal[6]), 
						    .DOA7(DOA_internal[7]), 
						    .DOA8(DOA_internal[8]), 
						    .DOA9(DOA_internal[9]), 
						    .DOA10(DOA_internal[10]), 
						    .DOA11(DOA_internal[11]), 
						    .DOA12(DOA_internal[12]), 
						    .DOA13(DOA_internal[13]), 
						    .DOA14(DOA_internal[14]), 
						    .DOA15(DOA_internal[15]), 
						    .DOA16(DOA_internal[16]), 
						    .DOA17(DOA_internal[17]), 
						    .DOB0(DOB_internal[0]), 
						    .DOB1(DOB_internal[1]), 
						    .DOB2(DOB_internal[2]), 
						    .DOB3(DOB_internal[3]), 
						    .DOB4(DOB_internal[4]), 
						    .DOB5(DOB_internal[5]), 
						    .DOB6(DOB_internal[6]), 
						    .DOB7(DOB_internal[7]),
						    .DOB8(DOB_internal[8]), 
						    .DOB9(DOB_internal[9]), 
						    .DOB10(DOB_internal[10]), 
						    .DOB11(DOB_internal[11]), 
						    .DOB12(DOB_internal[12]), 
						    .DOB13(DOB_internal[13]), 
						    .DOB14(DOB_internal[14]), 
						    .DOB15(DOB_internal[15]), 
						    .DOB16(DOB_internal[16]), 
						    .DOB17(DOB_internal[17]));



			defparam ram_36_inst_highbits.INITVAL_1F = INITVAL_1F_highbits ;
			defparam ram_36_inst_highbits.INITVAL_1E = INITVAL_1E_highbits ;
			defparam ram_36_inst_highbits.INITVAL_1D = INITVAL_1D_highbits ;
			defparam ram_36_inst_highbits.INITVAL_1C = INITVAL_1C_highbits ;
			defparam ram_36_inst_highbits.INITVAL_1B = INITVAL_1B_highbits ;
			defparam ram_36_inst_highbits.INITVAL_1A = INITVAL_1A_highbits ;
			defparam ram_36_inst_highbits.INITVAL_19 = INITVAL_19_highbits ;
			defparam ram_36_inst_highbits.INITVAL_18 = INITVAL_18_highbits ;
			defparam ram_36_inst_highbits.INITVAL_17 = INITVAL_17_highbits ;
			defparam ram_36_inst_highbits.INITVAL_16 = INITVAL_16_highbits ;
			defparam ram_36_inst_highbits.INITVAL_15 = INITVAL_15_highbits ;
			defparam ram_36_inst_highbits.INITVAL_14 = INITVAL_14_highbits ;
			defparam ram_36_inst_highbits.INITVAL_13 = INITVAL_13_highbits ;
			defparam ram_36_inst_highbits.INITVAL_12 = INITVAL_12_highbits ;
			defparam ram_36_inst_highbits.INITVAL_11 = INITVAL_11_highbits ;
			defparam ram_36_inst_highbits.INITVAL_10 = INITVAL_10_highbits ;
			defparam ram_36_inst_highbits.INITVAL_0F = INITVAL_0F_highbits ;
			defparam ram_36_inst_highbits.INITVAL_0E = INITVAL_0E_highbits ;
			defparam ram_36_inst_highbits.INITVAL_0D = INITVAL_0D_highbits ;
			defparam ram_36_inst_highbits.INITVAL_0C = INITVAL_0C_highbits ;
			defparam ram_36_inst_highbits.INITVAL_0B = INITVAL_0B_highbits ;
			defparam ram_36_inst_highbits.INITVAL_0A = INITVAL_0A_highbits ;
			defparam ram_36_inst_highbits.INITVAL_09 = INITVAL_09_highbits ;
			defparam ram_36_inst_highbits.INITVAL_08 = INITVAL_08_highbits ;
			defparam ram_36_inst_highbits.INITVAL_07 = INITVAL_07_highbits ;
			defparam ram_36_inst_highbits.INITVAL_06 = INITVAL_06_highbits ;
			defparam ram_36_inst_highbits.INITVAL_05 = INITVAL_05_highbits ;
			defparam ram_36_inst_highbits.INITVAL_04 = INITVAL_04_highbits ;
			defparam ram_36_inst_highbits.INITVAL_03 = INITVAL_03_highbits ;
			defparam ram_36_inst_highbits.INITVAL_02 = INITVAL_02_highbits ;
			defparam ram_36_inst_highbits.INITVAL_01 = INITVAL_01_highbits ;
			defparam ram_36_inst_highbits.INITVAL_00 = INITVAL_00_highbits ;
			defparam ram_36_inst_highbits.CSDECODE_A = "0b000" ;
			defparam ram_36_inst_highbits.CSDECODE_B = "0b000" ;
			defparam ram_36_inst_highbits.WRITEMODE_A = "WRITETHROUGH" ;
			defparam ram_36_inst_highbits.WRITEMODE_B = "READBEFOREWRITE" ;
			defparam ram_36_inst_highbits.GSR = "DISABLED" ;
 			defparam ram_36_inst_highbits.REGMODE_A = "NOREG" ;
			defparam ram_36_inst_highbits.REGMODE_B = "NOREG" ;
			defparam ram_36_inst_highbits.DATA_WIDTH_A = 18 ;
			defparam ram_36_inst_highbits.DATA_WIDTH_B = 18 ;
			DP16KC ram_36_inst_highbits (
						    .DIA0(DIA[18]), 
						    .DIA1(DIA[19]), 
						    .DIA2(DIA[20]), 
						    .DIA3(DIA[21]), 
						    .DIA4(DIA[22]), 
						    .DIA5(DIA[23]), 
						    .DIA6(DIA[24]), 
						    .DIA7(DIA[25]), 
						    .DIA8(DIA[26]), 
						    .DIA9(DIA[27]), 
						    .DIA10(DIA[28]), 
						    .DIA11(DIA[29]), 
						    .DIA12(DIA[30]), 
						    .DIA13(DIA[31]), 
						    .DIA14(DIA[32]), 
						    .DIA15(DIA[33]), 
						    .DIA16(DIA[34]), 
						    .DIA17(DIA[35]), 
						    .ADA0(scuba_vhi), 
						    .ADA1(scuba_vhi), 
						    .ADA2(scuba_vlo), 
						    .ADA3(scuba_vlo), 
						    .ADA4(ADDRA[0]), 
						    .ADA5(ADDRA[1]), 
						    .ADA6(ADDRA[2]), 
						    .ADA7(ADDRA[3]), 
						    .ADA8(ADDRA[4]), 
						    .ADA9(ADDRA[5]), 
						    .ADA10(ADDRA[6]), 
						    .ADA11(ADDRA[7]), 
						    .ADA12(ADDRA[8]), 
						    .ADA13(scuba_vlo), 
						    .CEA(ENA), 
						    .CLKA(CLKA), 
						    .OCEA(ENA), 
						    .WEA(WEA), 
						    .CSA0(scuba_vlo), 
						    .CSA1(scuba_vlo), 
						    .CSA2(scuba_vlo), 
						    .RSTA(scuba_vlo), 
						    .DIB0(DIB[18]), 
						    .DIB1(DIB[19]), 
						    .DIB2(DIB[20]), 
						    .DIB3(DIB[21]), 
						    .DIB4(DIB[22]), 
						    .DIB5(DIB[23]), 
						    .DIB6(DIB[24]), 
						    .DIB7(DIB[25]), 
						    .DIB8(DIB[26]), 
						    .DIB9(DIB[27]), 
						    .DIB10(DIB[28]), 
						    .DIB11(DIB[29]), 
						    .DIB12(DIB[30]), 
						    .DIB13(DIB[31]), 
						    .DIB14(DIB[32]), 
						    .DIB15(DIB[33]), 
						    .DIB16(DIB[34]), 
						    .DIB17(DIB[35]), 
						    .ADB0(scuba_vhi), 
						    .ADB1(scuba_vhi), 
						    .ADB2(scuba_vlo), 
						    .ADB3(scuba_vlo), 
						    .ADB4(ADDRB[0]), 
						    .ADB5(ADDRB[1]), 
						    .ADB6(ADDRB[2]), 
						    .ADB7(ADDRB[3]), 
						    .ADB8(ADDRB[4]), 
						    .ADB9(ADDRB[5]), 
						    .ADB10(ADDRB[6]), 
						    .ADB11(ADDRB[7]), 
						    .ADB12(ADDRB[8]), 
						    .ADB13(scuba_vlo), 
						    .CEB(ENB), 
						    .CLKB(CLKB), 
						    .OCEB(ENB), 
						    .WEB(WEB), 
						    .CSB0(scuba_vlo), 
						    .CSB1(scuba_vlo), 
						    .CSB2(scuba_vlo), 
						    .RSTB(scuba_vlo), 
						    .DOA0(DOA_internal[18]), 
						    .DOA1(DOA_internal[19]), 
						    .DOA2(DOA_internal[20]), 
						    .DOA3(DOA_internal[21]), 
						    .DOA4(DOA_internal[22]), 
						    .DOA5(DOA_internal[23]), 
						    .DOA6(DOA_internal[24]), 
						    .DOA7(DOA_internal[25]), 
						    .DOA8(DOA_internal[26]), 
						    .DOA9(DOA_internal[27]), 
						    .DOA10(DOA_internal[28]), 
						    .DOA11(DOA_internal[29]), 
						    .DOA12(DOA_internal[30]), 
						    .DOA13(DOA_internal[31]), 
						    .DOA14(DOA_internal[32]), 
						    .DOA15(DOA_internal[33]), 
						    .DOA16(DOA_internal[34]), 
						    .DOA17(DOA_internal[35]), 
						    .DOB0(DOB_internal[18]), 
						    .DOB1(DOB_internal[19]), 
						    .DOB2(DOB_internal[20]), 
						    .DOB3(DOB_internal[21]), 
						    .DOB4(DOB_internal[22]), 
						    .DOB5(DOB_internal[23]), 
						    .DOB6(DOB_internal[24]), 
						    .DOB7(DOB_internal[25]), 
						    .DOB8(DOB_internal[26]), 
						    .DOB9(DOB_internal[27]), 
						    .DOB10(DOB_internal[28]), 
						    .DOB11(DOB_internal[29]), 
						    .DOB12(DOB_internal[30]), 
						    .DOB13(DOB_internal[31]), 
						    .DOB14(DOB_internal[32]), 
						    .DOB15(DOB_internal[33]), 
						    .DOB16(DOB_internal[34]), 
						    .DOB17(DOB_internal[35]));

		end
		else if (WRITE_MODE_B == "NO_CHANGE")
		begin
		
			nochange_ssr_logic #(
            .WIDTH  (      36      ),
            .SRVAL  ( SRVAL_A      )
            ) nochange_ssr_logic_inst_a (
            .CLK    ( CLKA         ),
            .DO_in  ( DOA_internal ),
            .DO_out ( DOA          ),
            .EN     ( ENA          ),
            .WE     ( WEA          ),
            .SSR    ( SSRA         )
            );     
            
            nochange_ssr_logic #(
            .WIDTH  (      36      ),
            .SRVAL  ( SRVAL_B      )
            ) nochange_ssr_logic_inst_b (
            .CLK    ( CLKB         ),
            .DO_in  ( DOB_internal ),
            .DO_out ( DOB          ),
            .EN     ( ENB          ),
            .WE     ( WEB          ),
            .SSR    ( SSRB         )
            );   



			defparam ram_36_inst_lowbits.INITVAL_1F = INITVAL_1F_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_1E = INITVAL_1E_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_1D = INITVAL_1D_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_1C = INITVAL_1C_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_1B = INITVAL_1B_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_1A = INITVAL_1A_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_19 = INITVAL_19_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_18 = INITVAL_18_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_17 = INITVAL_17_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_16 = INITVAL_16_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_15 = INITVAL_15_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_14 = INITVAL_14_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_13 = INITVAL_13_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_12 = INITVAL_12_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_11 = INITVAL_11_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_10 = INITVAL_10_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_0F = INITVAL_0F_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_0E = INITVAL_0E_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_0D = INITVAL_0D_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_0C = INITVAL_0C_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_0B = INITVAL_0B_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_0A = INITVAL_0A_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_09 = INITVAL_09_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_08 = INITVAL_08_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_07 = INITVAL_07_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_06 = INITVAL_06_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_05 = INITVAL_05_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_04 = INITVAL_04_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_03 = INITVAL_03_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_02 = INITVAL_02_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_01 = INITVAL_01_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_00 = INITVAL_00_lowbits ;
			defparam ram_36_inst_lowbits.CSDECODE_A = "0b000" ;
			defparam ram_36_inst_lowbits.CSDECODE_B = "0b000" ;
			defparam ram_36_inst_lowbits.WRITEMODE_A = "WRITETHROUGH" ;
			defparam ram_36_inst_lowbits.WRITEMODE_B = "WRITETHROUGH" ;
			defparam ram_36_inst_lowbits.GSR = "DISABLED" ;
 			defparam ram_36_inst_lowbits.REGMODE_A = "NOREG" ;
			defparam ram_36_inst_lowbits.REGMODE_B = "NOREG" ;
			defparam ram_36_inst_lowbits.DATA_WIDTH_A = 18 ;
			defparam ram_36_inst_lowbits.DATA_WIDTH_B = 18 ;
			DP16KC ram_36_inst_lowbits (
						    .DIA0(DIA[0]), 
						    .DIA1(DIA[1]), 
						    .DIA2(DIA[2]), 
						    .DIA3(DIA[3]), 
						    .DIA4(DIA[4]), 
						    .DIA5(DIA[5]), 
						    .DIA6(DIA[6]), 
						    .DIA7(DIA[7]), 
						    .DIA8(DIA[8]), 
						    .DIA9(DIA[9]), 
						    .DIA10(DIA[10]), 
						    .DIA11(DIA[11]), 
						    .DIA12(DIA[12]), 
						    .DIA13(DIA[13]), 
						    .DIA14(DIA[14]), 
						    .DIA15(DIA[15]), 
						    .DIA16(DIA[16]), 
						    .DIA17(DIA[17]), 
						    .ADA0(scuba_vhi), 
						    .ADA1(scuba_vhi), 
						    .ADA2(scuba_vlo), 
						    .ADA3(scuba_vlo), 
						    .ADA4(ADDRA[0]), 
						    .ADA5(ADDRA[1]), 
						    .ADA6(ADDRA[2]), 
						    .ADA7(ADDRA[3]), 
						    .ADA8(ADDRA[4]), 
						    .ADA9(ADDRA[5]), 
						    .ADA10(ADDRA[6]), 
						    .ADA11(ADDRA[7]), 
						    .ADA12(ADDRA[8]), 
						    .ADA13(scuba_vlo), 
						    .CEA(ENA), 
						    .CLKA(CLKA), 
						    .OCEA(ENA), 
						    .WEA(WEA), 
						    .CSA0(scuba_vlo), 
						    .CSA1(scuba_vlo), 
						    .CSA2(scuba_vlo), 
						    .RSTA(scuba_vlo), 
						    .DIB0(DIB[0]), 
						    .DIB1(DIB[1]), 
						    .DIB2(DIB[2]), 
						    .DIB3(DIB[3]), 
						    .DIB4(DIB[4]), 
						    .DIB5(DIB[5]), 
						    .DIB6(DIB[6]), 
						    .DIB7(DIB[7]), 
						    .DIB8(DIB[8]), 
						    .DIB9(DIB[9]), 
						    .DIB10(DIB[10]), 
						    .DIB11(DIB[11]), 
						    .DIB12(DIB[12]), 
						    .DIB13(DIB[13]), 
						    .DIB14(DIB[14]), 
						    .DIB15(DIB[15]), 
						    .DIB16(DIB[16]), 
						    .DIB17(DIB[17]), 
						    .ADB0(scuba_vhi), 
						    .ADB1(scuba_vhi), 
						    .ADB2(scuba_vlo), 
						    .ADB3(scuba_vlo), 
						    .ADB4(ADDRB[0]), 
						    .ADB5(ADDRB[1]), 
						    .ADB6(ADDRB[2]), 
						    .ADB7(ADDRB[3]), 
						    .ADB8(ADDRB[4]), 
						    .ADB9(ADDRB[5]), 
						    .ADB10(ADDRB[6]), 
						    .ADB11(ADDRB[7]), 
						    .ADB12(ADDRB[8]), 
						    .ADB13(scuba_vlo), 
						    .CEB(ENB), 
						    .CLKB(CLKB), 
						    .OCEB(ENB), 
						    .WEB(WEB), 
						    .CSB0(scuba_vlo), 
						    .CSB1(scuba_vlo), 
						    .CSB2(scuba_vlo), 
						    .RSTB(scuba_vlo), 
						    .DOA0(DOA_internal[0]), 
						    .DOA1(DOA_internal[1]), 
						    .DOA2(DOA_internal[2]), 
						    .DOA3(DOA_internal[3]), 
						    .DOA4(DOA_internal[4]), 
						    .DOA5(DOA_internal[5]), 
						    .DOA6(DOA_internal[6]), 
						    .DOA7(DOA_internal[7]), 
						    .DOA8(DOA_internal[8]), 
						    .DOA9(DOA_internal[9]), 
						    .DOA10(DOA_internal[10]), 
						    .DOA11(DOA_internal[11]), 
						    .DOA12(DOA_internal[12]), 
						    .DOA13(DOA_internal[13]), 
						    .DOA14(DOA_internal[14]), 
						    .DOA15(DOA_internal[15]), 
						    .DOA16(DOA_internal[16]), 
						    .DOA17(DOA_internal[17]), 
						    .DOB0(DOB_internal[0]), 
						    .DOB1(DOB_internal[1]), 
						    .DOB2(DOB_internal[2]), 
						    .DOB3(DOB_internal[3]), 
						    .DOB4(DOB_internal[4]), 
						    .DOB5(DOB_internal[5]), 
						    .DOB6(DOB_internal[6]), 
						    .DOB7(DOB_internal[7]),
						    .DOB8(DOB_internal[8]), 
						    .DOB9(DOB_internal[9]), 
						    .DOB10(DOB_internal[10]), 
						    .DOB11(DOB_internal[11]), 
						    .DOB12(DOB_internal[12]), 
						    .DOB13(DOB_internal[13]), 
						    .DOB14(DOB_internal[14]), 
						    .DOB15(DOB_internal[15]), 
						    .DOB16(DOB_internal[16]), 
						    .DOB17(DOB_internal[17]));



			defparam ram_36_inst_highbits.INITVAL_1F = INITVAL_1F_highbits ;
			defparam ram_36_inst_highbits.INITVAL_1E = INITVAL_1E_highbits ;
			defparam ram_36_inst_highbits.INITVAL_1D = INITVAL_1D_highbits ;
			defparam ram_36_inst_highbits.INITVAL_1C = INITVAL_1C_highbits ;
			defparam ram_36_inst_highbits.INITVAL_1B = INITVAL_1B_highbits ;
			defparam ram_36_inst_highbits.INITVAL_1A = INITVAL_1A_highbits ;
			defparam ram_36_inst_highbits.INITVAL_19 = INITVAL_19_highbits ;
			defparam ram_36_inst_highbits.INITVAL_18 = INITVAL_18_highbits ;
			defparam ram_36_inst_highbits.INITVAL_17 = INITVAL_17_highbits ;
			defparam ram_36_inst_highbits.INITVAL_16 = INITVAL_16_highbits ;
			defparam ram_36_inst_highbits.INITVAL_15 = INITVAL_15_highbits ;
			defparam ram_36_inst_highbits.INITVAL_14 = INITVAL_14_highbits ;
			defparam ram_36_inst_highbits.INITVAL_13 = INITVAL_13_highbits ;
			defparam ram_36_inst_highbits.INITVAL_12 = INITVAL_12_highbits ;
			defparam ram_36_inst_highbits.INITVAL_11 = INITVAL_11_highbits ;
			defparam ram_36_inst_highbits.INITVAL_10 = INITVAL_10_highbits ;
			defparam ram_36_inst_highbits.INITVAL_0F = INITVAL_0F_highbits ;
			defparam ram_36_inst_highbits.INITVAL_0E = INITVAL_0E_highbits ;
			defparam ram_36_inst_highbits.INITVAL_0D = INITVAL_0D_highbits ;
			defparam ram_36_inst_highbits.INITVAL_0C = INITVAL_0C_highbits ;
			defparam ram_36_inst_highbits.INITVAL_0B = INITVAL_0B_highbits ;
			defparam ram_36_inst_highbits.INITVAL_0A = INITVAL_0A_highbits ;
			defparam ram_36_inst_highbits.INITVAL_09 = INITVAL_09_highbits ;
			defparam ram_36_inst_highbits.INITVAL_08 = INITVAL_08_highbits ;
			defparam ram_36_inst_highbits.INITVAL_07 = INITVAL_07_highbits ;
			defparam ram_36_inst_highbits.INITVAL_06 = INITVAL_06_highbits ;
			defparam ram_36_inst_highbits.INITVAL_05 = INITVAL_05_highbits ;
			defparam ram_36_inst_highbits.INITVAL_04 = INITVAL_04_highbits ;
			defparam ram_36_inst_highbits.INITVAL_03 = INITVAL_03_highbits ;
			defparam ram_36_inst_highbits.INITVAL_02 = INITVAL_02_highbits ;
			defparam ram_36_inst_highbits.INITVAL_01 = INITVAL_01_highbits ;
			defparam ram_36_inst_highbits.INITVAL_00 = INITVAL_00_highbits ;
			defparam ram_36_inst_highbits.CSDECODE_A = "0b000" ;
			defparam ram_36_inst_highbits.CSDECODE_B = "0b000" ;
			defparam ram_36_inst_highbits.WRITEMODE_A = "WRITETHROUGH" ;
			defparam ram_36_inst_highbits.WRITEMODE_B = "WRITETHROUGH" ;
			defparam ram_36_inst_highbits.GSR = "DISABLED" ;
 			defparam ram_36_inst_highbits.REGMODE_A = "NOREG" ;
			defparam ram_36_inst_highbits.REGMODE_B = "NOREG" ;
			defparam ram_36_inst_highbits.DATA_WIDTH_A = 18 ;
			defparam ram_36_inst_highbits.DATA_WIDTH_B = 18 ;
			DP16KC ram_36_inst_highbits (
						    .DIA0(DIA[18]), 
						    .DIA1(DIA[19]), 
						    .DIA2(DIA[20]), 
						    .DIA3(DIA[21]), 
						    .DIA4(DIA[22]), 
						    .DIA5(DIA[23]), 
						    .DIA6(DIA[24]), 
						    .DIA7(DIA[25]), 
						    .DIA8(DIA[26]), 
						    .DIA9(DIA[27]), 
						    .DIA10(DIA[28]), 
						    .DIA11(DIA[29]), 
						    .DIA12(DIA[30]), 
						    .DIA13(DIA[31]), 
						    .DIA14(DIA[32]), 
						    .DIA15(DIA[33]), 
						    .DIA16(DIA[34]), 
						    .DIA17(DIA[35]), 
						    .ADA0(scuba_vhi), 
						    .ADA1(scuba_vhi), 
						    .ADA2(scuba_vlo), 
						    .ADA3(scuba_vlo), 
						    .ADA4(ADDRA[0]), 
						    .ADA5(ADDRA[1]), 
						    .ADA6(ADDRA[2]), 
						    .ADA7(ADDRA[3]), 
						    .ADA8(ADDRA[4]), 
						    .ADA9(ADDRA[5]), 
						    .ADA10(ADDRA[6]), 
						    .ADA11(ADDRA[7]), 
						    .ADA12(ADDRA[8]), 
						    .ADA13(scuba_vlo), 
						    .CEA(ENA), 
						    .CLKA(CLKA), 
						    .OCEA(ENA), 
						    .WEA(WEA), 
						    .CSA0(scuba_vlo), 
						    .CSA1(scuba_vlo), 
						    .CSA2(scuba_vlo), 
						    .RSTA(scuba_vlo), 
						    .DIB0(DIB[18]), 
						    .DIB1(DIB[19]), 
						    .DIB2(DIB[20]), 
						    .DIB3(DIB[21]), 
						    .DIB4(DIB[22]), 
						    .DIB5(DIB[23]), 
						    .DIB6(DIB[24]), 
						    .DIB7(DIB[25]), 
						    .DIB8(DIB[26]), 
						    .DIB9(DIB[27]), 
						    .DIB10(DIB[28]), 
						    .DIB11(DIB[29]), 
						    .DIB12(DIB[30]), 
						    .DIB13(DIB[31]), 
						    .DIB14(DIB[32]), 
						    .DIB15(DIB[33]), 
						    .DIB16(DIB[34]), 
						    .DIB17(DIB[35]), 
						    .ADB0(scuba_vhi), 
						    .ADB1(scuba_vhi), 
						    .ADB2(scuba_vlo), 
						    .ADB3(scuba_vlo), 
						    .ADB4(ADDRB[0]), 
						    .ADB5(ADDRB[1]), 
						    .ADB6(ADDRB[2]), 
						    .ADB7(ADDRB[3]), 
						    .ADB8(ADDRB[4]), 
						    .ADB9(ADDRB[5]), 
						    .ADB10(ADDRB[6]), 
						    .ADB11(ADDRB[7]), 
						    .ADB12(ADDRB[8]), 
						    .ADB13(scuba_vlo), 
						    .CEB(ENB), 
						    .CLKB(CLKB), 
						    .OCEB(ENB), 
						    .WEB(WEB), 
						    .CSB0(scuba_vlo), 
						    .CSB1(scuba_vlo), 
						    .CSB2(scuba_vlo), 
						    .RSTB(scuba_vlo), 
						    .DOA0(DOA_internal[18]), 
						    .DOA1(DOA_internal[19]), 
						    .DOA2(DOA_internal[20]), 
						    .DOA3(DOA_internal[21]), 
						    .DOA4(DOA_internal[22]), 
						    .DOA5(DOA_internal[23]), 
						    .DOA6(DOA_internal[24]), 
						    .DOA7(DOA_internal[25]), 
						    .DOA8(DOA_internal[26]), 
						    .DOA9(DOA_internal[27]), 
						    .DOA10(DOA_internal[28]), 
						    .DOA11(DOA_internal[29]), 
						    .DOA12(DOA_internal[30]), 
						    .DOA13(DOA_internal[31]), 
						    .DOA14(DOA_internal[32]), 
						    .DOA15(DOA_internal[33]), 
						    .DOA16(DOA_internal[34]), 
						    .DOA17(DOA_internal[35]), 
						    .DOB0(DOB_internal[18]), 
						    .DOB1(DOB_internal[19]), 
						    .DOB2(DOB_internal[20]), 
						    .DOB3(DOB_internal[21]), 
						    .DOB4(DOB_internal[22]), 
						    .DOB5(DOB_internal[23]), 
						    .DOB6(DOB_internal[24]), 
						    .DOB7(DOB_internal[25]), 
						    .DOB8(DOB_internal[26]), 
						    .DOB9(DOB_internal[27]), 
						    .DOB10(DOB_internal[28]), 
						    .DOB11(DOB_internal[29]), 
						    .DOB12(DOB_internal[30]), 
						    .DOB13(DOB_internal[31]), 
						    .DOB14(DOB_internal[32]), 
						    .DOB15(DOB_internal[33]), 
						    .DOB16(DOB_internal[34]), 
						    .DOB17(DOB_internal[35]));

		end
		else
		begin
		
			nochange_ssr_logic #(
            .WIDTH  (      36      ),
            .SRVAL  ( SRVAL_A      )
            ) nochange_ssr_logic_inst_a (
            .CLK    ( CLKA         ),
            .DO_in  ( DOA_internal ),
            .DO_out ( DOA          ),
            .EN     ( ENA          ),
            .WE     ( WEA          ),
            .SSR    ( SSRA         )
            );     
            
            ssr_logic #(
            .WIDTH  (      36      ),
            .SRVAL  ( SRVAL_B      )
            ) ssr_logic_inst_b (
            .CLK    ( CLKB         ),
            .DO_in  ( DOB_internal ),
            .DO_out ( DOB          ),
            .EN     ( ENB          ),
            .SSR    ( SSRB         )
            );



			defparam ram_36_inst_lowbits.INITVAL_1F = INITVAL_1F_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_1E = INITVAL_1E_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_1D = INITVAL_1D_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_1C = INITVAL_1C_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_1B = INITVAL_1B_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_1A = INITVAL_1A_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_19 = INITVAL_19_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_18 = INITVAL_18_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_17 = INITVAL_17_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_16 = INITVAL_16_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_15 = INITVAL_15_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_14 = INITVAL_14_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_13 = INITVAL_13_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_12 = INITVAL_12_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_11 = INITVAL_11_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_10 = INITVAL_10_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_0F = INITVAL_0F_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_0E = INITVAL_0E_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_0D = INITVAL_0D_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_0C = INITVAL_0C_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_0B = INITVAL_0B_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_0A = INITVAL_0A_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_09 = INITVAL_09_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_08 = INITVAL_08_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_07 = INITVAL_07_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_06 = INITVAL_06_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_05 = INITVAL_05_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_04 = INITVAL_04_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_03 = INITVAL_03_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_02 = INITVAL_02_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_01 = INITVAL_01_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_00 = INITVAL_00_lowbits ;
			defparam ram_36_inst_lowbits.CSDECODE_A = "0b000" ;
			defparam ram_36_inst_lowbits.CSDECODE_B = "0b000" ;
			defparam ram_36_inst_lowbits.WRITEMODE_A = "WRITETHROUGH" ;
			defparam ram_36_inst_lowbits.WRITEMODE_B = "WRITETHROUGH" ;
			defparam ram_36_inst_lowbits.GSR = "DISABLED" ;
 			defparam ram_36_inst_lowbits.REGMODE_A = "NOREG" ;
			defparam ram_36_inst_lowbits.REGMODE_B = "NOREG" ;
			defparam ram_36_inst_lowbits.DATA_WIDTH_A = 18 ;
			defparam ram_36_inst_lowbits.DATA_WIDTH_B = 18 ;
			DP16KC ram_36_inst_lowbits (
						    .DIA0(DIA[0]), 
						    .DIA1(DIA[1]), 
						    .DIA2(DIA[2]), 
						    .DIA3(DIA[3]), 
						    .DIA4(DIA[4]), 
						    .DIA5(DIA[5]), 
						    .DIA6(DIA[6]), 
						    .DIA7(DIA[7]), 
						    .DIA8(DIA[8]), 
						    .DIA9(DIA[9]), 
						    .DIA10(DIA[10]), 
						    .DIA11(DIA[11]), 
						    .DIA12(DIA[12]), 
						    .DIA13(DIA[13]), 
						    .DIA14(DIA[14]), 
						    .DIA15(DIA[15]), 
						    .DIA16(DIA[16]), 
						    .DIA17(DIA[17]), 
						    .ADA0(scuba_vhi), 
						    .ADA1(scuba_vhi), 
						    .ADA2(scuba_vlo), 
						    .ADA3(scuba_vlo), 
						    .ADA4(ADDRA[0]), 
						    .ADA5(ADDRA[1]), 
						    .ADA6(ADDRA[2]), 
						    .ADA7(ADDRA[3]), 
						    .ADA8(ADDRA[4]), 
						    .ADA9(ADDRA[5]), 
						    .ADA10(ADDRA[6]), 
						    .ADA11(ADDRA[7]), 
						    .ADA12(ADDRA[8]), 
						    .ADA13(scuba_vlo), 
						    .CEA(ENA), 
						    .CLKA(CLKA), 
						    .OCEA(ENA), 
						    .WEA(WEA), 
						    .CSA0(scuba_vlo), 
						    .CSA1(scuba_vlo), 
						    .CSA2(scuba_vlo), 
						    .RSTA(scuba_vlo), 
						    .DIB0(DIB[0]), 
						    .DIB1(DIB[1]), 
						    .DIB2(DIB[2]), 
						    .DIB3(DIB[3]), 
						    .DIB4(DIB[4]), 
						    .DIB5(DIB[5]), 
						    .DIB6(DIB[6]), 
						    .DIB7(DIB[7]), 
						    .DIB8(DIB[8]), 
						    .DIB9(DIB[9]), 
						    .DIB10(DIB[10]), 
						    .DIB11(DIB[11]), 
						    .DIB12(DIB[12]), 
						    .DIB13(DIB[13]), 
						    .DIB14(DIB[14]), 
						    .DIB15(DIB[15]), 
						    .DIB16(DIB[16]), 
						    .DIB17(DIB[17]), 
						    .ADB0(scuba_vhi), 
						    .ADB1(scuba_vhi), 
						    .ADB2(scuba_vlo), 
						    .ADB3(scuba_vlo), 
						    .ADB4(ADDRB[0]), 
						    .ADB5(ADDRB[1]), 
						    .ADB6(ADDRB[2]), 
						    .ADB7(ADDRB[3]), 
						    .ADB8(ADDRB[4]), 
						    .ADB9(ADDRB[5]), 
						    .ADB10(ADDRB[6]), 
						    .ADB11(ADDRB[7]), 
						    .ADB12(ADDRB[8]), 
						    .ADB13(scuba_vlo), 
						    .CEB(ENB), 
						    .CLKB(CLKB), 
						    .OCEB(ENB), 
						    .WEB(WEB), 
						    .CSB0(scuba_vlo), 
						    .CSB1(scuba_vlo), 
						    .CSB2(scuba_vlo), 
						    .RSTB(scuba_vlo), 
						    .DOA0(DOA_internal[0]), 
						    .DOA1(DOA_internal[1]), 
						    .DOA2(DOA_internal[2]), 
						    .DOA3(DOA_internal[3]), 
						    .DOA4(DOA_internal[4]), 
						    .DOA5(DOA_internal[5]), 
						    .DOA6(DOA_internal[6]), 
						    .DOA7(DOA_internal[7]), 
						    .DOA8(DOA_internal[8]), 
						    .DOA9(DOA_internal[9]), 
						    .DOA10(DOA_internal[10]), 
						    .DOA11(DOA_internal[11]), 
						    .DOA12(DOA_internal[12]), 
						    .DOA13(DOA_internal[13]), 
						    .DOA14(DOA_internal[14]), 
						    .DOA15(DOA_internal[15]), 
						    .DOA16(DOA_internal[16]), 
						    .DOA17(DOA_internal[17]), 
						    .DOB0(DOB_internal[0]), 
						    .DOB1(DOB_internal[1]), 
						    .DOB2(DOB_internal[2]), 
						    .DOB3(DOB_internal[3]), 
						    .DOB4(DOB_internal[4]), 
						    .DOB5(DOB_internal[5]), 
						    .DOB6(DOB_internal[6]), 
						    .DOB7(DOB_internal[7]),
						    .DOB8(DOB_internal[8]), 
						    .DOB9(DOB_internal[9]), 
						    .DOB10(DOB_internal[10]), 
						    .DOB11(DOB_internal[11]), 
						    .DOB12(DOB_internal[12]), 
						    .DOB13(DOB_internal[13]), 
						    .DOB14(DOB_internal[14]), 
						    .DOB15(DOB_internal[15]), 
						    .DOB16(DOB_internal[16]), 
						    .DOB17(DOB_internal[17]));



			defparam ram_36_inst_highbits.INITVAL_1F = INITVAL_1F_highbits ;
			defparam ram_36_inst_highbits.INITVAL_1E = INITVAL_1E_highbits ;
			defparam ram_36_inst_highbits.INITVAL_1D = INITVAL_1D_highbits ;
			defparam ram_36_inst_highbits.INITVAL_1C = INITVAL_1C_highbits ;
			defparam ram_36_inst_highbits.INITVAL_1B = INITVAL_1B_highbits ;
			defparam ram_36_inst_highbits.INITVAL_1A = INITVAL_1A_highbits ;
			defparam ram_36_inst_highbits.INITVAL_19 = INITVAL_19_highbits ;
			defparam ram_36_inst_highbits.INITVAL_18 = INITVAL_18_highbits ;
			defparam ram_36_inst_highbits.INITVAL_17 = INITVAL_17_highbits ;
			defparam ram_36_inst_highbits.INITVAL_16 = INITVAL_16_highbits ;
			defparam ram_36_inst_highbits.INITVAL_15 = INITVAL_15_highbits ;
			defparam ram_36_inst_highbits.INITVAL_14 = INITVAL_14_highbits ;
			defparam ram_36_inst_highbits.INITVAL_13 = INITVAL_13_highbits ;
			defparam ram_36_inst_highbits.INITVAL_12 = INITVAL_12_highbits ;
			defparam ram_36_inst_highbits.INITVAL_11 = INITVAL_11_highbits ;
			defparam ram_36_inst_highbits.INITVAL_10 = INITVAL_10_highbits ;
			defparam ram_36_inst_highbits.INITVAL_0F = INITVAL_0F_highbits ;
			defparam ram_36_inst_highbits.INITVAL_0E = INITVAL_0E_highbits ;
			defparam ram_36_inst_highbits.INITVAL_0D = INITVAL_0D_highbits ;
			defparam ram_36_inst_highbits.INITVAL_0C = INITVAL_0C_highbits ;
			defparam ram_36_inst_highbits.INITVAL_0B = INITVAL_0B_highbits ;
			defparam ram_36_inst_highbits.INITVAL_0A = INITVAL_0A_highbits ;
			defparam ram_36_inst_highbits.INITVAL_09 = INITVAL_09_highbits ;
			defparam ram_36_inst_highbits.INITVAL_08 = INITVAL_08_highbits ;
			defparam ram_36_inst_highbits.INITVAL_07 = INITVAL_07_highbits ;
			defparam ram_36_inst_highbits.INITVAL_06 = INITVAL_06_highbits ;
			defparam ram_36_inst_highbits.INITVAL_05 = INITVAL_05_highbits ;
			defparam ram_36_inst_highbits.INITVAL_04 = INITVAL_04_highbits ;
			defparam ram_36_inst_highbits.INITVAL_03 = INITVAL_03_highbits ;
			defparam ram_36_inst_highbits.INITVAL_02 = INITVAL_02_highbits ;
			defparam ram_36_inst_highbits.INITVAL_01 = INITVAL_01_highbits ;
			defparam ram_36_inst_highbits.INITVAL_00 = INITVAL_00_highbits ;
			defparam ram_36_inst_highbits.CSDECODE_A = "0b000" ;
			defparam ram_36_inst_highbits.CSDECODE_B = "0b000" ;
			defparam ram_36_inst_highbits.WRITEMODE_A = "WRITETHROUGH" ;
			defparam ram_36_inst_highbits.WRITEMODE_B = "WRITETHROUGH" ;
			defparam ram_36_inst_highbits.GSR = "DISABLED" ;
 			defparam ram_36_inst_highbits.REGMODE_A = "NOREG" ;
			defparam ram_36_inst_highbits.REGMODE_B = "NOREG" ;
			defparam ram_36_inst_highbits.DATA_WIDTH_A = 18 ;
			defparam ram_36_inst_highbits.DATA_WIDTH_B = 18 ;
			DP16KC ram_36_inst_highbits (
						    .DIA0(DIA[18]), 
						    .DIA1(DIA[19]), 
						    .DIA2(DIA[20]), 
						    .DIA3(DIA[21]), 
						    .DIA4(DIA[22]), 
						    .DIA5(DIA[23]), 
						    .DIA6(DIA[24]), 
						    .DIA7(DIA[25]), 
						    .DIA8(DIA[26]), 
						    .DIA9(DIA[27]), 
						    .DIA10(DIA[28]), 
						    .DIA11(DIA[29]), 
						    .DIA12(DIA[30]), 
						    .DIA13(DIA[31]), 
						    .DIA14(DIA[32]), 
						    .DIA15(DIA[33]), 
						    .DIA16(DIA[34]), 
						    .DIA17(DIA[35]), 
						    .ADA0(scuba_vhi), 
						    .ADA1(scuba_vhi), 
						    .ADA2(scuba_vlo), 
						    .ADA3(scuba_vlo), 
						    .ADA4(ADDRA[0]), 
						    .ADA5(ADDRA[1]), 
						    .ADA6(ADDRA[2]), 
						    .ADA7(ADDRA[3]), 
						    .ADA8(ADDRA[4]), 
						    .ADA9(ADDRA[5]), 
						    .ADA10(ADDRA[6]), 
						    .ADA11(ADDRA[7]), 
						    .ADA12(ADDRA[8]), 
						    .ADA13(scuba_vlo), 
						    .CEA(ENA), 
						    .CLKA(CLKA), 
						    .OCEA(ENA), 
						    .WEA(WEA), 
						    .CSA0(scuba_vlo), 
						    .CSA1(scuba_vlo), 
						    .CSA2(scuba_vlo), 
						    .RSTA(scuba_vlo), 
						    .DIB0(DIB[18]), 
						    .DIB1(DIB[19]), 
						    .DIB2(DIB[20]), 
						    .DIB3(DIB[21]), 
						    .DIB4(DIB[22]), 
						    .DIB5(DIB[23]), 
						    .DIB6(DIB[24]), 
						    .DIB7(DIB[25]), 
						    .DIB8(DIB[26]), 
						    .DIB9(DIB[27]), 
						    .DIB10(DIB[28]), 
						    .DIB11(DIB[29]), 
						    .DIB12(DIB[30]), 
						    .DIB13(DIB[31]), 
						    .DIB14(DIB[32]), 
						    .DIB15(DIB[33]), 
						    .DIB16(DIB[34]), 
						    .DIB17(DIB[35]), 
						    .ADB0(scuba_vhi), 
						    .ADB1(scuba_vhi), 
						    .ADB2(scuba_vlo), 
						    .ADB3(scuba_vlo), 
						    .ADB4(ADDRB[0]), 
						    .ADB5(ADDRB[1]), 
						    .ADB6(ADDRB[2]), 
						    .ADB7(ADDRB[3]), 
						    .ADB8(ADDRB[4]), 
						    .ADB9(ADDRB[5]), 
						    .ADB10(ADDRB[6]), 
						    .ADB11(ADDRB[7]), 
						    .ADB12(ADDRB[8]), 
						    .ADB13(scuba_vlo), 
						    .CEB(ENB), 
						    .CLKB(CLKB), 
						    .OCEB(ENB), 
						    .WEB(WEB), 
						    .CSB0(scuba_vlo), 
						    .CSB1(scuba_vlo), 
						    .CSB2(scuba_vlo), 
						    .RSTB(scuba_vlo), 
						    .DOA0(DOA_internal[18]), 
						    .DOA1(DOA_internal[19]), 
						    .DOA2(DOA_internal[20]), 
						    .DOA3(DOA_internal[21]), 
						    .DOA4(DOA_internal[22]), 
						    .DOA5(DOA_internal[23]), 
						    .DOA6(DOA_internal[24]), 
						    .DOA7(DOA_internal[25]), 
						    .DOA8(DOA_internal[26]), 
						    .DOA9(DOA_internal[27]), 
						    .DOA10(DOA_internal[28]), 
						    .DOA11(DOA_internal[29]), 
						    .DOA12(DOA_internal[30]), 
						    .DOA13(DOA_internal[31]), 
						    .DOA14(DOA_internal[32]), 
						    .DOA15(DOA_internal[33]), 
						    .DOA16(DOA_internal[34]), 
						    .DOA17(DOA_internal[35]), 
						    .DOB0(DOB_internal[18]), 
						    .DOB1(DOB_internal[19]), 
						    .DOB2(DOB_internal[20]), 
						    .DOB3(DOB_internal[21]), 
						    .DOB4(DOB_internal[22]), 
						    .DOB5(DOB_internal[23]), 
						    .DOB6(DOB_internal[24]), 
						    .DOB7(DOB_internal[25]), 
						    .DOB8(DOB_internal[26]), 
						    .DOB9(DOB_internal[27]), 
						    .DOB10(DOB_internal[28]), 
						    .DOB11(DOB_internal[29]), 
						    .DOB12(DOB_internal[30]), 
						    .DOB13(DOB_internal[31]), 
						    .DOB14(DOB_internal[32]), 
						    .DOB15(DOB_internal[33]), 
						    .DOB16(DOB_internal[34]), 
						    .DOB17(DOB_internal[35]));

		end

	end
	
	// end port a = NO_CHANGE

	// begin port a = invalid (port a defaults to WRITE_FIRST)


	else
	begin
	
			if (WRITE_MODE_B == "WRITE_FIRST")
		begin
		
            ssr_logic #(
            .WIDTH  (      36      ),
            .SRVAL  ( SRVAL_A      )
            ) ssr_logic_inst_a (
            .CLK    ( CLKA         ),
            .DO_in  ( DOA_internal ),
            .DO_out ( DOA          ),
            .EN     ( ENA          ),
            .SSR    ( SSRA         )
            );   
            
            ssr_logic #(
            .WIDTH  (      36      ),
            .SRVAL  ( SRVAL_B      )
            ) ssr_logic_inst_b (
            .CLK    ( CLKB         ),
            .DO_in  ( DOB_internal ),
            .DO_out ( DOB          ),
            .EN     ( ENB          ),
            .SSR    ( SSRB         )
            );   
		


			defparam ram_36_inst_lowbits.INITVAL_1F = INITVAL_1F_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_1E = INITVAL_1E_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_1D = INITVAL_1D_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_1C = INITVAL_1C_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_1B = INITVAL_1B_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_1A = INITVAL_1A_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_19 = INITVAL_19_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_18 = INITVAL_18_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_17 = INITVAL_17_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_16 = INITVAL_16_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_15 = INITVAL_15_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_14 = INITVAL_14_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_13 = INITVAL_13_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_12 = INITVAL_12_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_11 = INITVAL_11_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_10 = INITVAL_10_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_0F = INITVAL_0F_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_0E = INITVAL_0E_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_0D = INITVAL_0D_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_0C = INITVAL_0C_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_0B = INITVAL_0B_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_0A = INITVAL_0A_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_09 = INITVAL_09_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_08 = INITVAL_08_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_07 = INITVAL_07_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_06 = INITVAL_06_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_05 = INITVAL_05_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_04 = INITVAL_04_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_03 = INITVAL_03_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_02 = INITVAL_02_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_01 = INITVAL_01_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_00 = INITVAL_00_lowbits ;
			defparam ram_36_inst_lowbits.CSDECODE_A = "0b000" ;
			defparam ram_36_inst_lowbits.CSDECODE_B = "0b000" ;
			defparam ram_36_inst_lowbits.WRITEMODE_A = "WRITETHROUGH" ;
			defparam ram_36_inst_lowbits.WRITEMODE_B = "WRITETHROUGH" ;
			defparam ram_36_inst_lowbits.GSR = "DISABLED" ;
 			defparam ram_36_inst_lowbits.REGMODE_A = "NOREG" ;
			defparam ram_36_inst_lowbits.REGMODE_B = "NOREG" ;
			defparam ram_36_inst_lowbits.DATA_WIDTH_A = 18 ;
			defparam ram_36_inst_lowbits.DATA_WIDTH_B = 18 ;
			DP16KC ram_36_inst_lowbits (
						    .DIA0(DIA[0]), 
						    .DIA1(DIA[1]), 
						    .DIA2(DIA[2]), 
						    .DIA3(DIA[3]), 
						    .DIA4(DIA[4]), 
						    .DIA5(DIA[5]), 
						    .DIA6(DIA[6]), 
						    .DIA7(DIA[7]), 
						    .DIA8(DIA[8]), 
						    .DIA9(DIA[9]), 
						    .DIA10(DIA[10]), 
						    .DIA11(DIA[11]), 
						    .DIA12(DIA[12]), 
						    .DIA13(DIA[13]), 
						    .DIA14(DIA[14]), 
						    .DIA15(DIA[15]), 
						    .DIA16(DIA[16]), 
						    .DIA17(DIA[17]), 
						    .ADA0(scuba_vhi), 
						    .ADA1(scuba_vhi), 
						    .ADA2(scuba_vlo), 
						    .ADA3(scuba_vlo), 
						    .ADA4(ADDRA[0]), 
						    .ADA5(ADDRA[1]), 
						    .ADA6(ADDRA[2]), 
						    .ADA7(ADDRA[3]), 
						    .ADA8(ADDRA[4]), 
						    .ADA9(ADDRA[5]), 
						    .ADA10(ADDRA[6]), 
						    .ADA11(ADDRA[7]), 
						    .ADA12(ADDRA[8]), 
						    .ADA13(scuba_vlo), 
						    .CEA(ENA), 
						    .CLKA(CLKA), 
						    .OCEA(ENA), 
						    .WEA(WEA), 
						    .CSA0(scuba_vlo), 
						    .CSA1(scuba_vlo), 
						    .CSA2(scuba_vlo), 
						    .RSTA(scuba_vlo), 
						    .DIB0(DIB[0]), 
						    .DIB1(DIB[1]), 
						    .DIB2(DIB[2]), 
						    .DIB3(DIB[3]), 
						    .DIB4(DIB[4]), 
						    .DIB5(DIB[5]), 
						    .DIB6(DIB[6]), 
						    .DIB7(DIB[7]), 
						    .DIB8(DIB[8]), 
						    .DIB9(DIB[9]), 
						    .DIB10(DIB[10]), 
						    .DIB11(DIB[11]), 
						    .DIB12(DIB[12]), 
						    .DIB13(DIB[13]), 
						    .DIB14(DIB[14]), 
						    .DIB15(DIB[15]), 
						    .DIB16(DIB[16]), 
						    .DIB17(DIB[17]), 
						    .ADB0(scuba_vhi), 
						    .ADB1(scuba_vhi), 
						    .ADB2(scuba_vlo), 
						    .ADB3(scuba_vlo), 
						    .ADB4(ADDRB[0]), 
						    .ADB5(ADDRB[1]), 
						    .ADB6(ADDRB[2]), 
						    .ADB7(ADDRB[3]), 
						    .ADB8(ADDRB[4]), 
						    .ADB9(ADDRB[5]), 
						    .ADB10(ADDRB[6]), 
						    .ADB11(ADDRB[7]), 
						    .ADB12(ADDRB[8]), 
						    .ADB13(scuba_vlo), 
						    .CEB(ENB), 
						    .CLKB(CLKB), 
						    .OCEB(ENB), 
						    .WEB(WEB), 
						    .CSB0(scuba_vlo), 
						    .CSB1(scuba_vlo), 
						    .CSB2(scuba_vlo), 
						    .RSTB(scuba_vlo), 
						    .DOA0(DOA_internal[0]), 
						    .DOA1(DOA_internal[1]), 
						    .DOA2(DOA_internal[2]), 
						    .DOA3(DOA_internal[3]), 
						    .DOA4(DOA_internal[4]), 
						    .DOA5(DOA_internal[5]), 
						    .DOA6(DOA_internal[6]), 
						    .DOA7(DOA_internal[7]), 
						    .DOA8(DOA_internal[8]), 
						    .DOA9(DOA_internal[9]), 
						    .DOA10(DOA_internal[10]), 
						    .DOA11(DOA_internal[11]), 
						    .DOA12(DOA_internal[12]), 
						    .DOA13(DOA_internal[13]), 
						    .DOA14(DOA_internal[14]), 
						    .DOA15(DOA_internal[15]), 
						    .DOA16(DOA_internal[16]), 
						    .DOA17(DOA_internal[17]), 
						    .DOB0(DOB_internal[0]), 
						    .DOB1(DOB_internal[1]), 
						    .DOB2(DOB_internal[2]), 
						    .DOB3(DOB_internal[3]), 
						    .DOB4(DOB_internal[4]), 
						    .DOB5(DOB_internal[5]), 
						    .DOB6(DOB_internal[6]), 
						    .DOB7(DOB_internal[7]),
						    .DOB8(DOB_internal[8]), 
						    .DOB9(DOB_internal[9]), 
						    .DOB10(DOB_internal[10]), 
						    .DOB11(DOB_internal[11]), 
						    .DOB12(DOB_internal[12]), 
						    .DOB13(DOB_internal[13]), 
						    .DOB14(DOB_internal[14]), 
						    .DOB15(DOB_internal[15]), 
						    .DOB16(DOB_internal[16]), 
						    .DOB17(DOB_internal[17]));



			defparam ram_36_inst_highbits.INITVAL_1F = INITVAL_1F_highbits ;
			defparam ram_36_inst_highbits.INITVAL_1E = INITVAL_1E_highbits ;
			defparam ram_36_inst_highbits.INITVAL_1D = INITVAL_1D_highbits ;
			defparam ram_36_inst_highbits.INITVAL_1C = INITVAL_1C_highbits ;
			defparam ram_36_inst_highbits.INITVAL_1B = INITVAL_1B_highbits ;
			defparam ram_36_inst_highbits.INITVAL_1A = INITVAL_1A_highbits ;
			defparam ram_36_inst_highbits.INITVAL_19 = INITVAL_19_highbits ;
			defparam ram_36_inst_highbits.INITVAL_18 = INITVAL_18_highbits ;
			defparam ram_36_inst_highbits.INITVAL_17 = INITVAL_17_highbits ;
			defparam ram_36_inst_highbits.INITVAL_16 = INITVAL_16_highbits ;
			defparam ram_36_inst_highbits.INITVAL_15 = INITVAL_15_highbits ;
			defparam ram_36_inst_highbits.INITVAL_14 = INITVAL_14_highbits ;
			defparam ram_36_inst_highbits.INITVAL_13 = INITVAL_13_highbits ;
			defparam ram_36_inst_highbits.INITVAL_12 = INITVAL_12_highbits ;
			defparam ram_36_inst_highbits.INITVAL_11 = INITVAL_11_highbits ;
			defparam ram_36_inst_highbits.INITVAL_10 = INITVAL_10_highbits ;
			defparam ram_36_inst_highbits.INITVAL_0F = INITVAL_0F_highbits ;
			defparam ram_36_inst_highbits.INITVAL_0E = INITVAL_0E_highbits ;
			defparam ram_36_inst_highbits.INITVAL_0D = INITVAL_0D_highbits ;
			defparam ram_36_inst_highbits.INITVAL_0C = INITVAL_0C_highbits ;
			defparam ram_36_inst_highbits.INITVAL_0B = INITVAL_0B_highbits ;
			defparam ram_36_inst_highbits.INITVAL_0A = INITVAL_0A_highbits ;
			defparam ram_36_inst_highbits.INITVAL_09 = INITVAL_09_highbits ;
			defparam ram_36_inst_highbits.INITVAL_08 = INITVAL_08_highbits ;
			defparam ram_36_inst_highbits.INITVAL_07 = INITVAL_07_highbits ;
			defparam ram_36_inst_highbits.INITVAL_06 = INITVAL_06_highbits ;
			defparam ram_36_inst_highbits.INITVAL_05 = INITVAL_05_highbits ;
			defparam ram_36_inst_highbits.INITVAL_04 = INITVAL_04_highbits ;
			defparam ram_36_inst_highbits.INITVAL_03 = INITVAL_03_highbits ;
			defparam ram_36_inst_highbits.INITVAL_02 = INITVAL_02_highbits ;
			defparam ram_36_inst_highbits.INITVAL_01 = INITVAL_01_highbits ;
			defparam ram_36_inst_highbits.INITVAL_00 = INITVAL_00_highbits ;
			defparam ram_36_inst_highbits.CSDECODE_A = "0b000" ;
			defparam ram_36_inst_highbits.CSDECODE_B = "0b000" ;
			defparam ram_36_inst_highbits.WRITEMODE_A = "WRITETHROUGH" ;
			defparam ram_36_inst_highbits.WRITEMODE_B = "WRITETHROUGH" ;
			defparam ram_36_inst_highbits.GSR = "DISABLED" ;
 			defparam ram_36_inst_highbits.REGMODE_A = "NOREG" ;
			defparam ram_36_inst_highbits.REGMODE_B = "NOREG" ;
			defparam ram_36_inst_highbits.DATA_WIDTH_A = 18 ;
			defparam ram_36_inst_highbits.DATA_WIDTH_B = 18 ;
			DP16KC ram_36_inst_highbits (
						    .DIA0(DIA[18]), 
						    .DIA1(DIA[19]), 
						    .DIA2(DIA[20]), 
						    .DIA3(DIA[21]), 
						    .DIA4(DIA[22]), 
						    .DIA5(DIA[23]), 
						    .DIA6(DIA[24]), 
						    .DIA7(DIA[25]), 
						    .DIA8(DIA[26]), 
						    .DIA9(DIA[27]), 
						    .DIA10(DIA[28]), 
						    .DIA11(DIA[29]), 
						    .DIA12(DIA[30]), 
						    .DIA13(DIA[31]), 
						    .DIA14(DIA[32]), 
						    .DIA15(DIA[33]), 
						    .DIA16(DIA[34]), 
						    .DIA17(DIA[35]), 
						    .ADA0(scuba_vhi), 
						    .ADA1(scuba_vhi), 
						    .ADA2(scuba_vlo), 
						    .ADA3(scuba_vlo), 
						    .ADA4(ADDRA[0]), 
						    .ADA5(ADDRA[1]), 
						    .ADA6(ADDRA[2]), 
						    .ADA7(ADDRA[3]), 
						    .ADA8(ADDRA[4]), 
						    .ADA9(ADDRA[5]), 
						    .ADA10(ADDRA[6]), 
						    .ADA11(ADDRA[7]), 
						    .ADA12(ADDRA[8]), 
						    .ADA13(scuba_vlo), 
						    .CEA(ENA), 
						    .CLKA(CLKA), 
						    .OCEA(ENA), 
						    .WEA(WEA), 
						    .CSA0(scuba_vlo), 
						    .CSA1(scuba_vlo), 
						    .CSA2(scuba_vlo), 
						    .RSTA(scuba_vlo), 
						    .DIB0(DIB[18]), 
						    .DIB1(DIB[19]), 
						    .DIB2(DIB[20]), 
						    .DIB3(DIB[21]), 
						    .DIB4(DIB[22]), 
						    .DIB5(DIB[23]), 
						    .DIB6(DIB[24]), 
						    .DIB7(DIB[25]), 
						    .DIB8(DIB[26]), 
						    .DIB9(DIB[27]), 
						    .DIB10(DIB[28]), 
						    .DIB11(DIB[29]), 
						    .DIB12(DIB[30]), 
						    .DIB13(DIB[31]), 
						    .DIB14(DIB[32]), 
						    .DIB15(DIB[33]), 
						    .DIB16(DIB[34]), 
						    .DIB17(DIB[35]), 
						    .ADB0(scuba_vhi), 
						    .ADB1(scuba_vhi), 
						    .ADB2(scuba_vlo), 
						    .ADB3(scuba_vlo), 
						    .ADB4(ADDRB[0]), 
						    .ADB5(ADDRB[1]), 
						    .ADB6(ADDRB[2]), 
						    .ADB7(ADDRB[3]), 
						    .ADB8(ADDRB[4]), 
						    .ADB9(ADDRB[5]), 
						    .ADB10(ADDRB[6]), 
						    .ADB11(ADDRB[7]), 
						    .ADB12(ADDRB[8]), 
						    .ADB13(scuba_vlo), 
						    .CEB(ENB), 
						    .CLKB(CLKB), 
						    .OCEB(ENB), 
						    .WEB(WEB), 
						    .CSB0(scuba_vlo), 
						    .CSB1(scuba_vlo), 
						    .CSB2(scuba_vlo), 
						    .RSTB(scuba_vlo), 
						    .DOA0(DOA_internal[18]), 
						    .DOA1(DOA_internal[19]), 
						    .DOA2(DOA_internal[20]), 
						    .DOA3(DOA_internal[21]), 
						    .DOA4(DOA_internal[22]), 
						    .DOA5(DOA_internal[23]), 
						    .DOA6(DOA_internal[24]), 
						    .DOA7(DOA_internal[25]), 
						    .DOA8(DOA_internal[26]), 
						    .DOA9(DOA_internal[27]), 
						    .DOA10(DOA_internal[28]), 
						    .DOA11(DOA_internal[29]), 
						    .DOA12(DOA_internal[30]), 
						    .DOA13(DOA_internal[31]), 
						    .DOA14(DOA_internal[32]), 
						    .DOA15(DOA_internal[33]), 
						    .DOA16(DOA_internal[34]), 
						    .DOA17(DOA_internal[35]), 
						    .DOB0(DOB_internal[18]), 
						    .DOB1(DOB_internal[19]), 
						    .DOB2(DOB_internal[20]), 
						    .DOB3(DOB_internal[21]), 
						    .DOB4(DOB_internal[22]), 
						    .DOB5(DOB_internal[23]), 
						    .DOB6(DOB_internal[24]), 
						    .DOB7(DOB_internal[25]), 
						    .DOB8(DOB_internal[26]), 
						    .DOB9(DOB_internal[27]), 
						    .DOB10(DOB_internal[28]), 
						    .DOB11(DOB_internal[29]), 
						    .DOB12(DOB_internal[30]), 
						    .DOB13(DOB_internal[31]), 
						    .DOB14(DOB_internal[32]), 
						    .DOB15(DOB_internal[33]), 
						    .DOB16(DOB_internal[34]), 
						    .DOB17(DOB_internal[35]));

		end
		else if (WRITE_MODE_B == "READ_FIRST")
		begin
		
            ssr_logic #(
            .WIDTH  (      36      ),
            .SRVAL  ( SRVAL_A      )
            ) ssr_logic_inst_a (
            .CLK    ( CLKA         ),
            .DO_in  ( DOA_internal ),
            .DO_out ( DOA          ),
            .EN     ( ENA          ),
            .SSR    ( SSRA         )
            );   
            
            ssr_logic #(
            .WIDTH  (      36      ),
            .SRVAL  ( SRVAL_B      )
            ) ssr_logic_inst_b (
            .CLK    ( CLKB         ),
            .DO_in  ( DOB_internal ),
            .DO_out ( DOB          ),
            .EN     ( ENB          ),
            .SSR    ( SSRB         )
            );   
		


			defparam ram_36_inst_lowbits.INITVAL_1F = INITVAL_1F_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_1E = INITVAL_1E_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_1D = INITVAL_1D_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_1C = INITVAL_1C_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_1B = INITVAL_1B_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_1A = INITVAL_1A_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_19 = INITVAL_19_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_18 = INITVAL_18_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_17 = INITVAL_17_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_16 = INITVAL_16_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_15 = INITVAL_15_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_14 = INITVAL_14_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_13 = INITVAL_13_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_12 = INITVAL_12_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_11 = INITVAL_11_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_10 = INITVAL_10_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_0F = INITVAL_0F_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_0E = INITVAL_0E_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_0D = INITVAL_0D_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_0C = INITVAL_0C_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_0B = INITVAL_0B_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_0A = INITVAL_0A_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_09 = INITVAL_09_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_08 = INITVAL_08_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_07 = INITVAL_07_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_06 = INITVAL_06_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_05 = INITVAL_05_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_04 = INITVAL_04_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_03 = INITVAL_03_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_02 = INITVAL_02_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_01 = INITVAL_01_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_00 = INITVAL_00_lowbits ;
			defparam ram_36_inst_lowbits.CSDECODE_A = "0b000" ;
			defparam ram_36_inst_lowbits.CSDECODE_B = "0b000" ;
			defparam ram_36_inst_lowbits.WRITEMODE_A = "WRITETHROUGH" ;
			defparam ram_36_inst_lowbits.WRITEMODE_B = "READBEFOREWRITE" ;
			defparam ram_36_inst_lowbits.GSR = "DISABLED" ;
 			defparam ram_36_inst_lowbits.REGMODE_A = "NOREG" ;
			defparam ram_36_inst_lowbits.REGMODE_B = "NOREG" ;
			defparam ram_36_inst_lowbits.DATA_WIDTH_A = 18 ;
			defparam ram_36_inst_lowbits.DATA_WIDTH_B = 18 ;
			DP16KC ram_36_inst_lowbits (
						    .DIA0(DIA[0]), 
						    .DIA1(DIA[1]), 
						    .DIA2(DIA[2]), 
						    .DIA3(DIA[3]), 
						    .DIA4(DIA[4]), 
						    .DIA5(DIA[5]), 
						    .DIA6(DIA[6]), 
						    .DIA7(DIA[7]), 
						    .DIA8(DIA[8]), 
						    .DIA9(DIA[9]), 
						    .DIA10(DIA[10]), 
						    .DIA11(DIA[11]), 
						    .DIA12(DIA[12]), 
						    .DIA13(DIA[13]), 
						    .DIA14(DIA[14]), 
						    .DIA15(DIA[15]), 
						    .DIA16(DIA[16]), 
						    .DIA17(DIA[17]), 
						    .ADA0(scuba_vhi), 
						    .ADA1(scuba_vhi), 
						    .ADA2(scuba_vlo), 
						    .ADA3(scuba_vlo), 
						    .ADA4(ADDRA[0]), 
						    .ADA5(ADDRA[1]), 
						    .ADA6(ADDRA[2]), 
						    .ADA7(ADDRA[3]), 
						    .ADA8(ADDRA[4]), 
						    .ADA9(ADDRA[5]), 
						    .ADA10(ADDRA[6]), 
						    .ADA11(ADDRA[7]), 
						    .ADA12(ADDRA[8]), 
						    .ADA13(scuba_vlo), 
						    .CEA(ENA), 
						    .CLKA(CLKA), 
						    .OCEA(ENA), 
						    .WEA(WEA), 
						    .CSA0(scuba_vlo), 
						    .CSA1(scuba_vlo), 
						    .CSA2(scuba_vlo), 
						    .RSTA(scuba_vlo), 
						    .DIB0(DIB[0]), 
						    .DIB1(DIB[1]), 
						    .DIB2(DIB[2]), 
						    .DIB3(DIB[3]), 
						    .DIB4(DIB[4]), 
						    .DIB5(DIB[5]), 
						    .DIB6(DIB[6]), 
						    .DIB7(DIB[7]), 
						    .DIB8(DIB[8]), 
						    .DIB9(DIB[9]), 
						    .DIB10(DIB[10]), 
						    .DIB11(DIB[11]), 
						    .DIB12(DIB[12]), 
						    .DIB13(DIB[13]), 
						    .DIB14(DIB[14]), 
						    .DIB15(DIB[15]), 
						    .DIB16(DIB[16]), 
						    .DIB17(DIB[17]), 
						    .ADB0(scuba_vhi), 
						    .ADB1(scuba_vhi), 
						    .ADB2(scuba_vlo), 
						    .ADB3(scuba_vlo), 
						    .ADB4(ADDRB[0]), 
						    .ADB5(ADDRB[1]), 
						    .ADB6(ADDRB[2]), 
						    .ADB7(ADDRB[3]), 
						    .ADB8(ADDRB[4]), 
						    .ADB9(ADDRB[5]), 
						    .ADB10(ADDRB[6]), 
						    .ADB11(ADDRB[7]), 
						    .ADB12(ADDRB[8]), 
						    .ADB13(scuba_vlo), 
						    .CEB(ENB), 
						    .CLKB(CLKB), 
						    .OCEB(ENB), 
						    .WEB(WEB), 
						    .CSB0(scuba_vlo), 
						    .CSB1(scuba_vlo), 
						    .CSB2(scuba_vlo), 
						    .RSTB(scuba_vlo), 
						    .DOA0(DOA_internal[0]), 
						    .DOA1(DOA_internal[1]), 
						    .DOA2(DOA_internal[2]), 
						    .DOA3(DOA_internal[3]), 
						    .DOA4(DOA_internal[4]), 
						    .DOA5(DOA_internal[5]), 
						    .DOA6(DOA_internal[6]), 
						    .DOA7(DOA_internal[7]), 
						    .DOA8(DOA_internal[8]), 
						    .DOA9(DOA_internal[9]), 
						    .DOA10(DOA_internal[10]), 
						    .DOA11(DOA_internal[11]), 
						    .DOA12(DOA_internal[12]), 
						    .DOA13(DOA_internal[13]), 
						    .DOA14(DOA_internal[14]), 
						    .DOA15(DOA_internal[15]), 
						    .DOA16(DOA_internal[16]), 
						    .DOA17(DOA_internal[17]), 
						    .DOB0(DOB_internal[0]), 
						    .DOB1(DOB_internal[1]), 
						    .DOB2(DOB_internal[2]), 
						    .DOB3(DOB_internal[3]), 
						    .DOB4(DOB_internal[4]), 
						    .DOB5(DOB_internal[5]), 
						    .DOB6(DOB_internal[6]), 
						    .DOB7(DOB_internal[7]),
						    .DOB8(DOB_internal[8]), 
						    .DOB9(DOB_internal[9]), 
						    .DOB10(DOB_internal[10]), 
						    .DOB11(DOB_internal[11]), 
						    .DOB12(DOB_internal[12]), 
						    .DOB13(DOB_internal[13]), 
						    .DOB14(DOB_internal[14]), 
						    .DOB15(DOB_internal[15]), 
						    .DOB16(DOB_internal[16]), 
						    .DOB17(DOB_internal[17]));



			defparam ram_36_inst_highbits.INITVAL_1F = INITVAL_1F_highbits ;
			defparam ram_36_inst_highbits.INITVAL_1E = INITVAL_1E_highbits ;
			defparam ram_36_inst_highbits.INITVAL_1D = INITVAL_1D_highbits ;
			defparam ram_36_inst_highbits.INITVAL_1C = INITVAL_1C_highbits ;
			defparam ram_36_inst_highbits.INITVAL_1B = INITVAL_1B_highbits ;
			defparam ram_36_inst_highbits.INITVAL_1A = INITVAL_1A_highbits ;
			defparam ram_36_inst_highbits.INITVAL_19 = INITVAL_19_highbits ;
			defparam ram_36_inst_highbits.INITVAL_18 = INITVAL_18_highbits ;
			defparam ram_36_inst_highbits.INITVAL_17 = INITVAL_17_highbits ;
			defparam ram_36_inst_highbits.INITVAL_16 = INITVAL_16_highbits ;
			defparam ram_36_inst_highbits.INITVAL_15 = INITVAL_15_highbits ;
			defparam ram_36_inst_highbits.INITVAL_14 = INITVAL_14_highbits ;
			defparam ram_36_inst_highbits.INITVAL_13 = INITVAL_13_highbits ;
			defparam ram_36_inst_highbits.INITVAL_12 = INITVAL_12_highbits ;
			defparam ram_36_inst_highbits.INITVAL_11 = INITVAL_11_highbits ;
			defparam ram_36_inst_highbits.INITVAL_10 = INITVAL_10_highbits ;
			defparam ram_36_inst_highbits.INITVAL_0F = INITVAL_0F_highbits ;
			defparam ram_36_inst_highbits.INITVAL_0E = INITVAL_0E_highbits ;
			defparam ram_36_inst_highbits.INITVAL_0D = INITVAL_0D_highbits ;
			defparam ram_36_inst_highbits.INITVAL_0C = INITVAL_0C_highbits ;
			defparam ram_36_inst_highbits.INITVAL_0B = INITVAL_0B_highbits ;
			defparam ram_36_inst_highbits.INITVAL_0A = INITVAL_0A_highbits ;
			defparam ram_36_inst_highbits.INITVAL_09 = INITVAL_09_highbits ;
			defparam ram_36_inst_highbits.INITVAL_08 = INITVAL_08_highbits ;
			defparam ram_36_inst_highbits.INITVAL_07 = INITVAL_07_highbits ;
			defparam ram_36_inst_highbits.INITVAL_06 = INITVAL_06_highbits ;
			defparam ram_36_inst_highbits.INITVAL_05 = INITVAL_05_highbits ;
			defparam ram_36_inst_highbits.INITVAL_04 = INITVAL_04_highbits ;
			defparam ram_36_inst_highbits.INITVAL_03 = INITVAL_03_highbits ;
			defparam ram_36_inst_highbits.INITVAL_02 = INITVAL_02_highbits ;
			defparam ram_36_inst_highbits.INITVAL_01 = INITVAL_01_highbits ;
			defparam ram_36_inst_highbits.INITVAL_00 = INITVAL_00_highbits ;
			defparam ram_36_inst_highbits.CSDECODE_A = "0b000" ;
			defparam ram_36_inst_highbits.CSDECODE_B = "0b000" ;
			defparam ram_36_inst_highbits.WRITEMODE_A = "WRITETHROUGH" ;
			defparam ram_36_inst_highbits.WRITEMODE_B = "READBEFOREWRITE" ;
			defparam ram_36_inst_highbits.GSR = "DISABLED" ;
 			defparam ram_36_inst_highbits.REGMODE_A = "NOREG" ;
			defparam ram_36_inst_highbits.REGMODE_B = "NOREG" ;
			defparam ram_36_inst_highbits.DATA_WIDTH_A = 18 ;
			defparam ram_36_inst_highbits.DATA_WIDTH_B = 18 ;
			DP16KC ram_36_inst_highbits (
						    .DIA0(DIA[18]), 
						    .DIA1(DIA[19]), 
						    .DIA2(DIA[20]), 
						    .DIA3(DIA[21]), 
						    .DIA4(DIA[22]), 
						    .DIA5(DIA[23]), 
						    .DIA6(DIA[24]), 
						    .DIA7(DIA[25]), 
						    .DIA8(DIA[26]), 
						    .DIA9(DIA[27]), 
						    .DIA10(DIA[28]), 
						    .DIA11(DIA[29]), 
						    .DIA12(DIA[30]), 
						    .DIA13(DIA[31]), 
						    .DIA14(DIA[32]), 
						    .DIA15(DIA[33]), 
						    .DIA16(DIA[34]), 
						    .DIA17(DIA[35]), 
						    .ADA0(scuba_vhi), 
						    .ADA1(scuba_vhi), 
						    .ADA2(scuba_vlo), 
						    .ADA3(scuba_vlo), 
						    .ADA4(ADDRA[0]), 
						    .ADA5(ADDRA[1]), 
						    .ADA6(ADDRA[2]), 
						    .ADA7(ADDRA[3]), 
						    .ADA8(ADDRA[4]), 
						    .ADA9(ADDRA[5]), 
						    .ADA10(ADDRA[6]), 
						    .ADA11(ADDRA[7]), 
						    .ADA12(ADDRA[8]), 
						    .ADA13(scuba_vlo), 
						    .CEA(ENA), 
						    .CLKA(CLKA), 
						    .OCEA(ENA), 
						    .WEA(WEA), 
						    .CSA0(scuba_vlo), 
						    .CSA1(scuba_vlo), 
						    .CSA2(scuba_vlo), 
						    .RSTA(scuba_vlo), 
						    .DIB0(DIB[18]), 
						    .DIB1(DIB[19]), 
						    .DIB2(DIB[20]), 
						    .DIB3(DIB[21]), 
						    .DIB4(DIB[22]), 
						    .DIB5(DIB[23]), 
						    .DIB6(DIB[24]), 
						    .DIB7(DIB[25]), 
						    .DIB8(DIB[26]), 
						    .DIB9(DIB[27]), 
						    .DIB10(DIB[28]), 
						    .DIB11(DIB[29]), 
						    .DIB12(DIB[30]), 
						    .DIB13(DIB[31]), 
						    .DIB14(DIB[32]), 
						    .DIB15(DIB[33]), 
						    .DIB16(DIB[34]), 
						    .DIB17(DIB[35]), 
						    .ADB0(scuba_vhi), 
						    .ADB1(scuba_vhi), 
						    .ADB2(scuba_vlo), 
						    .ADB3(scuba_vlo), 
						    .ADB4(ADDRB[0]), 
						    .ADB5(ADDRB[1]), 
						    .ADB6(ADDRB[2]), 
						    .ADB7(ADDRB[3]), 
						    .ADB8(ADDRB[4]), 
						    .ADB9(ADDRB[5]), 
						    .ADB10(ADDRB[6]), 
						    .ADB11(ADDRB[7]), 
						    .ADB12(ADDRB[8]), 
						    .ADB13(scuba_vlo), 
						    .CEB(ENB), 
						    .CLKB(CLKB), 
						    .OCEB(ENB), 
						    .WEB(WEB), 
						    .CSB0(scuba_vlo), 
						    .CSB1(scuba_vlo), 
						    .CSB2(scuba_vlo), 
						    .RSTB(scuba_vlo), 
						    .DOA0(DOA_internal[18]), 
						    .DOA1(DOA_internal[19]), 
						    .DOA2(DOA_internal[20]), 
						    .DOA3(DOA_internal[21]), 
						    .DOA4(DOA_internal[22]), 
						    .DOA5(DOA_internal[23]), 
						    .DOA6(DOA_internal[24]), 
						    .DOA7(DOA_internal[25]), 
						    .DOA8(DOA_internal[26]), 
						    .DOA9(DOA_internal[27]), 
						    .DOA10(DOA_internal[28]), 
						    .DOA11(DOA_internal[29]), 
						    .DOA12(DOA_internal[30]), 
						    .DOA13(DOA_internal[31]), 
						    .DOA14(DOA_internal[32]), 
						    .DOA15(DOA_internal[33]), 
						    .DOA16(DOA_internal[34]), 
						    .DOA17(DOA_internal[35]), 
						    .DOB0(DOB_internal[18]), 
						    .DOB1(DOB_internal[19]), 
						    .DOB2(DOB_internal[20]), 
						    .DOB3(DOB_internal[21]), 
						    .DOB4(DOB_internal[22]), 
						    .DOB5(DOB_internal[23]), 
						    .DOB6(DOB_internal[24]), 
						    .DOB7(DOB_internal[25]), 
						    .DOB8(DOB_internal[26]), 
						    .DOB9(DOB_internal[27]), 
						    .DOB10(DOB_internal[28]), 
						    .DOB11(DOB_internal[29]), 
						    .DOB12(DOB_internal[30]), 
						    .DOB13(DOB_internal[31]), 
						    .DOB14(DOB_internal[32]), 
						    .DOB15(DOB_internal[33]), 
						    .DOB16(DOB_internal[34]), 
						    .DOB17(DOB_internal[35]));

		end
		else if (WRITE_MODE_B == "NO_CHANGE")
		begin
		
			ssr_logic #(
            .WIDTH  (      36      ),
            .SRVAL  ( SRVAL_A      )
            ) ssr_logic_inst_a (
            .CLK    ( CLKA         ),
            .DO_in  ( DOA_internal ),
            .DO_out ( DOA          ),
            .EN     ( ENA          ),
            .SSR    ( SSRA         )
            );   
            
            nochange_ssr_logic #(
            .WIDTH  (      36      ),
            .SRVAL  ( SRVAL_B      )
            ) nochange_ssr_logic_inst_b (
            .CLK    ( CLKB         ),
            .DO_in  ( DOB_internal ),
            .DO_out ( DOB          ),
            .EN     ( ENB          ),
            .WE     ( WEB          ),
            .SSR    ( SSRB         )
            ); 
			


			defparam ram_36_inst_lowbits.INITVAL_1F = INITVAL_1F_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_1E = INITVAL_1E_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_1D = INITVAL_1D_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_1C = INITVAL_1C_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_1B = INITVAL_1B_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_1A = INITVAL_1A_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_19 = INITVAL_19_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_18 = INITVAL_18_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_17 = INITVAL_17_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_16 = INITVAL_16_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_15 = INITVAL_15_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_14 = INITVAL_14_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_13 = INITVAL_13_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_12 = INITVAL_12_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_11 = INITVAL_11_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_10 = INITVAL_10_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_0F = INITVAL_0F_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_0E = INITVAL_0E_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_0D = INITVAL_0D_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_0C = INITVAL_0C_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_0B = INITVAL_0B_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_0A = INITVAL_0A_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_09 = INITVAL_09_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_08 = INITVAL_08_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_07 = INITVAL_07_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_06 = INITVAL_06_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_05 = INITVAL_05_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_04 = INITVAL_04_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_03 = INITVAL_03_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_02 = INITVAL_02_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_01 = INITVAL_01_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_00 = INITVAL_00_lowbits ;
			defparam ram_36_inst_lowbits.CSDECODE_A = "0b000" ;
			defparam ram_36_inst_lowbits.CSDECODE_B = "0b000" ;
			defparam ram_36_inst_lowbits.WRITEMODE_A = "WRITETHROUGH" ;
			defparam ram_36_inst_lowbits.WRITEMODE_B = "WRITETHROUGH" ;
			defparam ram_36_inst_lowbits.GSR = "DISABLED" ;
 			defparam ram_36_inst_lowbits.REGMODE_A = "NOREG" ;
			defparam ram_36_inst_lowbits.REGMODE_B = "NOREG" ;
			defparam ram_36_inst_lowbits.DATA_WIDTH_A = 18 ;
			defparam ram_36_inst_lowbits.DATA_WIDTH_B = 18 ;
			DP16KC ram_36_inst_lowbits (
						    .DIA0(DIA[0]), 
						    .DIA1(DIA[1]), 
						    .DIA2(DIA[2]), 
						    .DIA3(DIA[3]), 
						    .DIA4(DIA[4]), 
						    .DIA5(DIA[5]), 
						    .DIA6(DIA[6]), 
						    .DIA7(DIA[7]), 
						    .DIA8(DIA[8]), 
						    .DIA9(DIA[9]), 
						    .DIA10(DIA[10]), 
						    .DIA11(DIA[11]), 
						    .DIA12(DIA[12]), 
						    .DIA13(DIA[13]), 
						    .DIA14(DIA[14]), 
						    .DIA15(DIA[15]), 
						    .DIA16(DIA[16]), 
						    .DIA17(DIA[17]), 
						    .ADA0(scuba_vhi), 
						    .ADA1(scuba_vhi), 
						    .ADA2(scuba_vlo), 
						    .ADA3(scuba_vlo), 
						    .ADA4(ADDRA[0]), 
						    .ADA5(ADDRA[1]), 
						    .ADA6(ADDRA[2]), 
						    .ADA7(ADDRA[3]), 
						    .ADA8(ADDRA[4]), 
						    .ADA9(ADDRA[5]), 
						    .ADA10(ADDRA[6]), 
						    .ADA11(ADDRA[7]), 
						    .ADA12(ADDRA[8]), 
						    .ADA13(scuba_vlo), 
						    .CEA(ENA), 
						    .CLKA(CLKA), 
						    .OCEA(ENA), 
						    .WEA(WEA), 
						    .CSA0(scuba_vlo), 
						    .CSA1(scuba_vlo), 
						    .CSA2(scuba_vlo), 
						    .RSTA(scuba_vlo), 
						    .DIB0(DIB[0]), 
						    .DIB1(DIB[1]), 
						    .DIB2(DIB[2]), 
						    .DIB3(DIB[3]), 
						    .DIB4(DIB[4]), 
						    .DIB5(DIB[5]), 
						    .DIB6(DIB[6]), 
						    .DIB7(DIB[7]), 
						    .DIB8(DIB[8]), 
						    .DIB9(DIB[9]), 
						    .DIB10(DIB[10]), 
						    .DIB11(DIB[11]), 
						    .DIB12(DIB[12]), 
						    .DIB13(DIB[13]), 
						    .DIB14(DIB[14]), 
						    .DIB15(DIB[15]), 
						    .DIB16(DIB[16]), 
						    .DIB17(DIB[17]), 
						    .ADB0(scuba_vhi), 
						    .ADB1(scuba_vhi), 
						    .ADB2(scuba_vlo), 
						    .ADB3(scuba_vlo), 
						    .ADB4(ADDRB[0]), 
						    .ADB5(ADDRB[1]), 
						    .ADB6(ADDRB[2]), 
						    .ADB7(ADDRB[3]), 
						    .ADB8(ADDRB[4]), 
						    .ADB9(ADDRB[5]), 
						    .ADB10(ADDRB[6]), 
						    .ADB11(ADDRB[7]), 
						    .ADB12(ADDRB[8]), 
						    .ADB13(scuba_vlo), 
						    .CEB(ENB), 
						    .CLKB(CLKB), 
						    .OCEB(ENB), 
						    .WEB(WEB), 
						    .CSB0(scuba_vlo), 
						    .CSB1(scuba_vlo), 
						    .CSB2(scuba_vlo), 
						    .RSTB(scuba_vlo), 
						    .DOA0(DOA_internal[0]), 
						    .DOA1(DOA_internal[1]), 
						    .DOA2(DOA_internal[2]), 
						    .DOA3(DOA_internal[3]), 
						    .DOA4(DOA_internal[4]), 
						    .DOA5(DOA_internal[5]), 
						    .DOA6(DOA_internal[6]), 
						    .DOA7(DOA_internal[7]), 
						    .DOA8(DOA_internal[8]), 
						    .DOA9(DOA_internal[9]), 
						    .DOA10(DOA_internal[10]), 
						    .DOA11(DOA_internal[11]), 
						    .DOA12(DOA_internal[12]), 
						    .DOA13(DOA_internal[13]), 
						    .DOA14(DOA_internal[14]), 
						    .DOA15(DOA_internal[15]), 
						    .DOA16(DOA_internal[16]), 
						    .DOA17(DOA_internal[17]), 
						    .DOB0(DOB_internal[0]), 
						    .DOB1(DOB_internal[1]), 
						    .DOB2(DOB_internal[2]), 
						    .DOB3(DOB_internal[3]), 
						    .DOB4(DOB_internal[4]), 
						    .DOB5(DOB_internal[5]), 
						    .DOB6(DOB_internal[6]), 
						    .DOB7(DOB_internal[7]),
						    .DOB8(DOB_internal[8]), 
						    .DOB9(DOB_internal[9]), 
						    .DOB10(DOB_internal[10]), 
						    .DOB11(DOB_internal[11]), 
						    .DOB12(DOB_internal[12]), 
						    .DOB13(DOB_internal[13]), 
						    .DOB14(DOB_internal[14]), 
						    .DOB15(DOB_internal[15]), 
						    .DOB16(DOB_internal[16]), 
						    .DOB17(DOB_internal[17]));



			defparam ram_36_inst_highbits.INITVAL_1F = INITVAL_1F_highbits ;
			defparam ram_36_inst_highbits.INITVAL_1E = INITVAL_1E_highbits ;
			defparam ram_36_inst_highbits.INITVAL_1D = INITVAL_1D_highbits ;
			defparam ram_36_inst_highbits.INITVAL_1C = INITVAL_1C_highbits ;
			defparam ram_36_inst_highbits.INITVAL_1B = INITVAL_1B_highbits ;
			defparam ram_36_inst_highbits.INITVAL_1A = INITVAL_1A_highbits ;
			defparam ram_36_inst_highbits.INITVAL_19 = INITVAL_19_highbits ;
			defparam ram_36_inst_highbits.INITVAL_18 = INITVAL_18_highbits ;
			defparam ram_36_inst_highbits.INITVAL_17 = INITVAL_17_highbits ;
			defparam ram_36_inst_highbits.INITVAL_16 = INITVAL_16_highbits ;
			defparam ram_36_inst_highbits.INITVAL_15 = INITVAL_15_highbits ;
			defparam ram_36_inst_highbits.INITVAL_14 = INITVAL_14_highbits ;
			defparam ram_36_inst_highbits.INITVAL_13 = INITVAL_13_highbits ;
			defparam ram_36_inst_highbits.INITVAL_12 = INITVAL_12_highbits ;
			defparam ram_36_inst_highbits.INITVAL_11 = INITVAL_11_highbits ;
			defparam ram_36_inst_highbits.INITVAL_10 = INITVAL_10_highbits ;
			defparam ram_36_inst_highbits.INITVAL_0F = INITVAL_0F_highbits ;
			defparam ram_36_inst_highbits.INITVAL_0E = INITVAL_0E_highbits ;
			defparam ram_36_inst_highbits.INITVAL_0D = INITVAL_0D_highbits ;
			defparam ram_36_inst_highbits.INITVAL_0C = INITVAL_0C_highbits ;
			defparam ram_36_inst_highbits.INITVAL_0B = INITVAL_0B_highbits ;
			defparam ram_36_inst_highbits.INITVAL_0A = INITVAL_0A_highbits ;
			defparam ram_36_inst_highbits.INITVAL_09 = INITVAL_09_highbits ;
			defparam ram_36_inst_highbits.INITVAL_08 = INITVAL_08_highbits ;
			defparam ram_36_inst_highbits.INITVAL_07 = INITVAL_07_highbits ;
			defparam ram_36_inst_highbits.INITVAL_06 = INITVAL_06_highbits ;
			defparam ram_36_inst_highbits.INITVAL_05 = INITVAL_05_highbits ;
			defparam ram_36_inst_highbits.INITVAL_04 = INITVAL_04_highbits ;
			defparam ram_36_inst_highbits.INITVAL_03 = INITVAL_03_highbits ;
			defparam ram_36_inst_highbits.INITVAL_02 = INITVAL_02_highbits ;
			defparam ram_36_inst_highbits.INITVAL_01 = INITVAL_01_highbits ;
			defparam ram_36_inst_highbits.INITVAL_00 = INITVAL_00_highbits ;
			defparam ram_36_inst_highbits.CSDECODE_A = "0b000" ;
			defparam ram_36_inst_highbits.CSDECODE_B = "0b000" ;
			defparam ram_36_inst_highbits.WRITEMODE_A = "WRITETHROUGH" ;
			defparam ram_36_inst_highbits.WRITEMODE_B = "WRITETHROUGH" ;
			defparam ram_36_inst_highbits.GSR = "DISABLED" ;
 			defparam ram_36_inst_highbits.REGMODE_A = "NOREG" ;
			defparam ram_36_inst_highbits.REGMODE_B = "NOREG" ;
			defparam ram_36_inst_highbits.DATA_WIDTH_A = 18 ;
			defparam ram_36_inst_highbits.DATA_WIDTH_B = 18 ;
			DP16KC ram_36_inst_highbits (
						    .DIA0(DIA[18]), 
						    .DIA1(DIA[19]), 
						    .DIA2(DIA[20]), 
						    .DIA3(DIA[21]), 
						    .DIA4(DIA[22]), 
						    .DIA5(DIA[23]), 
						    .DIA6(DIA[24]), 
						    .DIA7(DIA[25]), 
						    .DIA8(DIA[26]), 
						    .DIA9(DIA[27]), 
						    .DIA10(DIA[28]), 
						    .DIA11(DIA[29]), 
						    .DIA12(DIA[30]), 
						    .DIA13(DIA[31]), 
						    .DIA14(DIA[32]), 
						    .DIA15(DIA[33]), 
						    .DIA16(DIA[34]), 
						    .DIA17(DIA[35]), 
						    .ADA0(scuba_vhi), 
						    .ADA1(scuba_vhi), 
						    .ADA2(scuba_vlo), 
						    .ADA3(scuba_vlo), 
						    .ADA4(ADDRA[0]), 
						    .ADA5(ADDRA[1]), 
						    .ADA6(ADDRA[2]), 
						    .ADA7(ADDRA[3]), 
						    .ADA8(ADDRA[4]), 
						    .ADA9(ADDRA[5]), 
						    .ADA10(ADDRA[6]), 
						    .ADA11(ADDRA[7]), 
						    .ADA12(ADDRA[8]), 
						    .ADA13(scuba_vlo), 
						    .CEA(ENA), 
						    .CLKA(CLKA), 
						    .OCEA(ENA), 
						    .WEA(WEA), 
						    .CSA0(scuba_vlo), 
						    .CSA1(scuba_vlo), 
						    .CSA2(scuba_vlo), 
						    .RSTA(scuba_vlo), 
						    .DIB0(DIB[18]), 
						    .DIB1(DIB[19]), 
						    .DIB2(DIB[20]), 
						    .DIB3(DIB[21]), 
						    .DIB4(DIB[22]), 
						    .DIB5(DIB[23]), 
						    .DIB6(DIB[24]), 
						    .DIB7(DIB[25]), 
						    .DIB8(DIB[26]), 
						    .DIB9(DIB[27]), 
						    .DIB10(DIB[28]), 
						    .DIB11(DIB[29]), 
						    .DIB12(DIB[30]), 
						    .DIB13(DIB[31]), 
						    .DIB14(DIB[32]), 
						    .DIB15(DIB[33]), 
						    .DIB16(DIB[34]), 
						    .DIB17(DIB[35]), 
						    .ADB0(scuba_vhi), 
						    .ADB1(scuba_vhi), 
						    .ADB2(scuba_vlo), 
						    .ADB3(scuba_vlo), 
						    .ADB4(ADDRB[0]), 
						    .ADB5(ADDRB[1]), 
						    .ADB6(ADDRB[2]), 
						    .ADB7(ADDRB[3]), 
						    .ADB8(ADDRB[4]), 
						    .ADB9(ADDRB[5]), 
						    .ADB10(ADDRB[6]), 
						    .ADB11(ADDRB[7]), 
						    .ADB12(ADDRB[8]), 
						    .ADB13(scuba_vlo), 
						    .CEB(ENB), 
						    .CLKB(CLKB), 
						    .OCEB(ENB), 
						    .WEB(WEB), 
						    .CSB0(scuba_vlo), 
						    .CSB1(scuba_vlo), 
						    .CSB2(scuba_vlo), 
						    .RSTB(scuba_vlo), 
						    .DOA0(DOA_internal[18]), 
						    .DOA1(DOA_internal[19]), 
						    .DOA2(DOA_internal[20]), 
						    .DOA3(DOA_internal[21]), 
						    .DOA4(DOA_internal[22]), 
						    .DOA5(DOA_internal[23]), 
						    .DOA6(DOA_internal[24]), 
						    .DOA7(DOA_internal[25]), 
						    .DOA8(DOA_internal[26]), 
						    .DOA9(DOA_internal[27]), 
						    .DOA10(DOA_internal[28]), 
						    .DOA11(DOA_internal[29]), 
						    .DOA12(DOA_internal[30]), 
						    .DOA13(DOA_internal[31]), 
						    .DOA14(DOA_internal[32]), 
						    .DOA15(DOA_internal[33]), 
						    .DOA16(DOA_internal[34]), 
						    .DOA17(DOA_internal[35]), 
						    .DOB0(DOB_internal[18]), 
						    .DOB1(DOB_internal[19]), 
						    .DOB2(DOB_internal[20]), 
						    .DOB3(DOB_internal[21]), 
						    .DOB4(DOB_internal[22]), 
						    .DOB5(DOB_internal[23]), 
						    .DOB6(DOB_internal[24]), 
						    .DOB7(DOB_internal[25]), 
						    .DOB8(DOB_internal[26]), 
						    .DOB9(DOB_internal[27]), 
						    .DOB10(DOB_internal[28]), 
						    .DOB11(DOB_internal[29]), 
						    .DOB12(DOB_internal[30]), 
						    .DOB13(DOB_internal[31]), 
						    .DOB14(DOB_internal[32]), 
						    .DOB15(DOB_internal[33]), 
						    .DOB16(DOB_internal[34]), 
						    .DOB17(DOB_internal[35]));

		end
		else
		begin
		
            ssr_logic #(
            .WIDTH  (      36      ),
            .SRVAL  ( SRVAL_A      )
            ) ssr_logic_inst_a (
            .CLK    ( CLKA         ),
            .DO_in  ( DOA_internal ),
            .DO_out ( DOA          ),
            .EN     ( ENA          ),
            .SSR    ( SSRA         )
            );   
            
            ssr_logic #(
            .WIDTH  (      36      ),
            .SRVAL  ( SRVAL_B      )
            ) ssr_logic_inst_b (
            .CLK    ( CLKB         ),
            .DO_in  ( DOB_internal ),
            .DO_out ( DOB          ),
            .EN     ( ENB          ),
            .SSR    ( SSRB         )
            );
		


			defparam ram_36_inst_lowbits.INITVAL_1F = INITVAL_1F_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_1E = INITVAL_1E_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_1D = INITVAL_1D_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_1C = INITVAL_1C_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_1B = INITVAL_1B_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_1A = INITVAL_1A_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_19 = INITVAL_19_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_18 = INITVAL_18_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_17 = INITVAL_17_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_16 = INITVAL_16_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_15 = INITVAL_15_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_14 = INITVAL_14_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_13 = INITVAL_13_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_12 = INITVAL_12_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_11 = INITVAL_11_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_10 = INITVAL_10_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_0F = INITVAL_0F_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_0E = INITVAL_0E_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_0D = INITVAL_0D_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_0C = INITVAL_0C_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_0B = INITVAL_0B_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_0A = INITVAL_0A_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_09 = INITVAL_09_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_08 = INITVAL_08_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_07 = INITVAL_07_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_06 = INITVAL_06_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_05 = INITVAL_05_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_04 = INITVAL_04_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_03 = INITVAL_03_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_02 = INITVAL_02_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_01 = INITVAL_01_lowbits ;
			defparam ram_36_inst_lowbits.INITVAL_00 = INITVAL_00_lowbits ;
			defparam ram_36_inst_lowbits.CSDECODE_A = "0b000" ;
			defparam ram_36_inst_lowbits.CSDECODE_B = "0b000" ;
			defparam ram_36_inst_lowbits.WRITEMODE_A = "WRITETHROUGH" ;
			defparam ram_36_inst_lowbits.WRITEMODE_B = "WRITETHROUGH" ;
			defparam ram_36_inst_lowbits.GSR = "DISABLED" ;
 			defparam ram_36_inst_lowbits.REGMODE_A = "NOREG" ;
			defparam ram_36_inst_lowbits.REGMODE_B = "NOREG" ;
			defparam ram_36_inst_lowbits.DATA_WIDTH_A = 18 ;
			defparam ram_36_inst_lowbits.DATA_WIDTH_B = 18 ;
			DP16KC ram_36_inst_lowbits (
						    .DIA0(DIA[0]), 
						    .DIA1(DIA[1]), 
						    .DIA2(DIA[2]), 
						    .DIA3(DIA[3]), 
						    .DIA4(DIA[4]), 
						    .DIA5(DIA[5]), 
						    .DIA6(DIA[6]), 
						    .DIA7(DIA[7]), 
						    .DIA8(DIA[8]), 
						    .DIA9(DIA[9]), 
						    .DIA10(DIA[10]), 
						    .DIA11(DIA[11]), 
						    .DIA12(DIA[12]), 
						    .DIA13(DIA[13]), 
						    .DIA14(DIA[14]), 
						    .DIA15(DIA[15]), 
						    .DIA16(DIA[16]), 
						    .DIA17(DIA[17]), 
						    .ADA0(scuba_vhi), 
						    .ADA1(scuba_vhi), 
						    .ADA2(scuba_vlo), 
						    .ADA3(scuba_vlo), 
						    .ADA4(ADDRA[0]), 
						    .ADA5(ADDRA[1]), 
						    .ADA6(ADDRA[2]), 
						    .ADA7(ADDRA[3]), 
						    .ADA8(ADDRA[4]), 
						    .ADA9(ADDRA[5]), 
						    .ADA10(ADDRA[6]), 
						    .ADA11(ADDRA[7]), 
						    .ADA12(ADDRA[8]), 
						    .ADA13(scuba_vlo), 
						    .CEA(ENA), 
						    .CLKA(CLKA), 
						    .OCEA(ENA), 
						    .WEA(WEA), 
						    .CSA0(scuba_vlo), 
						    .CSA1(scuba_vlo), 
						    .CSA2(scuba_vlo), 
						    .RSTA(scuba_vlo), 
						    .DIB0(DIB[0]), 
						    .DIB1(DIB[1]), 
						    .DIB2(DIB[2]), 
						    .DIB3(DIB[3]), 
						    .DIB4(DIB[4]), 
						    .DIB5(DIB[5]), 
						    .DIB6(DIB[6]), 
						    .DIB7(DIB[7]), 
						    .DIB8(DIB[8]), 
						    .DIB9(DIB[9]), 
						    .DIB10(DIB[10]), 
						    .DIB11(DIB[11]), 
						    .DIB12(DIB[12]), 
						    .DIB13(DIB[13]), 
						    .DIB14(DIB[14]), 
						    .DIB15(DIB[15]), 
						    .DIB16(DIB[16]), 
						    .DIB17(DIB[17]), 
						    .ADB0(scuba_vhi), 
						    .ADB1(scuba_vhi), 
						    .ADB2(scuba_vlo), 
						    .ADB3(scuba_vlo), 
						    .ADB4(ADDRB[0]), 
						    .ADB5(ADDRB[1]), 
						    .ADB6(ADDRB[2]), 
						    .ADB7(ADDRB[3]), 
						    .ADB8(ADDRB[4]), 
						    .ADB9(ADDRB[5]), 
						    .ADB10(ADDRB[6]), 
						    .ADB11(ADDRB[7]), 
						    .ADB12(ADDRB[8]), 
						    .ADB13(scuba_vlo), 
						    .CEB(ENB), 
						    .CLKB(CLKB), 
						    .OCEB(ENB), 
						    .WEB(WEB), 
						    .CSB0(scuba_vlo), 
						    .CSB1(scuba_vlo), 
						    .CSB2(scuba_vlo), 
						    .RSTB(scuba_vlo), 
						    .DOA0(DOA_internal[0]), 
						    .DOA1(DOA_internal[1]), 
						    .DOA2(DOA_internal[2]), 
						    .DOA3(DOA_internal[3]), 
						    .DOA4(DOA_internal[4]), 
						    .DOA5(DOA_internal[5]), 
						    .DOA6(DOA_internal[6]), 
						    .DOA7(DOA_internal[7]), 
						    .DOA8(DOA_internal[8]), 
						    .DOA9(DOA_internal[9]), 
						    .DOA10(DOA_internal[10]), 
						    .DOA11(DOA_internal[11]), 
						    .DOA12(DOA_internal[12]), 
						    .DOA13(DOA_internal[13]), 
						    .DOA14(DOA_internal[14]), 
						    .DOA15(DOA_internal[15]), 
						    .DOA16(DOA_internal[16]), 
						    .DOA17(DOA_internal[17]), 
						    .DOB0(DOB_internal[0]), 
						    .DOB1(DOB_internal[1]), 
						    .DOB2(DOB_internal[2]), 
						    .DOB3(DOB_internal[3]), 
						    .DOB4(DOB_internal[4]), 
						    .DOB5(DOB_internal[5]), 
						    .DOB6(DOB_internal[6]), 
						    .DOB7(DOB_internal[7]),
						    .DOB8(DOB_internal[8]), 
						    .DOB9(DOB_internal[9]), 
						    .DOB10(DOB_internal[10]), 
						    .DOB11(DOB_internal[11]), 
						    .DOB12(DOB_internal[12]), 
						    .DOB13(DOB_internal[13]), 
						    .DOB14(DOB_internal[14]), 
						    .DOB15(DOB_internal[15]), 
						    .DOB16(DOB_internal[16]), 
						    .DOB17(DOB_internal[17]));



			defparam ram_36_inst_highbits.INITVAL_1F = INITVAL_1F_highbits ;
			defparam ram_36_inst_highbits.INITVAL_1E = INITVAL_1E_highbits ;
			defparam ram_36_inst_highbits.INITVAL_1D = INITVAL_1D_highbits ;
			defparam ram_36_inst_highbits.INITVAL_1C = INITVAL_1C_highbits ;
			defparam ram_36_inst_highbits.INITVAL_1B = INITVAL_1B_highbits ;
			defparam ram_36_inst_highbits.INITVAL_1A = INITVAL_1A_highbits ;
			defparam ram_36_inst_highbits.INITVAL_19 = INITVAL_19_highbits ;
			defparam ram_36_inst_highbits.INITVAL_18 = INITVAL_18_highbits ;
			defparam ram_36_inst_highbits.INITVAL_17 = INITVAL_17_highbits ;
			defparam ram_36_inst_highbits.INITVAL_16 = INITVAL_16_highbits ;
			defparam ram_36_inst_highbits.INITVAL_15 = INITVAL_15_highbits ;
			defparam ram_36_inst_highbits.INITVAL_14 = INITVAL_14_highbits ;
			defparam ram_36_inst_highbits.INITVAL_13 = INITVAL_13_highbits ;
			defparam ram_36_inst_highbits.INITVAL_12 = INITVAL_12_highbits ;
			defparam ram_36_inst_highbits.INITVAL_11 = INITVAL_11_highbits ;
			defparam ram_36_inst_highbits.INITVAL_10 = INITVAL_10_highbits ;
			defparam ram_36_inst_highbits.INITVAL_0F = INITVAL_0F_highbits ;
			defparam ram_36_inst_highbits.INITVAL_0E = INITVAL_0E_highbits ;
			defparam ram_36_inst_highbits.INITVAL_0D = INITVAL_0D_highbits ;
			defparam ram_36_inst_highbits.INITVAL_0C = INITVAL_0C_highbits ;
			defparam ram_36_inst_highbits.INITVAL_0B = INITVAL_0B_highbits ;
			defparam ram_36_inst_highbits.INITVAL_0A = INITVAL_0A_highbits ;
			defparam ram_36_inst_highbits.INITVAL_09 = INITVAL_09_highbits ;
			defparam ram_36_inst_highbits.INITVAL_08 = INITVAL_08_highbits ;
			defparam ram_36_inst_highbits.INITVAL_07 = INITVAL_07_highbits ;
			defparam ram_36_inst_highbits.INITVAL_06 = INITVAL_06_highbits ;
			defparam ram_36_inst_highbits.INITVAL_05 = INITVAL_05_highbits ;
			defparam ram_36_inst_highbits.INITVAL_04 = INITVAL_04_highbits ;
			defparam ram_36_inst_highbits.INITVAL_03 = INITVAL_03_highbits ;
			defparam ram_36_inst_highbits.INITVAL_02 = INITVAL_02_highbits ;
			defparam ram_36_inst_highbits.INITVAL_01 = INITVAL_01_highbits ;
			defparam ram_36_inst_highbits.INITVAL_00 = INITVAL_00_highbits ;
			defparam ram_36_inst_highbits.CSDECODE_A = "0b000" ;
			defparam ram_36_inst_highbits.CSDECODE_B = "0b000" ;
			defparam ram_36_inst_highbits.WRITEMODE_A = "WRITETHROUGH" ;
			defparam ram_36_inst_highbits.WRITEMODE_B = "WRITETHROUGH" ;
			defparam ram_36_inst_highbits.GSR = "DISABLED" ;
 			defparam ram_36_inst_highbits.REGMODE_A = "NOREG" ;
			defparam ram_36_inst_highbits.REGMODE_B = "NOREG" ;
			defparam ram_36_inst_highbits.DATA_WIDTH_A = 18 ;
			defparam ram_36_inst_highbits.DATA_WIDTH_B = 18 ;
			DP16KC ram_36_inst_highbits (
						    .DIA0(DIA[18]), 
						    .DIA1(DIA[19]), 
						    .DIA2(DIA[20]), 
						    .DIA3(DIA[21]), 
						    .DIA4(DIA[22]), 
						    .DIA5(DIA[23]), 
						    .DIA6(DIA[24]), 
						    .DIA7(DIA[25]), 
						    .DIA8(DIA[26]), 
						    .DIA9(DIA[27]), 
						    .DIA10(DIA[28]), 
						    .DIA11(DIA[29]), 
						    .DIA12(DIA[30]), 
						    .DIA13(DIA[31]), 
						    .DIA14(DIA[32]), 
						    .DIA15(DIA[33]), 
						    .DIA16(DIA[34]), 
						    .DIA17(DIA[35]), 
						    .ADA0(scuba_vhi), 
						    .ADA1(scuba_vhi), 
						    .ADA2(scuba_vlo), 
						    .ADA3(scuba_vlo), 
						    .ADA4(ADDRA[0]), 
						    .ADA5(ADDRA[1]), 
						    .ADA6(ADDRA[2]), 
						    .ADA7(ADDRA[3]), 
						    .ADA8(ADDRA[4]), 
						    .ADA9(ADDRA[5]), 
						    .ADA10(ADDRA[6]), 
						    .ADA11(ADDRA[7]), 
						    .ADA12(ADDRA[8]), 
						    .ADA13(scuba_vlo), 
						    .CEA(ENA), 
						    .CLKA(CLKA), 
						    .OCEA(ENA), 
						    .WEA(WEA), 
						    .CSA0(scuba_vlo), 
						    .CSA1(scuba_vlo), 
						    .CSA2(scuba_vlo), 
						    .RSTA(scuba_vlo), 
						    .DIB0(DIB[18]), 
						    .DIB1(DIB[19]), 
						    .DIB2(DIB[20]), 
						    .DIB3(DIB[21]), 
						    .DIB4(DIB[22]), 
						    .DIB5(DIB[23]), 
						    .DIB6(DIB[24]), 
						    .DIB7(DIB[25]), 
						    .DIB8(DIB[26]), 
						    .DIB9(DIB[27]), 
						    .DIB10(DIB[28]), 
						    .DIB11(DIB[29]), 
						    .DIB12(DIB[30]), 
						    .DIB13(DIB[31]), 
						    .DIB14(DIB[32]), 
						    .DIB15(DIB[33]), 
						    .DIB16(DIB[34]), 
						    .DIB17(DIB[35]), 
						    .ADB0(scuba_vhi), 
						    .ADB1(scuba_vhi), 
						    .ADB2(scuba_vlo), 
						    .ADB3(scuba_vlo), 
						    .ADB4(ADDRB[0]), 
						    .ADB5(ADDRB[1]), 
						    .ADB6(ADDRB[2]), 
						    .ADB7(ADDRB[3]), 
						    .ADB8(ADDRB[4]), 
						    .ADB9(ADDRB[5]), 
						    .ADB10(ADDRB[6]), 
						    .ADB11(ADDRB[7]), 
						    .ADB12(ADDRB[8]), 
						    .ADB13(scuba_vlo), 
						    .CEB(ENB), 
						    .CLKB(CLKB), 
						    .OCEB(ENB), 
						    .WEB(WEB), 
						    .CSB0(scuba_vlo), 
						    .CSB1(scuba_vlo), 
						    .CSB2(scuba_vlo), 
						    .RSTB(scuba_vlo), 
						    .DOA0(DOA_internal[18]), 
						    .DOA1(DOA_internal[19]), 
						    .DOA2(DOA_internal[20]), 
						    .DOA3(DOA_internal[21]), 
						    .DOA4(DOA_internal[22]), 
						    .DOA5(DOA_internal[23]), 
						    .DOA6(DOA_internal[24]), 
						    .DOA7(DOA_internal[25]), 
						    .DOA8(DOA_internal[26]), 
						    .DOA9(DOA_internal[27]), 
						    .DOA10(DOA_internal[28]), 
						    .DOA11(DOA_internal[29]), 
						    .DOA12(DOA_internal[30]), 
						    .DOA13(DOA_internal[31]), 
						    .DOA14(DOA_internal[32]), 
						    .DOA15(DOA_internal[33]), 
						    .DOA16(DOA_internal[34]), 
						    .DOA17(DOA_internal[35]), 
						    .DOB0(DOB_internal[18]), 
						    .DOB1(DOB_internal[19]), 
						    .DOB2(DOB_internal[20]), 
						    .DOB3(DOB_internal[21]), 
						    .DOB4(DOB_internal[22]), 
						    .DOB5(DOB_internal[23]), 
						    .DOB6(DOB_internal[24]), 
						    .DOB7(DOB_internal[25]), 
						    .DOB8(DOB_internal[26]), 
						    .DOB9(DOB_internal[27]), 
						    .DOB10(DOB_internal[28]), 
						    .DOB11(DOB_internal[29]), 
						    .DOB12(DOB_internal[30]), 
						    .DOB13(DOB_internal[31]), 
						    .DOB14(DOB_internal[32]), 
						    .DOB15(DOB_internal[33]), 
						    .DOB16(DOB_internal[34]), 
						    .DOB17(DOB_internal[35]));


		end

	end
	
	// end port a = invalid (port a defaults to WRITE_FIRST)

	
endgenerate

endmodule
