/**
 * _______________________________________________________________________________
 *
 *  Copyright (c) 2012 TU Dresden, Chair for Embedded Systems
 *  Copyright (c) 2013-2016 TU Darmstadt, Computer Systems Group
 *  (http://www.rs.tu-darmstadt.de) All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions
 *  are met:
 *
 *  1. Redistributions of source code must retain the above copyright
 *     notice, this list of conditions and the following disclaimer.
 *
 *  2. Redistributions in binary form must reproduce the above copyright
 *     notice, this list of conditions and the following disclaimer in the
 *     documentation and/or other materials provided with the distribution.
 *
 *  3. All advertising materials mentioning features or use of this software
 *     must display the following acknowledgement: "This product includes
 *     software developed by the TU Dresden Chair for Embedded Systems, TU Darmstadt Computer Systems Group and
 *     its contributors."
 *
 *  4. Neither the name of the TU Dresden Chair for Embedded Systems, TU Darmstadt Computer Systems Group nor the
 *     names of its contributors may be used to endorse or promote products
 *     derived from this software without specific prior written permission.
 *
 *  THIS SOFTWARE IS PROVIDED BY TU DRESDEN CHAIR FOR EMBEDDED SYSTEMS, TU DARMSTADT COMPUTER SYSTEMS GROUP AND
 *  CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING,
 *  BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
 *  FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 *  REGENTS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 *  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
 *  TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 *  PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 *  LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 *  NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 *  SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * _______________________________________________________________________________
 */

 `default_nettype none

`timescale 1 ns / 1 ps

module ram_18_prim
#(
	parameter WRITE_MODE_A = "WRITE_FIRST",
	parameter INIT_A = 18'h00000, // only for  xilinx (no function on lattice)
	parameter SRVAL_A = 18'h00000,
	parameter WRITE_MODE_B = "WRITE_FIRST",
	parameter INIT_B = 18'h00000, // only for  xilinx (no function on lattice)
	parameter SRVAL_B = 18'h00000,
	parameter SIM_COLLISION_CHECK = "ALL",	// for testing on xilinx (no function on lattice)
	parameter INITVAL_3F = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" , // ram initialization for lattice
        parameter INITVAL_3E = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ,
        parameter INITVAL_3D = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ,
        parameter INITVAL_3C = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ,
        parameter INITVAL_3B = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ,
        parameter INITVAL_3A = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ,
        parameter INITVAL_39 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ,
        parameter INITVAL_38 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ,
        parameter INITVAL_37 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ,
        parameter INITVAL_36 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ,
        parameter INITVAL_35 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ,
        parameter INITVAL_34 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ,
        parameter INITVAL_33 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ,
        parameter INITVAL_32 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ,
        parameter INITVAL_31 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ,
        parameter INITVAL_30 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ,
        parameter INITVAL_2F = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ,
        parameter INITVAL_2E = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ,
        parameter INITVAL_2D = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ,
        parameter INITVAL_2C = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ,
        parameter INITVAL_2B = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ,
        parameter INITVAL_2A = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ,
        parameter INITVAL_29 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ,
        parameter INITVAL_28 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ,
        parameter INITVAL_27 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ,
        parameter INITVAL_26 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ,
        parameter INITVAL_25 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ,
        parameter INITVAL_24 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ,
        parameter INITVAL_23 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ,
        parameter INITVAL_22 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ,
        parameter INITVAL_21 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ,
        parameter INITVAL_20 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ,
        parameter INITVAL_1F = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ,
        parameter INITVAL_1E = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ,
        parameter INITVAL_1D = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ,
        parameter INITVAL_1C = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ,
        parameter INITVAL_1B = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ,
        parameter INITVAL_1A = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ,
        parameter INITVAL_19 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ,
        parameter INITVAL_18 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ,
        parameter INITVAL_17 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ,
        parameter INITVAL_16 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ,
        parameter INITVAL_15 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ,
        parameter INITVAL_14 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ,
        parameter INITVAL_13 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ,
        parameter INITVAL_12 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ,
        parameter INITVAL_11 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ,
        parameter INITVAL_10 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ,
        parameter INITVAL_0F = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ,
        parameter INITVAL_0E = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ,
        parameter INITVAL_0D = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ,
        parameter INITVAL_0C = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ,
        parameter INITVAL_0B = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ,
        parameter INITVAL_0A = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ,
        parameter INITVAL_09 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ,
        parameter INITVAL_08 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ,
        parameter INITVAL_07 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ,
        parameter INITVAL_06 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ,
        parameter INITVAL_05 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ,
        parameter INITVAL_04 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ,
        parameter INITVAL_03 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ,
        parameter INITVAL_02 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ,
        parameter INITVAL_01 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" ,
        parameter INITVAL_00 = "0x00000000000000000000000000000000000000000000000000000000000000000000000000000000" 
)
(
	CLKA,
	CLKB,
	DOA,
	DOB,
	DIA,
	DIB,
	ADDRA,
	ADDRB,
	ENA,
	ENB,
	WEA,
	WEB,
	SSRA,
	SSRB
);


input wire		CLKA;
input wire		CLKB;
input wire	[17:0]	DIA;
input wire	[17:0]	DIB;
input wire	[9:0]	ADDRA;
input wire	[9:0]	ADDRB;
input wire		ENA;
input wire		ENB;
input wire		WEA;
input wire		WEB;
input wire		SSRA;
input wire		SSRB;

output wire	[17:0]	DOA;
output wire	[17:0]	DOB;

wire scuba_vhi;
wire scuba_vlo;

VHI scuba_vhi_inst (.Z(scuba_vhi));
VLO scuba_vlo_inst (.Z(scuba_vlo));

wire [17:0] DOA_internal;
wire [17:0] DOB_internal;

// instantiation according to WRITE_MODE_A and WRITE_MODE_B
generate

	// begin port a = WRITE_FIRST

	if (WRITE_MODE_A == "WRITE_FIRST")
	begin

		if (WRITE_MODE_B == "WRITE_FIRST")
		begin
		
            ssr_logic #(
            .WIDTH  (      18      ),
            .SRVAL  ( SRVAL_A      )
            ) ssr_logic_inst_a (
            .CLK    ( CLKA         ),
            .DO_in  ( DOA_internal ),
            .DO_out ( DOA          ),
            .EN     ( ENA          ),
            .SSR    ( SSRA         )
            );   
            
            ssr_logic #(
            .WIDTH  (      18      ),
            .SRVAL  ( SRVAL_B      )
            ) ssr_logic_inst_b (
            .CLK    ( CLKB         ),
            .DO_in  ( DOB_internal ),
            .DO_out ( DOB          ),
            .EN     ( ENB          ),
            .SSR    ( SSRB         )
            );  

			defparam ram_18_inst_0_0_0.INIT_DATA = "STATIC" ;
			defparam ram_18_inst_0_0_0.ASYNC_RESET_RELEASE = "SYNC" ;
			defparam ram_18_inst_0_0_0.INITVAL_3F = INITVAL_3F ;
			defparam ram_18_inst_0_0_0.INITVAL_3E = INITVAL_3E ;
			defparam ram_18_inst_0_0_0.INITVAL_3D = INITVAL_3D ;
			defparam ram_18_inst_0_0_0.INITVAL_3C = INITVAL_3C ;
			defparam ram_18_inst_0_0_0.INITVAL_3B = INITVAL_3B ;
			defparam ram_18_inst_0_0_0.INITVAL_3A = INITVAL_3A ;
			defparam ram_18_inst_0_0_0.INITVAL_39 = INITVAL_39 ;
			defparam ram_18_inst_0_0_0.INITVAL_38 = INITVAL_38 ;
			defparam ram_18_inst_0_0_0.INITVAL_37 = INITVAL_37 ;
			defparam ram_18_inst_0_0_0.INITVAL_36 = INITVAL_36 ;
			defparam ram_18_inst_0_0_0.INITVAL_35 = INITVAL_35 ;
			defparam ram_18_inst_0_0_0.INITVAL_34 = INITVAL_34 ;
			defparam ram_18_inst_0_0_0.INITVAL_33 = INITVAL_33 ;
			defparam ram_18_inst_0_0_0.INITVAL_32 = INITVAL_32 ;
			defparam ram_18_inst_0_0_0.INITVAL_31 = INITVAL_31 ;
			defparam ram_18_inst_0_0_0.INITVAL_30 = INITVAL_30 ;
			defparam ram_18_inst_0_0_0.INITVAL_2F = INITVAL_2F ;
			defparam ram_18_inst_0_0_0.INITVAL_2E = INITVAL_2E ;
			defparam ram_18_inst_0_0_0.INITVAL_2D = INITVAL_2D ;
			defparam ram_18_inst_0_0_0.INITVAL_2C = INITVAL_2C ;
			defparam ram_18_inst_0_0_0.INITVAL_2B = INITVAL_2B ;
			defparam ram_18_inst_0_0_0.INITVAL_2A = INITVAL_2A ;
			defparam ram_18_inst_0_0_0.INITVAL_29 = INITVAL_29 ;
			defparam ram_18_inst_0_0_0.INITVAL_28 = INITVAL_28 ;
			defparam ram_18_inst_0_0_0.INITVAL_27 = INITVAL_27 ;
			defparam ram_18_inst_0_0_0.INITVAL_26 = INITVAL_26 ;
			defparam ram_18_inst_0_0_0.INITVAL_25 = INITVAL_25 ;
			defparam ram_18_inst_0_0_0.INITVAL_24 = INITVAL_24 ;
			defparam ram_18_inst_0_0_0.INITVAL_23 = INITVAL_23 ;
			defparam ram_18_inst_0_0_0.INITVAL_22 = INITVAL_22 ;
			defparam ram_18_inst_0_0_0.INITVAL_21 = INITVAL_21 ;
			defparam ram_18_inst_0_0_0.INITVAL_20 = INITVAL_20 ;
			defparam ram_18_inst_0_0_0.INITVAL_1F = INITVAL_1F ;
			defparam ram_18_inst_0_0_0.INITVAL_1E = INITVAL_1E ;
			defparam ram_18_inst_0_0_0.INITVAL_1D = INITVAL_1D ;
			defparam ram_18_inst_0_0_0.INITVAL_1C = INITVAL_1C ;
			defparam ram_18_inst_0_0_0.INITVAL_1B = INITVAL_1B ;
			defparam ram_18_inst_0_0_0.INITVAL_1A = INITVAL_1A ;
			defparam ram_18_inst_0_0_0.INITVAL_19 = INITVAL_19 ;
			defparam ram_18_inst_0_0_0.INITVAL_18 = INITVAL_18 ;
			defparam ram_18_inst_0_0_0.INITVAL_17 = INITVAL_17 ;
			defparam ram_18_inst_0_0_0.INITVAL_16 = INITVAL_16 ;
			defparam ram_18_inst_0_0_0.INITVAL_15 = INITVAL_15 ;
			defparam ram_18_inst_0_0_0.INITVAL_14 = INITVAL_14 ;
			defparam ram_18_inst_0_0_0.INITVAL_13 = INITVAL_13 ;
			defparam ram_18_inst_0_0_0.INITVAL_12 = INITVAL_12 ;
			defparam ram_18_inst_0_0_0.INITVAL_11 = INITVAL_11 ;
			defparam ram_18_inst_0_0_0.INITVAL_10 = INITVAL_10 ;
			defparam ram_18_inst_0_0_0.INITVAL_0F = INITVAL_0F ;
			defparam ram_18_inst_0_0_0.INITVAL_0E = INITVAL_0E ;
			defparam ram_18_inst_0_0_0.INITVAL_0D = INITVAL_0D ;
			defparam ram_18_inst_0_0_0.INITVAL_0C = INITVAL_0C ;
			defparam ram_18_inst_0_0_0.INITVAL_0B = INITVAL_0B ;
			defparam ram_18_inst_0_0_0.INITVAL_0A = INITVAL_0A ;
			defparam ram_18_inst_0_0_0.INITVAL_09 = INITVAL_09 ;
			defparam ram_18_inst_0_0_0.INITVAL_08 = INITVAL_08 ;
			defparam ram_18_inst_0_0_0.INITVAL_07 = INITVAL_07 ;
			defparam ram_18_inst_0_0_0.INITVAL_06 = INITVAL_06 ;
			defparam ram_18_inst_0_0_0.INITVAL_05 = INITVAL_05 ;
			defparam ram_18_inst_0_0_0.INITVAL_04 = INITVAL_04 ;
			defparam ram_18_inst_0_0_0.INITVAL_03 = INITVAL_03 ;
			defparam ram_18_inst_0_0_0.INITVAL_02 = INITVAL_02 ;
			defparam ram_18_inst_0_0_0.INITVAL_01 = INITVAL_01 ;
			defparam ram_18_inst_0_0_0.INITVAL_00 = INITVAL_00 ;
			defparam ram_18_inst_0_0_0.CSDECODE_A = "0b000" ;
			defparam ram_18_inst_0_0_0.CSDECODE_B = "0b000" ;
			defparam ram_18_inst_0_0_0.WRITEMODE_A = "WRITETHROUGH" ;
			defparam ram_18_inst_0_0_0.WRITEMODE_B = "WRITETHROUGH" ;
			defparam ram_18_inst_0_0_0.GSR = "DISABLED" ;
			defparam ram_18_inst_0_0_0.RESETMODE = "ASYNC" ;
 			defparam ram_18_inst_0_0_0.REGMODE_A = "NOREG" ;
			defparam ram_18_inst_0_0_0.REGMODE_B = "NOREG" ;
			defparam ram_18_inst_0_0_0.DATA_WIDTH_A = 18 ;
			defparam ram_18_inst_0_0_0.DATA_WIDTH_B = 18 ;
			DP16KD ram_18_inst_0_0_0 (
						    .DIA0(DIA[0]), 
						    .DIA1(DIA[1]), 
						    .DIA2(DIA[2]), 
						    .DIA3(DIA[3]), 
						    .DIA4(DIA[4]), 
						    .DIA5(DIA[5]), 
						    .DIA6(DIA[6]), 
						    .DIA7(DIA[7]), 
						    .DIA8(DIA[8]), 
						    .DIA9(DIA[9]), 
						    .DIA10(DIA[10]), 
						    .DIA11(DIA[11]), 
						    .DIA12(DIA[12]), 
						    .DIA13(DIA[13]), 
						    .DIA14(DIA[14]), 
						    .DIA15(DIA[15]), 
						    .DIA16(DIA[16]), 
						    .DIA17(DIA[17]), 
						    .ADA0(scuba_vhi), 
						    .ADA1(scuba_vhi), 
						    .ADA2(scuba_vlo), 
						    .ADA3(scuba_vlo), 
						    .ADA4(ADDRA[0]), 
						    .ADA5(ADDRA[1]), 
						    .ADA6(ADDRA[2]), 
						    .ADA7(ADDRA[3]), 
						    .ADA8(ADDRA[4]), 
						    .ADA9(ADDRA[5]), 
						    .ADA10(ADDRA[6]), 
						    .ADA11(ADDRA[7]), 
						    .ADA12(ADDRA[8]), 
						    .ADA13(ADDRA[9]), 
						    .CEA(ENA), 
						    .CLKA(CLKA), 
						    .OCEA(ENA), 
						    .WEA(WEA), 
						    .CSA0(scuba_vlo), 
						    .CSA1(scuba_vlo), 
						    .CSA2(scuba_vlo), 
						    .RSTA(scuba_vlo), 
						    .DIB0(DIB[0]), 
						    .DIB1(DIB[1]), 
						    .DIB2(DIB[2]), 
						    .DIB3(DIB[3]), 
						    .DIB4(DIB[4]), 
						    .DIB5(DIB[5]), 
						    .DIB6(DIB[6]), 
						    .DIB7(DIB[7]), 
						    .DIB8(DIB[8]), 
						    .DIB9(DIB[9]), 
						    .DIB10(DIB[10]), 
						    .DIB11(DIB[11]), 
						    .DIB12(DIB[12]), 
						    .DIB13(DIB[13]), 
						    .DIB14(DIB[14]), 
						    .DIB15(DIB[15]), 
						    .DIB16(DIB[16]), 
						    .DIB17(DIB[17]), 
						    .ADB0(scuba_vhi), 
						    .ADB1(scuba_vhi), 
						    .ADB2(scuba_vlo), 
						    .ADB3(scuba_vlo), 
						    .ADB4(ADDRB[0]), 
						    .ADB5(ADDRB[1]), 
						    .ADB6(ADDRB[2]), 
						    .ADB7(ADDRB[3]), 
						    .ADB8(ADDRB[4]), 
						    .ADB9(ADDRB[5]), 
						    .ADB10(ADDRB[6]), 
						    .ADB11(ADDRB[7]), 
						    .ADB12(ADDRB[8]), 
						    .ADB13(ADDRB[9]), 
						    .CEB(ENB), 
						    .CLKB(CLKB), 
						    .OCEB(ENB), 
						    .WEB(WEB), 
						    .CSB0(scuba_vlo), 
						    .CSB1(scuba_vlo), 
						    .CSB2(scuba_vlo), 
						    .RSTB(scuba_vlo), 
						    .DOA0(DOA_internal[0]), 
						    .DOA1(DOA_internal[1]), 
						    .DOA2(DOA_internal[2]), 
						    .DOA3(DOA_internal[3]), 
						    .DOA4(DOA_internal[4]), 
						    .DOA5(DOA_internal[5]), 
						    .DOA6(DOA_internal[6]), 
						    .DOA7(DOA_internal[7]), 
						    .DOA8(DOA_internal[8]), 
						    .DOA9(DOA_internal[9]), 
						    .DOA10(DOA_internal[10]),
						    .DOA11(DOA_internal[11]), 
						    .DOA12(DOA_internal[12]), 
						    .DOA13(DOA_internal[13]), 
						    .DOA14(DOA_internal[14]), 
						    .DOA15(DOA_internal[15]), 
						    .DOA16(DOA_internal[16]), 
						    .DOA17(DOA_internal[17]), 
						    .DOB0(DOB_internal[0]), 
						    .DOB1(DOB_internal[1]), 
						    .DOB2(DOB_internal[2]), 
						    .DOB3(DOB_internal[3]), 
						    .DOB4(DOB_internal[4]), 
						    .DOB5(DOB_internal[5]), 
						    .DOB6(DOB_internal[6]), 
						    .DOB7(DOB_internal[7]), 
						    .DOB8(DOB_internal[8]), 
						    .DOB9(DOB_internal[9]), 
						    .DOB10(DOB_internal[10]), 
						    .DOB11(DOB_internal[11]),
						    .DOB12(DOB_internal[12]), 
						    .DOB13(DOB_internal[13]), 
						    .DOB14(DOB_internal[14]), 
						    .DOB15(DOB_internal[15]), 
						    .DOB16(DOB_internal[16]), 
						    .DOB17(DOB_internal[17]));

		end
		else if (WRITE_MODE_B == "READ_FIRST")
		begin
		
            ssr_logic #(
            .WIDTH  (      18      ),
            .SRVAL  ( SRVAL_A      )
            ) ssr_logic_inst_a (
            .CLK    ( CLKA         ),
            .DO_in  ( DOA_internal ),
            .DO_out ( DOA          ),
            .EN     ( ENA          ),
            .SSR    ( SSRA         )
            );   
            
            ssr_logic #(
            .WIDTH  (      18      ),
            .SRVAL  ( SRVAL_B      )
            ) ssr_logic_inst_b (
            .CLK    ( CLKB         ),
            .DO_in  ( DOB_internal ),
            .DO_out ( DOB          ),
            .EN     ( ENB          ),
            .SSR    ( SSRB         )
            );

			defparam ram_18_inst_0_0_0.INIT_DATA = "STATIC" ;
			defparam ram_18_inst_0_0_0.ASYNC_RESET_RELEASE = "SYNC" ;
			defparam ram_18_inst_0_0_0.INITVAL_3F = INITVAL_3F ;
			defparam ram_18_inst_0_0_0.INITVAL_3E = INITVAL_3E ;
			defparam ram_18_inst_0_0_0.INITVAL_3D = INITVAL_3D ;
			defparam ram_18_inst_0_0_0.INITVAL_3C = INITVAL_3C ;
			defparam ram_18_inst_0_0_0.INITVAL_3B = INITVAL_3B ;
			defparam ram_18_inst_0_0_0.INITVAL_3A = INITVAL_3A ;
			defparam ram_18_inst_0_0_0.INITVAL_39 = INITVAL_39 ;
			defparam ram_18_inst_0_0_0.INITVAL_38 = INITVAL_38 ;
			defparam ram_18_inst_0_0_0.INITVAL_37 = INITVAL_37 ;
			defparam ram_18_inst_0_0_0.INITVAL_36 = INITVAL_36 ;
			defparam ram_18_inst_0_0_0.INITVAL_35 = INITVAL_35 ;
			defparam ram_18_inst_0_0_0.INITVAL_34 = INITVAL_34 ;
			defparam ram_18_inst_0_0_0.INITVAL_33 = INITVAL_33 ;
			defparam ram_18_inst_0_0_0.INITVAL_32 = INITVAL_32 ;
			defparam ram_18_inst_0_0_0.INITVAL_31 = INITVAL_31 ;
			defparam ram_18_inst_0_0_0.INITVAL_30 = INITVAL_30 ;
			defparam ram_18_inst_0_0_0.INITVAL_2F = INITVAL_2F ;
			defparam ram_18_inst_0_0_0.INITVAL_2E = INITVAL_2E ;
			defparam ram_18_inst_0_0_0.INITVAL_2D = INITVAL_2D ;
			defparam ram_18_inst_0_0_0.INITVAL_2C = INITVAL_2C ;
			defparam ram_18_inst_0_0_0.INITVAL_2B = INITVAL_2B ;
			defparam ram_18_inst_0_0_0.INITVAL_2A = INITVAL_2A ;
			defparam ram_18_inst_0_0_0.INITVAL_29 = INITVAL_29 ;
			defparam ram_18_inst_0_0_0.INITVAL_28 = INITVAL_28 ;
			defparam ram_18_inst_0_0_0.INITVAL_27 = INITVAL_27 ;
			defparam ram_18_inst_0_0_0.INITVAL_26 = INITVAL_26 ;
			defparam ram_18_inst_0_0_0.INITVAL_25 = INITVAL_25 ;
			defparam ram_18_inst_0_0_0.INITVAL_24 = INITVAL_24 ;
			defparam ram_18_inst_0_0_0.INITVAL_23 = INITVAL_23 ;
			defparam ram_18_inst_0_0_0.INITVAL_22 = INITVAL_22 ;
			defparam ram_18_inst_0_0_0.INITVAL_21 = INITVAL_21 ;
			defparam ram_18_inst_0_0_0.INITVAL_20 = INITVAL_20 ;
			defparam ram_18_inst_0_0_0.INITVAL_1F = INITVAL_1F ;
			defparam ram_18_inst_0_0_0.INITVAL_1E = INITVAL_1E ;
			defparam ram_18_inst_0_0_0.INITVAL_1D = INITVAL_1D ;
			defparam ram_18_inst_0_0_0.INITVAL_1C = INITVAL_1C ;
			defparam ram_18_inst_0_0_0.INITVAL_1B = INITVAL_1B ;
			defparam ram_18_inst_0_0_0.INITVAL_1A = INITVAL_1A ;
			defparam ram_18_inst_0_0_0.INITVAL_19 = INITVAL_19 ;
			defparam ram_18_inst_0_0_0.INITVAL_18 = INITVAL_18 ;
			defparam ram_18_inst_0_0_0.INITVAL_17 = INITVAL_17 ;
			defparam ram_18_inst_0_0_0.INITVAL_16 = INITVAL_16 ;
			defparam ram_18_inst_0_0_0.INITVAL_15 = INITVAL_15 ;
			defparam ram_18_inst_0_0_0.INITVAL_14 = INITVAL_14 ;
			defparam ram_18_inst_0_0_0.INITVAL_13 = INITVAL_13 ;
			defparam ram_18_inst_0_0_0.INITVAL_12 = INITVAL_12 ;
			defparam ram_18_inst_0_0_0.INITVAL_11 = INITVAL_11 ;
			defparam ram_18_inst_0_0_0.INITVAL_10 = INITVAL_10 ;
			defparam ram_18_inst_0_0_0.INITVAL_0F = INITVAL_0F ;
			defparam ram_18_inst_0_0_0.INITVAL_0E = INITVAL_0E ;
			defparam ram_18_inst_0_0_0.INITVAL_0D = INITVAL_0D ;
			defparam ram_18_inst_0_0_0.INITVAL_0C = INITVAL_0C ;
			defparam ram_18_inst_0_0_0.INITVAL_0B = INITVAL_0B ;
			defparam ram_18_inst_0_0_0.INITVAL_0A = INITVAL_0A ;
			defparam ram_18_inst_0_0_0.INITVAL_09 = INITVAL_09 ;
			defparam ram_18_inst_0_0_0.INITVAL_08 = INITVAL_08 ;
			defparam ram_18_inst_0_0_0.INITVAL_07 = INITVAL_07 ;
			defparam ram_18_inst_0_0_0.INITVAL_06 = INITVAL_06 ;
			defparam ram_18_inst_0_0_0.INITVAL_05 = INITVAL_05 ;
			defparam ram_18_inst_0_0_0.INITVAL_04 = INITVAL_04 ;
			defparam ram_18_inst_0_0_0.INITVAL_03 = INITVAL_03 ;
			defparam ram_18_inst_0_0_0.INITVAL_02 = INITVAL_02 ;
			defparam ram_18_inst_0_0_0.INITVAL_01 = INITVAL_01 ;
			defparam ram_18_inst_0_0_0.INITVAL_00 = INITVAL_00 ;
			defparam ram_18_inst_0_0_0.CSDECODE_A = "0b000" ;
			defparam ram_18_inst_0_0_0.CSDECODE_B = "0b000" ;
			defparam ram_18_inst_0_0_0.WRITEMODE_A = "WRITETHROUGH" ;
			defparam ram_18_inst_0_0_0.WRITEMODE_B = "READBEFOREWRITE" ;
			defparam ram_18_inst_0_0_0.GSR = "DISABLED" ;
			defparam ram_18_inst_0_0_0.RESETMODE = "ASYNC" ;
 			defparam ram_18_inst_0_0_0.REGMODE_A = "NOREG" ;
			defparam ram_18_inst_0_0_0.REGMODE_B = "NOREG" ;
			defparam ram_18_inst_0_0_0.DATA_WIDTH_A = 18 ;
			defparam ram_18_inst_0_0_0.DATA_WIDTH_B = 18 ;
			DP16KD ram_18_inst_0_0_0 (
						    .DIA0(DIA[0]), 
						    .DIA1(DIA[1]), 
						    .DIA2(DIA[2]), 
						    .DIA3(DIA[3]), 
						    .DIA4(DIA[4]), 
						    .DIA5(DIA[5]), 
						    .DIA6(DIA[6]), 
						    .DIA7(DIA[7]), 
						    .DIA8(DIA[8]), 
						    .DIA9(DIA[9]), 
						    .DIA10(DIA[10]), 
						    .DIA11(DIA[11]), 
						    .DIA12(DIA[12]), 
						    .DIA13(DIA[13]), 
						    .DIA14(DIA[14]), 
						    .DIA15(DIA[15]), 
						    .DIA16(DIA[16]), 
						    .DIA17(DIA[17]), 
						    .ADA0(scuba_vhi), 
						    .ADA1(scuba_vhi), 
						    .ADA2(scuba_vlo), 
						    .ADA3(scuba_vlo), 
						    .ADA4(ADDRA[0]), 
						    .ADA5(ADDRA[1]), 
						    .ADA6(ADDRA[2]), 
						    .ADA7(ADDRA[3]), 
						    .ADA8(ADDRA[4]), 
						    .ADA9(ADDRA[5]), 
						    .ADA10(ADDRA[6]), 
						    .ADA11(ADDRA[7]), 
						    .ADA12(ADDRA[8]), 
						    .ADA13(ADDRA[9]), 
						    .CEA(ENA), 
						    .CLKA(CLKA), 
						    .OCEA(ENA), 
						    .WEA(WEA), 
						    .CSA0(scuba_vlo), 
						    .CSA1(scuba_vlo), 
						    .CSA2(scuba_vlo), 
						    .RSTA(scuba_vlo), 
						    .DIB0(DIB[0]), 
						    .DIB1(DIB[1]), 
						    .DIB2(DIB[2]), 
						    .DIB3(DIB[3]), 
						    .DIB4(DIB[4]), 
						    .DIB5(DIB[5]), 
						    .DIB6(DIB[6]), 
						    .DIB7(DIB[7]), 
						    .DIB8(DIB[8]), 
						    .DIB9(DIB[9]), 
						    .DIB10(DIB[10]), 
						    .DIB11(DIB[11]), 
						    .DIB12(DIB[12]), 
						    .DIB13(DIB[13]), 
						    .DIB14(DIB[14]), 
						    .DIB15(DIB[15]), 
						    .DIB16(DIB[16]), 
						    .DIB17(DIB[17]), 
						    .ADB0(scuba_vhi), 
						    .ADB1(scuba_vhi), 
						    .ADB2(scuba_vlo), 
						    .ADB3(scuba_vlo), 
						    .ADB4(ADDRB[0]), 
						    .ADB5(ADDRB[1]), 
						    .ADB6(ADDRB[2]), 
						    .ADB7(ADDRB[3]), 
						    .ADB8(ADDRB[4]), 
						    .ADB9(ADDRB[5]), 
						    .ADB10(ADDRB[6]), 
						    .ADB11(ADDRB[7]), 
						    .ADB12(ADDRB[8]), 
						    .ADB13(ADDRB[9]), 
						    .CEB(ENB), 
						    .CLKB(CLKB), 
						    .OCEB(ENB), 
						    .WEB(WEB), 
						    .CSB0(scuba_vlo), 
						    .CSB1(scuba_vlo), 
						    .CSB2(scuba_vlo), 
						    .RSTB(scuba_vlo), 
						    .DOA0(DOA_internal[0]), 
						    .DOA1(DOA_internal[1]), 
						    .DOA2(DOA_internal[2]), 
						    .DOA3(DOA_internal[3]), 
						    .DOA4(DOA_internal[4]), 
						    .DOA5(DOA_internal[5]), 
						    .DOA6(DOA_internal[6]), 
						    .DOA7(DOA_internal[7]), 
						    .DOA8(DOA_internal[8]), 
						    .DOA9(DOA_internal[9]), 
						    .DOA10(DOA_internal[10]),
						    .DOA11(DOA_internal[11]), 
						    .DOA12(DOA_internal[12]), 
						    .DOA13(DOA_internal[13]), 
						    .DOA14(DOA_internal[14]), 
						    .DOA15(DOA_internal[15]), 
						    .DOA16(DOA_internal[16]), 
						    .DOA17(DOA_internal[17]), 
						    .DOB0(DOB_internal[0]), 
						    .DOB1(DOB_internal[1]), 
						    .DOB2(DOB_internal[2]), 
						    .DOB3(DOB_internal[3]), 
						    .DOB4(DOB_internal[4]), 
						    .DOB5(DOB_internal[5]), 
						    .DOB6(DOB_internal[6]), 
						    .DOB7(DOB_internal[7]), 
						    .DOB8(DOB_internal[8]), 
						    .DOB9(DOB_internal[9]), 
						    .DOB10(DOB_internal[10]), 
						    .DOB11(DOB_internal[11]),
						    .DOB12(DOB_internal[12]), 
						    .DOB13(DOB_internal[13]), 
						    .DOB14(DOB_internal[14]), 
						    .DOB15(DOB_internal[15]), 
						    .DOB16(DOB_internal[16]), 
						    .DOB17(DOB_internal[17]));

		end
		else if (WRITE_MODE_B == "NO_CHANGE")
		begin

            ssr_logic #(
            .WIDTH  (      18      ),
            .SRVAL  ( SRVAL_A      )
            ) ssr_logic_inst_a (
            .CLK    ( CLKA         ),
            .DO_in  ( DOA_internal ),
            .DO_out ( DOA          ),
            .EN     ( ENA          ),
            .SSR    ( SSRA         )
            );   
            
            nochange_ssr_logic #(
            .WIDTH  (      18      ),
            .SRVAL  ( SRVAL_B      )
            ) nochange_ssr_logic_inst_b (
            .CLK    ( CLKB         ),
            .DO_in  ( DOB_internal ),
            .DO_out ( DOB          ),
            .EN     ( ENB          ),
            .WE     ( WEB          ),
            .SSR    ( SSRB         )
            );   

			defparam ram_18_inst_0_0_0.INIT_DATA = "STATIC" ;
			defparam ram_18_inst_0_0_0.ASYNC_RESET_RELEASE = "SYNC" ;
			defparam ram_18_inst_0_0_0.INITVAL_3F = INITVAL_3F ;
			defparam ram_18_inst_0_0_0.INITVAL_3E = INITVAL_3E ;
			defparam ram_18_inst_0_0_0.INITVAL_3D = INITVAL_3D ;
			defparam ram_18_inst_0_0_0.INITVAL_3C = INITVAL_3C ;
			defparam ram_18_inst_0_0_0.INITVAL_3B = INITVAL_3B ;
			defparam ram_18_inst_0_0_0.INITVAL_3A = INITVAL_3A ;
			defparam ram_18_inst_0_0_0.INITVAL_39 = INITVAL_39 ;
			defparam ram_18_inst_0_0_0.INITVAL_38 = INITVAL_38 ;
			defparam ram_18_inst_0_0_0.INITVAL_37 = INITVAL_37 ;
			defparam ram_18_inst_0_0_0.INITVAL_36 = INITVAL_36 ;
			defparam ram_18_inst_0_0_0.INITVAL_35 = INITVAL_35 ;
			defparam ram_18_inst_0_0_0.INITVAL_34 = INITVAL_34 ;
			defparam ram_18_inst_0_0_0.INITVAL_33 = INITVAL_33 ;
			defparam ram_18_inst_0_0_0.INITVAL_32 = INITVAL_32 ;
			defparam ram_18_inst_0_0_0.INITVAL_31 = INITVAL_31 ;
			defparam ram_18_inst_0_0_0.INITVAL_30 = INITVAL_30 ;
			defparam ram_18_inst_0_0_0.INITVAL_2F = INITVAL_2F ;
			defparam ram_18_inst_0_0_0.INITVAL_2E = INITVAL_2E ;
			defparam ram_18_inst_0_0_0.INITVAL_2D = INITVAL_2D ;
			defparam ram_18_inst_0_0_0.INITVAL_2C = INITVAL_2C ;
			defparam ram_18_inst_0_0_0.INITVAL_2B = INITVAL_2B ;
			defparam ram_18_inst_0_0_0.INITVAL_2A = INITVAL_2A ;
			defparam ram_18_inst_0_0_0.INITVAL_29 = INITVAL_29 ;
			defparam ram_18_inst_0_0_0.INITVAL_28 = INITVAL_28 ;
			defparam ram_18_inst_0_0_0.INITVAL_27 = INITVAL_27 ;
			defparam ram_18_inst_0_0_0.INITVAL_26 = INITVAL_26 ;
			defparam ram_18_inst_0_0_0.INITVAL_25 = INITVAL_25 ;
			defparam ram_18_inst_0_0_0.INITVAL_24 = INITVAL_24 ;
			defparam ram_18_inst_0_0_0.INITVAL_23 = INITVAL_23 ;
			defparam ram_18_inst_0_0_0.INITVAL_22 = INITVAL_22 ;
			defparam ram_18_inst_0_0_0.INITVAL_21 = INITVAL_21 ;
			defparam ram_18_inst_0_0_0.INITVAL_20 = INITVAL_20 ;
			defparam ram_18_inst_0_0_0.INITVAL_1F = INITVAL_1F ;
			defparam ram_18_inst_0_0_0.INITVAL_1E = INITVAL_1E ;
			defparam ram_18_inst_0_0_0.INITVAL_1D = INITVAL_1D ;
			defparam ram_18_inst_0_0_0.INITVAL_1C = INITVAL_1C ;
			defparam ram_18_inst_0_0_0.INITVAL_1B = INITVAL_1B ;
			defparam ram_18_inst_0_0_0.INITVAL_1A = INITVAL_1A ;
			defparam ram_18_inst_0_0_0.INITVAL_19 = INITVAL_19 ;
			defparam ram_18_inst_0_0_0.INITVAL_18 = INITVAL_18 ;
			defparam ram_18_inst_0_0_0.INITVAL_17 = INITVAL_17 ;
			defparam ram_18_inst_0_0_0.INITVAL_16 = INITVAL_16 ;
			defparam ram_18_inst_0_0_0.INITVAL_15 = INITVAL_15 ;
			defparam ram_18_inst_0_0_0.INITVAL_14 = INITVAL_14 ;
			defparam ram_18_inst_0_0_0.INITVAL_13 = INITVAL_13 ;
			defparam ram_18_inst_0_0_0.INITVAL_12 = INITVAL_12 ;
			defparam ram_18_inst_0_0_0.INITVAL_11 = INITVAL_11 ;
			defparam ram_18_inst_0_0_0.INITVAL_10 = INITVAL_10 ;
			defparam ram_18_inst_0_0_0.INITVAL_0F = INITVAL_0F ;
			defparam ram_18_inst_0_0_0.INITVAL_0E = INITVAL_0E ;
			defparam ram_18_inst_0_0_0.INITVAL_0D = INITVAL_0D ;
			defparam ram_18_inst_0_0_0.INITVAL_0C = INITVAL_0C ;
			defparam ram_18_inst_0_0_0.INITVAL_0B = INITVAL_0B ;
			defparam ram_18_inst_0_0_0.INITVAL_0A = INITVAL_0A ;
			defparam ram_18_inst_0_0_0.INITVAL_09 = INITVAL_09 ;
			defparam ram_18_inst_0_0_0.INITVAL_08 = INITVAL_08 ;
			defparam ram_18_inst_0_0_0.INITVAL_07 = INITVAL_07 ;
			defparam ram_18_inst_0_0_0.INITVAL_06 = INITVAL_06 ;
			defparam ram_18_inst_0_0_0.INITVAL_05 = INITVAL_05 ;
			defparam ram_18_inst_0_0_0.INITVAL_04 = INITVAL_04 ;
			defparam ram_18_inst_0_0_0.INITVAL_03 = INITVAL_03 ;
			defparam ram_18_inst_0_0_0.INITVAL_02 = INITVAL_02 ;
			defparam ram_18_inst_0_0_0.INITVAL_01 = INITVAL_01 ;
			defparam ram_18_inst_0_0_0.INITVAL_00 = INITVAL_00 ;
			defparam ram_18_inst_0_0_0.CSDECODE_A = "0b000" ;
			defparam ram_18_inst_0_0_0.CSDECODE_B = "0b000" ;
			defparam ram_18_inst_0_0_0.WRITEMODE_A = "WRITETHROUGH" ;
			defparam ram_18_inst_0_0_0.WRITEMODE_B = "WRITETHROUGH" ;
			defparam ram_18_inst_0_0_0.GSR = "DISABLED" ;
			defparam ram_18_inst_0_0_0.RESETMODE = "ASYNC" ;
 			defparam ram_18_inst_0_0_0.REGMODE_A = "NOREG" ;
			defparam ram_18_inst_0_0_0.REGMODE_B = "NOREG" ;
			defparam ram_18_inst_0_0_0.DATA_WIDTH_A = 18 ;
			defparam ram_18_inst_0_0_0.DATA_WIDTH_B = 18 ;
			DP16KD ram_18_inst_0_0_0 (
						    .DIA0(DIA[0]), 
						    .DIA1(DIA[1]), 
						    .DIA2(DIA[2]), 
						    .DIA3(DIA[3]), 
						    .DIA4(DIA[4]), 
						    .DIA5(DIA[5]), 
						    .DIA6(DIA[6]), 
						    .DIA7(DIA[7]), 
						    .DIA8(DIA[8]), 
						    .DIA9(DIA[9]), 
						    .DIA10(DIA[10]), 
						    .DIA11(DIA[11]), 
						    .DIA12(DIA[12]), 
						    .DIA13(DIA[13]), 
						    .DIA14(DIA[14]), 
						    .DIA15(DIA[15]), 
						    .DIA16(DIA[16]), 
						    .DIA17(DIA[17]), 
						    .ADA0(scuba_vhi), 
						    .ADA1(scuba_vhi), 
						    .ADA2(scuba_vlo), 
						    .ADA3(scuba_vlo), 
						    .ADA4(ADDRA[0]), 
						    .ADA5(ADDRA[1]), 
						    .ADA6(ADDRA[2]), 
						    .ADA7(ADDRA[3]), 
						    .ADA8(ADDRA[4]), 
						    .ADA9(ADDRA[5]), 
						    .ADA10(ADDRA[6]), 
						    .ADA11(ADDRA[7]), 
						    .ADA12(ADDRA[8]), 
						    .ADA13(ADDRA[9]), 
						    .CEA(ENA), 
						    .CLKA(CLKA), 
						    .OCEA(ENA), 
						    .WEA(WEA), 
						    .CSA0(scuba_vlo), 
						    .CSA1(scuba_vlo), 
						    .CSA2(scuba_vlo), 
						    .RSTA(scuba_vlo), 
						    .DIB0(DIB[0]), 
						    .DIB1(DIB[1]), 
						    .DIB2(DIB[2]), 
						    .DIB3(DIB[3]), 
						    .DIB4(DIB[4]), 
						    .DIB5(DIB[5]), 
						    .DIB6(DIB[6]), 
						    .DIB7(DIB[7]), 
						    .DIB8(DIB[8]), 
						    .DIB9(DIB[9]), 
						    .DIB10(DIB[10]), 
						    .DIB11(DIB[11]), 
						    .DIB12(DIB[12]), 
						    .DIB13(DIB[13]), 
						    .DIB14(DIB[14]), 
						    .DIB15(DIB[15]), 
						    .DIB16(DIB[16]), 
						    .DIB17(DIB[17]), 
						    .ADB0(scuba_vhi), 
						    .ADB1(scuba_vhi), 
						    .ADB2(scuba_vlo), 
						    .ADB3(scuba_vlo), 
						    .ADB4(ADDRB[0]), 
						    .ADB5(ADDRB[1]), 
						    .ADB6(ADDRB[2]), 
						    .ADB7(ADDRB[3]), 
						    .ADB8(ADDRB[4]), 
						    .ADB9(ADDRB[5]), 
						    .ADB10(ADDRB[6]), 
						    .ADB11(ADDRB[7]), 
						    .ADB12(ADDRB[8]), 
						    .ADB13(ADDRB[9]), 
						    .CEB(ENB), 
						    .CLKB(CLKB), 
						    .OCEB(ENB), 
						    .WEB(WEB), 
						    .CSB0(scuba_vlo), 
						    .CSB1(scuba_vlo), 
						    .CSB2(scuba_vlo), 
						    .RSTB(scuba_vlo), 
						    .DOA0(DOA_internal[0]), 
						    .DOA1(DOA_internal[1]), 
						    .DOA2(DOA_internal[2]), 
						    .DOA3(DOA_internal[3]), 
						    .DOA4(DOA_internal[4]), 
						    .DOA5(DOA_internal[5]), 
						    .DOA6(DOA_internal[6]), 
						    .DOA7(DOA_internal[7]), 
						    .DOA8(DOA_internal[8]), 
						    .DOA9(DOA_internal[9]), 
						    .DOA10(DOA_internal[10]),
						    .DOA11(DOA_internal[11]), 
						    .DOA12(DOA_internal[12]), 
						    .DOA13(DOA_internal[13]), 
						    .DOA14(DOA_internal[14]), 
						    .DOA15(DOA_internal[15]), 
						    .DOA16(DOA_internal[16]), 
						    .DOA17(DOA_internal[17]), 
						    .DOB0(DOB_internal[0]), 
						    .DOB1(DOB_internal[1]), 
						    .DOB2(DOB_internal[2]), 
						    .DOB3(DOB_internal[3]), 
						    .DOB4(DOB_internal[4]), 
						    .DOB5(DOB_internal[5]), 
						    .DOB6(DOB_internal[6]), 
						    .DOB7(DOB_internal[7]), 
						    .DOB8(DOB_internal[8]), 
						    .DOB9(DOB_internal[9]), 
						    .DOB10(DOB_internal[10]), 
						    .DOB11(DOB_internal[11]),
						    .DOB12(DOB_internal[12]), 
						    .DOB13(DOB_internal[13]), 
						    .DOB14(DOB_internal[14]), 
						    .DOB15(DOB_internal[15]), 
						    .DOB16(DOB_internal[16]), 
						    .DOB17(DOB_internal[17]));

		end
		else
		begin
		
            ssr_logic #(
            .WIDTH  (      18      ),
            .SRVAL  ( SRVAL_A      )
            ) ssr_logic_inst_a (
            .CLK    ( CLKA         ),
            .DO_in  ( DOA_internal ),
            .DO_out ( DOA          ),
            .EN     ( ENA          ),
            .SSR    ( SSRA         )
            );   
            
            ssr_logic #(
            .WIDTH  (      18      ),
            .SRVAL  ( SRVAL_B      )
            ) ssr_logic_inst_b (
            .CLK    ( CLKB         ),
            .DO_in  ( DOB_internal ),
            .DO_out ( DOB          ),
            .EN     ( ENB          ),
            .SSR    ( SSRB         )
            );   

			defparam ram_18_inst_0_0_0.INIT_DATA = "STATIC" ;
			defparam ram_18_inst_0_0_0.ASYNC_RESET_RELEASE = "SYNC" ;
			defparam ram_18_inst_0_0_0.INITVAL_3F = INITVAL_3F ;
			defparam ram_18_inst_0_0_0.INITVAL_3E = INITVAL_3E ;
			defparam ram_18_inst_0_0_0.INITVAL_3D = INITVAL_3D ;
			defparam ram_18_inst_0_0_0.INITVAL_3C = INITVAL_3C ;
			defparam ram_18_inst_0_0_0.INITVAL_3B = INITVAL_3B ;
			defparam ram_18_inst_0_0_0.INITVAL_3A = INITVAL_3A ;
			defparam ram_18_inst_0_0_0.INITVAL_39 = INITVAL_39 ;
			defparam ram_18_inst_0_0_0.INITVAL_38 = INITVAL_38 ;
			defparam ram_18_inst_0_0_0.INITVAL_37 = INITVAL_37 ;
			defparam ram_18_inst_0_0_0.INITVAL_36 = INITVAL_36 ;
			defparam ram_18_inst_0_0_0.INITVAL_35 = INITVAL_35 ;
			defparam ram_18_inst_0_0_0.INITVAL_34 = INITVAL_34 ;
			defparam ram_18_inst_0_0_0.INITVAL_33 = INITVAL_33 ;
			defparam ram_18_inst_0_0_0.INITVAL_32 = INITVAL_32 ;
			defparam ram_18_inst_0_0_0.INITVAL_31 = INITVAL_31 ;
			defparam ram_18_inst_0_0_0.INITVAL_30 = INITVAL_30 ;
			defparam ram_18_inst_0_0_0.INITVAL_2F = INITVAL_2F ;
			defparam ram_18_inst_0_0_0.INITVAL_2E = INITVAL_2E ;
			defparam ram_18_inst_0_0_0.INITVAL_2D = INITVAL_2D ;
			defparam ram_18_inst_0_0_0.INITVAL_2C = INITVAL_2C ;
			defparam ram_18_inst_0_0_0.INITVAL_2B = INITVAL_2B ;
			defparam ram_18_inst_0_0_0.INITVAL_2A = INITVAL_2A ;
			defparam ram_18_inst_0_0_0.INITVAL_29 = INITVAL_29 ;
			defparam ram_18_inst_0_0_0.INITVAL_28 = INITVAL_28 ;
			defparam ram_18_inst_0_0_0.INITVAL_27 = INITVAL_27 ;
			defparam ram_18_inst_0_0_0.INITVAL_26 = INITVAL_26 ;
			defparam ram_18_inst_0_0_0.INITVAL_25 = INITVAL_25 ;
			defparam ram_18_inst_0_0_0.INITVAL_24 = INITVAL_24 ;
			defparam ram_18_inst_0_0_0.INITVAL_23 = INITVAL_23 ;
			defparam ram_18_inst_0_0_0.INITVAL_22 = INITVAL_22 ;
			defparam ram_18_inst_0_0_0.INITVAL_21 = INITVAL_21 ;
			defparam ram_18_inst_0_0_0.INITVAL_20 = INITVAL_20 ;
			defparam ram_18_inst_0_0_0.INITVAL_1F = INITVAL_1F ;
			defparam ram_18_inst_0_0_0.INITVAL_1E = INITVAL_1E ;
			defparam ram_18_inst_0_0_0.INITVAL_1D = INITVAL_1D ;
			defparam ram_18_inst_0_0_0.INITVAL_1C = INITVAL_1C ;
			defparam ram_18_inst_0_0_0.INITVAL_1B = INITVAL_1B ;
			defparam ram_18_inst_0_0_0.INITVAL_1A = INITVAL_1A ;
			defparam ram_18_inst_0_0_0.INITVAL_19 = INITVAL_19 ;
			defparam ram_18_inst_0_0_0.INITVAL_18 = INITVAL_18 ;
			defparam ram_18_inst_0_0_0.INITVAL_17 = INITVAL_17 ;
			defparam ram_18_inst_0_0_0.INITVAL_16 = INITVAL_16 ;
			defparam ram_18_inst_0_0_0.INITVAL_15 = INITVAL_15 ;
			defparam ram_18_inst_0_0_0.INITVAL_14 = INITVAL_14 ;
			defparam ram_18_inst_0_0_0.INITVAL_13 = INITVAL_13 ;
			defparam ram_18_inst_0_0_0.INITVAL_12 = INITVAL_12 ;
			defparam ram_18_inst_0_0_0.INITVAL_11 = INITVAL_11 ;
			defparam ram_18_inst_0_0_0.INITVAL_10 = INITVAL_10 ;
			defparam ram_18_inst_0_0_0.INITVAL_0F = INITVAL_0F ;
			defparam ram_18_inst_0_0_0.INITVAL_0E = INITVAL_0E ;
			defparam ram_18_inst_0_0_0.INITVAL_0D = INITVAL_0D ;
			defparam ram_18_inst_0_0_0.INITVAL_0C = INITVAL_0C ;
			defparam ram_18_inst_0_0_0.INITVAL_0B = INITVAL_0B ;
			defparam ram_18_inst_0_0_0.INITVAL_0A = INITVAL_0A ;
			defparam ram_18_inst_0_0_0.INITVAL_09 = INITVAL_09 ;
			defparam ram_18_inst_0_0_0.INITVAL_08 = INITVAL_08 ;
			defparam ram_18_inst_0_0_0.INITVAL_07 = INITVAL_07 ;
			defparam ram_18_inst_0_0_0.INITVAL_06 = INITVAL_06 ;
			defparam ram_18_inst_0_0_0.INITVAL_05 = INITVAL_05 ;
			defparam ram_18_inst_0_0_0.INITVAL_04 = INITVAL_04 ;
			defparam ram_18_inst_0_0_0.INITVAL_03 = INITVAL_03 ;
			defparam ram_18_inst_0_0_0.INITVAL_02 = INITVAL_02 ;
			defparam ram_18_inst_0_0_0.INITVAL_01 = INITVAL_01 ;
			defparam ram_18_inst_0_0_0.INITVAL_00 = INITVAL_00 ;
			defparam ram_18_inst_0_0_0.CSDECODE_A = "0b000" ;
			defparam ram_18_inst_0_0_0.CSDECODE_B = "0b000" ;
			defparam ram_18_inst_0_0_0.WRITEMODE_A = "WRITETHROUGH" ;
			defparam ram_18_inst_0_0_0.WRITEMODE_B = "WRITETHROUGH" ;
			defparam ram_18_inst_0_0_0.GSR = "DISABLED" ;
			defparam ram_18_inst_0_0_0.RESETMODE = "ASYNC" ;
 			defparam ram_18_inst_0_0_0.REGMODE_A = "NOREG" ;
			defparam ram_18_inst_0_0_0.REGMODE_B = "NOREG" ;
			defparam ram_18_inst_0_0_0.DATA_WIDTH_A = 18 ;
			defparam ram_18_inst_0_0_0.DATA_WIDTH_B = 18 ;
			DP16KD ram_18_inst_0_0_0 (
						    .DIA0(DIA[0]), 
						    .DIA1(DIA[1]), 
						    .DIA2(DIA[2]), 
						    .DIA3(DIA[3]), 
						    .DIA4(DIA[4]), 
						    .DIA5(DIA[5]), 
						    .DIA6(DIA[6]), 
						    .DIA7(DIA[7]), 
						    .DIA8(DIA[8]), 
						    .DIA9(DIA[9]), 
						    .DIA10(DIA[10]), 
						    .DIA11(DIA[11]), 
						    .DIA12(DIA[12]), 
						    .DIA13(DIA[13]), 
						    .DIA14(DIA[14]), 
						    .DIA15(DIA[15]), 
						    .DIA16(DIA[16]), 
						    .DIA17(DIA[17]), 
						    .ADA0(scuba_vhi), 
						    .ADA1(scuba_vhi), 
						    .ADA2(scuba_vlo), 
						    .ADA3(scuba_vlo), 
						    .ADA4(ADDRA[0]), 
						    .ADA5(ADDRA[1]), 
						    .ADA6(ADDRA[2]), 
						    .ADA7(ADDRA[3]), 
						    .ADA8(ADDRA[4]), 
						    .ADA9(ADDRA[5]), 
						    .ADA10(ADDRA[6]), 
						    .ADA11(ADDRA[7]), 
						    .ADA12(ADDRA[8]), 
						    .ADA13(ADDRA[9]), 
						    .CEA(ENA), 
						    .CLKA(CLKA), 
						    .OCEA(ENA), 
						    .WEA(WEA), 
						    .CSA0(scuba_vlo), 
						    .CSA1(scuba_vlo), 
						    .CSA2(scuba_vlo), 
						    .RSTA(scuba_vlo), 
						    .DIB0(DIB[0]), 
						    .DIB1(DIB[1]), 
						    .DIB2(DIB[2]), 
						    .DIB3(DIB[3]), 
						    .DIB4(DIB[4]), 
						    .DIB5(DIB[5]), 
						    .DIB6(DIB[6]), 
						    .DIB7(DIB[7]), 
						    .DIB8(DIB[8]), 
						    .DIB9(DIB[9]), 
						    .DIB10(DIB[10]), 
						    .DIB11(DIB[11]), 
						    .DIB12(DIB[12]), 
						    .DIB13(DIB[13]), 
						    .DIB14(DIB[14]), 
						    .DIB15(DIB[15]), 
						    .DIB16(DIB[16]), 
						    .DIB17(DIB[17]), 
						    .ADB0(scuba_vhi), 
						    .ADB1(scuba_vhi), 
						    .ADB2(scuba_vlo), 
						    .ADB3(scuba_vlo), 
						    .ADB4(ADDRB[0]), 
						    .ADB5(ADDRB[1]), 
						    .ADB6(ADDRB[2]), 
						    .ADB7(ADDRB[3]), 
						    .ADB8(ADDRB[4]), 
						    .ADB9(ADDRB[5]), 
						    .ADB10(ADDRB[6]), 
						    .ADB11(ADDRB[7]), 
						    .ADB12(ADDRB[8]), 
						    .ADB13(ADDRB[9]), 
						    .CEB(ENB), 
						    .CLKB(CLKB), 
						    .OCEB(ENB), 
						    .WEB(WEB), 
						    .CSB0(scuba_vlo), 
						    .CSB1(scuba_vlo), 
						    .CSB2(scuba_vlo), 
						    .RSTB(scuba_vlo), 
						    .DOA0(DOA_internal[0]), 
						    .DOA1(DOA_internal[1]), 
						    .DOA2(DOA_internal[2]), 
						    .DOA3(DOA_internal[3]), 
						    .DOA4(DOA_internal[4]), 
						    .DOA5(DOA_internal[5]), 
						    .DOA6(DOA_internal[6]), 
						    .DOA7(DOA_internal[7]), 
						    .DOA8(DOA_internal[8]), 
						    .DOA9(DOA_internal[9]), 
						    .DOA10(DOA_internal[10]),
						    .DOA11(DOA_internal[11]), 
						    .DOA12(DOA_internal[12]), 
						    .DOA13(DOA_internal[13]), 
						    .DOA14(DOA_internal[14]), 
						    .DOA15(DOA_internal[15]), 
						    .DOA16(DOA_internal[16]), 
						    .DOA17(DOA_internal[17]), 
						    .DOB0(DOB_internal[0]), 
						    .DOB1(DOB_internal[1]), 
						    .DOB2(DOB_internal[2]), 
						    .DOB3(DOB_internal[3]), 
						    .DOB4(DOB_internal[4]), 
						    .DOB5(DOB_internal[5]), 
						    .DOB6(DOB_internal[6]), 
						    .DOB7(DOB_internal[7]), 
						    .DOB8(DOB_internal[8]), 
						    .DOB9(DOB_internal[9]), 
						    .DOB10(DOB_internal[10]), 
						    .DOB11(DOB_internal[11]),
						    .DOB12(DOB_internal[12]), 
						    .DOB13(DOB_internal[13]), 
						    .DOB14(DOB_internal[14]), 
						    .DOB15(DOB_internal[15]), 
						    .DOB16(DOB_internal[16]), 
						    .DOB17(DOB_internal[17]));

		end

	end

	// end port a = WRITE_FIRST

	// begin port a = READ_FIRST

	else if (WRITE_MODE_A == "READ_FIRST")
	begin

		if (WRITE_MODE_B == "WRITE_FIRST")
		begin
		
            ssr_logic #(
            .WIDTH  (      18      ),
            .SRVAL  ( SRVAL_A      )
            ) ssr_logic_inst_a (
            .CLK    ( CLKA         ),
            .DO_in  ( DOA_internal ),
            .DO_out ( DOA          ),
            .EN     ( ENA          ),
            .SSR    ( SSRA         )
            );   
            
            ssr_logic #(
            .WIDTH  (      18      ),
            .SRVAL  ( SRVAL_B      )
            ) ssr_logic_inst_b (
            .CLK    ( CLKB         ),
            .DO_in  ( DOB_internal ),
            .DO_out ( DOB          ),
            .EN     ( ENB          ),
            .SSR    ( SSRB         )
            );   

			defparam ram_18_inst_0_0_0.INIT_DATA = "STATIC" ;
			defparam ram_18_inst_0_0_0.ASYNC_RESET_RELEASE = "SYNC" ;
			defparam ram_18_inst_0_0_0.INITVAL_3F = INITVAL_3F ;
			defparam ram_18_inst_0_0_0.INITVAL_3E = INITVAL_3E ;
			defparam ram_18_inst_0_0_0.INITVAL_3D = INITVAL_3D ;
			defparam ram_18_inst_0_0_0.INITVAL_3C = INITVAL_3C ;
			defparam ram_18_inst_0_0_0.INITVAL_3B = INITVAL_3B ;
			defparam ram_18_inst_0_0_0.INITVAL_3A = INITVAL_3A ;
			defparam ram_18_inst_0_0_0.INITVAL_39 = INITVAL_39 ;
			defparam ram_18_inst_0_0_0.INITVAL_38 = INITVAL_38 ;
			defparam ram_18_inst_0_0_0.INITVAL_37 = INITVAL_37 ;
			defparam ram_18_inst_0_0_0.INITVAL_36 = INITVAL_36 ;
			defparam ram_18_inst_0_0_0.INITVAL_35 = INITVAL_35 ;
			defparam ram_18_inst_0_0_0.INITVAL_34 = INITVAL_34 ;
			defparam ram_18_inst_0_0_0.INITVAL_33 = INITVAL_33 ;
			defparam ram_18_inst_0_0_0.INITVAL_32 = INITVAL_32 ;
			defparam ram_18_inst_0_0_0.INITVAL_31 = INITVAL_31 ;
			defparam ram_18_inst_0_0_0.INITVAL_30 = INITVAL_30 ;
			defparam ram_18_inst_0_0_0.INITVAL_2F = INITVAL_2F ;
			defparam ram_18_inst_0_0_0.INITVAL_2E = INITVAL_2E ;
			defparam ram_18_inst_0_0_0.INITVAL_2D = INITVAL_2D ;
			defparam ram_18_inst_0_0_0.INITVAL_2C = INITVAL_2C ;
			defparam ram_18_inst_0_0_0.INITVAL_2B = INITVAL_2B ;
			defparam ram_18_inst_0_0_0.INITVAL_2A = INITVAL_2A ;
			defparam ram_18_inst_0_0_0.INITVAL_29 = INITVAL_29 ;
			defparam ram_18_inst_0_0_0.INITVAL_28 = INITVAL_28 ;
			defparam ram_18_inst_0_0_0.INITVAL_27 = INITVAL_27 ;
			defparam ram_18_inst_0_0_0.INITVAL_26 = INITVAL_26 ;
			defparam ram_18_inst_0_0_0.INITVAL_25 = INITVAL_25 ;
			defparam ram_18_inst_0_0_0.INITVAL_24 = INITVAL_24 ;
			defparam ram_18_inst_0_0_0.INITVAL_23 = INITVAL_23 ;
			defparam ram_18_inst_0_0_0.INITVAL_22 = INITVAL_22 ;
			defparam ram_18_inst_0_0_0.INITVAL_21 = INITVAL_21 ;
			defparam ram_18_inst_0_0_0.INITVAL_20 = INITVAL_20 ;
			defparam ram_18_inst_0_0_0.INITVAL_1F = INITVAL_1F ;
			defparam ram_18_inst_0_0_0.INITVAL_1E = INITVAL_1E ;
			defparam ram_18_inst_0_0_0.INITVAL_1D = INITVAL_1D ;
			defparam ram_18_inst_0_0_0.INITVAL_1C = INITVAL_1C ;
			defparam ram_18_inst_0_0_0.INITVAL_1B = INITVAL_1B ;
			defparam ram_18_inst_0_0_0.INITVAL_1A = INITVAL_1A ;
			defparam ram_18_inst_0_0_0.INITVAL_19 = INITVAL_19 ;
			defparam ram_18_inst_0_0_0.INITVAL_18 = INITVAL_18 ;
			defparam ram_18_inst_0_0_0.INITVAL_17 = INITVAL_17 ;
			defparam ram_18_inst_0_0_0.INITVAL_16 = INITVAL_16 ;
			defparam ram_18_inst_0_0_0.INITVAL_15 = INITVAL_15 ;
			defparam ram_18_inst_0_0_0.INITVAL_14 = INITVAL_14 ;
			defparam ram_18_inst_0_0_0.INITVAL_13 = INITVAL_13 ;
			defparam ram_18_inst_0_0_0.INITVAL_12 = INITVAL_12 ;
			defparam ram_18_inst_0_0_0.INITVAL_11 = INITVAL_11 ;
			defparam ram_18_inst_0_0_0.INITVAL_10 = INITVAL_10 ;
			defparam ram_18_inst_0_0_0.INITVAL_0F = INITVAL_0F ;
			defparam ram_18_inst_0_0_0.INITVAL_0E = INITVAL_0E ;
			defparam ram_18_inst_0_0_0.INITVAL_0D = INITVAL_0D ;
			defparam ram_18_inst_0_0_0.INITVAL_0C = INITVAL_0C ;
			defparam ram_18_inst_0_0_0.INITVAL_0B = INITVAL_0B ;
			defparam ram_18_inst_0_0_0.INITVAL_0A = INITVAL_0A ;
			defparam ram_18_inst_0_0_0.INITVAL_09 = INITVAL_09 ;
			defparam ram_18_inst_0_0_0.INITVAL_08 = INITVAL_08 ;
			defparam ram_18_inst_0_0_0.INITVAL_07 = INITVAL_07 ;
			defparam ram_18_inst_0_0_0.INITVAL_06 = INITVAL_06 ;
			defparam ram_18_inst_0_0_0.INITVAL_05 = INITVAL_05 ;
			defparam ram_18_inst_0_0_0.INITVAL_04 = INITVAL_04 ;
			defparam ram_18_inst_0_0_0.INITVAL_03 = INITVAL_03 ;
			defparam ram_18_inst_0_0_0.INITVAL_02 = INITVAL_02 ;
			defparam ram_18_inst_0_0_0.INITVAL_01 = INITVAL_01 ;
			defparam ram_18_inst_0_0_0.INITVAL_00 = INITVAL_00 ;
			defparam ram_18_inst_0_0_0.CSDECODE_A = "0b000" ;
			defparam ram_18_inst_0_0_0.CSDECODE_B = "0b000" ;
			defparam ram_18_inst_0_0_0.WRITEMODE_A = "READBEFOREWRITE" ;
			defparam ram_18_inst_0_0_0.WRITEMODE_B = "WRITETHROUGH" ;
			defparam ram_18_inst_0_0_0.GSR = "DISABLED" ;
			defparam ram_18_inst_0_0_0.RESETMODE = "ASYNC" ;
 			defparam ram_18_inst_0_0_0.REGMODE_A = "NOREG" ;
			defparam ram_18_inst_0_0_0.REGMODE_B = "NOREG" ;
			defparam ram_18_inst_0_0_0.DATA_WIDTH_A = 18 ;
			defparam ram_18_inst_0_0_0.DATA_WIDTH_B = 18 ;
			DP16KD ram_18_inst_0_0_0 (
						    .DIA0(DIA[0]), 
						    .DIA1(DIA[1]), 
						    .DIA2(DIA[2]), 
						    .DIA3(DIA[3]), 
						    .DIA4(DIA[4]), 
						    .DIA5(DIA[5]), 
						    .DIA6(DIA[6]), 
						    .DIA7(DIA[7]), 
						    .DIA8(DIA[8]), 
						    .DIA9(DIA[9]), 
						    .DIA10(DIA[10]), 
						    .DIA11(DIA[11]), 
						    .DIA12(DIA[12]), 
						    .DIA13(DIA[13]), 
						    .DIA14(DIA[14]), 
						    .DIA15(DIA[15]), 
						    .DIA16(DIA[16]), 
						    .DIA17(DIA[17]), 
						    .ADA0(scuba_vhi), 
						    .ADA1(scuba_vhi), 
						    .ADA2(scuba_vlo), 
						    .ADA3(scuba_vlo), 
						    .ADA4(ADDRA[0]), 
						    .ADA5(ADDRA[1]), 
						    .ADA6(ADDRA[2]), 
						    .ADA7(ADDRA[3]), 
						    .ADA8(ADDRA[4]), 
						    .ADA9(ADDRA[5]), 
						    .ADA10(ADDRA[6]), 
						    .ADA11(ADDRA[7]), 
						    .ADA12(ADDRA[8]), 
						    .ADA13(ADDRA[9]), 
						    .CEA(ENA), 
						    .CLKA(CLKA), 
						    .OCEA(ENA), 
						    .WEA(WEA), 
						    .CSA0(scuba_vlo), 
						    .CSA1(scuba_vlo), 
						    .CSA2(scuba_vlo), 
						    .RSTA(scuba_vlo), 
						    .DIB0(DIB[0]), 
						    .DIB1(DIB[1]), 
						    .DIB2(DIB[2]), 
						    .DIB3(DIB[3]), 
						    .DIB4(DIB[4]), 
						    .DIB5(DIB[5]), 
						    .DIB6(DIB[6]), 
						    .DIB7(DIB[7]), 
						    .DIB8(DIB[8]), 
						    .DIB9(DIB[9]), 
						    .DIB10(DIB[10]), 
						    .DIB11(DIB[11]), 
						    .DIB12(DIB[12]), 
						    .DIB13(DIB[13]), 
						    .DIB14(DIB[14]), 
						    .DIB15(DIB[15]), 
						    .DIB16(DIB[16]), 
						    .DIB17(DIB[17]), 
						    .ADB0(scuba_vhi), 
						    .ADB1(scuba_vhi), 
						    .ADB2(scuba_vlo), 
						    .ADB3(scuba_vlo), 
						    .ADB4(ADDRB[0]), 
						    .ADB5(ADDRB[1]), 
						    .ADB6(ADDRB[2]), 
						    .ADB7(ADDRB[3]), 
						    .ADB8(ADDRB[4]), 
						    .ADB9(ADDRB[5]), 
						    .ADB10(ADDRB[6]), 
						    .ADB11(ADDRB[7]), 
						    .ADB12(ADDRB[8]), 
						    .ADB13(ADDRB[9]), 
						    .CEB(ENB), 
						    .CLKB(CLKB), 
						    .OCEB(ENB), 
						    .WEB(WEB), 
						    .CSB0(scuba_vlo), 
						    .CSB1(scuba_vlo), 
						    .CSB2(scuba_vlo), 
						    .RSTB(scuba_vlo), 
						    .DOA0(DOA_internal[0]), 
						    .DOA1(DOA_internal[1]), 
						    .DOA2(DOA_internal[2]), 
						    .DOA3(DOA_internal[3]), 
						    .DOA4(DOA_internal[4]), 
						    .DOA5(DOA_internal[5]), 
						    .DOA6(DOA_internal[6]), 
						    .DOA7(DOA_internal[7]), 
						    .DOA8(DOA_internal[8]), 
						    .DOA9(DOA_internal[9]), 
						    .DOA10(DOA_internal[10]),
						    .DOA11(DOA_internal[11]), 
						    .DOA12(DOA_internal[12]), 
						    .DOA13(DOA_internal[13]), 
						    .DOA14(DOA_internal[14]), 
						    .DOA15(DOA_internal[15]), 
						    .DOA16(DOA_internal[16]), 
						    .DOA17(DOA_internal[17]), 
						    .DOB0(DOB_internal[0]), 
						    .DOB1(DOB_internal[1]), 
						    .DOB2(DOB_internal[2]), 
						    .DOB3(DOB_internal[3]), 
						    .DOB4(DOB_internal[4]), 
						    .DOB5(DOB_internal[5]), 
						    .DOB6(DOB_internal[6]), 
						    .DOB7(DOB_internal[7]), 
						    .DOB8(DOB_internal[8]), 
						    .DOB9(DOB_internal[9]), 
						    .DOB10(DOB_internal[10]), 
						    .DOB11(DOB_internal[11]),
						    .DOB12(DOB_internal[12]), 
						    .DOB13(DOB_internal[13]), 
						    .DOB14(DOB_internal[14]), 
						    .DOB15(DOB_internal[15]), 
						    .DOB16(DOB_internal[16]), 
						    .DOB17(DOB_internal[17]));

		end
		else if (WRITE_MODE_B == "READ_FIRST")
		begin
		
            ssr_logic #(
            .WIDTH  (      18      ),
            .SRVAL  ( SRVAL_A      )
            ) ssr_logic_inst_a (
            .CLK    ( CLKA         ),
            .DO_in  ( DOA_internal ),
            .DO_out ( DOA          ),
            .EN     ( ENA          ),
            .SSR    ( SSRA         )
            );   
            
            ssr_logic #(
            .WIDTH  (      18      ),
            .SRVAL  ( SRVAL_B      )
            ) ssr_logic_inst_b (
            .CLK    ( CLKB         ),
            .DO_in  ( DOB_internal ),
            .DO_out ( DOB          ),
            .EN     ( ENB          ),
            .SSR    ( SSRB         )
            ); 

			defparam ram_18_inst_0_0_0.INIT_DATA = "STATIC" ;
			defparam ram_18_inst_0_0_0.ASYNC_RESET_RELEASE = "SYNC" ;
			defparam ram_18_inst_0_0_0.INITVAL_3F = INITVAL_3F ;
			defparam ram_18_inst_0_0_0.INITVAL_3E = INITVAL_3E ;
			defparam ram_18_inst_0_0_0.INITVAL_3D = INITVAL_3D ;
			defparam ram_18_inst_0_0_0.INITVAL_3C = INITVAL_3C ;
			defparam ram_18_inst_0_0_0.INITVAL_3B = INITVAL_3B ;
			defparam ram_18_inst_0_0_0.INITVAL_3A = INITVAL_3A ;
			defparam ram_18_inst_0_0_0.INITVAL_39 = INITVAL_39 ;
			defparam ram_18_inst_0_0_0.INITVAL_38 = INITVAL_38 ;
			defparam ram_18_inst_0_0_0.INITVAL_37 = INITVAL_37 ;
			defparam ram_18_inst_0_0_0.INITVAL_36 = INITVAL_36 ;
			defparam ram_18_inst_0_0_0.INITVAL_35 = INITVAL_35 ;
			defparam ram_18_inst_0_0_0.INITVAL_34 = INITVAL_34 ;
			defparam ram_18_inst_0_0_0.INITVAL_33 = INITVAL_33 ;
			defparam ram_18_inst_0_0_0.INITVAL_32 = INITVAL_32 ;
			defparam ram_18_inst_0_0_0.INITVAL_31 = INITVAL_31 ;
			defparam ram_18_inst_0_0_0.INITVAL_30 = INITVAL_30 ;
			defparam ram_18_inst_0_0_0.INITVAL_2F = INITVAL_2F ;
			defparam ram_18_inst_0_0_0.INITVAL_2E = INITVAL_2E ;
			defparam ram_18_inst_0_0_0.INITVAL_2D = INITVAL_2D ;
			defparam ram_18_inst_0_0_0.INITVAL_2C = INITVAL_2C ;
			defparam ram_18_inst_0_0_0.INITVAL_2B = INITVAL_2B ;
			defparam ram_18_inst_0_0_0.INITVAL_2A = INITVAL_2A ;
			defparam ram_18_inst_0_0_0.INITVAL_29 = INITVAL_29 ;
			defparam ram_18_inst_0_0_0.INITVAL_28 = INITVAL_28 ;
			defparam ram_18_inst_0_0_0.INITVAL_27 = INITVAL_27 ;
			defparam ram_18_inst_0_0_0.INITVAL_26 = INITVAL_26 ;
			defparam ram_18_inst_0_0_0.INITVAL_25 = INITVAL_25 ;
			defparam ram_18_inst_0_0_0.INITVAL_24 = INITVAL_24 ;
			defparam ram_18_inst_0_0_0.INITVAL_23 = INITVAL_23 ;
			defparam ram_18_inst_0_0_0.INITVAL_22 = INITVAL_22 ;
			defparam ram_18_inst_0_0_0.INITVAL_21 = INITVAL_21 ;
			defparam ram_18_inst_0_0_0.INITVAL_20 = INITVAL_20 ;
			defparam ram_18_inst_0_0_0.INITVAL_1F = INITVAL_1F ;
			defparam ram_18_inst_0_0_0.INITVAL_1E = INITVAL_1E ;
			defparam ram_18_inst_0_0_0.INITVAL_1D = INITVAL_1D ;
			defparam ram_18_inst_0_0_0.INITVAL_1C = INITVAL_1C ;
			defparam ram_18_inst_0_0_0.INITVAL_1B = INITVAL_1B ;
			defparam ram_18_inst_0_0_0.INITVAL_1A = INITVAL_1A ;
			defparam ram_18_inst_0_0_0.INITVAL_19 = INITVAL_19 ;
			defparam ram_18_inst_0_0_0.INITVAL_18 = INITVAL_18 ;
			defparam ram_18_inst_0_0_0.INITVAL_17 = INITVAL_17 ;
			defparam ram_18_inst_0_0_0.INITVAL_16 = INITVAL_16 ;
			defparam ram_18_inst_0_0_0.INITVAL_15 = INITVAL_15 ;
			defparam ram_18_inst_0_0_0.INITVAL_14 = INITVAL_14 ;
			defparam ram_18_inst_0_0_0.INITVAL_13 = INITVAL_13 ;
			defparam ram_18_inst_0_0_0.INITVAL_12 = INITVAL_12 ;
			defparam ram_18_inst_0_0_0.INITVAL_11 = INITVAL_11 ;
			defparam ram_18_inst_0_0_0.INITVAL_10 = INITVAL_10 ;
			defparam ram_18_inst_0_0_0.INITVAL_0F = INITVAL_0F ;
			defparam ram_18_inst_0_0_0.INITVAL_0E = INITVAL_0E ;
			defparam ram_18_inst_0_0_0.INITVAL_0D = INITVAL_0D ;
			defparam ram_18_inst_0_0_0.INITVAL_0C = INITVAL_0C ;
			defparam ram_18_inst_0_0_0.INITVAL_0B = INITVAL_0B ;
			defparam ram_18_inst_0_0_0.INITVAL_0A = INITVAL_0A ;
			defparam ram_18_inst_0_0_0.INITVAL_09 = INITVAL_09 ;
			defparam ram_18_inst_0_0_0.INITVAL_08 = INITVAL_08 ;
			defparam ram_18_inst_0_0_0.INITVAL_07 = INITVAL_07 ;
			defparam ram_18_inst_0_0_0.INITVAL_06 = INITVAL_06 ;
			defparam ram_18_inst_0_0_0.INITVAL_05 = INITVAL_05 ;
			defparam ram_18_inst_0_0_0.INITVAL_04 = INITVAL_04 ;
			defparam ram_18_inst_0_0_0.INITVAL_03 = INITVAL_03 ;
			defparam ram_18_inst_0_0_0.INITVAL_02 = INITVAL_02 ;
			defparam ram_18_inst_0_0_0.INITVAL_01 = INITVAL_01 ;
			defparam ram_18_inst_0_0_0.INITVAL_00 = INITVAL_00 ;
			defparam ram_18_inst_0_0_0.CSDECODE_A = "0b000" ;
			defparam ram_18_inst_0_0_0.CSDECODE_B = "0b000" ;
			defparam ram_18_inst_0_0_0.WRITEMODE_A = "READBEFOREWRITE" ;
			defparam ram_18_inst_0_0_0.WRITEMODE_B = "READBEFOREWRITE" ;
			defparam ram_18_inst_0_0_0.GSR = "DISABLED" ;
			defparam ram_18_inst_0_0_0.RESETMODE = "ASYNC" ;
 			defparam ram_18_inst_0_0_0.REGMODE_A = "NOREG" ;
			defparam ram_18_inst_0_0_0.REGMODE_B = "NOREG" ;
			defparam ram_18_inst_0_0_0.DATA_WIDTH_A = 18 ;
			defparam ram_18_inst_0_0_0.DATA_WIDTH_B = 18 ;
			DP16KD ram_18_inst_0_0_0 (
						    .DIA0(DIA[0]), 
						    .DIA1(DIA[1]), 
						    .DIA2(DIA[2]), 
						    .DIA3(DIA[3]), 
						    .DIA4(DIA[4]), 
						    .DIA5(DIA[5]), 
						    .DIA6(DIA[6]), 
						    .DIA7(DIA[7]), 
						    .DIA8(DIA[8]), 
						    .DIA9(DIA[9]), 
						    .DIA10(DIA[10]), 
						    .DIA11(DIA[11]), 
						    .DIA12(DIA[12]), 
						    .DIA13(DIA[13]), 
						    .DIA14(DIA[14]), 
						    .DIA15(DIA[15]), 
						    .DIA16(DIA[16]), 
						    .DIA17(DIA[17]), 
						    .ADA0(scuba_vhi), 
						    .ADA1(scuba_vhi), 
						    .ADA2(scuba_vlo), 
						    .ADA3(scuba_vlo), 
						    .ADA4(ADDRA[0]), 
						    .ADA5(ADDRA[1]), 
						    .ADA6(ADDRA[2]), 
						    .ADA7(ADDRA[3]), 
						    .ADA8(ADDRA[4]), 
						    .ADA9(ADDRA[5]), 
						    .ADA10(ADDRA[6]), 
						    .ADA11(ADDRA[7]), 
						    .ADA12(ADDRA[8]), 
						    .ADA13(ADDRA[9]), 
						    .CEA(ENA), 
						    .CLKA(CLKA), 
						    .OCEA(ENA), 
						    .WEA(WEA), 
						    .CSA0(scuba_vlo), 
						    .CSA1(scuba_vlo), 
						    .CSA2(scuba_vlo), 
						    .RSTA(scuba_vlo), 
						    .DIB0(DIB[0]), 
						    .DIB1(DIB[1]), 
						    .DIB2(DIB[2]), 
						    .DIB3(DIB[3]), 
						    .DIB4(DIB[4]), 
						    .DIB5(DIB[5]), 
						    .DIB6(DIB[6]), 
						    .DIB7(DIB[7]), 
						    .DIB8(DIB[8]), 
						    .DIB9(DIB[9]), 
						    .DIB10(DIB[10]), 
						    .DIB11(DIB[11]), 
						    .DIB12(DIB[12]), 
						    .DIB13(DIB[13]), 
						    .DIB14(DIB[14]), 
						    .DIB15(DIB[15]), 
						    .DIB16(DIB[16]), 
						    .DIB17(DIB[17]), 
						    .ADB0(scuba_vhi), 
						    .ADB1(scuba_vhi), 
						    .ADB2(scuba_vlo), 
						    .ADB3(scuba_vlo), 
						    .ADB4(ADDRB[0]), 
						    .ADB5(ADDRB[1]), 
						    .ADB6(ADDRB[2]), 
						    .ADB7(ADDRB[3]), 
						    .ADB8(ADDRB[4]), 
						    .ADB9(ADDRB[5]), 
						    .ADB10(ADDRB[6]), 
						    .ADB11(ADDRB[7]), 
						    .ADB12(ADDRB[8]), 
						    .ADB13(ADDRB[9]), 
						    .CEB(ENB), 
						    .CLKB(CLKB), 
						    .OCEB(ENB), 
						    .WEB(WEB), 
						    .CSB0(scuba_vlo), 
						    .CSB1(scuba_vlo), 
						    .CSB2(scuba_vlo), 
						    .RSTB(scuba_vlo), 
						    .DOA0(DOA_internal[0]), 
						    .DOA1(DOA_internal[1]), 
						    .DOA2(DOA_internal[2]), 
						    .DOA3(DOA_internal[3]), 
						    .DOA4(DOA_internal[4]), 
						    .DOA5(DOA_internal[5]), 
						    .DOA6(DOA_internal[6]), 
						    .DOA7(DOA_internal[7]), 
						    .DOA8(DOA_internal[8]), 
						    .DOA9(DOA_internal[9]), 
						    .DOA10(DOA_internal[10]),
						    .DOA11(DOA_internal[11]), 
						    .DOA12(DOA_internal[12]), 
						    .DOA13(DOA_internal[13]), 
						    .DOA14(DOA_internal[14]), 
						    .DOA15(DOA_internal[15]), 
						    .DOA16(DOA_internal[16]), 
						    .DOA17(DOA_internal[17]), 
						    .DOB0(DOB_internal[0]), 
						    .DOB1(DOB_internal[1]), 
						    .DOB2(DOB_internal[2]), 
						    .DOB3(DOB_internal[3]), 
						    .DOB4(DOB_internal[4]), 
						    .DOB5(DOB_internal[5]), 
						    .DOB6(DOB_internal[6]), 
						    .DOB7(DOB_internal[7]), 
						    .DOB8(DOB_internal[8]), 
						    .DOB9(DOB_internal[9]), 
						    .DOB10(DOB_internal[10]), 
						    .DOB11(DOB_internal[11]),
						    .DOB12(DOB_internal[12]), 
						    .DOB13(DOB_internal[13]), 
						    .DOB14(DOB_internal[14]), 
						    .DOB15(DOB_internal[15]), 
						    .DOB16(DOB_internal[16]), 
						    .DOB17(DOB_internal[17]));

		end
		else if (WRITE_MODE_B == "NO_CHANGE")
		begin

            ssr_logic #(
            .WIDTH  (      18      ),
            .SRVAL  ( SRVAL_A      )
            ) ssr_logic_inst_a (
            .CLK    ( CLKA         ),
            .DO_in  ( DOA_internal ),
            .DO_out ( DOA          ),
            .EN     ( ENA          ),
            .SSR    ( SSRA         )
            );   
            
            nochange_ssr_logic #(
            .WIDTH  (      18      ),
            .SRVAL  ( SRVAL_B      )
            ) nochange_ssr_logic_inst_b (
            .CLK    ( CLKB         ),
            .DO_in  ( DOB_internal ),
            .DO_out ( DOB          ),
            .EN     ( ENB          ),
            .WE     ( WEB          ),
            .SSR    ( SSRB         )
            );  

			defparam ram_18_inst_0_0_0.INIT_DATA = "STATIC" ;
			defparam ram_18_inst_0_0_0.ASYNC_RESET_RELEASE = "SYNC" ;
			defparam ram_18_inst_0_0_0.INITVAL_3F = INITVAL_3F ;
			defparam ram_18_inst_0_0_0.INITVAL_3E = INITVAL_3E ;
			defparam ram_18_inst_0_0_0.INITVAL_3D = INITVAL_3D ;
			defparam ram_18_inst_0_0_0.INITVAL_3C = INITVAL_3C ;
			defparam ram_18_inst_0_0_0.INITVAL_3B = INITVAL_3B ;
			defparam ram_18_inst_0_0_0.INITVAL_3A = INITVAL_3A ;
			defparam ram_18_inst_0_0_0.INITVAL_39 = INITVAL_39 ;
			defparam ram_18_inst_0_0_0.INITVAL_38 = INITVAL_38 ;
			defparam ram_18_inst_0_0_0.INITVAL_37 = INITVAL_37 ;
			defparam ram_18_inst_0_0_0.INITVAL_36 = INITVAL_36 ;
			defparam ram_18_inst_0_0_0.INITVAL_35 = INITVAL_35 ;
			defparam ram_18_inst_0_0_0.INITVAL_34 = INITVAL_34 ;
			defparam ram_18_inst_0_0_0.INITVAL_33 = INITVAL_33 ;
			defparam ram_18_inst_0_0_0.INITVAL_32 = INITVAL_32 ;
			defparam ram_18_inst_0_0_0.INITVAL_31 = INITVAL_31 ;
			defparam ram_18_inst_0_0_0.INITVAL_30 = INITVAL_30 ;
			defparam ram_18_inst_0_0_0.INITVAL_2F = INITVAL_2F ;
			defparam ram_18_inst_0_0_0.INITVAL_2E = INITVAL_2E ;
			defparam ram_18_inst_0_0_0.INITVAL_2D = INITVAL_2D ;
			defparam ram_18_inst_0_0_0.INITVAL_2C = INITVAL_2C ;
			defparam ram_18_inst_0_0_0.INITVAL_2B = INITVAL_2B ;
			defparam ram_18_inst_0_0_0.INITVAL_2A = INITVAL_2A ;
			defparam ram_18_inst_0_0_0.INITVAL_29 = INITVAL_29 ;
			defparam ram_18_inst_0_0_0.INITVAL_28 = INITVAL_28 ;
			defparam ram_18_inst_0_0_0.INITVAL_27 = INITVAL_27 ;
			defparam ram_18_inst_0_0_0.INITVAL_26 = INITVAL_26 ;
			defparam ram_18_inst_0_0_0.INITVAL_25 = INITVAL_25 ;
			defparam ram_18_inst_0_0_0.INITVAL_24 = INITVAL_24 ;
			defparam ram_18_inst_0_0_0.INITVAL_23 = INITVAL_23 ;
			defparam ram_18_inst_0_0_0.INITVAL_22 = INITVAL_22 ;
			defparam ram_18_inst_0_0_0.INITVAL_21 = INITVAL_21 ;
			defparam ram_18_inst_0_0_0.INITVAL_20 = INITVAL_20 ;
			defparam ram_18_inst_0_0_0.INITVAL_1F = INITVAL_1F ;
			defparam ram_18_inst_0_0_0.INITVAL_1E = INITVAL_1E ;
			defparam ram_18_inst_0_0_0.INITVAL_1D = INITVAL_1D ;
			defparam ram_18_inst_0_0_0.INITVAL_1C = INITVAL_1C ;
			defparam ram_18_inst_0_0_0.INITVAL_1B = INITVAL_1B ;
			defparam ram_18_inst_0_0_0.INITVAL_1A = INITVAL_1A ;
			defparam ram_18_inst_0_0_0.INITVAL_19 = INITVAL_19 ;
			defparam ram_18_inst_0_0_0.INITVAL_18 = INITVAL_18 ;
			defparam ram_18_inst_0_0_0.INITVAL_17 = INITVAL_17 ;
			defparam ram_18_inst_0_0_0.INITVAL_16 = INITVAL_16 ;
			defparam ram_18_inst_0_0_0.INITVAL_15 = INITVAL_15 ;
			defparam ram_18_inst_0_0_0.INITVAL_14 = INITVAL_14 ;
			defparam ram_18_inst_0_0_0.INITVAL_13 = INITVAL_13 ;
			defparam ram_18_inst_0_0_0.INITVAL_12 = INITVAL_12 ;
			defparam ram_18_inst_0_0_0.INITVAL_11 = INITVAL_11 ;
			defparam ram_18_inst_0_0_0.INITVAL_10 = INITVAL_10 ;
			defparam ram_18_inst_0_0_0.INITVAL_0F = INITVAL_0F ;
			defparam ram_18_inst_0_0_0.INITVAL_0E = INITVAL_0E ;
			defparam ram_18_inst_0_0_0.INITVAL_0D = INITVAL_0D ;
			defparam ram_18_inst_0_0_0.INITVAL_0C = INITVAL_0C ;
			defparam ram_18_inst_0_0_0.INITVAL_0B = INITVAL_0B ;
			defparam ram_18_inst_0_0_0.INITVAL_0A = INITVAL_0A ;
			defparam ram_18_inst_0_0_0.INITVAL_09 = INITVAL_09 ;
			defparam ram_18_inst_0_0_0.INITVAL_08 = INITVAL_08 ;
			defparam ram_18_inst_0_0_0.INITVAL_07 = INITVAL_07 ;
			defparam ram_18_inst_0_0_0.INITVAL_06 = INITVAL_06 ;
			defparam ram_18_inst_0_0_0.INITVAL_05 = INITVAL_05 ;
			defparam ram_18_inst_0_0_0.INITVAL_04 = INITVAL_04 ;
			defparam ram_18_inst_0_0_0.INITVAL_03 = INITVAL_03 ;
			defparam ram_18_inst_0_0_0.INITVAL_02 = INITVAL_02 ;
			defparam ram_18_inst_0_0_0.INITVAL_01 = INITVAL_01 ;
			defparam ram_18_inst_0_0_0.INITVAL_00 = INITVAL_00 ;
			defparam ram_18_inst_0_0_0.CSDECODE_A = "0b000" ;
			defparam ram_18_inst_0_0_0.CSDECODE_B = "0b000" ;
			defparam ram_18_inst_0_0_0.WRITEMODE_A = "READBEFOREWRITE" ;
			defparam ram_18_inst_0_0_0.WRITEMODE_B = "WRITETHROUGH" ;
			defparam ram_18_inst_0_0_0.GSR = "DISABLED" ;
			defparam ram_18_inst_0_0_0.RESETMODE = "ASYNC" ;
 			defparam ram_18_inst_0_0_0.REGMODE_A = "NOREG" ;
			defparam ram_18_inst_0_0_0.REGMODE_B = "NOREG" ;
			defparam ram_18_inst_0_0_0.DATA_WIDTH_A = 18 ;
			defparam ram_18_inst_0_0_0.DATA_WIDTH_B = 18 ;
			DP16KD ram_18_inst_0_0_0 (
						    .DIA0(DIA[0]), 
						    .DIA1(DIA[1]), 
						    .DIA2(DIA[2]), 
						    .DIA3(DIA[3]), 
						    .DIA4(DIA[4]), 
						    .DIA5(DIA[5]), 
						    .DIA6(DIA[6]), 
						    .DIA7(DIA[7]), 
						    .DIA8(DIA[8]), 
						    .DIA9(DIA[9]), 
						    .DIA10(DIA[10]), 
						    .DIA11(DIA[11]), 
						    .DIA12(DIA[12]), 
						    .DIA13(DIA[13]), 
						    .DIA14(DIA[14]), 
						    .DIA15(DIA[15]), 
						    .DIA16(DIA[16]), 
						    .DIA17(DIA[17]), 
						    .ADA0(scuba_vhi), 
						    .ADA1(scuba_vhi), 
						    .ADA2(scuba_vlo), 
						    .ADA3(scuba_vlo), 
						    .ADA4(ADDRA[0]), 
						    .ADA5(ADDRA[1]), 
						    .ADA6(ADDRA[2]), 
						    .ADA7(ADDRA[3]), 
						    .ADA8(ADDRA[4]), 
						    .ADA9(ADDRA[5]), 
						    .ADA10(ADDRA[6]), 
						    .ADA11(ADDRA[7]), 
						    .ADA12(ADDRA[8]), 
						    .ADA13(ADDRA[9]), 
						    .CEA(ENA), 
						    .CLKA(CLKA), 
						    .OCEA(ENA), 
						    .WEA(WEA), 
						    .CSA0(scuba_vlo), 
						    .CSA1(scuba_vlo), 
						    .CSA2(scuba_vlo), 
						    .RSTA(scuba_vlo), 
						    .DIB0(DIB[0]), 
						    .DIB1(DIB[1]), 
						    .DIB2(DIB[2]), 
						    .DIB3(DIB[3]), 
						    .DIB4(DIB[4]), 
						    .DIB5(DIB[5]), 
						    .DIB6(DIB[6]), 
						    .DIB7(DIB[7]), 
						    .DIB8(DIB[8]), 
						    .DIB9(DIB[9]), 
						    .DIB10(DIB[10]), 
						    .DIB11(DIB[11]), 
						    .DIB12(DIB[12]), 
						    .DIB13(DIB[13]), 
						    .DIB14(DIB[14]), 
						    .DIB15(DIB[15]), 
						    .DIB16(DIB[16]), 
						    .DIB17(DIB[17]), 
						    .ADB0(scuba_vhi), 
						    .ADB1(scuba_vhi), 
						    .ADB2(scuba_vlo), 
						    .ADB3(scuba_vlo), 
						    .ADB4(ADDRB[0]), 
						    .ADB5(ADDRB[1]), 
						    .ADB6(ADDRB[2]), 
						    .ADB7(ADDRB[3]), 
						    .ADB8(ADDRB[4]), 
						    .ADB9(ADDRB[5]), 
						    .ADB10(ADDRB[6]), 
						    .ADB11(ADDRB[7]), 
						    .ADB12(ADDRB[8]), 
						    .ADB13(ADDRB[9]), 
						    .CEB(ENB), 
						    .CLKB(CLKB), 
						    .OCEB(ENB), 
						    .WEB(WEB), 
						    .CSB0(scuba_vlo), 
						    .CSB1(scuba_vlo), 
						    .CSB2(scuba_vlo), 
						    .RSTB(scuba_vlo), 
						    .DOA0(DOA_internal[0]), 
						    .DOA1(DOA_internal[1]), 
						    .DOA2(DOA_internal[2]), 
						    .DOA3(DOA_internal[3]), 
						    .DOA4(DOA_internal[4]), 
						    .DOA5(DOA_internal[5]), 
						    .DOA6(DOA_internal[6]), 
						    .DOA7(DOA_internal[7]), 
						    .DOA8(DOA_internal[8]), 
						    .DOA9(DOA_internal[9]), 
						    .DOA10(DOA_internal[10]),
						    .DOA11(DOA_internal[11]), 
						    .DOA12(DOA_internal[12]), 
						    .DOA13(DOA_internal[13]), 
						    .DOA14(DOA_internal[14]), 
						    .DOA15(DOA_internal[15]), 
						    .DOA16(DOA_internal[16]), 
						    .DOA17(DOA_internal[17]), 
						    .DOB0(DOB_internal[0]), 
						    .DOB1(DOB_internal[1]), 
						    .DOB2(DOB_internal[2]), 
						    .DOB3(DOB_internal[3]), 
						    .DOB4(DOB_internal[4]), 
						    .DOB5(DOB_internal[5]), 
						    .DOB6(DOB_internal[6]), 
						    .DOB7(DOB_internal[7]), 
						    .DOB8(DOB_internal[8]), 
						    .DOB9(DOB_internal[9]), 
						    .DOB10(DOB_internal[10]), 
						    .DOB11(DOB_internal[11]),
						    .DOB12(DOB_internal[12]), 
						    .DOB13(DOB_internal[13]), 
						    .DOB14(DOB_internal[14]), 
						    .DOB15(DOB_internal[15]), 
						    .DOB16(DOB_internal[16]), 
						    .DOB17(DOB_internal[17]));

		end
		else
		begin
		
            ssr_logic #(
            .WIDTH  (      18      ),
            .SRVAL  ( SRVAL_A      )
            ) ssr_logic_inst_a (
            .CLK    ( CLKA         ),
            .DO_in  ( DOA_internal ),
            .DO_out ( DOA          ),
            .EN     ( ENA          ),
            .SSR    ( SSRA         )
            );   
            
            ssr_logic #(
            .WIDTH  (      18      ),
            .SRVAL  ( SRVAL_B      )
            ) ssr_logic_inst_b (
            .CLK    ( CLKB         ),
            .DO_in  ( DOB_internal ),
            .DO_out ( DOB          ),
            .EN     ( ENB          ),
            .SSR    ( SSRB         )
            ); 

			defparam ram_18_inst_0_0_0.INIT_DATA = "STATIC" ;
			defparam ram_18_inst_0_0_0.ASYNC_RESET_RELEASE = "SYNC" ;
			defparam ram_18_inst_0_0_0.INITVAL_3F = INITVAL_3F ;
			defparam ram_18_inst_0_0_0.INITVAL_3E = INITVAL_3E ;
			defparam ram_18_inst_0_0_0.INITVAL_3D = INITVAL_3D ;
			defparam ram_18_inst_0_0_0.INITVAL_3C = INITVAL_3C ;
			defparam ram_18_inst_0_0_0.INITVAL_3B = INITVAL_3B ;
			defparam ram_18_inst_0_0_0.INITVAL_3A = INITVAL_3A ;
			defparam ram_18_inst_0_0_0.INITVAL_39 = INITVAL_39 ;
			defparam ram_18_inst_0_0_0.INITVAL_38 = INITVAL_38 ;
			defparam ram_18_inst_0_0_0.INITVAL_37 = INITVAL_37 ;
			defparam ram_18_inst_0_0_0.INITVAL_36 = INITVAL_36 ;
			defparam ram_18_inst_0_0_0.INITVAL_35 = INITVAL_35 ;
			defparam ram_18_inst_0_0_0.INITVAL_34 = INITVAL_34 ;
			defparam ram_18_inst_0_0_0.INITVAL_33 = INITVAL_33 ;
			defparam ram_18_inst_0_0_0.INITVAL_32 = INITVAL_32 ;
			defparam ram_18_inst_0_0_0.INITVAL_31 = INITVAL_31 ;
			defparam ram_18_inst_0_0_0.INITVAL_30 = INITVAL_30 ;
			defparam ram_18_inst_0_0_0.INITVAL_2F = INITVAL_2F ;
			defparam ram_18_inst_0_0_0.INITVAL_2E = INITVAL_2E ;
			defparam ram_18_inst_0_0_0.INITVAL_2D = INITVAL_2D ;
			defparam ram_18_inst_0_0_0.INITVAL_2C = INITVAL_2C ;
			defparam ram_18_inst_0_0_0.INITVAL_2B = INITVAL_2B ;
			defparam ram_18_inst_0_0_0.INITVAL_2A = INITVAL_2A ;
			defparam ram_18_inst_0_0_0.INITVAL_29 = INITVAL_29 ;
			defparam ram_18_inst_0_0_0.INITVAL_28 = INITVAL_28 ;
			defparam ram_18_inst_0_0_0.INITVAL_27 = INITVAL_27 ;
			defparam ram_18_inst_0_0_0.INITVAL_26 = INITVAL_26 ;
			defparam ram_18_inst_0_0_0.INITVAL_25 = INITVAL_25 ;
			defparam ram_18_inst_0_0_0.INITVAL_24 = INITVAL_24 ;
			defparam ram_18_inst_0_0_0.INITVAL_23 = INITVAL_23 ;
			defparam ram_18_inst_0_0_0.INITVAL_22 = INITVAL_22 ;
			defparam ram_18_inst_0_0_0.INITVAL_21 = INITVAL_21 ;
			defparam ram_18_inst_0_0_0.INITVAL_20 = INITVAL_20 ;
			defparam ram_18_inst_0_0_0.INITVAL_1F = INITVAL_1F ;
			defparam ram_18_inst_0_0_0.INITVAL_1E = INITVAL_1E ;
			defparam ram_18_inst_0_0_0.INITVAL_1D = INITVAL_1D ;
			defparam ram_18_inst_0_0_0.INITVAL_1C = INITVAL_1C ;
			defparam ram_18_inst_0_0_0.INITVAL_1B = INITVAL_1B ;
			defparam ram_18_inst_0_0_0.INITVAL_1A = INITVAL_1A ;
			defparam ram_18_inst_0_0_0.INITVAL_19 = INITVAL_19 ;
			defparam ram_18_inst_0_0_0.INITVAL_18 = INITVAL_18 ;
			defparam ram_18_inst_0_0_0.INITVAL_17 = INITVAL_17 ;
			defparam ram_18_inst_0_0_0.INITVAL_16 = INITVAL_16 ;
			defparam ram_18_inst_0_0_0.INITVAL_15 = INITVAL_15 ;
			defparam ram_18_inst_0_0_0.INITVAL_14 = INITVAL_14 ;
			defparam ram_18_inst_0_0_0.INITVAL_13 = INITVAL_13 ;
			defparam ram_18_inst_0_0_0.INITVAL_12 = INITVAL_12 ;
			defparam ram_18_inst_0_0_0.INITVAL_11 = INITVAL_11 ;
			defparam ram_18_inst_0_0_0.INITVAL_10 = INITVAL_10 ;
			defparam ram_18_inst_0_0_0.INITVAL_0F = INITVAL_0F ;
			defparam ram_18_inst_0_0_0.INITVAL_0E = INITVAL_0E ;
			defparam ram_18_inst_0_0_0.INITVAL_0D = INITVAL_0D ;
			defparam ram_18_inst_0_0_0.INITVAL_0C = INITVAL_0C ;
			defparam ram_18_inst_0_0_0.INITVAL_0B = INITVAL_0B ;
			defparam ram_18_inst_0_0_0.INITVAL_0A = INITVAL_0A ;
			defparam ram_18_inst_0_0_0.INITVAL_09 = INITVAL_09 ;
			defparam ram_18_inst_0_0_0.INITVAL_08 = INITVAL_08 ;
			defparam ram_18_inst_0_0_0.INITVAL_07 = INITVAL_07 ;
			defparam ram_18_inst_0_0_0.INITVAL_06 = INITVAL_06 ;
			defparam ram_18_inst_0_0_0.INITVAL_05 = INITVAL_05 ;
			defparam ram_18_inst_0_0_0.INITVAL_04 = INITVAL_04 ;
			defparam ram_18_inst_0_0_0.INITVAL_03 = INITVAL_03 ;
			defparam ram_18_inst_0_0_0.INITVAL_02 = INITVAL_02 ;
			defparam ram_18_inst_0_0_0.INITVAL_01 = INITVAL_01 ;
			defparam ram_18_inst_0_0_0.INITVAL_00 = INITVAL_00 ;
			defparam ram_18_inst_0_0_0.CSDECODE_A = "0b000" ;
			defparam ram_18_inst_0_0_0.CSDECODE_B = "0b000" ;
			defparam ram_18_inst_0_0_0.WRITEMODE_A = "READBEFOREWRITE" ;
			defparam ram_18_inst_0_0_0.WRITEMODE_B = "WRITETHROUGH" ;
			defparam ram_18_inst_0_0_0.GSR = "DISABLED" ;
			defparam ram_18_inst_0_0_0.RESETMODE = "ASYNC" ;
 			defparam ram_18_inst_0_0_0.REGMODE_A = "NOREG" ;
			defparam ram_18_inst_0_0_0.REGMODE_B = "NOREG" ;
			defparam ram_18_inst_0_0_0.DATA_WIDTH_A = 18 ;
			defparam ram_18_inst_0_0_0.DATA_WIDTH_B = 18 ;
			DP16KD ram_18_inst_0_0_0 (
						    .DIA0(DIA[0]), 
						    .DIA1(DIA[1]), 
						    .DIA2(DIA[2]), 
						    .DIA3(DIA[3]), 
						    .DIA4(DIA[4]), 
						    .DIA5(DIA[5]), 
						    .DIA6(DIA[6]), 
						    .DIA7(DIA[7]), 
						    .DIA8(DIA[8]), 
						    .DIA9(DIA[9]), 
						    .DIA10(DIA[10]), 
						    .DIA11(DIA[11]), 
						    .DIA12(DIA[12]), 
						    .DIA13(DIA[13]), 
						    .DIA14(DIA[14]), 
						    .DIA15(DIA[15]), 
						    .DIA16(DIA[16]), 
						    .DIA17(DIA[17]), 
						    .ADA0(scuba_vhi), 
						    .ADA1(scuba_vhi), 
						    .ADA2(scuba_vlo), 
						    .ADA3(scuba_vlo), 
						    .ADA4(ADDRA[0]), 
						    .ADA5(ADDRA[1]), 
						    .ADA6(ADDRA[2]), 
						    .ADA7(ADDRA[3]), 
						    .ADA8(ADDRA[4]), 
						    .ADA9(ADDRA[5]), 
						    .ADA10(ADDRA[6]), 
						    .ADA11(ADDRA[7]), 
						    .ADA12(ADDRA[8]), 
						    .ADA13(ADDRA[9]), 
						    .CEA(ENA), 
						    .CLKA(CLKA), 
						    .OCEA(ENA), 
						    .WEA(WEA), 
						    .CSA0(scuba_vlo), 
						    .CSA1(scuba_vlo), 
						    .CSA2(scuba_vlo), 
						    .RSTA(scuba_vlo), 
						    .DIB0(DIB[0]), 
						    .DIB1(DIB[1]), 
						    .DIB2(DIB[2]), 
						    .DIB3(DIB[3]), 
						    .DIB4(DIB[4]), 
						    .DIB5(DIB[5]), 
						    .DIB6(DIB[6]), 
						    .DIB7(DIB[7]), 
						    .DIB8(DIB[8]), 
						    .DIB9(DIB[9]), 
						    .DIB10(DIB[10]), 
						    .DIB11(DIB[11]), 
						    .DIB12(DIB[12]), 
						    .DIB13(DIB[13]), 
						    .DIB14(DIB[14]), 
						    .DIB15(DIB[15]), 
						    .DIB16(DIB[16]), 
						    .DIB17(DIB[17]), 
						    .ADB0(scuba_vhi), 
						    .ADB1(scuba_vhi), 
						    .ADB2(scuba_vlo), 
						    .ADB3(scuba_vlo), 
						    .ADB4(ADDRB[0]), 
						    .ADB5(ADDRB[1]), 
						    .ADB6(ADDRB[2]), 
						    .ADB7(ADDRB[3]), 
						    .ADB8(ADDRB[4]), 
						    .ADB9(ADDRB[5]), 
						    .ADB10(ADDRB[6]), 
						    .ADB11(ADDRB[7]), 
						    .ADB12(ADDRB[8]), 
						    .ADB13(ADDRB[9]), 
						    .CEB(ENB), 
						    .CLKB(CLKB), 
						    .OCEB(ENB), 
						    .WEB(WEB), 
						    .CSB0(scuba_vlo), 
						    .CSB1(scuba_vlo), 
						    .CSB2(scuba_vlo), 
						    .RSTB(scuba_vlo), 
						    .DOA0(DOA_internal[0]), 
						    .DOA1(DOA_internal[1]), 
						    .DOA2(DOA_internal[2]), 
						    .DOA3(DOA_internal[3]), 
						    .DOA4(DOA_internal[4]), 
						    .DOA5(DOA_internal[5]), 
						    .DOA6(DOA_internal[6]), 
						    .DOA7(DOA_internal[7]), 
						    .DOA8(DOA_internal[8]), 
						    .DOA9(DOA_internal[9]), 
						    .DOA10(DOA_internal[10]),
						    .DOA11(DOA_internal[11]), 
						    .DOA12(DOA_internal[12]), 
						    .DOA13(DOA_internal[13]), 
						    .DOA14(DOA_internal[14]), 
						    .DOA15(DOA_internal[15]), 
						    .DOA16(DOA_internal[16]), 
						    .DOA17(DOA_internal[17]), 
						    .DOB0(DOB_internal[0]), 
						    .DOB1(DOB_internal[1]), 
						    .DOB2(DOB_internal[2]), 
						    .DOB3(DOB_internal[3]), 
						    .DOB4(DOB_internal[4]), 
						    .DOB5(DOB_internal[5]), 
						    .DOB6(DOB_internal[6]), 
						    .DOB7(DOB_internal[7]), 
						    .DOB8(DOB_internal[8]), 
						    .DOB9(DOB_internal[9]), 
						    .DOB10(DOB_internal[10]), 
						    .DOB11(DOB_internal[11]),
						    .DOB12(DOB_internal[12]), 
						    .DOB13(DOB_internal[13]), 
						    .DOB14(DOB_internal[14]), 
						    .DOB15(DOB_internal[15]), 
						    .DOB16(DOB_internal[16]), 
						    .DOB17(DOB_internal[17]));

		end

	end

	// end port a = READ_FIRST

	// begin port a = NO_CHANGE

	else if (WRITE_MODE_A == "NO_CHANGE")
	begin

		if (WRITE_MODE_B == "WRITE_FIRST")
		begin

            nochange_ssr_logic #(
            .WIDTH  (      18      ),
            .SRVAL  ( SRVAL_A      )
            ) nochange_ssr_logic_inst_a (
            .CLK    ( CLKA         ),
            .DO_in  ( DOA_internal ),
            .DO_out ( DOA          ),
            .EN     ( ENA          ),
            .WE     ( WEA          ),
            .SSR    ( SSRA         )
            );     
            
            ssr_logic #(
            .WIDTH  (      18      ),
            .SRVAL  ( SRVAL_B      )
            ) ssr_logic_inst_b (
            .CLK    ( CLKB         ),
            .DO_in  ( DOB_internal ),
            .DO_out ( DOB          ),
            .EN     ( ENB          ),
            .SSR    ( SSRB         )
            ); 


			defparam ram_18_inst_0_0_0.INIT_DATA = "STATIC" ;
			defparam ram_18_inst_0_0_0.ASYNC_RESET_RELEASE = "SYNC" ;
			defparam ram_18_inst_0_0_0.INITVAL_3F = INITVAL_3F ;
			defparam ram_18_inst_0_0_0.INITVAL_3E = INITVAL_3E ;
			defparam ram_18_inst_0_0_0.INITVAL_3D = INITVAL_3D ;
			defparam ram_18_inst_0_0_0.INITVAL_3C = INITVAL_3C ;
			defparam ram_18_inst_0_0_0.INITVAL_3B = INITVAL_3B ;
			defparam ram_18_inst_0_0_0.INITVAL_3A = INITVAL_3A ;
			defparam ram_18_inst_0_0_0.INITVAL_39 = INITVAL_39 ;
			defparam ram_18_inst_0_0_0.INITVAL_38 = INITVAL_38 ;
			defparam ram_18_inst_0_0_0.INITVAL_37 = INITVAL_37 ;
			defparam ram_18_inst_0_0_0.INITVAL_36 = INITVAL_36 ;
			defparam ram_18_inst_0_0_0.INITVAL_35 = INITVAL_35 ;
			defparam ram_18_inst_0_0_0.INITVAL_34 = INITVAL_34 ;
			defparam ram_18_inst_0_0_0.INITVAL_33 = INITVAL_33 ;
			defparam ram_18_inst_0_0_0.INITVAL_32 = INITVAL_32 ;
			defparam ram_18_inst_0_0_0.INITVAL_31 = INITVAL_31 ;
			defparam ram_18_inst_0_0_0.INITVAL_30 = INITVAL_30 ;
			defparam ram_18_inst_0_0_0.INITVAL_2F = INITVAL_2F ;
			defparam ram_18_inst_0_0_0.INITVAL_2E = INITVAL_2E ;
			defparam ram_18_inst_0_0_0.INITVAL_2D = INITVAL_2D ;
			defparam ram_18_inst_0_0_0.INITVAL_2C = INITVAL_2C ;
			defparam ram_18_inst_0_0_0.INITVAL_2B = INITVAL_2B ;
			defparam ram_18_inst_0_0_0.INITVAL_2A = INITVAL_2A ;
			defparam ram_18_inst_0_0_0.INITVAL_29 = INITVAL_29 ;
			defparam ram_18_inst_0_0_0.INITVAL_28 = INITVAL_28 ;
			defparam ram_18_inst_0_0_0.INITVAL_27 = INITVAL_27 ;
			defparam ram_18_inst_0_0_0.INITVAL_26 = INITVAL_26 ;
			defparam ram_18_inst_0_0_0.INITVAL_25 = INITVAL_25 ;
			defparam ram_18_inst_0_0_0.INITVAL_24 = INITVAL_24 ;
			defparam ram_18_inst_0_0_0.INITVAL_23 = INITVAL_23 ;
			defparam ram_18_inst_0_0_0.INITVAL_22 = INITVAL_22 ;
			defparam ram_18_inst_0_0_0.INITVAL_21 = INITVAL_21 ;
			defparam ram_18_inst_0_0_0.INITVAL_20 = INITVAL_20 ;
			defparam ram_18_inst_0_0_0.INITVAL_1F = INITVAL_1F ;
			defparam ram_18_inst_0_0_0.INITVAL_1E = INITVAL_1E ;
			defparam ram_18_inst_0_0_0.INITVAL_1D = INITVAL_1D ;
			defparam ram_18_inst_0_0_0.INITVAL_1C = INITVAL_1C ;
			defparam ram_18_inst_0_0_0.INITVAL_1B = INITVAL_1B ;
			defparam ram_18_inst_0_0_0.INITVAL_1A = INITVAL_1A ;
			defparam ram_18_inst_0_0_0.INITVAL_19 = INITVAL_19 ;
			defparam ram_18_inst_0_0_0.INITVAL_18 = INITVAL_18 ;
			defparam ram_18_inst_0_0_0.INITVAL_17 = INITVAL_17 ;
			defparam ram_18_inst_0_0_0.INITVAL_16 = INITVAL_16 ;
			defparam ram_18_inst_0_0_0.INITVAL_15 = INITVAL_15 ;
			defparam ram_18_inst_0_0_0.INITVAL_14 = INITVAL_14 ;
			defparam ram_18_inst_0_0_0.INITVAL_13 = INITVAL_13 ;
			defparam ram_18_inst_0_0_0.INITVAL_12 = INITVAL_12 ;
			defparam ram_18_inst_0_0_0.INITVAL_11 = INITVAL_11 ;
			defparam ram_18_inst_0_0_0.INITVAL_10 = INITVAL_10 ;
			defparam ram_18_inst_0_0_0.INITVAL_0F = INITVAL_0F ;
			defparam ram_18_inst_0_0_0.INITVAL_0E = INITVAL_0E ;
			defparam ram_18_inst_0_0_0.INITVAL_0D = INITVAL_0D ;
			defparam ram_18_inst_0_0_0.INITVAL_0C = INITVAL_0C ;
			defparam ram_18_inst_0_0_0.INITVAL_0B = INITVAL_0B ;
			defparam ram_18_inst_0_0_0.INITVAL_0A = INITVAL_0A ;
			defparam ram_18_inst_0_0_0.INITVAL_09 = INITVAL_09 ;
			defparam ram_18_inst_0_0_0.INITVAL_08 = INITVAL_08 ;
			defparam ram_18_inst_0_0_0.INITVAL_07 = INITVAL_07 ;
			defparam ram_18_inst_0_0_0.INITVAL_06 = INITVAL_06 ;
			defparam ram_18_inst_0_0_0.INITVAL_05 = INITVAL_05 ;
			defparam ram_18_inst_0_0_0.INITVAL_04 = INITVAL_04 ;
			defparam ram_18_inst_0_0_0.INITVAL_03 = INITVAL_03 ;
			defparam ram_18_inst_0_0_0.INITVAL_02 = INITVAL_02 ;
			defparam ram_18_inst_0_0_0.INITVAL_01 = INITVAL_01 ;
			defparam ram_18_inst_0_0_0.INITVAL_00 = INITVAL_00 ;
			defparam ram_18_inst_0_0_0.CSDECODE_A = "0b000" ;
			defparam ram_18_inst_0_0_0.CSDECODE_B = "0b000" ;
			defparam ram_18_inst_0_0_0.WRITEMODE_A = "WRITETHROUGH" ;
			defparam ram_18_inst_0_0_0.WRITEMODE_B = "WRITETHROUGH" ;
			defparam ram_18_inst_0_0_0.GSR = "DISABLED" ;
			defparam ram_18_inst_0_0_0.RESETMODE = "ASYNC" ;
 			defparam ram_18_inst_0_0_0.REGMODE_A = "NOREG" ;
			defparam ram_18_inst_0_0_0.REGMODE_B = "NOREG" ;
			defparam ram_18_inst_0_0_0.DATA_WIDTH_A = 18 ;
			defparam ram_18_inst_0_0_0.DATA_WIDTH_B = 18 ;
			DP16KD ram_18_inst_0_0_0 (
						    .DIA0(DIA[0]), 
						    .DIA1(DIA[1]), 
						    .DIA2(DIA[2]), 
						    .DIA3(DIA[3]), 
						    .DIA4(DIA[4]), 
						    .DIA5(DIA[5]), 
						    .DIA6(DIA[6]), 
						    .DIA7(DIA[7]), 
						    .DIA8(DIA[8]), 
						    .DIA9(DIA[9]), 
						    .DIA10(DIA[10]), 
						    .DIA11(DIA[11]), 
						    .DIA12(DIA[12]), 
						    .DIA13(DIA[13]), 
						    .DIA14(DIA[14]), 
						    .DIA15(DIA[15]), 
						    .DIA16(DIA[16]), 
						    .DIA17(DIA[17]), 
						    .ADA0(scuba_vhi), 
						    .ADA1(scuba_vhi), 
						    .ADA2(scuba_vlo), 
						    .ADA3(scuba_vlo), 
						    .ADA4(ADDRA[0]), 
						    .ADA5(ADDRA[1]), 
						    .ADA6(ADDRA[2]), 
						    .ADA7(ADDRA[3]), 
						    .ADA8(ADDRA[4]), 
						    .ADA9(ADDRA[5]), 
						    .ADA10(ADDRA[6]), 
						    .ADA11(ADDRA[7]), 
						    .ADA12(ADDRA[8]), 
						    .ADA13(ADDRA[9]), 
						    .CEA(ENA), 
						    .CLKA(CLKA), 
						    .OCEA(ENA), 
						    .WEA(WEA), 
						    .CSA0(scuba_vlo), 
						    .CSA1(scuba_vlo), 
						    .CSA2(scuba_vlo), 
						    .RSTA(scuba_vlo), 
						    .DIB0(DIB[0]), 
						    .DIB1(DIB[1]), 
						    .DIB2(DIB[2]), 
						    .DIB3(DIB[3]), 
						    .DIB4(DIB[4]), 
						    .DIB5(DIB[5]), 
						    .DIB6(DIB[6]), 
						    .DIB7(DIB[7]), 
						    .DIB8(DIB[8]), 
						    .DIB9(DIB[9]), 
						    .DIB10(DIB[10]), 
						    .DIB11(DIB[11]), 
						    .DIB12(DIB[12]), 
						    .DIB13(DIB[13]), 
						    .DIB14(DIB[14]), 
						    .DIB15(DIB[15]), 
						    .DIB16(DIB[16]), 
						    .DIB17(DIB[17]), 
						    .ADB0(scuba_vhi), 
						    .ADB1(scuba_vhi), 
						    .ADB2(scuba_vlo), 
						    .ADB3(scuba_vlo), 
						    .ADB4(ADDRB[0]), 
						    .ADB5(ADDRB[1]), 
						    .ADB6(ADDRB[2]), 
						    .ADB7(ADDRB[3]), 
						    .ADB8(ADDRB[4]), 
						    .ADB9(ADDRB[5]), 
						    .ADB10(ADDRB[6]), 
						    .ADB11(ADDRB[7]), 
						    .ADB12(ADDRB[8]), 
						    .ADB13(ADDRB[9]), 
						    .CEB(ENB), 
						    .CLKB(CLKB), 
						    .OCEB(ENB), 
						    .WEB(WEB), 
						    .CSB0(scuba_vlo), 
						    .CSB1(scuba_vlo), 
						    .CSB2(scuba_vlo), 
						    .RSTB(scuba_vlo), 
						    .DOA0(DOA_internal[0]), 
						    .DOA1(DOA_internal[1]), 
						    .DOA2(DOA_internal[2]), 
						    .DOA3(DOA_internal[3]), 
						    .DOA4(DOA_internal[4]), 
						    .DOA5(DOA_internal[5]), 
						    .DOA6(DOA_internal[6]), 
						    .DOA7(DOA_internal[7]), 
						    .DOA8(DOA_internal[8]), 
						    .DOA9(DOA_internal[9]), 
						    .DOA10(DOA_internal[10]),
						    .DOA11(DOA_internal[11]), 
						    .DOA12(DOA_internal[12]), 
						    .DOA13(DOA_internal[13]), 
						    .DOA14(DOA_internal[14]), 
						    .DOA15(DOA_internal[15]), 
						    .DOA16(DOA_internal[16]), 
						    .DOA17(DOA_internal[17]), 
						    .DOB0(DOB_internal[0]), 
						    .DOB1(DOB_internal[1]), 
						    .DOB2(DOB_internal[2]), 
						    .DOB3(DOB_internal[3]), 
						    .DOB4(DOB_internal[4]), 
						    .DOB5(DOB_internal[5]), 
						    .DOB6(DOB_internal[6]), 
						    .DOB7(DOB_internal[7]), 
						    .DOB8(DOB_internal[8]), 
						    .DOB9(DOB_internal[9]), 
						    .DOB10(DOB_internal[10]), 
						    .DOB11(DOB_internal[11]),
						    .DOB12(DOB_internal[12]), 
						    .DOB13(DOB_internal[13]), 
						    .DOB14(DOB_internal[14]), 
						    .DOB15(DOB_internal[15]), 
						    .DOB16(DOB_internal[16]), 
						    .DOB17(DOB_internal[17]));

		end
		else if (WRITE_MODE_B == "READ_FIRST")
		begin

			nochange_ssr_logic #(
            .WIDTH  (      18      ),
            .SRVAL  ( SRVAL_A      )
            ) nochange_ssr_logic_inst_a (
            .CLK    ( CLKA         ),
            .DO_in  ( DOA_internal ),
            .DO_out ( DOA          ),
            .EN     ( ENA          ),
            .WE     ( WEA          ),
            .SSR    ( SSRA         )
            );     
            
            ssr_logic #(
            .WIDTH  (      18      ),
            .SRVAL  ( SRVAL_B      )
            ) ssr_logic_inst_b (
            .CLK    ( CLKB         ),
            .DO_in  ( DOB_internal ),
            .DO_out ( DOB          ),
            .EN     ( ENB          ),
            .SSR    ( SSRB         )
            );

			defparam ram_18_inst_0_0_0.INIT_DATA = "STATIC" ;
			defparam ram_18_inst_0_0_0.ASYNC_RESET_RELEASE = "SYNC" ;
			defparam ram_18_inst_0_0_0.INITVAL_3F = INITVAL_3F ;
			defparam ram_18_inst_0_0_0.INITVAL_3E = INITVAL_3E ;
			defparam ram_18_inst_0_0_0.INITVAL_3D = INITVAL_3D ;
			defparam ram_18_inst_0_0_0.INITVAL_3C = INITVAL_3C ;
			defparam ram_18_inst_0_0_0.INITVAL_3B = INITVAL_3B ;
			defparam ram_18_inst_0_0_0.INITVAL_3A = INITVAL_3A ;
			defparam ram_18_inst_0_0_0.INITVAL_39 = INITVAL_39 ;
			defparam ram_18_inst_0_0_0.INITVAL_38 = INITVAL_38 ;
			defparam ram_18_inst_0_0_0.INITVAL_37 = INITVAL_37 ;
			defparam ram_18_inst_0_0_0.INITVAL_36 = INITVAL_36 ;
			defparam ram_18_inst_0_0_0.INITVAL_35 = INITVAL_35 ;
			defparam ram_18_inst_0_0_0.INITVAL_34 = INITVAL_34 ;
			defparam ram_18_inst_0_0_0.INITVAL_33 = INITVAL_33 ;
			defparam ram_18_inst_0_0_0.INITVAL_32 = INITVAL_32 ;
			defparam ram_18_inst_0_0_0.INITVAL_31 = INITVAL_31 ;
			defparam ram_18_inst_0_0_0.INITVAL_30 = INITVAL_30 ;
			defparam ram_18_inst_0_0_0.INITVAL_2F = INITVAL_2F ;
			defparam ram_18_inst_0_0_0.INITVAL_2E = INITVAL_2E ;
			defparam ram_18_inst_0_0_0.INITVAL_2D = INITVAL_2D ;
			defparam ram_18_inst_0_0_0.INITVAL_2C = INITVAL_2C ;
			defparam ram_18_inst_0_0_0.INITVAL_2B = INITVAL_2B ;
			defparam ram_18_inst_0_0_0.INITVAL_2A = INITVAL_2A ;
			defparam ram_18_inst_0_0_0.INITVAL_29 = INITVAL_29 ;
			defparam ram_18_inst_0_0_0.INITVAL_28 = INITVAL_28 ;
			defparam ram_18_inst_0_0_0.INITVAL_27 = INITVAL_27 ;
			defparam ram_18_inst_0_0_0.INITVAL_26 = INITVAL_26 ;
			defparam ram_18_inst_0_0_0.INITVAL_25 = INITVAL_25 ;
			defparam ram_18_inst_0_0_0.INITVAL_24 = INITVAL_24 ;
			defparam ram_18_inst_0_0_0.INITVAL_23 = INITVAL_23 ;
			defparam ram_18_inst_0_0_0.INITVAL_22 = INITVAL_22 ;
			defparam ram_18_inst_0_0_0.INITVAL_21 = INITVAL_21 ;
			defparam ram_18_inst_0_0_0.INITVAL_20 = INITVAL_20 ;
			defparam ram_18_inst_0_0_0.INITVAL_1F = INITVAL_1F ;
			defparam ram_18_inst_0_0_0.INITVAL_1E = INITVAL_1E ;
			defparam ram_18_inst_0_0_0.INITVAL_1D = INITVAL_1D ;
			defparam ram_18_inst_0_0_0.INITVAL_1C = INITVAL_1C ;
			defparam ram_18_inst_0_0_0.INITVAL_1B = INITVAL_1B ;
			defparam ram_18_inst_0_0_0.INITVAL_1A = INITVAL_1A ;
			defparam ram_18_inst_0_0_0.INITVAL_19 = INITVAL_19 ;
			defparam ram_18_inst_0_0_0.INITVAL_18 = INITVAL_18 ;
			defparam ram_18_inst_0_0_0.INITVAL_17 = INITVAL_17 ;
			defparam ram_18_inst_0_0_0.INITVAL_16 = INITVAL_16 ;
			defparam ram_18_inst_0_0_0.INITVAL_15 = INITVAL_15 ;
			defparam ram_18_inst_0_0_0.INITVAL_14 = INITVAL_14 ;
			defparam ram_18_inst_0_0_0.INITVAL_13 = INITVAL_13 ;
			defparam ram_18_inst_0_0_0.INITVAL_12 = INITVAL_12 ;
			defparam ram_18_inst_0_0_0.INITVAL_11 = INITVAL_11 ;
			defparam ram_18_inst_0_0_0.INITVAL_10 = INITVAL_10 ;
			defparam ram_18_inst_0_0_0.INITVAL_0F = INITVAL_0F ;
			defparam ram_18_inst_0_0_0.INITVAL_0E = INITVAL_0E ;
			defparam ram_18_inst_0_0_0.INITVAL_0D = INITVAL_0D ;
			defparam ram_18_inst_0_0_0.INITVAL_0C = INITVAL_0C ;
			defparam ram_18_inst_0_0_0.INITVAL_0B = INITVAL_0B ;
			defparam ram_18_inst_0_0_0.INITVAL_0A = INITVAL_0A ;
			defparam ram_18_inst_0_0_0.INITVAL_09 = INITVAL_09 ;
			defparam ram_18_inst_0_0_0.INITVAL_08 = INITVAL_08 ;
			defparam ram_18_inst_0_0_0.INITVAL_07 = INITVAL_07 ;
			defparam ram_18_inst_0_0_0.INITVAL_06 = INITVAL_06 ;
			defparam ram_18_inst_0_0_0.INITVAL_05 = INITVAL_05 ;
			defparam ram_18_inst_0_0_0.INITVAL_04 = INITVAL_04 ;
			defparam ram_18_inst_0_0_0.INITVAL_03 = INITVAL_03 ;
			defparam ram_18_inst_0_0_0.INITVAL_02 = INITVAL_02 ;
			defparam ram_18_inst_0_0_0.INITVAL_01 = INITVAL_01 ;
			defparam ram_18_inst_0_0_0.INITVAL_00 = INITVAL_00 ;
			defparam ram_18_inst_0_0_0.CSDECODE_A = "0b000" ;
			defparam ram_18_inst_0_0_0.CSDECODE_B = "0b000" ;
			defparam ram_18_inst_0_0_0.WRITEMODE_A = "WRITETHROUGH" ;
			defparam ram_18_inst_0_0_0.WRITEMODE_B = "READBEFOREWRITE" ;
			defparam ram_18_inst_0_0_0.GSR = "DISABLED" ;
			defparam ram_18_inst_0_0_0.RESETMODE = "ASYNC" ;
 			defparam ram_18_inst_0_0_0.REGMODE_A = "NOREG" ;
			defparam ram_18_inst_0_0_0.REGMODE_B = "NOREG" ;
			defparam ram_18_inst_0_0_0.DATA_WIDTH_A = 18 ;
			defparam ram_18_inst_0_0_0.DATA_WIDTH_B = 18 ;
			DP16KD ram_18_inst_0_0_0 (
						    .DIA0(DIA[0]), 
						    .DIA1(DIA[1]), 
						    .DIA2(DIA[2]), 
						    .DIA3(DIA[3]), 
						    .DIA4(DIA[4]), 
						    .DIA5(DIA[5]), 
						    .DIA6(DIA[6]), 
						    .DIA7(DIA[7]), 
						    .DIA8(DIA[8]), 
						    .DIA9(DIA[9]), 
						    .DIA10(DIA[10]), 
						    .DIA11(DIA[11]), 
						    .DIA12(DIA[12]), 
						    .DIA13(DIA[13]), 
						    .DIA14(DIA[14]), 
						    .DIA15(DIA[15]), 
						    .DIA16(DIA[16]), 
						    .DIA17(DIA[17]), 
						    .ADA0(scuba_vhi), 
						    .ADA1(scuba_vhi), 
						    .ADA2(scuba_vlo), 
						    .ADA3(scuba_vlo), 
						    .ADA4(ADDRA[0]), 
						    .ADA5(ADDRA[1]), 
						    .ADA6(ADDRA[2]), 
						    .ADA7(ADDRA[3]), 
						    .ADA8(ADDRA[4]), 
						    .ADA9(ADDRA[5]), 
						    .ADA10(ADDRA[6]), 
						    .ADA11(ADDRA[7]), 
						    .ADA12(ADDRA[8]), 
						    .ADA13(ADDRA[9]), 
						    .CEA(ENA), 
						    .CLKA(CLKA), 
						    .OCEA(ENA), 
						    .WEA(WEA), 
						    .CSA0(scuba_vlo), 
						    .CSA1(scuba_vlo), 
						    .CSA2(scuba_vlo), 
						    .RSTA(scuba_vlo), 
						    .DIB0(DIB[0]), 
						    .DIB1(DIB[1]), 
						    .DIB2(DIB[2]), 
						    .DIB3(DIB[3]), 
						    .DIB4(DIB[4]), 
						    .DIB5(DIB[5]), 
						    .DIB6(DIB[6]), 
						    .DIB7(DIB[7]), 
						    .DIB8(DIB[8]), 
						    .DIB9(DIB[9]), 
						    .DIB10(DIB[10]), 
						    .DIB11(DIB[11]), 
						    .DIB12(DIB[12]), 
						    .DIB13(DIB[13]), 
						    .DIB14(DIB[14]), 
						    .DIB15(DIB[15]), 
						    .DIB16(DIB[16]), 
						    .DIB17(DIB[17]), 
						    .ADB0(scuba_vhi), 
						    .ADB1(scuba_vhi), 
						    .ADB2(scuba_vlo), 
						    .ADB3(scuba_vlo), 
						    .ADB4(ADDRB[0]), 
						    .ADB5(ADDRB[1]), 
						    .ADB6(ADDRB[2]), 
						    .ADB7(ADDRB[3]), 
						    .ADB8(ADDRB[4]), 
						    .ADB9(ADDRB[5]), 
						    .ADB10(ADDRB[6]), 
						    .ADB11(ADDRB[7]), 
						    .ADB12(ADDRB[8]), 
						    .ADB13(ADDRB[9]), 
						    .CEB(ENB), 
						    .CLKB(CLKB), 
						    .OCEB(ENB), 
						    .WEB(WEB), 
						    .CSB0(scuba_vlo), 
						    .CSB1(scuba_vlo), 
						    .CSB2(scuba_vlo), 
						    .RSTB(scuba_vlo), 
						    .DOA0(DOA_internal[0]), 
						    .DOA1(DOA_internal[1]), 
						    .DOA2(DOA_internal[2]), 
						    .DOA3(DOA_internal[3]), 
						    .DOA4(DOA_internal[4]), 
						    .DOA5(DOA_internal[5]), 
						    .DOA6(DOA_internal[6]), 
						    .DOA7(DOA_internal[7]), 
						    .DOA8(DOA_internal[8]), 
						    .DOA9(DOA_internal[9]), 
						    .DOA10(DOA_internal[10]),
						    .DOA11(DOA_internal[11]), 
						    .DOA12(DOA_internal[12]), 
						    .DOA13(DOA_internal[13]), 
						    .DOA14(DOA_internal[14]), 
						    .DOA15(DOA_internal[15]), 
						    .DOA16(DOA_internal[16]), 
						    .DOA17(DOA_internal[17]), 
						    .DOB0(DOB_internal[0]), 
						    .DOB1(DOB_internal[1]), 
						    .DOB2(DOB_internal[2]), 
						    .DOB3(DOB_internal[3]), 
						    .DOB4(DOB_internal[4]), 
						    .DOB5(DOB_internal[5]), 
						    .DOB6(DOB_internal[6]), 
						    .DOB7(DOB_internal[7]), 
						    .DOB8(DOB_internal[8]), 
						    .DOB9(DOB_internal[9]), 
						    .DOB10(DOB_internal[10]), 
						    .DOB11(DOB_internal[11]),
						    .DOB12(DOB_internal[12]), 
						    .DOB13(DOB_internal[13]), 
						    .DOB14(DOB_internal[14]), 
						    .DOB15(DOB_internal[15]), 
						    .DOB16(DOB_internal[16]), 
						    .DOB17(DOB_internal[17]));

		end
		else if (WRITE_MODE_B == "NO_CHANGE")
		begin

			nochange_ssr_logic #(
            .WIDTH  (      18      ),
            .SRVAL  ( SRVAL_A      )
            ) nochange_ssr_logic_inst_a (
            .CLK    ( CLKA         ),
            .DO_in  ( DOA_internal ),
            .DO_out ( DOA          ),
            .EN     ( ENA          ),
            .WE     ( WEA          ),
            .SSR    ( SSRA         )
            );     
            
            nochange_ssr_logic #(
            .WIDTH  (      18      ),
            .SRVAL  ( SRVAL_B      )
            ) nochange_ssr_logic_inst_b (
            .CLK    ( CLKB         ),
            .DO_in  ( DOB_internal ),
            .DO_out ( DOB          ),
            .EN     ( ENB          ),
            .WE     ( WEB          ),
            .SSR    ( SSRB         )
            );   

			defparam ram_18_inst_0_0_0.INIT_DATA = "STATIC" ;
			defparam ram_18_inst_0_0_0.ASYNC_RESET_RELEASE = "SYNC" ;
			defparam ram_18_inst_0_0_0.INITVAL_3F = INITVAL_3F ;
			defparam ram_18_inst_0_0_0.INITVAL_3E = INITVAL_3E ;
			defparam ram_18_inst_0_0_0.INITVAL_3D = INITVAL_3D ;
			defparam ram_18_inst_0_0_0.INITVAL_3C = INITVAL_3C ;
			defparam ram_18_inst_0_0_0.INITVAL_3B = INITVAL_3B ;
			defparam ram_18_inst_0_0_0.INITVAL_3A = INITVAL_3A ;
			defparam ram_18_inst_0_0_0.INITVAL_39 = INITVAL_39 ;
			defparam ram_18_inst_0_0_0.INITVAL_38 = INITVAL_38 ;
			defparam ram_18_inst_0_0_0.INITVAL_37 = INITVAL_37 ;
			defparam ram_18_inst_0_0_0.INITVAL_36 = INITVAL_36 ;
			defparam ram_18_inst_0_0_0.INITVAL_35 = INITVAL_35 ;
			defparam ram_18_inst_0_0_0.INITVAL_34 = INITVAL_34 ;
			defparam ram_18_inst_0_0_0.INITVAL_33 = INITVAL_33 ;
			defparam ram_18_inst_0_0_0.INITVAL_32 = INITVAL_32 ;
			defparam ram_18_inst_0_0_0.INITVAL_31 = INITVAL_31 ;
			defparam ram_18_inst_0_0_0.INITVAL_30 = INITVAL_30 ;
			defparam ram_18_inst_0_0_0.INITVAL_2F = INITVAL_2F ;
			defparam ram_18_inst_0_0_0.INITVAL_2E = INITVAL_2E ;
			defparam ram_18_inst_0_0_0.INITVAL_2D = INITVAL_2D ;
			defparam ram_18_inst_0_0_0.INITVAL_2C = INITVAL_2C ;
			defparam ram_18_inst_0_0_0.INITVAL_2B = INITVAL_2B ;
			defparam ram_18_inst_0_0_0.INITVAL_2A = INITVAL_2A ;
			defparam ram_18_inst_0_0_0.INITVAL_29 = INITVAL_29 ;
			defparam ram_18_inst_0_0_0.INITVAL_28 = INITVAL_28 ;
			defparam ram_18_inst_0_0_0.INITVAL_27 = INITVAL_27 ;
			defparam ram_18_inst_0_0_0.INITVAL_26 = INITVAL_26 ;
			defparam ram_18_inst_0_0_0.INITVAL_25 = INITVAL_25 ;
			defparam ram_18_inst_0_0_0.INITVAL_24 = INITVAL_24 ;
			defparam ram_18_inst_0_0_0.INITVAL_23 = INITVAL_23 ;
			defparam ram_18_inst_0_0_0.INITVAL_22 = INITVAL_22 ;
			defparam ram_18_inst_0_0_0.INITVAL_21 = INITVAL_21 ;
			defparam ram_18_inst_0_0_0.INITVAL_20 = INITVAL_20 ;
			defparam ram_18_inst_0_0_0.INITVAL_1F = INITVAL_1F ;
			defparam ram_18_inst_0_0_0.INITVAL_1E = INITVAL_1E ;
			defparam ram_18_inst_0_0_0.INITVAL_1D = INITVAL_1D ;
			defparam ram_18_inst_0_0_0.INITVAL_1C = INITVAL_1C ;
			defparam ram_18_inst_0_0_0.INITVAL_1B = INITVAL_1B ;
			defparam ram_18_inst_0_0_0.INITVAL_1A = INITVAL_1A ;
			defparam ram_18_inst_0_0_0.INITVAL_19 = INITVAL_19 ;
			defparam ram_18_inst_0_0_0.INITVAL_18 = INITVAL_18 ;
			defparam ram_18_inst_0_0_0.INITVAL_17 = INITVAL_17 ;
			defparam ram_18_inst_0_0_0.INITVAL_16 = INITVAL_16 ;
			defparam ram_18_inst_0_0_0.INITVAL_15 = INITVAL_15 ;
			defparam ram_18_inst_0_0_0.INITVAL_14 = INITVAL_14 ;
			defparam ram_18_inst_0_0_0.INITVAL_13 = INITVAL_13 ;
			defparam ram_18_inst_0_0_0.INITVAL_12 = INITVAL_12 ;
			defparam ram_18_inst_0_0_0.INITVAL_11 = INITVAL_11 ;
			defparam ram_18_inst_0_0_0.INITVAL_10 = INITVAL_10 ;
			defparam ram_18_inst_0_0_0.INITVAL_0F = INITVAL_0F ;
			defparam ram_18_inst_0_0_0.INITVAL_0E = INITVAL_0E ;
			defparam ram_18_inst_0_0_0.INITVAL_0D = INITVAL_0D ;
			defparam ram_18_inst_0_0_0.INITVAL_0C = INITVAL_0C ;
			defparam ram_18_inst_0_0_0.INITVAL_0B = INITVAL_0B ;
			defparam ram_18_inst_0_0_0.INITVAL_0A = INITVAL_0A ;
			defparam ram_18_inst_0_0_0.INITVAL_09 = INITVAL_09 ;
			defparam ram_18_inst_0_0_0.INITVAL_08 = INITVAL_08 ;
			defparam ram_18_inst_0_0_0.INITVAL_07 = INITVAL_07 ;
			defparam ram_18_inst_0_0_0.INITVAL_06 = INITVAL_06 ;
			defparam ram_18_inst_0_0_0.INITVAL_05 = INITVAL_05 ;
			defparam ram_18_inst_0_0_0.INITVAL_04 = INITVAL_04 ;
			defparam ram_18_inst_0_0_0.INITVAL_03 = INITVAL_03 ;
			defparam ram_18_inst_0_0_0.INITVAL_02 = INITVAL_02 ;
			defparam ram_18_inst_0_0_0.INITVAL_01 = INITVAL_01 ;
			defparam ram_18_inst_0_0_0.INITVAL_00 = INITVAL_00 ;
			defparam ram_18_inst_0_0_0.CSDECODE_A = "0b000" ;
			defparam ram_18_inst_0_0_0.CSDECODE_B = "0b000" ;
			defparam ram_18_inst_0_0_0.WRITEMODE_A = "WRITETHROUGH" ;
			defparam ram_18_inst_0_0_0.WRITEMODE_B = "WRITETHROUGH" ;
			defparam ram_18_inst_0_0_0.GSR = "DISABLED" ;
			defparam ram_18_inst_0_0_0.RESETMODE = "ASYNC" ;
 			defparam ram_18_inst_0_0_0.REGMODE_A = "NOREG" ;
			defparam ram_18_inst_0_0_0.REGMODE_B = "NOREG" ;
			defparam ram_18_inst_0_0_0.DATA_WIDTH_A = 18 ;
			defparam ram_18_inst_0_0_0.DATA_WIDTH_B = 18 ;
			DP16KD ram_18_inst_0_0_0 (
						    .DIA0(DIA[0]), 
						    .DIA1(DIA[1]), 
						    .DIA2(DIA[2]), 
						    .DIA3(DIA[3]), 
						    .DIA4(DIA[4]), 
						    .DIA5(DIA[5]), 
						    .DIA6(DIA[6]), 
						    .DIA7(DIA[7]), 
						    .DIA8(DIA[8]), 
						    .DIA9(DIA[9]), 
						    .DIA10(DIA[10]), 
						    .DIA11(DIA[11]), 
						    .DIA12(DIA[12]), 
						    .DIA13(DIA[13]), 
						    .DIA14(DIA[14]), 
						    .DIA15(DIA[15]), 
						    .DIA16(DIA[16]), 
						    .DIA17(DIA[17]), 
						    .ADA0(scuba_vhi), 
						    .ADA1(scuba_vhi), 
						    .ADA2(scuba_vlo), 
						    .ADA3(scuba_vlo), 
						    .ADA4(ADDRA[0]), 
						    .ADA5(ADDRA[1]), 
						    .ADA6(ADDRA[2]), 
						    .ADA7(ADDRA[3]), 
						    .ADA8(ADDRA[4]), 
						    .ADA9(ADDRA[5]), 
						    .ADA10(ADDRA[6]), 
						    .ADA11(ADDRA[7]), 
						    .ADA12(ADDRA[8]), 
						    .ADA13(ADDRA[9]), 
						    .CEA(ENA), 
						    .CLKA(CLKA), 
						    .OCEA(ENA), 
						    .WEA(WEA), 
						    .CSA0(scuba_vlo), 
						    .CSA1(scuba_vlo), 
						    .CSA2(scuba_vlo), 
						    .RSTA(scuba_vlo), 
						    .DIB0(DIB[0]), 
						    .DIB1(DIB[1]), 
						    .DIB2(DIB[2]), 
						    .DIB3(DIB[3]), 
						    .DIB4(DIB[4]), 
						    .DIB5(DIB[5]), 
						    .DIB6(DIB[6]), 
						    .DIB7(DIB[7]), 
						    .DIB8(DIB[8]), 
						    .DIB9(DIB[9]), 
						    .DIB10(DIB[10]), 
						    .DIB11(DIB[11]), 
						    .DIB12(DIB[12]), 
						    .DIB13(DIB[13]), 
						    .DIB14(DIB[14]), 
						    .DIB15(DIB[15]), 
						    .DIB16(DIB[16]), 
						    .DIB17(DIB[17]), 
						    .ADB0(scuba_vhi), 
						    .ADB1(scuba_vhi), 
						    .ADB2(scuba_vlo), 
						    .ADB3(scuba_vlo), 
						    .ADB4(ADDRB[0]), 
						    .ADB5(ADDRB[1]), 
						    .ADB6(ADDRB[2]), 
						    .ADB7(ADDRB[3]), 
						    .ADB8(ADDRB[4]), 
						    .ADB9(ADDRB[5]), 
						    .ADB10(ADDRB[6]), 
						    .ADB11(ADDRB[7]), 
						    .ADB12(ADDRB[8]), 
						    .ADB13(ADDRB[9]), 
						    .CEB(ENB), 
						    .CLKB(CLKB), 
						    .OCEB(ENB), 
						    .WEB(WEB), 
						    .CSB0(scuba_vlo), 
						    .CSB1(scuba_vlo), 
						    .CSB2(scuba_vlo), 
						    .RSTB(scuba_vlo), 
						    .DOA0(DOA_internal[0]), 
						    .DOA1(DOA_internal[1]), 
						    .DOA2(DOA_internal[2]), 
						    .DOA3(DOA_internal[3]), 
						    .DOA4(DOA_internal[4]), 
						    .DOA5(DOA_internal[5]), 
						    .DOA6(DOA_internal[6]), 
						    .DOA7(DOA_internal[7]), 
						    .DOA8(DOA_internal[8]), 
						    .DOA9(DOA_internal[9]), 
						    .DOA10(DOA_internal[10]),
						    .DOA11(DOA_internal[11]), 
						    .DOA12(DOA_internal[12]), 
						    .DOA13(DOA_internal[13]), 
						    .DOA14(DOA_internal[14]), 
						    .DOA15(DOA_internal[15]), 
						    .DOA16(DOA_internal[16]), 
						    .DOA17(DOA_internal[17]), 
						    .DOB0(DOB_internal[0]), 
						    .DOB1(DOB_internal[1]), 
						    .DOB2(DOB_internal[2]), 
						    .DOB3(DOB_internal[3]), 
						    .DOB4(DOB_internal[4]), 
						    .DOB5(DOB_internal[5]), 
						    .DOB6(DOB_internal[6]), 
						    .DOB7(DOB_internal[7]), 
						    .DOB8(DOB_internal[8]), 
						    .DOB9(DOB_internal[9]), 
						    .DOB10(DOB_internal[10]), 
						    .DOB11(DOB_internal[11]),
						    .DOB12(DOB_internal[12]), 
						    .DOB13(DOB_internal[13]), 
						    .DOB14(DOB_internal[14]), 
						    .DOB15(DOB_internal[15]), 
						    .DOB16(DOB_internal[16]), 
						    .DOB17(DOB_internal[17]));

		end
		else
		begin

			nochange_ssr_logic #(
            .WIDTH  (      18      ),
            .SRVAL  ( SRVAL_A      )
            ) nochange_ssr_logic_inst_a (
            .CLK    ( CLKA         ),
            .DO_in  ( DOA_internal ),
            .DO_out ( DOA          ),
            .EN     ( ENA          ),
            .WE     ( WEA          ),
            .SSR    ( SSRA         )
            );     
            
            ssr_logic #(
            .WIDTH  (      18      ),
            .SRVAL  ( SRVAL_B      )
            ) ssr_logic_inst_b (
            .CLK    ( CLKB         ),
            .DO_in  ( DOB_internal ),
            .DO_out ( DOB          ),
            .EN     ( ENB          ),
            .SSR    ( SSRB         )
            );


			defparam ram_18_inst_0_0_0.INIT_DATA = "STATIC" ;
			defparam ram_18_inst_0_0_0.ASYNC_RESET_RELEASE = "SYNC" ;
			defparam ram_18_inst_0_0_0.INITVAL_3F = INITVAL_3F ;
			defparam ram_18_inst_0_0_0.INITVAL_3E = INITVAL_3E ;
			defparam ram_18_inst_0_0_0.INITVAL_3D = INITVAL_3D ;
			defparam ram_18_inst_0_0_0.INITVAL_3C = INITVAL_3C ;
			defparam ram_18_inst_0_0_0.INITVAL_3B = INITVAL_3B ;
			defparam ram_18_inst_0_0_0.INITVAL_3A = INITVAL_3A ;
			defparam ram_18_inst_0_0_0.INITVAL_39 = INITVAL_39 ;
			defparam ram_18_inst_0_0_0.INITVAL_38 = INITVAL_38 ;
			defparam ram_18_inst_0_0_0.INITVAL_37 = INITVAL_37 ;
			defparam ram_18_inst_0_0_0.INITVAL_36 = INITVAL_36 ;
			defparam ram_18_inst_0_0_0.INITVAL_35 = INITVAL_35 ;
			defparam ram_18_inst_0_0_0.INITVAL_34 = INITVAL_34 ;
			defparam ram_18_inst_0_0_0.INITVAL_33 = INITVAL_33 ;
			defparam ram_18_inst_0_0_0.INITVAL_32 = INITVAL_32 ;
			defparam ram_18_inst_0_0_0.INITVAL_31 = INITVAL_31 ;
			defparam ram_18_inst_0_0_0.INITVAL_30 = INITVAL_30 ;
			defparam ram_18_inst_0_0_0.INITVAL_2F = INITVAL_2F ;
			defparam ram_18_inst_0_0_0.INITVAL_2E = INITVAL_2E ;
			defparam ram_18_inst_0_0_0.INITVAL_2D = INITVAL_2D ;
			defparam ram_18_inst_0_0_0.INITVAL_2C = INITVAL_2C ;
			defparam ram_18_inst_0_0_0.INITVAL_2B = INITVAL_2B ;
			defparam ram_18_inst_0_0_0.INITVAL_2A = INITVAL_2A ;
			defparam ram_18_inst_0_0_0.INITVAL_29 = INITVAL_29 ;
			defparam ram_18_inst_0_0_0.INITVAL_28 = INITVAL_28 ;
			defparam ram_18_inst_0_0_0.INITVAL_27 = INITVAL_27 ;
			defparam ram_18_inst_0_0_0.INITVAL_26 = INITVAL_26 ;
			defparam ram_18_inst_0_0_0.INITVAL_25 = INITVAL_25 ;
			defparam ram_18_inst_0_0_0.INITVAL_24 = INITVAL_24 ;
			defparam ram_18_inst_0_0_0.INITVAL_23 = INITVAL_23 ;
			defparam ram_18_inst_0_0_0.INITVAL_22 = INITVAL_22 ;
			defparam ram_18_inst_0_0_0.INITVAL_21 = INITVAL_21 ;
			defparam ram_18_inst_0_0_0.INITVAL_20 = INITVAL_20 ;
			defparam ram_18_inst_0_0_0.INITVAL_1F = INITVAL_1F ;
			defparam ram_18_inst_0_0_0.INITVAL_1E = INITVAL_1E ;
			defparam ram_18_inst_0_0_0.INITVAL_1D = INITVAL_1D ;
			defparam ram_18_inst_0_0_0.INITVAL_1C = INITVAL_1C ;
			defparam ram_18_inst_0_0_0.INITVAL_1B = INITVAL_1B ;
			defparam ram_18_inst_0_0_0.INITVAL_1A = INITVAL_1A ;
			defparam ram_18_inst_0_0_0.INITVAL_19 = INITVAL_19 ;
			defparam ram_18_inst_0_0_0.INITVAL_18 = INITVAL_18 ;
			defparam ram_18_inst_0_0_0.INITVAL_17 = INITVAL_17 ;
			defparam ram_18_inst_0_0_0.INITVAL_16 = INITVAL_16 ;
			defparam ram_18_inst_0_0_0.INITVAL_15 = INITVAL_15 ;
			defparam ram_18_inst_0_0_0.INITVAL_14 = INITVAL_14 ;
			defparam ram_18_inst_0_0_0.INITVAL_13 = INITVAL_13 ;
			defparam ram_18_inst_0_0_0.INITVAL_12 = INITVAL_12 ;
			defparam ram_18_inst_0_0_0.INITVAL_11 = INITVAL_11 ;
			defparam ram_18_inst_0_0_0.INITVAL_10 = INITVAL_10 ;
			defparam ram_18_inst_0_0_0.INITVAL_0F = INITVAL_0F ;
			defparam ram_18_inst_0_0_0.INITVAL_0E = INITVAL_0E ;
			defparam ram_18_inst_0_0_0.INITVAL_0D = INITVAL_0D ;
			defparam ram_18_inst_0_0_0.INITVAL_0C = INITVAL_0C ;
			defparam ram_18_inst_0_0_0.INITVAL_0B = INITVAL_0B ;
			defparam ram_18_inst_0_0_0.INITVAL_0A = INITVAL_0A ;
			defparam ram_18_inst_0_0_0.INITVAL_09 = INITVAL_09 ;
			defparam ram_18_inst_0_0_0.INITVAL_08 = INITVAL_08 ;
			defparam ram_18_inst_0_0_0.INITVAL_07 = INITVAL_07 ;
			defparam ram_18_inst_0_0_0.INITVAL_06 = INITVAL_06 ;
			defparam ram_18_inst_0_0_0.INITVAL_05 = INITVAL_05 ;
			defparam ram_18_inst_0_0_0.INITVAL_04 = INITVAL_04 ;
			defparam ram_18_inst_0_0_0.INITVAL_03 = INITVAL_03 ;
			defparam ram_18_inst_0_0_0.INITVAL_02 = INITVAL_02 ;
			defparam ram_18_inst_0_0_0.INITVAL_01 = INITVAL_01 ;
			defparam ram_18_inst_0_0_0.INITVAL_00 = INITVAL_00 ;
			defparam ram_18_inst_0_0_0.CSDECODE_A = "0b000" ;
			defparam ram_18_inst_0_0_0.CSDECODE_B = "0b000" ;
			defparam ram_18_inst_0_0_0.WRITEMODE_A = "WRITETHROUGH" ;
			defparam ram_18_inst_0_0_0.WRITEMODE_B = "WRITETHROUGH" ;
			defparam ram_18_inst_0_0_0.GSR = "DISABLED" ;
			defparam ram_18_inst_0_0_0.RESETMODE = "ASYNC" ;
 			defparam ram_18_inst_0_0_0.REGMODE_A = "NOREG" ;
			defparam ram_18_inst_0_0_0.REGMODE_B = "NOREG" ;
			defparam ram_18_inst_0_0_0.DATA_WIDTH_A = 18 ;
			defparam ram_18_inst_0_0_0.DATA_WIDTH_B = 18 ;
			DP16KD ram_18_inst_0_0_0 (
						    .DIA0(DIA[0]), 
						    .DIA1(DIA[1]), 
						    .DIA2(DIA[2]), 
						    .DIA3(DIA[3]), 
						    .DIA4(DIA[4]), 
						    .DIA5(DIA[5]), 
						    .DIA6(DIA[6]), 
						    .DIA7(DIA[7]), 
						    .DIA8(DIA[8]), 
						    .DIA9(DIA[9]), 
						    .DIA10(DIA[10]), 
						    .DIA11(DIA[11]), 
						    .DIA12(DIA[12]), 
						    .DIA13(DIA[13]), 
						    .DIA14(DIA[14]), 
						    .DIA15(DIA[15]), 
						    .DIA16(DIA[16]), 
						    .DIA17(DIA[17]), 
						    .ADA0(scuba_vhi), 
						    .ADA1(scuba_vhi), 
						    .ADA2(scuba_vlo), 
						    .ADA3(scuba_vlo), 
						    .ADA4(ADDRA[0]), 
						    .ADA5(ADDRA[1]), 
						    .ADA6(ADDRA[2]), 
						    .ADA7(ADDRA[3]), 
						    .ADA8(ADDRA[4]), 
						    .ADA9(ADDRA[5]), 
						    .ADA10(ADDRA[6]), 
						    .ADA11(ADDRA[7]), 
						    .ADA12(ADDRA[8]), 
						    .ADA13(ADDRA[9]), 
						    .CEA(ENA), 
						    .CLKA(CLKA), 
						    .OCEA(ENA), 
						    .WEA(WEA), 
						    .CSA0(scuba_vlo), 
						    .CSA1(scuba_vlo), 
						    .CSA2(scuba_vlo), 
						    .RSTA(scuba_vlo), 
						    .DIB0(DIB[0]), 
						    .DIB1(DIB[1]), 
						    .DIB2(DIB[2]), 
						    .DIB3(DIB[3]), 
						    .DIB4(DIB[4]), 
						    .DIB5(DIB[5]), 
						    .DIB6(DIB[6]), 
						    .DIB7(DIB[7]), 
						    .DIB8(DIB[8]), 
						    .DIB9(DIB[9]), 
						    .DIB10(DIB[10]), 
						    .DIB11(DIB[11]), 
						    .DIB12(DIB[12]), 
						    .DIB13(DIB[13]), 
						    .DIB14(DIB[14]), 
						    .DIB15(DIB[15]), 
						    .DIB16(DIB[16]), 
						    .DIB17(DIB[17]), 
						    .ADB0(scuba_vhi), 
						    .ADB1(scuba_vhi), 
						    .ADB2(scuba_vlo), 
						    .ADB3(scuba_vlo), 
						    .ADB4(ADDRB[0]), 
						    .ADB5(ADDRB[1]), 
						    .ADB6(ADDRB[2]), 
						    .ADB7(ADDRB[3]), 
						    .ADB8(ADDRB[4]), 
						    .ADB9(ADDRB[5]), 
						    .ADB10(ADDRB[6]), 
						    .ADB11(ADDRB[7]), 
						    .ADB12(ADDRB[8]), 
						    .ADB13(ADDRB[9]), 
						    .CEB(ENB), 
						    .CLKB(CLKB), 
						    .OCEB(ENB), 
						    .WEB(WEB), 
						    .CSB0(scuba_vlo), 
						    .CSB1(scuba_vlo), 
						    .CSB2(scuba_vlo), 
						    .RSTB(scuba_vlo), 
						    .DOA0(DOA_internal[0]), 
						    .DOA1(DOA_internal[1]), 
						    .DOA2(DOA_internal[2]), 
						    .DOA3(DOA_internal[3]), 
						    .DOA4(DOA_internal[4]), 
						    .DOA5(DOA_internal[5]), 
						    .DOA6(DOA_internal[6]), 
						    .DOA7(DOA_internal[7]), 
						    .DOA8(DOA_internal[8]), 
						    .DOA9(DOA_internal[9]), 
						    .DOA10(DOA_internal[10]),
						    .DOA11(DOA_internal[11]), 
						    .DOA12(DOA_internal[12]), 
						    .DOA13(DOA_internal[13]), 
						    .DOA14(DOA_internal[14]), 
						    .DOA15(DOA_internal[15]), 
						    .DOA16(DOA_internal[16]), 
						    .DOA17(DOA_internal[17]), 
						    .DOB0(DOB_internal[0]), 
						    .DOB1(DOB_internal[1]), 
						    .DOB2(DOB_internal[2]), 
						    .DOB3(DOB_internal[3]), 
						    .DOB4(DOB_internal[4]), 
						    .DOB5(DOB_internal[5]), 
						    .DOB6(DOB_internal[6]), 
						    .DOB7(DOB_internal[7]), 
						    .DOB8(DOB_internal[8]), 
						    .DOB9(DOB_internal[9]), 
						    .DOB10(DOB_internal[10]), 
						    .DOB11(DOB_internal[11]),
						    .DOB12(DOB_internal[12]), 
						    .DOB13(DOB_internal[13]), 
						    .DOB14(DOB_internal[14]), 
						    .DOB15(DOB_internal[15]), 
						    .DOB16(DOB_internal[16]), 
						    .DOB17(DOB_internal[17]));

		end

	end

	// end port a = NO_CHANGE

	// begin port a = invalid (port a defaults to WRITE_FIRST)


	else
	begin

		if (WRITE_MODE_B == "WRITE_FIRST")
		begin
		
            ssr_logic #(
            .WIDTH  (      18      ),
            .SRVAL  ( SRVAL_A      )
            ) ssr_logic_inst_a (
            .CLK    ( CLKA         ),
            .DO_in  ( DOA_internal ),
            .DO_out ( DOA          ),
            .EN     ( ENA          ),
            .SSR    ( SSRA         )
            );   
            
            ssr_logic #(
            .WIDTH  (      18      ),
            .SRVAL  ( SRVAL_B      )
            ) ssr_logic_inst_b (
            .CLK    ( CLKB         ),
            .DO_in  ( DOB_internal ),
            .DO_out ( DOB          ),
            .EN     ( ENB          ),
            .SSR    ( SSRB         )
            );  

			defparam ram_18_inst_0_0_0.INIT_DATA = "STATIC" ;
			defparam ram_18_inst_0_0_0.ASYNC_RESET_RELEASE = "SYNC" ;
			defparam ram_18_inst_0_0_0.INITVAL_3F = INITVAL_3F ;
			defparam ram_18_inst_0_0_0.INITVAL_3E = INITVAL_3E ;
			defparam ram_18_inst_0_0_0.INITVAL_3D = INITVAL_3D ;
			defparam ram_18_inst_0_0_0.INITVAL_3C = INITVAL_3C ;
			defparam ram_18_inst_0_0_0.INITVAL_3B = INITVAL_3B ;
			defparam ram_18_inst_0_0_0.INITVAL_3A = INITVAL_3A ;
			defparam ram_18_inst_0_0_0.INITVAL_39 = INITVAL_39 ;
			defparam ram_18_inst_0_0_0.INITVAL_38 = INITVAL_38 ;
			defparam ram_18_inst_0_0_0.INITVAL_37 = INITVAL_37 ;
			defparam ram_18_inst_0_0_0.INITVAL_36 = INITVAL_36 ;
			defparam ram_18_inst_0_0_0.INITVAL_35 = INITVAL_35 ;
			defparam ram_18_inst_0_0_0.INITVAL_34 = INITVAL_34 ;
			defparam ram_18_inst_0_0_0.INITVAL_33 = INITVAL_33 ;
			defparam ram_18_inst_0_0_0.INITVAL_32 = INITVAL_32 ;
			defparam ram_18_inst_0_0_0.INITVAL_31 = INITVAL_31 ;
			defparam ram_18_inst_0_0_0.INITVAL_30 = INITVAL_30 ;
			defparam ram_18_inst_0_0_0.INITVAL_2F = INITVAL_2F ;
			defparam ram_18_inst_0_0_0.INITVAL_2E = INITVAL_2E ;
			defparam ram_18_inst_0_0_0.INITVAL_2D = INITVAL_2D ;
			defparam ram_18_inst_0_0_0.INITVAL_2C = INITVAL_2C ;
			defparam ram_18_inst_0_0_0.INITVAL_2B = INITVAL_2B ;
			defparam ram_18_inst_0_0_0.INITVAL_2A = INITVAL_2A ;
			defparam ram_18_inst_0_0_0.INITVAL_29 = INITVAL_29 ;
			defparam ram_18_inst_0_0_0.INITVAL_28 = INITVAL_28 ;
			defparam ram_18_inst_0_0_0.INITVAL_27 = INITVAL_27 ;
			defparam ram_18_inst_0_0_0.INITVAL_26 = INITVAL_26 ;
			defparam ram_18_inst_0_0_0.INITVAL_25 = INITVAL_25 ;
			defparam ram_18_inst_0_0_0.INITVAL_24 = INITVAL_24 ;
			defparam ram_18_inst_0_0_0.INITVAL_23 = INITVAL_23 ;
			defparam ram_18_inst_0_0_0.INITVAL_22 = INITVAL_22 ;
			defparam ram_18_inst_0_0_0.INITVAL_21 = INITVAL_21 ;
			defparam ram_18_inst_0_0_0.INITVAL_20 = INITVAL_20 ;
			defparam ram_18_inst_0_0_0.INITVAL_1F = INITVAL_1F ;
			defparam ram_18_inst_0_0_0.INITVAL_1E = INITVAL_1E ;
			defparam ram_18_inst_0_0_0.INITVAL_1D = INITVAL_1D ;
			defparam ram_18_inst_0_0_0.INITVAL_1C = INITVAL_1C ;
			defparam ram_18_inst_0_0_0.INITVAL_1B = INITVAL_1B ;
			defparam ram_18_inst_0_0_0.INITVAL_1A = INITVAL_1A ;
			defparam ram_18_inst_0_0_0.INITVAL_19 = INITVAL_19 ;
			defparam ram_18_inst_0_0_0.INITVAL_18 = INITVAL_18 ;
			defparam ram_18_inst_0_0_0.INITVAL_17 = INITVAL_17 ;
			defparam ram_18_inst_0_0_0.INITVAL_16 = INITVAL_16 ;
			defparam ram_18_inst_0_0_0.INITVAL_15 = INITVAL_15 ;
			defparam ram_18_inst_0_0_0.INITVAL_14 = INITVAL_14 ;
			defparam ram_18_inst_0_0_0.INITVAL_13 = INITVAL_13 ;
			defparam ram_18_inst_0_0_0.INITVAL_12 = INITVAL_12 ;
			defparam ram_18_inst_0_0_0.INITVAL_11 = INITVAL_11 ;
			defparam ram_18_inst_0_0_0.INITVAL_10 = INITVAL_10 ;
			defparam ram_18_inst_0_0_0.INITVAL_0F = INITVAL_0F ;
			defparam ram_18_inst_0_0_0.INITVAL_0E = INITVAL_0E ;
			defparam ram_18_inst_0_0_0.INITVAL_0D = INITVAL_0D ;
			defparam ram_18_inst_0_0_0.INITVAL_0C = INITVAL_0C ;
			defparam ram_18_inst_0_0_0.INITVAL_0B = INITVAL_0B ;
			defparam ram_18_inst_0_0_0.INITVAL_0A = INITVAL_0A ;
			defparam ram_18_inst_0_0_0.INITVAL_09 = INITVAL_09 ;
			defparam ram_18_inst_0_0_0.INITVAL_08 = INITVAL_08 ;
			defparam ram_18_inst_0_0_0.INITVAL_07 = INITVAL_07 ;
			defparam ram_18_inst_0_0_0.INITVAL_06 = INITVAL_06 ;
			defparam ram_18_inst_0_0_0.INITVAL_05 = INITVAL_05 ;
			defparam ram_18_inst_0_0_0.INITVAL_04 = INITVAL_04 ;
			defparam ram_18_inst_0_0_0.INITVAL_03 = INITVAL_03 ;
			defparam ram_18_inst_0_0_0.INITVAL_02 = INITVAL_02 ;
			defparam ram_18_inst_0_0_0.INITVAL_01 = INITVAL_01 ;
			defparam ram_18_inst_0_0_0.INITVAL_00 = INITVAL_00 ;
			defparam ram_18_inst_0_0_0.CSDECODE_A = "0b000" ;
			defparam ram_18_inst_0_0_0.CSDECODE_B = "0b000" ;
			defparam ram_18_inst_0_0_0.WRITEMODE_A = "WRITETHROUGH" ;
			defparam ram_18_inst_0_0_0.WRITEMODE_B = "WRITETHROUGH" ;
			defparam ram_18_inst_0_0_0.GSR = "DISABLED" ;
			defparam ram_18_inst_0_0_0.RESETMODE = "ASYNC" ;
 			defparam ram_18_inst_0_0_0.REGMODE_A = "NOREG" ;
			defparam ram_18_inst_0_0_0.REGMODE_B = "NOREG" ;
			defparam ram_18_inst_0_0_0.DATA_WIDTH_A = 18 ;
			defparam ram_18_inst_0_0_0.DATA_WIDTH_B = 18 ;
			DP16KD ram_18_inst_0_0_0 (
						    .DIA0(DIA[0]), 
						    .DIA1(DIA[1]), 
						    .DIA2(DIA[2]), 
						    .DIA3(DIA[3]), 
						    .DIA4(DIA[4]), 
						    .DIA5(DIA[5]), 
						    .DIA6(DIA[6]), 
						    .DIA7(DIA[7]), 
						    .DIA8(DIA[8]), 
						    .DIA9(DIA[9]), 
						    .DIA10(DIA[10]), 
						    .DIA11(DIA[11]), 
						    .DIA12(DIA[12]), 
						    .DIA13(DIA[13]), 
						    .DIA14(DIA[14]), 
						    .DIA15(DIA[15]), 
						    .DIA16(DIA[16]), 
						    .DIA17(DIA[17]), 
						    .ADA0(scuba_vhi), 
						    .ADA1(scuba_vhi), 
						    .ADA2(scuba_vlo), 
						    .ADA3(scuba_vlo), 
						    .ADA4(ADDRA[0]), 
						    .ADA5(ADDRA[1]), 
						    .ADA6(ADDRA[2]), 
						    .ADA7(ADDRA[3]), 
						    .ADA8(ADDRA[4]), 
						    .ADA9(ADDRA[5]), 
						    .ADA10(ADDRA[6]), 
						    .ADA11(ADDRA[7]), 
						    .ADA12(ADDRA[8]), 
						    .ADA13(ADDRA[9]), 
						    .CEA(ENA), 
						    .CLKA(CLKA), 
						    .OCEA(ENA), 
						    .WEA(WEA), 
						    .CSA0(scuba_vlo), 
						    .CSA1(scuba_vlo), 
						    .CSA2(scuba_vlo), 
						    .RSTA(scuba_vlo), 
						    .DIB0(DIB[0]), 
						    .DIB1(DIB[1]), 
						    .DIB2(DIB[2]), 
						    .DIB3(DIB[3]), 
						    .DIB4(DIB[4]), 
						    .DIB5(DIB[5]), 
						    .DIB6(DIB[6]), 
						    .DIB7(DIB[7]), 
						    .DIB8(DIB[8]), 
						    .DIB9(DIB[9]), 
						    .DIB10(DIB[10]), 
						    .DIB11(DIB[11]), 
						    .DIB12(DIB[12]), 
						    .DIB13(DIB[13]), 
						    .DIB14(DIB[14]), 
						    .DIB15(DIB[15]), 
						    .DIB16(DIB[16]), 
						    .DIB17(DIB[17]), 
						    .ADB0(scuba_vhi), 
						    .ADB1(scuba_vhi), 
						    .ADB2(scuba_vlo), 
						    .ADB3(scuba_vlo), 
						    .ADB4(ADDRB[0]), 
						    .ADB5(ADDRB[1]), 
						    .ADB6(ADDRB[2]), 
						    .ADB7(ADDRB[3]), 
						    .ADB8(ADDRB[4]), 
						    .ADB9(ADDRB[5]), 
						    .ADB10(ADDRB[6]), 
						    .ADB11(ADDRB[7]), 
						    .ADB12(ADDRB[8]), 
						    .ADB13(ADDRB[9]), 
						    .CEB(ENB), 
						    .CLKB(CLKB), 
						    .OCEB(ENB), 
						    .WEB(WEB), 
						    .CSB0(scuba_vlo), 
						    .CSB1(scuba_vlo), 
						    .CSB2(scuba_vlo), 
						    .RSTB(scuba_vlo), 
						    .DOA0(DOA_internal[0]), 
						    .DOA1(DOA_internal[1]), 
						    .DOA2(DOA_internal[2]), 
						    .DOA3(DOA_internal[3]), 
						    .DOA4(DOA_internal[4]), 
						    .DOA5(DOA_internal[5]), 
						    .DOA6(DOA_internal[6]), 
						    .DOA7(DOA_internal[7]), 
						    .DOA8(DOA_internal[8]), 
						    .DOA9(DOA_internal[9]), 
						    .DOA10(DOA_internal[10]),
						    .DOA11(DOA_internal[11]), 
						    .DOA12(DOA_internal[12]), 
						    .DOA13(DOA_internal[13]), 
						    .DOA14(DOA_internal[14]), 
						    .DOA15(DOA_internal[15]), 
						    .DOA16(DOA_internal[16]), 
						    .DOA17(DOA_internal[17]), 
						    .DOB0(DOB_internal[0]), 
						    .DOB1(DOB_internal[1]), 
						    .DOB2(DOB_internal[2]), 
						    .DOB3(DOB_internal[3]), 
						    .DOB4(DOB_internal[4]), 
						    .DOB5(DOB_internal[5]), 
						    .DOB6(DOB_internal[6]), 
						    .DOB7(DOB_internal[7]), 
						    .DOB8(DOB_internal[8]), 
						    .DOB9(DOB_internal[9]), 
						    .DOB10(DOB_internal[10]), 
						    .DOB11(DOB_internal[11]),
						    .DOB12(DOB_internal[12]), 
						    .DOB13(DOB_internal[13]), 
						    .DOB14(DOB_internal[14]), 
						    .DOB15(DOB_internal[15]), 
						    .DOB16(DOB_internal[16]), 
						    .DOB17(DOB_internal[17]));

		end
		else if (WRITE_MODE_B == "READ_FIRST")
		begin
		
            ssr_logic #(
            .WIDTH  (      18      ),
            .SRVAL  ( SRVAL_A      )
            ) ssr_logic_inst_a (
            .CLK    ( CLKA         ),
            .DO_in  ( DOA_internal ),
            .DO_out ( DOA          ),
            .EN     ( ENA          ),
            .SSR    ( SSRA         )
            );   
            
            ssr_logic #(
            .WIDTH  (      18      ),
            .SRVAL  ( SRVAL_B      )
            ) ssr_logic_inst_b (
            .CLK    ( CLKB         ),
            .DO_in  ( DOB_internal ),
            .DO_out ( DOB          ),
            .EN     ( ENB          ),
            .SSR    ( SSRB         )
            ); 

			defparam ram_18_inst_0_0_0.INIT_DATA = "STATIC" ;
			defparam ram_18_inst_0_0_0.ASYNC_RESET_RELEASE = "SYNC" ;
			defparam ram_18_inst_0_0_0.INITVAL_3F = INITVAL_3F ;
			defparam ram_18_inst_0_0_0.INITVAL_3E = INITVAL_3E ;
			defparam ram_18_inst_0_0_0.INITVAL_3D = INITVAL_3D ;
			defparam ram_18_inst_0_0_0.INITVAL_3C = INITVAL_3C ;
			defparam ram_18_inst_0_0_0.INITVAL_3B = INITVAL_3B ;
			defparam ram_18_inst_0_0_0.INITVAL_3A = INITVAL_3A ;
			defparam ram_18_inst_0_0_0.INITVAL_39 = INITVAL_39 ;
			defparam ram_18_inst_0_0_0.INITVAL_38 = INITVAL_38 ;
			defparam ram_18_inst_0_0_0.INITVAL_37 = INITVAL_37 ;
			defparam ram_18_inst_0_0_0.INITVAL_36 = INITVAL_36 ;
			defparam ram_18_inst_0_0_0.INITVAL_35 = INITVAL_35 ;
			defparam ram_18_inst_0_0_0.INITVAL_34 = INITVAL_34 ;
			defparam ram_18_inst_0_0_0.INITVAL_33 = INITVAL_33 ;
			defparam ram_18_inst_0_0_0.INITVAL_32 = INITVAL_32 ;
			defparam ram_18_inst_0_0_0.INITVAL_31 = INITVAL_31 ;
			defparam ram_18_inst_0_0_0.INITVAL_30 = INITVAL_30 ;
			defparam ram_18_inst_0_0_0.INITVAL_2F = INITVAL_2F ;
			defparam ram_18_inst_0_0_0.INITVAL_2E = INITVAL_2E ;
			defparam ram_18_inst_0_0_0.INITVAL_2D = INITVAL_2D ;
			defparam ram_18_inst_0_0_0.INITVAL_2C = INITVAL_2C ;
			defparam ram_18_inst_0_0_0.INITVAL_2B = INITVAL_2B ;
			defparam ram_18_inst_0_0_0.INITVAL_2A = INITVAL_2A ;
			defparam ram_18_inst_0_0_0.INITVAL_29 = INITVAL_29 ;
			defparam ram_18_inst_0_0_0.INITVAL_28 = INITVAL_28 ;
			defparam ram_18_inst_0_0_0.INITVAL_27 = INITVAL_27 ;
			defparam ram_18_inst_0_0_0.INITVAL_26 = INITVAL_26 ;
			defparam ram_18_inst_0_0_0.INITVAL_25 = INITVAL_25 ;
			defparam ram_18_inst_0_0_0.INITVAL_24 = INITVAL_24 ;
			defparam ram_18_inst_0_0_0.INITVAL_23 = INITVAL_23 ;
			defparam ram_18_inst_0_0_0.INITVAL_22 = INITVAL_22 ;
			defparam ram_18_inst_0_0_0.INITVAL_21 = INITVAL_21 ;
			defparam ram_18_inst_0_0_0.INITVAL_20 = INITVAL_20 ;
			defparam ram_18_inst_0_0_0.INITVAL_1F = INITVAL_1F ;
			defparam ram_18_inst_0_0_0.INITVAL_1E = INITVAL_1E ;
			defparam ram_18_inst_0_0_0.INITVAL_1D = INITVAL_1D ;
			defparam ram_18_inst_0_0_0.INITVAL_1C = INITVAL_1C ;
			defparam ram_18_inst_0_0_0.INITVAL_1B = INITVAL_1B ;
			defparam ram_18_inst_0_0_0.INITVAL_1A = INITVAL_1A ;
			defparam ram_18_inst_0_0_0.INITVAL_19 = INITVAL_19 ;
			defparam ram_18_inst_0_0_0.INITVAL_18 = INITVAL_18 ;
			defparam ram_18_inst_0_0_0.INITVAL_17 = INITVAL_17 ;
			defparam ram_18_inst_0_0_0.INITVAL_16 = INITVAL_16 ;
			defparam ram_18_inst_0_0_0.INITVAL_15 = INITVAL_15 ;
			defparam ram_18_inst_0_0_0.INITVAL_14 = INITVAL_14 ;
			defparam ram_18_inst_0_0_0.INITVAL_13 = INITVAL_13 ;
			defparam ram_18_inst_0_0_0.INITVAL_12 = INITVAL_12 ;
			defparam ram_18_inst_0_0_0.INITVAL_11 = INITVAL_11 ;
			defparam ram_18_inst_0_0_0.INITVAL_10 = INITVAL_10 ;
			defparam ram_18_inst_0_0_0.INITVAL_0F = INITVAL_0F ;
			defparam ram_18_inst_0_0_0.INITVAL_0E = INITVAL_0E ;
			defparam ram_18_inst_0_0_0.INITVAL_0D = INITVAL_0D ;
			defparam ram_18_inst_0_0_0.INITVAL_0C = INITVAL_0C ;
			defparam ram_18_inst_0_0_0.INITVAL_0B = INITVAL_0B ;
			defparam ram_18_inst_0_0_0.INITVAL_0A = INITVAL_0A ;
			defparam ram_18_inst_0_0_0.INITVAL_09 = INITVAL_09 ;
			defparam ram_18_inst_0_0_0.INITVAL_08 = INITVAL_08 ;
			defparam ram_18_inst_0_0_0.INITVAL_07 = INITVAL_07 ;
			defparam ram_18_inst_0_0_0.INITVAL_06 = INITVAL_06 ;
			defparam ram_18_inst_0_0_0.INITVAL_05 = INITVAL_05 ;
			defparam ram_18_inst_0_0_0.INITVAL_04 = INITVAL_04 ;
			defparam ram_18_inst_0_0_0.INITVAL_03 = INITVAL_03 ;
			defparam ram_18_inst_0_0_0.INITVAL_02 = INITVAL_02 ;
			defparam ram_18_inst_0_0_0.INITVAL_01 = INITVAL_01 ;
			defparam ram_18_inst_0_0_0.INITVAL_00 = INITVAL_00 ;
			defparam ram_18_inst_0_0_0.CSDECODE_A = "0b000" ;
			defparam ram_18_inst_0_0_0.CSDECODE_B = "0b000" ;
			defparam ram_18_inst_0_0_0.WRITEMODE_A = "WRITETHROUGH" ;
			defparam ram_18_inst_0_0_0.WRITEMODE_B = "READBEFOREWRITE" ;
			defparam ram_18_inst_0_0_0.GSR = "DISABLED" ;
			defparam ram_18_inst_0_0_0.RESETMODE = "ASYNC" ;
 			defparam ram_18_inst_0_0_0.REGMODE_A = "NOREG" ;
			defparam ram_18_inst_0_0_0.REGMODE_B = "NOREG" ;
			defparam ram_18_inst_0_0_0.DATA_WIDTH_A = 18 ;
			defparam ram_18_inst_0_0_0.DATA_WIDTH_B = 18 ;
			DP16KD ram_18_inst_0_0_0 (
						    .DIA0(DIA[0]), 
						    .DIA1(DIA[1]), 
						    .DIA2(DIA[2]), 
						    .DIA3(DIA[3]), 
						    .DIA4(DIA[4]), 
						    .DIA5(DIA[5]), 
						    .DIA6(DIA[6]), 
						    .DIA7(DIA[7]), 
						    .DIA8(DIA[8]), 
						    .DIA9(DIA[9]), 
						    .DIA10(DIA[10]), 
						    .DIA11(DIA[11]), 
						    .DIA12(DIA[12]), 
						    .DIA13(DIA[13]), 
						    .DIA14(DIA[14]), 
						    .DIA15(DIA[15]), 
						    .DIA16(DIA[16]), 
						    .DIA17(DIA[17]), 
						    .ADA0(scuba_vhi), 
						    .ADA1(scuba_vhi), 
						    .ADA2(scuba_vlo), 
						    .ADA3(scuba_vlo), 
						    .ADA4(ADDRA[0]), 
						    .ADA5(ADDRA[1]), 
						    .ADA6(ADDRA[2]), 
						    .ADA7(ADDRA[3]), 
						    .ADA8(ADDRA[4]), 
						    .ADA9(ADDRA[5]), 
						    .ADA10(ADDRA[6]), 
						    .ADA11(ADDRA[7]), 
						    .ADA12(ADDRA[8]), 
						    .ADA13(ADDRA[9]), 
						    .CEA(ENA), 
						    .CLKA(CLKA), 
						    .OCEA(ENA), 
						    .WEA(WEA), 
						    .CSA0(scuba_vlo), 
						    .CSA1(scuba_vlo), 
						    .CSA2(scuba_vlo), 
						    .RSTA(scuba_vlo), 
						    .DIB0(DIB[0]), 
						    .DIB1(DIB[1]), 
						    .DIB2(DIB[2]), 
						    .DIB3(DIB[3]), 
						    .DIB4(DIB[4]), 
						    .DIB5(DIB[5]), 
						    .DIB6(DIB[6]), 
						    .DIB7(DIB[7]), 
						    .DIB8(DIB[8]), 
						    .DIB9(DIB[9]), 
						    .DIB10(DIB[10]), 
						    .DIB11(DIB[11]), 
						    .DIB12(DIB[12]), 
						    .DIB13(DIB[13]), 
						    .DIB14(DIB[14]), 
						    .DIB15(DIB[15]), 
						    .DIB16(DIB[16]), 
						    .DIB17(DIB[17]), 
						    .ADB0(scuba_vhi), 
						    .ADB1(scuba_vhi), 
						    .ADB2(scuba_vlo), 
						    .ADB3(scuba_vlo), 
						    .ADB4(ADDRB[0]), 
						    .ADB5(ADDRB[1]), 
						    .ADB6(ADDRB[2]), 
						    .ADB7(ADDRB[3]), 
						    .ADB8(ADDRB[4]), 
						    .ADB9(ADDRB[5]), 
						    .ADB10(ADDRB[6]), 
						    .ADB11(ADDRB[7]), 
						    .ADB12(ADDRB[8]), 
						    .ADB13(ADDRB[9]), 
						    .CEB(ENB), 
						    .CLKB(CLKB), 
						    .OCEB(ENB), 
						    .WEB(WEB), 
						    .CSB0(scuba_vlo), 
						    .CSB1(scuba_vlo), 
						    .CSB2(scuba_vlo), 
						    .RSTB(scuba_vlo), 
						    .DOA0(DOA_internal[0]), 
						    .DOA1(DOA_internal[1]), 
						    .DOA2(DOA_internal[2]), 
						    .DOA3(DOA_internal[3]), 
						    .DOA4(DOA_internal[4]), 
						    .DOA5(DOA_internal[5]), 
						    .DOA6(DOA_internal[6]), 
						    .DOA7(DOA_internal[7]), 
						    .DOA8(DOA_internal[8]), 
						    .DOA9(DOA_internal[9]), 
						    .DOA10(DOA_internal[10]),
						    .DOA11(DOA_internal[11]), 
						    .DOA12(DOA_internal[12]), 
						    .DOA13(DOA_internal[13]), 
						    .DOA14(DOA_internal[14]), 
						    .DOA15(DOA_internal[15]), 
						    .DOA16(DOA_internal[16]), 
						    .DOA17(DOA_internal[17]), 
						    .DOB0(DOB_internal[0]), 
						    .DOB1(DOB_internal[1]), 
						    .DOB2(DOB_internal[2]), 
						    .DOB3(DOB_internal[3]), 
						    .DOB4(DOB_internal[4]), 
						    .DOB5(DOB_internal[5]), 
						    .DOB6(DOB_internal[6]), 
						    .DOB7(DOB_internal[7]), 
						    .DOB8(DOB_internal[8]), 
						    .DOB9(DOB_internal[9]), 
						    .DOB10(DOB_internal[10]), 
						    .DOB11(DOB_internal[11]),
						    .DOB12(DOB_internal[12]), 
						    .DOB13(DOB_internal[13]), 
						    .DOB14(DOB_internal[14]), 
						    .DOB15(DOB_internal[15]), 
						    .DOB16(DOB_internal[16]), 
						    .DOB17(DOB_internal[17]));

		end
		else if (WRITE_MODE_B == "NO_CHANGE")
		begin

			ssr_logic #(
            .WIDTH  (      18      ),
            .SRVAL  ( SRVAL_A      )
            ) ssr_logic_inst_a (
            .CLK    ( CLKA         ),
            .DO_in  ( DOA_internal ),
            .DO_out ( DOA          ),
            .EN     ( ENA          ),
            .SSR    ( SSRA         )
            );   
            
            nochange_ssr_logic #(
            .WIDTH  (      18      ),
            .SRVAL  ( SRVAL_B      )
            ) nochange_ssr_logic_inst_b (
            .CLK    ( CLKB         ),
            .DO_in  ( DOB_internal ),
            .DO_out ( DOB          ),
            .EN     ( ENB          ),
            .WE     ( WEB          ),
            .SSR    ( SSRB         )
            ); 


			defparam ram_18_inst_0_0_0.INIT_DATA = "STATIC" ;
			defparam ram_18_inst_0_0_0.ASYNC_RESET_RELEASE = "SYNC" ;
			defparam ram_18_inst_0_0_0.INITVAL_3F = INITVAL_3F ;
			defparam ram_18_inst_0_0_0.INITVAL_3E = INITVAL_3E ;
			defparam ram_18_inst_0_0_0.INITVAL_3D = INITVAL_3D ;
			defparam ram_18_inst_0_0_0.INITVAL_3C = INITVAL_3C ;
			defparam ram_18_inst_0_0_0.INITVAL_3B = INITVAL_3B ;
			defparam ram_18_inst_0_0_0.INITVAL_3A = INITVAL_3A ;
			defparam ram_18_inst_0_0_0.INITVAL_39 = INITVAL_39 ;
			defparam ram_18_inst_0_0_0.INITVAL_38 = INITVAL_38 ;
			defparam ram_18_inst_0_0_0.INITVAL_37 = INITVAL_37 ;
			defparam ram_18_inst_0_0_0.INITVAL_36 = INITVAL_36 ;
			defparam ram_18_inst_0_0_0.INITVAL_35 = INITVAL_35 ;
			defparam ram_18_inst_0_0_0.INITVAL_34 = INITVAL_34 ;
			defparam ram_18_inst_0_0_0.INITVAL_33 = INITVAL_33 ;
			defparam ram_18_inst_0_0_0.INITVAL_32 = INITVAL_32 ;
			defparam ram_18_inst_0_0_0.INITVAL_31 = INITVAL_31 ;
			defparam ram_18_inst_0_0_0.INITVAL_30 = INITVAL_30 ;
			defparam ram_18_inst_0_0_0.INITVAL_2F = INITVAL_2F ;
			defparam ram_18_inst_0_0_0.INITVAL_2E = INITVAL_2E ;
			defparam ram_18_inst_0_0_0.INITVAL_2D = INITVAL_2D ;
			defparam ram_18_inst_0_0_0.INITVAL_2C = INITVAL_2C ;
			defparam ram_18_inst_0_0_0.INITVAL_2B = INITVAL_2B ;
			defparam ram_18_inst_0_0_0.INITVAL_2A = INITVAL_2A ;
			defparam ram_18_inst_0_0_0.INITVAL_29 = INITVAL_29 ;
			defparam ram_18_inst_0_0_0.INITVAL_28 = INITVAL_28 ;
			defparam ram_18_inst_0_0_0.INITVAL_27 = INITVAL_27 ;
			defparam ram_18_inst_0_0_0.INITVAL_26 = INITVAL_26 ;
			defparam ram_18_inst_0_0_0.INITVAL_25 = INITVAL_25 ;
			defparam ram_18_inst_0_0_0.INITVAL_24 = INITVAL_24 ;
			defparam ram_18_inst_0_0_0.INITVAL_23 = INITVAL_23 ;
			defparam ram_18_inst_0_0_0.INITVAL_22 = INITVAL_22 ;
			defparam ram_18_inst_0_0_0.INITVAL_21 = INITVAL_21 ;
			defparam ram_18_inst_0_0_0.INITVAL_20 = INITVAL_20 ;
			defparam ram_18_inst_0_0_0.INITVAL_1F = INITVAL_1F ;
			defparam ram_18_inst_0_0_0.INITVAL_1E = INITVAL_1E ;
			defparam ram_18_inst_0_0_0.INITVAL_1D = INITVAL_1D ;
			defparam ram_18_inst_0_0_0.INITVAL_1C = INITVAL_1C ;
			defparam ram_18_inst_0_0_0.INITVAL_1B = INITVAL_1B ;
			defparam ram_18_inst_0_0_0.INITVAL_1A = INITVAL_1A ;
			defparam ram_18_inst_0_0_0.INITVAL_19 = INITVAL_19 ;
			defparam ram_18_inst_0_0_0.INITVAL_18 = INITVAL_18 ;
			defparam ram_18_inst_0_0_0.INITVAL_17 = INITVAL_17 ;
			defparam ram_18_inst_0_0_0.INITVAL_16 = INITVAL_16 ;
			defparam ram_18_inst_0_0_0.INITVAL_15 = INITVAL_15 ;
			defparam ram_18_inst_0_0_0.INITVAL_14 = INITVAL_14 ;
			defparam ram_18_inst_0_0_0.INITVAL_13 = INITVAL_13 ;
			defparam ram_18_inst_0_0_0.INITVAL_12 = INITVAL_12 ;
			defparam ram_18_inst_0_0_0.INITVAL_11 = INITVAL_11 ;
			defparam ram_18_inst_0_0_0.INITVAL_10 = INITVAL_10 ;
			defparam ram_18_inst_0_0_0.INITVAL_0F = INITVAL_0F ;
			defparam ram_18_inst_0_0_0.INITVAL_0E = INITVAL_0E ;
			defparam ram_18_inst_0_0_0.INITVAL_0D = INITVAL_0D ;
			defparam ram_18_inst_0_0_0.INITVAL_0C = INITVAL_0C ;
			defparam ram_18_inst_0_0_0.INITVAL_0B = INITVAL_0B ;
			defparam ram_18_inst_0_0_0.INITVAL_0A = INITVAL_0A ;
			defparam ram_18_inst_0_0_0.INITVAL_09 = INITVAL_09 ;
			defparam ram_18_inst_0_0_0.INITVAL_08 = INITVAL_08 ;
			defparam ram_18_inst_0_0_0.INITVAL_07 = INITVAL_07 ;
			defparam ram_18_inst_0_0_0.INITVAL_06 = INITVAL_06 ;
			defparam ram_18_inst_0_0_0.INITVAL_05 = INITVAL_05 ;
			defparam ram_18_inst_0_0_0.INITVAL_04 = INITVAL_04 ;
			defparam ram_18_inst_0_0_0.INITVAL_03 = INITVAL_03 ;
			defparam ram_18_inst_0_0_0.INITVAL_02 = INITVAL_02 ;
			defparam ram_18_inst_0_0_0.INITVAL_01 = INITVAL_01 ;
			defparam ram_18_inst_0_0_0.INITVAL_00 = INITVAL_00 ;
			defparam ram_18_inst_0_0_0.CSDECODE_A = "0b000" ;
			defparam ram_18_inst_0_0_0.CSDECODE_B = "0b000" ;
			defparam ram_18_inst_0_0_0.WRITEMODE_A = "WRITETHROUGH" ;
			defparam ram_18_inst_0_0_0.WRITEMODE_B = "WRITETHROUGH" ;
			defparam ram_18_inst_0_0_0.GSR = "DISABLED" ;
			defparam ram_18_inst_0_0_0.RESETMODE = "ASYNC" ;
 			defparam ram_18_inst_0_0_0.REGMODE_A = "NOREG" ;
			defparam ram_18_inst_0_0_0.REGMODE_B = "NOREG" ;
			defparam ram_18_inst_0_0_0.DATA_WIDTH_A = 18 ;
			defparam ram_18_inst_0_0_0.DATA_WIDTH_B = 18 ;
			DP16KD ram_18_inst_0_0_0 (
						    .DIA0(DIA[0]), 
						    .DIA1(DIA[1]), 
						    .DIA2(DIA[2]), 
						    .DIA3(DIA[3]), 
						    .DIA4(DIA[4]), 
						    .DIA5(DIA[5]), 
						    .DIA6(DIA[6]), 
						    .DIA7(DIA[7]), 
						    .DIA8(DIA[8]), 
						    .DIA9(DIA[9]), 
						    .DIA10(DIA[10]), 
						    .DIA11(DIA[11]), 
						    .DIA12(DIA[12]), 
						    .DIA13(DIA[13]), 
						    .DIA14(DIA[14]), 
						    .DIA15(DIA[15]), 
						    .DIA16(DIA[16]), 
						    .DIA17(DIA[17]), 
						    .ADA0(scuba_vhi), 
						    .ADA1(scuba_vhi), 
						    .ADA2(scuba_vlo), 
						    .ADA3(scuba_vlo), 
						    .ADA4(ADDRA[0]), 
						    .ADA5(ADDRA[1]), 
						    .ADA6(ADDRA[2]), 
						    .ADA7(ADDRA[3]), 
						    .ADA8(ADDRA[4]), 
						    .ADA9(ADDRA[5]), 
						    .ADA10(ADDRA[6]), 
						    .ADA11(ADDRA[7]), 
						    .ADA12(ADDRA[8]), 
						    .ADA13(ADDRA[9]), 
						    .CEA(ENA), 
						    .CLKA(CLKA), 
						    .OCEA(ENA), 
						    .WEA(WEA), 
						    .CSA0(scuba_vlo), 
						    .CSA1(scuba_vlo), 
						    .CSA2(scuba_vlo), 
						    .RSTA(scuba_vlo), 
						    .DIB0(DIB[0]), 
						    .DIB1(DIB[1]), 
						    .DIB2(DIB[2]), 
						    .DIB3(DIB[3]), 
						    .DIB4(DIB[4]), 
						    .DIB5(DIB[5]), 
						    .DIB6(DIB[6]), 
						    .DIB7(DIB[7]), 
						    .DIB8(DIB[8]), 
						    .DIB9(DIB[9]), 
						    .DIB10(DIB[10]), 
						    .DIB11(DIB[11]), 
						    .DIB12(DIB[12]), 
						    .DIB13(DIB[13]), 
						    .DIB14(DIB[14]), 
						    .DIB15(DIB[15]), 
						    .DIB16(DIB[16]), 
						    .DIB17(DIB[17]), 
						    .ADB0(scuba_vhi), 
						    .ADB1(scuba_vhi), 
						    .ADB2(scuba_vlo), 
						    .ADB3(scuba_vlo), 
						    .ADB4(ADDRB[0]), 
						    .ADB5(ADDRB[1]), 
						    .ADB6(ADDRB[2]), 
						    .ADB7(ADDRB[3]), 
						    .ADB8(ADDRB[4]), 
						    .ADB9(ADDRB[5]), 
						    .ADB10(ADDRB[6]), 
						    .ADB11(ADDRB[7]), 
						    .ADB12(ADDRB[8]), 
						    .ADB13(ADDRB[9]), 
						    .CEB(ENB), 
						    .CLKB(CLKB), 
						    .OCEB(ENB), 
						    .WEB(WEB), 
						    .CSB0(scuba_vlo), 
						    .CSB1(scuba_vlo), 
						    .CSB2(scuba_vlo), 
						    .RSTB(scuba_vlo), 
						    .DOA0(DOA_internal[0]), 
						    .DOA1(DOA_internal[1]), 
						    .DOA2(DOA_internal[2]), 
						    .DOA3(DOA_internal[3]), 
						    .DOA4(DOA_internal[4]), 
						    .DOA5(DOA_internal[5]), 
						    .DOA6(DOA_internal[6]), 
						    .DOA7(DOA_internal[7]), 
						    .DOA8(DOA_internal[8]), 
						    .DOA9(DOA_internal[9]), 
						    .DOA10(DOA_internal[10]),
						    .DOA11(DOA_internal[11]), 
						    .DOA12(DOA_internal[12]), 
						    .DOA13(DOA_internal[13]), 
						    .DOA14(DOA_internal[14]), 
						    .DOA15(DOA_internal[15]), 
						    .DOA16(DOA_internal[16]), 
						    .DOA17(DOA_internal[17]), 
						    .DOB0(DOB_internal[0]), 
						    .DOB1(DOB_internal[1]), 
						    .DOB2(DOB_internal[2]), 
						    .DOB3(DOB_internal[3]), 
						    .DOB4(DOB_internal[4]), 
						    .DOB5(DOB_internal[5]), 
						    .DOB6(DOB_internal[6]), 
						    .DOB7(DOB_internal[7]), 
						    .DOB8(DOB_internal[8]), 
						    .DOB9(DOB_internal[9]), 
						    .DOB10(DOB_internal[10]), 
						    .DOB11(DOB_internal[11]),
						    .DOB12(DOB_internal[12]), 
						    .DOB13(DOB_internal[13]), 
						    .DOB14(DOB_internal[14]), 
						    .DOB15(DOB_internal[15]), 
						    .DOB16(DOB_internal[16]), 
						    .DOB17(DOB_internal[17]));

		end
		else
		begin
		
            ssr_logic #(
            .WIDTH  (      18      ),
            .SRVAL  ( SRVAL_A      )
            ) ssr_logic_inst_a (
            .CLK    ( CLKA         ),
            .DO_in  ( DOA_internal ),
            .DO_out ( DOA          ),
            .EN     ( ENA          ),
            .SSR    ( SSRA         )
            );   
            
            ssr_logic #(
            .WIDTH  (      18      ),
            .SRVAL  ( SRVAL_B      )
            ) ssr_logic_inst_b (
            .CLK    ( CLKB         ),
            .DO_in  ( DOB_internal ),
            .DO_out ( DOB          ),
            .EN     ( ENB          ),
            .SSR    ( SSRB         )
            ); 

			defparam ram_18_inst_0_0_0.INIT_DATA = "STATIC" ;
			defparam ram_18_inst_0_0_0.ASYNC_RESET_RELEASE = "SYNC" ;
			defparam ram_18_inst_0_0_0.INITVAL_3F = INITVAL_3F ;
			defparam ram_18_inst_0_0_0.INITVAL_3E = INITVAL_3E ;
			defparam ram_18_inst_0_0_0.INITVAL_3D = INITVAL_3D ;
			defparam ram_18_inst_0_0_0.INITVAL_3C = INITVAL_3C ;
			defparam ram_18_inst_0_0_0.INITVAL_3B = INITVAL_3B ;
			defparam ram_18_inst_0_0_0.INITVAL_3A = INITVAL_3A ;
			defparam ram_18_inst_0_0_0.INITVAL_39 = INITVAL_39 ;
			defparam ram_18_inst_0_0_0.INITVAL_38 = INITVAL_38 ;
			defparam ram_18_inst_0_0_0.INITVAL_37 = INITVAL_37 ;
			defparam ram_18_inst_0_0_0.INITVAL_36 = INITVAL_36 ;
			defparam ram_18_inst_0_0_0.INITVAL_35 = INITVAL_35 ;
			defparam ram_18_inst_0_0_0.INITVAL_34 = INITVAL_34 ;
			defparam ram_18_inst_0_0_0.INITVAL_33 = INITVAL_33 ;
			defparam ram_18_inst_0_0_0.INITVAL_32 = INITVAL_32 ;
			defparam ram_18_inst_0_0_0.INITVAL_31 = INITVAL_31 ;
			defparam ram_18_inst_0_0_0.INITVAL_30 = INITVAL_30 ;
			defparam ram_18_inst_0_0_0.INITVAL_2F = INITVAL_2F ;
			defparam ram_18_inst_0_0_0.INITVAL_2E = INITVAL_2E ;
			defparam ram_18_inst_0_0_0.INITVAL_2D = INITVAL_2D ;
			defparam ram_18_inst_0_0_0.INITVAL_2C = INITVAL_2C ;
			defparam ram_18_inst_0_0_0.INITVAL_2B = INITVAL_2B ;
			defparam ram_18_inst_0_0_0.INITVAL_2A = INITVAL_2A ;
			defparam ram_18_inst_0_0_0.INITVAL_29 = INITVAL_29 ;
			defparam ram_18_inst_0_0_0.INITVAL_28 = INITVAL_28 ;
			defparam ram_18_inst_0_0_0.INITVAL_27 = INITVAL_27 ;
			defparam ram_18_inst_0_0_0.INITVAL_26 = INITVAL_26 ;
			defparam ram_18_inst_0_0_0.INITVAL_25 = INITVAL_25 ;
			defparam ram_18_inst_0_0_0.INITVAL_24 = INITVAL_24 ;
			defparam ram_18_inst_0_0_0.INITVAL_23 = INITVAL_23 ;
			defparam ram_18_inst_0_0_0.INITVAL_22 = INITVAL_22 ;
			defparam ram_18_inst_0_0_0.INITVAL_21 = INITVAL_21 ;
			defparam ram_18_inst_0_0_0.INITVAL_20 = INITVAL_20 ;
			defparam ram_18_inst_0_0_0.INITVAL_1F = INITVAL_1F ;
			defparam ram_18_inst_0_0_0.INITVAL_1E = INITVAL_1E ;
			defparam ram_18_inst_0_0_0.INITVAL_1D = INITVAL_1D ;
			defparam ram_18_inst_0_0_0.INITVAL_1C = INITVAL_1C ;
			defparam ram_18_inst_0_0_0.INITVAL_1B = INITVAL_1B ;
			defparam ram_18_inst_0_0_0.INITVAL_1A = INITVAL_1A ;
			defparam ram_18_inst_0_0_0.INITVAL_19 = INITVAL_19 ;
			defparam ram_18_inst_0_0_0.INITVAL_18 = INITVAL_18 ;
			defparam ram_18_inst_0_0_0.INITVAL_17 = INITVAL_17 ;
			defparam ram_18_inst_0_0_0.INITVAL_16 = INITVAL_16 ;
			defparam ram_18_inst_0_0_0.INITVAL_15 = INITVAL_15 ;
			defparam ram_18_inst_0_0_0.INITVAL_14 = INITVAL_14 ;
			defparam ram_18_inst_0_0_0.INITVAL_13 = INITVAL_13 ;
			defparam ram_18_inst_0_0_0.INITVAL_12 = INITVAL_12 ;
			defparam ram_18_inst_0_0_0.INITVAL_11 = INITVAL_11 ;
			defparam ram_18_inst_0_0_0.INITVAL_10 = INITVAL_10 ;
			defparam ram_18_inst_0_0_0.INITVAL_0F = INITVAL_0F ;
			defparam ram_18_inst_0_0_0.INITVAL_0E = INITVAL_0E ;
			defparam ram_18_inst_0_0_0.INITVAL_0D = INITVAL_0D ;
			defparam ram_18_inst_0_0_0.INITVAL_0C = INITVAL_0C ;
			defparam ram_18_inst_0_0_0.INITVAL_0B = INITVAL_0B ;
			defparam ram_18_inst_0_0_0.INITVAL_0A = INITVAL_0A ;
			defparam ram_18_inst_0_0_0.INITVAL_09 = INITVAL_09 ;
			defparam ram_18_inst_0_0_0.INITVAL_08 = INITVAL_08 ;
			defparam ram_18_inst_0_0_0.INITVAL_07 = INITVAL_07 ;
			defparam ram_18_inst_0_0_0.INITVAL_06 = INITVAL_06 ;
			defparam ram_18_inst_0_0_0.INITVAL_05 = INITVAL_05 ;
			defparam ram_18_inst_0_0_0.INITVAL_04 = INITVAL_04 ;
			defparam ram_18_inst_0_0_0.INITVAL_03 = INITVAL_03 ;
			defparam ram_18_inst_0_0_0.INITVAL_02 = INITVAL_02 ;
			defparam ram_18_inst_0_0_0.INITVAL_01 = INITVAL_01 ;
			defparam ram_18_inst_0_0_0.INITVAL_00 = INITVAL_00 ;
			defparam ram_18_inst_0_0_0.CSDECODE_A = "0b000" ;
			defparam ram_18_inst_0_0_0.CSDECODE_B = "0b000" ;
			defparam ram_18_inst_0_0_0.WRITEMODE_A = "WRITETHROUGH" ;
			defparam ram_18_inst_0_0_0.WRITEMODE_B = "WRITETHROUGH" ;
			defparam ram_18_inst_0_0_0.GSR = "DISABLED" ;
			defparam ram_18_inst_0_0_0.RESETMODE = "ASYNC" ;
 			defparam ram_18_inst_0_0_0.REGMODE_A = "NOREG" ;
			defparam ram_18_inst_0_0_0.REGMODE_B = "NOREG" ;
			defparam ram_18_inst_0_0_0.DATA_WIDTH_A = 18 ;
			defparam ram_18_inst_0_0_0.DATA_WIDTH_B = 18 ;
			DP16KD ram_18_inst_0_0_0 (
						    .DIA0(DIA[0]), 
						    .DIA1(DIA[1]), 
						    .DIA2(DIA[2]), 
						    .DIA3(DIA[3]), 
						    .DIA4(DIA[4]), 
						    .DIA5(DIA[5]), 
						    .DIA6(DIA[6]), 
						    .DIA7(DIA[7]), 
						    .DIA8(DIA[8]), 
						    .DIA9(DIA[9]), 
						    .DIA10(DIA[10]), 
						    .DIA11(DIA[11]), 
						    .DIA12(DIA[12]), 
						    .DIA13(DIA[13]), 
						    .DIA14(DIA[14]), 
						    .DIA15(DIA[15]), 
						    .DIA16(DIA[16]), 
						    .DIA17(DIA[17]), 
						    .ADA0(scuba_vhi), 
						    .ADA1(scuba_vhi), 
						    .ADA2(scuba_vlo), 
						    .ADA3(scuba_vlo), 
						    .ADA4(ADDRA[0]), 
						    .ADA5(ADDRA[1]), 
						    .ADA6(ADDRA[2]), 
						    .ADA7(ADDRA[3]), 
						    .ADA8(ADDRA[4]), 
						    .ADA9(ADDRA[5]), 
						    .ADA10(ADDRA[6]), 
						    .ADA11(ADDRA[7]), 
						    .ADA12(ADDRA[8]), 
						    .ADA13(ADDRA[9]), 
						    .CEA(ENA), 
						    .CLKA(CLKA), 
						    .OCEA(ENA), 
						    .WEA(WEA), 
						    .CSA0(scuba_vlo), 
						    .CSA1(scuba_vlo), 
						    .CSA2(scuba_vlo), 
						    .RSTA(scuba_vlo), 
						    .DIB0(DIB[0]), 
						    .DIB1(DIB[1]), 
						    .DIB2(DIB[2]), 
						    .DIB3(DIB[3]), 
						    .DIB4(DIB[4]), 
						    .DIB5(DIB[5]), 
						    .DIB6(DIB[6]), 
						    .DIB7(DIB[7]), 
						    .DIB8(DIB[8]), 
						    .DIB9(DIB[9]), 
						    .DIB10(DIB[10]), 
						    .DIB11(DIB[11]), 
						    .DIB12(DIB[12]), 
						    .DIB13(DIB[13]), 
						    .DIB14(DIB[14]), 
						    .DIB15(DIB[15]), 
						    .DIB16(DIB[16]), 
						    .DIB17(DIB[17]), 
						    .ADB0(scuba_vhi), 
						    .ADB1(scuba_vhi), 
						    .ADB2(scuba_vlo), 
						    .ADB3(scuba_vlo), 
						    .ADB4(ADDRB[0]), 
						    .ADB5(ADDRB[1]), 
						    .ADB6(ADDRB[2]), 
						    .ADB7(ADDRB[3]), 
						    .ADB8(ADDRB[4]), 
						    .ADB9(ADDRB[5]), 
						    .ADB10(ADDRB[6]), 
						    .ADB11(ADDRB[7]), 
						    .ADB12(ADDRB[8]), 
						    .ADB13(ADDRB[9]), 
						    .CEB(ENB), 
						    .CLKB(CLKB), 
						    .OCEB(ENB), 
						    .WEB(WEB), 
						    .CSB0(scuba_vlo), 
						    .CSB1(scuba_vlo), 
						    .CSB2(scuba_vlo), 
						    .RSTB(scuba_vlo), 
						    .DOA0(DOA_internal[0]), 
						    .DOA1(DOA_internal[1]), 
						    .DOA2(DOA_internal[2]), 
						    .DOA3(DOA_internal[3]), 
						    .DOA4(DOA_internal[4]), 
						    .DOA5(DOA_internal[5]), 
						    .DOA6(DOA_internal[6]), 
						    .DOA7(DOA_internal[7]), 
						    .DOA8(DOA_internal[8]), 
						    .DOA9(DOA_internal[9]), 
						    .DOA10(DOA_internal[10]),
						    .DOA11(DOA_internal[11]), 
						    .DOA12(DOA_internal[12]), 
						    .DOA13(DOA_internal[13]), 
						    .DOA14(DOA_internal[14]), 
						    .DOA15(DOA_internal[15]), 
						    .DOA16(DOA_internal[16]), 
						    .DOA17(DOA_internal[17]), 
						    .DOB0(DOB_internal[0]), 
						    .DOB1(DOB_internal[1]), 
						    .DOB2(DOB_internal[2]), 
						    .DOB3(DOB_internal[3]), 
						    .DOB4(DOB_internal[4]), 
						    .DOB5(DOB_internal[5]), 
						    .DOB6(DOB_internal[6]), 
						    .DOB7(DOB_internal[7]), 
						    .DOB8(DOB_internal[8]), 
						    .DOB9(DOB_internal[9]), 
						    .DOB10(DOB_internal[10]), 
						    .DOB11(DOB_internal[11]),
						    .DOB12(DOB_internal[12]), 
						    .DOB13(DOB_internal[13]), 
						    .DOB14(DOB_internal[14]), 
						    .DOB15(DOB_internal[15]), 
						    .DOB16(DOB_internal[16]), 
						    .DOB17(DOB_internal[17]));

		end

	end

	// end port a = invalid (port a defaults to WRITE_FIRST)

endgenerate

endmodule
